/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/base/common/stopwatch","vs/base/common/codicons","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","fs","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/common/mime","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(G){for(var e=[],w=0,R=G.length;w<R;w++)e[w]=ge[G[w]];return e};define(ge[51],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(R,C){if(!R)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=w}),define(ge[52],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const w=Object.prototype.hasOwnProperty;function R(i){const A=[];for(let d in i)w.call(i,d)&&A.push(i[d]);return A}e.values=R;function C(i,A){for(let d in i)if(w.call(i,d)&&A({key:d,value:i[d]},function(){delete i[d]})===!1)return}e.forEach=C;function T(i,A){const d=Object.create(null);for(const p of i){const a=A(p);let h=d[a];h||(h=d[a]=[]),h.push(p)}return d}e.groupBy=T;function y(i){const A=Object.create(null);return i&&i.forEach((d,p)=>{A[p]=d}),A}e.fromMap=y;function k(i,A){const d=[],p=[];for(let a of i)A.has(a)||d.push(a);for(let a of A)i.has(a)||p.push(a);return{removed:d,added:p}}e.diffSets=k;function D(i,A){const d=[],p=[];for(let[a,h]of i)A.has(a)||d.push(h);for(let[a,h]of A)i.has(a)||p.push(h);return{removed:d,added:p}}e.diffMaps=D;class I{constructor(){this.map=new Map}add(A,d){let p=this.map.get(A);p||(p=new Set,this.map.set(A,p)),p.add(d)}delete(A,d){const p=this.map.get(A);!p||(p.delete(d),p.size===0&&this.map.delete(A))}forEach(A,d){const p=this.map.get(A);!p||p.forEach(d)}}e.SetMap=I}),define(ge[53],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(y){return(k,D,I)=>{let i=null,A=null;if(typeof I.value=="function"?(i="value",A=I.value):typeof I.get=="function"&&(i="get",A=I.get),!A)throw new Error("not supported");I[i]=y(A,D)}}e.createDecorator=w;function R(y,k,D){let I=null,i=null;if(typeof D.value=="function"?(I="value",i=D.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(I="get",i=D.get),!i)throw new Error("not supported");const A=`$memoize$${k}`;D[I]=function(...d){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,d)}),this[A]}}e.memoize=R;function C(y,k,D){return w((I,i)=>{const A=`$debounce$${i}`,d=`$debounce$result$${i}`;return function(...p){this[d]||(this[d]=D?D():void 0),clearTimeout(this[A]),k&&(this[d]=k(this[d],...p),p=[this[d]]),this[A]=setTimeout(()=>{I.apply(this,p),this[d]=D?D():void 0},y)}})}e.debounce=C;function T(y,k,D){return w((I,i)=>{const A=`$throttle$timer$${i}`,d=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,a=`$throttle$pending$${i}`;return function(...h){if(this[d]||(this[d]=D?D():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),k&&(this[d]=k(this[d],...h)),this[a])return;const E=this[p]+y;E<=Date.now()?(this[p]=Date.now(),I.apply(this,[this[d]]),this[d]=D?D():void 0):(this[a]=!0,this[A]=setTimeout(()=>{this[a]=!1,this[p]=Date.now(),I.apply(this,[this[d]]),this[d]=D?D():void 0},E-Date.now()))}})}e.throttle=T}),define(ge[17],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=w,e.errorHandler=new w;function R(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=R;function C(c){D(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=C;function T(c){D(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=T;function y(c){if(c instanceof Error){let{name:t,message:n}=c;const s=c.stacktrace||c.stack;return{$isError:!0,name:t,message:n,stack:s}}return c}e.transformErrorForSerialization=y;const k="Canceled";function D(c){return c instanceof Error&&c.name===k&&c.message===k}e.isPromiseCanceledError=D;class I extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=I;function i(){const c=new Error(k);return c.name=c.message,c}e.canceled=i;function A(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=A;function d(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=d;function p(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function a(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function h(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=h;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class v extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=v;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function u(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function f(c,t=Object.create(null)){const n=new Error(c);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=f}),define(ge[16],pe([0,1,17]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(W,P=0){return W[W.length-(1+P)]}e.tail=R;function C(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=C;function T(W,P,N=(F,M)=>F===M){if(W===P)return!0;if(!W||!P||W.length!==P.length)return!1;for(let F=0,M=W.length;F<M;F++)if(!N(W[F],P[F]))return!1;return!0}e.equals=T;function y(W,P,N){let F=0,M=W.length-1;for(;F<=M;){const B=(F+M)/2|0,H=N(W[B],P);if(H<0)F=B+1;else if(H>0)M=B-1;else return B}return-(F+1)}e.binarySearch=y;function k(W,P){let N=0,F=W.length;if(F===0)return 0;for(;N<F;){const M=Math.floor((N+F)/2);P(W[M])?F=M:N=M+1}return N}e.findFirstInSorted=k;function D(W,P,N){if(W=W|0,W>=P.length)throw new TypeError("invalid index");let F=P[Math.floor(P.length*Math.random())],M=[],B=[],H=[];for(let Q of P){const le=N(Q,F);le<0?M.push(Q):le>0?B.push(Q):H.push(Q)}return W<M.length?D(W,M,N):W<M.length+H.length?H[0]:D(W-(M.length+H.length),B,N)}e.quickSelect=D;function I(W,P){const N=[];let F;for(const M of W.slice(0).sort(P))!F||P(F[0],M)!==0?(F=[M],N.push(F)):F.push(M);return N}e.groupBy=I;function i(W,P,N){const F=[];function M(Q,le,be){if(le===0&&be.length===0)return;const Te=F[F.length-1];Te&&Te.start+Te.deleteCount===Q?(Te.deleteCount+=le,Te.toInsert.push(...be)):F.push({start:Q,deleteCount:le,toInsert:be})}let B=0,H=0;for(;;){if(B===W.length){M(B,0,P.slice(H));break}if(H===P.length){M(B,W.length-B,[]);break}const Q=W[B],le=P[H],be=N(Q,le);be===0?(B+=1,H+=1):be<0?(M(B,1,[]),B+=1):be>0&&(M(B,0,[le]),H+=1)}return F}e.sortedDiff=i;function A(W,P,N){const F=i(W,P,N),M=[],B=[];for(const H of F)M.push(...W.slice(H.start,H.start+H.deleteCount)),B.push(...H.toInsert);return{removed:M,added:B}}e.delta=A;function d(W,P,N){if(N===0)return[];const F=W.slice(0,N).sort(P);return a(W,P,F,N,W.length),F}e.top=d;function p(W,P,N,F,M){return N===0?Promise.resolve([]):new Promise((B,H)=>{(async()=>{const Q=W.length,le=W.slice(0,N).sort(P);for(let be=N,Te=Math.min(N+F,Q);be<Q;be=Te,Te=Math.min(Te+F,Q)){if(be>N&&await new Promise(ke=>setTimeout(ke)),M&&M.isCancellationRequested)throw(0,w.canceled)();a(W,P,le,be,Te)}return le})().then(B,H)})}e.topAsync=p;function a(W,P,N,F,M){for(const B=N.length;F<M;F++){const H=W[F];if(P(H,N[B-1])<0){N.pop();const Q=k(N,le=>P(H,le)<0);N.splice(Q,0,H)}}}function h(W){return W.filter(P=>!!P)}e.coalesce=h;function E(W){let P=0;for(let N=0;N<W.length;N++)W[N]&&(W[P]=W[N],P+=1);W.length=P}e.coalesceInPlace=E;function v(W,P,N){W.splice(N,0,W.splice(P,1)[0])}e.move=v;function S(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=S;function u(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=u;function f(W,P){if(!P)return W.filter((F,M)=>W.indexOf(F)===M);const N=Object.create(null);return W.filter(F=>{const M=P(F);return N[M]?!1:(N[M]=!0,!0)})}e.distinct=f;function c(W){const P=new Set;return W.filter(N=>P.has(N)?!1:(P.add(N),!0))}e.distinctES6=c;function t(W){const P=Object.create(null);return N=>{const F=W(N);return P[F]?!1:(P[F]=!0,!0)}}e.uniqueFilter=t;function n(W,P){for(let N=W.length-1;N>=0;N--){const F=W[N];if(P(F))return N}return-1}e.lastIndex=n;function s(W,P){return W.length>0?W[0]:P}e.firstOrDefault=s;function r(W,P,N=(F,M)=>F===M){let F=0;for(let M=0,B=Math.min(W.length,P.length);M<B&&N(W[M],P[M]);M++)F++;return F}e.commonPrefixLength=r;function o(W){return[].concat(...W)}e.flatten=o;function g(W,P){let N=typeof P=="number"?W:0;typeof P=="number"?N=W:(N=0,P=W);const F=[];if(N<=P)for(let M=N;M<P;M++)F.push(M);else for(let M=N;M>P;M--)F.push(M);return F}e.range=g;function m(W,P,N){return W.reduce((F,M)=>(F[P(M)]=N?N(M):M,F),Object.create(null))}e.index=m;function _(W,P){return W.push(P),()=>b(W,P)}e.insert=_;function b(W,P){const N=W.indexOf(P);if(N>-1)return W.splice(N,1),P}e.remove=b;function l(W,P,N){const F=W.slice(0,P),M=W.slice(P);return F.concat(N,M)}e.arrayInsert=l;function L(W,P){let N;if(typeof P=="number"){let F=P;N=()=>{const M=Math.sin(F++)*179426549;return M-Math.floor(M)}}else N=Math.random;for(let F=W.length-1;F>0;F-=1){const M=Math.floor(N()*(F+1)),B=W[F];W[F]=W[M],W[M]=B}}e.shuffle=L;function O(W,P){const N=W.indexOf(P);N>-1&&(W.splice(N,1),W.unshift(P))}e.pushToStart=O;function $(W,P){const N=W.indexOf(P);N>-1&&(W.splice(N,1),W.push(P))}e.pushToEnd=$;function ie(W,P){return Array.isArray(W)?W.map(P):P(W)}e.mapArrayOrNot=ie;function se(W){return Array.isArray(W)?W:[W]}e.asArray=se;function U(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=U;function V(W,P){for(const N of W){const F=P(N);if(F!==void 0)return F}}e.mapFind=V}),define(ge[72],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(R){const C=this;let T=!1,y;return function(){return T||(T=!0,y=R.apply(C,arguments)),y}}e.once=w}),define(ge[73],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class w{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=w,e.defaultGenerator=new w("id#")}),define(ge[54],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(R){function C(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}R.is=C;const T=Object.freeze([]);function y(){return T}R.empty=y;function*k(c){yield c}R.single=k;function D(c){return c||T}R.from=D;function I(c){return!c||c[Symbol.iterator]().next().done===!0}R.isEmpty=I;function i(c){return c[Symbol.iterator]().next().value}R.first=i;function A(c,t){for(const n of c)if(t(n))return!0;return!1}R.some=A;function d(c,t){for(const n of c)if(t(n))return n}R.find=d;function*p(c,t){for(const n of c)t(n)&&(yield n)}R.filter=p;function*a(c,t){let n=0;for(const s of c)yield t(s,n++)}R.map=a;function*h(...c){for(const t of c)for(const n of t)yield n}R.concat=h;function*E(c){for(const t of c)for(const n of t)yield n}R.concatNested=E;function v(c,t,n){let s=n;for(const r of c)s=t(s,r);return s}R.reduce=v;function*S(c,t,n=c.length){for(t<0&&(t+=c.length),n<0?n+=c.length:n>c.length&&(n=c.length);t<n;t++)yield c[t]}R.slice=S;function u(c,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,c];const s=c[Symbol.iterator]();for(let r=0;r<t;r++){const o=s.next();if(o.done)return[n,R.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}R.consume=u;function f(c,t,n=(s,r)=>s===r){const s=c[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const o=s.next(),g=r.next();if(o.done!==g.done)return!1;if(o.done)return!0;if(!n(o.value,g.value))return!1}}R.equals=f})(w=e.Iterable||(e.Iterable={}))}),define(ge[55],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let s=0,r=t.length,o="",g=0,m=16,_=0;function b(U){let V=0,W=0;for(;V<U;){const P=t.charCodeAt(s);if(P>=48&&P<=57)W=W*16+P-48;else if(P>=65&&P<=70)W=W*16+P-65+10;else if(P>=97&&P<=102)W=W*16+P-97+10;else break;s++,V++}return V<U&&(W=-1),W}function l(U){s=U,o="",g=0,m=16,_=0}function L(){const U=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&I(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&I(t.charCodeAt(s)))for(s++;s<t.length&&I(t.charCodeAt(s));)s++;else return _=3,t.substring(U,s);let V=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&I(t.charCodeAt(s))){for(s++;s<t.length&&I(t.charCodeAt(s));)s++;V=s}else _=3;return t.substring(U,V)}function O(){let U="",V=s;for(;;){if(s>=r){U+=t.substring(V,s),_=2;break}const W=t.charCodeAt(s);if(W===34){U+=t.substring(V,s),s++;break}if(W===92){if(U+=t.substring(V,s),s++,s>=r){_=2;break}switch(t.charCodeAt(s++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:const N=b(4);N>=0?U+=String.fromCharCode(N):_=4;break;default:_=5}V=s;continue}if(W>=0&&W<=31)if(D(W)){U+=t.substring(V,s),_=2;break}else _=6;s++}return U}function $(){if(o="",_=0,g=s,s>=r)return g=r,m=17;let U=t.charCodeAt(s);if(k(U)){do s++,o+=String.fromCharCode(U),U=t.charCodeAt(s);while(k(U));return m=15}if(D(U))return s++,o+=String.fromCharCode(U),U===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),m=14;switch(U){case 123:return s++,m=1;case 125:return s++,m=2;case 91:return s++,m=3;case 93:return s++,m=4;case 58:return s++,m=6;case 44:return s++,m=5;case 34:return s++,o=O(),m=10;case 47:const V=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<r&&!D(t.charCodeAt(s));)s++;return o=t.substring(V,s),m=12}if(t.charCodeAt(s+1)===42){s+=2;const W=r-1;let P=!1;for(;s<W;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,P=!0;break}s++}return P||(s++,_=1),o=t.substring(V,s),m=13}return o+=String.fromCharCode(U),s++,m=16;case 45:if(o+=String.fromCharCode(U),s++,s===r||!I(t.charCodeAt(s)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=L(),m=11;default:for(;s<r&&ie(U);)s++,U=t.charCodeAt(s);if(g!==s){switch(o=t.substring(g,s),o){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return o+=String.fromCharCode(U),s++,m=16}}function ie(U){if(k(U)||D(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let U;do U=$();while(U>=12&&U<=15);return U}return{setPosition:l,getPosition:()=>s,scan:n?se:$,getToken:()=>m,getTokenValue:()=>o,getTokenOffset:()=>g,getTokenLength:()=>s-g,getTokenError:()=>_}}e.createScanner=y;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function A(t,n){const s=[],r=new Object;let o;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function _(b,l,L,O){g.value=b,g.offset=l,g.length=L,g.type=O,g.colonOffset=void 0,o=g}try{u(t,{onObjectBegin:(b,l)=>{if(n<=b)throw r;o=void 0,m=n>b,s.push("")},onObjectProperty:(b,l,L)=>{if(n<l||(_(b,l,L,"property"),s[s.length-1]=b,n<=l+L))throw r},onObjectEnd:(b,l)=>{if(n<=b)throw r;o=void 0,s.pop()},onArrayBegin:(b,l)=>{if(n<=b)throw r;o=void 0,s.push(0)},onArrayEnd:(b,l)=>{if(n<=b)throw r;o=void 0,s.pop()},onLiteralValue:(b,l,L)=>{if(n<l||(_(b,l,L,c(b)),n<=l+L))throw r},onSeparator:(b,l,L)=>{if(n<=l)throw r;if(b===":"&&o&&o.type==="property")o.colonOffset=l,m=!1,o=void 0;else if(b===","){const O=s[s.length-1];typeof O=="number"?s[s.length-1]=O+1:(m=!0,s[s.length-1]=""),o=void 0}}})}catch(b){if(b!==r)throw b}return{path:s,previousNode:o,isAtPropertyKey:m,matches:b=>{let l=0;for(let L=0;l<b.length&&L<s.length;L++)if(b[l]===s[L]||b[l]==="*")l++;else if(b[l]!=="**")return!1;return l===b.length}}}e.getLocation=A;function d(t,n=[],s=T.DEFAULT){let r=null,o=[];const g=[];function m(b){Array.isArray(o)?o.push(b):r!==null&&(o[r]=b)}return u(t,{onObjectBegin:()=>{const b={};m(b),g.push(o),o=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{o=g.pop()},onArrayBegin:()=>{const b=[];m(b),g.push(o),o=b,r=null},onArrayEnd:()=>{o=g.pop()},onLiteralValue:m,onError:(b,l,L)=>{n.push({error:b,offset:l,length:L})}},s),o[0]}e.parse=d;function p(t,n=[],s=T.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(b){r.type==="property"&&(r.length=b-r.offset,r=r.parent)}function g(b){return r.children.push(b),b}u(t,{onObjectBegin:b=>{r=g({type:"object",offset:b,length:-1,parent:r,children:[]})},onObjectProperty:(b,l,L)=>{r=g({type:"property",offset:l,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:b,offset:l,length:L,parent:r})},onObjectEnd:(b,l)=>{r.length=b+l-r.offset,r=r.parent,o(b+l)},onArrayBegin:(b,l)=>{r=g({type:"array",offset:b,length:-1,parent:r,children:[]})},onArrayEnd:(b,l)=>{r.length=b+l-r.offset,r=r.parent,o(b+l)},onLiteralValue:(b,l,L)=>{g({type:c(b),offset:l,length:L,parent:r,value:b}),o(l+L)},onSeparator:(b,l,L)=>{r.type==="property"&&(b===":"?r.colonOffset=l:b===","&&o(l))},onError:(b,l,L)=>{n.push({error:b,offset:l,length:L})}},s);const _=r.children[0];return _&&delete _.parent,_}e.parseTree=p;function a(t,n){if(!t)return;let s=t;for(let r of n)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const g of s.children)if(Array.isArray(g.children)&&g.children[0].value===r){s=g.children[1],o=!0;break}if(!o)return}else{const o=r;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}e.findNodeAtLocation=a;function h(t){if(!t.parent||!t.parent.children)return[];const n=h(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=h;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const n=Object.create(null);for(let s of t.children){const r=s.children[1];r&&(n[s.children[0].value]=E(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function v(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=v;function S(t,n,s=!1){if(v(t,n,s)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const g=S(r[o],n,s);if(g)return g}return t}}e.findNodeAtOffset=S;function u(t,n,s=T.DEFAULT){const r=y(t,!1);function o(le){return le?()=>le(r.getTokenOffset(),r.getTokenLength()):()=>!0}function g(le){return le?be=>le(be,r.getTokenOffset(),r.getTokenLength()):()=>!0}const m=o(n.onObjectBegin),_=g(n.onObjectProperty),b=o(n.onObjectEnd),l=o(n.onArrayBegin),L=o(n.onArrayEnd),O=g(n.onLiteralValue),$=g(n.onSeparator),ie=o(n.onComment),se=g(n.onError),U=s&&s.disallowComments,V=s&&s.allowTrailingComma;function W(){for(;;){const le=r.scan();switch(r.getTokenError()){case 4:P(14);break;case 5:P(15);break;case 3:P(13);break;case 1:U||P(11);break;case 2:P(12);break;case 6:P(16);break}switch(le){case 12:case 13:U?P(10):ie();break;case 16:P(1);break;case 15:case 14:break;default:return le}}}function P(le,be=[],Te=[]){if(se(le),be.length+Te.length>0){let ke=r.getToken();for(;ke!==17;){if(be.indexOf(ke)!==-1){W();break}else if(Te.indexOf(ke)!==-1)break;ke=W()}}}function N(le){const be=r.getTokenValue();return le?O(be):_(be),W(),!0}function F(){switch(r.getToken()){case 11:let le=0;try{le=JSON.parse(r.getTokenValue()),typeof le!="number"&&(P(2),le=0)}catch(be){P(2)}O(le);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return W(),!0}function M(){return r.getToken()!==10?(P(3,[],[2,5]),!1):(N(!1),r.getToken()===6?($(":"),W(),Q()||P(4,[],[2,5])):P(5,[],[2,5]),!0)}function B(){m(),W();let le=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(le||P(4,[],[]),$(","),W(),r.getToken()===2&&V)break}else le&&P(6,[],[]);M()||P(4,[],[2,5]),le=!0}return b(),r.getToken()!==2?P(7,[2],[]):W(),!0}function H(){l(),W();let le=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(le||P(4,[],[]),$(","),W(),r.getToken()===4&&V)break}else le&&P(6,[],[]);Q()||P(4,[],[4,5]),le=!0}return L(),r.getToken()!==4?P(8,[4],[]):W(),!0}function Q(){switch(r.getToken()){case 3:return H();case 1:return B();case 10:return N(!0);default:return F()}}return W(),r.getToken()===17?s.allowEmptyContent?!0:(P(4,[],[]),!1):Q()?(r.getToken()!==17&&P(9,[],[]),!0):(P(4,[],[]),!1)}e.visit=u;function f(t,n){let s=y(t),r=[],o,g=0,m;do switch(m=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:g!==m&&r.push(t.substring(g,m)),n!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,n)),g=s.getPosition();break}while(o!==17);return r.join("")}e.stripComments=f;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ge[133],pe([0,1,55]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(D,I,i){let A,d,p,a,h;if(I){for(a=I.offset,h=a+I.length,p=a;p>0&&!k(D,p-1);)p--;let g=h;for(;g<D.length&&!k(D,g);)g++;d=D.substring(p,g),A=T(d,i)}else d=D,A=0,p=0,a=0,h=D.length;const E=y(i,D);let v=!1,S=0,u;i.insertSpaces?u=C(" ",i.tabSize||4):u="	";const f=(0,w.createScanner)(d,!1);let c=!1;function t(){return E+C(u,A+S)}function n(){let g=f.scan();for(v=!1;g===15||g===14;)v=v||g===14,g=f.scan();return c=g===16||f.getTokenError()!==0,g}const s=[];function r(g,m,_){!c&&m<h&&_>a&&D.substring(m,_)!==g&&s.push({offset:m,length:_-m,content:g})}let o=n();if(o!==17){const g=f.getTokenOffset()+p,m=C(u,A);r(m,p,g)}for(;o!==17;){let g=f.getTokenOffset()+f.getTokenLength()+p,m=n(),_="";for(;!v&&(m===12||m===13);){const l=f.getTokenOffset()+p;r(" ",g,l),g=f.getTokenOffset()+f.getTokenLength()+p,_=m===12?t():"",m=n()}if(m===2)o!==1&&(S--,_=t());else if(m===4)o!==3&&(S--,_=t());else{switch(o){case 3:case 1:S++,_=t();break;case 5:case 12:_=t();break;case 13:v?_=t():_=" ";break;case 6:_=" ";break;case 10:if(m===6){_="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?_=" ":m!==5&&m!==17&&(c=!0);break;case 16:c=!0;break}v&&(m===12||m===13)&&(_=t())}const b=f.getTokenOffset()+p;r(_,g,b),o=m}return s}e.format=R;function C(D,I){let i="";for(let A=0;A<I;A++)i+=D;return i}function T(D,I){let i=0,A=0;const d=I.tabSize||4;for(;i<D.length;){const p=D.charAt(i);if(p===" ")A++;else if(p==="	")A+=d;else break;i++}return Math.floor(A/d)}function y(D,I){for(let i=0;i<I.length;i++){const A=I.charAt(i);if(A==="\r")return i+1<I.length&&I.charAt(i+1)===`
`?`\r
`:"\r";if(A===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function k(D,I){return`\r
`.indexOf(D.charAt(I))!==-1}e.isEOL=k}),define(ge[134],pe([0,1,55,133]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(I,i,A){return T(I,i,void 0,A)}e.removeProperty=C;function T(I,i,A,d,p){const a=i.slice(),h=[],E=(0,w.parseTree)(I,h);let v,S;for(;a.length>0&&(S=a.pop(),v=(0,w.findNodeAtLocation)(E,a),v===void 0&&A!==void 0);)typeof S=="string"?A={[S]:A}:A=[A];if(v)if(v.type==="object"&&typeof S=="string"&&Array.isArray(v.children)){const u=(0,w.findNodeAtLocation)(v,[S]);if(u!==void 0)if(A===void 0){if(!u.parent)throw new Error("Malformed AST");const f=v.children.indexOf(u.parent);let c,t=u.parent.offset+u.parent.length;if(f>0){const n=v.children[f-1];c=n.offset+n.length}else c=v.offset+1,v.children.length>1&&(t=v.children[1].offset);return y(I,{offset:c,length:t-c,content:""},d)}else return y(I,{offset:u.offset,length:u.length,content:JSON.stringify(A)},d);else{if(A===void 0)return[];const f=`${JSON.stringify(S)}: ${JSON.stringify(A)}`,c=p?p(v.children.map(n=>n.children[0].value)):v.children.length;let t;if(c>0){const n=v.children[c-1];t={offset:n.offset+n.length,length:0,content:","+f}}else v.children.length===0?t={offset:v.offset+1,length:0,content:f}:t={offset:v.offset+1,length:0,content:f+","};return y(I,t,d)}}else if(v.type==="array"&&typeof S=="number"&&Array.isArray(v.children))if(A!==void 0){const u=`${JSON.stringify(A)}`;let f;if(v.children.length===0||S===0)f={offset:v.offset+1,length:0,content:v.children.length===0?u:u+","};else{const c=S===-1||S>v.children.length?v.children.length:S,t=v.children[c-1];f={offset:t.offset+t.length,length:0,content:","+u}}return y(I,f,d)}else{const u=S,f=v.children[u];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===u){const t=v.children[u-1],n=t.offset+t.length,s=v.offset+v.length;c={offset:n,length:s-2-n,content:""}}else c={offset:f.offset,length:v.children[u+1].offset-f.offset,content:""};return y(I,c,d)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${v.type}`);else{if(A===void 0)throw new Error("Can not delete in empty document");return y(I,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(A)},d)}}e.setProperty=T;function y(I,i,A){let d=k(I,i),p=i.offset,a=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,R.isEOL)(d,p-1);)p--;for(;a<d.length&&!(0,R.isEOL)(d,a);)a++}const h=(0,R.format)(d,{offset:p,length:a-p},A);for(let v=h.length-1;v>=0;v--){const S=h[v];d=k(d,S),p=Math.min(p,S.offset),a=Math.max(a,S.offset+S.length),a+=S.content.length-S.length}const E=I.length-(d.length-a)-p;return[{offset:p,length:E,content:d.substring(p,a)}]}e.withFormatting=y;function k(I,i){return I.substring(0,i.offset)+i.content+I.substring(i.offset+i.length)}e.applyEdit=k;function D(I,i){let A=i.slice(0).sort((p,a)=>{const h=p.offset-a.offset;return h===0?p.length-a.length:h}),d=I.length;for(let p=A.length-1;p>=0;p--){let a=A[p];if(a.offset+a.length<=d)I=k(I,a);else throw new Error("Overlapping edit");d=a.offset}return I}e.applyEdits=D}),define(ge[135],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new w(()=>C(this.getValue()))}}e.Lazy=w}),define(ge[6],pe([0,1,72,54]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const C=!1;let T=null;function y(u){T=u}if(e.setDisposableTracker=y,C){const u="__is_disposable_tracked__";T=new class{trackDisposable(f){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[u]||console.log(c)},3e3)}markTracked(f){if(f&&f!==h.None)try{f[u]=!0}catch(c){}}}}function k(u){!T||T.markTracked(u)}function D(u){return T&&T.trackDisposable(u),u}e.trackDisposable=D;class I extends Error{constructor(f){super(`Encountered errors while disposing of store. Errors: [${f.join(", ")}]`);this.errors=f}}e.MultiDisposeError=I;function i(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=i;function A(u){if(R.Iterable.is(u)){let f=[];for(const c of u)if(c){k(c);try{c.dispose()}catch(t){f.push(t)}}if(f.length===1)throw f[0];if(f.length>1)throw new I(f);return Array.isArray(u)?[]:u}else if(u)return k(u),u.dispose(),u}e.dispose=A;function d(...u){return u.forEach(k),p(()=>A(u))}e.combinedDisposable=d;function p(u){const f=D({dispose:()=>{k(f),u()}});return f}e.toDisposable=p;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(k(this),this._isDisposed=!0,this.clear())}clear(){try{A(this._toDispose.values())}finally{this._toDispose.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return k(f),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(f),f}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new a,D(this)}dispose(){k(this),this._store.dispose()}_register(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(f)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(f){var c;this._isDisposed||f===this._value||((c=this._value)===null||c===void 0||c.dispose(),f&&k(f),this._value=f)}clear(){this.value=void 0}dispose(){var f;this._isDisposed=!0,k(this),(f=this._value)===null||f===void 0||f.dispose(),this._value=void 0}}e.MutableDisposable=E;class v{constructor(){this.references=new Map}acquire(f,...c){let t=this.references.get(f);t||(t={counter:0,object:this.createReferencedObject(f,...c)},this.references.set(f,t));const{object:n}=t,s=(0,w.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(f,t.object),this.references.delete(f))});return t.counter++,{object:n,dispose:s}}}e.ReferenceCollection=v;class S{constructor(f){this.object=f}dispose(){}}e.ImmortalReference=S}),define(ge[56],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(T){this.element=T,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class R{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let T=this._first;for(;T!==w.Undefined;){const y=T.next;T.prev=w.Undefined,T.next=w.Undefined,T=y}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,y){const k=new w(T);if(this._first===w.Undefined)this._first=k,this._last=k;else if(y){const I=this._last;this._last=k,k.prev=I,I.next=k}else{const I=this._first;this._first=k,k.next=I,I.prev=k}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(k))}}shift(){if(this._first!==w.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==w.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==w.Undefined&&T.next!==w.Undefined){const y=T.prev;y.next=T.next,T.next.prev=y}else T.prev===w.Undefined&&T.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):T.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):T.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==w.Undefined;)yield T.element,T=T.next}}e.LinkedList=R}),function(G,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(G=typeof globalThis!="undefined"?globalThis:G||self,G.marked=e())}(this,function(){"use strict";function G(De,ye){for(var Ce=0;Ce<ye.length;Ce++){var ae=ye[Ce];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(De,ae.key,ae)}}function e(De,ye,Ce){return ye&&G(De.prototype,ye),Ce&&G(De,Ce),De}function w(De,ye){if(!!De){if(typeof De=="string")return R(De,ye);var Ce=Object.prototype.toString.call(De).slice(8,-1);if(Ce==="Object"&&De.constructor&&(Ce=De.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(De);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return R(De,ye)}}function R(De,ye){(ye==null||ye>De.length)&&(ye=De.length);for(var Ce=0,ae=new Array(ye);Ce<ye;Ce++)ae[Ce]=De[Ce];return ae}function C(De,ye){var Ce;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Ce=w(De))||ye&&De&&typeof De.length=="number"){Ce&&(De=Ce);var ae=0;return function(){return ae>=De.length?{done:!0}:{done:!1,value:De[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ce=De[Symbol.iterator](),Ce.next.bind(Ce)}function T(De){var ye={exports:{}};return De(ye,ye.exports),ye.exports}var y=T(function(De){function ye(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ce(ae){De.exports.defaults=ae}De.exports={defaults:ye(),getDefaults:ye,changeDefaults:Ce}}),k=/[&<>"']/,D=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,A={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(ye){return A[ye]};function p(De,ye){if(ye){if(k.test(De))return De.replace(D,d)}else if(I.test(De))return De.replace(i,d);return De}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(De){return De.replace(a,function(ye,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var E=/(^|[^\[])\^/g;function v(De,ye){De=De.source||De,ye=ye||"";var Ce={replace:function(he,z){return z=z.source||z,z=z.replace(E,"$1"),De=De.replace(he,z),Ce},getRegex:function(){return new RegExp(De,ye)}};return Ce}var S=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(De,ye,Ce){if(De){var ae;try{ae=decodeURIComponent(h(Ce)).replace(S,"").toLowerCase()}catch(he){return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}ye&&!u.test(Ce)&&(Ce=r(ye,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(he){return null}return Ce}var c={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(De,ye){c[" "+De]||(t.test(De)?c[" "+De]=De+"/":c[" "+De]=_(De,"/",!0)),De=c[" "+De];var Ce=De.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ce?ye:De.replace(n,"$1")+ye:ye.charAt(0)==="/"?Ce?ye:De.replace(s,"$1")+ye:De+ye}var o={exec:function(){}};function g(De){for(var ye=1,Ce,ae;ye<arguments.length;ye++){Ce=arguments[ye];for(ae in Ce)Object.prototype.hasOwnProperty.call(Ce,ae)&&(De[ae]=Ce[ae])}return De}function m(De,ye){var Ce=De.replace(/\|/g,function(z,Z,ue){for(var Ie=!1,Pe=Z;--Pe>=0&&ue[Pe]==="\\";)Ie=!Ie;return Ie?"|":" |"}),ae=Ce.split(/ \|/),he=0;if(ae.length>ye)ae.splice(ye);else for(;ae.length<ye;)ae.push("");for(;he<ae.length;he++)ae[he]=ae[he].trim().replace(/\\\|/g,"|");return ae}function _(De,ye,Ce){var ae=De.length;if(ae===0)return"";for(var he=0;he<ae;){var z=De.charAt(ae-he-1);if(z===ye&&!Ce)he++;else if(z!==ye&&Ce)he++;else break}return De.substr(0,ae-he)}function b(De,ye){if(De.indexOf(ye[1])===-1)return-1;for(var Ce=De.length,ae=0,he=0;he<Ce;he++)if(De[he]==="\\")he++;else if(De[he]===ye[0])ae++;else if(De[he]===ye[1]&&(ae--,ae<0))return he;return-1}function l(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(De,ye){if(ye<1)return"";for(var Ce="";ye>1;)ye&1&&(Ce+=De),ye>>=1,De+=De;return Ce+De}var O={escape:p,unescape:h,edit:v,cleanUrl:f,resolveUrl:r,noopTest:o,merge:g,splitCells:m,rtrim:_,findClosingBracket:b,checkSanitizeDeprecation:l,repeatString:L},$=y.defaults,ie=O.rtrim,se=O.splitCells,U=O.escape,V=O.findClosingBracket;function W(De,ye,Ce){var ae=ye.href,he=ye.title?U(ye.title):null,z=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Ce,href:ae,title:he,text:z}:{type:"image",raw:Ce,href:ae,title:he,text:U(z)}}function P(De,ye){var Ce=De.match(/^(\s+)(?:```)/);if(Ce===null)return ye;var ae=Ce[1];return ye.split(`
`).map(function(he){var z=he.match(/^\s+/);if(z===null)return he;var Z=z[0];return Z.length>=ae.length?he.slice(ae.length):he}).join(`
`)}var N=function(){function De(Ce){this.options=Ce||$}var ye=De.prototype;return ye.space=function(ae){var he=this.rules.block.newline.exec(ae);if(he)return he[0].length>1?{type:"space",raw:he[0]}:{raw:`
`}},ye.code=function(ae){var he=this.rules.block.code.exec(ae);if(he){var z=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?z:ie(z,`
`)}}},ye.fences=function(ae){var he=this.rules.block.fences.exec(ae);if(he){var z=he[0],Z=P(z,he[3]||"");return{type:"code",raw:z,lang:he[2]?he[2].trim():he[2],text:Z}}},ye.heading=function(ae){var he=this.rules.block.heading.exec(ae);if(he){var z=he[2].trim();if(/#$/.test(z)){var Z=ie(z,"#");(this.options.pedantic||!Z||/ $/.test(Z))&&(z=Z.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:z}}},ye.nptable=function(ae){var he=this.rules.block.nptable.exec(ae);if(he){var z={type:"table",header:se(he[1].replace(/^ *| *\| *$/g,"")),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:he[3]?he[3].replace(/\n$/,"").split(`
`):[],raw:he[0]};if(z.header.length===z.align.length){var Z=z.align.length,ue;for(ue=0;ue<Z;ue++)/^ *-+: *$/.test(z.align[ue])?z.align[ue]="right":/^ *:-+: *$/.test(z.align[ue])?z.align[ue]="center":/^ *:-+ *$/.test(z.align[ue])?z.align[ue]="left":z.align[ue]=null;for(Z=z.cells.length,ue=0;ue<Z;ue++)z.cells[ue]=se(z.cells[ue],z.header.length);return z}}},ye.hr=function(ae){var he=this.rules.block.hr.exec(ae);if(he)return{type:"hr",raw:he[0]}},ye.blockquote=function(ae){var he=this.rules.block.blockquote.exec(ae);if(he){var z=he[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:he[0],text:z}}},ye.list=function(ae){var he=this.rules.block.list.exec(ae);if(he){var z=he[0],Z=he[2],ue=Z.length>1,Ie={type:"list",raw:z,ordered:ue,start:ue?+Z.slice(0,-1):"",loose:!1,items:[]},Pe=he[0].match(this.rules.block.item),Ue=!1,xe,Qe,rt,tt,Ye,ot,Et,bt,_e=Pe.length;rt=this.rules.block.listItemStart.exec(Pe[0]);for(var fe=0;fe<_e;fe++){if(xe=Pe[fe],z=xe,fe!==_e-1){if(tt=this.rules.block.listItemStart.exec(Pe[fe+1]),this.options.pedantic?tt[1].length>rt[1].length:tt[1].length>rt[0].length||tt[1].length>3){Pe.splice(fe,2,Pe[fe]+`
`+Pe[fe+1]),fe--,_e--;continue}else(!this.options.pedantic||this.options.smartLists?tt[2][tt[2].length-1]!==Z[Z.length-1]:ue===(tt[2].length===1))&&(Ye=Pe.slice(fe+1).join(`
`),Ie.raw=Ie.raw.substring(0,Ie.raw.length-Ye.length),fe=_e-1);rt=tt}Qe=xe.length,xe=xe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~xe.indexOf(`
 `)&&(Qe-=xe.length,xe=this.options.pedantic?xe.replace(/^ {1,4}/gm,""):xe.replace(new RegExp("^ {1,"+Qe+"}","gm"),"")),ot=Ue||/\n\n(?!\s*$)/.test(xe),fe!==_e-1&&(Ue=xe.charAt(xe.length-1)===`
`,ot||(ot=Ue)),ot&&(Ie.loose=!0),this.options.gfm&&(Et=/^\[[ xX]\] /.test(xe),bt=void 0,Et&&(bt=xe[1]!==" ",xe=xe.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:z,task:Et,checked:bt,loose:ot,text:xe})}return Ie}},ye.html=function(ae){var he=this.rules.block.html.exec(ae);if(he)return{type:this.options.sanitize?"paragraph":"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):U(he[0]):he[0]}},ye.def=function(ae){var he=this.rules.block.def.exec(ae);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var z=he[1].toLowerCase().replace(/\s+/g," ");return{tag:z,raw:he[0],href:he[2],title:he[3]}}},ye.table=function(ae){var he=this.rules.block.table.exec(ae);if(he){var z={type:"table",header:se(he[1].replace(/^ *| *\| *$/g,"")),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:he[3]?he[3].replace(/\n$/,"").split(`
`):[]};if(z.header.length===z.align.length){z.raw=he[0];var Z=z.align.length,ue;for(ue=0;ue<Z;ue++)/^ *-+: *$/.test(z.align[ue])?z.align[ue]="right":/^ *:-+: *$/.test(z.align[ue])?z.align[ue]="center":/^ *:-+ *$/.test(z.align[ue])?z.align[ue]="left":z.align[ue]=null;for(Z=z.cells.length,ue=0;ue<Z;ue++)z.cells[ue]=se(z.cells[ue].replace(/^ *\| *| *\| *$/g,""),z.header.length);return z}}},ye.lheading=function(ae){var he=this.rules.block.lheading.exec(ae);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1]}},ye.paragraph=function(ae){var he=this.rules.block.paragraph.exec(ae);if(he)return{type:"paragraph",raw:he[0],text:he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1]}},ye.text=function(ae){var he=this.rules.block.text.exec(ae);if(he)return{type:"text",raw:he[0],text:he[0]}},ye.escape=function(ae){var he=this.rules.inline.escape.exec(ae);if(he)return{type:"escape",raw:he[0],text:U(he[1])}},ye.tag=function(ae,he,z){var Z=this.rules.inline.tag.exec(ae);if(Z)return!he&&/^<a /i.test(Z[0])?he=!0:he&&/^<\/a>/i.test(Z[0])&&(he=!1),!z&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?z=!0:z&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(z=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:he,inRawBlock:z,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):U(Z[0]):Z[0]}},ye.link=function(ae){var he=this.rules.inline.link.exec(ae);if(he){var z=he[2].trim();if(!this.options.pedantic&&/^</.test(z)){if(!/>$/.test(z))return;var Z=ie(z.slice(0,-1),"\\");if((z.length-Z.length)%2==0)return}else{var ue=V(he[2],"()");if(ue>-1){var Ie=he[0].indexOf("!")===0?5:4,Pe=Ie+he[1].length+ue;he[2]=he[2].substring(0,ue),he[0]=he[0].substring(0,Pe).trim(),he[3]=""}}var Ue=he[2],xe="";if(this.options.pedantic){var Qe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ue);Qe&&(Ue=Qe[1],xe=Qe[3])}else xe=he[3]?he[3].slice(1,-1):"";return Ue=Ue.trim(),/^</.test(Ue)&&(this.options.pedantic&&!/>$/.test(z)?Ue=Ue.slice(1):Ue=Ue.slice(1,-1)),W(he,{href:Ue&&Ue.replace(this.rules.inline._escapes,"$1"),title:xe&&xe.replace(this.rules.inline._escapes,"$1")},he[0])}},ye.reflink=function(ae,he){var z;if((z=this.rules.inline.reflink.exec(ae))||(z=this.rules.inline.nolink.exec(ae))){var Z=(z[2]||z[1]).replace(/\s+/g," ");if(Z=he[Z.toLowerCase()],!Z||!Z.href){var ue=z[0].charAt(0);return{type:"text",raw:ue,text:ue}}return W(z,Z,z[0])}},ye.emStrong=function(ae,he,z){z===void 0&&(z="");var Z=this.rules.inline.emStrong.lDelim.exec(ae);if(!!Z&&!(Z[3]&&z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=Z[1]||Z[2]||"";if(!ue||ue&&(z===""||this.rules.inline.punctuation.exec(z))){var Ie=Z[0].length-1,Pe,Ue,xe=Ie,Qe=0,rt=Z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,he=he.slice(-1*ae.length+Ie);(Z=rt.exec(he))!=null;)if(Pe=Z[1]||Z[2]||Z[3]||Z[4]||Z[5]||Z[6],!!Pe){if(Ue=Pe.length,Z[3]||Z[4]){xe+=Ue;continue}else if((Z[5]||Z[6])&&Ie%3&&!((Ie+Ue)%3)){Qe+=Ue;continue}if(xe-=Ue,!(xe>0)){if(xe+Qe-Ue<=0&&!he.slice(rt.lastIndex).match(rt)&&(Ue=Math.min(Ue,Ue+xe+Qe)),Math.min(Ie,Ue)%2)return{type:"em",raw:ae.slice(0,Ie+Z.index+Ue+1),text:ae.slice(1,Ie+Z.index+Ue)};if(Math.min(Ie,Ue)%2==0)return{type:"strong",raw:ae.slice(0,Ie+Z.index+Ue+1),text:ae.slice(2,Ie+Z.index+Ue-1)}}}}}},ye.codespan=function(ae){var he=this.rules.inline.code.exec(ae);if(he){var z=he[2].replace(/\n/g," "),Z=/[^ ]/.test(z),ue=/^ /.test(z)&&/ $/.test(z);return Z&&ue&&(z=z.substring(1,z.length-1)),z=U(z,!0),{type:"codespan",raw:he[0],text:z}}},ye.br=function(ae){var he=this.rules.inline.br.exec(ae);if(he)return{type:"br",raw:he[0]}},ye.del=function(ae){var he=this.rules.inline.del.exec(ae);if(he)return{type:"del",raw:he[0],text:he[2]}},ye.autolink=function(ae,he){var z=this.rules.inline.autolink.exec(ae);if(z){var Z,ue;return z[2]==="@"?(Z=U(this.options.mangle?he(z[1]):z[1]),ue="mailto:"+Z):(Z=U(z[1]),ue=Z),{type:"link",raw:z[0],text:Z,href:ue,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.url=function(ae,he){var z;if(z=this.rules.inline.url.exec(ae)){var Z,ue;if(z[2]==="@")Z=U(this.options.mangle?he(z[0]):z[0]),ue="mailto:"+Z;else{var Ie;do Ie=z[0],z[0]=this.rules.inline._backpedal.exec(z[0])[0];while(Ie!==z[0]);Z=U(z[0]),z[1]==="www."?ue="http://"+Z:ue=Z}return{type:"link",raw:z[0],text:Z,href:ue,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.inlineText=function(ae,he,z){var Z=this.rules.inline.text.exec(ae);if(Z){var ue;return he?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):U(Z[0]):Z[0]:ue=U(this.options.smartypants?z(Z[0]):Z[0]),{type:"text",raw:Z[0],text:ue}}},De}(),F=O.noopTest,M=O.edit,B=O.merge,H={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:F,table:F,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};H._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,H._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,H.def=M(H.def).replace("label",H._label).replace("title",H._title).getRegex(),H.bullet=/(?:[*+-]|\d{1,9}[.)])/,H.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,H.item=M(H.item,"gm").replace(/bull/g,H.bullet).getRegex(),H.listItemStart=M(/^( *)(bull)/).replace("bull",H.bullet).getRegex(),H.list=M(H.list).replace(/bull/g,H.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+H.def.source+")").getRegex(),H._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",H._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,H.html=M(H.html,"i").replace("comment",H._comment).replace("tag",H._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),H.paragraph=M(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",H._tag).getRegex(),H.blockquote=M(H.blockquote).replace("paragraph",H.paragraph).getRegex(),H.normal=B({},H),H.gfm=B({},H.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),H.gfm.nptable=M(H.gfm.nptable).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",H._tag).getRegex(),H.gfm.table=M(H.gfm.table).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",H._tag).getRegex(),H.pedantic=B({},H.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",H._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:F,paragraph:M(H.normal._paragraph).replace("hr",H.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",H.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:F,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:F,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=M(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=M(H._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=M(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=M(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=M(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=M(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=M(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=M(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=M(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=M(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=B({},Q),Q.pedantic=B({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=B({},Q.normal,{escape:M(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Q.gfm.url=M(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=B({},Q.gfm,{br:M(Q.br).replace("{2,}","*").getRegex(),text:M(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var le={block:H,inline:Q},be=y.defaults,Te=le.block,ke=le.inline,Ne=O.repeatString;function Ke(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ze(De){var ye="",Ce,ae,he=De.length;for(Ce=0;Ce<he;Ce++)ae=De.charCodeAt(Ce),Math.random()>.5&&(ae="x"+ae.toString(16)),ye+="&#"+ae+";";return ye}var qe=function(){function De(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||be,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ae={block:Te.normal,inline:ke.normal};this.options.pedantic?(ae.block=Te.pedantic,ae.inline=ke.pedantic):this.options.gfm&&(ae.block=Te.gfm,this.options.breaks?ae.inline=ke.breaks:ae.inline=ke.gfm),this.tokenizer.rules=ae}De.lex=function(ae,he){var z=new De(he);return z.lex(ae)},De.lexInline=function(ae,he){var z=new De(he);return z.inlineTokens(ae)};var ye=De.prototype;return ye.lex=function(ae){return ae=ae.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ae,this.tokens,!0),this.inline(this.tokens),this.tokens},ye.blockTokens=function(ae,he,z){he===void 0&&(he=[]),z===void 0&&(z=!0),this.options.pedantic&&(ae=ae.replace(/^ +$/gm,""));for(var Z,ue,Ie,Pe;ae;){if(Z=this.tokenizer.space(ae)){ae=ae.substring(Z.raw.length),Z.type&&he.push(Z);continue}if(Z=this.tokenizer.code(ae)){ae=ae.substring(Z.raw.length),Pe=he[he.length-1],Pe&&Pe.type==="paragraph"?(Pe.raw+=`
`+Z.raw,Pe.text+=`
`+Z.text):he.push(Z);continue}if(Z=this.tokenizer.fences(ae)){ae=ae.substring(Z.raw.length),he.push(Z);continue}if(Z=this.tokenizer.heading(ae)){ae=ae.substring(Z.raw.length),he.push(Z);continue}if(Z=this.tokenizer.nptable(ae)){ae=ae.substring(Z.raw.length),he.push(Z);continue}if(Z=this.tokenizer.hr(ae)){ae=ae.substring(Z.raw.length),he.push(Z);continue}if(Z=this.tokenizer.blockquote(ae)){ae=ae.substring(Z.raw.length),Z.tokens=this.blockTokens(Z.text,[],z),he.push(Z);continue}if(Z=this.tokenizer.list(ae)){for(ae=ae.substring(Z.raw.length),Ie=Z.items.length,ue=0;ue<Ie;ue++)Z.items[ue].tokens=this.blockTokens(Z.items[ue].text,[],!1);he.push(Z);continue}if(Z=this.tokenizer.html(ae)){ae=ae.substring(Z.raw.length),he.push(Z);continue}if(z&&(Z=this.tokenizer.def(ae))){ae=ae.substring(Z.raw.length),this.tokens.links[Z.tag]||(this.tokens.links[Z.tag]={href:Z.href,title:Z.title});continue}if(Z=this.tokenizer.table(ae)){ae=ae.substring(Z.raw.length),he.push(Z);continue}if(Z=this.tokenizer.lheading(ae)){ae=ae.substring(Z.raw.length),he.push(Z);continue}if(z&&(Z=this.tokenizer.paragraph(ae))){ae=ae.substring(Z.raw.length),he.push(Z);continue}if(Z=this.tokenizer.text(ae)){ae=ae.substring(Z.raw.length),Pe=he[he.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+Z.raw,Pe.text+=`
`+Z.text):he.push(Z);continue}if(ae){var Ue="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(Ue);break}else throw new Error(Ue)}}return he},ye.inline=function(ae){var he,z,Z,ue,Ie,Pe,Ue=ae.length;for(he=0;he<Ue;he++)switch(Pe=ae[he],Pe.type){case"paragraph":case"text":case"heading":{Pe.tokens=[],this.inlineTokens(Pe.text,Pe.tokens);break}case"table":{for(Pe.tokens={header:[],cells:[]},ue=Pe.header.length,z=0;z<ue;z++)Pe.tokens.header[z]=[],this.inlineTokens(Pe.header[z],Pe.tokens.header[z]);for(ue=Pe.cells.length,z=0;z<ue;z++)for(Ie=Pe.cells[z],Pe.tokens.cells[z]=[],Z=0;Z<Ie.length;Z++)Pe.tokens.cells[z][Z]=[],this.inlineTokens(Ie[Z],Pe.tokens.cells[z][Z]);break}case"blockquote":{this.inline(Pe.tokens);break}case"list":{for(ue=Pe.items.length,z=0;z<ue;z++)this.inline(Pe.items[z].tokens);break}}return ae},ye.inlineTokens=function(ae,he,z,Z){he===void 0&&(he=[]),z===void 0&&(z=!1),Z===void 0&&(Z=!1);var ue,Ie,Pe=ae,Ue,xe,Qe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Ue=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)rt.includes(Ue[0].slice(Ue[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ue.index)+"["+Ne("a",Ue[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ue=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ue.index)+"["+Ne("a",Ue[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ue=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ue.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;){if(xe||(Qe=""),xe=!1,ue=this.tokenizer.escape(ae)){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.tag(ae,z,Z)){ae=ae.substring(ue.raw.length),z=ue.inLink,Z=ue.inRawBlock;var tt=he[he.length-1];tt&&ue.type==="text"&&tt.type==="text"?(tt.raw+=ue.raw,tt.text+=ue.text):he.push(ue);continue}if(ue=this.tokenizer.link(ae)){ae=ae.substring(ue.raw.length),ue.type==="link"&&(ue.tokens=this.inlineTokens(ue.text,[],!0,Z)),he.push(ue);continue}if(ue=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(ue.raw.length);var Ye=he[he.length-1];ue.type==="link"?(ue.tokens=this.inlineTokens(ue.text,[],!0,Z),he.push(ue)):Ye&&ue.type==="text"&&Ye.type==="text"?(Ye.raw+=ue.raw,Ye.text+=ue.text):he.push(ue);continue}if(ue=this.tokenizer.emStrong(ae,Pe,Qe)){ae=ae.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],z,Z),he.push(ue);continue}if(ue=this.tokenizer.codespan(ae)){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.br(ae)){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.del(ae)){ae=ae.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],z,Z),he.push(ue);continue}if(ue=this.tokenizer.autolink(ae,ze)){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(!z&&(ue=this.tokenizer.url(ae,ze))){ae=ae.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.inlineText(ae,Z,Ke)){ae=ae.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(Qe=ue.raw.slice(-1)),xe=!0,Ie=he[he.length-1],Ie&&Ie.type==="text"?(Ie.raw+=ue.raw,Ie.text+=ue.text):he.push(ue);continue}if(ae){var ot="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ot);break}else throw new Error(ot)}}return he},e(De,null,[{key:"rules",get:function(){return{block:Te,inline:ke}}}]),De}(),q=y.defaults,J=O.cleanUrl,re=O.escape,oe=function(){function De(Ce){this.options=Ce||q}var ye=De.prototype;return ye.code=function(ae,he,z){var Z=(he||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(ae,Z);ue!=null&&ue!==ae&&(z=!0,ae=ue)}return ae=ae.replace(/\n$/,"")+`
`,Z?'<pre><code class="'+this.options.langPrefix+re(Z,!0)+'">'+(z?ae:re(ae,!0))+`</code></pre>
`:"<pre><code>"+(z?ae:re(ae,!0))+`</code></pre>
`},ye.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},ye.html=function(ae){return ae},ye.heading=function(ae,he,z,Z){return this.options.headerIds?"<h"+he+' id="'+this.options.headerPrefix+Z.slug(z)+'">'+ae+"</h"+he+`>
`:"<h"+he+">"+ae+"</h"+he+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ae,he,z){var Z=he?"ol":"ul",ue=he&&z!==1?' start="'+z+'"':"";return"<"+Z+ue+`>
`+ae+"</"+Z+`>
`},ye.listitem=function(ae){return"<li>"+ae+`</li>
`},ye.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ae){return"<p>"+ae+`</p>
`},ye.table=function(ae,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+he+`</table>
`},ye.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},ye.tablecell=function(ae,he){var z=he.header?"th":"td",Z=he.align?"<"+z+' align="'+he.align+'">':"<"+z+">";return Z+ae+"</"+z+`>
`},ye.strong=function(ae){return"<strong>"+ae+"</strong>"},ye.em=function(ae){return"<em>"+ae+"</em>"},ye.codespan=function(ae){return"<code>"+ae+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ae){return"<del>"+ae+"</del>"},ye.link=function(ae,he,z){if(ae=J(this.options.sanitize,this.options.baseUrl,ae),ae===null)return z;var Z='<a href="'+re(ae)+'"';return he&&(Z+=' title="'+he+'"'),Z+=">"+z+"</a>",Z},ye.image=function(ae,he,z){if(ae=J(this.options.sanitize,this.options.baseUrl,ae),ae===null)return z;var Z='<img src="'+ae+'" alt="'+z+'"';return he&&(Z+=' title="'+he+'"'),Z+=this.options.xhtml?"/>":">",Z},ye.text=function(ae){return ae},De}(),Y=function(){function De(){}var ye=De.prototype;return ye.strong=function(ae){return ae},ye.em=function(ae){return ae},ye.codespan=function(ae){return ae},ye.del=function(ae){return ae},ye.html=function(ae){return ae},ye.text=function(ae){return ae},ye.link=function(ae,he,z){return""+z},ye.image=function(ae,he,z){return""+z},ye.br=function(){return""},De}(),ce=function(){function De(){this.seen={}}var ye=De.prototype;return ye.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ae,he){var z=ae,Z=0;if(this.seen.hasOwnProperty(z)){Z=this.seen[ae];do Z++,z=ae+"-"+Z;while(this.seen.hasOwnProperty(z))}return he||(this.seen[ae]=Z,this.seen[z]=0),z},ye.slug=function(ae,he){he===void 0&&(he={});var z=this.serialize(ae);return this.getNextSafeSlug(z,he.dryrun)},De}(),ve=y.defaults,Le=O.unescape,we=function(){function De(Ce){this.options=Ce||ve,this.options.renderer=this.options.renderer||new oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new ce}De.parse=function(ae,he){var z=new De(he);return z.parse(ae)},De.parseInline=function(ae,he){var z=new De(he);return z.parseInline(ae)};var ye=De.prototype;return ye.parse=function(ae,he){he===void 0&&(he=!0);var z="",Z,ue,Ie,Pe,Ue,xe,Qe,rt,tt,Ye,ot,Et,bt,_e,fe,de,X,Fe,Re=ae.length;for(Z=0;Z<Re;Z++)switch(Ye=ae[Z],Ye.type){case"space":continue;case"hr":{z+=this.renderer.hr();continue}case"heading":{z+=this.renderer.heading(this.parseInline(Ye.tokens),Ye.depth,Le(this.parseInline(Ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{z+=this.renderer.code(Ye.text,Ye.lang,Ye.escaped);continue}case"table":{for(rt="",Qe="",Pe=Ye.header.length,ue=0;ue<Pe;ue++)Qe+=this.renderer.tablecell(this.parseInline(Ye.tokens.header[ue]),{header:!0,align:Ye.align[ue]});for(rt+=this.renderer.tablerow(Qe),tt="",Pe=Ye.cells.length,ue=0;ue<Pe;ue++){for(xe=Ye.tokens.cells[ue],Qe="",Ue=xe.length,Ie=0;Ie<Ue;Ie++)Qe+=this.renderer.tablecell(this.parseInline(xe[Ie]),{header:!1,align:Ye.align[Ie]});tt+=this.renderer.tablerow(Qe)}z+=this.renderer.table(rt,tt);continue}case"blockquote":{tt=this.parse(Ye.tokens),z+=this.renderer.blockquote(tt);continue}case"list":{for(ot=Ye.ordered,Et=Ye.start,bt=Ye.loose,Pe=Ye.items.length,tt="",ue=0;ue<Pe;ue++)fe=Ye.items[ue],de=fe.checked,X=fe.task,_e="",fe.task&&(Fe=this.renderer.checkbox(de),bt?fe.tokens.length>0&&fe.tokens[0].type==="text"?(fe.tokens[0].text=Fe+" "+fe.tokens[0].text,fe.tokens[0].tokens&&fe.tokens[0].tokens.length>0&&fe.tokens[0].tokens[0].type==="text"&&(fe.tokens[0].tokens[0].text=Fe+" "+fe.tokens[0].tokens[0].text)):fe.tokens.unshift({type:"text",text:Fe}):_e+=Fe),_e+=this.parse(fe.tokens,bt),tt+=this.renderer.listitem(_e,X,de);z+=this.renderer.list(tt,ot,Et);continue}case"html":{z+=this.renderer.html(Ye.text);continue}case"paragraph":{z+=this.renderer.paragraph(this.parseInline(Ye.tokens));continue}case"text":{for(tt=Ye.tokens?this.parseInline(Ye.tokens):Ye.text;Z+1<Re&&ae[Z+1].type==="text";)Ye=ae[++Z],tt+=`
`+(Ye.tokens?this.parseInline(Ye.tokens):Ye.text);z+=he?this.renderer.paragraph(tt):tt;continue}default:{var Ze='Token with "'+Ye.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}return z},ye.parseInline=function(ae,he){he=he||this.renderer;var z="",Z,ue,Ie=ae.length;for(Z=0;Z<Ie;Z++)switch(ue=ae[Z],ue.type){case"escape":{z+=he.text(ue.text);break}case"html":{z+=he.html(ue.text);break}case"link":{z+=he.link(ue.href,ue.title,this.parseInline(ue.tokens,he));break}case"image":{z+=he.image(ue.href,ue.title,ue.text);break}case"strong":{z+=he.strong(this.parseInline(ue.tokens,he));break}case"em":{z+=he.em(this.parseInline(ue.tokens,he));break}case"codespan":{z+=he.codespan(ue.text);break}case"br":{z+=he.br();break}case"del":{z+=he.del(this.parseInline(ue.tokens,he));break}case"text":{z+=he.text(ue.text);break}default:{var Pe='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}return z},De}(),je=O.merge,K=O.checkSanitizeDeprecation,ne=O.escape,Ee=y.getDefaults,Oe=y.changeDefaults,$e=y.defaults;function We(De,ye,Ce){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof ye=="function"&&(Ce=ye,ye=null),ye=je({},We.defaults,ye||{}),K(ye),Ce){var ae=ye.highlight,he;try{he=qe.lex(De,ye)}catch(Ie){return Ce(Ie)}var z=function(Pe){var Ue;if(!Pe)try{Ue=we.parse(he,ye)}catch(xe){Pe=xe}return ye.highlight=ae,Pe?Ce(Pe):Ce(null,Ue)};if(!ae||ae.length<3||(delete ye.highlight,!he.length))return z();var Z=0;We.walkTokens(he,function(Ie){Ie.type==="code"&&(Z++,setTimeout(function(){ae(Ie.text,Ie.lang,function(Pe,Ue){if(Pe)return z(Pe);Ue!=null&&Ue!==Ie.text&&(Ie.text=Ue,Ie.escaped=!0),Z--,Z===0&&z()})},0))}),Z===0&&z();return}try{var ue=qe.lex(De,ye);return ye.walkTokens&&We.walkTokens(ue,ye.walkTokens),we.parse(ue,ye)}catch(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ne(Ie.message+"",!0)+"</pre>";throw Ie}}We.options=We.setOptions=function(De){return je(We.defaults,De),Oe(We.defaults),We},We.getDefaults=Ee,We.defaults=$e,We.use=function(De){var ye=je({},De);if(De.renderer&&function(){var ae=We.defaults.renderer||new oe,he=function(ue){var Ie=ae[ue];ae[ue]=function(){for(var Pe=arguments.length,Ue=new Array(Pe),xe=0;xe<Pe;xe++)Ue[xe]=arguments[xe];var Qe=De.renderer[ue].apply(ae,Ue);return Qe===!1&&(Qe=Ie.apply(ae,Ue)),Qe}};for(var z in De.renderer)he(z);ye.renderer=ae}(),De.tokenizer&&function(){var ae=We.defaults.tokenizer||new N,he=function(ue){var Ie=ae[ue];ae[ue]=function(){for(var Pe=arguments.length,Ue=new Array(Pe),xe=0;xe<Pe;xe++)Ue[xe]=arguments[xe];var Qe=De.tokenizer[ue].apply(ae,Ue);return Qe===!1&&(Qe=Ie.apply(ae,Ue)),Qe}};for(var z in De.tokenizer)he(z);ye.tokenizer=ae}(),De.walkTokens){var Ce=We.defaults.walkTokens;ye.walkTokens=function(ae){De.walkTokens(ae),Ce&&Ce(ae)}}We.setOptions(ye)},We.walkTokens=function(De,ye){for(var Ce=C(De),ae;!(ae=Ce()).done;){var he=ae.value;switch(ye(he),he.type){case"table":{for(var z=C(he.tokens.header),Z;!(Z=z()).done;){var ue=Z.value;We.walkTokens(ue,ye)}for(var Ie=C(he.tokens.cells),Pe;!(Pe=Ie()).done;)for(var Ue=Pe.value,xe=C(Ue),Qe;!(Qe=xe()).done;){var rt=Qe.value;We.walkTokens(rt,ye)}break}case"list":{We.walkTokens(he.items,ye);break}default:he.tokens&&We.walkTokens(he.tokens,ye)}}},We.parseInline=function(De,ye){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");ye=je({},We.defaults,ye||{}),K(ye);try{var Ce=qe.lexInline(De,ye);return ye.walkTokens&&We.walkTokens(Ce,ye.walkTokens),we.parseInline(Ce,ye)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ne(ae.message+"",!0)+"</pre>";throw ae}},We.Parser=we,We.parser=we.parse,We.Renderer=oe,We.TextRenderer=Y,We.Lexer=qe,We.lexer=qe.lex,We.Tokenizer=N,We.Slugger=ce,We.parse=We;var Xe=We;return Xe}),define(ge[74],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(y,k,D){return Math.min(Math.max(y,k),D)}e.clamp=w;function R(y,k){return(k+y%k)%k}e.rot=R;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class T{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function G(C){const T=[];typeof C=="number"&&T.push("code/timeOrigin",C);function y(D){T.push(D,Date.now())}function k(){const D=[];for(let I=0;I<T.length;I+=2)D.push({name:T[I],startTime:T[I+1]});return D}return{mark:y,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const y of performance.getEntriesByType("mark"))T.push({name:y.name,startTime:Math.round(C+y.startTime)});return T}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function w(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=w(R))}(),define(ge[11],pe([0,1]),function(G,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let C=!1,T=!1,y=!1,k=!1,D=!1,I=!1,i=!1,A,d=R,p,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const E=typeof((w=h==null?void 0:h.versions)===null||w===void 0?void 0:w.electron)=="string"&&h.type==="renderer";if(e.isElectronSandboxed=E&&(h==null?void 0:h.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=h==null?void 0:h.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)a=navigator.userAgent,C=a.indexOf("Windows")>=0,T=a.indexOf("Macintosh")>=0,i=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=a.indexOf("Linux")>=0,I=!0,A=navigator.language,d=A;else if(typeof h=="object"){C=h.platform==="win32",T=h.platform==="darwin",y=h.platform==="linux",k=y&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,A=R,d=R;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),g=o.availableLanguages["*"];A=o.locale,d=g||R,p=o._translationsConfigFile}catch(o){}D=!0}else console.error("Unable to resolve platform.");var v;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function S(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let u=0;T?u=1:C?u=3:y&&(u=2),e.isWindows=C,e.isMacintosh=T,e.isLinux=y,e.isLinuxSnap=k,e.isNative=D,e.isWeb=I,e.isIOS=i,e.platform=u,e.userAgent=a,e.language=d;var f;(function(r){function o(){return e.language}r.value=o;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=g;function m(){return e.language==="en"}r.isDefault=m})(f=e.Language||(e.Language={})),e.locale=A,e.translationsConfigFile=p,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let g=[];e.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeSetImmediateId)for(let b=0,l=g.length;b<l;b++){const L=g[b];if(L.id===_.data.vscodeSetImmediateId){g.splice(b,1),L.callback();return}}});let m=0;return _=>{const b=++m;g.push({id:b,callback:_}),e.globals.postMessage({vscodeSetImmediateId:b},"*")}}if(typeof(h==null?void 0:h.nextTick)=="function")return h.nextTick.bind(h);const o=Promise.resolve();return g=>o.then(g)}();var c;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||i?2:C?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(ge[36],pe([0,1,11]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof w.globals.vscode!="undefined"&&typeof w.globals.vscode.process!="undefined"){const C=w.globals.vscode.process;R={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(T){return(0,w.setImmediate)(T)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:R={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},nextTick(C){return(0,w.setImmediate)(C)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(ge[9],pe([0,1,36]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,C=97,T=90,y=122,k=46,D=47,I=92,i=58,A=63;class d extends Error{constructor(f,c,t){let n;typeof c=="string"&&c.indexOf("not ")===0?(n="must not be",c=c.replace(/^not /,"")):n="must be";const s=f.indexOf(".")!==-1?"property":"argument";let r=`The "${f}" ${s} ${n} of type ${c}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function p(u,f){if(typeof u!="string")throw new d(f,"string",u)}function a(u){return u===D||u===I}function h(u){return u===D}function E(u){return u>=R&&u<=T||u>=C&&u<=y}function v(u,f,c,t){let n="",s=0,r=-1,o=0,g=0;for(let m=0;m<=u.length;++m){if(m<u.length)g=u.charCodeAt(m);else{if(t(g))break;g=D}if(t(g)){if(!(r===m-1||o===1))if(o===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==k||n.charCodeAt(n.length-2)!==k){if(n.length>2){const _=n.lastIndexOf(c);_===-1?(n="",s=0):(n=n.slice(0,_),s=n.length-1-n.lastIndexOf(c)),r=m,o=0;continue}else if(n.length!==0){n="",s=0,r=m,o=0;continue}}f&&(n+=n.length>0?`${c}..`:"..",s=2)}else n.length>0?n+=`${c}${u.slice(r+1,m)}`:n=u.slice(r+1,m),s=m-r-1;r=m,o=0}else g===k&&o!==-1?++o:o=-1}return n}function S(u,f){if(f===null||typeof f!="object")throw new d("pathObject","Object",f);const c=f.dir||f.root,t=f.base||`${f.name||""}${f.ext||""}`;return c?c===f.root?`${c}${t}`:`${c}${u}${t}`:t}e.win32={resolve(...u){let f="",c="",t=!1;for(let n=u.length-1;n>=-1;n--){let s;if(n>=0){if(s=u[n],p(s,"path"),s.length===0)continue}else f.length===0?s=w.cwd():(s=w.env[`=${f}`]||w.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==f.toLowerCase()&&s.charCodeAt(2)===I)&&(s=`${f}\\`));const r=s.length;let o=0,g="",m=!1;const _=s.charCodeAt(0);if(r===1)a(_)&&(o=1,m=!0);else if(a(_))if(m=!0,a(s.charCodeAt(1))){let b=2,l=b;for(;b<r&&!a(s.charCodeAt(b));)b++;if(b<r&&b!==l){const L=s.slice(l,b);for(l=b;b<r&&a(s.charCodeAt(b));)b++;if(b<r&&b!==l){for(l=b;b<r&&!a(s.charCodeAt(b));)b++;(b===r||b!==l)&&(g=`\\\\${L}\\${s.slice(l,b)}`,o=b)}}}else o=1;else E(_)&&s.charCodeAt(1)===i&&(g=s.slice(0,2),o=2,r>2&&a(s.charCodeAt(2))&&(m=!0,o=3));if(g.length>0)if(f.length>0){if(g.toLowerCase()!==f.toLowerCase())continue}else f=g;if(t){if(f.length>0)break}else if(c=`${s.slice(o)}\\${c}`,t=m,m&&f.length>0)break}return c=v(c,!t,"\\",a),t?`${f}\\${c}`:`${f}${c}`||"."},normalize(u){p(u,"path");const f=u.length;if(f===0)return".";let c=0,t,n=!1;const s=u.charCodeAt(0);if(f===1)return h(s)?"\\":u;if(a(s))if(n=!0,a(u.charCodeAt(1))){let o=2,g=o;for(;o<f&&!a(u.charCodeAt(o));)o++;if(o<f&&o!==g){const m=u.slice(g,o);for(g=o;o<f&&a(u.charCodeAt(o));)o++;if(o<f&&o!==g){for(g=o;o<f&&!a(u.charCodeAt(o));)o++;if(o===f)return`\\\\${m}\\${u.slice(g)}\\`;o!==g&&(t=`\\\\${m}\\${u.slice(g,o)}`,c=o)}}}else c=1;else E(s)&&u.charCodeAt(1)===i&&(t=u.slice(0,2),c=2,f>2&&a(u.charCodeAt(2))&&(n=!0,c=3));let r=c<f?v(u.slice(c),!n,"\\",a):"";return r.length===0&&!n&&(r="."),r.length>0&&a(u.charCodeAt(f-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(u){p(u,"path");const f=u.length;if(f===0)return!1;const c=u.charCodeAt(0);return a(c)||f>2&&E(c)&&u.charCodeAt(1)===i&&a(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let f,c;for(let s=0;s<u.length;++s){const r=u[s];p(r,"path"),r.length>0&&(f===void 0?f=c=r:f+=`\\${r}`)}if(f===void 0)return".";let t=!0,n=0;if(typeof c=="string"&&a(c.charCodeAt(0))){++n;const s=c.length;s>1&&a(c.charCodeAt(1))&&(++n,s>2&&(a(c.charCodeAt(2))?++n:t=!1))}if(t){for(;n<f.length&&a(f.charCodeAt(n));)n++;n>=2&&(f=`\\${f.slice(n)}`)}return e.win32.normalize(f)},relative(u,f){if(p(u,"from"),p(f,"to"),u===f)return"";const c=e.win32.resolve(u),t=e.win32.resolve(f);if(c===t||(u=c.toLowerCase(),f=t.toLowerCase(),u===f))return"";let n=0;for(;n<u.length&&u.charCodeAt(n)===I;)n++;let s=u.length;for(;s-1>n&&u.charCodeAt(s-1)===I;)s--;const r=s-n;let o=0;for(;o<f.length&&f.charCodeAt(o)===I;)o++;let g=f.length;for(;g-1>o&&f.charCodeAt(g-1)===I;)g--;const m=g-o,_=r<m?r:m;let b=-1,l=0;for(;l<_;l++){const O=u.charCodeAt(n+l);if(O!==f.charCodeAt(o+l))break;O===I&&(b=l)}if(l!==_){if(b===-1)return t}else{if(m>_){if(f.charCodeAt(o+l)===I)return t.slice(o+l+1);if(l===2)return t.slice(o+l)}r>_&&(u.charCodeAt(n+l)===I?b=l:l===2&&(b=3)),b===-1&&(b=0)}let L="";for(l=n+b+1;l<=s;++l)(l===s||u.charCodeAt(l)===I)&&(L+=L.length===0?"..":"\\..");return o+=b,L.length>0?`${L}${t.slice(o,g)}`:(t.charCodeAt(o)===I&&++o,t.slice(o,g))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const f=e.win32.resolve(u);if(f.length<=2)return u;if(f.charCodeAt(0)===I){if(f.charCodeAt(1)===I){const c=f.charCodeAt(2);if(c!==A&&c!==k)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(E(f.charCodeAt(0))&&f.charCodeAt(1)===i&&f.charCodeAt(2)===I)return`\\\\?\\${f}`;return u},dirname(u){p(u,"path");const f=u.length;if(f===0)return".";let c=-1,t=0;const n=u.charCodeAt(0);if(f===1)return a(n)?u:".";if(a(n)){if(c=t=1,a(u.charCodeAt(1))){let o=2,g=o;for(;o<f&&!a(u.charCodeAt(o));)o++;if(o<f&&o!==g){for(g=o;o<f&&a(u.charCodeAt(o));)o++;if(o<f&&o!==g){for(g=o;o<f&&!a(u.charCodeAt(o));)o++;if(o===f)return u;o!==g&&(c=t=o+1)}}}}else E(n)&&u.charCodeAt(1)===i&&(c=f>2&&a(u.charCodeAt(2))?3:2,t=c);let s=-1,r=!0;for(let o=f-1;o>=t;--o)if(a(u.charCodeAt(o))){if(!r){s=o;break}}else r=!1;if(s===-1){if(c===-1)return".";s=c}return u.slice(0,s)},basename(u,f){f!==void 0&&p(f,"ext"),p(u,"path");let c=0,t=-1,n=!0,s;if(u.length>=2&&E(u.charCodeAt(0))&&u.charCodeAt(1)===i&&(c=2),f!==void 0&&f.length>0&&f.length<=u.length){if(f===u)return"";let r=f.length-1,o=-1;for(s=u.length-1;s>=c;--s){const g=u.charCodeAt(s);if(a(g)){if(!n){c=s+1;break}}else o===-1&&(n=!1,o=s+1),r>=0&&(g===f.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=o))}return c===t?t=o:t===-1&&(t=u.length),u.slice(c,t)}for(s=u.length-1;s>=c;--s)if(a(u.charCodeAt(s))){if(!n){c=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":u.slice(c,t)},extname(u){p(u,"path");let f=0,c=-1,t=0,n=-1,s=!0,r=0;u.length>=2&&u.charCodeAt(1)===i&&E(u.charCodeAt(0))&&(f=t=2);for(let o=u.length-1;o>=f;--o){const g=u.charCodeAt(o);if(a(g)){if(!s){t=o+1;break}continue}n===-1&&(s=!1,n=o+1),g===k?c===-1?c=o:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||n===-1||r===0||r===1&&c===n-1&&c===t+1?"":u.slice(c,n)},format:S.bind(null,"\\"),parse(u){p(u,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return f;const c=u.length;let t=0,n=u.charCodeAt(0);if(c===1)return a(n)?(f.root=f.dir=u,f):(f.base=f.name=u,f);if(a(n)){if(t=1,a(u.charCodeAt(1))){let b=2,l=b;for(;b<c&&!a(u.charCodeAt(b));)b++;if(b<c&&b!==l){for(l=b;b<c&&a(u.charCodeAt(b));)b++;if(b<c&&b!==l){for(l=b;b<c&&!a(u.charCodeAt(b));)b++;b===c?t=b:b!==l&&(t=b+1)}}}}else if(E(n)&&u.charCodeAt(1)===i){if(c<=2)return f.root=f.dir=u,f;if(t=2,a(u.charCodeAt(2))){if(c===3)return f.root=f.dir=u,f;t=3}}t>0&&(f.root=u.slice(0,t));let s=-1,r=t,o=-1,g=!0,m=u.length-1,_=0;for(;m>=t;--m){if(n=u.charCodeAt(m),a(n)){if(!g){r=m+1;break}continue}o===-1&&(g=!1,o=m+1),n===k?s===-1?s=m:_!==1&&(_=1):s!==-1&&(_=-1)}return o!==-1&&(s===-1||_===0||_===1&&s===o-1&&s===r+1?f.base=f.name=u.slice(r,o):(f.name=u.slice(r,s),f.base=u.slice(r,o),f.ext=u.slice(s,o))),r>0&&r!==t?f.dir=u.slice(0,r-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let f="",c=!1;for(let t=u.length-1;t>=-1&&!c;t--){const n=t>=0?u[t]:w.cwd();p(n,"path"),n.length!==0&&(f=`${n}/${f}`,c=n.charCodeAt(0)===D)}return f=v(f,!c,"/",h),c?`/${f}`:f.length>0?f:"."},normalize(u){if(p(u,"path"),u.length===0)return".";const f=u.charCodeAt(0)===D,c=u.charCodeAt(u.length-1)===D;return u=v(u,!f,"/",h),u.length===0?f?"/":c?"./":".":(c&&(u+="/"),f?`/${u}`:u)},isAbsolute(u){return p(u,"path"),u.length>0&&u.charCodeAt(0)===D},join(...u){if(u.length===0)return".";let f;for(let c=0;c<u.length;++c){const t=u[c];p(t,"path"),t.length>0&&(f===void 0?f=t:f+=`/${t}`)}return f===void 0?".":e.posix.normalize(f)},relative(u,f){if(p(u,"from"),p(f,"to"),u===f||(u=e.posix.resolve(u),f=e.posix.resolve(f),u===f))return"";const c=1,t=u.length,n=t-c,s=1,r=f.length-s,o=n<r?n:r;let g=-1,m=0;for(;m<o;m++){const b=u.charCodeAt(c+m);if(b!==f.charCodeAt(s+m))break;b===D&&(g=m)}if(m===o)if(r>o){if(f.charCodeAt(s+m)===D)return f.slice(s+m+1);if(m===0)return f.slice(s+m)}else n>o&&(u.charCodeAt(c+m)===D?g=m:m===0&&(g=0));let _="";for(m=c+g+1;m<=t;++m)(m===t||u.charCodeAt(m)===D)&&(_+=_.length===0?"..":"/..");return`${_}${f.slice(s+g)}`},toNamespacedPath(u){return u},dirname(u){if(p(u,"path"),u.length===0)return".";const f=u.charCodeAt(0)===D;let c=-1,t=!0;for(let n=u.length-1;n>=1;--n)if(u.charCodeAt(n)===D){if(!t){c=n;break}}else t=!1;return c===-1?f?"/":".":f&&c===1?"//":u.slice(0,c)},basename(u,f){f!==void 0&&p(f,"ext"),p(u,"path");let c=0,t=-1,n=!0,s;if(f!==void 0&&f.length>0&&f.length<=u.length){if(f===u)return"";let r=f.length-1,o=-1;for(s=u.length-1;s>=0;--s){const g=u.charCodeAt(s);if(g===D){if(!n){c=s+1;break}}else o===-1&&(n=!1,o=s+1),r>=0&&(g===f.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=o))}return c===t?t=o:t===-1&&(t=u.length),u.slice(c,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===D){if(!n){c=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":u.slice(c,t)},extname(u){p(u,"path");let f=-1,c=0,t=-1,n=!0,s=0;for(let r=u.length-1;r>=0;--r){const o=u.charCodeAt(r);if(o===D){if(!n){c=r+1;break}continue}t===-1&&(n=!1,t=r+1),o===k?f===-1?f=r:s!==1&&(s=1):f!==-1&&(s=-1)}return f===-1||t===-1||s===0||s===1&&f===t-1&&f===c+1?"":u.slice(f,t)},format:S.bind(null,"/"),parse(u){p(u,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return f;const c=u.charCodeAt(0)===D;let t;c?(f.root="/",t=1):t=0;let n=-1,s=0,r=-1,o=!0,g=u.length-1,m=0;for(;g>=t;--g){const _=u.charCodeAt(g);if(_===D){if(!o){s=g+1;break}continue}r===-1&&(o=!1,r=g+1),_===k?n===-1?n=g:m!==1&&(m=1):n!==-1&&(m=-1)}if(r!==-1){const _=s===0&&c?1:s;n===-1||m===0||m===1&&n===r-1&&n===s+1?f.base=f.name=u.slice(_,r):(f.name=u.slice(_,n),f.base=u.slice(_,r),f.ext=u.slice(n,r))}return s>0?f.dir=u.slice(0,s-1):c&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[136],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var w;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(w=e.Source||(e.Source={}));var R;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(T,...y){const k=y.reduce((i,A)=>(i[A]=!0,i),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(i=>!k[i]).forEach(i=>{for(let A=0;A<D.length;A++)if(i.search(D[A])!==-1){delete T[i];break}})}e.sanitizeProcessEnvironment=C}),define(ge[44],pe([0,1,11]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=w.globals.performance&&typeof w.globals.performance.now=="function";class C{constructor(y){this._highResolution=R&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new C(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=C}),define(ge[3],pe([0,1,17,72,6,56,44]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(v){v.None=()=>C.Disposable.None;function S(U){return(V,W=null,P)=>{let N=!1,F;return F=U(M=>{if(!N)return F?F.dispose():N=!0,V.call(W,M)},null,P),N&&F.dispose(),F}}v.once=S;function u(U,V){return r((W,P=null,N)=>U(F=>W.call(P,V(F)),null,N))}v.map=u;function f(U,V){return r((W,P=null,N)=>U(F=>{V(F),W.call(P,F)},null,N))}v.forEach=f;function c(U,V){return r((W,P=null,N)=>U(F=>V(F)&&W.call(P,F),null,N))}v.filter=c;function t(U){return U}v.signal=t;function n(...U){return(V,W=null,P)=>(0,C.combinedDisposable)(...U.map(N=>N(F=>V.call(W,F),null,P)))}v.any=n;function s(U,V,W){let P=W;return u(U,N=>(P=V(P,N),P))}v.reduce=s;function r(U){let V;const W=new d({onFirstListenerAdd(){V=U(W.fire,W)},onLastListenerRemove(){V.dispose()}});return W.event}v.snapshot=r;function o(U,V,W=100,P=!1,N){let F,M,B,H=0;const Q=new d({leakWarningThreshold:N,onFirstListenerAdd(){F=U(le=>{H++,M=V(M,le),P&&!B&&(Q.fire(M),M=void 0),clearTimeout(B),B=setTimeout(()=>{const be=M;M=void 0,B=void 0,(!P||H>1)&&Q.fire(be),H=0},W)})},onLastListenerRemove(){F.dispose()}});return Q.event}v.debounce=o;function g(U){const V=new Date().getTime();return u(S(U),W=>new Date().getTime()-V)}v.stopwatch=g;function m(U,V=(W,P)=>W===P){let W=!0,P;return c(U,N=>{const F=W||!V(N,P);return W=!1,P=N,F})}v.latch=m;function _(U,V){return[v.filter(U,V),v.filter(U,W=>!V(W))]}v.split=_;function b(U,V=!1,W=[]){let P=W.slice(),N=U(B=>{P?P.push(B):M.fire(B)});const F=()=>{P&&P.forEach(B=>M.fire(B)),P=null},M=new d({onFirstListenerAdd(){N||(N=U(B=>M.fire(B)))},onFirstListenerDidAdd(){P&&(V?setTimeout(F):F())},onLastListenerRemove(){N&&N.dispose(),N=null}});return M.event}v.buffer=b;class l{constructor(V){this.event=V}map(V){return new l(u(this.event,V))}forEach(V){return new l(f(this.event,V))}filter(V){return new l(c(this.event,V))}reduce(V,W){return new l(s(this.event,V,W))}latch(){return new l(m(this.event))}debounce(V,W=100,P=!1,N){return new l(o(this.event,V,W,P,N))}on(V,W,P){return this.event(V,W,P)}once(V,W,P){return S(this.event)(V,W,P)}}function L(U){return new l(U)}v.chain=L;function O(U,V,W=P=>P){const P=(...B)=>M.fire(W(...B)),N=()=>U.on(V,P),F=()=>U.removeListener(V,P),M=new d({onFirstListenerAdd:N,onLastListenerRemove:F});return M.event}v.fromNodeEventEmitter=O;function $(U,V,W=P=>P){const P=(...B)=>M.fire(W(...B)),N=()=>U.addEventListener(V,P),F=()=>U.removeEventListener(V,P),M=new d({onFirstListenerAdd:N,onLastListenerRemove:F});return M.event}v.fromDOMEventEmitter=$;function ie(U){const V=new d;let W=!1;return U.then(void 0,()=>null).then(()=>{W?V.fire(void 0):setTimeout(()=>V.fire(void 0),0)}),W=!0,V.event}v.fromPromise=ie;function se(U){return new Promise(V=>S(U)(V))}v.toPromise=se})(k=e.Event||(e.Event={}));class D{constructor(S){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${S}_${D._idPool++}`}start(S){this._stopWatch=new y.StopWatch(!0),this._listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this._elapsedOverall+=S,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${S.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let I=-1;function i(v){const S=I;return I=v,{dispose(){I=S}}}e.setGlobalLeakWarningThreshold=i;class A{constructor(S,u=Math.random().toString(18).slice(2,5)){this.customThreshold=S,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(S){let u=I;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||S<u)return;this._stacks||(this._stacks=new Map);const f=new Error().stack.split(`
`).slice(3).join(`
`),c=this._stacks.get(f)||0;if(this._stacks.set(f,c+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,n=0;for(const[s,r]of this._stacks)(!t||n<r)&&(t=s,n=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(f)||0;this._stacks.set(f,t-1)}}}class d{constructor(S){var u;this._disposed=!1,this._options=S,this._leakageMon=I>0?new A(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(S,u,f)=>{var c;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(u?[S,u]:S);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,S,u);const s=(c=this._leakageMon)===null||c===void 0?void 0:c.check(this._listeners.size);let r;return r={dispose:()=>{s&&s(),r.dispose=d._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},f instanceof C.DisposableStore?f.add(r):Array.isArray(f)&&f.push(r),r}),this._event}fire(S){var u,f;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,S]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,t]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,t):c[0].call(c[1],t)}catch(n){(0,w.onUnexpectedError)(n)}}(f=this._perfMon)===null||f===void 0||f.stop()}}dispose(){var S,u,f,c,t;this._disposed||(this._disposed=!0,(S=this._listeners)===null||S===void 0||S.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(c=(f=this._options)===null||f===void 0?void 0:f.onLastListenerRemove)===null||c===void 0||c.call(f),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=d,d._noop=function(){};class p extends d{constructor(S){super(S);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=S==null?void 0:S.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._listeners&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=p;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const u={event:S,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const f=()=>{this.hasListeners&&this.unhook(u);const c=this.events.indexOf(u);this.events.splice(c,1)};return(0,C.toDisposable)((0,R.once)(f))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(u=>this.emitter.fire(u))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class h{constructor(){this.buffers=[]}wrapEvent(S){return(u,f,c)=>S(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>u.call(f,t)):u.call(f,t)},void 0,c)}bufferEvents(S){const u=[];this.buffers.push(u);const f=S();return this.buffers.pop(),u.forEach(c=>c()),f}}e.EventBufferer=h;class E{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=C.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(ge[21],pe([0,1,3]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(k,D){const I=setTimeout(k.bind(D),0);return{dispose(){clearTimeout(I)}}});var C;(function(k){function D(I){return I===k.None||I===k.Cancelled||I instanceof T?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}k.isCancellationToken=D,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(C=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=C.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=y}),define(ge[45],pe([0,1,3]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(A){const d=this._icons.get(A.id);d?A.description?d.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new R;e.iconRegistry=C;function T(i,A){return new k(i,A)}e.registerCodicon=T;function y(i){return i?i.replace(/\$\((.*?)\)/g,(A,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=y;class k{constructor(A,d,p){this.id=A,this.definition=d,this.description=p,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function D(i,A){const d=["codicon","codicon-"+i];return A&&d.push("codicon-modifier-"+A),d}e.getClassNamesArray=D;var I;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const A=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function d(h){if(h instanceof k)return["codicon","codicon-"+h.id];const E=A.exec(h.id);if(!E)return d(k.error);let[,v,S]=E;const u=["codicon","codicon-"+v];return S&&u.push("codicon-modifier-"+S.substr(1)),u}i.asClassNameArray=d;function p(h){return d(h).join(" ")}i.asClassName=p;function a(h){return"."+d(h).join(".")}i.asCSSSelector=a})(I=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(k=e.Codicon||(e.Codicon={}))}),define(ge[93],pe([0,1,17,6]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(u){const f=u;return f?[f.on,f.pause,f.resume,f.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=C;function T(u){const f=u;return f?C(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=T;function y(u,f){return new k(u,f)}e.newWriteableStream=y;class k{constructor(f,c){this.reducer=f,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){var c;if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof((c=this.options)===null||c===void 0?void 0:c.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(c=>c(f))}emitError(f){this.listeners.error.length===0?(0,w.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(c=>c(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,c){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(f,c){if(this.state.destroyed)return;let t;switch(f){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(c);n>=0&&t.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(u,f){const c=[];let t;for(;(t=u.read())!==null;)c.push(t);return f(c)}e.consumeReadable=D;function I(u,f,c){const t=[];let n;for(;(n=u.read())!==null&&t.length<c;)t.push(n);return n===null&&t.length>0?f(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const s=n;return n=void 0,s}return u.read()}}}e.peekReadable=I;function i(u,f){return new Promise((c,t)=>{const n=[];A(u,{onData:s=>{f&&n.push(s)},onError:s=>{f?t(s):c(void 0)},onEnd:()=>{c(f?f(n):void 0)}})})}e.consumeStream=i;function A(u,f){u.on("error",c=>f.onError(c)),u.on("end",()=>f.onEnd()),u.on("data",c=>f.onData(c))}e.listenStream=A;function d(u,f){return new Promise((c,t)=>{const n=new R.DisposableStore,s=[],r=m=>{if(s.push(m),s.length>f)return n.dispose(),u.pause(),c({stream:u,buffer:s,ended:!1})},o=m=>t(m),g=()=>c({stream:u,buffer:s,ended:!0});n.add((0,R.toDisposable)(()=>u.removeListener("error",o))),u.on("error",o),n.add((0,R.toDisposable)(()=>u.removeListener("end",g))),u.on("end",g),n.add((0,R.toDisposable)(()=>u.removeListener("data",r))),u.on("data",r)})}e.peekStream=d;function p(u,f){const c=y(f);return c.end(u),c}e.toStream=p;function a(){const u=y(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=a;function h(u){let f=!1;return{read:()=>f?null:(f=!0,u)}}e.toReadable=h;function E(u,f,c){const t=y(c);return A(u,{onData:n=>t.write(f.data(n)),onError:n=>t.error(f.error?f.error(n):n),onEnd:()=>t.end()}),t}e.transform=E;function v(u,f,c){let t=!1;return{read:()=>{const n=f.read();return t?n:(t=!0,n!==null?c([u,n]):u)}}}e.prefixedReadable=v;function S(u,f,c){let t=!1;const n=y(c);return A(f,{onData:s=>t?n.write(s):(t=!0,n.write(c([u,s]))),onError:s=>n.error(s),onEnd:()=>{t||(t=!0,n.write(u)),n.end()}}),n}e.prefixedStream=S}),define(ge[8],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function w(z){return!z||typeof z!="string"?!0:z.trim().length===0}e.isFalsyOrWhitespace=w;const R=/{(\d+)}/g;function C(z,...Z){return Z.length===0?z:z.replace(R,function(ue,Ie){const Pe=parseInt(Ie,10);return isNaN(Pe)||Pe<0||Pe>=Z.length?ue:Z[Pe]})}e.format=C;function T(z){return z.replace(/[<>&]/g,function(Z){switch(Z){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Z}})}e.escape=T;function y(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function k(z,Z){let ue=0;const Ie=Z.charCodeAt(0);for(let Pe=z.length-1;Pe>=0;Pe--)z.charCodeAt(Pe)===Ie&&ue++;return ue}e.count=k;function D(z,Z,ue="\u2026"){return z.length<=Z?z:`${z.substr(0,Z)}${ue}`}e.truncate=D;function I(z,Z=" "){const ue=i(z,Z);return A(ue,Z)}e.trim=I;function i(z,Z){if(!z||!Z)return z;const ue=Z.length;if(ue===0||z.length===0)return z;let Ie=0;for(;z.indexOf(Z,Ie)===Ie;)Ie=Ie+ue;return z.substring(Ie)}e.ltrim=i;function A(z,Z){if(!z||!Z)return z;const ue=Z.length,Ie=z.length;if(ue===0||Ie===0)return z;let Pe=Ie,Ue=-1;for(;Ue=z.lastIndexOf(Z,Pe-1),!(Ue===-1||Ue+ue!==Pe);){if(Ue===0)return"";Pe=Ue}return z.substring(0,Pe)}e.rtrim=A;function d(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function p(z){return z.replace(/\*/g,"")}e.stripWildcards=p;function a(z,Z,ue={}){if(!z)throw new Error("Cannot create regex from empty string");Z||(z=y(z)),ue.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let Ie="";return ue.global&&(Ie+="g"),ue.matchCase||(Ie+="i"),ue.multiline&&(Ie+="m"),ue.unicode&&(Ie+="u"),new RegExp(z,Ie)}e.createRegExp=a;function h(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function E(z){return!!z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function v(z){return(z.global?"g":"")+(z.ignoreCase?"i":"")+(z.multiline?"m":"")+(z.unicode?"u":"")}e.regExpFlags=v;function S(z){return z.split(/\r\n|\r|\n/)}e.splitLines=S;function u(z){for(let Z=0,ue=z.length;Z<ue;Z++){const Ie=z.charCodeAt(Z);if(Ie!==32&&Ie!==9)return Z}return-1}e.firstNonWhitespaceIndex=u;function f(z,Z=0,ue=z.length){for(let Ie=Z;Ie<ue;Ie++){const Pe=z.charCodeAt(Ie);if(Pe!==32&&Pe!==9)return z.substring(Z,Ie)}return z.substring(Z,ue)}e.getLeadingWhitespace=f;function c(z,Z=z.length-1){for(let ue=Z;ue>=0;ue--){const Ie=z.charCodeAt(ue);if(Ie!==32&&Ie!==9)return ue}return-1}e.lastNonWhitespaceIndex=c;function t(z,Z){return z<Z?-1:z>Z?1:0}e.compare=t;function n(z,Z,ue=0,Ie=z.length,Pe=0,Ue=Z.length){for(;ue<Ie&&Pe<Ue;ue++,Pe++){let rt=z.charCodeAt(ue),tt=Z.charCodeAt(Pe);if(rt<tt)return-1;if(rt>tt)return 1}const xe=Ie-ue,Qe=Ue-Pe;return xe<Qe?-1:xe>Qe?1:0}e.compareSubstring=n;function s(z,Z){return r(z,Z,0,z.length,0,Z.length)}e.compareIgnoreCase=s;function r(z,Z,ue=0,Ie=z.length,Pe=0,Ue=Z.length){for(;ue<Ie&&Pe<Ue;ue++,Pe++){let rt=z.charCodeAt(ue),tt=Z.charCodeAt(Pe);if(rt===tt)continue;const Ye=rt-tt;if(!(Ye===32&&g(tt))&&!(Ye===-32&&g(rt)))return o(rt)&&o(tt)?Ye:n(z.toLowerCase(),Z.toLowerCase(),ue,Ie,Pe,Ue)}const xe=Ie-ue,Qe=Ue-Pe;return xe<Qe?-1:xe>Qe?1:0}e.compareSubstringIgnoreCase=r;function o(z){return z>=97&&z<=122}e.isLowerAsciiLetter=o;function g(z){return z>=65&&z<=90}e.isUpperAsciiLetter=g;function m(z){return o(z)||g(z)}function _(z,Z){return z.length===Z.length&&b(z,Z)}e.equalsIgnoreCase=_;function b(z,Z,ue=z.length){for(let Ie=0;Ie<ue;Ie++){const Pe=z.charCodeAt(Ie),Ue=Z.charCodeAt(Ie);if(Pe!==Ue){if(m(Pe)&&m(Ue)){const xe=Math.abs(Pe-Ue);if(xe!==0&&xe!==32)return!1}else if(String.fromCharCode(Pe).toLowerCase()!==String.fromCharCode(Ue).toLowerCase())return!1}}return!0}function l(z,Z){const ue=Z.length;return Z.length>z.length?!1:b(z,Z,ue)}e.startsWithIgnoreCase=l;function L(z,Z){let ue,Ie=Math.min(z.length,Z.length);for(ue=0;ue<Ie;ue++)if(z.charCodeAt(ue)!==Z.charCodeAt(ue))return ue;return Ie}e.commonPrefixLength=L;function O(z,Z){let ue,Ie=Math.min(z.length,Z.length);const Pe=z.length-1,Ue=Z.length-1;for(ue=0;ue<Ie;ue++)if(z.charCodeAt(Pe-ue)!==Z.charCodeAt(Ue-ue))return ue;return Ie}e.commonSuffixLength=O;function $(z){return 55296<=z&&z<=56319}e.isHighSurrogate=$;function ie(z){return 56320<=z&&z<=57343}e.isLowSurrogate=ie;function se(z,Z){return(z-55296<<10)+(Z-56320)+65536}e.computeCodePoint=se;function U(z,Z,ue){const Ie=z.charCodeAt(ue);if($(Ie)&&ue+1<Z){const Pe=z.charCodeAt(ue+1);if(ie(Pe))return se(Ie,Pe)}return Ie}e.getNextCodePoint=U;function V(z,Z){const ue=z.charCodeAt(Z-1);if(ie(ue)&&Z>1){const Ie=z.charCodeAt(Z-2);if($(Ie))return se(Ie,ue)}return ue}function W(z,Z){const ue=We.getInstance(),Ie=Z,Pe=z.length,Ue=U(z,Pe,Z);Z+=Ue>=65536?2:1;let xe=ue.getGraphemeBreakType(Ue);for(;Z<Pe;){const Qe=U(z,Pe,Z),rt=ue.getGraphemeBreakType(Qe);if(Oe(xe,rt))break;Z+=Qe>=65536?2:1,xe=rt}return Z-Ie}e.nextCharLength=W;function P(z,Z){const ue=We.getInstance(),Ie=Z,Pe=V(z,Z);Z-=Pe>=65536?2:1;let Ue=ue.getGraphemeBreakType(Pe);for(;Z>0;){const xe=V(z,Z),Qe=ue.getGraphemeBreakType(xe);if(Oe(Qe,Ue))break;Z-=xe>=65536?2:1,Ue=Qe}return Ie-Z}e.prevCharLength=P;function N(z,Z){const ue=We.getInstance(),Ie=z.length,Pe=Z,Ue=U(z,Ie,Z),xe=ue.getGraphemeBreakType(Ue);Z+=Ue>=65536?2:1;let Qe=xe;for(;Z<Ie;){const tt=U(z,Ie,Z),Ye=ue.getGraphemeBreakType(tt);if(Oe(Qe,Ye))break;Z+=tt>=65536?2:1,Qe=Ye}const rt=Z;for(Z=Pe,Qe=xe;Z>0;){const tt=V(z,Z),Ye=ue.getGraphemeBreakType(tt);if(Oe(Ye,Qe))break;Z-=tt>=65536?2:1,Qe=Ye}return[Z,rt]}function F(z,Z){return Z>0&&ie(z.charCodeAt(Z))?N(z,Z-1):N(z,Z)}e.getCharContainingOffset=F;function M(z){const Z=z.length;let ue=0,Ie=0;for(;Ie<Z;){const xe=U(z,Z,Ie);Ie+=xe>=65536?2:1,xe<128?ue+=1:xe<2048?ue+=2:xe<65536?ue+=3:ue+=4}const Pe=new Uint8Array(ue);Ie=0;let Ue=0;for(;Ie<Z;){const xe=U(z,Z,Ie);Ie+=xe>=65536?2:1,xe<128?Pe[Ue++]=xe:xe<2048?(Pe[Ue++]=192|(xe&1984)>>>6,Pe[Ue++]=128|(xe&63)>>>0):xe<65536?(Pe[Ue++]=224|(xe&61440)>>>12,Pe[Ue++]=128|(xe&4032)>>>6,Pe[Ue++]=128|(xe&63)>>>0):(Pe[Ue++]=240|(xe&1835008)>>>18,Pe[Ue++]=128|(xe&258048)>>>12,Pe[Ue++]=128|(xe&4032)>>>6,Pe[Ue++]=128|(xe&63)>>>0)}return Pe}e.encodeUTF8=M;function B(z){const Z=z.byteLength,ue=[];let Ie=0;for(;Ie<Z;){const Pe=z[Ie];let Ue;if(Pe>=240&&Ie+3<Z?Ue=(z[Ie++]&7)<<18>>>0|(z[Ie++]&63)<<12>>>0|(z[Ie++]&63)<<6>>>0|(z[Ie++]&63)<<0>>>0:Pe>=224&&Ie+2<Z?Ue=(z[Ie++]&15)<<12>>>0|(z[Ie++]&63)<<6>>>0|(z[Ie++]&63)<<0>>>0:Pe>=192&&Ie+1<Z?Ue=(z[Ie++]&31)<<6>>>0|(z[Ie++]&63)<<0>>>0:Ue=z[Ie++],Ue>=0&&Ue<=55295||Ue>=57344&&Ue<=65535)ue.push(String.fromCharCode(Ue));else if(Ue>=65536&&Ue<=1114111){const xe=Ue-65536,Qe=55296+((xe&1047552)>>>10),rt=56320+((xe&1023)>>>0);ue.push(String.fromCharCode(Qe)),ue.push(String.fromCharCode(rt))}else ue.push(String.fromCharCode(65533))}return ue.join("")}e.decodeUTF8=B;const H=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(z){return H.test(z)}e.containsRTL=Q;const le=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function be(z){return le.test(z)}e.containsEmoji=be;const Te=/^[\t\n\r\x20-\x7E]*$/;function ke(z){return Te.test(z)}e.isBasicASCII=ke,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ne(z){return e.UNUSUAL_LINE_TERMINATORS.test(z)}e.containsUnusualLineTerminators=Ne;function Ke(z){for(let Z=0,ue=z.length;Z<ue;Z++)if(ze(z.charCodeAt(Z)))return!0;return!1}e.containsFullWidthCharacter=Ke;function ze(z){return z=+z,z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}e.isFullWidthCharacter=ze;function qe(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129003||z>=129280&&z<=129535||z>=129648&&z<=129750}e.isEmojiImprecise=qe;function q(z,Z){if(z.length<Z)return z;const ue=/\b/g;let Ie=0;for(;ue.test(z)&&!(z.length-ue.lastIndex<Z);)Ie=ue.lastIndex,ue.lastIndex+=1;return z.substring(Ie).replace(/^\s/,"")}e.lcut=q;const J=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,oe=/\x1b\[0?m/g;function Y(z){return z&&(z=z.replace(J,""),z=z.replace(re,""),z=z.replace(oe,"")),z}e.removeAnsiEscapeCodes=Y,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(z){return!!(z&&z.length>0&&z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function ve(z){return ce(z)?z.substr(1):z}e.stripUTF8BOM=ve;function Le(z,Z){if(!z||!Z||z.length<Z.length)return!1;const ue=Z.length,Ie=z.toLowerCase();let Pe=0,Ue=-1;for(;Pe<ue;){const xe=Ie.indexOf(Z[Pe],Ue+1);if(xe<0)return!1;Ue=xe,Pe++}return!0}e.fuzzyContains=Le;function we(z,Z=!1){return z?(Z&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}e.containsUppercaseCharacter=we;function je(z){return z.charAt(0).toUpperCase()+z.slice(1)}e.uppercaseFirstLetter=je;function K(z,Z=1){if(Z===0)return"";let ue=-1;do ue=z.indexOf(`
`,ue+1),Z--;while(Z>0&&ue>=0);return ue===-1?z:(z[ue-1]==="\r"&&ue--,z.substr(0,ue))}e.getNLines=K;function ne(z){const Z=90-65+1;return z=z%(2*Z),z<Z?String.fromCharCode(97+z):String.fromCharCode(65+z-Z)}e.singleLetterHash=ne;function Ee(z){return We.getInstance().getGraphemeBreakType(z)}e.getGraphemeBreakType=Ee;function Oe(z,Z){return z===0?Z!==5&&Z!==7:z===2&&Z===3?!1:z===4||z===2||z===3||Z===4||Z===2||Z===3?!0:!(z===8&&(Z===8||Z===9||Z===11||Z===12)||(z===11||z===9)&&(Z===9||Z===10)||(z===12||z===10)&&Z===10||Z===5||Z===13||Z===7||z===1||z===13&&Z===14||z===6&&Z===6)}e.breakBetweenGraphemeBreakType=Oe;var $e;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})($e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{constructor(){this._data=Xe()}static getInstance(){return We._INSTANCE||(We._INSTANCE=new We),We._INSTANCE}getGraphemeBreakType(Z){if(Z<32)return Z===10?3:Z===13?2:4;if(Z<127)return 0;const ue=this._data,Ie=ue.length/3;let Pe=1;for(;Pe<=Ie;)if(Z<ue[3*Pe])Pe=2*Pe;else if(Z>ue[3*Pe+1])Pe=2*Pe+1;else return ue[3*Pe+2];return 0}}We._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function De(z,Z){if(z===0)return 0;const ue=ye(z,Z);if(ue!==void 0)return ue;const Ie=V(Z,z);return z-=Ce(Ie),z}e.getLeftDeleteOffset=De;function ye(z,Z){let ue=V(Z,z);for(z-=Ce(ue);ae(ue)||ue===65039||ue===8419;){if(z===0)return;ue=V(Z,z),z-=Ce(ue)}if(!!qe(ue)){if(z>=0){const Ie=V(Z,z);Ie===8205&&(z-=Ce(Ie))}return z}}function Ce(z){return z>=65536?2:1}function ae(z){return 127995<=z&&z<=127999}var he;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(he||(he={}))}),define(ge[23],pe([0,1,8,93]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let k,D;class I{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return C?new I(Buffer.allocUnsafe(m)):new I(new Uint8Array(m))}static wrap(m){return C&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new I(m)}static fromString(m,_){return!((_==null?void 0:_.dontUseNodeBuffer)||!1)&&C?new I(Buffer.from(m)):T?(k||(k=new TextEncoder),new I(k.encode(m))):new I(w.encodeUTF8(m))}static concat(m,_){if(typeof _=="undefined"){_=0;for(let L=0,O=m.length;L<O;L++)_+=m[L].byteLength}const b=I.alloc(_);let l=0;for(let L=0,O=m.length;L<O;L++){const $=m[L];b.set($,l),l+=$.byteLength}return b}toString(){return C?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):w.decodeUTF8(this.buffer)}slice(m,_){return new I(this.buffer.subarray(m,_))}set(m,_){m instanceof I?this.buffer.set(m.buffer,_):this.buffer.set(m,_)}readUInt32BE(m){return d(this.buffer,m)}writeUInt32BE(m,_){p(this.buffer,m,_)}readUInt32LE(m){return a(this.buffer,m)}writeUInt32LE(m,_){h(this.buffer,m,_)}readUInt8(m){return E(this.buffer,m)}writeUInt8(m,_){v(this.buffer,m,_)}}e.VSBuffer=I;function i(g,m){return g[m+0]<<0>>>0|g[m+1]<<8>>>0}e.readUInt16LE=i;function A(g,m,_){g[_+0]=m&255,m=m>>>8,g[_+1]=m&255}e.writeUInt16LE=A;function d(g,m){return g[m]*2**24+g[m+1]*2**16+g[m+2]*2**8+g[m+3]}e.readUInt32BE=d;function p(g,m,_){g[_+3]=m,m=m>>>8,g[_+2]=m,m=m>>>8,g[_+1]=m,m=m>>>8,g[_]=m}e.writeUInt32BE=p;function a(g,m){return g[m+0]<<0>>>0|g[m+1]<<8>>>0|g[m+2]<<16>>>0|g[m+3]<<24>>>0}e.readUInt32LE=a;function h(g,m,_){g[_+0]=m&255,m=m>>>8,g[_+1]=m&255,m=m>>>8,g[_+2]=m&255,m=m>>>8,g[_+3]=m&255}e.writeUInt32LE=h;function E(g,m){return g[m]}e.readUInt8=E;function v(g,m,_){g[_]=m}e.writeUInt8=v;function S(g){return R.consumeReadable(g,m=>I.concat(m))}e.readableToBuffer=S;function u(g){return R.toReadable(g)}e.bufferToReadable=u;function f(g){return R.consumeStream(g,m=>I.concat(m))}e.streamToBuffer=f;async function c(g){return g.ended?I.concat(g.buffer):I.concat([...g.buffer,await f(g.stream)])}e.bufferedStreamToBuffer=c;function t(g){return R.toStream(g,m=>I.concat(m))}e.bufferToStream=t;function n(g){return R.transform(g,{data:m=>typeof m=="string"?I.fromString(m):I.wrap(m)},m=>I.concat(m))}e.streamToBufferReadableStream=n;function s(g){return R.newWriteableStream(m=>I.concat(m),g)}e.newWriteableBufferStream=s;function r(g,m){return R.prefixedReadable(g,m,_=>I.concat(_))}e.prefixedBufferReadable=r;function o(g,m){return R.prefixedStream(g,m,_=>I.concat(_))}e.prefixedBufferStream=o}),define(ge[75],pe([0,1,8]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(v){return C(v,0)}e.hash=R;function C(v,S){switch(typeof v){case"object":return v===null?T(349,S):Array.isArray(v)?D(v,S):I(v,S);case"string":return k(v,S);case"boolean":return y(v,S);case"number":return T(v,S);case"undefined":return T(937,S);default:return T(617,S)}}e.doHash=C;function T(v,S){return(S<<5)-S+v|0}function y(v,S){return T(v?433:863,S)}function k(v,S){S=T(149417,S);for(let u=0,f=v.length;u<f;u++)S=T(v.charCodeAt(u),S);return S}e.stringHash=k;function D(v,S){return S=T(104579,S),v.reduce((u,f)=>C(f,u),S)}function I(v,S){return S=T(181387,S),Object.keys(v).sort().reduce((u,f)=>(u=k(f,u),C(v[f],u)),S)}class i{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=C(S,this._value),this._value}}e.Hasher=i;var A;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function d(v,S,u=32){const f=u-S,c=~((1<<f)-1);return(v<<S|(c&v)>>>f)>>>0}function p(v,S=0,u=v.byteLength,f=0){for(let c=0;c<u;c++)v[S+c]=f}function a(v,S,u="0"){for(;v.length<S;)v=u+v;return v}function h(v,S=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(u=>u.toString(16).padStart(2,"0")).join(""):a((v>>>0).toString(16),S/4)}e.toHexString=h;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const u=S.length;if(u===0)return;const f=this._buff;let c=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=S.charCodeAt(0),s=0);;){let r=n;if(w.isHighSurrogate(n))if(s+1<u){const o=S.charCodeAt(s+1);w.isLowSurrogate(o)?(s++,r=w.computeCodePoint(n,o)):r=65533}else{t=n;break}else w.isLowSurrogate(n)&&(r=65533);if(c=this._push(f,c,r),s++,s<u)n=S.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=t}_push(S,u,f){return f<128?S[u++]=f:f<2048?(S[u++]=192|(f&1984)>>>6,S[u++]=128|(f&63)>>>0):f<65536?(S[u++]=224|(f&61440)>>>12,S[u++]=128|(f&4032)>>>6,S[u++]=128|(f&63)>>>0):(S[u++]=240|(f&1835008)>>>18,S[u++]=128|(f&258048)>>>12,S[u++]=128|(f&4032)>>>6,S[u++]=128|(f&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=E._bigBlock32,u=this._buffDV;for(let m=0;m<64;m+=4)S.setUint32(m,u.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)S.setUint32(m,d(S.getUint32(m-12,!1)^S.getUint32(m-32,!1)^S.getUint32(m-56,!1)^S.getUint32(m-64,!1),1),!1);let f=this._h0,c=this._h1,t=this._h2,n=this._h3,s=this._h4,r,o,g;for(let m=0;m<80;m++)m<20?(r=c&t|~c&n,o=1518500249):m<40?(r=c^t^n,o=1859775393):m<60?(r=c&t|c&n|t&n,o=2400959708):(r=c^t^n,o=3395469782),g=d(f,5)+r+s+o+S.getUint32(m*4,!1)&4294967295,s=n,n=t,t=d(c,30),c=f,f=g;this._h0=this._h0+f&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[57],pe([0,1,8]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(R||(R={})),function(C){const T="error",y="warning",k="warn",D="info",I="ignore";function i(d){return d?w.equalsIgnoreCase(T,d)?C.Error:w.equalsIgnoreCase(y,d)||w.equalsIgnoreCase(k,d)?C.Warning:w.equalsIgnoreCase(D,d)?C.Info:C.Ignore:C.Ignore}C.fromValue=i;function A(d){switch(d){case C.Error:return T;case C.Warning:return y;case C.Info:return D;default:return I}}C.toString=A}(R||(R={})),e.default=R}),define(ge[12],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(m){return Array.isArray(m)}e.isArray=w;function R(m){return typeof m=="string"}e.isString=R;function C(m){return Array.isArray(m)&&m.every(_=>R(_))}e.isStringArray=C;function T(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=T;function y(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=y;function k(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=k;function D(m){return m===!0||m===!1}e.isBoolean=D;function I(m){return typeof m=="undefined"}e.isUndefined=I;function i(m){return!A(m)}e.isDefined=i;function A(m){return I(m)||m===null}e.isUndefinedOrNull=A;function d(m,_){if(!m)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=d;function p(m){if(A(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=p;function a(...m){const _=[];for(let b=0;b<m.length;b++){const l=m[b];if(A(l))throw new Error(`Assertion Failed: argument at index ${b} is undefined or null`);_.push(l)}return _}e.assertAllDefined=a;const h=Object.prototype.hasOwnProperty;function E(m){if(!T(m))return!1;for(let _ in m)if(h.call(m,_))return!1;return!0}e.isEmptyObject=E;function v(m){return typeof m=="function"}e.isFunction=v;function S(...m){return m.length>0&&m.every(v)}e.areFunctions=S;function u(m,_){const b=Math.min(m.length,_.length);for(let l=0;l<b;l++)f(m[l],_[l])}e.validateConstraints=u;function f(m,_){if(R(_)){if(typeof m!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(v(_)){try{if(m instanceof _)return}catch(b){}if(!A(m)&&m.constructor===_||_.length===1&&_.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function c(m){let _=[],b=Object.getPrototypeOf(m);for(;Object.prototype!==b;)_=_.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return _}e.getAllPropertyNames=c;function t(m){const _=[];for(const b of c(m))typeof m[b]=="function"&&_.push(b);return _}e.getAllMethodNames=t;function n(m,_){const b=L=>function(){const O=Array.prototype.slice.call(arguments,0);return _(L,O)};let l={};for(const L of m)l[L]=b(L);return l}e.createProxyObject=n;function s(m){return m===null?void 0:m}e.withNullAsUndefined=s;function r(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=r;function o(m){return class{constructor(){return new Proxy({},{get(_,b){if(_[b])return _[b];throw new Error(`Not Implemented: ${m}->${String(b)}`)}})}}}e.NotImplementedProxy=o;function g(m){throw new Error("Unreachable")}e.assertNever=g}),define(ge[29],pe([0,1,11,8,9,12]),function(G,e,w,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(s){return s===47||s===92}e.isPathSeparator=y;function k(s){return s.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=k;function D(s){return s.indexOf("/")===-1&&(s=k(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=D;function I(s,r=C.posix.sep){if(!s)return"";const o=s.length,g=s.charCodeAt(0);if(y(g)){if(y(s.charCodeAt(1))&&!y(s.charCodeAt(2))){let _=3;const b=_;for(;_<o&&!y(s.charCodeAt(_));_++);if(b!==_&&!y(s.charCodeAt(_+1))){for(_+=1;_<o;_++)if(y(s.charCodeAt(_)))return s.slice(0,_+1).replace(/[\\/]/g,r)}}return r}else if(v(g)&&s.charCodeAt(1)===58)return y(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let m=s.indexOf("://");if(m!==-1){for(m+=3;m<o;m++)if(y(s.charCodeAt(m)))return s.slice(0,m+1)}return""}e.getRoot=I;function i(s){if(!w.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let o=2;const g=o;for(;o<s.length&&(r=s.charCodeAt(o),r!==92);o++);return!(g===o||(r=s.charCodeAt(o+1),isNaN(r)||r===92))}e.isUNC=i;const A=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(s,r=w.isWindows){const o=r?A:d;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||r&&p.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=a;function h(s,r,o){const g=s===r;return!o||g?g:!s||!r?!1:(0,R.equalsIgnoreCase)(s,r)}e.isEqual=h;function E(s,r,o,g=C.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(o){if(!(0,R.startsWithIgnoreCase)(s,r))return!1;if(r.length===s.length)return!0;let _=r.length;return r.charAt(r.length-1)===g&&_--,s.charAt(_)===g}return r.charAt(r.length-1)!==g&&(r+=g),s.indexOf(r)===0}e.isEqualOrParent=E;function v(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=v;function S(s,r){return w.isWindows&&s.endsWith(":")&&(s+=C.sep),(0,C.isAbsolute)(s)||(s=(0,C.join)(r,s)),s=(0,C.normalize)(s),w.isWindows?(s=(0,R.rtrim)(s,C.sep),s.endsWith(":")&&(s+=C.sep)):(s=(0,R.rtrim)(s,C.sep),s||(s=C.sep)),s}e.sanitizeFilePath=S;function u(s){const r=(0,C.normalize)(s);return w.isWindows?s.length>3?!1:f(r)&&(s.length===2||r.charCodeAt(2)===92):r===C.posix.sep}e.isRootOrDriveLetter=u;function f(s){return w.isWindows?v(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function c(s){return f(s)?s[0]:void 0}e.getDriveLetter=c;function t(s,r,o){return r.length>s.length?-1:s===r?0:(o&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=t;function n(s){const r=s.split(":");let o,g,m;if(r.forEach(_=>{const b=Number(_);(0,T.isNumber)(b)?g===void 0?g=b:m===void 0&&(m=b):o=o?[o,_].join(":"):_}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:g!==void 0?g:void 0,column:m!==void 0?m:g!==void 0?1:void 0}}e.parseLineAndColumnAware=n}),define(ge[25],pe([0,1,12]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const E=Array.isArray(h)?[]:{};return Object.keys(h).forEach(v=>{h[v]&&typeof h[v]=="object"?E[v]=R(h[v]):E[v]=h[v]}),E}e.deepClone=R;function C(h){if(!h||typeof h!="object")return h;const E=[h];for(;E.length>0;){const v=E.shift();Object.freeze(v);for(const S in v)if(T.call(v,S)){const u=v[S];typeof u=="object"&&!Object.isFrozen(u)&&E.push(u)}}return h}e.deepFreeze=C;const T=Object.prototype.hasOwnProperty;function y(h,E){return k(h,E,new Set)}e.cloneAndChange=y;function k(h,E,v){if((0,w.isUndefinedOrNull)(h))return h;const S=E(h);if(typeof S!="undefined")return S;if((0,w.isArray)(h)){const u=[];for(const f of h)u.push(k(f,E,v));return u}if((0,w.isObject)(h)){if(v.has(h))throw new Error("Cannot clone recursive data-structure");v.add(h);const u={};for(let f in h)T.call(h,f)&&(u[f]=k(h[f],E,v));return v.delete(h),u}return h}function D(h,E,v=!0){return(0,w.isObject)(h)?((0,w.isObject)(E)&&Object.keys(E).forEach(S=>{S in h?v&&((0,w.isObject)(h[S])&&(0,w.isObject)(E[S])?D(h[S],E[S],v):h[S]=E[S]):h[S]=E[S]}),h):E}e.mixin=D;function I(h,E){if(h===E)return!0;if(h==null||E===null||E===void 0||typeof h!=typeof E||typeof h!="object"||Array.isArray(h)!==Array.isArray(E))return!1;let v,S;if(Array.isArray(h)){if(h.length!==E.length)return!1;for(v=0;v<h.length;v++)if(!I(h[v],E[v]))return!1}else{const u=[];for(S in h)u.push(S);u.sort();const f=[];for(S in E)f.push(S);if(f.sort(),!I(u,f))return!1;for(v=0;v<u.length;v++)if(!I(h[u[v]],E[u[v]]))return!1}return!0}e.equals=I;function i(h){const E=new Set;return JSON.stringify(h,(v,S)=>{if((0,w.isObject)(S)||Array.isArray(S)){if(E.has(S))return"[Circular]";E.add(S)}return S})}e.safeStringify=i;function A(h,E,v){const S=E(h);return typeof S=="undefined"?v:S}e.getOrDefault=A;function d(h,E){const v=Object.create(null);return!h||!E||Object.keys(E).forEach(u=>{const f=h[u],c=E[u];I(f,c)||(v[u]=c)}),v}e.distinct=d;function p(h,E){const v=E.toLowerCase(),S=Object.keys(h).find(u=>u.toLowerCase()===v);return S?h[S]:h[E]}e.getCaseInsensitive=p;function a(h,E){const v=Object.create(null);for(const S of Object.keys(h))E(S,h[S])&&(v[S]=h[S]);return v}e.filter=a}),define(ge[94],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var w;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(w=e.Constants||(e.Constants={}));function R(T){return T<0?0:T>255?255:T|0}e.toUint8=R;function C(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=C}),define(ge[2],pe([0,1,11,9]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,T=/^\//,y=/^\/\//;function k(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!C.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!T.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(s,r){return!s&&!r?"file":s}function I(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==A&&(r=A+r):r=A;break}return r}const i="",A="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(r,o,g,m,_,b=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=D(r,b),this.authority=o||i,this.path=I(this.scheme,g||i),this.query=m||i,this.fragment=_||i,k(this,b))}static isUri(r){return r instanceof p?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return u(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:g,path:m,query:_,fragment:b}=r;return o===void 0?o=this.scheme:o===null&&(o=i),g===void 0?g=this.authority:g===null&&(g=i),m===void 0?m=this.path:m===null&&(m=i),_===void 0?_=this.query:_===null&&(_=i),b===void 0?b=this.fragment:b===null&&(b=i),o===this.scheme&&g===this.authority&&m===this.path&&_===this.query&&b===this.fragment?this:new h(o,g,m,_,b)}static parse(r,o=!1){const g=d.exec(r);return g?new h(g[2]||i,n(g[4]||i),n(g[5]||i),n(g[7]||i),n(g[9]||i),o):new h(i,i,i,i,i)}static file(r){let o=i;if(w.isWindows&&(r=r.replace(/\\/g,A)),r[0]===A&&r[1]===A){const g=r.indexOf(A,2);g===-1?(o=r.substring(2),r=A):(o=r.substring(2,g),r=r.substring(g)||A)}return new h("file",o,r,i,i)}static from(r){const o=new h(r.scheme,r.authority,r.path,r.query,r.fragment);return k(o,!0),o}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return w.isWindows&&r.scheme==="file"?g=p.file(R.win32.join(u(r,!0),...o)).path:g=R.posix.join(r.path,...o),r.with({path:g})}toString(r=!1){return f(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof p)return r;{const o=new h(r);return o._formatted=r.external,o._fsPath=r._sep===a?r.fsPath:null,o}}else return r}}e.URI=p;const a=w.isWindows?1:void 0;class h extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(r=!1){return r?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=a),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(s,r){let o,g=-1;for(let m=0;m<s.length;m++){const _=s.charCodeAt(m);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||r&&_===47)g!==-1&&(o+=encodeURIComponent(s.substring(g,m)),g=-1),o!==void 0&&(o+=s.charAt(m));else{o===void 0&&(o=s.substr(0,m));const b=E[_];b!==void 0?(g!==-1&&(o+=encodeURIComponent(s.substring(g,m)),g=-1),o+=b):g===-1&&(g=m)}}return g!==-1&&(o+=encodeURIComponent(s.substring(g))),o!==void 0?o:s}function S(s){let r;for(let o=0;o<s.length;o++){const g=s.charCodeAt(o);g===35||g===63?(r===void 0&&(r=s.substr(0,o)),r+=E[g]):r!==void 0&&(r+=s[o])}return r!==void 0?r:s}function u(s,r){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,w.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=u;function f(s,r){const o=r?S:v;let g="",{scheme:m,authority:_,path:b,query:l,fragment:L}=s;if(m&&(g+=m,g+=":"),(_||m==="file")&&(g+=A,g+=A),_){let O=_.indexOf("@");if(O!==-1){const $=_.substr(0,O);_=_.substr(O+1),O=$.indexOf(":"),O===-1?g+=o($,!1):(g+=o($.substr(0,O),!1),g+=":",g+=o($.substr(O+1),!1)),g+="@"}_=_.toLowerCase(),O=_.indexOf(":"),O===-1?g+=o(_,!1):(g+=o(_.substr(0,O),!1),g+=_.substr(O))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const O=b.charCodeAt(1);O>=65&&O<=90&&(b=`/${String.fromCharCode(O+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const O=b.charCodeAt(0);O>=65&&O<=90&&(b=`${String.fromCharCode(O+32)}:${b.substr(2)}`)}g+=o(b,!0)}return l&&(g+="?",g+=o(l,!1)),L&&(g+="#",g+=r?L:v(L,!1)),g}function c(s){try{return decodeURIComponent(s)}catch(r){return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,r=>c(r)):s}});var nt=this&&this.__classPrivateFieldSet||function(G,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!C:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(G,w):C?C.value=w:e.set(G,w),w},Be=this&&this.__classPrivateFieldGet||function(G,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!R:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(G):R?R.value:e.get(G)};define(ge[22],pe([0,1,2,8]),function(G,e,w,R){"use strict";var C,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(t,n,s){let r=t.get(n);return r===void 0&&(r=s,t.set(n,r)),r}e.getOrSet=k;function D(t){const n=[];return t.forEach((s,r)=>{n.push(`${r} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function I(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=I;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}e.StringIterator=i;class A{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,R.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class d{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,R.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var p;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(p||(p={}));class a{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,R.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class h{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(n){this._iter=n}static forUris(n=()=>!1){return new E(new a(n))}static forPaths(){return new E(new d)}static forStrings(){return new E(new i)}static forConfigKeys(){return new E(new A)}clear(){this._root=void 0}set(n,s){const r=this._iter.reset(n);let o;for(this._root||(this._root=new h,this._root.segment=r.value()),o=this._root;;){const m=r.cmp(o.segment);if(m>0)o.left||(o.left=new h,o.left.segment=r.value()),o=o.left;else if(m<0)o.right||(o.right=new h,o.right.segment=r.value()),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new h,o.mid.segment=r.value()),o=o.mid;else break}const g=o.value;return o.value=s,o.key=n,g}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const r=this._iter.reset(n),o=[];let g=this._root;for(;g;){const m=r.cmp(g.segment);if(m>0)o.push([1,g]),g=g.left;else if(m<0)o.push([-1,g]),g=g.right;else if(r.hasNext())r.next(),o.push([0,g]),g=g.mid;else{for(s?(g.left=void 0,g.mid=void 0,g.right=void 0):g.value=void 0;o.length>0&&g.isEmpty();){let[_,b]=o.pop();switch(_){case 1:b.left=void 0;break;case 0:b.mid=void 0;break;case-1:b.right=void 0;break}g=b}break}}}findSubstr(n){const s=this._iter.reset(n);let r=this._root,o;for(;r;){const g=s.cmp(r.segment);if(g>0)r=r.left;else if(g<0)r=r.right;else if(s.hasNext())s.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[s,r]of this)n(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=E;class v{constructor(n,s){this[C]="ResourceMap",n instanceof v?(this.map=new Map(n.map),this.toKey=s??v.defaultToKey):(this.map=new Map,this.toKey=n??v.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[r,o]of this.map)n(o,w.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield w.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[w.URI.parse(n[0]),n[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[w.URI.parse(n[0]),n[1]]}}e.ResourceMap=v,v.defaultToKey=t=>t.toString();var S;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class u{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const r=this._map.get(n);if(!!r)return s!==0&&this.touch(r,s),r.value}set(n,s,r=0){let o=this._map.get(n);if(o)o.value=s,r!==0&&this.touch(o,r);else{switch(o={key:n,value:s,next:void 0,previous:void 0},r){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const r=this._state;let o=this._head;for(;o;){if(s?n.bind(s)(o.value,o.key,this):n(o.value,o.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const g={value:r.key,done:!1};return r=r.next,g}else return{value:void 0,done:!0}}};return o}values(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const g={value:r.value,done:!1};return r=r.next,g}else return{value:void 0,done:!0}}};return o}entries(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const g={value:[r.key,r.value],done:!1};return r=r.next,g}else return{value:void 0,done:!0}}};return o}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,r=this.size;for(;s&&r>n;)this._map.delete(s.key),s=s.next,r--;this._head=s,this._size=r,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,r=n.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const r=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(r.previous=o,o.next=r),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const r=n.next,o=n.previous;n===this._head?(r.previous=void 0,this._head=r):(r.previous=o,o.next=r),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,r)=>{n.push([r,s])}),n}fromJSON(n){this.clear();for(const[s,r]of n)this.set(s,r)}}e.LinkedMap=u;class f extends u{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class c{constructor(n){y.set(this,void 0),nt(this,y,n,"f")}get size(){return Be(this,y,"f").size}forEach(n,s){Be(this,y,"f").forEach(n,s)}get(n){return Be(this,y,"f").get(n)}has(n){return Be(this,y,"f").has(n)}entries(){return Be(this,y,"f").entries()}keys(){return Be(this,y,"f").keys()}values(){return Be(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Be(this,y,"f").entries()}}e.ReadonlyMapView=c}),define(ge[95],pe([0,1,22,8]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...Y){return function(ce,ve){for(let Le=0,we=Y.length;Le<we;Le++){const je=Y[Le](ce,ve);if(je)return je}return null}}e.or=C,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(Y,ce,ve){if(!ve||ve.length<ce.length)return null;let Le;return Y?Le=R.startsWithIgnoreCase(ve,ce):Le=ve.indexOf(ce)===0,Le?ce.length>0?[{start:0,end:ce.length}]:[]:null}function y(Y,ce){const ve=ce.toLowerCase().indexOf(Y.toLowerCase());return ve===-1?null:[{start:ve,end:ve+Y.length}]}e.matchesContiguousSubString=y;function k(Y,ce){return D(Y.toLowerCase(),ce.toLowerCase(),0,0)}e.matchesSubString=k;function D(Y,ce,ve,Le){if(ve===Y.length)return[];if(Le===ce.length)return null;if(Y[ve]===ce[Le]){let we=null;return(we=D(Y,ce,ve+1,Le+1))?v({start:Le,end:Le+1},we):null}return D(Y,ce,ve,Le+1)}function I(Y){return 97<=Y&&Y<=122}function i(Y){return 65<=Y&&Y<=90}e.isUpper=i;function A(Y){return 48<=Y&&Y<=57}function d(Y){return Y===32||Y===9||Y===10||Y===13}const p=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>p.add(Y.charCodeAt(0)));function a(Y){return d(Y)||p.has(Y)}function h(Y,ce){return Y===ce||a(Y)&&a(ce)}function E(Y){return I(Y)||i(Y)||A(Y)}function v(Y,ce){return ce.length===0?ce=[Y]:Y.end===ce[0].start?ce[0].start=Y.start:ce.unshift(Y),ce}function S(Y,ce){for(let ve=ce;ve<Y.length;ve++){const Le=Y.charCodeAt(ve);if(i(Le)||A(Le)||ve>0&&!E(Y.charCodeAt(ve-1)))return ve}return Y.length}function u(Y,ce,ve,Le){if(ve===Y.length)return[];if(Le===ce.length)return null;if(Y[ve]!==ce[Le].toLowerCase())return null;{let we=null,je=Le+1;for(we=u(Y,ce,ve+1,Le+1);!we&&(je=S(ce,je))<ce.length;)we=u(Y,ce,ve+1,je),je++;return we===null?null:v({start:Le,end:Le+1},we)}}function f(Y){let ce=0,ve=0,Le=0,we=0,je=0;for(let $e=0;$e<Y.length;$e++)je=Y.charCodeAt($e),i(je)&&ce++,I(je)&&ve++,E(je)&&Le++,A(je)&&we++;const K=ce/Y.length,ne=ve/Y.length,Ee=Le/Y.length,Oe=we/Y.length;return{upperPercent:K,lowerPercent:ne,alphaPercent:Ee,numericPercent:Oe}}function c(Y){const{upperPercent:ce,lowerPercent:ve}=Y;return ve===0&&ce>.6}function t(Y){const{upperPercent:ce,lowerPercent:ve,alphaPercent:Le,numericPercent:we}=Y;return ve>.2&&ce<.8&&Le>.6&&we<.2}function n(Y){let ce=0,ve=0,Le=0,we=0;for(let je=0;je<Y.length;je++)Le=Y.charCodeAt(je),i(Le)&&ce++,I(Le)&&ve++,d(Le)&&we++;return(ce===0||ve===0)&&we===0?Y.length<=30:ce<=5}function s(Y,ce){if(!ce||(ce=ce.trim(),ce.length===0)||!n(Y)||ce.length>60)return null;const ve=f(ce);if(!t(ve)){if(!c(ve))return null;ce=ce.toLowerCase()}let Le=null,we=0;for(Y=Y.toLowerCase();we<ce.length&&(Le=u(Y,ce,0,we))===null;)we=S(ce,we+1);return Le}e.matchesCamelCase=s;function r(Y,ce,ve=!1){if(!ce||ce.length===0)return null;let Le=null,we=0;for(Y=Y.toLowerCase(),ce=ce.toLowerCase();we<ce.length&&(Le=o(Y,ce,0,we,ve))===null;)we=g(ce,we+1);return Le}e.matchesWords=r;function o(Y,ce,ve,Le,we){if(ve===Y.length)return[];if(Le===ce.length)return null;if(h(Y.charCodeAt(ve),ce.charCodeAt(Le))){let je=null,K=Le+1;if(je=o(Y,ce,ve+1,Le+1,we),!we)for(;!je&&(K=g(ce,K))<ce.length;)je=o(Y,ce,ve+1,K,we),K++;return je===null?null:v({start:Le,end:Le+1},je)}else return null}function g(Y,ce){for(let ve=ce;ve<Y.length;ve++)if(a(Y.charCodeAt(ve))||ve>0&&a(Y.charCodeAt(ve-1)))return ve;return Y.length}const m=C(e.matchesPrefix,s,y),_=C(e.matchesPrefix,s,k),b=new w.LRUCache(1e4);function l(Y,ce,ve=!1){if(typeof Y!="string"||typeof ce!="string")return null;let Le=b.get(Y);Le||(Le=new RegExp(R.convertSimple2RegExpPattern(Y),"i"),b.set(Y,Le));const we=Le.exec(ce);return we?[{start:we.index,end:we.index+we[0].length}]:ve?_(Y,ce):m(Y,ce)}e.matchesFuzzy=l;function L(Y,ce){const ve=Ke(Y,Y.toLowerCase(),0,ce,ce.toLowerCase(),0,!0);return ve?$(ve):null}e.matchesFuzzy2=L;function O(Y,ce,ve,Le,we,je){const K=Math.min(13,Y.length);for(;ve<K;ve++){const ne=Ke(Y,ce,ve,Le,we,je,!1);if(ne)return ne}return[0,je]}e.anyScore=O;function $(Y){if(typeof Y=="undefined")return[];const ce=[],ve=Y[1];for(let Le=Y.length-1;Le>1;Le--){const we=Y[Le]+ve,je=ce[ce.length-1];je&&je.end===we?je.end=we+1:ce.push({start:we,end:we+1})}return ce}e.createMatches=$;const ie=128;function se(){const Y=[],ce=[];for(let ve=0;ve<=ie;ve++)ce[ve]=0;for(let ve=0;ve<=ie;ve++)Y.push(ce.slice(0));return Y}function U(Y){const ce=[];for(let ve=0;ve<=Y;ve++)ce[ve]=0;return ce}const V=U(2*ie),W=U(2*ie),P=se(),N=se(),F=se(),M=!1;function B(Y,ce,ve,Le,we){function je(ne,Ee,Oe=" "){for(;ne.length<Ee;)ne=Oe+ne;return ne}let K=` |   |${Le.split("").map(ne=>je(ne,3)).join("|")}
`;for(let ne=0;ne<=ve;ne++)ne===0?K+=" |":K+=`${ce[ne-1]}|`,K+=Y[ne].slice(0,we+1).map(Ee=>je(Ee.toString(),3)).join("|")+`
`;return K}function H(Y,ce,ve,Le){Y=Y.substr(ce),ve=ve.substr(Le),console.log(B(N,Y,Y.length,ve,ve.length)),console.log(B(F,Y,Y.length,ve,ve.length)),console.log(B(P,Y,Y.length,ve,ve.length))}function Q(Y,ce){if(ce<0||ce>=Y.length)return!1;const ve=Y.codePointAt(ce);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(ve)}}function le(Y,ce){if(ce<0||ce>=Y.length)return!1;switch(Y.charCodeAt(ce)){case 32:case 9:return!0;default:return!1}}function be(Y,ce,ve){return ce[Y]!==ve[Y]}function Te(Y,ce,ve,Le,we,je,K=!1){for(;ce<ve&&we<je;)Y[ce]===Le[we]&&(K&&(V[ce]=we),ce+=1),we+=1;return ce===ve}e.isPatternInWord=Te;var ke;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var Ne;(function(Y){Y.Default=[-100,0];function ce(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}Y.isDefault=ce})(Ne=e.FuzzyScore||(e.FuzzyScore={}));function Ke(Y,ce,ve,Le,we,je,K){const ne=Y.length>ie?ie:Y.length,Ee=Le.length>ie?ie:Le.length;if(ve>=ne||je>=Ee||ne-ve>Ee-je||!Te(ce,ve,ne,we,je,Ee,!0))return;ze(ne,Ee,ve,je,ce,we);let Oe=1,$e=1,We=ve,Xe=je;const De=[!1];for(Oe=1,We=ve;We<ne;Oe++,We++){const z=V[We],Z=W[We],ue=We+1<ne?W[We+1]:Ee;for($e=z-je+1,Xe=z;Xe<ue;$e++,Xe++){let Ie=Number.MIN_SAFE_INTEGER,Pe=!1;Xe<=Z&&(Ie=qe(Y,ce,We,ve,Le,we,Xe,Ee,je,P[Oe-1][$e-1]===0,De));let Ue=0;Ie!==Number.MAX_SAFE_INTEGER&&(Pe=!0,Ue=Ie+N[Oe-1][$e-1]);const xe=Xe>z,Qe=xe?N[Oe][$e-1]+(P[Oe][$e-1]>0?-5:0):0,rt=Xe>z+1&&P[Oe][$e-1]>0,tt=rt?N[Oe][$e-2]+(P[Oe][$e-2]>0?-5:0):0;if(rt&&(!xe||tt>=Qe)&&(!Pe||tt>=Ue))N[Oe][$e]=tt,F[Oe][$e]=3,P[Oe][$e]=0;else if(xe&&(!Pe||Qe>=Ue))N[Oe][$e]=Qe,F[Oe][$e]=2,P[Oe][$e]=0;else if(Pe)N[Oe][$e]=Ue,F[Oe][$e]=1,P[Oe][$e]=P[Oe-1][$e-1]+1;else throw new Error("not possible")}}if(M&&H(Y,ve,Le,je),!De[0]&&!K)return;Oe--,$e--;const ye=[N[Oe][$e],je];let Ce=0,ae=0;for(;Oe>=1;){let z=$e;do{const Z=F[Oe][z];if(Z===3)z=z-2;else if(Z===2)z=z-1;else break}while(z>=1);Ce>1&&ce[ve+Oe-1]===we[je+$e-1]&&!be(z+je-1,Le,we)&&Ce+1>P[Oe][z]&&(z=$e),z===$e?Ce++:Ce=1,ae||(ae=z),Oe--,$e=z-1,ye.push($e)}Ee===ne&&(ye[0]+=2);const he=ae-ne;return ye[0]-=he,ye}e.fuzzyScore=Ke;function ze(Y,ce,ve,Le,we,je){let K=Y-1,ne=ce-1;for(;K>=ve&&ne>=Le;)we[K]===je[ne]&&(W[K]=ne,K--),ne--}function qe(Y,ce,ve,Le,we,je,K,ne,Ee,Oe,$e){if(ce[ve]!==je[K])return Number.MIN_SAFE_INTEGER;let We=1,Xe=!1;return K===ve-Le?We=Y[ve]===we[K]?7:5:be(K,we,je)&&(K===0||!be(K-1,we,je))?(We=Y[ve]===we[K]?7:5,Xe=!0):Q(je,K)&&(K===0||!Q(je,K-1))?We=5:(Q(je,K-1)||le(je,K-1))&&(We=5,Xe=!0),We>1&&ve===Le&&($e[0]=!0),Xe||(Xe=be(K,we,je)||Q(je,K-1)||le(je,K-1)),ve===Le?K>Ee&&(We-=Xe?3:5):Oe?We+=Xe?2:0:We+=Xe?0:1,K+1===ne&&(We-=Xe?3:5),We}function q(Y,ce,ve,Le,we,je,K){return re(Y,ce,ve,Le,we,je,!0,K)}e.fuzzyScoreGracefulAggressive=q;function J(Y,ce,ve,Le,we,je,K){return re(Y,ce,ve,Le,we,je,!1,K)}e.fuzzyScoreGraceful=J;function re(Y,ce,ve,Le,we,je,K,ne){let Ee=Ke(Y,ce,ve,Le,we,je,ne);if(Ee&&!K)return Ee;if(Y.length>=3){const Oe=Math.min(7,Y.length-1);for(let $e=ve+1;$e<Oe;$e++){const We=oe(Y,$e);if(We){const Xe=Ke(We,We.toLowerCase(),ve,Le,we,je,ne);Xe&&(Xe[0]-=3,(!Ee||Xe[0]>Ee[0])&&(Ee=Xe))}}}return Ee}function oe(Y,ce){if(ce+1>=Y.length)return;const ve=Y[ce],Le=Y[ce+1];if(ve!==Le)return Y.slice(0,ce)+Le+ve+Y.slice(ce+2)}}),define(ge[137],pe([0,1,45,95,8]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${T.source}`,"g");function k(h){return h.replace(y,(E,v)=>v?E:`\\${E}`)}e.escapeIcons=k;const D=new RegExp(`\\\\${T.source}`,"g");function I(h){return h.replace(D,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=I;const i=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function A(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(i,(E,v,S,u)=>S?E:v||u||"")}e.stripIcons=A;function d(h){const E=h.indexOf(e.iconStartMarker);return E===-1?{text:h}:p(h,E)}e.parseLabelWithIcons=d;function p(h,E){const v=[];let S="";function u(g){if(g){S+=g;for(const m of g)v.push(t)}}let f=-1,c="",t=0,n,s,r=E;const o=h.length;for(u(h.substr(0,E));r<o;)n=h[r],s=h[r+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(f=r,u(c),c=e.iconStartMarker,r++):n===")"&&f!==-1?(t+=r-f+1,f=-1,c=""):f!==-1?/^[a-z0-9\-]$/i.test(n)?c+=n:(u(c),f=-1,c=""):u(n),r++;return u(c),{text:S,iconOffsets:v}}function a(h,E,v=!1){const{text:S,iconOffsets:u}=E;if(!u||u.length===0)return(0,R.matchesFuzzy)(h,S,v);const f=(0,C.ltrim)(S," "),c=S.length-f.length,t=(0,R.matchesFuzzy)(h,f,v);if(t)for(const n of t){const s=u[n.start+c]+c;n.start+=s,n.end+=s}return t}e.matchesFuzzyIconAware=a}),define(ge[96],pe([0,1,16,137,17]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(h="",E=!1){var v,S;if(this.value=h,typeof this.value!="string")throw(0,C.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1):(this.isTrusted=(v=E.isTrusted)!==null&&v!==void 0?v:void 0,this.supportThemeIcons=(S=E.supportThemeIcons)!==null&&S!==void 0?S:!1)}appendText(h,E=0){return this.value+=A(this.supportThemeIcons?(0,R.escapeIcons)(h):h).replace(/([ \t]+)/g,(v,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,E){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}}e.MarkdownString=y;function k(a){return D(a)?!a.value:Array.isArray(a)?a.every(k):!0}e.isEmptyMarkdownString=k;function D(a){return a instanceof y?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function I(a,h){return!a&&!h?!0:!a||!h?!1:Array.isArray(a)&&Array.isArray(h)?(0,w.equals)(a,h,i):D(a)&&D(h)?i(a,h):!1}e.markedStringsEquals=I;function i(a,h){return a===h?!0:!a||!h?!1:a.value===h.value&&a.isTrusted===h.isTrusted&&a.supportThemeIcons===h.supportThemeIcons}function A(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function d(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function p(a){const h=[],E=a.split("|").map(S=>S.trim());a=E[0];const v=E[1];if(v){const S=/height=(\d+)/.exec(v),u=/width=(\d+)/.exec(v),f=S?S[1]:"",c=u?u[1]:"",t=isFinite(parseInt(c)),n=isFinite(parseInt(f));t&&h.push(`width="${c}"`),n&&h.push(`height="${f}"`)}return{href:a,dimensions:h}}e.parseHrefAndDimensions=p}),define(ge[58],pe([0,1,23,8,2]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(I){return JSON.stringify(I,k)}e.stringify=T;function y(I){let i=JSON.parse(I);return i=D(i),i}e.parse=y;function k(I,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,R.regExpFlags)(i)}:i}function D(I,i=0){if(!I||i>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return C.URI.revive(I);case 2:return new RegExp(I.source,I.flags)}if(I instanceof w.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let A=0;A<I.length;++A)I[A]=D(I[A],i+1);else for(const A in I)Object.hasOwnProperty.call(I,A)&&(I[A]=D(I[A],i+1))}return I}e.revive=D}),define(ge[10],pe([0,1,2,11]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,I,i){this._hosts[D]=I,this._ports[D]=i}setConnectionToken(D,I){this._connectionTokens[D]=I}rewrite(D){if(this._delegate)return this._delegate(D);const I=D.authority;let i=this._hosts[I];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const A=this._ports[I],d=this._connectionTokens[I];let p=`path=${encodeURIComponent(D.path)}`;return typeof d=="string"&&(p+=`&tkn=${encodeURIComponent(d)}`),w.URI.from({scheme:R.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${i}:${A}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new T;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,I,i){const A=this.toUri(D,I);return A.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(A):R.isNative&&(i||R.isPreferringBrowserCodeLoad)&&A.scheme===C.file?A.with({scheme:C.vscodeFileResource,authority:A.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):A}asFileUri(D,I){const i=this.toUri(D,I);return i.scheme===C.vscodeFileResource?i.with({scheme:C.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(D,I){return w.URI.isUri(D)?D:w.URI.parse(I.toUrl(D))}}e.FileAccess=new y}),define(ge[76],pe([0,1,22]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new w.LRUCache(1e4);function C(I){return D(I,"NFC",R)}e.normalizeNFC=C;const T=new w.LRUCache(1e4);function y(I){return D(I,"NFD",T)}e.normalizeNFD=y;const k=/[^\u0000-\u0080]/;function D(I,i,A){if(!e.canNormalize||!I)return I;const d=A.get(I);if(d)return d;let p;return k.test(I)?p=I.normalize(i):p=I,A.set(I,p),p}e.removeAccents=function(){if(e.canNormalize){const I=/[\u0300-\u036f]/g;return function(i){return y(i).replace(I,"")}}else return function(I){return I}}()}),define(ge[24],pe([0,1,29,9,2,8,10,11]),function(G,e,w,R,C,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(p){return(0,C.uriToFsPath)(p,!0)}e.originalFSPath=D;class I{constructor(a){this._ignorePathCasing=a}compare(a,h,E=!1){return a===h?0:(0,T.compare)(this.getComparisonKey(a,E),this.getComparisonKey(h,E))}isEqual(a,h,E=!1){return a===h?!0:!a||!h?!1:this.getComparisonKey(a,E)===this.getComparisonKey(h,E)}getComparisonKey(a,h=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,h,E=!1){if(a.scheme===h.scheme){if(a.scheme===y.Schemas.file)return w.isEqualOrParent(D(a),D(h),this._ignorePathCasing(a))&&a.query===h.query&&(E||a.fragment===h.fragment);if((0,e.isEqualAuthority)(a.authority,h.authority))return w.isEqualOrParent(a.path,h.path,this._ignorePathCasing(a),"/")&&a.query===h.query&&(E||a.fragment===h.fragment)}return!1}joinPath(a,...h){return C.URI.joinPath(a,...h)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return R.posix.basename(a.path)}extname(a){return R.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let h;return a.scheme===y.Schemas.file?h=C.URI.file(R.dirname(D(a))).path:(h=R.posix.dirname(a.path),a.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),h="/")),a.with({path:h})}normalizePath(a){if(!a.path.length)return a;let h;return a.scheme===y.Schemas.file?h=C.URI.file(R.normalize(D(a))).path:h=R.posix.normalize(a.path),a.with({path:h})}relativePath(a,h){if(a.scheme!==h.scheme||!(0,e.isEqualAuthority)(a.authority,h.authority))return;if(a.scheme===y.Schemas.file){const S=R.relative(D(a),D(h));return k.isWindows?w.toSlashes(S):S}let E=a.path||"/",v=h.path||"/";if(this._ignorePathCasing(a)){let S=0;for(const u=Math.min(E.length,v.length);S<u&&!(E.charCodeAt(S)!==v.charCodeAt(S)&&E.charAt(S).toLowerCase()!==v.charAt(S).toLowerCase());S++);E=v.substr(0,S)+E.substr(S)}return R.posix.relative(E,v)}resolvePath(a,h){if(a.scheme===y.Schemas.file){const E=C.URI.file(R.resolve(D(a),h));return a.with({authority:E.authority,path:E.path})}return h=w.toPosixPath(h),a.with({path:R.posix.resolve(a.path,h)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,h){return a===h||(0,T.equalsIgnoreCase)(a,h)}hasTrailingPathSeparator(a,h=R.sep){if(a.scheme===y.Schemas.file){const E=D(a);return E.length>w.getRoot(E).length&&E[E.length-1]===h}else{const E=a.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,h=R.sep){return(0,e.hasTrailingPathSeparator)(a,h)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,h=R.sep){let E=!1;if(a.scheme===y.Schemas.file){const v=D(a);E=v!==void 0&&v.length===w.getRoot(v).length&&v[v.length-1]===h}else{h="/";const v=a.path;E=v.length===1&&v.charCodeAt(v.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(a,h)?a.with({path:a.path+"/"}):a}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(p=>p.scheme===y.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new I(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,a){const h=[];for(let E=0;E<p.length;E++){const v=a(p[E]);p.some((S,u)=>u===E?!1:(0,e.isEqualOrParent)(v,a(S)))||h.push(p[E])}return h}e.distinctParents=i;var A;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function a(h){const E=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(u=>{const[f,c]=u.split(":");f&&c&&E.set(f,c)});const S=h.path.substring(0,h.path.indexOf(";"));return S&&E.set(p.META_DATA_MIME,S),E}p.parseMetaData=a})(A=e.DataUri||(e.DataUri={}));function d(p,a,h){if(a){let E=p.path;return E&&E[0]!==R.posix.sep&&(E=R.posix.sep+E),p.with({scheme:h,authority:a,path:E})}return p.with({scheme:h})}e.toLocalResource=d}),define(ge[13],pe([0,1,21,17,3,6,56,24]),function(G,e,w,R,C,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(N){return!!N&&typeof N.then=="function"}e.isThenable=D;function I(N){const F=new w.CancellationTokenSource,M=N(F.token),B=new Promise((H,Q)=>{F.token.onCancellationRequested(()=>{Q((0,R.canceled)())}),Promise.resolve(M).then(le=>{F.dispose(),H(le)},le=>{F.dispose(),Q(le)})});return new class{cancel(){F.cancel()}then(H,Q){return B.then(H,Q)}catch(H){return this.then(void 0,H)}finally(H){return B.finally(H)}}}e.createCancelablePromise=I;function i(N,F,M){return Promise.race([N,new Promise(B=>F.onCancellationRequested(()=>B(M)))])}e.raceCancellation=i;async function A(N){let F=-1;const M=N.map((H,Q)=>H.then(le=>(F=Q,le))),B=await Promise.race(M);return N.forEach((H,Q)=>{Q!==F&&H.cancel()}),B}e.raceCancellablePromises=A;function d(N,F,M){let B;const H=setTimeout(()=>{B==null||B(void 0),M==null||M()},F);return Promise.race([N.finally(()=>clearTimeout(H)),new Promise(Q=>B=Q)])}e.raceTimeout=d;function p(N){return new Promise((F,M)=>{const B=N();D(B)?B.then(F,M):F(B)})}e.asPromise=p;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(M,M).then(B)})}return new Promise((M,B)=>{this.queuedPromise.then(M,B)})}return this.activePromise=F(),new Promise((M,B)=>{this.activePromise.then(H=>{this.activePromise=null,M(H)},H=>{this.activePromise=null,B(H)})})}}e.Throttler=a;class h{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=h;class E{constructor(){this.promiseMap=new Map}queue(F,M){var B;const Q=((B=this.promiseMap.get(F))!==null&&B!==void 0?B:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(F)===Q&&this.promiseMap.delete(F)});return this.promiseMap.set(F,Q),Q}}e.SequencerByKey=E;class v{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,M=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,H)=>{this.doResolve=B,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=v;class S{constructor(F){this.delayer=new v(F),this.throttler=new a}trigger(F,M){return this.delayer.trigger(()=>this.throttler.queue(F),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,M)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class f extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function c(N,F){return F?new Promise((M,B)=>{const H=setTimeout(M,N);F.onCancellationRequested(()=>{clearTimeout(H),B((0,R.canceled)())})}):I(M=>c(N,M))}e.timeout=c;function t(N,F=0){const M=setTimeout(N,F);return(0,T.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=t;function n(N){return N.then(void 0,F=>{})}e.ignoreErrors=n;function s(N){const F=[];let M=0;const B=N.length;function H(){return M<B?N[M++]():null}function Q(le){le!=null&&F.push(le);const be=H();return be?be.then(Q):Promise.resolve(F)}return Promise.resolve(null).then(Q)}e.sequence=s;function r(N,F=B=>!!B,M=null){let B=0;const H=N.length,Q=()=>{if(B>=H)return Promise.resolve(M);const le=N[B++];return Promise.resolve(le()).then(Te=>F(Te)?Promise.resolve(Te):Q())};return Q()}e.first=r;function o(N,F=B=>!!B,M=null){if(N.length===0)return Promise.resolve(M);let B=N.length;const H=()=>{var Q,le;B=-1;for(const be of N)(le=(Q=be).cancel)===null||le===void 0||le.call(Q)};return new Promise((Q,le)=>{for(const be of N)be.then(Te=>{--B>=0&&F(Te)?(H(),Q(Te)):B===0&&Q(M)}).catch(Te=>{--B>=0&&(H(),le(Te))})})}e.firstParallel=o;class g{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((M,B)=>{this.outstandingPromises.push({factory:F,c:M,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const M=F.factory();M.then(F.c,F.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=g;class m extends g{constructor(){super(1)}}e.Queue=m;class _{constructor(){this.queues=new Map}queueFor(F,M=k.extUri){const B=M.getComparisonKey(F);let H=this.queues.get(B);return H||(H=new m,C.Event.once(H.onFinished)(()=>{H==null||H.dispose(),this.queues.delete(B)}),this.queues.set(B,H)),H}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=_;class b{constructor(F,M){this._token=-1,typeof F=="function"&&typeof M=="number"&&this.setIfNotSet(F,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},M)}setIfNotSet(F,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},M))}}e.TimeoutTimer=b;class l{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setInterval(()=>{F()},M)}}e.IntervalTimer=l;class L{constructor(F,M){this.timeoutToken=-1,this.runner=F,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class O extends L{constructor(F,M){super(F,M);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const M=setTimeout(()=>F(N));let B=!1;return{dispose(){B||(B=!0,clearTimeout(M))}}}}else e.runWhenIdle=(N,F)=>{const M=requestIdleCallback(N,typeof F=="number"?{timeout:F}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(M))}}}}();class ${constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=$;async function ie(N,F,M){let B;for(let H=0;H<M;H++)try{return await N()}catch(Q){B=Q,await c(F)}throw B}e.retry=ie;class se{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,M,B){return this._pending={taskId:F,cancel:()=>B==null?void 0:B(),promise:M},M.then(()=>this.donePending(F),()=>this.donePending(F)),M}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let M,B;const H=new Promise((Q,le)=>{M=Q,B=le});this._next={run:F,promise:H,promiseResolve:M,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=se;class U{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=U;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,M)=>{this.completeCallback=F,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(M=>{this.completeCallback(F),this.resolved=!0,M()})}error(F){return new Promise(M=>{this.errorCallback(F),this.rejected=!0,M()})}cancel(){new Promise(F=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=V;class W extends C.Emitter{async fireAsync(F,M,B){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const H of this._listeners)this._asyncDeliveryQueue.push([H,F]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[H,Q]=this._asyncDeliveryQueue.shift(),le=[],be=Object.assign(Object.assign({},Q),{waitUntil:Te=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");B&&(Te=B(Te,typeof H=="function"?H:H[0])),le.push(Te)}});try{typeof H=="function"?H.call(void 0,be):H[0].call(H[1],be)}catch(Te){(0,R.onUnexpectedError)(Te);continue}Object.freeze(le),await P.settled(le).catch(Te=>(0,R.onUnexpectedError)(Te))}}}}e.AsyncEmitter=W;var P;(function(N){async function F(Q){return typeof Promise.allSettled=="function"?M(Q):B(Q)}N.allSettled=F;async function M(Q){return Promise.allSettled(Q)}async function B(Q){return Promise.all(Q.map(le=>le.then(be=>({status:"fulfilled",value:be}),be=>({status:"rejected",reason:be}))))}async function H(Q){let le;const be=await Promise.all(Q.map(Te=>Te.then(ke=>ke,ke=>{le||(le=ke)})));if(typeof le!="undefined")throw le;return be}N.settled=H})(P=e.Promises||(e.Promises={}))}),define(ge[97],pe([0,1,9,13]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new R.IdleValue(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),T=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(b,l,L=!1){const O=b||"",$=l||"",ie=C.value.collator.compare(O,$);return C.value.collatorIsNumeric&&ie===0&&O!==$?O<$?-1:1:ie}e.compareFileNames=k;function D(b,l){const L=T.value.collator;return b=b||"",l=l||"",c(L,b,l)}e.compareFileNamesDefault=D;function I(b,l){const L=T.value.collator;return b=b||"",l=l||"",r(b,l)||c(L,b,l)}e.compareFileNamesUpper=I;function i(b,l){const L=T.value.collator;return b=b||"",l=l||"",s(b,l)||c(L,b,l)}e.compareFileNamesLower=i;function A(b,l){return b=b||"",l=l||"",b===l?0:b<l?-1:1}e.compareFileNamesUnicode=A;function d(b,l,L=!1){L||(b=b&&b.toLowerCase(),l=l&&l.toLowerCase());const[O,$]=u(b),[ie,se]=u(l);return O!==ie?O<ie?-1:1:$===se?0:$<se?-1:1}e.noIntlCompareFileNames=d;function p(b,l){const[L,O]=u(b),[$,ie]=u(l);let se=C.value.collator.compare(O,ie);if(se===0){if(C.value.collatorIsNumeric&&O!==ie)return O<ie?-1:1;if(se=C.value.collator.compare(L,$),C.value.collatorIsNumeric&&se===0&&L!==$)return L<$?-1:1}return se}e.compareFileExtensions=p;function a(b,l){b=b||"",l=l||"";const L=f(b),O=f(l),$=T.value.collator,ie=y.value.collator;return c(ie,L,O)||c($,b,l)}e.compareFileExtensionsDefault=a;function h(b,l){b=b||"",l=l||"";const L=f(b),O=f(l),$=T.value.collator,ie=y.value.collator;return c(ie,L,O)||r(b,l)||c($,b,l)}e.compareFileExtensionsUpper=h;function E(b,l){b=b||"",l=l||"";const L=f(b),O=f(l),$=T.value.collator,ie=y.value.collator;return c(ie,L,O)||s(b,l)||c($,b,l)}e.compareFileExtensionsLower=E;function v(b,l){b=b||"",l=l||"";const L=f(b).toLowerCase(),O=f(l).toLowerCase();return L!==O?L<O?-1:1:b!==l?b<l?-1:1:0}e.compareFileExtensionsUnicode=v;const S=/^(.*?)(\.([^.]*))?$/;function u(b,l=!1){const L=b?S.exec(b):[];let O=[L&&L[1]||"",L&&L[3]||""];return l&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function f(b){const l=b?S.exec(b):[];return l&&l[1]&&l[1].charAt(0)!=="."&&l[3]||""}function c(b,l,L){let O=b.compare(l,L);return O!==0?O:l.length!==L.length?l.length<L.length?-1:1:0}function t(b){const l=b.charAt(0);return l.toLocaleUpperCase()!==l}function n(b){const l=b.charAt(0);return l.toLocaleLowerCase()!==l}function s(b,l){return t(b)&&n(l)?-1:n(b)&&t(l)?1:0}function r(b,l){return n(b)&&t(l)?-1:t(b)&&n(l)?1:0}function o(b,l,L=!1){return L||(b=b&&b.toLowerCase(),l=l&&l.toLowerCase()),b===l?0:b<l?-1:1}function g(b,l,L=!1){const O=b.split(w.sep),$=l.split(w.sep),ie=O.length-1,se=$.length-1;let U,V;for(let W=0;;W++){if(U=ie===W,V=se===W,U&&V)return k(O[W],$[W],L);if(U)return-1;if(V)return 1;const P=o(O[W],$[W],L);if(P!==0)return P}}e.comparePaths=g;function m(b,l,L){const O=b.toLowerCase(),$=l.toLowerCase(),ie=_(b,l,L);if(ie)return ie;const se=O.endsWith(L),U=$.endsWith(L);if(se!==U)return se?-1:1;const V=k(O,$);return V!==0?V:O.localeCompare($)}e.compareAnything=m;function _(b,l,L){const O=b.toLowerCase(),$=l.toLowerCase(),ie=O.startsWith(L),se=$.startsWith(L);if(ie!==se)return ie?-1:1;if(ie&&se){if(O.length<$.length)return-1;if(O.length>$.length)return 1}return 0}e.compareByPrefix=_}),define(ge[98],pe([0,1,97,95,9,11,8]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const k=0,D=[k,[]];function I(U,V,W,P){if(!U||!V)return D;const N=U.length,F=V.length;if(N<F)return D;const M=U.toLowerCase();return!P&&!M.includes(W)?D:i(V,W,F,U,M,N)}e.scoreFuzzy=I;function i(U,V,W,P,N,F){const M=[],B=[];for(let be=0;be<W;be++){const Te=be*F,ke=Te-F,Ne=be>0,Ke=U[be],ze=V[be];for(let qe=0;qe<F;qe++){const q=qe>0,J=Te+qe,re=J-1,oe=ke+qe-1,Y=q?M[re]:0,ce=Ne&&q?M[oe]:0,ve=Ne&&q?B[oe]:0;let Le;!ce&&Ne?Le=0:Le=A(Ke,ze,P,N,qe,ve),Le&&ce+Le>=Y?(B[J]=ve+1,M[J]=ce+Le):(B[J]=k,M[J]=Y)}}const H=[];let Q=W-1,le=F-1;for(;Q>=0&&le>=0;){const be=Q*F+le;B[be]===k||(H.push(le),Q--),le--}return[M[W*F-1],H.reverse()]}function A(U,V,W,P,N,F){let M=0;if(!d(V,P[N]))return M;if(M+=1,F>0&&(M+=F*5),U===W[N]&&(M+=1),N===0)M+=8;else{const B=p(W.charCodeAt(N-1));B?M+=B:(0,R.isUpper)(W.charCodeAt(N))&&(M+=2)}return M}function d(U,V){return U===V?!0:U==="/"||U==="\\"?V==="/"||V==="\\":!1}function p(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function h(U,V,W=0,P=0){const N=V;return N.values&&N.values.length>1?E(U,N.values,W,P):v(U,V,W,P)}e.scoreFuzzy2=h;function E(U,V,W,P){let N=0;const F=[];for(const M of V){const[B,H]=v(U,M,W,P);if(typeof B!="number")return a;N+=B,F.push(...H)}return[N,g(F)]}function v(U,V,W,P){const N=(0,R.fuzzyScore)(V.original,V.originalLowercase,W,U,U.toLowerCase(),P,!0);return N?[N[0],(0,R.createMatches)(N)]:a}const S=Object.freeze({score:0}),u=1<<18,f=1<<17,c=1<<16;function t(U,V,W,P,N){if(!U||!V.normalized)return S;const F=P.getItemLabel(U);if(!F)return S;const M=P.getItemDescription(U);let B;M?B=`${F}${M}${V.normalized}${Array.isArray(V.values)?V.values.length:""}${W}`:B=`${F}${V.normalized}${Array.isArray(V.values)?V.values.length:""}${W}`;const H=N[B];if(H)return H;const Q=n(F,M,P.getItemPath(U),V,W);return N[B]=Q,Q}e.scoreItemFuzzy=t;function n(U,V,W,P,N){const F=!W||!P.containsPathSeparator;return W&&(T.isLinux?P.pathNormalized===W:(0,y.equalsIgnoreCase)(P.pathNormalized,W))?{score:u,labelMatch:[{start:0,end:U.length}],descriptionMatch:V?[{start:0,end:V.length}]:void 0}:P.values&&P.values.length>1?s(U,V,W,P.values,F,N):r(U,V,W,P,F,N)}function s(U,V,W,P,N,F){let M=0;const B=[],H=[];for(const Q of P){const{score:le,labelMatch:be,descriptionMatch:Te}=r(U,V,W,Q,N,F);if(le===k)return S;M+=le,be&&B.push(...be),Te&&H.push(...Te)}return{score:M,labelMatch:g(B),descriptionMatch:g(H)}}function r(U,V,W,P,N,F){if(N||!V){const[M,B]=I(U,P.normalized,P.normalizedLowercase,F);if(M){const H=(0,R.matchesPrefix)(P.normalized,U);let Q;return H?(Q=f,Q+=Math.round(P.normalized.length/U.length*100)):Q=c,{score:Q+M,labelMatch:H||o(B)}}}if(V){let M=V;W&&(M=`${V}${C.sep}`);const B=M.length,H=`${M}${U}`,[Q,le]=I(H,P.normalized,P.normalizedLowercase,F);if(Q){const be=o(le),Te=[],ke=[];return be.forEach(Ne=>{Ne.start<B&&Ne.end>B?(Te.push({start:0,end:Ne.end-B}),ke.push({start:Ne.start,end:B})):Ne.start>=B?Te.push({start:Ne.start-B,end:Ne.end-B}):ke.push(Ne)}),{score:Q,labelMatch:Te,descriptionMatch:ke}}}return S}function o(U){const V=[];if(!U)return V;let W;for(const P of U)W&&W.end===P?W.end+=1:(W={start:P,end:P+1},V.push(W));return V}function g(U){const V=U.sort((N,F)=>N.start-F.start),W=[];let P;for(const N of V)!P||!m(P,N)?(P=N,W.push(N)):(P.start=Math.min(P.start,N.start),P.end=Math.max(P.end,N.end));return W}function m(U,V){return!(U.end<V.start||V.end<U.start)}function _(U,V,W,P,N,F){const M=t(U,W,P,N,F),B=t(V,W,P,N,F),H=M.score,Q=B.score;if((H===u||Q===u)&&H!==Q)return H===u?-1:1;if(H>c||Q>c){if(H!==Q)return H>Q?-1:1;if(H<f&&Q<f){const ze=l(M.labelMatch,B.labelMatch);if(ze!==0)return ze}const Ne=N.getItemLabel(U)||"",Ke=N.getItemLabel(V)||"";if(Ne.length!==Ke.length)return Ne.length-Ke.length}if(H!==Q)return H>Q?-1:1;const le=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,be=Array.isArray(B.labelMatch)&&B.labelMatch.length>0;if(le&&!be)return-1;if(be&&!le)return 1;const Te=b(U,M,N),ke=b(V,B,N);return Te&&ke&&Te!==ke?ke>Te?-1:1:L(U,V,W,N)}e.compareItemsByFuzzyScore=_;function b(U,V,W){let P=-1,N=-1;if(V.descriptionMatch&&V.descriptionMatch.length?P=V.descriptionMatch[0].start:V.labelMatch&&V.labelMatch.length&&(P=V.labelMatch[0].start),V.labelMatch&&V.labelMatch.length){if(N=V.labelMatch[V.labelMatch.length-1].end,V.descriptionMatch&&V.descriptionMatch.length){const F=W.getItemDescription(U);F&&(N+=F.length)}}else V.descriptionMatch&&V.descriptionMatch.length&&(N=V.descriptionMatch[V.descriptionMatch.length-1].end);return N-P}function l(U,V){if(!U&&!V||(!U||!U.length)&&(!V||!V.length))return 0;if(!V||!V.length)return-1;if(!U||!U.length)return 1;const W=U[0].start,N=U[U.length-1].end-W,F=V[0].start,B=V[V.length-1].end-F;return N===B?0:B<N?1:-1}function L(U,V,W,P){const N=P.getItemLabel(U)||"",F=P.getItemLabel(V)||"",M=P.getItemDescription(U),B=P.getItemDescription(V),H=N.length+(M?M.length:0),Q=F.length+(B?B.length:0);if(H!==Q)return H-Q;const le=P.getItemPath(U),be=P.getItemPath(V);return le&&be&&le.length!==be.length?le.length-be.length:N!==F?(0,w.compareAnything)(N,F,W.normalized):M&&B&&M!==B?(0,w.compareAnything)(M,B,W.normalized):le&&be&&le!==be?(0,w.compareAnything)(le,be,W.normalized):0}const O=" ";function $(U){typeof U!="string"&&(U="");const V=U.toLowerCase(),{pathNormalized:W,normalized:P,normalizedLowercase:N}=ie(U),F=W.indexOf(C.sep)>=0;let M;const B=U.split(O);if(B.length>1)for(const H of B){const{pathNormalized:Q,normalized:le,normalizedLowercase:be}=ie(H);le&&(M||(M=[]),M.push({original:H,originalLowercase:H.toLowerCase(),pathNormalized:Q,normalized:le,normalizedLowercase:be}))}return{original:U,originalLowercase:V,pathNormalized:W,normalized:P,normalizedLowercase:N,values:M,containsPathSeparator:F}}e.prepareQuery=$;function ie(U){let V;T.isWindows?V=U.replace(/\//g,C.sep):V=U.replace(/\\/g,C.sep);const W=(0,y.stripWildcards)(V).replace(/\s/g,"");return{pathNormalized:V,normalized:W,normalizedLowercase:W.toLowerCase()}}function se(U){return Array.isArray(U)?$(U.map(V=>V.original).join(O)):$(U.original)}e.pieceToQuery=se}),define(ge[30],pe([0,1,8,29,9,22,13]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const D="**",I="/",i="[/\\\\]",A="[^/\\\\]",d=/\//g;function p(M){switch(M){case 0:return"";case 1:return`${A}*?`;default:return`(?:${i}|${A}+${i}|${i}${A}+)*?`}}function a(M,B){if(!M)return[];const H=[];let Q=!1,le=!1,be="";for(const Te of M){switch(Te){case B:if(!Q&&!le){H.push(be),be="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":le=!0;break;case"]":le=!1;break}be+=Te}return be&&H.push(be),H}e.splitGlobAware=a;function h(M){if(!M)return"";let B="";const H=a(M,I);if(H.every(Q=>Q===D))B=".*";else{let Q=!1;H.forEach((le,be)=>{if(le===D){Q||(B+=p(2),Q=!0);return}let Te=!1,ke="",Ne=!1,Ke="";for(const ze of le){if(ze!=="}"&&Te){ke+=ze;continue}if(Ne&&(ze!=="]"||!Ke)){let qe;ze==="-"?qe=ze:(ze==="^"||ze==="!")&&!Ke?qe="^":ze===I?qe="":qe=w.escapeRegExpCharacters(ze),Ke+=qe;continue}switch(ze){case"{":Te=!0;continue;case"[":Ne=!0;continue;case"}":B+=`(?:${a(ke,",").map(J=>h(J)).join("|")})`,Te=!1,ke="";break;case"]":B+="["+Ke+"]",Ne=!1,Ke="";break;case"?":B+=A;continue;case"*":B+=p(1);continue;default:B+=w.escapeRegExpCharacters(ze)}}be<H.length-1&&(H[be+1]!==D||be+2<H.length)&&(B+=i),Q=!1})}return B}const E=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},s=function(){return null};function r(M,B){if(!M)return s;let H;typeof M!="string"?H=M.pattern:H=M,H=H.trim();const Q=`${H}_${!!B.trimForExclusions}`;let le=t.get(Q);if(le)return o(le,M);let be;if(E.test(H)){const Te=H.substr(4);le=function(ke,Ne){return typeof ke=="string"&&ke.endsWith(Te)?H:null}}else(be=v.exec(g(H,B)))?le=m(be[1],H):(B.trimForExclusions?u:S).test(H)?le=_(H,B):(be=f.exec(g(H,B)))?le=b(be[1].substr(1),H,!0):(be=c.exec(g(H,B)))?le=b(be[1],H,!1):le=l(H);return t.set(Q,le),o(le,M)}function o(M,B){return typeof B=="string"?M:function(H,Q){return R.isEqualOrParent(H,B.base)?M(C.relative(B.base,H),Q):null}}function g(M,B){return B.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function m(M,B){const H=`/${M}`,Q=`\\${M}`,le=function(Te,ke){return typeof Te!="string"?null:ke?ke===M?B:null:Te===M||Te.endsWith(H)||Te.endsWith(Q)?B:null},be=[M];return le.basenames=be,le.patterns=[B],le.allBasenames=be,le}function _(M,B){const H=F(M.slice(1,-1).split(",").map(ke=>r(ke,B)).filter(ke=>ke!==s),M),Q=H.length;if(!Q)return s;if(Q===1)return H[0];const le=function(ke,Ne){for(let Ke=0,ze=H.length;Ke<ze;Ke++)if(H[Ke](ke,Ne))return M;return null},be=H.find(ke=>!!ke.allBasenames);be&&(le.allBasenames=be.allBasenames);const Te=H.reduce((ke,Ne)=>Ne.allPaths?ke.concat(Ne.allPaths):ke,[]);return Te.length&&(le.allPaths=Te),le}function b(M,B,H){const Q=C.sep===C.posix.sep,le=Q?M:M.replace(d,C.sep),be=C.sep+le,Te=C.posix.sep+M,ke=H?function(Ne,Ke){return typeof Ne=="string"&&(Ne===le||Ne.endsWith(be)||!Q&&(Ne===M||Ne.endsWith(Te)))?B:null}:function(Ne,Ke){return typeof Ne=="string"&&(Ne===le||!Q&&Ne===M)?B:null};return ke.allPaths=[(H?"*/":"./")+M],ke}function l(M){try{const B=new RegExp(`^${h(M)}$`);return function(H){return B.lastIndex=0,typeof H=="string"&&B.test(H)?M:null}}catch(B){return s}}function L(M,B,H){return!M||typeof B!="string"?!1:O(M)(B,void 0,H)}e.match=L;function O(M,B={}){if(!M)return n;if(typeof M=="string"||U(M)){const H=r(M,B);if(H===s)return n;const Q=function(le,be){return!!H(le,be)};return H.allBasenames&&(Q.allBasenames=H.allBasenames),H.allPaths&&(Q.allPaths=H.allPaths),Q}return P(M,B)}e.parse=O;function $(M){if(!M)return;let B;return H=>(B||(B=(M()||Promise.resolve([])).then(Q=>Q?se(Q):{})),B.then(Q=>!!Q[H]))}e.hasSiblingPromiseFn=$;function ie(M){if(!M)return;let B;return H=>{if(!B){const Q=M();B=Q?se(Q):{}}return!!B[H]}}e.hasSiblingFn=ie;function se(M){const B={};for(const H of M)B[H]=!0;return B}function U(M){const B=M;return B&&typeof B.base=="string"&&typeof B.pattern=="string"}e.isRelativePattern=U;function V(M){return M.allBasenames||[]}e.getBasenameTerms=V;function W(M){return M.allPaths||[]}e.getPathTerms=W;function P(M,B){const H=F(Object.getOwnPropertyNames(M).map(ke=>N(ke,M[ke],B)).filter(ke=>ke!==s)),Q=H.length;if(!Q)return s;if(!H.some(ke=>!!ke.requiresSiblings)){if(Q===1)return H[0];const ke=function(ze,qe){for(let q=0,J=H.length;q<J;q++){const re=H[q](ze,qe);if(re)return re}return null},Ne=H.find(ze=>!!ze.allBasenames);Ne&&(ke.allBasenames=Ne.allBasenames);const Ke=H.reduce((ze,qe)=>qe.allPaths?ze.concat(qe.allPaths):ze,[]);return Ke.length&&(ke.allPaths=Ke),ke}const le=function(ke,Ne,Ke){let ze;for(let qe=0,q=H.length;qe<q;qe++){const J=H[qe];J.requiresSiblings&&Ke&&(Ne||(Ne=C.basename(ke)),ze||(ze=Ne.substr(0,Ne.length-C.extname(ke).length)));const re=J(ke,Ne,ze,Ke);if(re)return re}return null},be=H.find(ke=>!!ke.allBasenames);be&&(le.allBasenames=be.allBasenames);const Te=H.reduce((ke,Ne)=>Ne.allPaths?ke.concat(Ne.allPaths):ke,[]);return Te.length&&(le.allPaths=Te),le}function N(M,B,H){if(B===!1)return s;const Q=r(M,H);if(Q===s)return s;if(typeof B=="boolean")return Q;if(B){const le=B.when;if(typeof le=="string"){const be=(Te,ke,Ne,Ke)=>{if(!Ke||!Q(Te,ke))return null;const ze=le.replace("$(basename)",Ne),qe=Ke(ze);return(0,y.isThenable)(qe)?qe.then(q=>q?M:null):qe?M:null};return be.requiresSiblings=!0,be}}return Q}function F(M,B){const H=M.filter(ke=>!!ke.basenames);if(H.length<2)return M;const Q=H.reduce((ke,Ne)=>{const Ke=Ne.basenames;return Ke?ke.concat(Ke):ke},[]);let le;if(B){le=[];for(let ke=0,Ne=Q.length;ke<Ne;ke++)le.push(B)}else le=H.reduce((ke,Ne)=>{const Ke=Ne.patterns;return Ke?ke.concat(Ke):ke},[]);const be=function(ke,Ne){if(typeof ke!="string")return null;if(!Ne){let ze;for(ze=ke.length;ze>0;ze--){const qe=ke.charCodeAt(ze-1);if(qe===47||qe===92)break}Ne=ke.substr(ze)}const Ke=Q.indexOf(Ne);return Ke!==-1?le[Ke]:null};be.basenames=Q,be.patterns=le,be.allBasenames=Q;const Te=M.filter(ke=>!ke.basenames);return Te.push(be),Te}}),define(ge[77],pe([0,1,2,9,8,10,11,24,29]),function(G,e,w,R,C,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(r,o,g){if(typeof r=="string"&&(r=w.URI.file(r)),g){const _=g.getWorkspaceFolder(r);if(_){const b=g.getWorkspace().folders.length>1;let l;if((0,k.isEqual)(_.uri,r)?l="":l=(0,k.relativePath)(_.uri,r),b){const L=_.name?_.name:(0,k.basename)(_.uri);l=l?L+" \u2022 "+l:L}return l}}if(r.scheme!==T.Schemas.file&&r.scheme!==T.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(r.fsPath))return(0,R.normalize)(A(r.fsPath));let m=(0,R.normalize)(r.fsPath);return!y.isWindows&&(o==null?void 0:o.userHome)&&(m=p(m,o.userHome.fsPath)),m}e.getPathLabel=I;function i(r){if(!r)return;typeof r=="string"&&(r=w.URI.file(r));const o=(0,k.basename)(r)||(r.scheme===T.Schemas.file?r.fsPath:r.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(o)?A(o):o}e.getBaseLabel=i;function A(r){return(0,D.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=A;let d=Object.create(null);function p(r,o){if(y.isWindows||!r||!o)return r;let g=d.original===o?d.normalized:void 0;return g||(g=`${(0,C.rtrim)(o,R.posix.sep)}${R.posix.sep}`,d={original:o,normalized:g}),(y.isLinux?r.startsWith(g):(0,C.startsWithIgnoreCase)(r,g))&&(r=`~/${r.substr(g.length)}`),r}e.tildify=p;function a(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=a;const h="\u2026",E="\\\\",v="~";function S(r,o=R.sep){const g=new Array(r.length);let m=!1;for(let _=0;_<r.length;_++){let b=r[_];if(b===""){g[_]=`.${o}`;continue}if(!b){g[_]=b;continue}m=!0;let l="";b.indexOf(E)===0?(l=b.substr(0,b.indexOf(E)+E.length),b=b.substr(b.indexOf(E)+E.length)):b.indexOf(o)===0?(l=b.substr(0,b.indexOf(o)+o.length),b=b.substr(b.indexOf(o)+o.length)):b.indexOf(v)===0&&(l=b.substr(0,b.indexOf(v)+v.length),b=b.substr(b.indexOf(v)+v.length));const L=b.split(o);for(let O=1;m&&O<=L.length;O++)for(let $=L.length-O;m&&$>=0;$--){m=!1;let ie=L.slice($,$+O).join(o);for(let se=0;!m&&se<r.length;se++)if(se!==_&&r[se]&&r[se].indexOf(ie)>-1){const U=$+O===L.length,V=$>0&&r[se].indexOf(o)>-1?o+ie:ie,W=r[se].endsWith(V);m=!U||W}if(!m){let se="";(L[0].endsWith(":")||l!=="")&&($===1&&($=0,O++,ie=L[0]+o+ie),$>0&&(se=L[0]+o),se=l+se),$>0&&(se=se+h+o),se=se+ie,$+O<L.length&&(se=se+o+h),g[_]=se}}m&&(g[_]=b)}return g}e.shorten=S;var u;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function f(r,o=Object.create(null)){const g=[];let m=!1,_="";for(const b of r)if(b==="$"||m&&b==="{")_&&g.push({value:_,type:u.TEXT}),_="",m=!0;else if(b==="}"&&m){const l=o[_];if(typeof l=="string")l.length&&g.push({value:l,type:u.VARIABLE});else if(l){const L=g[g.length-1];(!L||L.type!==u.SEPARATOR)&&g.push({value:l.label,type:u.SEPARATOR})}_="",m=!1}else _+=b;return _&&!m&&g.push({value:_,type:u.TEXT}),g.filter((b,l)=>{if(b.type===u.SEPARATOR){const L=g[l-1],O=g[l+1];return[L,O].every($=>$&&($.type===u.VARIABLE||$.type===u.TEXT)&&$.value.length>0)}return!0}).map(b=>b.value).join("")}e.template=f;function c(r,o){return y.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):r.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function t(r,o){return y.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):y.isWindows?r.replace(/&&|&/g,g=>g==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(r){const o=r.indexOf("/")!==-1?R.posix:R.win32,g=o.basename(r),m=o.dirname(r);return g.length?{name:g,parentPath:m}:{name:m,parentPath:""}}e.splitName=s}),define(ge[138],pe([0,1,9,8,30,10,24]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let k=[],D=[],I=[];function i(t,n=!1){const s=A(t);k.push(s),s.userConfigured?I.push(s):D.push(s),n&&!s.userConfigured&&k.forEach(r=>{r.mime===s.mime||r.userConfigured||(s.extension&&r.extension===s.extension&&console.warn(`Overwriting extension <<${s.extension}>> to now point to mime <<${s.mime}>>`),s.filename&&r.filename===s.filename&&console.warn(`Overwriting filename <<${s.filename}>> to now point to mime <<${s.mime}>>`),s.filepattern&&r.filepattern===s.filepattern&&console.warn(`Overwriting filepattern <<${s.filepattern}>> to now point to mime <<${s.mime}>>`),s.firstline&&r.firstline===s.firstline&&console.warn(`Overwriting firstline <<${s.firstline}>> to now point to mime <<${s.mime}>>`))})}e.registerTextMime=i;function A(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?t.filepattern.toLowerCase():void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(w.posix.sep)>=0:!1}}function d(t){t?(k=k.filter(n=>!n.userConfigured),I=[]):(k=[],D=[],I=[])}e.clearTextMimes=d;function p(t,n){let s;if(t)switch(t.scheme){case T.Schemas.file:s=t.fsPath;break;case T.Schemas.data:s=y.DataUri.parseMetaData(t).get(y.DataUri.META_DATA_LABEL);break;default:s=t.path}if(!s)return[e.MIME_UNKNOWN];s=s.toLowerCase();const r=(0,w.basename)(s),o=a(s,r,I);if(o)return[o,e.MIME_TEXT];const g=a(s,r,D);if(g)return[g,e.MIME_TEXT];if(n){const m=h(n);if(m)return[m,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=p;function a(t,n,s){let r=null,o=null,g=null;for(let m=s.length-1;m>=0;m--){const _=s[m];if(n===_.filenameLowercase){r=_;break}if(_.filepattern&&(!o||_.filepattern.length>o.filepattern.length)){const b=_.filepatternOnPath?t:n;(0,C.match)(_.filepatternLowercase,b)&&(o=_)}_.extension&&(!g||_.extension.length>g.extension.length)&&n.endsWith(_.extensionLowercase)&&(g=_)}return r?r.mime:o?o.mime:g?g.mime:null}function h(t){if((0,R.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let n=k.length-1;n>=0;n--){const s=k[n];if(!s.firstline)continue;const r=t.match(s.firstline);if(r&&r.length>0)return s.mime}return null}function E(t){return t?typeof t=="string"?t===e.MIME_BINARY||t===e.MIME_TEXT||t===e.MIME_UNKNOWN:t.length===1&&E(t[0]):!0}e.isUnspecific=E;const v={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function S(t){const n=(0,w.extname)(t);return v[n.toLowerCase()]}e.getMediaMime=S;function u(t){for(const n in v)if(v[n]===t)return n}e.getExtensionForMimeType=u;const f=/^(.+)\/(.+?)(;.+)?$/;function c(t,n){var s;const r=f.exec(t);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${(s=r[3])!==null&&s!==void 0?s:""}`:n?void 0:t}e.normalizeMimeType=c}),define(ge[99],pe([0,1,2]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(i){return i.toJSON()}class C{constructor(A){this._uriTransformer=A}transformIncoming(A){const d=this._uriTransformer.transformIncoming(A);return d===A?A:R(w.URI.from(d))}transformOutgoing(A){const d=this._uriTransformer.transformOutgoing(A);return d===A?A:R(w.URI.from(d))}transformOutgoingURI(A){const d=this._uriTransformer.transformOutgoing(A);return d===A?A:w.URI.from(d)}transformOutgoingScheme(A){return this._uriTransformer.transformOutgoingScheme(A)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,A,d){if(!i||d>200)return null;if(typeof i=="object"){if(i instanceof w.URI)return A.transformOutgoing(i);for(let p in i)if(Object.hasOwnProperty.call(i,p)){const a=T(i[p],A,d+1);a!==null&&(i[p]=a)}}return null}function y(i,A){const d=T(i,A,0);return d===null?i:d}e.transformOutgoingURIs=y;function k(i,A,d,p){if(!i||p>200)return null;if(typeof i=="object"){if(i.$mid===1)return d?w.URI.revive(A.transformIncoming(i)):A.transformIncoming(i);for(let a in i)if(Object.hasOwnProperty.call(i,a)){const h=k(i[a],A,d,p+1);h!==null&&(i[a]=h)}}return null}function D(i,A){const d=k(i,A,!1,0);return d===null?i:d}e.transformIncomingURIs=D;function I(i,A){const d=k(i,A,!0,0);return d===null?i:d}e.transformAndReviveIncomingURIs=I}),define(ge[32],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(D){return w.test(D)}e.isUUID=R;const C=new Uint8Array(16),T=[];for(let D=0;D<256;D++)T.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let I=0;I<D.length;I++)D[I]=Math.floor(Math.random()*256);return D};function k(){y(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let D=0,I="";return I+=T[C[D++]],I+=T[C[D++]],I+=T[C[D++]],I+=T[C[D++]],I+="-",I+=T[C[D++]],I+=T[C[D++]],I+="-",I+=T[C[D++]],I+=T[C[D++]],I+="-",I+=T[C[D++]],I+=T[C[D++]],I+="-",I+=T[C[D++]],I+=T[C[D++]],I+=T[C[D++]],I+=T[C[D++]],I+=T[C[D++]],I+=T[C[D++]],I}e.generateUuid=k}),define(ge[139],pe([0,1,100]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(T="utf8"){this.stringDecoder=new w.StringDecoder(T),this.remaining=null}write(T){const y=[],k=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(k.length<1)return y;let D=0,I,i=D;for(;i<k.length;)if(I=k.charCodeAt(i),I===13||I===10){if(y.push(k.substring(D,i)),i++,i<k.length){const A=I;I=k.charCodeAt(i),(A===13&&I===10||A===10&&I===13)&&i++}D=i}else i++;return this.remaining=D<k.length?k.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=R}),define(ge[28],pe([0,1,59,101,281,9,13,11,29,32,76,24,2]),function(G,e,w,R,C,T,y,k,D,I,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var p;(function(P){P[P.UNLINK=0]="UNLINK",P[P.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function a(P,N=p.UNLINK){if((0,D.isRootOrDriveLetter)(P))throw new Error("rimraf - will refuse to recursively delete root");return N===p.UNLINK?E(P):h(P)}e.rimraf=a;async function h(P){try{const N=(0,T.join)((0,R.tmpdir)(),(0,I.generateUuid)());try{await W.rename(P,N)}catch(F){return E(P)}E(N).catch(F=>{})}catch(N){if(N.code!=="ENOENT")throw N}}async function E(P){return W.rmdir(P,{recursive:!0,maxRetries:3})}function v(P){if((0,D.isRootOrDriveLetter)(P))throw new Error("rimraf - will refuse to recursively delete root");w.rmdirSync(P,{recursive:!0})}e.rimrafSync=v;async function S(P,N){return c(await(N?u(P):W.readdir(P)))}e.readdir=S;async function u(P){try{return await W.readdir(P,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const N=[],F=await S(P);for(const M of F){let B=!1,H=!1,Q=!1;try{const le=await W.lstat((0,T.join)(P,M));B=le.isFile(),H=le.isDirectory(),Q=le.isSymbolicLink()}catch(le){console.warn("[node.js fs] unexpected error from lstat after readdir: ",le)}N.push({name:M,isFile:()=>B,isDirectory:()=>H,isSymbolicLink:()=>Q})}return N}function f(P){return c(w.readdirSync(P))}e.readdirSync=f;function c(P){return P.map(N=>typeof N=="string"?k.isMacintosh?(0,i.normalizeNFC)(N):N:(N.name=k.isMacintosh?(0,i.normalizeNFC)(N.name):N.name,N))}async function t(P){const N=await S(P),F=[];for(const M of N)await s.existsDirectory((0,T.join)(P,M))&&F.push(M);return F}e.readDirsInDir=t;function n(P,N=1e3){return new Promise(F=>{let M=!1;const B=setInterval(()=>{M||(M=!0,w.access(P,H=>{M=!1,H&&(clearInterval(B),F(void 0))}))},N)})}e.whenDeleted=n;var s;(function(P){async function N(B){let H;try{if(H=await W.lstat(B),!H.isSymbolicLink())return{stat:H}}catch(Q){}try{return{stat:await W.stat(B),symbolicLink:(H==null?void 0:H.isSymbolicLink())?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(k.isWindows&&Q.code==="EACCES")try{return{stat:await W.stat(await W.readlink(B)),symbolicLink:{dangling:!1}}}catch(le){if(le.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw le}throw Q}}P.stat=N;async function F(B){try{const{stat:H,symbolicLink:Q}=await P.stat(B);return H.isFile()&&(Q==null?void 0:Q.dangling)!==!0}catch(H){}return!1}P.existsFile=F;async function M(B){try{const{stat:H,symbolicLink:Q}=await P.stat(B);return H.isDirectory()&&(Q==null?void 0:Q.dangling)!==!0}catch(H){}return!1}P.existsDirectory=M})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new y.ResourceQueue;function o(P,N,F){return r.queueFor(d.URI.file(P),A.extUriBiasedIgnorePathCase).queue(()=>{const M=b(F);return new Promise((B,H)=>m(P,N,M,Q=>Q?H(Q):B()))})}e.writeFile=o;let g=!0;function m(P,N,F,M){if(!g)return w.writeFile(P,N,{mode:F.mode,flag:F.flag},M);w.open(P,F.flag,F.mode,(B,H)=>{if(B)return M(B);w.writeFile(H,N,Q=>{if(Q)return w.close(H,()=>M(Q));w.fdatasync(H,le=>(le&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",le),g=!1),w.close(H,be=>M(be))))})})}function _(P,N,F){const M=b(F);if(!g)return w.writeFileSync(P,N,{mode:M.mode,flag:M.flag});const B=w.openSync(P,M.flag,M.mode);try{w.writeFileSync(B,N);try{w.fdatasyncSync(B)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),g=!1}}finally{w.closeSync(B)}}e.writeFileSync=_;function b(P){return P?{mode:typeof P.mode=="number"?P.mode:438,flag:typeof P.flag=="string"?P.flag:"w"}:{mode:438,flag:"w"}}async function l(P,N){if(P===N)return;async function F(M){try{const B=await W.lstat(M);if(B.isDirectory()||B.isSymbolicLink())return;await W.utimes(M,B.atime,new Date)}catch(B){}}try{await W.rename(P,N),await F(N)}catch(M){if(P.toLowerCase()!==N.toLowerCase()&&M.code==="EXDEV"||P.endsWith("."))await L(P,N,{preserveSymlinks:!1}),await a(P,p.MOVE),await F(N);else throw M}}e.move=l;async function L(P,N,F){return $(P,N,{root:{source:P,target:N},options:F,handledSourcePaths:new Set})}e.copy=L;const O=511;async function $(P,N,F){if(F.handledSourcePaths.has(P))return;F.handledSourcePaths.add(P);const{stat:M,symbolicLink:B}=await s.stat(P);if(B){if(F.options.preserveSymlinks)try{return await U(P,N,F)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(B.dangling)return}return M.isDirectory()?ie(P,N,M.mode&O,F):se(P,N,M.mode&O)}async function ie(P,N,F,M){await W.mkdir(N,{recursive:!0,mode:F});const B=await S(P);for(const H of B)await $((0,T.join)(P,H),(0,T.join)(N,H),M)}async function se(P,N,F){await W.copyFile(P,N),await W.chmod(N,F)}async function U(P,N,F){let M=await W.readlink(P);(0,D.isEqualOrParent)(M,F.root.source,!k.isLinux)&&(M=(0,T.join)(F.root.target,M.substr(F.root.source.length+1))),await W.symlink(M,N)}async function V(P){try{return await W.access(P),!0}catch(N){return!1}}e.exists=V;var W;(function(P){P.access=(0,C.promisify)(w.access),P.stat=(0,C.promisify)(w.stat),P.lstat=(0,C.promisify)(w.lstat),P.utimes=(0,C.promisify)(w.utimes),P.read=(0,C.promisify)(w.read),P.readFile=(0,C.promisify)(w.readFile),P.write=(0,C.promisify)(w.write),P.writeFile=(0,C.promisify)(w.writeFile),P.appendFile=(0,C.promisify)(w.appendFile),P.fdatasync=(0,C.promisify)(w.fdatasync),P.truncate=(0,C.promisify)(w.truncate),P.rename=(0,C.promisify)(w.rename),P.copyFile=(0,C.promisify)(w.copyFile),P.open=(0,C.promisify)(w.open),P.close=(0,C.promisify)(w.close),P.symlink=(0,C.promisify)(w.symlink),P.readlink=(0,C.promisify)(w.readlink),P.chmod=(0,C.promisify)(w.chmod),P.readdir=(0,C.promisify)(w.readdir),P.mkdir=(0,C.promisify)(w.mkdir),P.unlink=(0,C.promisify)(w.unlink),P.rmdir=(0,C.promisify)(w.rmdir),P.realpath=(0,C.promisify)(w.realpath)})(W=e.Promises||(e.Promises={}))}),define(ge[102],pe([0,1,59,8,9,28]),function(G,e,w,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function y(i){const A=(0,C.dirname)(i);if(i===A)return i;const d=((0,C.basename)(i)||i).toLowerCase();try{const a=(0,T.readdirSync)(A).filter(h=>h.toLowerCase()===d);if(a.length===1){const h=y(A);if(h)return(0,C.join)(h,a[0])}else if(a.length>1){const h=a.indexOf(d);if(h>=0){const E=y(A);if(E)return(0,C.join)(E,a[h])}}}catch(p){}return null}e.realcaseSync=y;async function k(i){try{return await T.Promises.realpath(i)}catch(A){const d=I(i);return await T.Promises.access(d,w.constants.R_OK),d}}e.realpath=k;function D(i){try{return w.realpathSync(i)}catch(A){const d=I(i);return w.accessSync(d,w.constants.R_OK),d}}e.realpathSync=D;function I(i){return(0,R.rtrim)((0,C.normalize)(i),C.sep)}});var Ve=this&&this.__decorate||function(G,e,w,R){var C=arguments.length,T=C<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,w):R,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(G,e,w,R);else for(var k=G.length-1;k>=0;k--)(y=G[k])&&(T=(C<3?y(T):C>3?y(e,w,T):y(e,w))||T);return C>3&&T&&Object.defineProperty(e,w,T),T};define(ge[103],pe([0,1,3,6,13,21,17,23,16,12,58,8,53]),function(G,e,w,R,C,T,y,k,D,I,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function a(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function E(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(v||(v={}));class S{constructor(M){this.buffer=M,this.pos=0}read(M){const B=this.buffer.slice(this.pos,this.pos+M);return this.pos+=B.byteLength,B}}class u{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var f;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(f||(f={}));function c(F){const M=k.VSBuffer.alloc(4);return M.writeUInt32BE(F,0),M}function t(F){return F.read(4).readUInt32BE(0)}function n(F){const M=k.VSBuffer.alloc(1);return M.writeUInt8(F,0),M}const s={Undefined:n(f.Undefined),String:n(f.String),Buffer:n(f.Buffer),VSBuffer:n(f.VSBuffer),Array:n(f.Array),Object:n(f.Object)},r=typeof Buffer!="undefined";function o(F,M){if(typeof M=="undefined")F.write(s.Undefined);else if(typeof M=="string"){const B=k.VSBuffer.fromString(M);F.write(s.String),F.write(c(B.byteLength)),F.write(B)}else if(r&&Buffer.isBuffer(M)){const B=k.VSBuffer.wrap(M);F.write(s.Buffer),F.write(c(B.byteLength)),F.write(B)}else if(M instanceof k.VSBuffer)F.write(s.VSBuffer),F.write(c(M.byteLength)),F.write(M);else if(Array.isArray(M)){F.write(s.Array),F.write(c(M.length));for(const B of M)o(F,B)}else{const B=k.VSBuffer.fromString(JSON.stringify(M));F.write(s.Object),F.write(c(B.byteLength)),F.write(B)}}function g(F){switch(F.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return F.read(t(F)).toString();case f.Buffer:return F.read(t(F)).buffer;case f.VSBuffer:return F.read(t(F));case f.Array:{const B=t(F),H=[];for(let Q=0;Q<B;Q++)H.push(g(F));return H}case f.Object:return JSON.parse(F.read(t(F)).toString())}}class m{constructor(M,B,H=null,Q=1e3){this.protocol=M,this.ctx=B,this.logger=H,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(M,B){this.channels.set(M,B),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const B=this.send([M.type]);this.logger&&this.logger.logOutgoing(B,0,1,E(M.type));return}case 201:case 202:case 204:case 203:{const B=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(B,M.id,1,E(M.type),M.data);return}}}send(M,B=void 0){const H=new u;return o(H,M),o(H,B),this.sendBuffer(H.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(B){return 0}}onRawMessage(M){const B=new S(M),H=g(B),Q=g(B),le=H[0];switch(le){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],1,`${a(le)}: ${H[2]}.${H[3]}`,Q),this.onPromise({type:le,id:H[1],channelName:H[2],name:H[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],1,`${a(le)}: ${H[2]}.${H[3]}`,Q),this.onEventListen({type:le,id:H[1],channelName:H[2],name:H[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],1,`${a(le)}`),this.disposeActiveRequest({type:le,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],1,`${a(le)}`),this.disposeActiveRequest({type:le,id:H[1]})}}onPromise(M){const B=this.channels.get(M.channelName);if(!B){this.collectPendingRequest(M);return}const H=new T.CancellationTokenSource;let Q;try{Q=B.call(this.ctx,M.name,M.arg,H.token)}catch(Te){Q=Promise.reject(Te)}const le=M.id;Q.then(Te=>{this.sendResponse({id:le,data:Te,type:201}),this.activeRequests.delete(M.id)},Te=>{Te instanceof Error?this.sendResponse({id:le,data:{message:Te.message,name:Te.name,stack:Te.stack?Te.stack.split?Te.stack.split(`
`):Te.stack:void 0},type:202}):this.sendResponse({id:le,data:Te,type:203}),this.activeRequests.delete(M.id)});const be=(0,R.toDisposable)(()=>H.cancel());this.activeRequests.set(M.id,be)}onEventListen(M){const B=this.channels.get(M.channelName);if(!B){this.collectPendingRequest(M);return}const H=M.id,le=B.listen(this.ctx,M.name,M.arg)(be=>this.sendResponse({id:H,data:be,type:204}));this.activeRequests.set(M.id,le)}disposeActiveRequest(M){const B=this.activeRequests.get(M.id);B&&(B.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let B=this.pendingRequests.get(M.channelName);B||(B=[],this.pendingRequests.set(M.channelName,B));const H=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);B.push({request:M,timeoutTimer:H})}flushPendingRequests(M){const B=this.pendingRequests.get(M);if(B){for(const H of B)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=m;var _;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(_=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(M,B=null){this.protocol=M,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=B}getChannel(M){const B=this;return{call(H,Q,le){return B.isDisposed?Promise.reject(y.canceled()):B.requestPromise(M,H,Q,le)},listen(H,Q){return B.isDisposed?Promise.reject(y.canceled()):B.requestEvent(M,H,Q)}}}requestPromise(M,B,H,Q=T.CancellationToken.None){const le=this.lastRequestId++,Te={id:le,type:100,channelName:M,name:B,arg:H};if(Q.isCancellationRequested)return Promise.reject(y.canceled());let ke;return new Promise((Ke,ze)=>{if(Q.isCancellationRequested)return ze(y.canceled());const qe=()=>{const oe=Y=>{switch(Y.type){case 201:this.handlers.delete(le),Ke(Y.data);break;case 202:this.handlers.delete(le);const ce=new Error(Y.data.message);ce.stack=Y.data.stack,ce.name=Y.data.name,ze(ce);break;case 203:this.handlers.delete(le),ze(Y.data);break}};this.handlers.set(le,oe),this.sendRequest(Te)};let q=null;this.state===v.Idle?qe():(q=(0,C.createCancelablePromise)(oe=>this.whenInitialized()),q.then(()=>{q=null,qe()}));const J=()=>{q?(q.cancel(),q=null):this.sendRequest({id:le,type:101}),ze(y.canceled())},re=Q.onCancellationRequested(J);ke=(0,R.combinedDisposable)((0,R.toDisposable)(J),re),this.activeRequests.add(ke)}).finally(()=>{this.activeRequests.delete(ke)})}requestEvent(M,B,H){const Q=this.lastRequestId++,be={id:Q,type:102,channelName:M,name:B,arg:H};let Te=null;const ke=new w.Emitter({onFirstListenerAdd:()=>{Te=(0,C.createCancelablePromise)(Ke=>this.whenInitialized()),Te.then(()=>{Te=null,this.activeRequests.add(ke),this.sendRequest(be)})},onLastListenerRemove:()=>{Te?(Te.cancel(),Te=null):(this.activeRequests.delete(ke),this.sendRequest({id:Q,type:103}))}}),Ne=Ke=>ke.fire(Ke.data);return this.handlers.set(Q,Ne),ke.event}sendRequest(M){switch(M.type){case 100:case 102:{const B=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(B,M.id,0,`${a(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const B=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(B,M.id,0,a(M.type));return}}}send(M,B=void 0){const H=new u;return o(H,M),o(H,B),this.sendBuffer(H.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(B){return 0}}onBuffer(M){const B=new S(M),H=g(B),Q=g(B),le=H[0];switch(le){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,E(le)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,H[1],0,E(le),Q),this.onResponse({type:H[0],id:H[1],data:Q})}}onResponse(M){if(M.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const B=this.handlers.get(M.id);B&&B(M)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}Ve([d.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class l{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:B,onDidClientDisconnect:H})=>{w.Event.once(B.onMessage)(le=>{const be=new S(le),Te=g(be),ke=new m(B,Te),Ne=new b(B);this.channels.forEach((ze,qe)=>ke.registerChannel(qe,ze));const Ke={channelServer:ke,channelClient:Ne,ctx:Te};this._connections.add(Ke),this._onDidAddConnection.fire(Ke),H(()=>{ke.dispose(),Ne.dispose(),this._connections.delete(Ke),this._onDidRemoveConnection.fire(Ke)})})})}get connections(){const M=[];return this._connections.forEach(B=>M.push(B)),M}getChannel(M,B){const H=this;return{call(Q,le,be){let Te;if((0,I.isFunction)(B)){let Ne=(0,D.getRandomElement)(H.connections.filter(B));Te=Ne?Promise.resolve(Ne):w.Event.toPromise(w.Event.filter(H.onDidAddConnection,B))}else Te=B.routeCall(H,Q,le);const ke=Te.then(Ne=>Ne.channelClient.getChannel(M));return O(ke).call(Q,le,be)},listen(Q,le){if((0,I.isFunction)(B))return H.getMulticastEvent(M,B,Q,le);const be=B.routeEvent(H,Q,le).then(Te=>Te.channelClient.getChannel(M));return O(be).listen(Q,le)}}}getMulticastEvent(M,B,H,Q){const le=this;let be=new R.DisposableStore;const Te=new w.Emitter({onFirstListenerAdd:()=>{be=new R.DisposableStore;const ke=new w.EventMultiplexer,Ne=new Map,Ke=qe=>{const J=qe.channelClient.getChannel(M).listen(H,Q),re=ke.add(J);Ne.set(qe,re)},ze=qe=>{const q=Ne.get(qe);!q||(q.dispose(),Ne.delete(qe))};le.connections.filter(B).forEach(Ke),w.Event.filter(le.onDidAddConnection,B)(Ke,void 0,be),le.onDidRemoveConnection(ze,void 0,be),ke.event(Te.fire,Te,be),be.add(ke)},onLastListenerRemove:()=>{be.dispose()}});return Te.event}registerChannel(M,B){this.channels.set(M,B),this._connections.forEach(H=>{H.channelServer.registerChannel(M,B)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=l;class L{constructor(M,B,H=null){const Q=new u;o(Q,B),M.send(Q.buffer),this.channelClient=new b(M,H),this.channelServer=new m(M,B,H)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,B){this.channelServer.registerChannel(M,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function O(F){return{call(M,B,H){return F.then(Q=>Q.call(M,B,H))},listen(M,B){const H=new w.Relay;return F.then(Q=>H.input=Q.listen(M,B)),H.event}}}e.getDelayedChannel=O;function $(F){let M=!1;return{call(B,H,Q){return M?F.call(B,H,Q):(0,C.timeout)(0).then(()=>M=!0).then(()=>F.call(B,H,Q))},listen(B,H){if(M)return F.listen(B,H);const Q=new w.Relay;return(0,C.timeout)(0).then(()=>M=!0).then(()=>Q.input=F.listen(B,H)),Q.event}}}e.getNextTickChannel=$;class ie{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const B of M.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await w.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=ie;var se;(function(F){function M(Q,le){const be=Q,Te=le&&le.disableMarshalling,ke=new Map;for(const Ne in be)H(Ne)&&ke.set(Ne,w.Event.buffer(be[Ne],!0));return new class{listen(Ne,Ke){const ze=ke.get(Ke);if(ze)return ze;throw new Error(`Event not found: ${Ke}`)}call(Ne,Ke,ze){const qe=be[Ke];if(typeof qe=="function"){if(!Te&&Array.isArray(ze))for(let q=0;q<ze.length;q++)ze[q]=(0,i.revive)(ze[q]);return qe.apply(be,ze)}throw new Error(`Method not found: ${Ke}`)}}}F.fromService=M;function B(Q,le){const be=le&&le.disableMarshalling;return new Proxy({},{get(Te,ke){var Ne;if(typeof ke=="string")return((Ne=le==null?void 0:le.properties)===null||Ne===void 0?void 0:Ne.has(ke))?le.properties.get(ke):H(ke)?Q.listen(ke):async function(...Ke){let ze;le&&!(0,I.isUndefinedOrNull)(le.context)?ze=[le.context,...Ke]:ze=Ke;const qe=await Q.call(ke,ze);return be?qe:(0,i.revive)(qe)};throw new Error(`Property not found: ${String(ke)}`)}})}F.toService=B;function H(Q){return Q[0]==="o"&&Q[1]==="n"&&A.isUpperAsciiLetter(Q.charCodeAt(2))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let M=F.toString();if(M!=="[object Object]")return M}return F}function W(F){return Array.isArray(F)?F.map(V):V(F)}function P(F,M,B,H,Q,le,be){be=W(be);const Te=U[Q],ke=Te[H%Te.length];let Ne=[`%c[${F}]%c[${String(M).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${ke}`];/\($/.test(le)?(Ne=Ne.concat(be),Ne.push(")")):Ne.push(be),console.log.apply(console,Ne)}e.logWithColors=P;class N{constructor(M,B){this._outgoingPrefix=M,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,B,H,Q,le){this._totalOutgoing+=M,P(this._outgoingPrefix,this._totalOutgoing,M,B,H,Q,le)}logIncoming(M,B,H,Q,le){this._totalIncoming+=M,P(this._incomingPrefix,this._totalIncoming,M,B,H,Q,le)}}e.IPCLogger=N}),define(ge[104],pe([0,1,3,103,6,23,11,36]),function(G,e,w,R,C,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function I(){return D||(D=T.VSBuffer.alloc(0)),D}class i{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,r){if(s===0)return I();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const _=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=s),_}if(this._chunks[0].byteLength>s){const _=this._chunks[0].slice(0,s);return r&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),_}let o=T.VSBuffer.alloc(s),g=0,m=0;for(;s>0;){const _=this._chunks[m];if(_.byteLength>s){const b=_.slice(0,s);o.set(b,g),g+=s,r&&(this._chunks[m]=_.slice(s),this._totalLength-=s),s-=s}else o.set(_,g),g+=_.byteLength,r?(this._chunks.shift(),this._totalLength-=_.byteLength):m++,s-=_.byteLength}return o}}e.ChunkStream=i;var A;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(A||(A={}));var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(s,r,o,g){this.type=s,this.id=r,this.ack=o,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends C.Disposable{constructor(s){super();this._onMessage=this._register(new w.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new i,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const o=this._state.messageType,g=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new p(o,g,m,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=T.VSBuffer.alloc(13);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this._writeSoon(r,s.data)}_bufferAdd(s,r){const o=this._totalLength===0;return this._data.push(s,r),this._totalLength+=s.byteLength+r.byteLength,o}_bufferTake(){const s=T.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,r){this._bufferAdd(s,r)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends C.Disposable{constructor(s){super();this._onMessage=new w.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new w.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new p(1,0,0,s))}}e.Protocol=E;class v extends R.IPCClient{constructor(s,r,o=null){super(s,r,o);this.protocol=s}static fromSocket(s,r){return new v(new E(s),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=v;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new w.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,k.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class u{constructor(s){this.data=s,this.next=null}}class f{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],r=0,o=this._first;for(;o;)s[r++]=o.data,o=o.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const r=new u(s);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class c{constructor(){this.lastRuns=[];const s=Date.now();for(let r=0;r<c._HISTORY_LENGTH;r++)this.lastRuns[r]=s-1e3*r;setInterval(()=>{for(let r=c._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const s=Date.now(),r=(1+c._HISTORY_LENGTH)*1e3;let o=0;for(let g=0;g<c._HISTORY_LENGTH;g++)s-this.lastRuns[g]<=r&&o++;return 1-o/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class t{constructor(s,r=null){this._loadEstimator=c.getInstance(),this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new f,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new p(5,0,0,I());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const r=new p(4,0,0,I());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,r){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let r=0,o=s.length;r<o;r++)this._socketWriter.write(s[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new p(6,0,0,I())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const r=this._outgoingUnackMsg.toArray();for(let o=0,g=r.length;o<g;o++)this._socketWriter.write(r[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new p(1,r,this._incomingAckId,s);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(s){const r=new p(2,0,0,s);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const s=this._outgoingUnackMsg.peek(),r=Date.now()-s.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,I());this._socketWriter.write(s)}}e.PersistentProtocol=t}),define(ge[105],pe([0,1,94]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(k){let D=(0,w.toUint8)(k);this._defaultValue=D,this._asciiMap=R._createAsciiMap(D),this._map=new Map}static _createAsciiMap(k){let D=new Uint8Array(256);for(let I=0;I<256;I++)D[I]=k;return D}set(k,D){let I=(0,w.toUint8)(D);k>=0&&k<256?this._asciiMap[k]=I:this._map.set(k,I)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=R;var C;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(C||(C={}));class T{constructor(){this._actual=new R(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=T}),define(ge[140],pe([0,1,105]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends w.CharacterClassifier{constructor(k){super(0);for(let D=0,I=k.length;D<I;D++)this.set(k.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function T(y){let k={};return D=>(k.hasOwnProperty(D)||(k[D]=y(D)),k[D])}e.getMapForWordSeparators=T(y=>new C(y))}),define(ge[46],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class w{constructor(C,T){this.lineNumber=C,this.column=T}with(C=this.lineNumber,T=this.column){return C===this.lineNumber&&T===this.column?this:new w(C,T)}delta(C=0,T=0){return this.with(this.lineNumber+C,this.column+T)}equals(C){return w.equals(this,C)}static equals(C,T){return!C&&!T?!0:!!C&&!!T&&C.lineNumber===T.lineNumber&&C.column===T.column}isBefore(C){return w.isBefore(this,C)}static isBefore(C,T){return C.lineNumber<T.lineNumber?!0:T.lineNumber<C.lineNumber?!1:C.column<T.column}isBeforeOrEqual(C){return w.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,T){return C.lineNumber<T.lineNumber?!0:T.lineNumber<C.lineNumber?!1:C.column<=T.column}static compare(C,T){let y=C.lineNumber|0,k=T.lineNumber|0;if(y===k){let D=C.column|0,I=T.column|0;return D-I}return y-k}clone(){return new w(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new w(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=w}),define(ge[42],pe([0,1,46]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(T,y,k,D){T>k||T===k&&y>D?(this.startLineNumber=k,this.startColumn=D,this.endLineNumber=T,this.endColumn=y):(this.startLineNumber=T,this.startColumn=y,this.endLineNumber=k,this.endColumn=D)}isEmpty(){return R.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return R.containsPosition(this,T)}static containsPosition(T,y){return!(y.lineNumber<T.startLineNumber||y.lineNumber>T.endLineNumber||y.lineNumber===T.startLineNumber&&y.column<T.startColumn||y.lineNumber===T.endLineNumber&&y.column>T.endColumn)}containsRange(T){return R.containsRange(this,T)}static containsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>T.endColumn)}strictContainsRange(T){return R.strictContainsRange(this,T)}static strictContainsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<=T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>=T.endColumn)}plusRange(T){return R.plusRange(this,T)}static plusRange(T,y){let k,D,I,i;return y.startLineNumber<T.startLineNumber?(k=y.startLineNumber,D=y.startColumn):y.startLineNumber===T.startLineNumber?(k=y.startLineNumber,D=Math.min(y.startColumn,T.startColumn)):(k=T.startLineNumber,D=T.startColumn),y.endLineNumber>T.endLineNumber?(I=y.endLineNumber,i=y.endColumn):y.endLineNumber===T.endLineNumber?(I=y.endLineNumber,i=Math.max(y.endColumn,T.endColumn)):(I=T.endLineNumber,i=T.endColumn),new R(k,D,I,i)}intersectRanges(T){return R.intersectRanges(this,T)}static intersectRanges(T,y){let k=T.startLineNumber,D=T.startColumn,I=T.endLineNumber,i=T.endColumn,A=y.startLineNumber,d=y.startColumn,p=y.endLineNumber,a=y.endColumn;return k<A?(k=A,D=d):k===A&&(D=Math.max(D,d)),I>p?(I=p,i=a):I===p&&(i=Math.min(i,a)),k>I||k===I&&D>i?null:new R(k,D,I,i)}equalsRange(T){return R.equalsRange(this,T)}static equalsRange(T,y){return!!T&&!!y&&T.startLineNumber===y.startLineNumber&&T.startColumn===y.startColumn&&T.endLineNumber===y.endLineNumber&&T.endColumn===y.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(T){return new w.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(T){return new w.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,y){return new R(this.startLineNumber,this.startColumn,T,y)}setStartPosition(T,y){return new R(T,y,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(T){return new R(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,y=T){return new R(T.lineNumber,T.column,y.lineNumber,y.column)}static lift(T){return T?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn)}static areIntersecting(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,y){if(T&&y){const I=T.startLineNumber|0,i=y.startLineNumber|0;if(I===i){const A=T.startColumn|0,d=y.startColumn|0;if(A===d){const p=T.endLineNumber|0,a=y.endLineNumber|0;if(p===a){const h=T.endColumn|0,E=y.endColumn|0;return h-E}return p-a}return A-d}return I-i}return(T?1:0)-(y?1:0)}static compareRangesUsingEnds(T,y){return T.endLineNumber===y.endLineNumber?T.endColumn===y.endColumn?T.startLineNumber===y.startLineNumber?T.startColumn-y.startColumn:T.startLineNumber-y.startLineNumber:T.endColumn-y.endColumn:T.endLineNumber-y.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=R}),define(ge[141],pe([0,1,46,42]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class T extends R.Range{constructor(k,D,I,i){super(k,D,I,i);this.selectionStartLineNumber=k,this.selectionStartColumn=D,this.positionLineNumber=I,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return T.selectionsEqual(this,k)}static selectionsEqual(k,D){return k.selectionStartLineNumber===D.selectionStartLineNumber&&k.selectionStartColumn===D.selectionStartColumn&&k.positionLineNumber===D.positionLineNumber&&k.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,D){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,k,D):new T(k,D,this.startLineNumber,this.startColumn)}getPosition(){return new w.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(k,D){return this.getDirection()===0?new T(k,D,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,k,D)}static fromPositions(k,D=k){return new T(k.lineNumber,k.column,D.lineNumber,D.column)}static liftSelection(k){return new T(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,D){if(k&&!D||!k&&D)return!1;if(!k&&!D)return!0;if(k.length!==D.length)return!1;for(let I=0,i=k.length;I<i;I++)if(!this.selectionsEqual(k[I],D[I]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,D,I,i,A){return A===0?new T(k,D,I,i):new T(I,i,k,D)}}e.Selection=T}),define(ge[106],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var w;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(w=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(h){this.tabSize=Math.max(1,h.tabSize|0),this.indentSize=h.tabSize|0,this.insertSpaces=Boolean(h.insertSpaces),this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=Boolean(h.trimAutoWhitespace)}equals(h){return this.tabSize===h.tabSize&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class D{constructor(h,E){this.range=h,this.matches=E}}e.FindMatch=D;var I;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(I=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right"})(i=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var A;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(A=e.ModelConstants||(e.ModelConstants={}));class d{constructor(h,E,v,S,u,f){this.identifier=h,this.range=E,this.text=v,this.forceMoveMarkers=S,this.isAutoWhitespaceEdit=u,this._isTracked=f}}e.ValidAnnotatedEditOperation=d;class p{constructor(h,E,v){this.reverseEdits=h,this.changes=E,this.trimAutoWhitespaceLineNumbers=v}}e.ApplyEditsResult=p}),define(ge[142],pe([0,1,8,140,46,42,106]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class D{constructor(u,f,c,t){this.searchString=u,this.isRegex=f,this.matchCase=c,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=I(this.searchString):u=this.searchString.indexOf(`
`)>=0;let f=null;try{f=w.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!f)return null;let c=!this.isRegex&&!u;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new i(f,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=D;function I(S){if(!S||S.length===0)return!1;for(let u=0,f=S.length;u<f;u++)if(S.charCodeAt(u)===92){if(u++,u>=f)break;const t=S.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=I;class i{constructor(u,f,c){this.regex=u,this.wordSeparators=f,this.simpleSearch=c}}e.SearchData=i;function A(S,u,f){if(!f)return new y.FindMatch(S,null);let c=[];for(let t=0,n=u.length;t<n;t++)c[t]=u[t];return new y.FindMatch(S,c)}e.createFindMatch=A;class d{constructor(u){let f=[],c=0;for(let t=0,n=u.length;t<n;t++)u.charCodeAt(t)===10&&(f[c++]=t);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(u){const f=this._lineFeedsOffsets;let c=0,t=f.length-1;if(t===-1||u<=f[0])return 0;for(;c<t;){const n=c+((t-c)/2>>0);f[n]>=u?t=n-1:f[n+1]>=u?(c=n,t=n):c=n+1}return c+1}}class p{static findMatches(u,f,c,t,n){const s=f.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(u,c,new v(s.wordSeparators,s.regex),t,n):this._doFindMatchesLineByLine(u,c,s,t,n):[]}static _getMultilineMatchRange(u,f,c,t,n,s){let r,o=0;t?(o=t.findLineFeedCountBeforeOffset(n),r=f+n+o):r=f+n;let g;if(t){let l=t.findLineFeedCountBeforeOffset(n+s.length)-o;g=r+s.length+l}else g=r+s.length;const m=u.getPositionAt(r),_=u.getPositionAt(g);return new T.Range(m.lineNumber,m.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(u,f,c,t,n){const s=u.getOffsetAt(f.getStartPosition()),r=u.getValueInRange(f,1),o=u.getEOL()===`\r
`?new d(r):null,g=[];let m=0,_;for(c.reset(0);_=c.next(r);)if(g[m++]=A(this._getMultilineMatchRange(u,s,r,o,_.index,_[0]),_,t),m>=n)return g;return g}static _doFindMatchesLineByLine(u,f,c,t,n){const s=[];let r=0;if(f.startLineNumber===f.endLineNumber){const g=u.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return r=this._findMatchesInLine(c,g,f.startLineNumber,f.startColumn-1,r,s,t,n),s}const o=u.getLineContent(f.startLineNumber).substring(f.startColumn-1);r=this._findMatchesInLine(c,o,f.startLineNumber,f.startColumn-1,r,s,t,n);for(let g=f.startLineNumber+1;g<f.endLineNumber&&r<n;g++)r=this._findMatchesInLine(c,u.getLineContent(g),g,0,r,s,t,n);if(r<n){const g=u.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);r=this._findMatchesInLine(c,g,f.endLineNumber,0,r,s,t,n)}return s}static _findMatchesInLine(u,f,c,t,n,s,r,o){const g=u.wordSeparators;if(!r&&u.simpleSearch){const b=u.simpleSearch,l=b.length,L=f.length;let O=-l;for(;(O=f.indexOf(b,O+l))!==-1;)if((!g||E(g,f,L,O,l))&&(s[n++]=new y.FindMatch(new T.Range(c,O+1+t,c,O+1+l+t),null),n>=o))return n;return n}const m=new v(u.wordSeparators,u.regex);let _;m.reset(0);do if(_=m.next(f),_&&(s[n++]=A(new T.Range(c,_.index+1+t,c,_.index+1+_[0].length+t),_,r),n>=o))return n;while(_);return n}static findNextMatch(u,f,c,t){const n=f.parseSearchRequest();if(!n)return null;const s=new v(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(u,c,s,t):this._doFindNextMatchLineByLine(u,c,s,t)}static _doFindNextMatchMultiline(u,f,c,t){const n=new C.Position(f.lineNumber,1),s=u.getOffsetAt(n),r=u.getLineCount(),o=u.getValueInRange(new T.Range(n.lineNumber,n.column,r,u.getLineMaxColumn(r)),1),g=u.getEOL()===`\r
`?new d(o):null;c.reset(f.column-1);let m=c.next(o);return m?A(this._getMultilineMatchRange(u,s,o,g,m.index,m[0]),m,t):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(u,new C.Position(1,1),c,t):null}static _doFindNextMatchLineByLine(u,f,c,t){const n=u.getLineCount(),s=f.lineNumber,r=u.getLineContent(s),o=this._findFirstMatchInLine(c,r,s,f.column,t);if(o)return o;for(let g=1;g<=n;g++){const m=(s+g-1)%n,_=u.getLineContent(m+1),b=this._findFirstMatchInLine(c,_,m+1,1,t);if(b)return b}return null}static _findFirstMatchInLine(u,f,c,t,n){u.reset(t-1);const s=u.next(f);return s?A(new T.Range(c,s.index+1,c,s.index+1+s[0].length),s,n):null}static findPreviousMatch(u,f,c,t){const n=f.parseSearchRequest();if(!n)return null;const s=new v(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(u,c,s,t):this._doFindPreviousMatchLineByLine(u,c,s,t)}static _doFindPreviousMatchMultiline(u,f,c,t){const n=this._doFindMatchesMultiline(u,new T.Range(1,1,f.lineNumber,f.column),c,t,10*k);if(n.length>0)return n[n.length-1];const s=u.getLineCount();return f.lineNumber!==s||f.column!==u.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(u,new C.Position(s,u.getLineMaxColumn(s)),c,t):null}static _doFindPreviousMatchLineByLine(u,f,c,t){const n=u.getLineCount(),s=f.lineNumber,r=u.getLineContent(s).substring(0,f.column-1),o=this._findLastMatchInLine(c,r,s,t);if(o)return o;for(let g=1;g<=n;g++){const m=(n+s-g-1)%n,_=u.getLineContent(m+1),b=this._findLastMatchInLine(c,_,m+1,t);if(b)return b}return null}static _findLastMatchInLine(u,f,c,t){let n=null,s;for(u.reset(0);s=u.next(f);)n=A(new T.Range(c,s.index+1,c,s.index+1+s[0].length),s,t);return n}}e.TextModelSearch=p;function a(S,u,f,c,t){if(c===0)return!0;const n=u.charCodeAt(c-1);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=u.charCodeAt(c);if(S.get(s)!==0)return!0}return!1}function h(S,u,f,c,t){if(c+t===f)return!0;const n=u.charCodeAt(c+t);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=u.charCodeAt(c+t-1);if(S.get(s)!==0)return!0}return!1}function E(S,u,f,c,t){return a(S,u,f,c,t)&&h(S,u,f,c,t)}e.isValidMatch=E;class v{constructor(u,f){this._wordSeparators=u,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const f=u.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(c=this._searchRegex.exec(u),!c))return null;const t=c.index,n=c[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){w.getNextCodePoint(u,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||E(this._wordSeparators,u,f,t,n))return c}while(c);return null}}e.Searcher=v}),define(ge[107],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function w(k=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)k.indexOf(I)>=0||(D+="\\"+I);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=w();function R(k){let D=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)D=k;else{let I="g";k.ignoreCase&&(I+="i"),k.multiline&&(I+="m"),k.unicode&&(I+="u"),D=new RegExp(k.source,I)}return D.lastIndex=0,D}e.ensureValidWordDefinition=R;const C={maxLen:1e3,windowSize:15,timeBudget:150};function T(k,D,I,i,A=C){if(I.length>A.maxLen){let E=k-A.maxLen/2;return E<0?E=0:i+=E,I=I.substring(E,k+A.maxLen/2),T(k,D,I,i,A)}const d=Date.now(),p=k-1-i;let a=-1,h=null;for(let E=1;!(Date.now()-d>=A.timeBudget);E++){const v=p-A.windowSize*E;D.lastIndex=Math.max(0,v);const S=y(D,I,p,a);if(!S&&h||(h=S,v<=0))break;a=v}if(h){let E={word:h[0],startColumn:i+1+h.index,endColumn:i+1+h.index+h[0].length};return D.lastIndex=0,E}return null}e.getWordAtText=T;function y(k,D,I,i){let A;for(;A=k.exec(D);){const d=A.index||0;if(d<=I&&k.lastIndex>=I)return A;if(i>0&&d>i)return null}return null}}),define(ge[143],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var w;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(w=e.IndentAction||(e.IndentAction={}));class R{constructor(k){if(this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let D=0,I=k.notIn.length;D<I;D++)switch(k.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=R;class C{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of k)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=C;function T(y,k,D){y.has(k)?y.get(k).push(D):y.set(k,[D])}}),define(ge[78],pe([0,1,30,9]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(T,y,k,D){if(Array.isArray(T)){let I=0;for(const i of T){const A=C(i,y,k,D);if(A===10)return A;A>I&&(I=A)}return I}else{if(typeof T=="string")return D?T==="*"?5:T===k?10:0:0;if(T){const{language:I,pattern:i,scheme:A,hasAccessToAllModels:d}=T;if(!D&&!d)return 0;let p=0;if(A)if(A===y.scheme)p=10;else if(A==="*")p=5;else return 0;if(I)if(I===k)p=10;else if(I==="*")p=Math.max(p,5);else return 0;if(i){let a;if(typeof i=="string"?a=i:a=Object.assign(Object.assign({},i),{base:(0,R.normalize)(i.base)}),a===y.fsPath||(0,w.match)(a,y.fsPath))p=10;else return 0}return p}else return 0}}e.score=C}),define(ge[144],pe([0,1,105]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class C{constructor(a,h,E){const v=new Uint8Array(a*h);for(let S=0,u=a*h;S<u;S++)v[S]=E;this._data=v,this.rows=a,this.cols=h}get(a,h){return this._data[a*this.cols+h]}set(a,h,E){this._data[a*this.cols+h]=E}}e.Uint8Matrix=C;class T{constructor(a){let h=0,E=0;for(let S=0,u=a.length;S<u;S++){let[f,c,t]=a[S];c>h&&(h=c),f>E&&(E=f),t>E&&(E=t)}h++,E++;let v=new C(E,h,0);for(let S=0,u=a.length;S<u;S++){let[f,c,t]=a[S];v.set(f,c,t)}this._states=v,this._maxCharCode=h}nextState(a,h){return h<0||h>=this._maxCharCode?0:this._states.get(a,h)}}e.StateMachine=T;let y=null;function k(){return y===null&&(y=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let I=null;function i(){if(I===null){I=new w.CharacterClassifier(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<p.length;h++)I.set(p.charCodeAt(h),1);const a=".,;";for(let h=0;h<a.length;h++)I.set(a.charCodeAt(h),2)}return I}class A{static _createLink(a,h,E,v,S){let u=S-1;do{const f=h.charCodeAt(u);if(a.get(f)!==2)break;u--}while(u>v);if(v>0){const f=h.charCodeAt(v-1),c=h.charCodeAt(u);(f===40&&c===41||f===91&&c===93||f===123&&c===125)&&u--}return{range:{startLineNumber:E,startColumn:v+1,endLineNumber:E,endColumn:u+2},url:h.substring(v,u+1)}}static computeLinks(a,h=k()){const E=i();let v=[];for(let S=1,u=a.getLineCount();S<=u;S++){const f=a.getLineContent(S),c=f.length;let t=0,n=0,s=0,r=1,o=!1,g=!1,m=!1,_=!1;for(;t<c;){let b=!1;const l=f.charCodeAt(t);if(r===13){let L;switch(l){case 40:o=!0,L=0;break;case 41:L=o?0:1;break;case 91:m=!0,g=!0,L=0;break;case 93:m=!1,L=g?0:1;break;case 123:_=!0,L=0;break;case 125:L=_?0:1;break;case 39:L=s===34||s===96?0:1;break;case 34:L=s===39||s===96?0:1;break;case 96:L=s===39||s===34?0:1;break;case 42:L=s===42?1:0;break;case 124:L=s===124?1:0;break;case 32:L=m?0:1;break;default:L=E.get(l)}L===1&&(v.push(A._createLink(E,f,S,n,t)),b=!0)}else if(r===12){let L;l===91?(g=!0,L=0):L=E.get(l),L===1?b=!0:r=13}else r=h.nextState(r,l),r===0&&(b=!0);b&&(r=1,o=!1,g=!1,_=!1,n=t+1,s=l),t++}r===13&&v.push(A._createLink(E,f,S,n,c))}return v}}e.LinkComputer=A;function d(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:A.computeLinks(p)}e.computeLinks=d}),define(ge[145],pe([0,1,3,6]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new w.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,k){return this._map.set(y,k),this.fire([y]),(0,R.toDisposable)(()=>{this._map.get(y)===k&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,k){let D=null,I=!1;return this._promises.set(y,k.then(i=>{this._promises.delete(y),!(I||!i)&&(D=this.register(y,i))})),(0,R.toDisposable)(()=>{I=!0,D&&D.dispose()})}getPromise(y){const k=this.get(y);if(k)return Promise.resolve(k);const D=this._promises.get(y);return D?D.then(I=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(ge[108],pe([0,1,23,11]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(A){A[A.Full=1]="Full",A[A.Delta=2]="Delta"})(C||(C={}));function T(A){for(let d=0,p=A.length;d<p;d+=4){const a=A[d+0],h=A[d+1],E=A[d+2],v=A[d+3];A[d+0]=v,A[d+1]=E,A[d+2]=h,A[d+3]=a}}function y(A){const d=new Uint8Array(A.buffer,A.byteOffset,A.length*4);return R.isLittleEndian()||T(d),w.VSBuffer.wrap(d)}function k(A){const d=A.buffer;if(R.isLittleEndian()||T(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const p=new Uint8Array(d.byteLength);return p.set(d),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function D(A){const d=new Uint32Array(I(A));let p=0;if(d[p++]=A.id,A.type==="full")d[p++]=1,d[p++]=A.data.length,d.set(A.data,p),p+=A.data.length;else{d[p++]=2,d[p++]=A.deltas.length;for(const a of A.deltas)d[p++]=a.start,d[p++]=a.deleteCount,a.data?(d[p++]=a.data.length,d.set(a.data,p),p+=a.data.length):d[p++]=0}return y(d)}e.encodeSemanticTokensDto=D;function I(A){let d=0;if(d+=1+1,A.type==="full")d+=1+A.data.length;else{d+=1,d+=(1+1+1)*A.deltas.length;for(const p of A.deltas)p.data&&(d+=p.data.length)}return d}function i(A){const d=k(A);let p=0;const a=d[p++];if(d[p++]===1){const S=d[p++],u=d.subarray(p,p+S);return p+=S,{id:a,type:"full",data:u}}const E=d[p++];let v=[];for(let S=0;S<E;S++){const u=d[p++],f=d[p++],c=d[p++];let t;c>0&&(t=d.subarray(p,p+c),p+=c),v[S]={start:u,deleteCount:f,data:t}}return{id:a,type:"delta",deltas:v}}e.decodeSemanticTokensDto=i}),define(ge[109],pe([0,1,94]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(y,k){this.index=y,this.remainder=k}}e.PrefixSumIndexOfResult=R;class C{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,k){y=(0,w.toUint32)(y);const D=this.values,I=this.prefixSum,i=k.length;return i===0?!1:(this.values=new Uint32Array(D.length+i),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+i),this.values.set(k,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,k){return y=(0,w.toUint32)(y),k=(0,w.toUint32)(k),this.values[y]===k?!1:(this.values[y]=k,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,k){y=(0,w.toUint32)(y),k=(0,w.toUint32)(k);const D=this.values,I=this.prefixSum;if(y>=D.length)return!1;let i=D.length-y;return k>=i&&(k=i),k===0?!1:(this.values=new Uint32Array(D.length-k),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+k),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,w.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),y>=this.values.length&&(y=this.values.length-1);for(let D=k;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let k=0,D=this.values.length-1,I=0,i=0,A=0;for(;k<=D;)if(I=k+(D-k)/2|0,i=this.prefixSum[I],A=i-this.values[I],y<A)D=I-1;else if(y>=i)k=I+1;else break;return new R(I,y-A)}}e.PrefixSumComputer=C}),define(ge[146],pe([0,1,8,46,109]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(k,D,I,i){this._uri=k,this._lines=D,this._eol=I,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const D=k.changes;for(const I of D)this._acceptDeleteRange(I.range),this._acceptInsertText(new R.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,D=this._lines.length,I=new Uint32Array(D);for(let i=0;i<D;i++)I[i]=this._lines[i].length+k;this._lineStarts=new C.PrefixSumComputer(I)}}_setLineText(k,D){this._lines[k]=D,this._lineStarts&&this._lineStarts.changeValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,D){if(D.length===0)return;let I=(0,w.splitLines)(D);if(I.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+I[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}I[I.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+I[0]);let i=new Uint32Array(I.length-1);for(let A=1;A<I.length;A++)this._lines.splice(k.lineNumber+A-1,0,I[A]),i[A-1]=I[A].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,i)}}e.MirrorTextModel=T}),define(ge[147],pe([18,19]),function(G,e){return G.create("vs/base/common/date",e)}),define(ge[148],pe([0,1,147]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,C=R*60,T=C*24,y=T*7,k=T*30,D=T*365;function I(A,d){typeof A!="number"&&(A=A.getTime());const p=Math.round((new Date().getTime()-A)/1e3);if(p<-30)return(0,w.localize)(0,null,I(new Date().getTime()+p*1e3,!1));if(p<30)return(0,w.localize)(1,null);let a;return p<R?(a=p,d?a===1?(0,w.localize)(2,null,a):(0,w.localize)(3,null,a):a===1?(0,w.localize)(4,null,a):(0,w.localize)(5,null,a)):p<C?(a=Math.floor(p/R),d?a===1?(0,w.localize)(6,null,a):(0,w.localize)(7,null,a):a===1?(0,w.localize)(8,null,a):(0,w.localize)(9,null,a)):p<T?(a=Math.floor(p/C),d?a===1?(0,w.localize)(10,null,a):(0,w.localize)(11,null,a):a===1?(0,w.localize)(12,null,a):(0,w.localize)(13,null,a)):p<y?(a=Math.floor(p/T),d?a===1?(0,w.localize)(14,null,a):(0,w.localize)(15,null,a):a===1?(0,w.localize)(16,null,a):(0,w.localize)(17,null,a)):p<k?(a=Math.floor(p/y),d?a===1?(0,w.localize)(18,null,a):(0,w.localize)(19,null,a):a===1?(0,w.localize)(20,null,a):(0,w.localize)(21,null,a)):p<D?(a=Math.floor(p/k),d?a===1?(0,w.localize)(22,null,a):(0,w.localize)(23,null,a):a===1?(0,w.localize)(24,null,a):(0,w.localize)(25,null,a)):(a=Math.floor(p/D),d?a===1?(0,w.localize)(26,null,a):(0,w.localize)(27,null,a):a===1?(0,w.localize)(28,null,a):(0,w.localize)(29,null,a))}e.fromNow=I;function i(A){return A.getFullYear()+"-"+String(A.getMonth()+1).padStart(2,"0")+"-"+String(A.getDate()).padStart(2,"0")+"T"+String(A.getHours()).padStart(2,"0")+":"+String(A.getMinutes()).padStart(2,"0")+":"+String(A.getSeconds()).padStart(2,"0")+"."+(A.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(ge[149],pe([18,19]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ge[60],pe([0,1,149,12,16]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(I,i){return i&&(I.stack||I.stacktrace)?w.localize(0,null,k(I),y(I.stack)||y(I.stacktrace)):k(I)}function y(I){return Array.isArray(I)?I.join(`
`):I}function k(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?w.localize(1,null,I.message):I.message||w.localize(2,null)}function D(I=null,i=!1){if(!I)return w.localize(3,null);if(Array.isArray(I)){const A=C.coalesce(I),d=D(A[0],i);return A.length>1?w.localize(4,null,d,A.length):d}if(R.isString(I))return I;if(I.detail){const A=I.detail;if(A.error)return T(A.error,i);if(A.exception)return T(A.exception,i)}return I.stack?T(I,i):I.message?I.message:w.localize(5,null)}e.toErrorMessage=D}),define(ge[150],pe([18,19]),function(G,e){return G.create("vs/base/node/processes",e)}),define(ge[110],pe([0,1,9,28,37,150,36,12,25,29,11,139,10]),function(G,e,w,R,C,T,y,k,D,I,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function p(f){switch(f){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function a(f,c){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};c&&(t.cwd=c);const n=C.execFile("taskkill",["/T","/F","/PID",f.pid.toString()],t);return new Promise(s=>{n.once("error",r=>{s({success:!1,error:r})}),n.once("exit",(r,o)=>{s(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?p(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=d.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(n=>{C.execFile(t,[f.pid.toString()],{encoding:"utf8",shell:!0},(s,r,o)=>{n(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else f.kill("SIGKILL");return Promise.resolve({success:!0})}function h(f=y.env){return f.comspec||"cmd.exe"}e.getWindowsShell=h;class E{constructor(c,t,n,s){if(t!==void 0&&n!==void 0&&s!==void 0)this.cmd=c,this.args=t,this.shell=n,this.options=s;else{const r=c;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(y.env).forEach(o=>{r[o]=y.env[o]}),Object.keys(this.options.env).forEach(o=>{r[o]=this.options.env[o]}),this.options.env=r}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const t=c.lastIndexOf(w.sep);return t!==-1&&(c=c.substring(t+1)),E.WellKnowCommands[c]?c:"other"}start(c){return i.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(y.cwd()))?Promise.reject(new Error(T.localize(0,null))):this.useExec().then(t=>{let n,s;const r=new Promise((o,g)=>{n=o,s=g});if(t){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=C.exec(o,this.options,(g,m,_)=>{this.childProcess=null;const b=g;b&&b.killed?s({killed:this.terminateRequested,stdout:m.toString(),stderr:_.toString()}):this.handleExec(n,c,g,m,_)})}else{let o=null;const g=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,n,c,s);const _={terminated:this.terminateRequested};k.isNumber(m)&&(_.cmdCode=m),n(_)};if(this.shell&&i.isWindows){const m=D.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let _=!1,b=!1;const l=[];let L=this.ensureQuotes(this.cmd);l.push(L.value),_=L.quoted,this.args&&this.args.forEach($=>{L=this.ensureQuotes($),l.push(L.value),b=b&&L.quoted});const O=["/s","/c"];_?b?O.push('"'+l.join(" ")+'"'):l.length>1?O.push('"'+l[0]+'" '+l.slice(1).join(" ")):O.push('"'+l[0]+'"'):O.push(l.join(" ")),o=C.spawn(h(),O,m)}else this.cmd&&(o=C.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(k.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",m=>{this.childProcess=null,s({terminated:this.terminateRequested,error:m})}),o.pid&&(this.childProcess.on("close",g),this.handleSpawn(o,n,c,s,!0)))}return r})}handleClose(c,t,n,s){}ensureQuotes(c){return E.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,a(c,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!i.isWindows)return c(!1);const t=C.spawn(h(),["/s","/c"]);t.on("error",n=>c(!0)),t.on("exit",n=>c(!1))})}}e.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class v extends E{constructor(c,t,n,s){super(c,t,n,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,t,n,s,r){[s,r].forEach((o,g)=>{const m=new A.LineDecoder;m.write(o).forEach(l=>{t({line:l,source:g===0?0:1})});const b=m.end();b&&t({line:b,source:g===0?0:1})}),c({terminated:this.terminateRequested,error:n})}handleSpawn(c,t,n,s,r){const o=new A.LineDecoder,g=new A.LineDecoder;c.stdout.on("data",m=>{o.write(m).forEach(b=>n({line:b,source:0}))}),c.stderr.on("data",m=>{g.write(m).forEach(b=>n({line:b,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=g}handleClose(c,t,n,s){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&n({line:r,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&n({line:o,source:1})}}e.LineProcess=v;function S(f){let c=[],t=!1;const n=function(s){if(t){c.push(s);return}(!f.send(s,o=>{if(o&&console.error(o),t=!1,c.length>0){const g=c.slice(0);c=[],g.forEach(m=>n(m))}})||i.isWindows)&&(t=!0)};return{send:n}}e.createQueuedSender=S;var u;(function(f){async function c(t,n,s){if(w.isAbsolute(t))return t;if(n===void 0&&(n=y.cwd()),w.dirname(t)!=="."||(s===void 0&&k.isString(y.env.PATH)&&(s=y.env.PATH.split(w.delimiter)),s===void 0||s.length===0))return w.join(n,t);async function o(g){return await R.exists(g)?!(await R.Promises.stat(g)).isDirectory():!1}for(let g of s){let m;if(w.isAbsolute(g)?m=w.join(g,t):m=w.join(n,g,t),await o(m))return m;let _=m+".com";if(await o(_)||(_=m+".exe",await o(_)))return _}return w.join(n,t)}f.findExecutable=c})(u=e.win32||(e.win32={}))}),define(ge[151],pe([18,19]),function(G,e){return G.create("vs/editor/common/config/editorOptions",e)}),define(ge[152],pe([0,1,151,11,107]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=y;class k{constructor(){this._values=[]}_read(ne){return this._values[ne]}get(ne){return this._values[ne]}_write(ne,Ee){this._values[ne]=Ee}}e.ValidatedEditorOptions=k;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class I{constructor(ne,Ee,Oe,$e){this.id=ne,this.name=Ee,this.defaultValue=Oe,this.schema=$e}compute(ne,Ee,Oe){return Oe}}class i{constructor(ne,Ee=null){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0,this.deps=Ee}validate(ne){return this.defaultValue}}class A{constructor(ne,Ee,Oe,$e){this.id=ne,this.name=Ee,this.defaultValue=Oe,this.schema=$e}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,Ee,Oe){return Oe}}function d(K,ne){return typeof K=="undefined"?ne:K==="false"?!1:Boolean(K)}e.boolean=d;class p extends A{constructor(ne,Ee,Oe,$e=void 0){typeof $e!="undefined"&&($e.type="boolean",$e.default=Oe),super(ne,Ee,Oe,$e)}validate(ne){return d(ne,this.defaultValue)}}class a extends A{constructor(ne,Ee,Oe,$e,We,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=Oe,Xe.minimum=$e,Xe.maximum=We),super(ne,Ee,Oe,Xe),this.minimum=$e,this.maximum=We}static clampedInt(ne,Ee,Oe,$e){if(typeof ne=="undefined")return Ee;let We=parseInt(ne,10);return isNaN(We)?Ee:(We=Math.max(Oe,We),We=Math.min($e,We),We|0)}validate(ne){return a.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class h extends A{constructor(ne,Ee,Oe,$e,We){typeof We!="undefined"&&(We.type="number",We.default=Oe),super(ne,Ee,Oe,We),this.validationFn=$e}static clamp(ne,Ee,Oe){return ne<Ee?Ee:ne>Oe?Oe:ne}static float(ne,Ee){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return Ee;const Oe=parseFloat(ne);return isNaN(Oe)?Ee:Oe}validate(ne){return this.validationFn(h.float(ne,this.defaultValue))}}class E extends A{static string(ne,Ee){return typeof ne!="string"?Ee:ne}constructor(ne,Ee,Oe,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.default=Oe),super(ne,Ee,Oe,$e)}validate(ne){return E.string(ne,this.defaultValue)}}function v(K,ne,Ee){return typeof K!="string"||Ee.indexOf(K)===-1?ne:K}e.stringSet=v;class S extends A{constructor(ne,Ee,Oe,$e,We=void 0){typeof We!="undefined"&&(We.type="string",We.enum=$e,We.default=Oe),super(ne,Ee,Oe,We),this._allowedValues=$e}validate(ne){return v(ne,this.defaultValue,this._allowedValues)}}class u extends I{constructor(ne,Ee,Oe,$e,We,Xe,De=void 0){typeof De!="undefined"&&(De.type="string",De.enum=We,De.default=$e),super(ne,Ee,Oe,De),this._allowedValues=We,this._convert=Xe}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function f(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",description:w.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,Ee,Oe){return Oe===0?ne.accessibilitySupport:Oe}}class t extends I{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:w.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{insertSpace:d(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(K){switch(K){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function g(K){switch(K){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class m extends i{constructor(){super(124,[62,31])}compute(ne,Ee,Oe){const $e=["monaco-editor"];return Ee.get(31)&&$e.push(Ee.get(31)),ne.extraEditorClassName&&$e.push(ne.extraEditorClassName),Ee.get(62)==="default"?$e.push("mouse-default"):Ee.get(62)==="copy"&&$e.push("mouse-copy"),Ee.get(97)&&$e.push("showUnused"),Ee.get(122)&&$e.push("showDeprecated"),$e.join(" ")}}class _ extends p{constructor(){super(30,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(ne,Ee,Oe){return Oe&&ne.emptySelectionClipboard}}class b extends I{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ne.seedSearchStringFromSelection,description:w.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[w.localize(9,null),w.localize(10,null),w.localize(11,null)],description:w.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:w.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:w.localize(14,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:w.localize(15,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{cursorMoveOnType:d(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:d(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":v(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(Ee.loop,this.defaultValue.loop)}}}class l extends I{constructor(){super(41,"fontLigatures",l.OFF,{anyOf:[{type:"boolean",description:w.localize(16,null)},{type:"string",description:w.localize(17,null)}],description:w.localize(18,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?l.OFF:ne==="true"?l.ON:ne:Boolean(ne)?l.ON:l.OFF}}e.EditorFontLigatures=l,l.OFF='"liga" off, "calt" off',l.ON='"liga" on, "calt" on';class L extends i{constructor(){super(40)}compute(ne,Ee,Oe){return ne.fontInfo}}class O extends A{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(19,null)})}validate(ne){let Ee=h.float(ne,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(Ee,6,100)}compute(ne,Ee,Oe){return ne.fontInfo.fontSize}}class $ extends I{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:w.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(21,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(a.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class ie extends I{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[w.localize(22,null),w.localize(23,null),w.localize(24,null)]},Oe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:w.localize(26,null)},Ee),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:w.localize(27,null)},Ee),"editor.gotoLocation.multipleDeclarations":Object.assign({description:w.localize(28,null)},Ee),"editor.gotoLocation.multipleImplementations":Object.assign({description:w.localize(29,null)},Ee),"editor.gotoLocation.multipleReferences":Object.assign({description:w.localize(30,null)},Ee),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:Oe,description:w.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:Oe,description:w.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:Oe,description:w.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:Oe,description:w.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:Oe,description:w.localize(35,null)}})}validate(ne){var Ee,Oe,$e,We,Xe;if(!ne||typeof ne!="object")return this.defaultValue;const De=ne;return{multiple:v(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(Ee=De.multipleDefinitions)!==null&&Ee!==void 0?Ee:v(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Oe=De.multipleTypeDefinitions)!==null&&Oe!==void 0?Oe:v(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:($e=De.multipleDeclarations)!==null&&$e!==void 0?$e:v(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(We=De.multipleImplementations)!==null&&We!==void 0?We:v(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=De.multipleReferences)!==null&&Xe!==void 0?Xe:v(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class se extends I{constructor(){const ne={enabled:!0,delay:300,sticky:!0};super(50,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:w.localize(36,null)},"editor.hover.delay":{type:"number",default:ne.delay,description:w.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:w.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:d(Ee.enabled,this.defaultValue.enabled),delay:a.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:d(Ee.sticky,this.defaultValue.sticky)}}}var U;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(U=e.RenderMinimap||(e.RenderMinimap={}));class V extends i{constructor(){super(127,[46,54,35,61,89,56,57,91,114,117,118,119,2])}compute(ne,Ee,Oe){return V.computeLayout(Ee,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const Ee=ne.height/ne.lineHeight,Oe=ne.scrollBeyondLastLine?Ee-1:0,$e=(ne.viewLineCount+Oe)/(ne.pixelRatio*ne.height),We=Math.floor(ne.viewLineCount/$e);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Oe,desiredRatio:$e,minimapLineCount:We}}static _computeMinimapLayout(ne,Ee){const Oe=ne.outerWidth,$e=ne.outerHeight,We=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(We*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Xe=Ee.stableMinimapLayoutInput,De=Xe&&ne.outerHeight===Xe.outerHeight&&ne.lineHeight===Xe.lineHeight&&ne.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&ne.pixelRatio===Xe.pixelRatio&&ne.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&ne.minimap.enabled===Xe.minimap.enabled&&ne.minimap.side===Xe.minimap.side&&ne.minimap.size===Xe.minimap.size&&ne.minimap.showSlider===Xe.minimap.showSlider&&ne.minimap.renderCharacters===Xe.minimap.renderCharacters&&ne.minimap.maxColumn===Xe.minimap.maxColumn&&ne.minimap.scale===Xe.minimap.scale&&ne.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&ne.isViewportWrapping===Xe.isViewportWrapping,ye=ne.lineHeight,Ce=ne.typicalHalfwidthCharacterWidth,ae=ne.scrollBeyondLastLine,he=ne.minimap.renderCharacters;let z=We>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const Z=ne.minimap.maxColumn,ue=ne.minimap.size,Ie=ne.minimap.side,Pe=ne.verticalScrollbarWidth,Ue=ne.viewLineCount,xe=ne.remainingWidth,Qe=ne.isViewportWrapping,rt=he?2:3;let tt=Math.floor(We*$e);const Ye=tt/We;let ot=!1,Et=!1,bt=rt*z,_e=z/We,fe=1;if(ue==="fill"||ue==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:ct,desiredRatio:it,minimapLineCount:vt}=V.computeContainedMinimapLineCount({viewLineCount:Ue,scrollBeyondLastLine:ae,height:$e,lineHeight:ye,pixelRatio:We});if(Ue/vt>1)ot=!0,Et=!0,z=1,bt=1,_e=z/We;else{let lt=!1,mt=z+1;if(ue==="fit"){const Pt=Math.ceil((Ue+ct)*bt);Qe&&De&&xe<=Ee.stableFitRemainingWidth?(lt=!0,mt=Ee.stableFitMaxMinimapScale):(lt=Pt>tt,Qe&&lt?(Ee.stableMinimapLayoutInput=ne,Ee.stableFitRemainingWidth=xe):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0))}if(ue==="fill"||lt){ot=!0;const Pt=z;bt=Math.min(ye*We,Math.max(1,Math.floor(1/it))),z=Math.min(mt,Math.max(1,Math.floor(bt/rt))),z>Pt&&(fe=Math.min(2,z/Pt)),_e=z/We/fe,tt=Math.ceil(Math.max(ft,Ue+ct)*bt),Qe&&lt&&(Ee.stableFitMaxMinimapScale=z)}}}const de=Math.floor(Z*_e),X=Math.min(de,Math.max(0,Math.floor((xe-Pe-2)*_e/(Ce+_e)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(We*X);const Re=Fe/We;Fe=Math.floor(Fe*fe);const Ze=he?1:2,et=Ie==="left"?0:Oe-X-Pe;return{renderMinimap:Ze,minimapLeft:et,minimapWidth:X,minimapHeightIsEditorHeight:ot,minimapIsSampling:Et,minimapScale:z,minimapLineHeight:bt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:tt,minimapCanvasOuterWidth:Re,minimapCanvasOuterHeight:Ye}}static computeLayout(ne,Ee){const Oe=Ee.outerWidth|0,$e=Ee.outerHeight|0,We=Ee.lineHeight|0,Xe=Ee.lineNumbersDigitCount|0,De=Ee.typicalHalfwidthCharacterWidth,ye=Ee.maxDigitWidth,Ce=Ee.pixelRatio,ae=Ee.viewLineCount,he=ne.get(119),z=he==="inherit"?ne.get(118):he,Z=z==="inherit"?ne.get(114):z,ue=ne.get(117),Ie=ne.get(2),Pe=Ee.isDominatedByLongLines,Ue=ne.get(46),xe=ne.get(56).renderType!==0,Qe=ne.get(57),rt=ne.get(91),tt=ne.get(61),Ye=ne.get(89),ot=Ye.verticalScrollbarSize,Et=Ye.verticalHasArrows,bt=Ye.arrowSize,_e=Ye.horizontalScrollbarSize,fe=ne.get(54),de=ne.get(35);let X;if(typeof fe=="string"&&/^\d+(\.\d+)?ch$/.test(fe)){const Rt=parseFloat(fe.substr(0,fe.length-2));X=a.clampedInt(Rt*De,0,0,1e3)}else X=a.clampedInt(fe,0,0,1e3);de&&(X+=16);let Fe=0;if(xe){const Rt=Math.max(Xe,Qe);Fe=Math.round(Rt*ye)}let Re=0;Ue&&(Re=We);let Ze=0,et=Ze+Re,ft=et+Fe,ct=ft+X;const it=Oe-Re-Fe-X;let vt=!1,ht=!1,lt=-1;Ie!==2&&(z==="inherit"&&Pe?(vt=!0,ht=!0):Z==="on"||Z==="bounded"?ht=!0:Z==="wordWrapColumn"&&(lt=ue));const mt=V._computeMinimapLayout({outerWidth:Oe,outerHeight:$e,lineHeight:We,typicalHalfwidthCharacterWidth:De,pixelRatio:Ce,scrollBeyondLastLine:rt,minimap:tt,verticalScrollbarWidth:ot,viewLineCount:ae,remainingWidth:it,isViewportWrapping:ht},Ee.memory||new D);mt.renderMinimap!==0&&mt.minimapLeft===0&&(Ze+=mt.minimapWidth,et+=mt.minimapWidth,ft+=mt.minimapWidth,ct+=mt.minimapWidth);const Pt=it-mt.minimapWidth,Ct=Math.max(1,Math.floor((Pt-ot-2)/De)),At=Et?bt:0;return ht&&(lt=Math.max(1,Ct),Z==="bounded"&&(lt=Math.min(lt,ue))),{width:Oe,height:$e,glyphMarginLeft:Ze,glyphMarginWidth:Re,lineNumbersLeft:et,lineNumbersWidth:Fe,decorationsLeft:ft,decorationsWidth:X,contentLeft:ct,contentWidth:Pt,minimap:mt,viewportColumn:Ct,isWordWrapMinified:vt,isViewportWrapping:ht,wrappingColumn:lt,verticalScrollbarWidth:ot,horizontalScrollbarHeight:_e,overviewRuler:{top:At,width:ot,height:$e-2*At,right:0}}}}e.EditorLayoutInfoComputer=V;class W extends I{constructor(){const ne={enabled:!0};super(53,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:w.localize(39,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:d(ne.enabled,this.defaultValue.enabled)}}}class P extends I{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(123,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:w.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,description:w.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,description:w.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:d(Ee.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class N extends a{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:w.localize(43,null)})}compute(ne,Ee,Oe){return ne.fontInfo.lineHeight}}class F extends I{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:w.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(45,null),w.localize(46,null),w.localize(47,null)],default:ne.size,description:w.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:w.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:w.localize(50,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:w.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:w.localize(53,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:d(Ee.enabled,this.defaultValue.enabled),size:v(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(Ee.side,this.defaultValue.side,["right","left"]),showSlider:v(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(Ee.scale,1,1,3),maxColumn:a.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(K){return K==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class B extends I{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(55,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{top:a.clampedInt(Ee.top,0,0,1e3),bottom:a.clampedInt(Ee.bottom,0,0,1e3)}}}class H extends I{constructor(){const ne={enabled:!0,cycle:!1};super(72,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:w.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:w.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:d(Ee.enabled,this.defaultValue.enabled),cycle:d(Ee.cycle,this.defaultValue.cycle)}}}class Q extends i{constructor(){super(125)}compute(ne,Ee,Oe){return ne.pixelRatio}}class le extends I{constructor(){const ne={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:w.localize(58,null)},comments:{type:"boolean",default:ne.comments,description:w.localize(59,null)},other:{type:"boolean",default:ne.other,description:w.localize(60,null)}}}],default:ne,description:w.localize(61,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const Ee=ne,Oe={other:d(Ee.other,this.defaultValue.other),comments:d(Ee.comments,this.defaultValue.comments),strings:d(Ee.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var be;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends I{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(62,null),w.localize(63,null),w.localize(64,null),w.localize(65,null)],default:"on",description:w.localize(66,null)})}validate(ne){let Ee=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(Ee=4,Oe=ne):ne==="interval"?Ee=3:ne==="relative"?Ee=2:ne==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Oe}}}function ke(K){const ne=K.get(84);return ne==="editable"?K.get(77):ne!=="on"}e.filterValidationDecorations=ke;class Ne extends I{constructor(){const ne=[],Ee={type:"number",description:w.localize(67,null)};super(88,"rulers",ne,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:w.localize(68,null),format:"color-hex"}}}]},default:ne,description:w.localize(69,null)})}validate(ne){if(Array.isArray(ne)){let Ee=[];for(let Oe of ne)if(typeof Oe=="number")Ee.push({column:a.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const $e=Oe;Ee.push({column:a.clampedInt($e.column,0,0,1e4),color:$e.color})}return Ee.sort((Oe,$e)=>Oe.column-$e.column),Ee}return this.defaultValue}}function Ke(K,ne){if(typeof K!="string")return ne;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends I{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne,Oe=a.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=a.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ke(Ee.vertical,this.defaultValue.vertical),horizontal:Ke(Ee.horizontal,this.defaultValue.horizontal),useShadows:d(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:a.clampedInt(Ee.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:a.clampedInt(Ee.verticalSliderSize,$e,0,1e3),scrollByPage:d(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}class qe extends I{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showSuggestionPreview:!1,suggestionPreviewExpanded:!0,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(70,null),w.localize(71,null)],default:ne.insertMode,description:w.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:w.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:w.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:w.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:w.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:w.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:w.localize(78,null)},"editor.suggest.showSuggestionPreview":{type:"boolean",default:ne.showSuggestionPreview,description:w.localize(79,null)},"editor.suggest.suggestionPreviewExpanded":{type:"boolean",default:ne.suggestionPreviewExpanded,description:w.localize(80,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:w.localize(81,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(82,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(83,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(84,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(85,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(86,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:w.localize(87,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(88,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(89,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(90,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(91,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(92,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(93,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(94,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(95,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(96,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(97,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(98,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(99,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(100,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(101,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(102,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(103,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(104,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(105,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(106,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(107,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(108,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(109,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(110,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(111,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(112,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{insertMode:v(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:d(Ee.showStatusBar,this.defaultValue.showStatusBar),showSuggestionPreview:d(Ee.showSuggestionPreview,this.defaultValue.showSuggestionPreview),suggestionPreviewExpanded:d(Ee.suggestionPreviewExpanded,this.defaultValue.suggestionPreviewExpanded),showInlineDetails:d(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(Ee.showMethods,this.defaultValue.showMethods),showFunctions:d(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:d(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(Ee.showDeprecated,this.defaultValue.showDeprecated),showFields:d(Ee.showFields,this.defaultValue.showFields),showVariables:d(Ee.showVariables,this.defaultValue.showVariables),showClasses:d(Ee.showClasses,this.defaultValue.showClasses),showStructs:d(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:d(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:d(Ee.showModules,this.defaultValue.showModules),showProperties:d(Ee.showProperties,this.defaultValue.showProperties),showEvents:d(Ee.showEvents,this.defaultValue.showEvents),showOperators:d(Ee.showOperators,this.defaultValue.showOperators),showUnits:d(Ee.showUnits,this.defaultValue.showUnits),showValues:d(Ee.showValues,this.defaultValue.showValues),showConstants:d(Ee.showConstants,this.defaultValue.showConstants),showEnums:d(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:d(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(Ee.showKeywords,this.defaultValue.showKeywords),showWords:d(Ee.showWords,this.defaultValue.showWords),showColors:d(Ee.showColors,this.defaultValue.showColors),showFiles:d(Ee.showFiles,this.defaultValue.showFiles),showReferences:d(Ee.showReferences,this.defaultValue.showReferences),showFolders:d(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:d(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:d(Ee.showUsers,this.defaultValue.showUsers),showIssues:d(Ee.showIssues,this.defaultValue.showIssues)}}}class q extends I{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(113,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class J extends i{constructor(){super(126,[77])}compute(ne,Ee,Oe){return Ee.get(77)?!0:ne.tabFocusMode}}var re;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(re=e.WrappingIndent||(e.WrappingIndent={}));function oe(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Y extends i{constructor(){super(128,[127])}compute(ne,Ee,Oe){const $e=Ee.get(127);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}const ce="Consolas, 'Courier New', monospace",ve="Menlo, Monaco, 'Courier New', monospace",Le="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?ve:R.isLinux?Le:ce,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function we(K){return e.editorOptionsRegistry[K.id]=K,K}var je;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.codeLens=12]="codeLens",K[K.codeLensFontFamily=13]="codeLensFontFamily",K[K.codeLensFontSize=14]="codeLensFontSize",K[K.colorDecorators=15]="colorDecorators",K[K.columnSelection=16]="columnSelection",K[K.comments=17]="comments",K[K.contextmenu=18]="contextmenu",K[K.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",K[K.cursorBlinking=20]="cursorBlinking",K[K.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",K[K.cursorStyle=22]="cursorStyle",K[K.cursorSurroundingLines=23]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",K[K.cursorWidth=25]="cursorWidth",K[K.disableLayerHinting=26]="disableLayerHinting",K[K.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",K[K.domReadOnly=28]="domReadOnly",K[K.dragAndDrop=29]="dragAndDrop",K[K.emptySelectionClipboard=30]="emptySelectionClipboard",K[K.extraEditorClassName=31]="extraEditorClassName",K[K.fastScrollSensitivity=32]="fastScrollSensitivity",K[K.find=33]="find",K[K.fixedOverflowWidgets=34]="fixedOverflowWidgets",K[K.folding=35]="folding",K[K.foldingStrategy=36]="foldingStrategy",K[K.foldingHighlight=37]="foldingHighlight",K[K.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=39]="fontFamily",K[K.fontInfo=40]="fontInfo",K[K.fontLigatures=41]="fontLigatures",K[K.fontSize=42]="fontSize",K[K.fontWeight=43]="fontWeight",K[K.formatOnPaste=44]="formatOnPaste",K[K.formatOnType=45]="formatOnType",K[K.glyphMargin=46]="glyphMargin",K[K.gotoLocation=47]="gotoLocation",K[K.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",K[K.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",K[K.hover=50]="hover",K[K.inDiffEditor=51]="inDiffEditor",K[K.letterSpacing=52]="letterSpacing",K[K.lightbulb=53]="lightbulb",K[K.lineDecorationsWidth=54]="lineDecorationsWidth",K[K.lineHeight=55]="lineHeight",K[K.lineNumbers=56]="lineNumbers",K[K.lineNumbersMinChars=57]="lineNumbersMinChars",K[K.linkedEditing=58]="linkedEditing",K[K.links=59]="links",K[K.matchBrackets=60]="matchBrackets",K[K.minimap=61]="minimap",K[K.mouseStyle=62]="mouseStyle",K[K.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=64]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",K[K.multiCursorModifier=66]="multiCursorModifier",K[K.multiCursorPaste=67]="multiCursorPaste",K[K.occurrencesHighlight=68]="occurrencesHighlight",K[K.overviewRulerBorder=69]="overviewRulerBorder",K[K.overviewRulerLanes=70]="overviewRulerLanes",K[K.padding=71]="padding",K[K.parameterHints=72]="parameterHints",K[K.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",K[K.quickSuggestions=75]="quickSuggestions",K[K.quickSuggestionsDelay=76]="quickSuggestionsDelay",K[K.readOnly=77]="readOnly",K[K.renameOnType=78]="renameOnType",K[K.renderControlCharacters=79]="renderControlCharacters",K[K.renderIndentGuides=80]="renderIndentGuides",K[K.renderFinalNewline=81]="renderFinalNewline",K[K.renderLineHighlight=82]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=84]="renderValidationDecorations",K[K.renderWhitespace=85]="renderWhitespace",K[K.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",K[K.roundedSelection=87]="roundedSelection",K[K.rulers=88]="rulers",K[K.scrollbar=89]="scrollbar",K[K.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=91]="scrollBeyondLastLine",K[K.scrollPredominantAxis=92]="scrollPredominantAxis",K[K.selectionClipboard=93]="selectionClipboard",K[K.selectionHighlight=94]="selectionHighlight",K[K.selectOnLineNumbers=95]="selectOnLineNumbers",K[K.showFoldingControls=96]="showFoldingControls",K[K.showUnused=97]="showUnused",K[K.snippetSuggestions=98]="snippetSuggestions",K[K.smartSelect=99]="smartSelect",K[K.smoothScrolling=100]="smoothScrolling",K[K.stickyTabStops=101]="stickyTabStops",K[K.stopRenderingLineAfter=102]="stopRenderingLineAfter",K[K.suggest=103]="suggest",K[K.suggestFontSize=104]="suggestFontSize",K[K.suggestLineHeight=105]="suggestLineHeight",K[K.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",K[K.suggestSelection=107]="suggestSelection",K[K.tabCompletion=108]="tabCompletion",K[K.tabIndex=109]="tabIndex",K[K.unusualLineTerminators=110]="unusualLineTerminators",K[K.useShadowDOM=111]="useShadowDOM",K[K.useTabStops=112]="useTabStops",K[K.wordSeparators=113]="wordSeparators",K[K.wordWrap=114]="wordWrap",K[K.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=117]="wordWrapColumn",K[K.wordWrapOverride1=118]="wordWrapOverride1",K[K.wordWrapOverride2=119]="wordWrapOverride2",K[K.wrappingIndent=120]="wrappingIndent",K[K.wrappingStrategy=121]="wrappingStrategy",K[K.showDeprecated=122]="showDeprecated",K[K.inlayHints=123]="inlayHints",K[K.editorClassName=124]="editorClassName",K[K.pixelRatio=125]="pixelRatio",K[K.tabFocusMode=126]="tabFocusMode",K[K.layoutInfo=127]="layoutInfo",K[K.wrappingInfo=128]="wrappingInfo"})(je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:we(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(114,null)})),acceptSuggestionOnEnter:we(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(115,null),""],markdownDescription:w.localize(116,null)})),accessibilitySupport:we(new c),accessibilityPageSize:we(new a(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(117,null)})),ariaLabel:we(new E(4,"ariaLabel",w.localize(118,null))),autoClosingBrackets:we(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(119,null),w.localize(120,null),""],description:w.localize(121,null)})),autoClosingDelete:we(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(122,null),""],description:w.localize(123,null)})),autoClosingOvertype:we(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(124,null),""],description:w.localize(125,null)})),autoClosingQuotes:we(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(126,null),w.localize(127,null),""],description:w.localize(128,null)})),autoIndent:we(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[w.localize(129,null),w.localize(130,null),w.localize(131,null),w.localize(132,null),w.localize(133,null)],description:w.localize(134,null)})),automaticLayout:we(new p(10,"automaticLayout",!1)),autoSurround:we(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(135,null),w.localize(136,null),w.localize(137,null),""],description:w.localize(138,null)})),stickyTabStops:we(new p(101,"stickyTabStops",!1,{description:w.localize(139,null)})),codeLens:we(new p(12,"codeLens",!0,{description:w.localize(140,null)})),codeLensFontFamily:we(new E(13,"codeLensFontFamily","",{description:w.localize(141,null)})),codeLensFontSize:we(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:w.localize(142,null)})),colorDecorators:we(new p(15,"colorDecorators",!0,{description:w.localize(143,null)})),columnSelection:we(new p(16,"columnSelection",!1,{description:w.localize(144,null)})),comments:we(new t),contextmenu:we(new p(18,"contextmenu",!0)),copyWithSyntaxHighlighting:we(new p(19,"copyWithSyntaxHighlighting",!0,{description:w.localize(145,null)})),cursorBlinking:we(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:w.localize(146,null)})),cursorSmoothCaretAnimation:we(new p(21,"cursorSmoothCaretAnimation",!1,{description:w.localize(147,null)})),cursorStyle:we(new u(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],g,{description:w.localize(148,null)})),cursorSurroundingLines:we(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(149,null)})),cursorSurroundingLinesStyle:we(new S(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(150,null),w.localize(151,null)],description:w.localize(152,null)})),cursorWidth:we(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(153,null)})),disableLayerHinting:we(new p(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:we(new p(27,"disableMonospaceOptimizations",!1)),domReadOnly:we(new p(28,"domReadOnly",!1)),dragAndDrop:we(new p(29,"dragAndDrop",!0,{description:w.localize(154,null)})),emptySelectionClipboard:we(new _),extraEditorClassName:we(new E(31,"extraEditorClassName","")),fastScrollSensitivity:we(new h(32,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:w.localize(155,null)})),find:we(new b),fixedOverflowWidgets:we(new p(34,"fixedOverflowWidgets",!1)),folding:we(new p(35,"folding",!0,{description:w.localize(156,null)})),foldingStrategy:we(new S(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(157,null),w.localize(158,null)],description:w.localize(159,null)})),foldingHighlight:we(new p(37,"foldingHighlight",!0,{description:w.localize(160,null)})),unfoldOnClickAfterEndOfLine:we(new p(38,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(161,null)})),fontFamily:we(new E(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(162,null)})),fontInfo:we(new L),fontLigatures2:we(new l),fontSize:we(new O),fontWeight:we(new $),formatOnPaste:we(new p(44,"formatOnPaste",!1,{description:w.localize(163,null)})),formatOnType:we(new p(45,"formatOnType",!1,{description:w.localize(164,null)})),glyphMargin:we(new p(46,"glyphMargin",!0,{description:w.localize(165,null)})),gotoLocation:we(new ie),hideCursorInOverviewRuler:we(new p(48,"hideCursorInOverviewRuler",!1,{description:w.localize(166,null)})),highlightActiveIndentGuide:we(new p(49,"highlightActiveIndentGuide",!0,{description:w.localize(167,null)})),hover:we(new se),inDiffEditor:we(new p(51,"inDiffEditor",!1)),letterSpacing:we(new h(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>h.clamp(K,-5,20),{description:w.localize(168,null)})),lightbulb:we(new W),lineDecorationsWidth:we(new A(54,"lineDecorationsWidth",10)),lineHeight:we(new N),lineNumbers:we(new Te),lineNumbersMinChars:we(new a(57,"lineNumbersMinChars",5,1,300)),linkedEditing:we(new p(58,"linkedEditing",!1,{description:w.localize(169,null)})),links:we(new p(59,"links",!0,{description:w.localize(170,null)})),matchBrackets:we(new S(60,"matchBrackets","always",["always","near","never"],{description:w.localize(171,null)})),minimap:we(new F),mouseStyle:we(new S(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:we(new h(63,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:w.localize(172,null)})),mouseWheelZoom:we(new p(64,"mouseWheelZoom",!1,{markdownDescription:w.localize(173,null)})),multiCursorMergeOverlapping:we(new p(65,"multiCursorMergeOverlapping",!0,{description:w.localize(174,null)})),multiCursorModifier:we(new u(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[w.localize(175,null),w.localize(176,null)],markdownDescription:w.localize(177,null)})),multiCursorPaste:we(new S(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(178,null),w.localize(179,null)],markdownDescription:w.localize(180,null)})),occurrencesHighlight:we(new p(68,"occurrencesHighlight",!0,{description:w.localize(181,null)})),overviewRulerBorder:we(new p(69,"overviewRulerBorder",!0,{description:w.localize(182,null)})),overviewRulerLanes:we(new a(70,"overviewRulerLanes",3,0,3)),padding:we(new B),parameterHints:we(new H),peekWidgetDefaultFocus:we(new S(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(183,null),w.localize(184,null)],description:w.localize(185,null)})),definitionLinkOpensInPeek:we(new p(74,"definitionLinkOpensInPeek",!1,{description:w.localize(186,null)})),quickSuggestions:we(new le),quickSuggestionsDelay:we(new a(76,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(187,null)})),readOnly:we(new p(77,"readOnly",!1)),renameOnType:we(new p(78,"renameOnType",!1,{description:w.localize(188,null),markdownDeprecationMessage:w.localize(189,null)})),renderControlCharacters:we(new p(79,"renderControlCharacters",!1,{description:w.localize(190,null)})),renderIndentGuides:we(new p(80,"renderIndentGuides",!0,{description:w.localize(191,null)})),renderFinalNewline:we(new p(81,"renderFinalNewline",!0,{description:w.localize(192,null)})),renderLineHighlight:we(new S(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(193,null)],description:w.localize(194,null)})),renderLineHighlightOnlyWhenFocus:we(new p(83,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(195,null)})),renderValidationDecorations:we(new S(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:we(new S(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(196,null),w.localize(197,null),w.localize(198,null),""],description:w.localize(199,null)})),revealHorizontalRightPadding:we(new a(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:we(new p(87,"roundedSelection",!0,{description:w.localize(200,null)})),rulers:we(new Ne),scrollbar:we(new ze),scrollBeyondLastColumn:we(new a(90,"scrollBeyondLastColumn",5,0,1073741824,{description:w.localize(201,null)})),scrollBeyondLastLine:we(new p(91,"scrollBeyondLastLine",!0,{description:w.localize(202,null)})),scrollPredominantAxis:we(new p(92,"scrollPredominantAxis",!0,{description:w.localize(203,null)})),selectionClipboard:we(new p(93,"selectionClipboard",!0,{description:w.localize(204,null),included:R.isLinux})),selectionHighlight:we(new p(94,"selectionHighlight",!0,{description:w.localize(205,null)})),selectOnLineNumbers:we(new p(95,"selectOnLineNumbers",!0)),showFoldingControls:we(new S(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[w.localize(206,null),w.localize(207,null)],description:w.localize(208,null)})),showUnused:we(new p(97,"showUnused",!0,{description:w.localize(209,null)})),showDeprecated:we(new p(122,"showDeprecated",!0,{description:w.localize(210,null)})),inlayHints:we(new P),snippetSuggestions:we(new S(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(211,null),w.localize(212,null),w.localize(213,null),w.localize(214,null)],description:w.localize(215,null)})),smartSelect:we(new q),smoothScrolling:we(new p(100,"smoothScrolling",!1,{description:w.localize(216,null)})),stopRenderingLineAfter:we(new a(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:we(new qe),suggestFontSize:we(new a(104,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(217,null)})),suggestLineHeight:we(new a(105,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(218,null)})),suggestOnTriggerCharacters:we(new p(106,"suggestOnTriggerCharacters",!0,{description:w.localize(219,null)})),suggestSelection:we(new S(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(220,null),w.localize(221,null),w.localize(222,null)],description:w.localize(223,null)})),tabCompletion:we(new S(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(224,null),w.localize(225,null),w.localize(226,null)],description:w.localize(227,null)})),tabIndex:we(new a(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:we(new S(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(228,null),w.localize(229,null),w.localize(230,null)],description:w.localize(231,null)})),useShadowDOM:we(new p(111,"useShadowDOM",!0)),useTabStops:we(new p(112,"useTabStops",!0,{description:w.localize(232,null)})),wordSeparators:we(new E(113,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:w.localize(233,null)})),wordWrap:we(new S(114,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(234,null),w.localize(235,null),w.localize(236,null),w.localize(237,null)],description:w.localize(238,null)})),wordWrapBreakAfterCharacters:we(new E(115,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:we(new E(116,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:we(new a(117,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(239,null)})),wordWrapOverride1:we(new S(118,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:we(new S(119,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:we(new u(120,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],oe,{enumDescriptions:[w.localize(240,null),w.localize(241,null),w.localize(242,null),w.localize(243,null)],description:w.localize(244,null)})),wrappingStrategy:we(new S(121,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[w.localize(245,null),w.localize(246,null)],description:w.localize(247,null)})),editorClassName:we(new m),pixelRatio:we(new Q),tabFocusMode:we(new J),layoutInfo:we(new V),wrappingInfo:we(new Y)}}),define(ge[153],pe([18,19]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[154],pe([18,19]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[155],pe([18,19]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[156],pe([18,19]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ge[157],pe([18,19]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ge[158],pe([18,19]),function(G,e){return G.create("vs/platform/markers/common/markers",e)}),define(ge[159],pe([18,19]),function(G,e){return G.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[160],pe([18,19]),function(G,e){return G.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[161],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[162],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[163],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[164],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[165],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[166],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[167],pe([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[168],pe([18,19]),function(G,e){return G.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[169],pe([18,19]),function(G,e){return G.create("vs/workbench/common/views",e)}),define(ge[170],pe([18,19]),function(G,e){return G.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[171],pe([18,19]),function(G,e){return G.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[172],pe([18,19]),function(G,e){return G.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[173],pe([18,19]),function(G,e){return G.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[174],pe([18,19]),function(G,e){return G.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[175],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var w;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(w=e.EditorActivation||(e.EditorActivation={}));var R;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var C;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[176],pe([0,1,155]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function T(d){return d=d.trim(),d==="*"||R.test(d)}e.isValidVersionStr=T;function y(d){if(!T(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=d.match(R);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=y;function k(d){if(!d)return null;let p=d.majorBase,a=d.majorMustEqual,h=d.minorBase,E=d.minorMustEqual,v=d.patchBase,S=d.patchMustEqual;d.hasCaret&&(p===0||(E=!1),S=!1);let u=0;if(d.preRelease){const f=C.exec(d.preRelease);if(f){const[,c,t,n]=f;u=Date.UTC(Number(c),Number(t)-1,Number(n))}}return{majorBase:p,majorMustEqual:a,minorBase:h,minorMustEqual:E,patchBase:v,patchMustEqual:S,isMinimum:d.hasGreaterEquals,notBefore:u}}e.normalizeVersion=k;function D(d,p,a){let h;typeof d=="string"?h=k(y(d)):h=d;let E;p instanceof Date?E=p.getTime():typeof p=="string"&&(E=new Date(p).getTime());let v;if(typeof a=="string"?v=k(y(a)):v=a,!h||!v)return!1;let S=h.majorBase,u=h.minorBase,f=h.patchBase,c=v.majorBase,t=v.minorBase,n=v.patchBase,s=v.notBefore,r=v.majorMustEqual,o=v.minorMustEqual,g=v.patchMustEqual;return v.isMinimum?S>c?!0:S<c?!1:u>t?!0:u<t||E&&E<s?!1:f>=n:(S===1&&c===0&&(!r||!o||!g)&&(c=1,t=0,n=0,r=!0,o=!1,g=!1),S<c?!1:S>c?!r:u<t?!1:u>t?!o:f<n?!1:f>n?!g:!(E&&E<s))}e.isValidVersion=D;function I(d,p,a,h){return a.isBuiltin||typeof a.main=="undefined"?!0:A(d,p,a.engines.vscode,h)}e.isValidExtensionVersion=I;function i(d,p,a){return d==="*"||A(p,a,d)}e.isEngineValid=i;function A(d,p,a,h=[]){let E=k(y(a));if(!E)return h.push(w.localize(0,null,a)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return h.push(w.localize(1,null,a)),!1}else if(!E.majorMustEqual)return h.push(w.localize(2,null,a)),!1;return D(d,p,E)?!0:(h.push(w.localize(3,null,d,a)),!1)}}),define(ge[111],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class w{constructor(T,y=[],k=!1){this.ctor=T,this.staticArguments=y,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=w;const R=(C,...T)=>new w(C,T);e.createSyncDescriptor=R}),define(ge[79],pe([0,1,111]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function C(y,k,D){k instanceof w.SyncDescriptor||(k=new w.SyncDescriptor(k,[],D)),R.push([y,k])}e.registerSingleton=C;function T(){return R}e.getSingletonServiceDescriptors=T}),define(ge[177],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=w;class R{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let y of this._nodes.values())y.outgoing.size===0&&T.push(y);return T}insertEdge(T,y){const k=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(y);k.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(T),k)}removeNode(T){const y=this._hashFn(T);this._nodes.delete(y);for(let k of this._nodes.values())k.outgoing.delete(y),k.incoming.delete(y)}lookupOrInsertNode(T){const y=this._hashFn(T);let k=this._nodes.get(y);return k||(k=new w(T),this._nodes.set(y,k)),k}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[y,k]of this._nodes)T.push(`${y}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,y]of this._nodes){const k=new Set([T]),D=this._findCycle(y,k);if(D)return D}}_findCycle(T,y){for(let[k,D]of T.outgoing){if(y.has(k))return[...y,k].join(" -> ");y.add(k);const I=this._findCycle(D,y);if(I)return I;y.delete(k)}}}e.Graph=R}),define(ge[4],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function D(I){return I[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=D})(w=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function R(k,D,I,i){D[w.DI_TARGET]===D?D[w.DI_DEPENDENCIES].push({id:k,index:I,optional:i}):(D[w.DI_DEPENDENCIES]=[{id:k,index:I,optional:i}],D[w.DI_TARGET]=D)}function C(k){if(w.serviceIds.has(k))return w.serviceIds.get(k);const D=function(I,i,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(D,I,A,!1)};return D.toString=()=>k,w.serviceIds.set(k,D),D}e.createDecorator=C;function T(k){return k}e.refineServiceDecorator=T;function y(k){return function(D,I,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(k,D,i,!0)}}e.optional=y}),define(ge[178],pe([0,1,4]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,w.createDecorator)("modelService");function R(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(ge[179],pe([0,1,3,75,6,22,74,78,178]),function(G,e,w,R,C,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function I(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(I):!!d.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new w.Emitter}get onDidChange(){return this._onDidChange.event}register(p,a){let h={selector:p,provider:a,_score:-1,_time:this._clock++};return this._entries.push(h),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,C.toDisposable)(()=>{if(h){let E=this._entries.indexOf(h);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),h=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const a=[];for(let h of this._entries)h._score>0&&a.push(h.provider);return a}ordered(p){const a=[];return this._orderedForEach(p,h=>a.push(h.provider)),a}orderedGroups(p){const a=[];let h,E;return this._orderedForEach(p,v=>{h&&E===v._score?h.push(v.provider):(E=v._score,h=[v.provider],a.push(h))}),a}_orderedForEach(p,a){if(!!p){this._updateScores(p);for(const h of this._entries)h._score>0&&a(h)}}_updateScores(p){let a={uri:p.uri.toString(),language:p.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let h of this._entries)if(h._score=(0,k.score)(h.selector,p.uri,p.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(p)),I(h.selector)&&h._score>0){for(let E of this._entries)E._score=0;h._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(p,a){return p._score<a._score?1:p._score>a._score?-1:p._time<a._time?1:p._time>a._time?-1:0}}e.LanguageFeatureRegistry=i;class A{constructor(p,a,h=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=a,this.max=h,this._cache=new T.LRUCache(50,.7)}_key(p){return p.id+(0,R.hash)(this._registry.all(p))}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const a=this._key(p),h=this._cache.get(a);return this._clamp(h==null?void 0:h.value)}update(p,a){const h=this._key(p);let E=this._cache.get(h);return E||(E=new y.MovingAverage,this._cache.set(h,E)),E.update(a),this.get(p)}}e.LanguageFeatureRequestDelays=A}),define(ge[80],pe([0,1,2,42,179,145,45]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(l){l[l.Null=0]="Null",l[l.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class D{constructor(L,O){this.language=L,this.id=O}}e.LanguageIdentifier=D;var I;(function(l){l[l.NotSet=-1]="NotSet",l[l.None=0]="None",l[l.Italic=1]="Italic",l[l.Bold=2]="Bold",l[l.Underline=4]="Underline"})(I=e.FontStyle||(e.FontStyle={}));var i;(function(l){l[l.None=0]="None",l[l.DefaultForeground=1]="DefaultForeground",l[l.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var A;(function(l){l[l.Other=0]="Other",l[l.Comment=1]="Comment",l[l.String=2]="String",l[l.RegEx=4]="RegEx"})(A=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(l){l[l.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",l[l.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",l[l.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",l[l.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",l[l.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",l[l.ITALIC_MASK=2048]="ITALIC_MASK",l[l.BOLD_MASK=4096]="BOLD_MASK",l[l.UNDERLINE_MASK=8192]="UNDERLINE_MASK",l[l.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",l[l.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",l[l.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",l[l.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",l[l.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",l[l.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",l[l.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",l[l.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",l[l.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",l[l.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class p{static getLanguageId(L){return(L&255)>>>0}static getTokenType(L){return(L&1792)>>>8}static getFontStyle(L){return(L&14336)>>>11}static getForeground(L){return(L&8372224)>>>14}static getBackground(L){return(L&4286578688)>>>23}static getClassNameFromMetadata(L){let O=this.getForeground(L),$="mtk"+O,ie=this.getFontStyle(L);return ie&1&&($+=" mtki"),ie&2&&($+=" mtkb"),ie&4&&($+=" mtku"),$}static getInlineStyleFromMetadata(L,O){const $=this.getForeground(L),ie=this.getFontStyle(L);let se=`color: ${O[$]};`;return ie&1&&(se+="font-style: italic;"),ie&2&&(se+="font-weight: bold;"),ie&4&&(se+="text-decoration: underline;"),se}}e.TokenMetadata=p;var a;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let l=Object.create(null);return l[0]="symbol-method",l[1]="symbol-function",l[2]="symbol-constructor",l[3]="symbol-field",l[4]="symbol-variable",l[5]="symbol-class",l[6]="symbol-struct",l[7]="symbol-interface",l[8]="symbol-module",l[9]="symbol-property",l[10]="symbol-event",l[11]="symbol-operator",l[12]="symbol-unit",l[13]="symbol-value",l[14]="symbol-constant",l[15]="symbol-enum",l[16]="symbol-enum-member",l[17]="symbol-keyword",l[27]="symbol-snippet",l[18]="symbol-text",l[19]="symbol-color",l[20]="symbol-file",l[21]="symbol-reference",l[22]="symbol-customcolor",l[23]="symbol-folder",l[24]="symbol-type-parameter",l[25]="account",l[26]="issues",function(L){const O=l[L];let $=O&&y.iconRegistry.get(O);return $||(console.info("No codicon found for CompletionItemKind "+L),$=y.Codicon.symbolProperty),$.classNames}}(),e.completionKindFromString=function(){let l=Object.create(null);return l.method=0,l.function=1,l.constructor=2,l.field=3,l.variable=4,l.class=5,l.struct=6,l.interface=7,l.module=8,l.property=9,l.event=10,l.operator=11,l.unit=12,l.value=13,l.constant=14,l.enum=15,l["enum-member"]=16,l.enumMember=16,l.keyword=17,l.snippet=27,l.text=18,l.color=19,l.file=20,l.reference=21,l.customcolor=22,l.folder=23,l["type-parameter"]=24,l.typeParameter=24,l.account=25,l.issue=26,function(L,O){let $=l[L];return typeof $=="undefined"&&!O&&($=9),$}}();var h;(function(l){l[l.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(l){return l&&w.URI.isUri(l.uri)&&R.Range.isIRange(l.range)&&(R.Range.isIRange(l.originSelectionRange)||R.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=t;var n;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var s;(function(l){l[l.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var r;(function(l){const L=new Map;L.set("file",0),L.set("module",1),L.set("namespace",2),L.set("package",3),L.set("class",4),L.set("method",5),L.set("property",6),L.set("field",7),L.set("constructor",8),L.set("enum",9),L.set("interface",10),L.set("function",11),L.set("variable",12),L.set("constant",13),L.set("string",14),L.set("number",15),L.set("boolean",16),L.set("array",17),L.set("object",18),L.set("key",19),L.set("null",20),L.set("enum-member",21),L.set("struct",22),L.set("event",23),L.set("operator",24),L.set("type-parameter",25);const O=new Map;O.set(0,"file"),O.set(1,"module"),O.set(2,"namespace"),O.set(3,"package"),O.set(4,"class"),O.set(5,"method"),O.set(6,"property"),O.set(7,"field"),O.set(8,"constructor"),O.set(9,"enum"),O.set(10,"interface"),O.set(11,"function"),O.set(12,"variable"),O.set(13,"constant"),O.set(14,"string"),O.set(15,"number"),O.set(16,"boolean"),O.set(17,"array"),O.set(18,"object"),O.set(19,"key"),O.set(20,"null"),O.set(21,"enum-member"),O.set(22,"struct"),O.set(23,"event"),O.set(24,"operator"),O.set(25,"type-parameter");function $(U){return L.get(U)}l.fromString=$;function ie(U){return O.get(U)}l.toString=ie;function se(U,V){const W=O.get(U);let P=W&&y.iconRegistry.get("symbol-"+W);return P||(console.info("No codicon found for SymbolKind "+U),P=y.Codicon.symbolProperty),`${V?"inline":"block"} ${P.classNames}`}l.toCssClassName=se})(r=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(L){this.value=L}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var g;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(g=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var _;(function(l){l[l.Other=0]="Other",l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(_=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var b;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[180],pe([0,1,6,12,4,3,56,54]),function(G,e,w,R,C,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,C.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,I){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!I)throw new Error("invalid command");return this.registerCommand({id:D,handler:I})}if(D.description){const a=[];for(let E of D.description.args)a.push(E.constraint);const h=D.handler;D.handler=function(E,...v){return(0,R.validateConstraints)(v,a),h(E,...v)}}const{id:i}=D;let A=this._commands.get(i);A||(A=new y.LinkedList,this._commands.set(i,A));let d=A.unshift(D),p=(0,w.toDisposable)(()=>{d();const a=this._commands.get(i);(a==null?void 0:a.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),p}registerCommandAlias(D,I){return e.CommandsRegistry.registerCommand(D,(i,...A)=>i.get(e.ICommandService).executeCommand(I,...A))}getCommand(D){const I=this._commands.get(D);if(!(!I||I.isEmpty()))return k.Iterable.first(I)}getCommands(){const D=new Map;for(const I of this._commands.keys()){const i=this.getCommand(I);i&&D.set(I,i)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>w.Disposable.None,onDidExecuteCommand:()=>w.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(ge[81],pe([0,1,8,4,11]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=C.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",C.isMacintosh),y.set("isLinux",C.isLinux),y.set("isWindows",C.isWindows),y.set("isWeb",C.isWeb),y.set("isMacNative",C.isMacintosh&&!C.isWeb),y.set("isEdge",T.indexOf("Edg/")>=0),y.set("isFirefox",T.indexOf("Firefox")>=0),y.set("isChrome",T.indexOf("Chrome")>=0),y.set("isSafari",T.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var D;(function(b){b[b.False=0]="False",b[b.True=1]="True",b[b.Defined=2]="Defined",b[b.Not=3]="Not",b[b.Equals=4]="Equals",b[b.NotEquals=5]="NotEquals",b[b.And=6]="And",b[b.Regex=7]="Regex",b[b.NotRegex=8]="NotRegex",b[b.Or=9]="Or",b[b.In=10]="In",b[b.NotIn=11]="NotIn",b[b.Greater=12]="Greater",b[b.GreaterEquals=13]="GreaterEquals",b[b.Smaller=14]="Smaller",b[b.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return A.INSTANCE}static true(){return d.INSTANCE}static has(l){return p.create(l)}static equals(l,L){return a.create(l,L)}static notEquals(l,L){return v.create(l,L)}static regex(l,L){return n.create(l,L)}static in(l,L){return h.create(l,L)}static not(l){return S.create(l)}static and(...l){return r.create(l)}static or(...l){return o.create(l)}static greater(l,L){return u.create(l,L)}static less(l,L){return c.create(l,L)}static deserialize(l,L=!1){if(!!l)return this._deserializeOrExpression(l,L)}static _deserializeOrExpression(l,L){let O=l.split("||");return o.create(O.map($=>this._deserializeAndExpression($,L)))}static _deserializeAndExpression(l,L){let O=l.split("&&");return r.create(O.map($=>this._deserializeOne($,L)))}static _deserializeOne(l,L){if(l=l.trim(),l.indexOf("!=")>=0){let O=l.split("!=");return v.create(O[0].trim(),this._deserializeValue(O[1],L))}if(l.indexOf("==")>=0){let O=l.split("==");return a.create(O[0].trim(),this._deserializeValue(O[1],L))}if(l.indexOf("=~")>=0){let O=l.split("=~");return n.create(O[0].trim(),this._deserializeRegexValue(O[1],L))}if(l.indexOf(" in ")>=0){let O=l.split(" in ");return h.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(l)){const O=l.split(">=");return f.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(l)){const O=l.split(">");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(l)){const O=l.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(l)){const O=l.split("<");return c.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(l)?S.create(l.substr(1).trim()):p.create(l)}static _deserializeValue(l,L){if(l=l.trim(),l==="true")return!0;if(l==="false")return!1;let O=/^'([^']*)'$/.exec(l);return O?O[1].trim():l}static _deserializeRegexValue(l,L){if((0,w.isFalsyOrWhitespace)(l)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=l.indexOf("/"),$=l.lastIndexOf("/");if(O===$||O<0){if(L)throw new Error(`bad regexp-value '${l}', missing /-enclosure`);return console.warn(`bad regexp-value '${l}', missing /-enclosure`),null}let ie=l.slice(O+1,$),se=l[$+1]==="i"?"i":"";try{return new RegExp(ie,se)}catch(U){if(L)throw new Error(`bad regexp-value '${l}', parse error: ${U}`);return console.warn(`bad regexp-value '${l}', parse error: ${U}`),null}}}e.ContextKeyExpr=I;function i(b,l){return b.cmp(l)}class A{constructor(){this.type=0}cmp(l){return this.type-l.type}equals(l){return l.type===this.type}evaluate(l){return!1}serialize(){return"false"}keys(){return[]}map(l){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=A,A.INSTANCE=new A;class d{constructor(){this.type=1}cmp(l){return this.type-l.type}equals(l){return l.type===this.type}evaluate(l){return!0}serialize(){return"true"}keys(){return[]}map(l){return this}negate(){return A.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class p{constructor(l){this.key=l,this.type=2}static create(l){const L=y.get(l);return typeof L=="boolean"?L?d.INSTANCE:A.INSTANCE:new p(l)}cmp(l){return l.type!==this.type?this.type-l.type:m(this.key,l.key)}equals(l){return l.type===this.type?this.key===l.key:!1}evaluate(l){return!!l.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(l){return l.mapDefined(this.key)}negate(){return S.create(this.key)}}e.ContextKeyDefinedExpr=p;class a{constructor(l,L){this.key=l,this.value=L,this.type=4}static create(l,L){if(typeof L=="boolean")return L?p.create(l):S.create(l);const O=y.get(l);return typeof O=="boolean"?L===(O?"true":"false")?d.INSTANCE:A.INSTANCE:new a(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:_(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return l.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(l){return l.mapEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class h{constructor(l,L){this.key=l,this.valueKey=L,this.type=10}static create(l,L){return new h(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:_(this.key,this.valueKey,l.key,l.valueKey)}equals(l){return l.type===this.type?this.key===l.key&&this.valueKey===l.valueKey:!1}evaluate(l){const L=l.getValue(this.valueKey),O=l.getValue(this.key);return Array.isArray(L)?L.indexOf(O)>=0:typeof O=="string"&&typeof L=="object"&&L!==null?k.call(L,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(l){return l.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=h;class E{constructor(l){this._actual=l,this.type=11}static create(l){return new E(l)}cmp(l){return l.type!==this.type?this.type-l.type:this._actual.cmp(l._actual)}equals(l){return l.type===this.type?this._actual.equals(l._actual):!1}evaluate(l){return!this._actual.evaluate(l)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(l){return new E(this._actual.map(l))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class v{constructor(l,L){this.key=l,this.value=L,this.type=5}static create(l,L){if(typeof L=="boolean")return L?S.create(l):p.create(l);const O=y.get(l);return typeof O=="boolean"?L===(O?"true":"false")?A.INSTANCE:d.INSTANCE:new v(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:_(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return l.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(l){return l.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=v;class S{constructor(l){this.key=l,this.type=3}static create(l){const L=y.get(l);return typeof L=="boolean"?L?A.INSTANCE:d.INSTANCE:new S(l)}cmp(l){return l.type!==this.type?this.type-l.type:m(this.key,l.key)}equals(l){return l.type===this.type?this.key===l.key:!1}evaluate(l){return!l.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(l){return l.mapNot(this.key)}negate(){return p.create(this.key)}}e.ContextKeyNotExpr=S;class u{constructor(l,L){this.key=l,this.value=L,this.type=12}static create(l,L){return new u(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:_(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(l){return l.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class f{constructor(l,L){this.key=l,this.value=L,this.type=13}static create(l,L){return new f(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:_(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(l){return l.mapGreaterEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=f;class c{constructor(l,L){this.key=l,this.value=L,this.type=14}static create(l,L){return new c(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:_(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(l){return l.mapSmaller(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerExpr=c;class t{constructor(l,L){this.key=l,this.value=L,this.type=15}static create(l,L){return new t(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:_(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(l){return l.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(l,L){this.key=l,this.regexp=L,this.type=7}static create(l,L){return new n(l,L)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.key<l.key)return-1;if(this.key>l.key)return 1;const L=this.regexp?this.regexp.source:"",O=l.regexp?l.regexp.source:"";return L<O?-1:L>O?1:0}equals(l){if(l.type===this.type){const L=this.regexp?this.regexp.source:"",O=l.regexp?l.regexp.source:"";return this.key===l.key&&L===O}return!1}evaluate(l){let L=l.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const l=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${l}`}keys(){return[this.key]}map(l){return l.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=n;class s{constructor(l){this._actual=l,this.type=8}static create(l){return new s(l)}cmp(l){return l.type!==this.type?this.type-l.type:this._actual.cmp(l._actual)}equals(l){return l.type===this.type?this._actual.equals(l._actual):!1}evaluate(l){return!this._actual.evaluate(l)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(l){return new s(this._actual.map(l))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class r{constructor(l){this.expr=l,this.type=6}static create(l){return r._normalizeArr(l)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.expr.length<l.expr.length)return-1;if(this.expr.length>l.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const $=i(this.expr[L],l.expr[L]);if($!==0)return $}return 0}equals(l){if(l.type===this.type){if(this.expr.length!==l.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(l.expr[L]))return!1;return!0}return!1}evaluate(l){for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].evaluate(l))return!1;return!0}static _normalizeArr(l){const L=[];let O=!1;for(const $ of l)if(!!$){if($.type===1){O=!0;continue}if($.type===0)return A.INSTANCE;if($.type===6){L.push(...$.expr);continue}L.push($)}if(L.length===0&&O)return d.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];for(L.sort(i);L.length>1;){const $=L[L.length-1];if($.type!==9)break;L.pop();const ie=L.pop(),se=o.create($.expr.map(U=>r.create([U,ie])));se&&(L.push(se),L.sort(i))}return L.length===1?L[0]:new r(L)}}serialize(){return this.expr.map(l=>l.serialize()).join(" && ")}keys(){const l=[];for(let L of this.expr)l.push(...L.keys());return l}map(l){return new r(this.expr.map(L=>L.map(l)))}negate(){let l=[];for(let L of this.expr)l.push(L.negate());return o.create(l)}}e.ContextKeyAndExpr=r;class o{constructor(l){this.expr=l,this.type=9}static create(l){const L=o._normalizeArr(l);if(L.length!==0)return L.length===1?L[0]:new o(L)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.expr.length<l.expr.length)return-1;if(this.expr.length>l.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const $=i(this.expr[L],l.expr[L]);if($!==0)return $}return 0}equals(l){if(l.type===this.type){if(this.expr.length!==l.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(l.expr[L]))return!1;return!0}return!1}evaluate(l){for(let L=0,O=this.expr.length;L<O;L++)if(this.expr[L].evaluate(l))return!0;return!1}static _normalizeArr(l){let L=[],O=!1;if(l){for(let $=0,ie=l.length;$<ie;$++){const se=l[$];if(!!se){if(se.type===0){O=!0;continue}if(se.type===1)return[d.INSTANCE];if(se.type===9){L=L.concat(se.expr);continue}L.push(se)}}if(L.length===0&&O)return[A.INSTANCE];L.sort(i)}return L}serialize(){return this.expr.map(l=>l.serialize()).join(" || ")}keys(){const l=[];for(let L of this.expr)l.push(...L.keys());return l}map(l){return new o(this.expr.map(L=>L.map(l)))}negate(){let l=[];for(let O of this.expr)l.push(O.negate());const L=O=>O.type===9?O.expr:[O];for(;l.length>1;){const O=l.shift(),$=l.shift(),ie=[];for(const se of L(O))for(const U of L($))ie.push(I.and(se,U));l.unshift(I.or(...ie))}return l[0]}}e.ContextKeyOrExpr=o;class g extends p{constructor(l,L,O){super(l);this._defaultValue=L,typeof O=="object"?g._info.push(Object.assign(Object.assign({},O),{key:l})):O!==!0&&g._info.push({key:l,description:O,type:L!=null?typeof L:void 0})}static all(){return g._info.values()}bindTo(l){return l.createKey(this.key,this._defaultValue)}getValue(l){return l.getContextKeyValue(this.key)}toNegated(){return I.not(this.key)}isEqualTo(l){return I.equals(this.key,l)}notEqualsTo(l){return I.notEquals(this.key,l)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(b,l){return b<l?-1:b>l?1:0}function _(b,l,L,O){return b<L?-1:b>L?1:l<O?-1:l>O?1:0}}),define(ge[181],pe([0,1,4]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[182],pe([0,1,154,4,10]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function T(A){return A&&typeof A=="object"&&typeof A.id=="string"&&(!A.uuid||typeof A.uuid=="string")}e.isIExtensionIdentifier=T;var y;(function(A){A[A.NoneOrRelevance=0]="NoneOrRelevance",A[A.LastUpdatedDate=1]="LastUpdatedDate",A[A.Title=2]="Title",A[A.PublisherName=3]="PublisherName",A[A.InstallCount=4]="InstallCount",A[A.PublishedDate=5]="PublishedDate",A[A.AverageRating=6]="AverageRating",A[A.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var k;(function(A){A[A.Default=0]="Default",A[A.Ascending=1]="Ascending",A[A.Descending=2]="Descending"})(k=e.SortOrder||(e.SortOrder={}));var D;(function(A){A.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var I;(function(A){A[A.None=0]="None",A[A.Install=1]="Install",A[A.Update=2]="Update"})(I=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(d,p){super(d);this.code=p}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,w.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(ge[26],pe([0,1,8,4]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function C(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkpaceSupportTypeMessage=C;function T(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));class k{constructor(A){this.value=A,this._lower=A.toLowerCase()}static equals(A,d){if(typeof A=="undefined"||A===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof A=="string"||typeof d=="string"){let p=typeof A=="string"?A:A.value,a=typeof d=="string"?d:d.value;return w.equalsIgnoreCase(p,a)}return A._lower===d._lower}static toKey(A){return typeof A=="string"?A.toLowerCase():A._lower}}e.ExtensionIdentifier=k;function D(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function I(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=I,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[183],pe([0,1,8,26]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(p,a){return p.uuid&&a.uuid?p.uuid===a.uuid:p.id===a.id?!0:(0,w.compareIgnoreCase)(p.id,a.id)===0}e.areSameExtensions=C;class T{constructor(a,h){this.version=h,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof T?C(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=T;function y(p,a){return`${p}.${a}`}e.getExtensionId=y;function k(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function D(p,a){return k(y(p,a))}e.getGalleryExtensionId=D;function I(p,a){const h=[],E=v=>{for(const S of h)if(S.some(u=>C(a(u),a(v))))return S;return null};for(const v of p){const S=E(v);S?S.push(v):h.push([v])}return h}e.groupByExtension=I;function i(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function A(p){return Object.assign({id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0)},p.telemetryData)}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(p){const a=new Set;for(const h of p)h.malicious&&a.add(h.id.id);return a}e.getMaliciousExtensionsSet=d}),define(ge[184],pe([0,1,4]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,w.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,w.createDecorator)("externalTerminal")}),define(ge[43],pe([0,1,157,9,2,4,8,12,22]),function(G,e,w,R,C,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function I(U){return U.create===!0}e.isFileOpenForWriteOptions=I;var i;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var A;(function(U){U[U.Readonly=1]="Readonly"})(A=e.FilePermission||(e.FilePermission={}));var d;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=p;function a(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=a;function h(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function E(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=E;var v;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(V,W){super(V);this.code=W}}e.FileSystemProviderError=S;function u(U,V){const W=new S(U.toString(),V);return c(W,V),W}e.createFileSystemProviderError=u;function f(U){return U||u((0,w.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=f;function c(U,V){return U.name=V?`${V} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=c;function t(U){if(!U)return v.Unknown;if(U instanceof S)return U.code;const V=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!V)return v.Unknown;switch(V[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=t;function n(U){if(U instanceof _)return U.fileOperationResult;switch(t(U)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(V,W,P){this.resource=V,this.operation=W,this.target=P}isOperation(V){return this.operation===V}}e.FileOperationEvent=r;var o;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class g{constructor(V,W){this.ignorePathCasing=W,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=V;for(const P of V)switch(P.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(P.resource,P);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(P.resource,P);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(P.resource,P);break}}contains(V,...W){return this.doContains(V,{includeChildren:!1},...W)}affects(V,...W){return this.doContains(V,{includeChildren:!0},...W)}doContains(V,W,...P){var N,F,M,B,H,Q;if(!V)return!1;const le=P.length>0;return!!((!le||P.includes(1))&&(((N=this.added)===null||N===void 0?void 0:N.get(V))||W.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(V)))||(!le||P.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(V))||W.includeChildren&&((B=this.updated)===null||B===void 0?void 0:B.findSuperstr(V)))||(!le||P.includes(2))&&(((H=this.deleted)===null||H===void 0?void 0:H.findSubstr(V))||W.includeChildren&&((Q=this.deleted)===null||Q===void 0?void 0:Q.findSuperstr(V))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(V){const W=[],P=V===1?this.added:V===0?this.updated:this.deleted;if(P)for(const[,N]of P)W.push(N);return W}filter(V){return new g(this.changes.filter(W=>V(W)),this.ignorePathCasing)}}e.FileChangesEvent=g;function m(U,V,W){return!U||!V||U===V||V.length>U.length?!1:(V.charAt(V.length-1)!==R.sep&&(V+=R.sep),W?(0,y.startsWithIgnoreCase)(U,V):U.indexOf(V)===0)}e.isParent=m;class _ extends Error{constructor(V,W,P){super(V);this.fileOperationResult=W,this.options=P}static isFileOperationError(V){return V instanceof Error&&!(0,k.isUndefinedOrNull)(V.fileOperationResult)}}e.FileOperationError=_;var b;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(b=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var l;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(l=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=L;async function O(U,V){if(!V.canHandleResource(C.URI.from({scheme:U.scheme})))return new Promise(W=>{const P=V.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===U.scheme&&N.added&&(P.dispose(),W())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(V){return(0,k.isNumber)(V)||(V=0),V<$.KB?(0,w.localize)(1,null,V.toFixed(0)):V<$.MB?(0,w.localize)(2,null,(V/$.KB).toFixed(2)):V<$.GB?(0,w.localize)(3,null,(V/$.MB).toFixed(2)):V<$.TB?(0,w.localize)(4,null,(V/$.GB).toFixed(2)):(0,w.localize)(5,null,(V/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var ie;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(ie=e.Arch||(e.Arch={}));function se(U){return{maxFileSize:U===0?300*$.MB:16*$.GB,maxHeapSize:U===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=se}),define(ge[82],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...C){this._entries=new Map;for(let[T,y]of C)this.set(T,y)}set(C,T){const y=this._entries.get(C);return this._entries.set(C,T),y}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=w}),define(ge[185],pe([0,1,17,177,111,4,82,13]),function(G,e,w,R,C,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class I extends Error{constructor(a){var h;super("cyclic dependency between services");this.message=(h=a.findCycleSlow())!==null&&h!==void 0?h:`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class i{constructor(a=new y.ServiceCollection,h=!1,E){this._activeInstantiations=new Set,this._services=a,this._strict=h,this._parent=E,this._services.set(T.IInstantiationService,this)}createChild(a){return new i(a,this._strict,this)}invokeFunction(a,...h){let E=d.traceInvocation(a),v=!1;try{return a({get:(u,f)=>{if(v)throw(0,w.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(u,E);if(!c&&f!==T.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return c}},...h)}finally{v=!0,E.stop()}}createInstance(a,...h){let E,v;return a instanceof C.SyncDescriptor?(E=d.traceCreation(a.ctor),v=this._createInstance(a.ctor,a.staticArguments.concat(h),E)):(E=d.traceCreation(a),v=this._createInstance(a,h,E)),E.stop(),v}_createInstance(a,h=[],E){let v=T._util.getServiceDependencies(a).sort((f,c)=>f.index-c.index),S=[];for(const f of v){let c=this._getOrCreateServiceInstance(f.id,E);if(!c&&this._strict&&!f.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${f.id}.`);S.push(c)}let u=v.length>0?v[0].index:h.length;if(h.length!==u){console.warn(`[createInstance] First service dependency of ${a.name} at position ${u+1} conflicts with ${h.length} static arguments`);let f=u-h.length;f>0?h=h.concat(new Array(f)):h=h.slice(0,u)}return new a(...[...h,...S])}_setServiceInstance(a,h){if(this._services.get(a)instanceof C.SyncDescriptor)this._services.set(a,h);else if(this._parent)this._parent._setServiceInstance(a,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let h=this._services.get(a);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):h}_getOrCreateServiceInstance(a,h){let E=this._getServiceInstanceOrDescriptor(a);return E instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,E,h.branch(a,!0)):(h.branch(a,!1),E)}_safeCreateAndCacheServiceInstance(a,h,E){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,h,E)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,h,E){const v=new R.Graph(f=>f.id.toString());let S=0;const u=[{id:a,desc:h,_trace:E}];for(;u.length;){const f=u.pop();if(v.lookupOrInsertNode(f),S++>1e3)throw new I(v);for(let c of T._util.getServiceDependencies(f.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${a} depends on ${c.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const n={id:c.id,desc:t,_trace:f._trace.branch(c.id,!0)};v.insertEdge(f,n),u.push(n)}}}for(;;){const f=v.roots();if(f.length===0){if(!v.isEmpty())throw new I(v);break}for(const{data:c}of f){if(this._getServiceInstanceOrDescriptor(c.id)instanceof C.SyncDescriptor){const n=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,n)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,h,E=[],v,S){if(this._services.get(a)instanceof C.SyncDescriptor)return this._createServiceInstance(h,E,v,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,h,E,v,S);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(a,h=[],E,v){if(E){const S=new k.IdleValue(()=>this._createInstance(a,h,v));return new Proxy(Object.create(null),{get(u,f){if(f in u)return u[f];let c=S.value,t=c[f];return typeof t!="function"||(t=t.bind(c),u[f]=t),t},set(u,f,c){return S.value[f]=c,!0}})}else return this._createInstance(a,h,v)}}e.InstantiationService=i;var A;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(A||(A={}));class d{constructor(a,h){this.type=a,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new d(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(a){return D?new d(0,a.name):d._None}branch(a,h){let E=new d(2,a.toString());return this._dep.push([a,h,E]),E}stop(){let a=Date.now()-this._start;d._totals+=a;let h=!1;function E(S,u){let f=[],c=new Array(S+1).join("	");for(const[t,n,s]of u._dep)if(n&&s){h=!0,f.push(`${c}CREATES -> ${t}`);let r=E(S+1,s);r&&f.push(r)}else f.push(`${c}uses -> ${t}`);return f.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(a>2||h)&&console.log(v.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(ge[14],pe([0,1,4,6,11,3,60]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function k(){return new Date().toISOString()}var D;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class I extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class i extends I{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(D.Error,this.format(s))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let r=t[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(o){}n+=(s>0?" ":"")+r}return n}}e.AbstractMessageLogger=i;class A extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,t,...n):console.warn(`[main ${k()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,t,...n):console.error(`[main ${k()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,t,...n):console.error(`[main ${k()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=A;class d extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class p extends I{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class a extends I{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class h extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=h;class E extends R.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class v{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=v;function S(c){if(c.verbose)return D.Trace;if(typeof c.logLevel=="string"){const t=u(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function u(c){switch(c){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=u;function f(c){switch(c){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=f}),define(ge[112],pe([0,1,14,43]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(D,I,i,A){try{const d=await new Promise((p,a)=>{G(["spdlog"],p,a)});return d.setFlushOn(w.LogLevel.Info),d.createAsyncRotatingLogger(D,I,i,A)}catch(d){console.error(d)}return null}function T(D,I,i,A){const d=G.__$__nodeRequire("spdlog");return d.setFlushOn(w.LogLevel.Info),d.createRotatingLogger(D,I,i,A)}e.createRotatingLogger=T;function y(D,I,i){switch(I){case w.LogLevel.Trace:D.trace(i);break;case w.LogLevel.Debug:D.debug(i);break;case w.LogLevel.Info:D.info(i);break;case w.LogLevel.Warning:D.warn(i);break;case w.LogLevel.Error:D.error(i);break;case w.LogLevel.Critical:D.critical(i);break;default:throw new Error("Invalid log level")}}class k extends w.AbstractMessageLogger{constructor(I,i,A,d){super();this.name=I,this.filepath=i,this.rotating=A,this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const I=this.rotating?6:1,i=30/I*R.ByteSize.MB;return C(this.name,this.filepath,i,I).then(A=>{if(A){this._logger=A,this._logger.setLevel(this.getLevel());for(const{level:d,message:p}of this.buffer)y(this._logger,d,p);this.buffer=[]}})}log(I,i){this._logger?y(this._logger,I,i):this.getLevel()<=I&&this.buffer.push({level:I,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(ge[113],pe([0,1,4,158,57]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function I(a,h){return h-a}D.compare=I;const i=Object.create(null);i[D.Error]=(0,R.localize)(0,null),i[D.Warning]=(0,R.localize)(1,null),i[D.Info]=(0,R.localize)(2,null);function A(a){return i[a]||""}D.toString=A;function d(a){switch(a){case C.default.Error:return D.Error;case C.default.Warning:return D.Warning;case C.default.Info:return D.Info;case C.default.Ignore:return D.Hint}}D.fromSeverity=d;function p(a){switch(a){case D.Error:return C.default.Error;case D.Warning:return C.default.Warning;case D.Info:return C.default.Info;case D.Hint:return C.default.Ignore}}D.toSeverity=p}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(D){const I="";function i(d){return A(d,!0)}D.makeKey=i;function A(d,p){let a=[I];return d.source?a.push(d.source.replace("\xA6","\\\xA6")):a.push(I),d.code?typeof d.code=="string"?a.push(d.code.replace("\xA6","\\\xA6")):a.push(d.code.value.replace("\xA6","\\\xA6")):a.push(I),d.severity!==void 0&&d.severity!==null?a.push(y.toString(d.severity)):a.push(I),d.message&&p?a.push(d.message.replace("\xA6","\\\xA6")):a.push(I),d.startLineNumber!==void 0&&d.startLineNumber!==null?a.push(d.startLineNumber.toString()):a.push(I),d.startColumn!==void 0&&d.startColumn!==null?a.push(d.startColumn.toString()):a.push(I),d.endLineNumber!==void 0&&d.endLineNumber!==null?a.push(d.endLineNumber.toString()):a.push(I),d.endColumn!==void 0&&d.endColumn!==null?a.push(d.endColumn.toString()):a.push(I),a.push(I),a.join("\xA6")}D.makeKeyOptionalMessage=A})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(ge[186],pe([0,1,57,4,3]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=w.default,e.INotificationService=(0,R.createDecorator)("notificationService");var T;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new D,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=k;class D{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=D}),define(ge[187],pe([0,1,6,8,2,4]),function(G,e,w,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return w.Disposable.None},registerValidator(){return w.Disposable.None},registerExternalUriResolver(){return w.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return w.Disposable.None},async open(){return!1},async resolveExternalUri(k){return{resolved:k,dispose(){}}}});function y(k,D){return C.URI.isUri(k)?(0,R.equalsIgnoreCase)(k.scheme,D):(0,R.startsWithIgnoreCase)(k,D+":")}e.matchesScheme=y}),define(ge[188],pe([0,1,10,11,36,24]),function(G,e,w,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const k=R.globals.vscode.context.configuration();if(k)y=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const k=(0,T.dirname)(w.FileAccess.asFileUri("",G));y=G.__$__nodeRequire((0,T.joinPath)(k,"product.json").fsPath);const D=G.__$__nodeRequire((0,T.joinPath)(k,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.57.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=y});var He=this&&this.__param||function(G,e){return function(w,R){e(w,R,G)}};define(ge[114],pe([0,1,4,21,6,13]),function(G,e,w,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,w.createDecorator)("progressService");var y;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(A){this.callback=A}get value(){return this._value}report(A){this._value=A,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let D=class extends C.Disposable{constructor(A,d){super();this.deferred=new T.DeferredPromise,d.withProgress(A,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(A){this.reporter?this.reporter.report(A):this.lastStep=A}};D=Ve([He(1,e.IProgressService)],D),e.UnmanagedProgress=D;class I extends C.Disposable{constructor(A){super();this.progressIndicator=A,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(A){this.stop();const d=++this.currentOperationId,p=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},A),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:p.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(A){this.currentOperationId===A&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,w.createDecorator)("editorProgressService")}),define(ge[38],pe([0,1,12,51]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(y,k){R.ok(w.isString(y)),R.ok(w.isObject(k)),R.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,k)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new C}),define(ge[115],pe([0,1,38,3]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,I){this.schemasById[C(D)]=I,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new T;w.Registry.add(e.Extensions.JSONContribution,y)}),define(ge[83],pe([0,1,153,3,38,12,115]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=C.Registry.as(y.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:w.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,S=!0){this.registerConfigurations([v],S)}registerConfigurations(v,S=!0){const u=[];v.forEach(f=>{u.push(...this.validateAndRegisterProperties(f,S,f.extensionInfo)),this.configurationContributors.push(f),this.registerJSONConfiguration(f)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(v){const S=[],u=f=>{if(f.properties)for(const c in f.properties)S.push(c),delete this.configurationProperties[c],this.removeFromSchema(c,f.properties[c]);f.allOf&&f.allOf.forEach(c=>u(c))};for(const f of v){u(f);const c=this.configurationContributors.indexOf(f);c!==-1&&this.configurationContributors.splice(c,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(v){const S=[],u=[];for(const f of v)for(const c in f)if(S.push(c),e.OVERRIDE_PROPERTY_PATTERN.test(c)){this.defaultValues[c]=Object.assign(Object.assign({},this.defaultValues[c]||{}),f[c]);const t={type:"object",default:this.defaultValues[c],description:w.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId};u.push(A(c)),this.configurationProperties[c]=t,this.defaultLanguageConfigurationOverridesNode.properties[c]=t}else{this.defaultValues[c]=f[c];const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(v){const S=[];for(const u of v)for(const f in u)if(S.push(f),delete this.defaultValues[f],e.OVERRIDE_PROPERTY_PATTERN.test(f))delete this.configurationProperties[f],delete this.defaultLanguageConfigurationOverridesNode.properties[f];else{const c=this.configurationProperties[f];c&&(this.updatePropertyDefaultValue(f,c),this.updateSchema(f,c))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const S of v)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,S=!0,u,f=3){var c;f=T.isUndefinedOrNull(v.scope)?f:v.scope;let t=[],n=v.properties;if(n)for(let r in n){if(S&&a(r)){delete n[r];continue}const o=n[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:(o.scope=T.isUndefinedOrNull(o.scope)?f:o.scope,o.restricted=T.isUndefinedOrNull(o.restricted)?!!((c=u==null?void 0:u.restrictedConfigurations)===null||c===void 0?void 0:c.includes(r)):o.restricted),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),t.push(r)}let s=v.allOf;if(s)for(let r of s)t.push(...this.validateAndRegisterProperties(r,S,u,f));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const S=u=>{let f=u.properties;if(f)for(const t in f)this.updateSchema(t,f[t]);let c=u.allOf;c&&c.forEach(S)};S(v)}updateSchema(v,S){switch(e.allSettings.properties[v]=S,S.scope){case 1:e.applicationSettings.properties[v]=S;break;case 2:e.machineSettings.properties[v]=S;break;case 6:e.machineOverridableSettings.properties[v]=S;break;case 3:e.windowSettings.properties[v]=S;break;case 4:e.resourceSettings.properties[v]=S;break;case 5:e.resourceSettings.properties[v]=S,this.resourceLanguageSettingsSchema.properties[v]=S;break}}removeFromSchema(v,S){switch(delete e.allSettings.properties[v],S.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const S=`[${v}]`,u={type:"object",description:w.localize(2,null),errorMessage:w.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,u),e.allSettings.properties[S]=u,e.applicationSettings.properties[S]=u,e.machineSettings.properties[S]=u,e.machineOverridableSettings.properties[S]=u,e.windowSettings.properties[S]=u,e.resourceSettings.properties[S]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,S){let u=this.defaultValues[v];T.isUndefined(u)&&(u=S.default),T.isUndefined(u)&&(u=d(S.type)),S.default=u}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function A(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=A;function d(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const p=new I;C.Registry.add(e.Extensions.Configuration,p);function a(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?w.localize(5,null,E):p.getConfigurationProperties()[E]!==void 0?w.localize(6,null,E):null:w.localize(4,null)}e.validateProperty=a;function h(){const E=[],v=p.getConfigurationProperties();for(const S of Object.keys(v))E.push([S,v[S].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=h}),define(ge[84],pe([0,1,25,12,2,38,4,83]),function(G,e,w,R,C,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof C.URI)}e.isConfigurationOverrides=D;var I;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function A(n,s){const r=s?n?s.keys.filter(L=>n.keys.indexOf(L)===-1):[...s.keys]:[],o=n?s?n.keys.filter(L=>s.keys.indexOf(L)===-1):[...n.keys]:[],g=[];if(s&&n){for(const L of n.keys)if(s.keys.indexOf(L)!==-1){const O=v(n.contents,L),$=v(s.contents,L);w.equals(O,$)||g.push(L)}}const m=[],_=L=>{const O={};for(const $ of L)for(const ie of $.identifiers)O[c(ie)]=$;return O},b=s?_(s.overrides):{},l=n?_(n.overrides):{};if(Object.keys(b).length)for(const L of r){const O=b[L];O&&m.push([(0,k.overrideIdentifierFromKey)(L),O.keys])}if(Object.keys(l).length)for(const L of o){const O=l[L];O&&m.push([(0,k.overrideIdentifierFromKey)(L),O.keys])}if(Object.keys(b).length&&Object.keys(l).length)for(const L of g){const O=l[L],$=b[L];if(O&&$){const ie=A({contents:O.contents,keys:O.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});m.push([(0,k.overrideIdentifierFromKey)(L),[...ie.added,...ie.removed,...ie.updated]])}}return{added:r,removed:o,updated:g,overrides:m}}e.compare=A;function d(n,s){const r=[];for(const o of Object.keys(n))if(k.OVERRIDE_PROPERTY_PATTERN.test(o)){const g={};for(const m in n[o])g[m]=n[o][m];r.push({identifiers:[(0,k.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(g),contents:p(g,s)})}return r}e.toOverrides=d;function p(n,s){const r=Object.create(null);for(let o in n)a(r,o,n[o],s);return r}e.toValuesTree=p;function a(n,s,r,o){const g=s.split("."),m=g.pop();let _=n;for(let b=0;b<g.length;b++){let l=g[b],L=_[l];switch(typeof L){case"undefined":L=_[l]=Object.create(null);break;case"object":break;default:o(`Ignoring ${s} as ${g.slice(0,b+1).join(".")} is ${JSON.stringify(L)}`);return}_=L}if(typeof _=="object"&&_!==null)try{_[m]=r}catch(b){o(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(_)}`)}else o(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(_)}`)}e.addToValueTree=a;function h(n,s){const r=s.split(".");E(n,r)}e.removeFromValueTree=h;function E(n,s){const r=s.shift();if(s.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const o=n[r];typeof o=="object"&&!Array.isArray(o)&&(E(o,s),Object.keys(o).length===0&&delete n[r])}}function v(n,s,r){function o(_,b){let l=_;for(const L of b){if(typeof l!="object"||l===null)return;l=l[L]}return l}const g=s.split("."),m=o(n,g);return typeof m=="undefined"?r:m}e.getConfigurationValue=v;function S(n,s,r){Object.keys(s).forEach(o=>{o!=="__proto__"&&(o in n?R.isObject(n[o])&&R.isObject(s[o])?S(n[o],s[o],r):r&&(n[o]=s[o]):n[o]=s[o])})}e.merge=S;function u(){const n=T.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=u;function f(){const n=Object.create(null),s=T.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let r in s){let o=s[r].default;a(n,r,o,g=>console.error(`Conflict in default settings: ${g}`))}return n}e.getDefaultValues=f;function c(n){return`[${n}]`}e.keyFromOverrideIdentifier=c;function t(n,s,r){const o=n.inspect(s),g=n.inspect(r);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:o.defaultValue}e.getMigratedSettingValue=t}),define(ge[189],pe([0,1,55,22,16,12,25,2,83,84,38,6,3]),function(G,e,w,R,C,T,y,k,D,I,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,I.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,I.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const r of C.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[r],g=n[r];g&&(typeof o=="object"&&typeof g=="object"?(o=y.deepClone(o),this.mergeContents(o,g)):o=g),s[r]=o}return new p(s,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),s=y.deepClone(this.overrides),r=[...this.keys];for(const o of t){this.mergeContents(n,o.contents);for(const g of o.overrides){const[m]=s.filter(_=>C.equals(_.identifiers,g.identifiers));m?this.mergeContents(m.contents,g.contents):s.push(y.deepClone(g))}for(const g of o.keys)r.indexOf(g)===-1&&r.push(g)}return new p(n,r,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&T.isObject(t[s])&&T.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=y.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,I.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,I.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=p;class a extends p{constructor(){const t=(0,I.getDefaultValues)(),n=(0,I.getConfigurationKeys)(),s=[];for(const r of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,D.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,I.toValuesTree)(t[r],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,n,s)}}e.DefaultConfigurationModel=a;class h{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:r,overrides:o,restricted:g}=this.doParseRaw(t,n);this._configurationModel=new p(s,r,o),this._restrictedConfigurations=g||[]}doParseContent(t){let n={},s=null,r=[],o=[],g=[];function m(b){Array.isArray(r)?r.push(b):s&&(r[s]=b)}let _={onObjectBegin:()=>{let b={};m(b),o.push(r),r=b,s=null},onObjectProperty:b=>{s=b},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{let b=[];m(b),o.push(r),r=b,s=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:m,onError:(b,l,L)=>{g.push({error:b,offset:l,length:L})}};if(t)try{w.visit(t,_),n=r[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return n}doParseRaw(t,n){const s=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,s,!0,n);t=r.raw;const o=(0,I.toValuesTree)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),g=Object.keys(t),m=(0,I.toOverrides)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:o,keys:g,overrides:m,restricted:r.restricted}}filter(t,n,s,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.skipRestricted))return{raw:t,restricted:[]};const o={},g=[];for(let m in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(m)&&s){const _=this.filter(t[m],n,!1,r);o[m]=_.raw,g.push(..._.restricted)}else{const _=n[m],b=_?typeof _.scope!="undefined"?_.scope:3:void 0;(_==null?void 0:_.restricted)&&g.push(m),(b===void 0||r.scopes===void 0||r.scopes.includes(b))&&(r.skipRestricted&&(_==null?void 0:_.restricted)||(o[m]=t[m]))}return{raw:o,restricted:g}}}e.ConfigurationModelParser=h;class E extends A.Disposable{constructor(t,n,s,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class v{constructor(t,n,s=new p,r=new p,o=new R.ResourceMap,g=new p,m=new R.ResourceMap,_=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=o,this._memoryConfiguration=g,this._memoryConfigurationByResource=m,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new p,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const r=this.getConsolidateConfigurationModel(n,s),o=this.getFolderConfigurationModelForResource(n.resource,s),g=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,m=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),b=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),l=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),L=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=o?n.overrideIdentifier?o.freeze().override(n.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,$=n.overrideIdentifier?g.override(n.overrideIdentifier).getValue(t):g.getValue(t),ie=r.getValue(t),se=C.distinct(C.flatten(r.overrides.map(U=>U.identifiers))).filter(U=>r.getOverrideValue(t,U)!==void 0);return{defaultValue:m,userValue:_,userLocalValue:b,userRemoteValue:l,workspaceValue:L,workspaceFolderValue:O,memoryValue:$,value:ie,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:b!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:l!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:n.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:g.getValue(t),override:n.overrideIdentifier?g.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(r=>D.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const o=(0,D.overrideIdentifierFromKey)(r),g=this._defaultConfiguration.getKeysForOverrideIdentifier(o),m=t.getKeysForOverrideIdentifier(o),_=[...m.filter(b=>g.indexOf(b)===-1),...g.filter(b=>m.indexOf(b)===-1),...g.filter(b=>!y.equals(this._defaultConfiguration.override(o).getValue(b),t.override(o).getValue(b)))];return[o,_]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,I.compare)(this.localUserConfiguration,t),g=[...n,...s,...r];return g.length&&this.updateLocalUserConfiguration(t),{keys:g,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,I.compare)(this.remoteUserConfiguration,t);let g=[...n,...s,...r];return g.length&&this.updateRemoteUserConfiguration(t),{keys:g,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,I.compare)(this.workspaceConfiguration,t);let g=[...n,...s,...r];return g.length&&this.updateWorkspaceConfiguration(t),{keys:g,overrides:o}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:r,updated:o,removed:g,overrides:m}=(0,I.compare)(s,n);let _=[...r,...o,...g];return(_.length||!s)&&this.updateFolderConfiguration(t,n),{keys:_,overrides:m}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:r,removed:o,overrides:g}=(0,I.compare)(n,void 0);return{keys:[...s,...r,...o],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const o=this._memoryConfigurationByResource.get(t);o&&(s=s.merge(o))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=s.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:r,keys:o}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:r,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((g,m)=>(g.set(k.URI.revive(m[0]),this.parseConfigurationModel(m[1])),g),new R.ResourceMap);return new v(n,s,new p,r,o,new p,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=v;function S(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,n=new Map;for(const r of c)r.keys.forEach(o=>t.add(o)),r.overrides.forEach(([o,g])=>{const m=(0,R.getOrSet)(n,o,new Set);g.forEach(_=>m.add(_))});const s=[];return n.forEach((r,o)=>s.push([o,[...r.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=S;class u{constructor(t,n,s,r){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(m=>o.add(m)),t.overrides.forEach(([,m])=>m.forEach(_=>o.add(_))),this.affectedKeys=[...o.values()];const g=new p;this.affectedKeys.forEach(m=>g.setValue(m,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,o=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,I.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(t=t[r],!t)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=u;class f extends u{constructor(t,n,s,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=f}),define(ge[190],pe([0,1,37,9,110,156,28,11,184,84,4,10,136]),function(G,e,w,R,C,T,y,k,D,I,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const p=T.localize(0,null);class a{async getDefaultTerminalForPlatforms(){const t=await v.getDefaultTerminalLinuxReady();return{windows:h.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let h=class zt extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(w,n,C.getWindowsShell(),t)}spawnTerminal(t,n,s,r){const o=n.terminal.external,g=(o==null?void 0:o.windowsExec)||zt.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const m=R.basename(g).toLowerCase();if(m==="cmder"||m==="cmder.exe")return t.spawn(g,r?[r]:void 0),Promise.resolve(void 0);const _=["/c","start","/wait"];return g.indexOf(" ")>=0&&_.push('""'),_.push(g),(m==="wt"||m==="wt.exe")&&_.push("-d ."),new Promise((b,l)=>{const L=S(process),O=t.spawn(s,_,{cwd:r,env:L});O.on("error",l),O.on("exit",()=>b())})}runInTerminal(t,n,s,r,o){const g="windowsExec"in o&&o.windowsExec?o.windowsExec:zt.getDefaultTerminalWindows();return new Promise((m,_)=>{const b=`"${n} - ${p}"`,l=`""${s.join('" "')}" & pause"`,L=["/c","start",b,"/wait",g,"/c",l],O=Object.assign({},S(process),r);Object.keys(O).filter(se=>O[se]===null).forEach(se=>delete O[se]);const $={cwd:n,env:O,windowsVerbatimArguments:!0};w.spawn(zt.CMD,L,$).on("error",se=>{_(u(se))}),m(void 0)})}static getDefaultTerminalWindows(){if(!zt._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");zt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return zt._DEFAULT_TERMINAL_WINDOWS}};h.CMD="cmd.exe",h=Ve([He(0,(0,i.optional)(I.IConfigurationService))],h),e.WindowsExternalTerminalService=h;let E=class Nn extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(w,n,t)}runInTerminal(t,n,s,r,o){const g=o.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((m,_)=>{if(g===D.DEFAULT_TERMINAL_OSX||g==="iTerm.app"){const b=g===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${b}.scpt`,G).fsPath,"-t",t||p,"-w",n];for(let ie of s)L.push("-a"),L.push(ie);if(r)for(let ie in r){const se=r[ie];se===null?(L.push("-u"),L.push(ie)):(L.push("-e"),L.push(`${ie}=${se}`))}let O="";const $=w.spawn(Nn.OSASCRIPT,L);$.on("error",ie=>{_(u(ie))}),$.stderr.on("data",ie=>{O+=ie.toString()}),$.on("exit",ie=>{if(ie===0)m(void 0);else if(O){const se=O.split(`
`,1);_(new Error(se[0]))}else _(new Error(T.localize(1,null,b,ie)))})}else _(new Error(T.localize(2,null,g)))})}spawnTerminal(t,n,s){const r=n.terminal.external,o=(r==null?void 0:r.osxExec)||D.DEFAULT_TERMINAL_OSX;return new Promise((g,m)=>{const _=["-a",o];s&&_.push(s);const b=t.spawn("/usr/bin/open",_);b.on("error",m),b.on("exit",()=>g())})}};E.OSASCRIPT="/usr/bin/osascript",E=Ve([He(0,(0,i.optional)(I.IConfigurationService))],E),e.MacExternalTerminalService=E;let v=class Vt extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(w,n,t)}runInTerminal(t,n,s,r,o){const g=o.linuxExec?Promise.resolve(o.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((m,_)=>{let b=[];g.then(l=>{l.indexOf("gnome-terminal")>=0?b.push("-x"):b.push("-e"),b.push("bash"),b.push("-c");const L=`${f(s)}; echo; read -p "${Vt.WAIT_MESSAGE}" -n1;`;b.push(`''${L}''`);const O=Object.assign({},process.env,r);Object.keys(O).filter(U=>O[U]===null).forEach(U=>delete O[U]);const $={cwd:n,env:O};let ie="";const se=w.spawn(l,b,$);se.on("error",U=>{_(u(U))}),se.stderr.on("data",U=>{ie+=U.toString()}),se.on("exit",U=>{if(U===0)m(void 0);else if(ie){const V=ie.split(`
`,1);_(new Error(V[0]))}else _(new Error(T.localize(4,null,l,U)))})})})}static async getDefaultTerminalLinuxReady(){return Vt._DEFAULT_TERMINAL_LINUX_READY||(Vt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{k.isLinux?await y.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),Vt._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,n,s){const r=n.terminal.external,o=(r==null?void 0:r.linuxExec)?Promise.resolve(r.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((g,m)=>{o.then(_=>{const b=S(process),l=t.spawn(_,[],{cwd:s,env:b});l.on("error",m),l.on("exit",()=>g())})})}};v.WAIT_MESSAGE=T.localize(3,null),v=Ve([He(0,(0,i.optional)(I.IConfigurationService))],v),e.LinuxExternalTerminalService=v;function S(c){const t=c.env;return(0,d.sanitizeProcessEnvironment)(t),t}function u(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(T.localize(5,null,c.path)):c}function f(c){let t="";for(let n of c)n.indexOf(" ")>=0?t+='"'+n+'"':t+=n,t+=" ";return t}}),define(ge[116],pe([0,1,4]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var R;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(y,k=R.Unknown,D){super(y);this._message=y,this._code=k,this._detail=D,this.isHandled=k===R.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(y){return y instanceof C&&y._code===R.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof C&&y._code===R.NoResolverFound}static isHandled(y){return y instanceof C&&y.isHandled}}e.RemoteAuthorityResolverError=C}),define(ge[117],pe([0,1,10]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function R(I){return I.scheme===w.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=R;function C(I){if(!I)return;const i=I.indexOf("+");return i<0?I:I.substr(0,i)}e.getRemoteName=C;function T(I){return I.scheme!==w.Schemas.file&&I.scheme!==w.Schemas.vscodeRemote}function y(I){if(I.folders.length)return I.folders.every(i=>T(i.uri))?I.folders[0].uri:void 0;if(I.configuration&&T(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=y;function k(I){var i;return(i=y(I))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=k;function D(I){return y(I)!==void 0}e.isVirtualWorkspace=D}),define(ge[191],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{vsda(){return new Promise((C,T)=>G(["vsda"],C,T))}async sign(C){try{const T=await this.vsda(),y=new T.signer;if(y)return y.sign(C)}catch(T){}return C}}e.SignService=w}),define(ge[192],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class w{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,T,y=5){let k;return k=T(D=>{const I=typeof D=="string"?D:D.data;let i=this._terminalBufferMap.get(C);if(i){i.data.push(I);return}const A=setTimeout(()=>this.flushBuffer(C),y);i={data:[I],timeoutId:A,dispose:()=>{clearTimeout(A),this.flushBuffer(C),k.dispose()}},this._terminalBufferMap.set(C,i)}),k}stopBuffering(C){const T=this._terminalBufferMap.get(C);T&&T.dispose()}flushBuffer(C){const T=this._terminalBufferMap.get(C);T&&(this._terminalBufferMap.delete(C),this._callback(C,T.data.join("")))}}e.TerminalDataBufferer=w}),define(ge[193],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(ge[194],pe([0,1,4,6,38,3,193,45]),function(G,e,w,R,C,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,w.createDecorator)("themeService");var D;(function(E){function v(S){return S&&typeof S=="object"&&typeof S.id=="string"}E.isThemeColor=v})(D=e.ThemeColor||(e.ThemeColor={}));function I(E){return{id:E}}e.themeColorFromId=I;var i;(function(E){function v(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||D.isThemeColor(n.color))}E.isThemeIcon=v;const S=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function u(n){const s=S.exec(n);if(!s)return;let[,r]=s;return{id:r}}E.fromString=u;function f(n,s){let r=n.id;const o=r.lastIndexOf("~");return o!==-1&&(r=r.substring(0,o)),s&&(r=`${r}~${s}`),{id:r}}E.modify=f;function c(n,s){var r,o;return n.id===s.id&&((r=n.color)===null||r===void 0?void 0:r.id)===((o=s.color)===null||o===void 0?void 0:o.id)}E.isEqual=c;function t(n){return{id:n.id}}E.asThemeIcon=t,E.asClassNameArray=k.CSSIcon.asClassNameArray,E.asClassName=k.CSSIcon.asClassName,E.asCSSSelector=k.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function A(E){switch(E){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=A,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,R.toDisposable)(()=>{const S=this.themingParticipants.indexOf(v);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new d;C.Registry.add(e.Extensions.ThemingContribution,p);function a(E){return p.onColorThemeChange(E)}e.registerThemingParticipant=a;class h extends R.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,S){let u=this.theme.getColor(v);return u&&S&&(u=S(u,this.theme)),u?u.toString():null}}e.Themable=h}),define(ge[195],pe([0,1,38,194,3,159,115,13,45]),function(G,e,w,R,C,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class I{constructor(){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,S,u,f){const c=this.iconsById[v];if(c){if(u&&!c.description){c.description=u,this.iconSchema.properties[v].markdownDescription=`${u} $(${v})`;const s=this.iconReferenceSchema.enum.indexOf(v);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=u),this._onDidChange.fire()}return c}let t={id:v,description:u,defaults:S,deprecationMessage:f};this.iconsById[v]=t;let n={$ref:"#/definitions/icons"};return f&&(n.deprecationMessage=f),u&&(n.markdownDescription=`${u}: $(${v})`),this.iconSchema.properties[v]=n,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(u||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const S=this.iconReferenceSchema.enum.indexOf(v);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,S){const u=this.iconFontsById[v];if(u)return u;let f={id:v,definition:S};return this.iconFontsById[v]=f,this._onDidChange.fire(),f}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFonts(){return Object.keys(this.iconFontsById).map(v=>this.iconFontsById[v])}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(c,t)=>c.id.localeCompare(t.id),S=c=>{for(;R.ThemeIcon.isThemeIcon(c.defaults);)c=this.iconsById[c.defaults.id];return`codicon codicon-${c?c.id:""}`};let u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.iconsById).map(c=>this.iconsById[c]);for(const c of f.filter(t=>!!t.description).sort(v))u.push(`|<i class="${S(c)}"></i>|${c.id}|${R.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const c of f.filter(t=>!R.ThemeIcon.isThemeIcon(t.defaults)).sort(v))u.push(`|<i class="${S(c)}"></i>|${c.id}|`);return u.join(`
`)}}const i=new I;w.Registry.add(e.Extensions.IconContribution,i);function A(E,v,S,u){return i.registerIcon(E,v,S,u)}e.registerIcon=A;function d(){return i}e.getIconRegistry=d;function p(){for(const E of D.iconRegistry.all)i.registerIcon(E.id,E.definition,E.description);D.iconRegistry.onDidRegister(E=>i.registerIcon(E.id,E.definition,E.description))}p(),e.iconsSchemaId="vscode://schemas/icons";let a=w.Registry.as(y.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,i.getIconSchema());const h=new k.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{h.isScheduled()||h.schedule()}),e.widgetClose=A("widget-close",D.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=A("goto-previous-location",D.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=A("goto-next-location",D.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=R.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(ge[61],pe([0,1,2,24,4,22]),function(G,e,w,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var y;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function k(d){const p=d;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=k;function D(d){const p=d;return!!(p&&typeof p=="object"&&w.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=D;class I{constructor(p,a,h,E){this._id=p,this._configuration=h,this._ignorePathCasing=E,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=I;class i{constructor(p,a){this.raw=a,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,R.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function A(d){return new i({uri:d,index:0,name:(0,R.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=A}),define(ge[118],pe([0,1,4,160,61,2,11,9,24,134,55,10,77,29,117]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(V){return(typeof V=="string"?(0,k.extname)(V):(0,D.extname)(V))===h}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,w.createDecorator)("workspacesService");function v(V){return V.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function S(V){return V.hasOwnProperty("folderUri")}e.isRecentFolder=S;function u(V){return V.hasOwnProperty("fileUri")}e.isRecentFile=u;function f(V){const W=V;return typeof(W==null?void 0:W.id)=="string"&&T.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=f;function c(V){if(V.configuration)return{id:V.id,configPath:V.configuration};if(V.folders.length===1)return{id:V.id,uri:V.folders[0].uri}}e.toWorkspaceIdentifier=c;function t(V){const W=V;return typeof(W==null?void 0:W.id)=="string"&&T.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=t;function n(V){const W=V;if(W==null?void 0:W.uri)return{id:W.id,uri:T.URI.revive(W.uri)};const P=V;if(P==null?void 0:P.configPath)return{id:P.id,configPath:T.URI.revive(P.configPath)};if(V==null?void 0:V.id)return{id:V.id}}e.reviveIdentifier=n;function s(V,W){return D.extUriBiasedIgnorePathCase.isEqualOrParent(V,W.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(V){return o(V)||g(V)}e.isStoredWorkspaceFolder=r;function o(V){const W=V;return typeof(W==null?void 0:W.path)=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=o;function g(V){const W=V;return typeof(W==null?void 0:W.uri)=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=g;function m(V,W,P,N,F=!y.isWindows,M){if(V.scheme!==N.scheme)return{name:P,uri:V.toString(!0)};let B=W?void 0:M.relativePath(N,V);if(B!==void 0)B.length===0?B=".":y.isWindows&&V.scheme===A.Schemas.file&&!F&&(B=B.replace(/\//g,"\\"));else if(V.scheme===A.Schemas.file)B=V.fsPath,y.isWindows&&(B=(0,d.normalizeDriveLetter)(B),F&&(B=(0,p.toSlashes)(B)));else{if(!M.isEqualAuthority(V.authority,N.authority))return{name:P,uri:V.toString(!0)};B=V.path}return{name:P,path:B}}e.getStoredWorkspaceFolder=m;function _(V,W,P){let N=[],F=new Set;const M=P.dirname(W);for(let B of V){let H;if(o(B))B.path&&(H=P.resolvePath(M,B.path));else if(g(B))try{H=T.URI.parse(B.uri),H.path[0]!=="/"&&(H=H.with({path:"/"+H.path}))}catch(Q){console.warn(Q)}if(H){let Q=P.getComparisonKey(H);if(!F.has(Q)){F.add(Q);const le=B.name||P.basenameOrAuthority(H);N.push(new C.WorkspaceFolder({uri:H,name:le,index:N.length},B))}}}return N}e.toWorkspaceFolders=_;function b(V,W,P,N,F){let M=l(W,V);const B=F.dirname(W),H=F.dirname(N),Q=[],le=L(M.folders);for(const Ne of M.folders){const Ke=o(Ne)?F.resolvePath(B,Ne.path):T.URI.parse(Ne.uri);let ze;P?ze=!1:ze=!o(Ne)||(0,k.isAbsolute)(Ne.path),Q.push(m(Ke,ze,Ne.name,H,le,F))}const be={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Te=I.setProperty(V,["folders"],Q,be);let ke=I.applyEdits(V,Te);return M.remoteAuthority===(0,a.getRemoteAuthority)(N)&&(ke=I.applyEdits(ke,I.removeProperty(ke,["remoteAuthority"],be))),ke}e.rewriteWorkspaceFileForNewLocation=b;function l(V,W){let P=i.parse(W);if(P&&Array.isArray(P.folders))P.folders=P.folders.filter(N=>r(N));else throw new Error(`${V} looks like an invalid workspace file.`);return P}function L(V){return y.isWindows?V.some(W=>o(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=L;function O(V){return V.workspace&&typeof V.workspace=="object"&&typeof V.workspace.id=="string"&&typeof V.workspace.configPath=="string"}function $(V){return typeof V.folderUri=="string"}function ie(V){return typeof V.fileUri=="string"}function se(V,W){const P={workspaces:[],files:[]};if(V){const N=function(M,B){for(let H=0;H<M.length;H++)try{B(M[H],H)}catch(Q){W.warn(`Error restoring recent entry ${JSON.stringify(M[H])}: ${Q.toString()}. Skip entry.`)}},F=V;if(Array.isArray(F.entries))N(F.entries,M=>{const B=M.label,H=M.remoteAuthority;O(M)?P.workspaces.push({label:B,remoteAuthority:H,workspace:{id:M.workspace.id,configPath:T.URI.parse(M.workspace.configPath)}}):$(M)?P.workspaces.push({label:B,remoteAuthority:H,folderUri:T.URI.parse(M.folderUri)}):ie(M)&&P.files.push({label:B,remoteAuthority:H,fileUri:T.URI.parse(M.fileUri)})});else{const M=V;Array.isArray(M.workspaces3)&&N(M.workspaces3,(B,H)=>{const Q=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[H]||void 0;typeof B=="object"&&typeof B.id=="string"&&typeof B.configURIPath=="string"?P.workspaces.push({label:Q,workspace:{id:B.id,configPath:T.URI.parse(B.configURIPath)}}):typeof B=="string"&&P.workspaces.push({label:Q,folderUri:T.URI.parse(B)})}),Array.isArray(M.files2)&&N(M.files2,(B,H)=>{const Q=Array.isArray(M.fileLabels)&&M.fileLabels[H]||void 0;typeof B=="string"&&P.files.push({label:Q,fileUri:T.URI.parse(B)})})}}return P}e.restoreRecentlyOpened=se;function U(V){const W={entries:[]};for(const P of V.workspaces)S(P)?W.entries.push({folderUri:P.folderUri.toString(),label:P.label,remoteAuthority:P.remoteAuthority}):W.entries.push({workspace:{id:P.workspace.id,configPath:P.workspace.configPath.toString()},label:P.label,remoteAuthority:P.remoteAuthority});for(const P of V.files)W.entries.push({fileUri:P.fileUri.toString(),label:P.label,remoteAuthority:P.remoteAuthority});return W}e.toStoreData=U}),define(ge[85],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class w{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const T=this._idPool++;return this._data.set(T,C),this.logDebugInfo(),T}get(C,T){return this._data.has(C)?this._data.get(C)[T]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!w.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=w,w.enableDebugLogging=!1}),define(ge[47],pe([0,1,2,3,4]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class T{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(k){this._tabs=k.map(D=>({name:D.name,group:D.group,resource:w.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(ge[62],pe([0,1,10,4]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(w.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,k){k===null?this._providerInfo.delete(y):this._providerInfo.set(y,k)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(ge[196],pe([0,1,13]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(y,k,D){this._deferredPromises=new Map,this._id=y,this._shared=k,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new w.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of I.values())i.complete()}catch(i){for(const A of I.values())A.error(i)}})()},0)}get keys(){var y;return Object.entries((y=this._value)!==null&&y!==void 0?y:{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this._init}get(y,k){let D=this._value[y];return typeof D=="undefined"&&(D=k),D}update(y,k){this._value[y]=k;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const I=new w.DeferredPromise;return this._deferredPromises.set(y,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class C extends R{constructor(y,k){super(y.identifier.value,!0,k);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=C}),define(ge[15],pe([0,1,4]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class R{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=R});var nt=this&&this.__classPrivateFieldSet||function(G,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!C:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(G,w):C?C.value=w:e.set(G,w),w},Be=this&&this.__classPrivateFieldGet||function(G,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!R:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(G):R?R.value:e.get(G)};define(ge[197],pe([0,1,26,3]),function(G,e,w,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(k,D){C.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=w.ExtensionIdentifier.toKey(k.identifier),nt(this,C,D,"f"),Be(this,C,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(k){return Be(this,C,"f").get(this._id,k)}store(k,D){return Be(this,C,"f").store(this._id,k,D)}delete(k){return Be(this,C,"f").delete(this._id,k)}}e.ExtensionSecrets=T,C=new WeakMap}),define(ge[119],pe([0,1,4,3]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(ge[86],pe([0,1,3]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const C=new WeakMap,T=y=>{let k=C.get(y);return k||(k={children:new Map,bus:new w.Emitter},C.set(y,k)),k};e.getPrivateApiFor=T}),define(ge[48],pe([0,1,4,3,15]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(k){function D(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}k.fromApiTunnel=D;function I(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}k.fromServiceTunnel=I})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,w.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,I){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,I){return{dispose:()=>{}}}async $providePortAttributes(D,I,i,A,d){return[]}async $forwardPort(D,I){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=Ve([He(0,C.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var nt=this&&this.__classPrivateFieldSet||function(G,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!C:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(G,w):C?C.value=w:e.set(G,w),w},Be=this&&this.__classPrivateFieldGet||function(G,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!R:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(G):R?R.value:e.get(G)},Qt=this&&this.__rest||function(G,e){var w={};for(var R in G)Object.prototype.hasOwnProperty.call(G,R)&&e.indexOf(R)<0&&(w[R]=G[R]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(G);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(G,R[C])&&(w[R[C]]=G[R[C]]);return w};define(ge[7],pe([0,1,16,17,96,22,138,12,2,32,43,116,86]),function(G,e,w,R,C,T,y,k,D,I,i,A,d){"use strict";var p,a,h,E,v,S,u,f,c,t,n,s,r,o,g,m,_,b;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function l(j){function x(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(x,j),Object.setPrototypeOf(x.prototype,j.prototype),x}let L=v=class{constructor(x){p.set(this,void 0),nt(this,p,x,"f")}static from(...x){let te=x;return new v(function(){if(te){for(const Se of te)Se&&typeof Se.dispose=="function"&&Se.dispose();te=void 0}})}dispose(){typeof Be(this,p,"f")=="function"&&(Be(this,p,"f").call(this),nt(this,p,void 0,"f"))}};p=new WeakMap,L=v=Ve([l],L),e.Disposable=L;let O=S=class{constructor(x,te){if(x<0)throw(0,R.illegalArgument)("line must be non-negative");if(te<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=x,this._character=te}static Min(...x){if(x.length===0)throw new TypeError;let te=x[0];for(let Se=1;Se<x.length;Se++){const Ge=x[Se];Ge.isBefore(te)&&(te=Ge)}return te}static Max(...x){if(x.length===0)throw new TypeError;let te=x[0];for(let Se=1;Se<x.length;Se++){const Ge=x[Se];Ge.isAfter(te)&&(te=Ge)}return te}static isPosition(x){if(!x)return!1;if(x instanceof S)return!0;let{line:te,character:Se}=x;return typeof te=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,te=0){if(x===null||te===null)throw(0,R.illegalArgument)();let Se;return typeof x=="undefined"?Se=0:typeof x=="number"?Se=x:(Se=typeof x.lineDelta=="number"?x.lineDelta:0,te=typeof x.characterDelta=="number"?x.characterDelta:0),Se===0&&te===0?this:new S(this.line+Se,this.character+te)}with(x,te=this.character){if(x===null||te===null)throw(0,R.illegalArgument)();let Se;return typeof x=="undefined"?Se=this.line:typeof x=="number"?Se=x:(Se=typeof x.line=="number"?x.line:this.line,te=typeof x.character=="number"?x.character:this.character),Se===this.line&&te===this.character?this:new S(Se,te)}toJSON(){return{line:this.line,character:this.character}}};O=S=Ve([l],O),e.Position=O;let $=u=class{constructor(x,te,Se,Ge){let Je,at;if(typeof x=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Ge=="number"?(Je=new O(x,te),at=new O(Se,Ge)):x instanceof O&&te instanceof O&&(Je=x,at=te),!Je||!at)throw new Error("Invalid arguments");Je.isBefore(at)?(this._start=Je,this._end=at):(this._start=at,this._end=Je)}static isRange(x){return x instanceof u?!0:x?O.isPosition(x.start)&&O.isPosition(x.end):!1}get start(){return this._start}get end(){return this._end}contains(x){return x instanceof u?this.contains(x._start)&&this.contains(x._end):x instanceof O?!(x.isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const te=O.Max(x.start,this._start),Se=O.Min(x.end,this._end);if(!te.isAfter(Se))return new u(te,Se)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const te=O.Min(x.start,this._start),Se=O.Max(x.end,this.end);return new u(te,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,te=this.end){if(x===null||te===null)throw(0,R.illegalArgument)();let Se;return x?O.isPosition(x)?Se=x:(Se=x.start||this.start,te=x.end||this.end):Se=this.start,Se.isEqual(this._start)&&te.isEqual(this.end)?this:new u(Se,te)}toJSON(){return[this.start,this.end]}};$=u=Ve([l],$),e.Range=$;let ie=f=class extends ${constructor(x,te,Se,Ge){let Je,at;if(typeof x=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Ge=="number"?(Je=new O(x,te),at=new O(Se,Ge)):x instanceof O&&te instanceof O&&(Je=x,at=te),!Je||!at)throw new Error("Invalid arguments");super(Je,at);this._anchor=Je,this._active=at}static isSelection(x){return x instanceof f?!0:x?$.isRange(x)&&O.isPosition(x.anchor)&&O.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ie=f=Ve([l],ie),e.Selection=ie;class se{constructor(x,te,Se){if(typeof x!="string"||x.length===0)throw(0,R.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,R.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,R.illegalArgument)("connectionToken");this.host=x,this.port=Math.round(te),this.connectionToken=Se}}e.ResolvedAuthority=se;class U extends Error{constructor(x,te=A.RemoteAuthorityResolverErrorCode.Unknown,Se){super(x);this._message=x,this._code=te,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static NotAvailable(x,te){return new U(x,A.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(x){return new U(x,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=U;var V;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var W;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let P=c=class{constructor(x,te){this._range=x,this._newText=te}static isTextEdit(x){return x instanceof c?!0:x?$.isRange(x)&&typeof x.newText=="string":!1}static replace(x,te){return new c(x,te)}static insert(x,te){return c.replace(new $(x,x),te)}static delete(x){return c.replace(x,"")}static setEndOfLine(x){const te=new c(new $(new O(0,0),new O(0,0)),"");return te.newEol=x,te}get range(){return this._range}set range(x){if(x&&!$.isRange(x))throw(0,R.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,R.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,R.illegalArgument)("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};P=c=Ve([l],P),e.TextEdit=P;var N;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellOutput=4]="CellOutput",j[j.CellReplace=5]="CellReplace",j[j.CellOutputItem=6]="CellOutputItem"})(N=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,te,Se,Ge){this._edits.push({_type:1,from:x,to:te,options:Se,metadata:Ge})}createFile(x,te,Se){this._edits.push({_type:1,from:void 0,to:x,options:te,metadata:Se})}deleteFile(x,te,Se){this._edits.push({_type:1,from:x,to:void 0,options:te,metadata:Se})}replaceNotebookMetadata(x,te,Se){this._edits.push({_type:3,metadata:Se,uri:x,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(x,te,Se,Ge,Je){let at,dt,yt=[],kt;if($t.isNotebookRange(te)&&Me.isNotebookCellDataArray(Se)&&!Me.isNotebookCellDataArray(Ge)?(at=te.start,dt=te.end,yt=Se,kt=Ge):typeof te=="number"&&typeof Se=="number"&&Me.isNotebookCellDataArray(Ge)&&(at=te,dt=Se,yt=Ge,kt=Je),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||yt.length>0)&&this._edits.push({_type:5,uri:x,index:at,count:dt-at,cells:yt,metadata:kt})}replaceNotebookCellMetadata(x,te,Se,Ge){this._edits.push({_type:3,metadata:Ge,uri:x,edit:{editType:8,index:te,metadata:Se}})}replace(x,te,Se,Ge){this._edits.push({_type:2,uri:x,edit:new P(te,Se),metadata:Ge})}insert(x,te,Se,Ge){this.replace(x,new $(te,te),Se,Ge)}delete(x,te,Se){this.replace(x,te,"",Se)}has(x){return this._edits.some(te=>te._type===2&&te.uri.toString()===x.toString())}set(x,te){if(te)for(const Se of te)Se&&this._edits.push({_type:2,uri:x,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const Ge=this._edits[Se];Ge._type===2&&Ge.uri.toString()===x.toString()&&(this._edits[Se]=void 0)}(0,w.coalesceInPlace)(this._edits)}}get(x){const te=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===x.toString()&&te.push(Se.edit);return te}entries(){const x=new T.ResourceMap;for(let te of this._edits)if(te._type===2){let Se=x.get(te.uri);Se||(Se=[te.uri,[]],x.set(te.uri,Se)),Se[1].push(te.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=Ve([l],F),e.WorkspaceEdit=F;let M=t=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof t?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=t._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,te=this._tabstop++){if(typeof x=="function"){const Se=new t;Se._tabstop=this._tabstop,x(Se),this._tabstop=Se._tabstop,x=Se.value}else x=t._escape(x);return this.value+="${",this.value+=te,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,te=this._tabstop++){const Se=x.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(x,te){if(typeof te=="function"){const Se=new t;Se._tabstop=this._tabstop,te(Se),this._tabstop=Se._tabstop,te=Se.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,te&&(this.value+=":",this.value+=te),this.value+="}",this}};M=t=Ve([l],M),e.SnippetString=M;var B;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(B=e.DiagnosticTag||(e.DiagnosticTag={}));var H;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(H=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Q=n=class{constructor(x,te){if(this.uri=x,te)if(te instanceof $)this.range=te;else if(te instanceof O)this.range=new $(te,te);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof n?!0:x?$.isRange(x.range)&&D.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Q=n=Ve([l],Q),e.Location=Q;let le=class{constructor(x,te){this.location=x,this.message=te}static is(x){return x?typeof x.message=="string"&&x.location&&$.isRange(x.location.range)&&D.URI.isUri(x.location.uri):!1}static isEqual(x,te){return x===te?!0:!x||!te?!1:x.message===te.message&&x.location.range.isEqual(te.location.range)&&x.location.uri.toString()===te.location.uri.toString()}};le=Ve([l],le),e.DiagnosticRelatedInformation=le;let be=class{constructor(x,te,Se=H.Error){if(!$.isRange(x))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=x,this.message=te,this.severity=Se}toJSON(){return{severity:H[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,te){return x===te?!0:!x||!te?!1:x.message===te.message&&x.severity===te.severity&&x.code===te.code&&x.severity===te.severity&&x.source===te.source&&x.range.isEqual(te.range)&&(0,w.equals)(x.tags,te.tags)&&(0,w.equals)(x.relatedInformation,te.relatedInformation,le.isEqual)}};be=Ve([l],be),e.Diagnostic=be;let Te=class{constructor(x,te){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:(0,C.isMarkdownString)(x)?this.contents=[x]:this.contents=[x],this.range=te}};Te=Ve([l],Te),e.Hover=Te;var ke;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ke=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ne=class{constructor(x,te=ke.Text){this.range=x,this.kind=te}toJSON(){return{range:this.range,kind:ke[this.kind]}}};Ne=Ve([l],Ne),e.DocumentHighlight=Ne;var Ke;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Ke=e.SymbolKind||(e.SymbolKind={}));var ze;(function(j){j[j.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let qe=s=class{constructor(x,te,Se,Ge,Je){this.name=x,this.kind=te,this.containerName=Je,typeof Se=="string"&&(this.containerName=Se),Ge instanceof Q?this.location=Ge:Se instanceof $&&(this.location=new Q(Ge,Se)),s.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ke[this.kind],location:this.location,containerName:this.containerName}}};qe=s=Ve([l],qe),e.SymbolInformation=qe;let q=r=class{constructor(x,te,Se,Ge,Je){this.name=x,this.detail=te,this.kind=Se,this.range=Ge,this.selectionRange=Je,this.children=[],r.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(r.validate)}};q=r=Ve([l],q),e.DocumentSymbol=q;var J;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(J=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let re=class{constructor(x,te){this.title=x,this.kind=te}};re=Ve([l],re),e.CodeAction=re;let oe=o=class{constructor(x){this.value=x}append(x){return new o(this.value?this.value+o.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+o.sep)}};oe.sep=".",oe=o=Ve([l],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let Y=class{constructor(x,te){if(this.range=x,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=Ve([l],Y),e.SelectionRange=Y;class ce{constructor(x,te,Se,Ge,Je,at){this.kind=x,this.name=te,this.detail=Se,this.uri=Ge,this.range=Je,this.selectionRange=at}}e.CallHierarchyItem=ce;class ve{constructor(x,te){this.fromRanges=te,this.from=x}}e.CallHierarchyIncomingCall=ve;class Le{constructor(x,te){this.fromRanges=te,this.to=x}}e.CallHierarchyOutgoingCall=Le;let we=class{constructor(x,te){this.range=x,this.command=te}get isResolved(){return!!this.command}};we=Ve([l],we),e.CodeLens=we;let je=g=class{constructor(x,te=!1){a.set(this,void 0),nt(this,a,new C.MarkdownString(x,{supportThemeIcons:te}),"f")}static isMarkdownString(x){return x instanceof g?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return Be(this,a,"f").value}set value(x){Be(this,a,"f").value=x}get isTrusted(){return Be(this,a,"f").isTrusted}set isTrusted(x){Be(this,a,"f").isTrusted=x}get supportThemeIcons(){return Be(this,a,"f").supportThemeIcons}appendText(x){return Be(this,a,"f").appendText(x),this}appendMarkdown(x){return Be(this,a,"f").appendMarkdown(x),this}appendCodeblock(x,te){return Be(this,a,"f").appendCodeblock(te??"",x),this}};a=new WeakMap,je=g=Ve([l],je),e.MarkdownString=je;let K=class{constructor(x,te){this.label=x,this.documentation=te}};K=Ve([l],K),e.ParameterInformation=K;let ne=class{constructor(x,te){this.label=x,this.documentation=te,this.parameters=[]}};ne=Ve([l],ne),e.SignatureInformation=ne;let Ee=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ee=Ve([l],Ee),e.SignatureHelp=Ee;var Oe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(Oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $e;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})($e=e.InlayHintKind||(e.InlayHintKind={}));let We=class{constructor(x,te,Se){this.text=x,this.position=te,this.kind=Se}};We=Ve([l],We),e.InlayHint=We;var Xe;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var De;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(De=e.CompletionItemKind||(e.CompletionItemKind={}));var ye;(function(j){j[j.Deprecated=1]="Deprecated"})(ye=e.CompletionItemTag||(e.CompletionItemTag={}));let Ce=class{constructor(x,te){this.label=x,this.kind=te}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&De[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ce=Ve([l],Ce),e.CompletionItem=Ce;let ae=class{constructor(x=[],te=!1){this.items=x,this.isIncomplete=te}};ae=Ve([l],ae),e.CompletionList=ae;let he=class{constructor(x,te,Se){this.text=x,this.range=te,this.command=Se}};he=Ve([l],he),e.InlineSuggestion=he;let z=class{constructor(x){this.items=x}};z=Ve([l],z),e.InlineSuggestions=z;var Z;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Z=e.ViewColumn||(e.ViewColumn={}));var ue;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ue=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ue;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ue=e.TextEditorRevealType||(e.TextEditorRevealType={}));var xe;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(xe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function x(te){switch(te){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=x}(xe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor(x,te){if(te&&!D.URI.isUri(te))throw(0,R.illegalArgument)("target");if(!$.isRange(x)||x.isEmpty)throw(0,R.illegalArgument)("range");this.range=x,this.target=te}};rt=Ve([l],rt),e.DocumentLink=rt;let tt=class{constructor(x,te,Se,Ge){this.red=x,this.green=te,this.blue=Se,this.alpha=Ge}};tt=Ve([l],tt),e.Color=tt;let Ye=class{constructor(x,te){if(te&&!(te instanceof tt))throw(0,R.illegalArgument)("color");if(!$.isRange(x)||x.isEmpty)throw(0,R.illegalArgument)("range");this.range=x,this.color=te}};Ye=Ve([l],Ye),e.ColorInformation=Ye;let ot=class{constructor(x){if(!x||typeof x!="string")throw(0,R.illegalArgument)("label");this.label=x}};ot=Ve([l],ot),e.ColorPresentation=ot;var Et;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Et=e.ColorFormat||(e.ColorFormat={}));var bt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(bt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var _e;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(_e=e.TaskRevealKind||(e.TaskRevealKind={}));var fe;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(fe=e.TaskPanelKind||(e.TaskPanelKind={}));let de=m=class{constructor(x,te){if(typeof x!="string"||typeof te!="string")throw(0,R.illegalArgument)("name");this._id=x}static from(x){switch(x){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}get id(){return this._id}};de.Clean=new m("clean","Clean"),de.Build=new m("build","Build"),de.Rebuild=new m("rebuild","Rebuild"),de.Test=new m("test","Test"),de=m=Ve([l],de),e.TaskGroup=de;function X(j){let x="";for(let te=0;te<j.length;te++)x+=j[te].replace(/,/g,",,")+",";return x}let Fe=class{constructor(x,te,Se){if(typeof x!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=x,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Se):this._options=te)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,R.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let te of this._args)x.push(te);return X(x)}};Fe=Ve([l],Fe),e.ProcessExecution=Fe;let Re=class{constructor(x,te,Se){if(this._args=[],Array.isArray(te)){if(!x)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,R.illegalArgument)("command");this._command=x,this._args=te,this._options=Se}else{if(typeof x!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=x,this._options=te}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,R.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)x.push(typeof te=="string"?te:te.value);return X(x)}};Re=Ve([l],Re),e.ShellExecution=Re;var Ze;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Ze=e.ShellQuoting||(e.ShellQuoting={}));var et;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(et=e.TaskScope||(e.TaskScope={}));class ft{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,I.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=ft;let ct=_=class{constructor(x,te,Se,Ge,Je,at){this.__deprecated=!1,this._definition=this.definition=x;let dt;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Se,this.execution=Ge,dt=Je,this.__deprecated=!0):te===et.Global||te===et.Workspace?(this.target=te,this._name=this.name=Se,this._source=this.source=Ge,this.execution=Je,dt=at):(this.target=te,this._name=this.name=Se,this._source=this.source=Ge,this.execution=Je,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Fe?this._definition={type:_.ProcessType,id:this._execution.computeId()}:this._execution instanceof Re?this._definition={type:_.ShellType,id:this._execution.computeId()}:this._execution instanceof ft?this._definition={type:_.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:_.EmptyType,id:(0,I.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const te=this._definition.type;(_.EmptyType===te||_.ProcessType===te||_.ShellType===te||_.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};ct.ExtensionCallbackType="customExecution",ct.ProcessType="process",ct.ShellType="shell",ct.EmptyType="$empty",ct=_=Ve([l],ct),e.Task=ct;var it;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(it=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(x,te=ht.None){this.collapsibleState=te,D.URI.isUri(x)?this.resourceUri=x:this.label=x}};vt=Ve([l],vt),e.TreeItem=vt;var ht;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let lt=class{constructor(x,te){this.id=x,this.color=te}};lt=Ve([l],lt),e.ThemeIcon=lt,lt.File=new lt("file"),lt.Folder=new lt("folder");let mt=class{constructor(x){this.id=x}};mt=Ve([l],mt),e.ThemeColor=mt;var Pt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(x,te){if(typeof x!="string"&&(!x||!D.URI.isUri(x)&&!D.URI.isUri(x.uri)))throw(0,R.illegalArgument)("base");if(typeof te!="string")throw(0,R.illegalArgument)("pattern");typeof x=="string"?(this.baseFolder=D.URI.file(x),this.base=x):D.URI.isUri(x)?(this.baseFolder=x,this.base=x.fsPath):(this.baseFolder=x.uri,this.base=x.uri.fsPath),this.pattern=te}};Ct=Ve([l],Ct),e.RelativePattern=Ct;let At=class{constructor(x,te,Se,Ge){this.enabled=typeof x=="boolean"?x:!0,typeof te=="string"&&(this.condition=te),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,I.generateUuid)()),this._id}};At=Ve([l],At),e.Breakpoint=At;let Rt=class extends At{constructor(x,te,Se,Ge,Je){super(te,Se,Ge,Je);if(x===null)throw(0,R.illegalArgument)("location");this.location=x}};Rt=Ve([l],Rt),e.SourceBreakpoint=Rt;let St=class extends At{constructor(x,te,Se,Ge,Je){super(te,Se,Ge,Je);this.functionName=x}};St=Ve([l],St),e.FunctionBreakpoint=St;let Xt=class extends At{constructor(x,te,Se,Ge,Je,at,dt){super(Ge,Je,at,dt);if(!te)throw(0,R.illegalArgument)("dataId");this.label=x,this.dataId=te,this.canPersist=Se}};Xt=Ve([l],Xt),e.DataBreakpoint=Xt;let Yt=class{constructor(x,te,Se){this.command=x,this.args=te||[],this.options=Se}};Yt=Ve([l],Yt),e.DebugAdapterExecutable=Yt;let gt=class{constructor(x,te){this.port=x,this.host=te}};gt=Ve([l],gt),e.DebugAdapterServer=gt;let Jt=class{constructor(x){this.path=x}};Jt=Ve([l],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor(x){this.implementation=x}};Zt=Ve([l],Zt),e.DebugAdapterInlineImplementation=Zt;let Dt=class{constructor(x,te){this.range=x,this.expression=te}};Dt=Ve([l],Dt),e.EvaluatableExpression=Dt;var dn;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor(x,te){this.range=x,this.text=te}};en=Ve([l],en),e.InlineValueText=en;let xt=class{constructor(x,te,Se=!0){this.range=x,this.variableName=te,this.caseSensitiveLookup=Se}};xt=Ve([l],xt),e.InlineValueVariableLookup=xt;let ut=class{constructor(x,te){this.range=x,this.expression=te}};ut=Ve([l],ut),e.InlineValueEvaluatableExpression=ut;let tn=class{constructor(x,te){this.frameId=x,this.stoppedLocation=te}};tn=Ve([l],tn),e.InlineValueContext=tn;var Ft;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ft=e.FileChangeType||(e.FileChangeType={}));let Mt=b=class extends Error{constructor(x,te=i.FileSystemProviderErrorCode.Unknown,Se){var Ge;super(D.URI.isUri(x)?x.toString(!0):x);this.code=(Ge=Se==null?void 0:Se.name)!==null&&Ge!==void 0?Ge:"Unknown",(0,i.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(x){return new b(x,i.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(x){return new b(x,i.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(x){return new b(x,i.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(x){return new b(x,i.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(x){return new b(x,i.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(x){return new b(x,i.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Mt=b=Ve([l],Mt),e.FileSystemError=Mt;let qt=class{constructor(x,te,Se){this.start=x,this.end=te,this.kind=Se}};qt=Ve([l],qt),e.FoldingRange=qt;var wn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(wn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var bn;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(bn=e.CommentMode||(e.CommentMode={}));class fn{constructor(x,te=[]){this.tokenTypes=x,this.tokenModifiers=te}}e.SemanticTokensLegend=fn;function Bt(j){return typeof j=="undefined"||(0,k.isStringArray)(j)}class nn{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let te=0,Se=x.tokenTypes.length;te<Se;te++)this._tokenTypeStrToInt.set(x.tokenTypes[te],te);for(let te=0,Se=x.tokenModifiers.length;te<Se;te++)this._tokenModifierStrToInt.set(x.tokenModifiers[te],te)}}push(x,te,Se,Ge,Je){if(typeof x=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof Je=="number"||typeof Je=="undefined"))return typeof Je=="undefined"&&(Je=0),this._pushEncoded(x,te,Se,Ge,Je);if($.isRange(x)&&typeof te=="string"&&Bt(Se))return this._push(x,te,Se);throw(0,R.illegalArgument)()}_push(x,te,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ge=x.start.line,Je=x.start.character,at=x.end.character-x.start.character,dt=this._tokenTypeStrToInt.get(te);let yt=0;if(Se)for(const kt of Se){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const Tt=this._tokenModifierStrToInt.get(kt);yt|=1<<Tt>>>0}this._pushEncoded(Ge,Je,at,dt,yt)}_pushEncoded(x,te,Se,Ge,Je){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let kt=0,Tt=0;for(let Lt=0;Lt<yt;Lt++){let Nt=this._data[5*Lt],cn=this._data[5*Lt+1];Nt===0?(Nt=kt,cn+=Tt):Nt+=kt,this._data[5*Lt]=Nt,this._data[5*Lt+1]=cn,kt=Nt,Tt=cn}}let at=x,dt=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Je,this._prevLine=x,this._prevChar=te}static _sortAndDeltaEncode(x){let te=[];const Se=x.length/5|0;for(let dt=0;dt<Se;dt++)te[dt]=dt;te.sort((dt,yt)=>{const kt=x[5*dt],Tt=x[5*yt];if(kt===Tt){const Lt=x[5*dt+1],Nt=x[5*yt+1];return Lt-Nt}return kt-Tt});const Ge=new Uint32Array(x.length);let Je=0,at=0;for(let dt=0;dt<Se;dt++){const yt=5*te[dt],kt=x[yt+0],Tt=x[yt+1],Lt=x[yt+2],Nt=x[yt+3],cn=x[yt+4],On=kt-Je,zn=On===0?Tt-at:Tt,un=5*dt;Ge[un+0]=On,Ge[un+1]=zn,Ge[un+2]=Lt,Ge[un+3]=Nt,Ge[un+4]=cn,Je=kt,at=Tt}return Ge}build(x){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),x):new Ht(nn._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=nn;class Ht{constructor(x,te){this.resultId=te,this.data=x}}e.SemanticTokens=Ht;class rn{constructor(x,te,Se){this.start=x,this.deleteCount=te,this.data=Se}}e.SemanticTokensEdit=rn;class En{constructor(x,te){this.resultId=te,this.edits=x}}e.SemanticTokensEdits=En;var _n;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(_n=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ot;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(Ot=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new lt("arrow-left")},Kt=Ve([l],Kt),e.QuickInputButtons=Kt;var Sn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Sn=e.ExtensionKind||(e.ExtensionKind={}));class yn{constructor(x,te,Se){this.badge=x,this.tooltip=te,this.color=Se}static validate(x){if(x.badge&&x.badge.length!==1&&x.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=yn;let sn=class{constructor(x){this.kind=x}};sn=Ve([l],sn),e.ColorTheme=sn;var on;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(on=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(x,te){if(x<0)throw(0,R.illegalArgument)("start must be positive");if(te<0)throw(0,R.illegalArgument)("end must be positive");x<=te?(this._start=x,this._end=te):(this._start=te,this._end=x)}static isNotebookRange(x){return x instanceof $t?!0:x?typeof x.start=="number"&&typeof x.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let te=this._start,Se=this._end;return x.start!==void 0&&(te=x.start),x.end!==void 0&&(Se=x.end),te===this._start&&Se===this._end?this:new $t(te,Se)}}e.NotebookRange=$t;class Gt{constructor(x,te){typeof x=="object"?Object.assign(this,x):(this.inputCollapsed=x,this.outputCollapsed=te)}with(x){let{inputCollapsed:te,outputCollapsed:Se}=x,Ge=Qt(x,["inputCollapsed","outputCollapsed"]);return te===void 0?te=this.inputCollapsed:te===null&&(te=void 0),Se===void 0?Se=this.outputCollapsed:Se===null&&(Se=void 0),te===this.inputCollapsed&&Se===this.outputCollapsed&&Object.keys(Ge).length===0?this:new Gt(Object.assign({inputCollapsed:te,outputCollapsed:Se},Ge))}}e.NotebookCellMetadata=Gt;class Wt{constructor(x={}){Object.assign(this,x)}with(x){return new Wt(x)}}e.NotebookDocumentMetadata=Wt;class Me{constructor(x,te,Se,Ge,Je,at){this.kind=x,this.value=te,this.languageId=Se,this.outputs=Ge??[],this.metadata=Je,this.executionSummary=at,Me.validate(this)}static validate(x){if(typeof x.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof x.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof x.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(x){return Array.isArray(x)&&x.every(te=>Me.isNotebookCellData(te))}static isNotebookCellData(x){return!0}}e.NotebookCellData=Me;class an{constructor(x,te){this.cells=x,this.metadata=te??new Wt}}e.NotebookData=an;class It{constructor(x,te,Se){this.data=x,this.mime=te,this.metadata=Se,x instanceof Uint8Array||(this.value=x);const Ge=(0,y.normalizeMimeType)(te,!0);if(!Ge)throw new Error("INVALID mime type, must not be empty or falsy: "+te);this.mime=Ge}static isNotebookCellOutputItem(x){return x instanceof It?!0:x?typeof x.mime=="string":!1}static error(x,te){const Se={name:x.name,message:x.message,stack:x.stack};return It.json(Se,"application/vnd.code.notebook.error",te)}static stdout(x,te){return It.text(x,"application/vnd.code.notebook.stdout",te)}static stderr(x,te){return It.text(x,"application/vnd.code.notebook.stderr",te)}static bytes(x,te="application/octet-stream",Se){return new It(x,te,Se)}static text(x,te="text/plain",Se){const Ge=Be(It,h,"f",E).encode(String(x));return new It(Ge,te,Se)}static json(x,te="application/json",Se){const Ge=JSON.stringify(x,void 0,"	");return It.text(Ge,te,Se)}}e.NotebookCellOutputItem=It,h=It,E={value:new TextEncoder};class pt{constructor(x,te,Se){this.outputs=pt.ensureUniqueMimeTypes(x,!0),typeof te=="string"?(this.id=te,this.metadata=Se):(this.id=(0,I.generateUuid)(),this.metadata=te??Se)}static ensureUniqueMimeTypes(x,te=!1){const Se=new Set,Ge=new Set;for(let Je=0;Je<x.length;Je++){const at=x[Je],dt=(0,y.normalizeMimeType)(at.mime);if(!Se.has(dt)){Se.add(dt);continue}Ge.add(Je),te&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?x:x.filter((Je,at)=>!Ge.has(at))}}e.NotebookCellOutput=pt;var Dn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Dn=e.NotebookCellKind||(e.NotebookCellKind={}));var Cn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Cn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var mn;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(mn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(gn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class kn{constructor(x,te,Se,Ge,Je,at){this.text=x,this.alignment=te,this.command=Se,this.tooltip=Ge,this.priority=Je,this.accessibilityInformation=at}}e.NotebookCellStatusBarItem=kn;var In;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(In=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pn{constructor(x,te=[]){this.uri=x,this.provides=typeof te=="string"?[te]:te}}e.NotebookKernelPreload=Pn;let ln=class{constructor(x,te){this.label=x,this.timestamp=te}};ln=Ve([l],ln),e.TimelineItem=ln;var pn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(pn=e.ExtensionMode||(e.ExtensionMode={}));var An;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(An=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Tn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=4]="RegEx"})(Tn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor(x,te){this.ranges=x,this.wordPattern=te}}e.LinkedEditingRanges=Rn;class Ln{constructor(x,te){this._port=x,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ln;var Fn;(function(j){j[j.Unset=0]="Unset",j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var ee;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information",j[j.Hint=3]="Hint"})(ee=e.TestMessageSeverity||(e.TestMessageSeverity={}));var me;(function(j){j[j.Pending=0]="Pending",j[j.Resolved=1]="Resolved"})(me=e.TestItemStatus||(e.TestItemStatus={}));const Ae=(j,x,te,Se)=>{let Ge=te;return{enumerable:!0,configurable:!1,get(){return Ge},set(Je){Se(Ge,Je)||(Ge=Je,j.bus.fire([3,x,Je]))}}},st=(j,x)=>j===x,wt=(j,x)=>j===x?!0:!j||!x?!1:j.isEqual(x);class _t{constructor(x,te,Se,Ge){this.label=te,this.data=Ge;const Je=(0,d.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:x,enumerable:!0,writable:!1},uri:{value:Se,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>Je.parent},children:{value:new T.ReadonlyMapView(Je.children),enumerable:!0,writable:!1},range:Ae(Je,"range",void 0,wt),description:Ae(Je,"description",void 0,st),runnable:Ae(Je,"runnable",!0,st),debuggable:Ae(Je,"debuggable",!1,st),status:Ae(Je,"status",me.Resolved,st),error:Ae(Je,"error",void 0,st)})}invalidate(){(0,d.getPrivateApiFor)(this).bus.fire([2])}dispose(){const x=(0,d.getPrivateApiFor)(this);x.parent&&(0,d.getPrivateApiFor)(x.parent).children.delete(this.id),x.bus.fire([1])}addChild(x){if(!(x instanceof _t))throw new Error("Test child must be created through vscode.test.createTestItem()");const te=(0,d.getPrivateApiFor)(this);if(te.children.has(x.id))throw new Error(`Attempted to insert a duplicate test item ID ${x.id}`);te.children.set(x.id,x),te.bus.fire([0,x])}}e.TestItemImpl=_t;class Mn{constructor(x){this.message=x,this.severity=ee.Error}static diff(x,te,Se){const Ge=new Mn(x);return Ge.expectedOutput=te,Ge.actualOutput=Se,Ge}}e.TestMessage=Mn;var $n;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})($n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Wn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Wn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Hn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore"})(Hn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[120],pe([0,1,51,10,8,146,107,7,16]),function(G,e,w,R,C,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function i(a,h){h?I.set(a,h):I.delete(a)}e.setWordDefinitionFor=i;function A(a){return I.get(a)}e.getWordDefinitionFor=A;class d extends T.MirrorTextModel{constructor(h,E,v,S,u,f,c,t){super(E,v,S,u);this._proxy=h,this._languageId=f,this._isDirty=c,this._notebook=t,this._isDisposed=!1}dispose(){(0,w.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,D.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===R.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(E){return E?h._getTextInRange(E):h.getText()},get eol(){return h._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(E){return h._lineAt(E)},offsetAt(E){return h._offsetAt(E)},positionAt(E){return h._positionAt(E)},validateRange(E){return h._validateRange(E)},validatePosition(E){return h._validatePosition(E)},getWordRangeAtPosition(E,v){return h._getWordRangeAtPosition(E,v)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,w.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,w.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const E=this._validateRange(h);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const v=this._eol,S=E.start.line,u=E.end.line,f=[];f.push(this._lines[S].substring(E.start.character));for(let c=S+1;c<u;c++)f.push(this._lines[c]);return f.push(this._lines[u].substring(0,E.end.character)),f.join(v)}_lineAt(h){let E;if(h instanceof k.Position?E=h.line:typeof h=="number"&&(E=h),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new p(E,this._lines[E],E===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(h),v=this._lines[E.index].length;return new k.Position(E.index,Math.min(E.remainder,v))}_validateRange(h){if(!(h instanceof k.Range))throw new Error("Invalid argument");const E=this._validatePosition(h.start),v=this._validatePosition(h.end);return E===h.start&&v===h.end?h:new k.Range(E.line,E.character,v.line,v.character)}_validatePosition(h){if(!(h instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:E,character:v}=h,S=!1;if(E<0)E=0,v=0,S=!0;else if(E>=this._lines.length)E=this._lines.length-1,v=this._lines[E].length,S=!0;else{const u=this._lines[E].length;v<0?(v=0,S=!0):v>u&&(v=u,S=!0)}return S?new k.Position(E,v):h}_getWordRangeAtPosition(h,E){const v=this._validatePosition(h);if(!E)E=A(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const S=(0,y.getWordAtText)(v.character+1,(0,y.ensureValidWordDefinition)(E),this._lines[v.line],0);if(S)return new k.Range(v.line,S.startColumn-1,v.line,S.endColumn-1)}}e.ExtHostDocumentData=d;class p{constructor(h,E,v){this._line=h,this._text=E,this._isLastLine=v}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(ge[198],pe([0,1,7,3,109,6,78,22,2,32]),function(G,e,w,R,C,T,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(d,p,a,h){this._notebook=a,this._selector=h,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,I.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(v=>{const S=this._cellUris.get(v.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=v=>{v===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(v=>E(v.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const d=[],p=[];for(const a of this._notebook.getCells())a.kind===w.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),d.push(a.document.getText().length+1),p.push(a.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(d){var p,a;if(!d){let u="";for(const f of this._cells)u+=f.document.getText()+`
`;return u=u.slice(0,-1),u}if(d.isEmpty)return"";const h=this.locationAt(d.start),E=this.locationAt(d.end),v=this._cells[(p=this._cellUris.get(h.uri))!==null&&p!==void 0?p:-1],S=this._cells[(a=this._cellUris.get(E.uri))!==null&&a!==void 0?a:-1];if(!v||!S)return"";if(v===S)return v.document.getText(new w.Range(h.range.start,E.range.end));{const u=v.document.getText(new w.Range(h.range.start,new w.Position(v.document.lineCount,0))),f=S.document.getText(new w.Range(new w.Position(0,0),E.range.end));return u+`
`+f}}offsetAt(d){const p=this._cellLines.getIndexOf(d.line),a=this._cellLengths.getAccumulatedValue(p.index-1),h=this._cells[p.index].document.offsetAt(d.with(p.remainder));return a+h}positionAt(d){if(typeof d=="number"){const a=this._cellLengths.getIndexOf(d),h=this._cellLines.getAccumulatedValue(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(h)}const p=this._cellUris.get(d.uri);if(p!==void 0){const a=this._cellLines.getAccumulatedValue(p-1);return new w.Position(a+d.range.start.line,d.range.start.character)}return new w.Position(0,0)}locationAt(d){w.Range.isRange(d)||(d=new w.Range(d,d));const p=this._cellLines.getIndexOf(d.start.line);let a=p;d.isEmpty||(a=this._cellLines.getIndexOf(d.end.line));const h=new w.Position(p.remainder,d.start.character),E=new w.Position(a.remainder,d.end.character),v=new w.Range(h,E),S=this._cells[p.index];return new w.Location(S.document.uri,S.document.validateRange(v))}contains(d){return this._cellUris.has(d)}validateRange(d){const p=this.validatePosition(d.start),a=this.validatePosition(d.end);return d.with(p,a)}validatePosition(d){const p=this._cellLines.getIndexOf(d.line),a=new w.Position(p.remainder,d.character),h=this._cells[p.index].document.validatePosition(a),E=this._cellLines.getAccumulatedValue(p.index-1);return new w.Position(E+h.line,h.character)}}e.ExtHostNotebookConcatDocument=i}),define(ge[199],pe([0,1,7,15,3]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(k){this._actual=new w.ColorTheme(w.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let D=k==="light"?w.ColorThemeKind.Light:k==="dark"?w.ColorThemeKind.Dark:w.ColorThemeKind.HighContrast;this._actual=new w.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Ve([He(0,R.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(ge[63],pe([0,1,4]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,w.createDecorator)("IURITransformerService");class R{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=R}),define(ge[200],pe([0,1,23]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(D){let I=this.buffers.indexOf(D);return I<0&&(I=this.buffers.length,this.buffers.push(D)),I}}function C(k,D){if(D.serializeBuffersForPostMessage){const I=new R,i=(p,a)=>{if(a instanceof ArrayBuffer){const h=I.add(a);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(a)){const h=T(a);if(h){const E=I.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:h,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},A=JSON.stringify(k,i),d=I.buffers.map(p=>{const a=new Uint8Array(p);return w.VSBuffer.wrap(a)});return{message:A,buffers:d}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=C;function T(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(k,D){const I=D.map(d=>{const p=new ArrayBuffer(d.byteLength);return new Uint8Array(p).set(d.buffer),p}),i=D.length?(d,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const a=p,{index:h}=a,E=I[h];if(a.view)switch(a.view.type){case 1:return new Int8Array(E,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return p}:void 0;return{message:JSON.parse(k,i),arrayBuffers:I}}e.deserializeWebviewMessage=y}),define(ge[87],pe([0,1,10,2]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function C(T,y){return T.scheme===w.Schemas.http||T.scheme===w.Schemas.https?T:(y&&y.authority&&y.isRemote&&T.scheme===w.Schemas.file&&(T=R.URI.from({scheme:w.Schemas.vscodeRemote,authority:y.authority,path:T.path})),R.URI.from({scheme:w.Schemas.https,authority:`${T.scheme}+${T.authority}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=C}),define(ge[201],pe([0,1,3,6,87]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(k,D,I){this._proxy=k,this._editors=D,this._initData=I,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const i=D.getVisibleTextEditors();for(const A of this._insets.values())i.indexOf(A.editor)<0&&A.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,D,I,i,A){let d;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===k){d=u;break}if(!d)throw new Error("not a visible editor");const p=this,a=this._handlePool++,h=new w.Emitter,E=new w.Emitter,v=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,C.asWebviewUri)(u,p._initData.remote)}get cspSource(){return C.webviewGenericCspSource}set options(u){this._options=u,p._proxy.$setOptions(a,u)}get options(){return this._options}set html(u){this._html=u,p._proxy.$setHtml(a,u)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(u){return p._proxy.$postMessage(a,u)}},S=new class{constructor(){this.editor=k,this.line=D,this.height=I,this.webview=v,this.onDidDispose=E.event}dispose(){p._insets.has(a)&&(p._insets.delete(a),p._proxy.$disposeEditorInset(a),E.fire(),E.dispose(),h.dispose())}};return this._proxy.$createEditorInset(a,d.id,d.value.document.uri,D+1,I,i||{},A.identifier,A.extensionLocation),this._insets.set(a,{editor:k,inset:S,onDidReceiveMessage:h}),S}$onDidDispose(k){const D=this._insets.get(k);D&&D.inset.dispose()}$onDidReceiveMessage(k,D){const I=this._insets.get(k);I&&I.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=T}),define(ge[202],pe([0,1,3,81,169,4,6,22,38,16,52,25,45,195]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,p.registerIcon)("default-view-icon",d.Codicon.window,(0,C.localize)(0,null));var a;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var h;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel"})(h=e.ViewContainerLocation||(e.ViewContainerLocation={}));function E(o){switch(o){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=E;function v(o){return`viewContainer.${o}.enabled`}e.getEnabledViewContainerContextKey=v;class S extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new w.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new w.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,I.flatten)([...this.viewContainers.values()])}registerViewContainer(g,m,_){var b;const l=this.get(g.id);if(l)return l;const L=g;return L.openCommandActionDescriptor=(_==null?void 0:_.donotRegisterOpenCommand)?void 0:(b=L.openCommandActionDescriptor)!==null&&b!==void 0?b:{id:L.id},(0,k.getOrSet)(this.viewContainers,m,[]).push(L),(_==null?void 0:_.isDefault)&&this.defaultViewContainers.push(L),this._onDidRegister.fire({viewContainer:L,viewContainerLocation:m}),L}deregisterViewContainer(g){for(const m of this.viewContainers.keys()){const _=this.viewContainers.get(m),b=_==null?void 0:_.indexOf(g);if(b!==-1){_==null||_.splice(b,1),_.length===0&&this.viewContainers.delete(m),this._onDidDeregister.fire({viewContainer:g,viewContainerLocation:m});return}}}get(g){return this.all.filter(m=>m.id===g)[0]}getViewContainers(g){return[...this.viewContainers.get(g)||[]]}getViewContainerLocation(g){return[...this.viewContainers.keys()].filter(m=>this.getViewContainers(m).filter(_=>(_==null?void 0:_.id)===g.id).length>0)[0]}getDefaultViewContainer(g){return this.defaultViewContainers.find(m=>this.getViewContainerLocation(m)===g)}}D.Registry.add(a.ViewContainersRegistry,new S);var u;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function f(o,g){var m,_,b,l;const L=(m=o.group)!==null&&m!==void 0?m:u.More,O=(_=g.group)!==null&&_!==void 0?_:u.More;return L!==O?L.localeCompare(O):((b=o.order)!==null&&b!==void 0?b:5)-((l=g.order)!==null&&l!==void 0?l:5)}class c extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new w.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new w.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new w.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new w.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(g,m){this.registerViews2([{views:g,viewContainer:m}])}registerViews2(g){g.forEach(({views:m,viewContainer:_})=>this.addViews(m,_)),this._onViewsRegistered.fire(g)}deregisterViews(g,m){const _=this.removeViews(g,m);_.length&&this._onViewsDeregistered.fire({views:_,viewContainer:m})}moveViews(g,m){for(const _ of this._views.keys())if(_!==m){const b=this.removeViews(g,_);b.length&&(this.addViews(b,m),this._onDidChangeContainer.fire({views:b,from:_,to:m}))}}getViews(g){return this._views.get(g)||[]}getView(g){for(const m of this._viewContainers){const _=(this._views.get(m)||[]).filter(b=>b.id===g)[0];if(_)return _}return null}getViewContainer(g){for(const m of this._viewContainers)if((this._views.get(m)||[]).filter(b=>b.id===g)[0])return m;return null}registerViewWelcomeContent(g,m){return this._viewWelcomeContents.add(g,m),this._onDidChangeViewWelcomeContent.fire(g),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(g,m),this._onDidChangeViewWelcomeContent.fire(g)})}registerViewWelcomeContent2(g,m){const _=new Map;for(const[b,l]of m)this._viewWelcomeContents.add(g,l),_.set(b,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(g,l),this._onDidChangeViewWelcomeContent.fire(g)}));return this._onDidChangeViewWelcomeContent.fire(g),_}getViewWelcomeContent(g){const m=[];return this._viewWelcomeContents.forEach(g,_=>m.push(_)),m.sort(f)}addViews(g,m){let _=this._views.get(m);_||(_=[],this._views.set(m,_),this._viewContainers.push(m));for(const b of g){if(this.getView(b.id)!==null)throw new Error((0,C.localize)(1,null,b.id));_.push(b)}}removeViews(g,m){const _=this._views.get(m);if(!_)return[];const b=[],l=[];for(const L of _)g.includes(L)?b.push(L):l.push(L);return b.length&&(l.length?this._views.set(m,l):(this._views.delete(m),this._viewContainers.splice(this._viewContainers.indexOf(m),1))),b}}D.Registry.add(a.ViewsRegistry,new c),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,C.localize)(2,null));function t(o){return`view.${o}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(g,m){this.resolved=!1,this._hasResolve=!1,(0,A.mixin)(this,g),this._hasResolve=!!m,this.resolve=async _=>{var b,l;if(m&&!this.resolved){const L=await m(_);L&&(this.tooltip=(b=this.tooltip)!==null&&b!==void 0?b:L.tooltip,this.command=(l=this.command)!==null&&l!==void 0?l:L.command)}_.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(ge[203],pe([0,1,2,180,118,14,181,202]),function(G,e,w,R,C,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(a){return(h,...E)=>a(h.get(R.ICommandService),...E)}class I{static execute(h,E){const v={forceReuseWindow:E&&E.reuseWindow,remoteAuthority:E&&E.remoteAuthority};return h.executeCommand("_files.newWindow",v)}}e.NewWindowAPICommand=I,I.ID="vscode.newWindow",R.CommandsRegistry.registerCommand({id:I.ID,handler:D(I.execute),description:{description:"Opens an new window",args:[]}}),R.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(a,h){return a.get(C.IWorkspacesService).removeRecentlyOpened([h])});class i{static execute(h,E){return typeof E=="string"?E=E.match(/^[^:/?#]+:\/\//)?w.URI.parse(E):w.URI.file(E):E=w.URI.revive(E),h.executeCommand("_workbench.removeFromRecentlyOpened",E)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",R.CommandsRegistry.registerCommand(i.ID,D(i.execute)),R.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(a,h){const E=a.get(C.IWorkspacesService);let v;const S=h.uri,u=h.label,f=h.remoteAuthority;return h.type==="workspace"?v={workspace:await E.getWorkspaceIdentifier(S),label:u,remoteAuthority:f}:h.type==="folder"?v={folderUri:S,label:u,remoteAuthority:f}:v={fileUri:S,label:u,remoteAuthority:f},E.addRecentlyOpened([v])}),R.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(a){return a.get(C.IWorkspacesService).getRecentlyOpened()}),R.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(a,h){const E=a.get(T.ILogService),v=a.get(y.IEnvironmentService);v.isExtensionDevelopment&&!!v.extensionTestsLocationURI&&E.setLevel(h)}),R.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(a){return a.get(T.ILogService).getLevel()}),R.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(a,h){const E=a.get(k.IViewDescriptorService),v=E.getViewContainerById(h.destinationId);if(!!v){for(const S of h.viewIds){const u=E.getViewDescriptorById(S);(u==null?void 0:u.canMoveView)&&E.moveViewsToContainer([u],v,k.ViewVisibilityState.Default)}await a.get(k.IViewsService).openViewContainer(v.id,!0)}});class A{static execute(h,E){return!Array.isArray(E==null?void 0:E.viewIds)||typeof(E==null?void 0:E.destinationId)!="string"?Promise.reject("Invalid arguments"):h.executeCommand("_workbench.action.moveViews",E)}}e.MoveViewsAPICommand=A,A.ID="vscode.moveViews",R.CommandsRegistry.registerCommand({id:A.ID,handler:D(A.execute),description:{description:"Move Views",args:[]}});class d{static execute(h,E){return h.executeCommand("_workbench.open",E)}}d.ID="vscode.open",R.CommandsRegistry.registerCommand(d.ID,D(d.execute));class p{static execute(h,E,v,S,u){return h.executeCommand("_workbench.diff",[E,v,S])}}p.ID="vscode.diff",R.CommandsRegistry.registerCommand(p.ID,D(p.execute))}),define(ge[121],pe([0,1,3,13,170]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new w.Emitter,this._onExit=new w.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,D,I,i){const A={command:k};if(D&&Object.keys(D).length>0&&(A.arguments=D),this.internalSend("request",A),typeof i=="number"){const d=setTimeout(()=>{clearTimeout(d);const p=this.pendingRequests.get(A.seq);if(p){this.pendingRequests.delete(A.seq);const a={type:"response",seq:0,request_seq:A.seq,success:!1,command:k,message:(0,C.localize)(0,null,i,k)};p(a)}},i)}return I&&this.pendingRequests.set(A.seq,I),A.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,D){return k.type!=="event"||D.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,R.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const D=k,I=this.pendingRequests.get(D.request_seq);I&&(this.pendingRequests.delete(D.request_seq),I(D));break}}}internalSend(k,D){D.type=k,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((D,I)=>k.set(I,D)),await(0,R.timeout)(500),k.forEach((D,I)=>{D({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(ge[204],pe([0,1,8,2,9,25,10]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function D(n,s,r){return n.replace(k,function(o,g){return s&&g.length>0&&g[0]!=="_"?o:r&&r.hasOwnProperty(g)?r[g]:o})}e.formatPII=D;function I(n){const s={};for(const r of Object.keys(n))r.startsWith("!")||(s[r]=n[r]);return s}e.filterExceptionsFromTelemetry=I;function i(n){return n.configuration.request==="attach"&&!A(n)}e.isSessionAttach=i;function A(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),(0,w.equalsIgnoreCase)(s,"extensionhost")||(0,w.equalsIgnoreCase)(s,"pwa-extensionhost")?n:n.parentSession?A(n.parentSession):void 0}e.getExtensionHostDebugSession=A;function d(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=d;function p(n,s,r){let o,g=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=m.exec(n);){let b=_.index+1,l=b+_[0].length;if(b<=s&&l>=r){o=_[0],g=b;break}}if(o){let b=/\w+/g,l=null;for(;(l=b.exec(o))&&!(l.index+1+g+l[0].length>=r););l&&(o=o.substring(0,b.lastIndex))}return o?{start:g,end:g+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(n){return!!(n&&n.match(a))}e.isUri=h;function E(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(h(n.path))return R.URI.parse(n.path);if((0,C.isAbsolute)(n.path))return R.URI.file(n.path)}return n.path}function v(n){if(typeof n.path=="object"){const s=R.URI.revive(n.path);if(s)return s.scheme===y.Schemas.file?s.fsPath:s.toString()}return n.path}function S(n,s){const r=s?E:v,o=(0,T.deepClone)(n);return f(o,(g,m)=>{g&&m&&(m.path=r(m))}),o}e.convertToDAPaths=S;function u(n,s){const r=s?E:v,o=(0,T.deepClone)(n);return f(o,(g,m)=>{!g&&m&&(m.path=r(m))}),o}e.convertToVSCPaths=u;function f(n,s){switch(n.type){case"event":const r=n;switch(r.event){case"output":s(!1,r.body.source);break;case"loadedSource":s(!1,r.body.source);break;case"breakpoint":s(!1,r.body.breakpoint.source);break;default:break}break;case"request":const o=n;switch(o.command){case"setBreakpoints":s(!0,o.arguments.source);break;case"breakpointLocations":s(!0,o.arguments.source);break;case"source":s(!0,o.arguments.source);break;case"gotoTargets":s(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(m=>s(!1,m));break;default:break}break;case"response":const g=n;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(m=>s(!1,m.source));break;case"loadedSources":g.body.sources.forEach(m=>s(!1,m));break;case"scopes":g.body.scopes.forEach(m=>s(!1,m.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(m=>s(!1,m.source));break;case"setBreakpoints":g.body.breakpoints.forEach(m=>s(!1,m.source));break;default:break}break}}function c(n){return n.filter(s=>{var r;return!((r=s.presentation)===null||r===void 0?void 0:r.hidden)}).sort((s,r)=>s.presentation?r.presentation?s.presentation.group?r.presentation.group?s.presentation.group!==r.presentation.group?s.presentation.group.localeCompare(r.presentation.group):t(s.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(s.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=c;function t(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}}),define(ge[205],pe([0,1,28,37,171,122,9,8,25,11,182,121]),function(G,e,w,R,C,T,y,k,D,I,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class d extends A.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(S,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,S.on("data",f=>this.handleData(f))}sendMessage(S){if(this.outputStream){const u=JSON.stringify(S);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${d.TWO_CRLF}${u}`,"utf8")}}handleData(S){for(this.rawData=Buffer.concat([this.rawData,S]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(f){this._onError.fire(new Error((f.message||f)+`
`+u))}continue}}else{const u=this.rawData.indexOf(d.TWO_CRLF);if(u!==-1){const c=this.rawData.toString("utf8",0,u).split(d.HEADER_LINESEPARATOR);for(const t of c){const n=t.split(d.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(u+d.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=d,d.TWO_CRLF=`\r
\r
`,d.HEADER_LINESEPARATOR=/\r?\n/,d.HEADER_FIELDSEPARATOR=/: */;class p extends d{startSession(){return new Promise((S,u)=>{let f=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),S(),f=!0}),this.socket.on("close",()=>{f?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",c=>{f?this._onError.fire(c):u(c)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class a extends p{constructor(S){super();this.adapterServer=S}createConnection(S){return T.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",S)}}e.SocketDebugAdapter=a;class h extends p{constructor(S){super();this.adapterServer=S}createConnection(S){return T.createConnection(this.adapterServer.path,S)}}e.NamedPipeDebugAdapter=h;class E extends d{constructor(S,u,f){super();this.adapterExecutable=S,this.debugType=u,this.outputService=f}async startSession(){const S=this.adapterExecutable.command,u=this.adapterExecutable.args,f=this.adapterExecutable.options||{};try{if(S)if(y.isAbsolute(S)){if(!await(0,w.exists)(S))throw new Error(C.localize(0,null,S))}else S.indexOf("/")<0&&S.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let c=process.env;if(f.env&&Object.keys(f.env).length>0&&(c=D.mixin(D.deepClone(process.env),f.env)),S==="node")if(Array.isArray(u)&&u.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:c,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};f.cwd&&(s.cwd=f.cwd);const r=R.fork(u[0],u.slice(1),s);if(!r.pid)throw new Error(C.localize(2,null,u[0]));this.serverProcess=r}else throw new Error(C.localize(3,null));else{const n={env:c};f.cwd&&(n.cwd=f.cwd),this.serverProcess=R.spawn(S,u,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,s)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const r=t.getChannel(i.ExtensionsChannelId);r&&r.append(n(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(c){this._onError.fire(c)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((S,u)=>{const f=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(c,t,n){if(c)return u(c)});f.on("exit",S),f.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(S,u){if(!S)return;const f=Object.create(null);S.runtime&&(S.runtime.indexOf("./")===0?f.runtime=y.join(u,S.runtime):f.runtime=S.runtime),S.runtimeArgs&&(f.runtimeArgs=S.runtimeArgs),S.program&&(y.isAbsolute(S.program)?f.program=S.program:f.program=y.join(u,S.program)),S.args&&(f.args=S.args);const c=S;return c.win&&(f.win=E.extract(c.win,u)),c.winx86&&(f.winx86=E.extract(c.winx86,u)),c.windows&&(f.windows=E.extract(c.windows,u)),c.osx&&(f.osx=E.extract(c.osx,u)),c.linux&&(f.linux=E.extract(c.linux,u)),f}static platformAdapterExecutable(S,u){let f=Object.create(null);u=u.toLowerCase();for(const o of S)if(o.contributes){const g=o.contributes.debuggers;g&&g.length>0&&g.filter(m=>typeof m.type=="string"&&k.equalsIgnoreCase(m.type,u)).forEach(m=>{const _=E.extract(m,o.extensionLocation.fsPath);f=D.mixin(f,_,o.isBuiltin)})}let c;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?c=f.winx86||f.win||f.windows:I.isWindows?c=f.win||f.windows:I.isMacintosh?c=f.osx:I.isLinux&&(c=f.linux),c=c||f;let t=c.program||f.program;const n=c.args||f.args;let s=c.runtime||f.runtime;const r=c.runtimeArgs||f.runtimeArgs;if(s)return{type:"executable",command:s,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=E}),define(ge[206],pe([0,1,37,11,29,190]),function(G,e,w,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function y(d,p){return new Promise((a,h)=>{let E="";const v=w.spawn(d,p);v.pid&&v.stdout.on("data",S=>{E+=S.toString()}),v.on("error",S=>{h(S)}),v.on("close",S=>{a(E)})})}let k;function D(d,p){if(!k)if(R.isWindows)k=new T.WindowsExternalTerminalService(void 0);else if(R.isMacintosh)k=new T.MacExternalTerminalService(void 0);else if(R.isLinux)k=new T.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const a=p.getConfiguration("terminal");return k.runInTerminal(d.title,d.cwd,d.args,d.env||{},a.external||{})}e.runInExternalTerminal=D;function I(d){return d?R.isWindows?new Promise(async p=>{(await new Promise((h,E)=>{G(["windows-process-tree"],h,E)})).getProcessTree(d,h=>{p(h.children.length>0)})}):y("/usr/bin/pgrep",["-lP",String(d)]).then(p=>{const a=p.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},p=>!0):Promise.resolve(!0)}e.hasChildProcesses=I;var i;(function(d){d[d.cmd=0]="cmd",d[d.powershell=1]="powershell",d[d.bash=2]="bash"})(i||(i={}));function A(d,p,a,h){d=d.trim().toLowerCase();let E;d.indexOf("powershell")>=0||d.indexOf("pwsh")>=0?E=1:d.indexOf("cmd.exe")>=0?E=0:d.indexOf("bash")>=0?E=2:R.isWindows?E=0:E=2;let v,S=" ";switch(E){case 1:if(v=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),a){const f=(0,C.getDriveLetter)(a);f&&(S+=`${f}:; `),S+=`cd ${v(a)}; `}if(h)for(let f in h){const c=h[f];c===null?S+=`Remove-Item env:${f}; `:S+=`\${env:${f}}='${c}'; `}if(p.length>0){const f=v(p.shift());S+=f[0]==="'"?`& ${f} `:`${f} `;for(let c of p)S+=`${v(c)} `}break;case 0:if(v=f=>(f=f.replace(/\"/g,'""'),f.indexOf(" ")>=0||f.indexOf('"')>=0||f.length===0?`"${f}"`:f),a){const f=(0,C.getDriveLetter)(a);f&&(S+=`${f}: && `),S+=`cd ${v(a)} && `}if(h){S+='cmd /C "';for(let f in h){let c=h[f];c===null?S+=`set "${f}=" && `:(c=c.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),S+=`set "${f}=${c}" && `)}}for(let f of p)S+=`${v(f)} `;h&&(S+='"');break;case 2:v=f=>(f=f.replace(/(["'\\\$])/g,"\\$1"),f.indexOf(" ")>=0||f.indexOf(";")>=0||f.length===0?`"${f}"`:f);const u=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(a&&(S+=`cd ${v(a)} ; `),h){S+="/usr/bin/env";for(let f in h){const c=h[f];c===null?S+=` -u ${u(f)}`:S+=` ${u(`${f}=${c}`)}`}S+=" "}for(let f of p)S+=`${v(f)} `;break}return S}e.prepareCommand=A}),define(ge[64],pe([0,1,30,10,9,11,81]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarPosition=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarAfterExecuteKey=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(b){b[b.Markup=1]="Markup",b[b.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(b){b[b.Running=1]="Running",b[b.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var I;(function(b){b[b.Pending=2]="Pending",b[b.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(b){b[b.WithHardKernelDependency=0]="WithHardKernelDependency",b[b.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",b[b.Pure=2]="Pure",b[b.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var A;(function(b){b[b.ModelChange=1]="ModelChange",b[b.Move=2]="Move",b[b.CellClearOutput=3]="CellClearOutput",b[b.CellsClearOutput=4]="CellsClearOutput",b[b.ChangeLanguage=5]="ChangeLanguage",b[b.Initialize=6]="Initialize",b[b.ChangeCellMetadata=7]="ChangeCellMetadata",b[b.Output=8]="Output",b[b.OutputItem=9]="OutputItem",b[b.ChangeCellContent=10]="ChangeCellContent",b[b.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",b[b.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",b[b.Unknown=100]="Unknown"})(A=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(b){b[b.Handle=0]="Handle",b[b.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(b){b[b.Replace=1]="Replace",b[b.Output=2]="Output",b[b.Metadata=3]="Metadata",b[b.CellLanguage=4]="CellLanguage",b[b.DocumentMetadata=5]="DocumentMetadata",b[b.Move=6]="Move",b[b.OutputItems=7]="OutputItems",b[b.PartialMetadata=8]="PartialMetadata",b[b.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));function a(b,l){if(l)return b.toString();const L=h.parse(b);return L?L.notebook.toString():b.toString()}e.getCellUndoRedoComparisonKey=a;var h;(function(b){b.scheme=R.Schemas.vscodeNotebookCell;const l=/^ch(\d{7,})/;function L(U,V){return U.with({scheme:b.scheme,fragment:`ch${V.toString().padStart(7,"0")}${U.scheme!==R.Schemas.file?U.scheme:""}`})}b.generate=L;function O(U){if(U.scheme!==b.scheme)return;const V=l.exec(U.fragment);return V?{handle:Number(V[1]),notebook:U.with({scheme:U.fragment.substr(V[0].length)||R.Schemas.file,fragment:null})}:void 0}b.parse=O;function $(U){if(U.scheme!==R.Schemas.vscodeNotebookCellMetadata)return;const V=l.exec(U.fragment);return V?{handle:Number(V[1]),notebook:U.with({scheme:U.fragment.substr(V[0].length)||R.Schemas.file,fragment:null})}:void 0}b.parseCellMetadataUri=$;function ie(U,V,W){return U.with({scheme:W,fragment:`ch${V.toString().padStart(7,"0")}${U.scheme!==R.Schemas.file?U.scheme:""}`})}b.generateCellUri=ie;function se(U,V){if(U.scheme!==V)return;const W=l.exec(U.fragment);return W?{handle:Number(W[1]),notebook:U.with({scheme:U.fragment.substr(W[0].length)||R.Schemas.file,fragment:null})}:void 0}b.parseCellUri=se})(h=e.CellUri||(e.CellUri={}));const E=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}]]);function v(b){var l,L;return(L=(l=E.get(b))===null||l===void 0?void 0:l.alwaysSecure)!==null&&L!==void 0?L:!1}e.mimeTypeIsAlwaysSecure=v;function S(b){var l,L;return(L=(l=E.get(b))===null||l===void 0?void 0:l.supportedByCore)!==null&&L!==void 0?L:!1}e.mimeTypeSupportedByCore=S;function u(b){var l,L;return(L=(l=E.get(b))===null||l===void 0?void 0:l.mergeable)!==null&&L!==void 0?L:!1}e.mimeTypeIsMergeable=u;function f(b,l){return T.isWindows&&(b=b.replace(/\//g,"\\"),l=l.replace(/\//g,"\\")),w.match(b,l)}function c(b,l,L){let O=0;for(let $=0;$<l.length;$++){if(f(l[$],b))return O;O++}for(let $=0;$<L.length;$++){if(f(L[$],b))return O;O++}return O}function t(b,l,L){return b.sort((O,$)=>c(O,l,L)-c($,l,L))}e.sortMimeTypes=t;function n(b,l,L,O=($,ie)=>$===ie){const $=[];function ie(V,W,P){if(W===0&&P.length===0)return;const N=$[$.length-1];N&&N.start+N.deleteCount===V?(N.deleteCount+=W,N.toInsert.push(...P)):$.push({start:V,deleteCount:W,toInsert:P})}let se=0,U=0;for(;;){if(se===b.length){ie(se,0,l.slice(U));break}if(U===l.length){ie(se,b.length-se,[]);break}const V=b[se],W=l[U];if(O(V,W)){se+=1,U+=1;continue}L(W)?(ie(se,1,[]),se+=1):(ie(se,0,[W]),U+=1)}return $}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(b){b.default="default",b.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(b){const l=b;return!!((typeof l.include=="string"||w.isRelativePattern(l.include))&&(typeof l.exclude=="string"||w.isRelativePattern(l.exclude)))}e.isDocumentExcludePattern=r;function o(b,l,L){if(Array.isArray(b.viewType)&&b.viewType.indexOf(l)>=0||b.viewType===l)return!0;if(b.filenamePattern){let O=r(b.filenamePattern)?b.filenamePattern.include:b.filenamePattern,$=r(b.filenamePattern)?b.filenamePattern.exclude:void 0;if(w.match(O,(0,C.basename)(L.fsPath).toLowerCase()))return!($&&w.match($,(0,C.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class g{constructor(l){this.textModel=l}getElements(){const l=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)l[L]=this.textModel.cells[L].getHashValue();return l}}e.CellSequence=g,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.ShowCellStatusBarAfterExecuteKey="notebook.showCellStatusBarAfterExecute",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarPosition="notebook.insertToolbarPosition",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled";var m;(function(b){b[b.Left=1]="Left",b[b.Right=2]="Right"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class _{static create(l){return`${_._prefix}${l}`}static parse(l){if(l.startsWith(_._prefix))return l.substr(_._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=_,_._prefix="notebook/"}),define(ge[207],pe([0,1,173,4,81]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,w.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,w.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,w.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[208],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function w(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=w;function R(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=R}),define(ge[123],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var w;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(D,I)=>{I.expand!==void 0&&(D.expand=I.expand),I.item!==void 0&&(D.item=D.item?Object.assign(D.item,I.item):I.item)};e.applyTestItemUpdate=R;var C;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(D,I)=>`${D}:${I.toString()}`;e.getTestSubscriptionKey=T;class y{add(I){}update(I){}remove(I,i){}complete(){}}e.IncrementalChangeCollector=y;class k{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(I){const i=this.createChangeCollector();for(const A of I)switch(A[0]){case 0:{const d=A[1];if(d.parent){if(this.items.has(d.parent)){const p=this.items.get(d.parent);p.children.add(d.item.extId);const a=this.createItem(d,p);this.items.set(d.item.extId,a),i.add(a)}}else{this.roots.add(d.item.extId);const p=this.createItem(d);this.items.set(d.item.extId,p),i.add(p)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=A[1],p=this.items.get(d.extId);if(!p)break;d.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,d),i.update(p);break}case 2:{const d=this.items.get(A[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d.item.extId);const p=[[A[1]]];for(;p.length;)for(const a of p.pop()){const h=this.items.get(a);h&&(p.push(h.children),this.items.delete(a),i.remove(h,h!==d),h.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(A[1]);break;case 3:this.updatePendingRoots(A[1]);break}i.complete()}retireTest(I){}updatePendingRoots(I){this.pendingRootCount+=I}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=k}),define(ge[209],pe([0,1,9,36,12,25,11,77,174]),function(G,e,w,R,C,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(A,d,p){this._contributedVariables=new Map,this._context=A,this._labelService=d,p&&(this._envVariablesPromise=p.then(a=>this.prepareEnv(a)))}prepareEnv(A){if(y.isWindows){const d=Object.create(null);return Object.keys(A).forEach(p=>{d[p.toLowerCase()]=A[p]}),d}return A}resolveWithEnvironment(A,d,p){return this.recursiveResolve(this.prepareEnv(A),d?d.uri:void 0,p)}async resolveAsync(A,d){return this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,d)}async resolveAnyBase(A,d,p,a){const h=T.deepClone(d);return y.isWindows&&h.windows?Object.keys(h.windows).forEach(E=>h[E]=h.windows[E]):y.isMacintosh&&h.osx?Object.keys(h.osx).forEach(E=>h[E]=h.osx[E]):y.isLinux&&h.linux&&Object.keys(h.linux).forEach(E=>h[E]=h.linux[E]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,h,p,a)}async resolveAnyAsync(A,d,p){return this.resolveAnyBase(A,d,p)}async resolveAnyMap(A,d,p){const a=new Map;return{newConfig:await this.resolveAnyBase(A,d,p,a),resolvedVariables:a}}resolveWithInteractionReplace(A,d,p,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(A,d,p,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(A,d){if(this._contributedVariables.has(A))throw new Error("Variable "+A+" is contributed twice.");this._contributedVariables.set(A,d)}recursiveResolve(A,d,p,a,h){if(C.isString(p))return this.resolveString(A,d,p,a,h);if(C.isArray(p))return p.map(E=>this.recursiveResolve(A,d,E,a,h));if(C.isObject(p)){let E=Object.create(null);return Object.keys(p).forEach(v=>{const S=this.resolveString(A,d,v,a,h);E[S]=this.recursiveResolve(A,d,p[v],a,h)}),E}return p}resolveString(A,d,p,a,h){return p.replace(I.VARIABLE_REGEXP,(v,S)=>{if(S.includes(I.VARIABLE_LHS))return v;let u=this.evaluateSingleVariable(A,v,S,d,a);return h&&h.set(S,u),u})}fsPath(A){return this._labelService?this._labelService.getUriLabel(A,{noPrefix:!0}):A.fsPath}evaluateSingleVariable(A,d,p,a,h){let E;const v=p.split(":");v.length>1&&(p=v[0],E=v[1]);const S=()=>{const c=this._context.getFilePath();if(c)return c;throw new Error((0,D.localize)(0,null,d))},u=()=>{const c=S();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,d,w.basename(c)))},f=()=>{if(E){const c=this._context.getFolderUri(E);if(c)return c;throw new Error((0,D.localize)(2,null,d,E))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,d)):new Error((0,D.localize)(4,null,d))};switch(p){case"env":if(E){if(A){const c=A[y.isWindows?E.toLowerCase():E];if(C.isString(c))return c}return""}throw new Error((0,D.localize)(5,null,d));case"config":if(E){const c=this._context.getConfigurationValue(a,E);if(C.isUndefinedOrNull(c))throw new Error((0,D.localize)(6,null,d,E));if(C.isObject(c))throw new Error((0,D.localize)(7,null,d,E));return c}throw new Error((0,D.localize)(8,null,d));case"command":return this.resolveFromMap(d,E,h,"command");case"input":return this.resolveFromMap(d,E,h,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return a||E?(0,k.normalizeDriveLetter)(this.fsPath(f())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return w.basename(this.fsPath(f()));case"lineNumber":const c=this._context.getLineNumber();if(c)return c;throw new Error((0,D.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,d));case"file":return S();case"fileWorkspaceFolder":return u();case"relativeFile":return a||E?w.relative(this.fsPath(f()),S()):S();case"relativeFileDirname":const n=w.dirname(S());if(a||E){const g=w.relative(this.fsPath(f()),n);return g.length===0?".":g}return n;case"fileDirname":return w.dirname(S());case"fileExtname":return w.extname(S());case"fileBasename":return w.basename(S());case"fileBasenameNoExtension":const s=w.basename(S());return s.slice(0,s.length-w.extname(s).length);case"fileDirnameBasename":return w.basename(w.dirname(S()));case"execPath":const r=this._context.getExecPath();return r||d;case"execInstallFolder":const o=this._context.getAppRoot();return o||d;case"pathSeparator":return w.sep;default:try{const g=E?`${p}:${E}`:p;return this.resolveFromMap(d,g,h,void 0)}catch(g){return d}}}}resolveFromMap(A,d,p,a){if(d&&p){const h=a===void 0?p[d]:p[a+":"+d];if(typeof h=="string")return h;throw new Error((0,D.localize)(11,null,A))}return A}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[210],pe([0,1,4]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var R;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var C;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var k;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(k=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.EDITOR_OPEN=2]="EDITOR_OPEN",d[d.EDITOR_CLOSE=3]="EDITOR_CLOSE",d[d.EDITOR_MOVE=4]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=6]="EDITOR_LABEL",d[d.EDITOR_PIN=7]="EDITOR_PIN",d[d.EDITOR_STICKY=8]="EDITOR_STICKY",d[d.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function A(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=A}),define(ge[211],pe([0,1,4]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[20],pe([0,1,16,96,282,58,25,12,2,42,80,175,113,64,211,7]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(_e){function fe(X){const{selectionStartLineNumber:Fe,selectionStartColumn:Re,positionLineNumber:Ze,positionColumn:et}=X,ft=new h.Position(Fe-1,Re-1),ct=new h.Position(Ze-1,et-1);return new h.Selection(ft,ct)}_e.to=fe;function de(X){const{anchor:Fe,active:Re}=X;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}_e.from=de})(E=e.Selection||(e.Selection={}));var v;(function(_e){function fe(X){if(!X)return;const{start:Fe,end:Re}=X;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}_e.from=fe;function de(X){if(!X)return;const{startLineNumber:Fe,startColumn:Re,endLineNumber:Ze,endColumn:et}=X;return new h.Range(Fe-1,Re-1,Ze-1,et-1)}_e.to=de})(v=e.Range||(e.Range={}));var S;(function(_e){function fe(de){switch(de){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 4:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}_e.to=fe})(S=e.TokenType||(e.TokenType={}));var u;(function(_e){function fe(X){return new h.Position(X.lineNumber-1,X.column-1)}_e.to=fe;function de(X){return{lineNumber:X.line+1,column:X.character+1}}_e.from=de})(u=e.Position||(e.Position={}));var f;(function(_e){function fe(X){switch(X){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}_e.from=fe;function de(X){switch(X){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}_e.to=de})(f=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(_e){function fe(X){let Fe;return X.code&&((0,k.isString)(X.code)||(0,k.isNumber)(X.code)?Fe=String(X.code):Fe={value:String(X.code.value),target:X.code.target}),Object.assign(Object.assign({},v.from(X.range)),{message:X.message,source:X.source,code:Fe,severity:n.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(t.from),tags:Array.isArray(X.tags)?(0,w.coalesce)(X.tags.map(f.from)):void 0})}_e.from=fe;function de(X){var Fe;const Re=new h.Diagnostic(v.to(X),X.message,n.to(X.severity));return Re.source=X.source,Re.code=(0,k.isString)(X.code)?X.code:(Fe=X.code)===null||Fe===void 0?void 0:Fe.value,Re.relatedInformation=X.relatedInformation&&X.relatedInformation.map(t.to),Re.tags=X.tags&&(0,w.coalesce)(X.tags.map(f.to)),Re}_e.to=de})(c=e.Diagnostic||(e.Diagnostic={}));var t;(function(_e){function fe(X){return Object.assign(Object.assign({},v.from(X.location.range)),{message:X.message,resource:X.location.uri})}_e.from=fe;function de(X){return new h.DiagnosticRelatedInformation(new h.Location(X.resource,v.to(X)),X.message)}_e.to=de})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(_e){function fe(X){switch(X){case h.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}_e.from=fe;function de(X){switch(X){case d.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}_e.to=de})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(_e){function fe(X){return typeof X=="number"&&X>=h.ViewColumn.One?X-1:X===h.ViewColumn.Beside?a.SIDE_GROUP:a.ACTIVE_GROUP}_e.from=fe;function de(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=de})(s=e.ViewColumn||(e.ViewColumn={}));function r(_e){return typeof _e.range!="undefined"}function o(_e){return _e.length===0?!0:!!r(_e[0])}e.isDecorationOptionsArr=o;var g;(function(_e){function fe(et){return et.map(_e.from)}_e.fromMany=fe;function de(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function X(et){let ft;if(de(et)){const{language:ht,value:lt}=et;ft={value:"```"+ht+`
`+lt+"\n```\n"}}else h.MarkdownString.isMarkdownString(et)?ft={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ft={value:et}:ft={value:""};const ct=Object.create(null);ft.uris=ct;const it=ht=>{try{let lt=D.URI.parse(ht,!0);lt=lt.with({query:Fe(lt.query,ct)}),ct[ht]=lt}catch(lt){}return""},vt=new C.Renderer;return vt.link=it,vt.image=ht=>it(R.parseHrefAndDimensions(ht).href),C(ft.value,{renderer:vt}),ft}_e.from=X;function Fe(et,ft){if(!et)return et;let ct;try{ct=(0,T.parse)(et)}catch(vt){}if(!ct)return et;let it=!1;return ct=(0,y.cloneAndChange)(ct,vt=>{if(D.URI.isUri(vt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[ht]=vt,it=!0,ht}else return}),it?JSON.stringify(ct):et}function Re(et){const ft=new h.MarkdownString(et.value,et.supportThemeIcons);return ft.isTrusted=et.isTrusted,ft}_e.to=Re;function Ze(et){if(!!et)return typeof et=="string"?et:_e.from(et)}_e.fromStrict=Ze})(g=e.MarkdownString||(e.MarkdownString={}));function m(_e){return o(_e)?_e.map(fe=>({range:v.from(fe.range),hoverMessage:Array.isArray(fe.hoverMessage)?g.fromMany(fe.hoverMessage):fe.hoverMessage?g.from(fe.hoverMessage):void 0,renderOptions:fe.renderOptions})):_e.map(fe=>({range:v.from(fe)}))}e.fromRangeOrRangeWithMessage=m;function _(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?D.URI.file(_e):_e}e.pathOrURIToURI=_;var b;(function(_e){function fe(de){return typeof de=="undefined"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?_(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}_e.from=fe})(b=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var l;(function(_e){function fe(de){return typeof de=="undefined"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?_(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?b.from(de.before):void 0,after:de.after?b.from(de.after):void 0}}_e.from=fe})(l=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var L;(function(_e){function fe(de){if(typeof de=="undefined")return de;switch(de){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=fe})(L=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(_e){function fe(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?L.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?l.from(de.light):void 0,dark:de.dark?l.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?_(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?b.from(de.before):void 0,after:de.after?b.from(de.after):void 0}}_e.from=fe})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(_e){function fe(X){return{text:X.newText,eol:X.newEol&&ne.from(X.newEol),range:v.from(X.range)}}_e.from=fe;function de(X){const Fe=new h.TextEdit(v.to(X.range),X.text);return Fe.newEol=typeof X.eol=="undefined"?void 0:ne.to(X.eol),Fe}_e.to=de})($=e.TextEdit||(e.TextEdit={}));var ie;(function(_e){function fe(X,Fe,Re){var Ze,et,ft;const ct={edits:[]};if(X instanceof h.WorkspaceEdit)for(let it of X._allEntries())if(it._type===1)ct.edits.push({_type:1,oldUri:it.from,newUri:it.to,options:it.options,metadata:it.metadata});else if(it._type===2){const vt=Fe==null?void 0:Fe.getDocument(it.uri);ct.edits.push({_type:2,resource:it.uri,edit:$.from(it.edit),modelVersionId:vt==null?void 0:vt.version,metadata:it.metadata})}else it._type===3?ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:it.edit,notebookMetadata:it.notebookMetadata,notebookVersionId:(Ze=Re==null?void 0:Re.getNotebookDocument(it.uri,!0))===null||Ze===void 0?void 0:Ze.apiNotebook.version}):it._type===4?(it.newOutputs&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:2,index:it.index,append:it.append,outputs:it.newOutputs.map(Pe.from)}}),it.newMetadata&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:8,index:it.index,metadata:it.newMetadata}})):it._type===5?ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,notebookVersionId:(et=Re==null?void 0:Re.getNotebookDocument(it.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:it.index,count:it.count,cells:it.cells.map(ue.from)}}):it._type===6&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:7,outputId:it.outputId,items:((ft=it.newOutputItems)===null||ft===void 0?void 0:ft.map(Ie.from))||[],append:it.append}});return ct}_e.from=fe;function de(X){const Fe=new h.WorkspaceEdit;for(const Re of X.edits)Re.edit?Fe.replace(D.URI.revive(Re.resource),v.to(Re.edit.range),Re.edit.text):Fe.renameFile(D.URI.revive(Re.oldUri),D.URI.revive(Re.newUri),Re.options);return Fe}_e.to=de})(ie=e.WorkspaceEdit||(e.WorkspaceEdit={}));var se;(function(_e){const fe=Object.create(null);fe[h.SymbolKind.File]=0,fe[h.SymbolKind.Module]=1,fe[h.SymbolKind.Namespace]=2,fe[h.SymbolKind.Package]=3,fe[h.SymbolKind.Class]=4,fe[h.SymbolKind.Method]=5,fe[h.SymbolKind.Property]=6,fe[h.SymbolKind.Field]=7,fe[h.SymbolKind.Constructor]=8,fe[h.SymbolKind.Enum]=9,fe[h.SymbolKind.Interface]=10,fe[h.SymbolKind.Function]=11,fe[h.SymbolKind.Variable]=12,fe[h.SymbolKind.Constant]=13,fe[h.SymbolKind.String]=14,fe[h.SymbolKind.Number]=15,fe[h.SymbolKind.Boolean]=16,fe[h.SymbolKind.Array]=17,fe[h.SymbolKind.Object]=18,fe[h.SymbolKind.Key]=19,fe[h.SymbolKind.Null]=20,fe[h.SymbolKind.EnumMember]=21,fe[h.SymbolKind.Struct]=22,fe[h.SymbolKind.Event]=23,fe[h.SymbolKind.Operator]=24,fe[h.SymbolKind.TypeParameter]=25;function de(Fe){return typeof fe[Fe]=="number"?fe[Fe]:6}_e.from=de;function X(Fe){for(const Re in fe)if(fe[Re]===Fe)return Number(Re);return h.SymbolKind.Property}_e.to=X})(se=e.SymbolKind||(e.SymbolKind={}));var U;(function(_e){function fe(X){switch(X){case h.SymbolTag.Deprecated:return 1}}_e.from=fe;function de(X){switch(X){case 1:return h.SymbolTag.Deprecated}}_e.to=de})(U=e.SymbolTag||(e.SymbolTag={}));var V;(function(_e){function fe(X){return{name:X.name,kind:se.from(X.kind),tags:X.tags&&X.tags.map(U.from),containerName:X.containerName,location:M.from(X.location)}}_e.from=fe;function de(X){const Fe=new h.SymbolInformation(X.name,se.to(X.kind),X.containerName,M.to(X.location));return Fe.tags=X.tags&&X.tags.map(U.to),Fe}_e.to=de})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var W;(function(_e){function fe(X){var Fe,Re;const Ze={name:X.name||"!!MISSING: name!!",detail:X.detail,range:v.from(X.range),selectionRange:v.from(X.selectionRange),kind:se.from(X.kind),tags:(Re=(Fe=X.tags)===null||Fe===void 0?void 0:Fe.map(U.from))!==null&&Re!==void 0?Re:[]};return X.children&&(Ze.children=X.children.map(fe)),Ze}_e.from=fe;function de(X){const Fe=new h.DocumentSymbol(X.name,X.detail,se.to(X.kind),v.to(X.range),v.to(X.selectionRange));return(0,w.isNonEmptyArray)(X.tags)&&(Fe.tags=X.tags.map(U.to)),X.children&&(Fe.children=X.children.map(de)),Fe}_e.to=de})(W=e.DocumentSymbol||(e.DocumentSymbol={}));var P;(function(_e){function fe(de){const X=new h.CallHierarchyItem(se.to(de.kind),de.name,de.detail||"",D.URI.revive(de.uri),v.to(de.range),v.to(de.selectionRange));return X._sessionId=de._sessionId,X._itemId=de._itemId,X}_e.to=fe})(P=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(_e){function fe(de){return new h.CallHierarchyIncomingCall(P.to(de.from),de.fromRanges.map(X=>v.to(X)))}_e.to=fe})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(_e){function fe(de){return new h.CallHierarchyOutgoingCall(P.to(de.to),de.fromRanges.map(X=>v.to(X)))}_e.to=fe})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(_e){function fe(X){return{range:X.range&&v.from(X.range),uri:X.uri}}_e.from=fe;function de(X){return new h.Location(D.URI.revive(X.uri),v.to(X.range))}_e.to=de})(M=e.location||(e.location={}));var B;(function(_e){function fe(X){const Fe=X,Re=X;return{originSelectionRange:Fe.originSelectionRange?v.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Re.uri,range:v.from(Fe.targetRange?Fe.targetRange:Re.range),targetSelectionRange:Fe.targetSelectionRange?v.from(Fe.targetSelectionRange):void 0}}_e.from=fe;function de(X){return{targetUri:D.URI.revive(X.uri),targetRange:v.to(X.range),targetSelectionRange:X.targetSelectionRange?v.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?v.to(X.originSelectionRange):void 0}}_e.to=de})(B=e.DefinitionLink||(e.DefinitionLink={}));var H;(function(_e){function fe(X){return{range:v.from(X.range),contents:g.fromMany(X.contents)}}_e.from=fe;function de(X){return new h.Hover(X.contents.map(g.to),v.to(X.range))}_e.to=de})(H=e.Hover||(e.Hover={}));var Q;(function(_e){function fe(X){return{range:v.from(X.range),expression:X.expression}}_e.from=fe;function de(X){return new h.EvaluatableExpression(v.to(X.range),X.expression)}_e.to=de})(Q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(_e){function fe(X){if(X instanceof h.InlineValueText)return{type:"text",range:v.from(X.range),text:X.text};if(X instanceof h.InlineValueVariableLookup)return{type:"variable",range:v.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:v.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=fe;function de(X){switch(X.type){case"text":return{range:v.to(X.range),text:X.text};case"variable":return{range:v.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:v.to(X.range),expression:X.expression}}}_e.to=de})(le=e.InlineValue||(e.InlineValue={}));var be;(function(_e){function fe(X){return{frameId:X.frameId,stoppedLocation:v.from(X.stoppedLocation)}}_e.from=fe;function de(X){return new h.InlineValueContext(X.frameId,v.to(X.stoppedLocation))}_e.to=de})(be=e.InlineValueContext||(e.InlineValueContext={}));var Te;(function(_e){function fe(X){return{range:v.from(X.range),kind:X.kind}}_e.from=fe;function de(X){return new h.DocumentHighlight(v.to(X.range),X.kind)}_e.to=de})(Te=e.DocumentHighlight||(e.DocumentHighlight={}));var ke;(function(_e){function fe(de){switch(de){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}_e.to=fe})(ke=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ne;(function(_e){function fe(de){return{triggerKind:ke.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}_e.to=fe})(Ne=e.CompletionContext||(e.CompletionContext={}));var Ke;(function(_e){function fe(X){switch(X){case h.CompletionItemTag.Deprecated:return 1}}_e.from=fe;function de(X){switch(X){case 1:return h.CompletionItemTag.Deprecated}}_e.to=de})(Ke=e.CompletionItemTag||(e.CompletionItemTag={}));var ze;(function(_e){const fe=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function de(Re){var Ze;return(Ze=fe.get(Re))!==null&&Ze!==void 0?Ze:9}_e.from=de;const X=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Fe(Re){var Ze;return(Ze=X.get(Re))!==null&&Ze!==void 0?Ze:h.CompletionItemKind.Property}_e.to=Fe})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var qe;(function(_e){function fe(de,X){var Fe;const Re=new h.CompletionItem(typeof de.label=="string"?de.label:de.label.name);return typeof de.label!="string"&&(Re.label2=de.label),Re.insertText=de.insertText,Re.kind=ze.to(de.kind),Re.tags=(Fe=de.tags)===null||Fe===void 0?void 0:Fe.map(Ke.to),Re.detail=de.detail,Re.documentation=R.isMarkdownString(de.documentation)?g.to(de.documentation):de.documentation,Re.sortText=de.sortText,Re.filterText=de.filterText,Re.preselect=de.preselect,Re.commitCharacters=de.commitCharacters,I.Range.isIRange(de.range)?Re.range=v.to(de.range):typeof de.range=="object"&&(Re.range={inserting:v.to(de.range.insert),replacing:v.to(de.range.replace)}),Re.keepWhitespace=typeof de.insertTextRules=="undefined"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules!="undefined"&&de.insertTextRules&4?Re.insertText=new h.SnippetString(de.insertText):(Re.insertText=de.insertText,Re.textEdit=Re.range instanceof h.Range?new h.TextEdit(Re.range,Re.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Re.additionalTextEdits=de.additionalTextEdits.map(Ze=>$.to(Ze))),Re.command=X&&de.command?X.fromInternal(de.command):void 0,Re}_e.to=fe})(qe=e.CompletionItem||(e.CompletionItem={}));var q;(function(_e){function fe(X){return{label:X.label,documentation:X.documentation?g.fromStrict(X.documentation):void 0}}_e.from=fe;function de(X){return{label:X.label,documentation:R.isMarkdownString(X.documentation)?g.to(X.documentation):X.documentation}}_e.to=de})(q=e.ParameterInformation||(e.ParameterInformation={}));var J;(function(_e){function fe(X){return{label:X.label,documentation:X.documentation?g.fromStrict(X.documentation):void 0,parameters:Array.isArray(X.parameters)?X.parameters.map(q.from):[],activeParameter:X.activeParameter}}_e.from=fe;function de(X){return{label:X.label,documentation:R.isMarkdownString(X.documentation)?g.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(q.to):[],activeParameter:X.activeParameter}}_e.to=de})(J=e.SignatureInformation||(e.SignatureInformation={}));var re;(function(_e){function fe(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(J.from):[]}}_e.from=fe;function de(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(J.to):[]}}_e.to=de})(re=e.SignatureHelp||(e.SignatureHelp={}));var oe;(function(_e){function fe(X){var Fe;return{text:X.text,position:u.from(X.position),kind:Y.from((Fe=X.kind)!==null&&Fe!==void 0?Fe:h.InlayHintKind.Other),whitespaceBefore:X.whitespaceBefore,whitespaceAfter:X.whitespaceAfter}}_e.from=fe;function de(X){const Fe=new h.InlayHint(X.text,u.to(X.position),Y.to(X.kind));return Fe.whitespaceAfter=X.whitespaceAfter,Fe.whitespaceBefore=X.whitespaceBefore,Fe}_e.to=de})(oe=e.InlayHint||(e.InlayHint={}));var Y;(function(_e){function fe(X){return X}_e.from=fe;function de(X){return X}_e.to=de})(Y=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(_e){function fe(X){return{range:v.from(X.range),url:X.target,tooltip:X.tooltip}}_e.from=fe;function de(X){let Fe;if(X.url)try{Fe=typeof X.url=="string"?D.URI.parse(X.url,!0):D.URI.revive(X.url)}catch(Re){}return new h.DocumentLink(v.to(X.range),Fe)}_e.to=de})(ce=e.DocumentLink||(e.DocumentLink={}));var ve;(function(_e){function fe(X){const Fe=new h.ColorPresentation(X.label);return X.textEdit&&(Fe.textEdit=$.to(X.textEdit)),X.additionalTextEdits&&(Fe.additionalTextEdits=X.additionalTextEdits.map(Re=>$.to(Re))),Fe}_e.to=fe;function de(X){return{label:X.label,textEdit:X.textEdit?$.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Fe=>$.from(Fe)):void 0}}_e.from=de})(ve=e.ColorPresentation||(e.ColorPresentation={}));var Le;(function(_e){function fe(X){return new h.Color(X[0],X[1],X[2],X[3])}_e.to=fe;function de(X){return[X.red,X.green,X.blue,X.alpha]}_e.from=de})(Le=e.Color||(e.Color={}));var we;(function(_e){function fe(X){return{range:v.from(X.range)}}_e.from=fe;function de(X){return new h.SelectionRange(v.to(X.range))}_e.to=de})(we=e.SelectionRange||(e.SelectionRange={}));var je;(function(_e){function fe(de){switch(de){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}_e.to=fe})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var K;(function(_e){function fe(X){switch(X){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=fe;function de(X){switch(X){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}_e.to=de})(K=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ne;(function(_e){function fe(X){if(X===h.EndOfLine.CRLF)return 1;if(X===h.EndOfLine.LF)return 0}_e.from=fe;function de(X){if(X===1)return h.EndOfLine.CRLF;if(X===0)return h.EndOfLine.LF}_e.to=de})(ne=e.EndOfLine||(e.EndOfLine={}));var Ee;(function(_e){function fe(de){if(typeof de=="object")return de.viewId;switch(de){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=fe})(Ee=e.ProgressLocation||(e.ProgressLocation={}));var Oe;(function(_e){function fe(de){const X={start:de.start+1,end:de.end+1};return de.kind&&(X.kind=$e.from(de.kind)),X}_e.from=fe})(Oe=e.FoldingRange||(e.FoldingRange={}));var $e;(function(_e){function fe(de){if(de)switch(de){case h.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}_e.from=fe})($e=e.FoldingRangeKind||(e.FoldingRangeKind={}));var We;(function(_e){function fe(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?v.from(de.selection):void 0,override:typeof de.override=="boolean"?A.EditorOverride.DISABLED:void 0}}_e.from=fe})(We=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(_e){function fe(X){return X instanceof h.RelativePattern||typeof X=="string"?X:de(X)?new h.RelativePattern(X.base,X.pattern):X}_e.from=fe;function de(X){const Fe=X;return Fe&&typeof Fe.base=="string"&&typeof Fe.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var De;(function(_e){function fe(de){if(de){if(Array.isArray(de))return de.map(fe);if(typeof de=="string")return de;{const X=de;return{language:X.language,scheme:X.scheme,pattern:typeof X.pattern=="undefined"?void 0:Xe.from(X.pattern),exclusive:X.exclusive}}}else return}_e.from=fe})(De=e.LanguageSelector||(e.LanguageSelector={}));var ye;(function(_e){function fe(X){return{start:X.start,end:X.end}}_e.from=fe;function de(X){return new h.NotebookRange(X.start,X.end)}_e.to=de})(ye=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(_e){function fe(de){return new h.NotebookCellMetadata().with(Object.assign(Object.assign({},de),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}_e.to=fe})(Ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var ae;(function(_e){function fe(X){return X}_e.from=fe;function de(X){return new h.NotebookDocumentMetadata().with(X)}_e.to=de})(ae=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var he;(function(_e){function fe(X){return{startTime:X.runStartTime,endTime:X.runEndTime,executionOrder:X.executionOrder,success:X.lastRunSuccess}}_e.to=fe;function de(X){return{lastRunSuccess:X.success,runStartTime:X.startTime,runEndTime:X.endTime,executionOrder:X.executionOrder}}_e.from=de})(he=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var z;(function(_e){function fe(X){switch(X){case h.NotebookCellKind.Markup:return p.CellKind.Markup;case h.NotebookCellKind.Code:default:return p.CellKind.Code}}_e.from=fe;function de(X){switch(X){case p.CellKind.Markup:return h.NotebookCellKind.Markup;case p.CellKind.Code:default:return h.NotebookCellKind.Code}}_e.to=de})(z=e.NotebookCellKind||(e.NotebookCellKind={}));var Z;(function(_e){function fe(X){const Fe={metadata:ae.from(X.metadata),cells:[]};for(let Re of X.cells)h.NotebookCellData.validate(Re),Fe.cells.push(ue.from(Re));return Fe}_e.from=fe;function de(X){return{metadata:ae.to(X.metadata),cells:X.cells.map(ue.to)}}_e.to=de})(Z=e.NotebookData||(e.NotebookData={}));var ue;(function(_e){function fe(X){var Fe;return{cellKind:z.from(X.kind),language:X.languageId,source:X.value,metadata:X.metadata,internalMetadata:he.from((Fe=X.executionSummary)!==null&&Fe!==void 0?Fe:{}),outputs:X.outputs?X.outputs.map(Pe.from):[]}}_e.from=fe;function de(X){return new h.NotebookCellData(z.to(X.cellKind),X.source,X.language,X.outputs?X.outputs.map(Pe.to):void 0,X.metadata?Ce.to(X.metadata):void 0,X.internalMetadata?he.to(X.internalMetadata):void 0)}_e.to=de})(ue=e.NotebookCellData||(e.NotebookCellData={}));var Ie;(function(_e){function fe(X){let Fe,Re;return X.data instanceof Uint8Array?Re=Array.from(X.data):Fe=X.value,{metadata:X.metadata,mime:X.mime,value:Fe,valueBytes:Re}}_e.from=fe;function de(X){let Fe;return Array.isArray(X.valueBytes)?Fe=new Uint8Array(X.valueBytes):Fe=X.value,new h.NotebookCellOutputItem(Fe,X.mime,X.metadata)}_e.to=de})(Ie=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(_e){function fe(X){return{outputId:X.id,outputs:X.outputs.map(Ie.from),metadata:X.metadata}}_e.from=fe;function de(X){const Fe=X.outputs.map(Ie.to);return new h.NotebookCellOutput(Fe,X.outputId,X.metadata)}_e.to=de})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ue;(function(_e){function fe(Re){if(Re!=null){if(Re instanceof h.RelativePattern||typeof Re=="string")return Re;if(Fe(Re))return new h.RelativePattern(Re.base,Re.pattern);if(X(Re))return{include:Xe.from(Re.include)||void 0,exclude:Xe.from(Re.exclude)||void 0}}}_e.from=fe;function de(Re){return typeof Re=="string"?Re:Fe(Re)?{base:Re.base,pattern:Re.pattern}:{include:Re.include,exclude:Re.exclude}}_e.to=de;function X(Re){const Ze=Re,et=Xe.from(Ze.include);if(!(et&&et instanceof h.RelativePattern||typeof et=="string"))return!1;const ft=Xe.from(Ze.exclude);return!!(ft&&ft instanceof h.RelativePattern||typeof ft=="string")}function Fe(Re){const Ze=Re;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Ue=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var xe;(function(_e){function fe(de){return{backgroundColor:de.backgroundColor,borderColor:de.borderColor,top:de.top?b.from(de.top):void 0}}_e.from=fe})(xe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Qe;(function(_e){function fe(de,X,Fe){const Re=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Re,Fe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}_e.from=fe})(Qe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var rt;(function(_e){function fe(de){var X,Fe,Re;return{transientOutputs:(X=de==null?void 0:de.transientOutputs)!==null&&X!==void 0?X:!1,transientCellMetadata:(Fe=de==null?void 0:de.transientCellMetadata)!==null&&Fe!==void 0?Fe:{},transientDocumentMetadata:(Re=de==null?void 0:de.transientDocumentMetadata)!==null&&Re!==void 0?Re:{}}}_e.from=fe})(rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var tt;(function(_e){function fe(X){var Fe;return{uri:X.uri,provides:typeof X.provides=="string"?[X.provides]:(Fe=X.provides)!==null&&Fe!==void 0?Fe:[]}}_e.from=fe;function de(X){return new h.NotebookKernelPreload(D.URI.revive(X.uri),X.provides)}_e.to=de})(tt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var Ye;(function(_e){function fe(X){return{message:g.fromStrict(X.message)||"",severity:X.severity,expectedOutput:X.expectedOutput,actualOutput:X.actualOutput,location:X.location?M.from(X.location):void 0}}_e.from=fe;function de(X){const Fe=new h.TestMessage(typeof X.message=="string"?X.message:g.to(X.message));return Fe.severity=X.severity,Fe.actualOutput=X.actualOutput,Fe.expectedOutput=X.expectedOutput,Fe}_e.to=de})(Ye=e.TestMessage||(e.TestMessage={}));var ot;(function(_e){function fe(Re){var Ze,et;return{extId:Re.id,label:Re.label,uri:Re.uri,range:v.from(Re.range)||null,debuggable:(Ze=Re.debuggable)!==null&&Ze!==void 0?Ze:!1,description:Re.description||null,runnable:(et=Re.runnable)!==null&&et!==void 0?et:!0,error:Re.error&&g.fromStrict(Re.error)||null}}_e.from=fe;function de(Re){return{extId:Re.id,label:Re.label,uri:Re.uri,range:v.from(Re.range)||null,debuggable:!1,description:Re.description||null,error:null,runnable:!0}}_e.fromResultSnapshot=de;function X(Re){return{id:Re.extId,label:Re.label,uri:D.URI.revive(Re.uri),range:v.to(Re.range||void 0),addChild:()=>{},dispose:()=>{},status:h.TestItemStatus.Pending,data:void 0,debuggable:Re.debuggable,description:Re.description||void 0,runnable:Re.runnable}}_e.toPlain=X;function Fe(Re){const Ze=new h.TestItemImpl(Re.extId,Re.label,D.URI.revive(Re.uri),void 0);return Ze.range=v.to(Re.range||void 0),Ze.debuggable=Re.debuggable,Ze.description=Re.description||void 0,Ze.runnable=Re.runnable,Ze}_e.to=Fe})(ot=e.TestItem||(e.TestItem={}));var Et;(function(_e){const fe=(X,Fe)=>Object.assign(Object.assign({},ot.toPlain(X.item)),{taskStates:X.tasks.map(Re=>({state:Re.state,duration:Re.duration,messages:Re.messages.map(Ye.to)})),children:X.children.map(Re=>Fe.get(Re)).filter(k.isDefined).map(Re=>fe(Re,Fe))});function de(X){const Fe=[],Re=new Map;for(const Ze of X.items)Re.set(Ze.item.extId,Ze),Ze.direct&&Fe.push(Ze);return{completedAt:X.completedAt,results:Fe.map(Ze=>fe(Ze,Re))}}_e.to=de})(Et=e.TestResults||(e.TestResults={}));var bt;(function(_e){function fe(de){switch(de){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}_e.to=fe})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[212],pe([0,1,2,17,7,20,56]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(I,i,A,d={timeout:1500,errors:3}){this._logService=I,this._documents=i,this._mainThreadBulkEdits=A,this._thresholds=d,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(i,A,d)=>{const a={dispose:this._callbacks.push([i,A,I])};return Array.isArray(d)&&d.push(a),a}}async $participateInSave(I,i){const A=w.URI.revive(I);let d=!1;const p=setTimeout(()=>d=!0,this._thresholds.timeout),a=[];try{for(let h of[...this._callbacks]){if(d)break;const E=this._documents.getDocument(A),v=await this._deliverEventAsyncAndBlameBadListeners(h,{document:E,reason:T.TextDocumentSaveReason.to(i)});a.push(v)}}finally{clearTimeout(p)}return a}_deliverEventAsyncAndBlameBadListeners([I,i,A],d){const p=this._badListeners.get(I);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(A,I,i,d).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const h=this._badListeners.get(I);this._badListeners.set(I,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,i,A,d){const p=[],a=Date.now(),{document:h,reason:E}=d,{version:v}=h,S=Object.freeze({document:h,reason:E,waitUntil(u){if(Object.isFrozen(p))throw(0,R.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(u))}});try{i.apply(A,[S])}catch(u){return Promise.reject(u)}return Object.freeze(p),new Promise((u,f)=>{const c=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(c),u(t)}).catch(t=>{clearTimeout(c),f(t)})}).then(u=>{const f={edits:[]};for(const c of u)if(Array.isArray(c)&&c.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:n,range:s}of c)f.edits.push({_type:2,resource:h.uri,edit:{range:s&&T.Range.from(s),text:t,eol:n&&T.EndOfLine.from(n)}});if(f.edits.length!==0)return v===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(ge[213],pe([0,1,3,13,30,2,20,7]),function(G,e,w,R,C,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(A,d,p,a,h){this._onDidCreate=new w.Emitter,this._onDidChange=new w.Emitter,this._onDidDelete=new w.Emitter,this._config=0,p&&(this._config+=1),a&&(this._config+=2),h&&(this._config+=4);const E=(0,C.parse)(d),v=A(S=>{if(!p)for(let u of S.created){const f=T.URI.revive(u);E(f.fsPath)&&this._onDidCreate.fire(f)}if(!a)for(let u of S.changed){const f=T.URI.revive(u);E(f.fsPath)&&this._onDidChange.fire(f)}if(!h)for(let u of S.deleted){const f=T.URI.revive(u);E(f.fsPath)&&this._onDidDelete.fire(f)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class I{constructor(A,d,p){this._logService=d,this._extHostDocumentsAndEditors=p,this._onFileSystemEvent=new w.Emitter,this._onDidRenameFile=new w.Emitter,this._onDidCreateFile=new w.Emitter,this._onDidDeleteFile=new w.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(A,d,p,a){return new D(this._onFileSystemEvent.event,A,d,p,a)}$onFileEvent(A){this._onFileSystemEvent.fire(A)}$onDidRunFileOperation(A,d){switch(A){case 2:this._onDidRenameFile.fire(Object.freeze({files:d.map(p=>({oldUri:T.URI.revive(p.source),newUri:T.URI.revive(p.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:d.map(p=>T.URI.revive(p.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:d.map(p=>T.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(A){return this._createWillExecuteEvent(A,this._onWillRenameFile)}getOnWillCreateFileEvent(A){return this._createWillExecuteEvent(A,this._onWillCreateFile)}getOnWillDeleteFileEvent(A){return this._createWillExecuteEvent(A,this._onWillDeleteFile)}_createWillExecuteEvent(A,d){return(p,a,h)=>{const E=function(S){p.call(a,S)};return E.extension=A,d.event(E,void 0,h)}}async $onWillRunFileOperation(A,d,p,a){switch(A){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:d.map(h=>({oldUri:T.URI.revive(h.source),newUri:T.URI.revive(h.target)}))},p,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:d.map(h=>T.URI.revive(h.target))},p,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:d.map(h=>T.URI.revive(h.target))},p,a)}}async _fireWillEvent(A,d,p,a){const h=new Set,E=[];if(await A.fireAsync(d,a,async(S,u)=>{var f;const c=Date.now(),t=await Promise.resolve(S);t instanceof k.WorkspaceEdit&&(E.push(t),h.add((f=u.extension.displayName)!==null&&f!==void 0?f:u.extension.identifier.value)),Date.now()-c>p&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),a.isCancellationRequested||E.length===0)return;const v={edits:[]};for(let S of E){let{edits:u}=y.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(u)}return{edit:v,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=I}),define(ge[214],pe([0,1,10,25,2,20,7,64]),function(G,e,w,R,C,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(d,p,a,h){this.start=d,this.deletedCount=p,this.deletedItems=a,this.items=h}static asApiEvents(d){return d.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(a=>a.apiCell)}))}}class I{constructor(d,p,a){var h,E,v;this.notebook=d,this._extHostDocument=p,this._cellData=a,this.handle=a.handle,this.uri=C.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(h=a.internalMetadata)!==null&&h!==void 0?h:{},this._metadata=T.NotebookCellMetadata.to((E=a.metadata)!==null&&E!==void 0?E:{}),this._previousResult=T.NotebookCellExecutionSummary.to((v=a.internalMetadata)!==null&&v!==void 0?v:{})}static asModelAddData(d,p){return{EOL:p.eol,lines:p.source,modeId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const d=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return d.notebook.getCellIndex(d)},notebook:d.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get executionSummary(){return d._previousResult}})}return this._apiCell}setOutputs(d){this._outputs=d.map(T.NotebookCellOutput.to)}setOutputItems(d,p,a){const h=a.map(T.NotebookCellOutputItem.to),E=this._outputs.find(v=>v.id===d);E&&(p||(E.outputs.length=0),E.outputs.push(...h))}setMetadata(d){this._metadata=T.NotebookCellMetadata.to(d)}setInternalMetadata(d){this._internalMetadata=d,this._previousResult=T.NotebookCellExecutionSummary.to(d)}}e.ExtHostCell=I;class i{constructor(d,p,a,h,E,v,S){this._proxy=d,this._textDocumentsAndEditors=p,this._textDocuments=a,this._emitter=h,this._viewType=E,this._metadata=v,this.uri=S,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get viewType(){return d._viewType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===w.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(p){return p=d._validateIndex(p),d._cells[p].apiCell},getCells(p){return(p?d._getCells(p):d._cells).map(h=>h.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){var p;(p=this._backup)===null||p===void 0||p.delete(),this._backup=d}disposeBackup(){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=this._metadata.with(d.metadata))}acceptModelChanged(d,p){this._versionId=d.versionId,this._isDirty=p;for(const a of d.rawEvents)a.kind===k.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(a.changes,!0),a.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===k.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(d){return d=d|0,d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){let p=d.start|0,a=d.end|0;return p<0&&(p=0),a>this._cells.length&&(a=this._cells.length),d.with({start:p,end:a})}_getCells(d){d=this._validateRange(d);const p=[];for(let a=d.start;a<d.end;a++)p.push(this._cells[a]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(d,p){if(this._disposed)return;const a=[],h=[],E=[];d.reverse().forEach(v=>{const u=v[2].map(t=>{const n=new I(this,this._textDocumentsAndEditors,t);return p||h.push(I.asModelAddData(this.apiNotebook,t)),n}),f=new D(v[0],v[1],[],u),c=this._cells.splice(v[0],v[1],...u);for(const t of c)E.push(t.uri),f.deletedItems.push(t.apiCell);a.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:E}),p||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(a)}))}_moveCell(d,p){const a=this._cells.splice(d,1);this._cells.splice(p,0,...a);const h=[new D(d,1,a.map(E=>E.apiCell),[]),new D(p,0,[],a)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(h)}))}_setCellOutputs(d,p){const a=this._cells[d];a.setOutputs(p),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(d,p,a,h){const E=this._cells[d];E.setOutputItems(p,a,h),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_changeCellLanguage(d,p){const a=this._cells[d];a.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelModeChanged(a.uri,p)}_changeCellMetadata(d,p){const a=this._cells[d],h=a.apiCell.metadata;a.setMetadata(p);const E=a.apiCell.metadata;(0,R.equals)(h,E)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(d,p){var a;const h=this._cells[d],E=h.internalMetadata;if(h.setInternalMetadata(p),E.runState!==p.runState){const v=(a=p.runState)!==null&&a!==void 0?a:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,executionState:v}))}}getCellFromApiCell(d){return this._cells.find(p=>p.apiCell===d)}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(p=>p.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(ge[124],pe([0,1,7,20]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(k){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=k}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(k){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:k})}replaceCellMetadata(k,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:k,metadata:D})}replaceCells(k,D,I){this._throwIfFinalized(),!(k===D&&I.length===0)&&this._collectedEdits.push({editType:1,index:k,count:D-k,cells:I.map(R.NotebookCellData.from)})}}class T{constructor(k,D,I,i,A,d){this.id=k,this._proxy=D,this.notebookData=I,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=A,this._visibleRanges=i,this._viewColumn=d}get apiEditor(){if(!this._editor){const k=this;this._editor={get document(){return k.notebookData.apiNotebook},get selections(){return k._selections},get visibleRanges(){return k._visibleRanges},revealRange(D,I){k._proxy.$tryRevealRange(k.id,R.NotebookRange.from(D),I??w.NotebookEditorRevealType.Default)},get viewColumn(){return k._viewColumn},edit(D){const I=new C(this.document.version);return D(I),k._applyEdit(I.finalize())},setDecorations(D,I){return k.setDecorations(D,I)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(k){this._visible=k}_acceptVisibleRanges(k){this._visibleRanges=k}_acceptSelections(k){this._selections=k}_acceptViewColumn(k){this._viewColumn=k}_applyEdit(k){if(k.cellEdits.length===0)return Promise.resolve(!0);const D=[];let I=-1;for(let i=0;i<k.cellEdits.length;i++){if(I<0){D.push(k.cellEdits[i]),I++;continue}const d=D[I],p=k.cellEdits[i];if(d.editType===1&&p.editType===1&&d.index===p.index){d.cells.push(...k.cellEdits[i].cells),d.count+=k.cellEdits[i].count;continue}D.push(k.cellEdits[i]),I++}return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,D)}setDecorations(k,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(k.key)))return D.isEmpty?this._hasDecorationsForKey.delete(k.key):this._hasDecorationsForKey.add(k.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(D),k.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(ge[215],pe([0,1,20,114,163,21,53]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(A){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=A}withProgress(A,d,p){const a=this._handles++,{title:h,location:E,cancellable:v}=d,S={label:(0,C.localize)(0,null,A.displayName||A.name),id:A.identifier.value};return this._proxy.$startProgress(a,{location:w.ProgressLocation.from(E),title:h,source:S,cancellable:v},A),this._withProgress(a,p,!!v)}_withProgress(A,d,p){let a;p&&(a=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(A,a));const h=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),a&&a.dispose()};let E;try{E=d(new I(this._proxy,A),p&&a?a.token:T.CancellationToken.None)}catch(v){throw h(A),v}return E.then(v=>h(A),v=>h(A)),E}$acceptProgressCanceled(A){const d=this._mapHandleToCancellationSource.get(A);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(A))}}e.ExtHostProgress=k;function D(i,A){return i.message=A.message,typeof A.increment=="number"&&(typeof i.increment=="number"?i.increment+=A.increment:i.increment=A.increment),i}class I extends R.Progress{constructor(A,d){super(p=>this.throttledReport(p));this._proxy=A,this._handle=d}throttledReport(A){this._proxy.$progressReport(this._handle,A)}}Ve([(0,y.throttle)(100,(i,A)=>D(i,A),()=>Object.create(null))],I.prototype,"throttledReport",null)}),define(ge[125],pe([0,1,51,17,73,20,7]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(d,p){const a=k._Keys.nextId();d.$registerTextEditorDecorationType(a,T.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:a,dispose(){d.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=k,k._Keys=new C.IdGenerator("TextEditorDecorationType");class D{constructor(d,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,p){this._throwIfFinalized();let a=null;if(d instanceof y.Position)a=new y.Range(d,d);else if(d instanceof y.Range)a=d;else throw new Error("Unrecognized location");this._pushEdit(a,p,!1)}insert(d,p){this._throwIfFinalized(),this._pushEdit(new y.Range(d,d),p,!0)}delete(d){this._throwIfFinalized();let p=null;if(d instanceof y.Range)p=d;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(d,p,a){const h=this._document.validateRange(d);this._collectedEdits.push({range:h,text:p,forceMoveMarkers:a})}setEndOfLine(d){if(this._throwIfFinalized(),d!==y.EndOfLine.LF&&d!==y.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=D;class I{constructor(d,p,a,h){this._proxy=d,this._id=p,this._accept(a),this._logService=h;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(v){E._setTabSize(v)},get insertSpaces(){return E._insertSpaces},set insertSpaces(v){E._setInsertSpaces(v)},get cursorStyle(){return E._cursorStyle},set cursorStyle(v){E._setCursorStyle(v)},get lineNumbers(){return E._lineNumbers},set lineNumbers(v){E._setLineNumbers(v)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const p=Math.floor(d);return p>0?p:null}if(typeof d=="string"){const p=parseInt(d,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(d){const p=this._validateTabSize(d);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const p=this._validateInsertSpaces(d);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(d)})))}assign(d){const p={};let a=!1;if(typeof d.tabSize!="undefined"){const h=this._validateTabSize(d.tabSize);h==="auto"?(a=!0,p.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,a=!0,p.tabSize=h)}if(typeof d.insertSpaces!="undefined"){const h=this._validateInsertSpaces(d.insertSpaces);h==="auto"?(a=!0,p.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,a=!0,p.insertSpaces=h)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,a=!0,p.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,a=!0,p.lineNumbers=T.TextEditorLineNumbersStyle.from(d.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,p))}_warnOnError(d){d.catch(p=>this._logService.warn(p))}}e.ExtHostTextEditorOptions=I;class i{constructor(d,p,a,h,E,v,S,u){this.id=d,this._proxy=p,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new I(this._proxy,this.id,v,a),this._visibleRanges=S,this._viewColumn=u;const f=this;this.value=Object.freeze({get document(){return h.getValue()},set document(c){throw(0,R.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(c){if(!(c instanceof y.Selection))throw(0,R.illegalArgument)("selection");f._selections=[c],f._trySetSelection()},get selections(){return f._selections},set selections(c){if(!Array.isArray(c)||c.some(t=>!(t instanceof y.Selection)))throw(0,R.illegalArgument)("selections");f._selections=c,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(c){throw(0,R.readonly)("visibleRanges")},get options(){return f._options.value},set options(c){f._disposed||f._options.assign(c)},get viewColumn(){return f._viewColumn},set viewColumn(c){throw(0,R.readonly)("viewColumn")},edit(c,t={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(h.getValue(),t);return c(n),f._applyEdit(n)},insertSnippet(c,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=f._selections.map(r=>T.Range.from(r));else if(t instanceof y.Position){const{lineNumber:r,column:o}=T.Position.from(t);s=[{startLineNumber:r,startColumn:o,endLineNumber:r,endColumn:o}]}else if(t instanceof y.Range)s=[T.Range.from(t)];else{s=[];for(const r of t)if(r instanceof y.Range)s.push(T.Range.from(r));else{const{lineNumber:o,column:g}=T.Position.from(r);s.push({startLineNumber:o,startColumn:g,endLineNumber:o,endColumn:g})}}return p.$tryInsertSnippet(d,c.value,s,n)},setDecorations(c,t){const n=t.length===0;n&&!f._hasDecorationsForKey.has(c.key)||(n?f._hasDecorationsForKey.delete(c.key):f._hasDecorationsForKey.add(c.key),f._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return p.$trySetDecorations(d,c.key,T.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let r=0,o=t.length;r<o;r++){const g=t[r];s[4*r]=g.start.line+1,s[4*r+1]=g.start.character+1,s[4*r+2]=g.end.line+1,s[4*r+3]=g.end.character+1}return p.$trySetDecorationsFast(d,c.key,s)}}))},revealRange(c,t){f._runOnProxy(()=>p.$tryRevealRange(d,T.Range.from(c),t||y.TextEditorRevealType.Default))},show(c){p.$tryShowEditor(d,T.ViewColumn.from(c))},hide(){p.$tryHideEditor(d)}})}dispose(){(0,w.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,w.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,w.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,w.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,w.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const p=d.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const a=p.edits.map(E=>E.range);a.sort((E,v)=>E.end.line===v.end.line?E.end.character===v.end.character?E.start.line===v.start.line?E.start.character-v.start.character:E.start.line-v.start.line:E.end.character-v.end.character:E.end.line-v.end.line);for(let E=0,v=a.length-1;E<v;E++){const S=a[E].end;if(a[E+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=p.edits.map(E=>({range:T.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,h,{setEndOfLine:typeof p.setEndOfLine=="number"?T.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=i}),define(ge[216],pe([0,1,166,24,2,3,6,13,7,12,16,20,21]),function(G,e,w,R,C,T,y,k,D,I,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(E,v){if((0,I.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let S;return Array.isArray(E.highlights)&&(S=E.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),S=S.length?S:void 0),{label:E.label,highlights:S}}}class a{constructor(v,S,u){this._proxy=v,this.commands=S,this.logService=u,this.treeViews=new Map;function f(c){return c&&c.$treeViewId&&c.$treeItemHandle}S.registerArgumentProcessor({processArgument:c=>f(c)?this.convertArgument(c):Array.isArray(c)&&c.length>0?c.map(t=>f(t)?this.convertArgument(t):t):c})}registerTreeDataProvider(v,S,u){const f=this.createTreeView(v,{treeDataProvider:S},u);return{dispose:()=>f.dispose()}}createTreeView(v,S,u){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=S.dragAndDropController!==void 0,c=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany,canDragAndDrop:f}),t=this.createExtHostTreeView(v,S,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(n){t.message=n},get title(){return t.title},set title(n){t.title=n},get description(){return t.description},set description(n){t.description=n},reveal:(n,s)=>t.reveal(n,s),dispose:async()=>{await c,this.treeViews.delete(v),t.dispose()}}}$getChildren(v,S){const u=this.treeViews.get(v);return u?u.getChildren(S):Promise.reject(new Error((0,w.localize)(0,null,v)))}$onDrop(v,S,u){const f=this.treeViews.get(v);return f?f.onDrop(S,u):Promise.reject(new Error((0,w.localize)(1,null,v)))}async $hasResolve(v){const S=this.treeViews.get(v);if(!S)throw new Error((0,w.localize)(2,null,v));return S.hasResolve}$resolve(v,S,u){const f=this.treeViews.get(v);if(!f)throw new Error((0,w.localize)(3,null,v));return f.resolveTreeItem(S,u)}$setExpanded(v,S,u){const f=this.treeViews.get(v);if(!f)throw new Error((0,w.localize)(4,null,v));f.setExpanded(S,u)}$setSelection(v,S){const u=this.treeViews.get(v);if(!u)throw new Error((0,w.localize)(5,null,v));u.setSelection(S)}$setVisible(v,S){const u=this.treeViews.get(v);if(!u)throw new Error((0,w.localize)(6,null,v));u.setVisible(S)}createExtHostTreeView(v,S,u){const f=new h(v,S,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(v,f),f}convertArgument(v){const S=this.treeViews.get(v.$treeViewId);return S?S.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=a;class h extends y.Disposable{constructor(v,S,u,f,c,t){super();if(this.viewId=v,this.proxy=u,this.commands=f,this.logService=c,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const o of t.contributes.views[r])o.id===v&&(this._title=o.name);this.dataProvider=S.treeDataProvider,this.dndController=S.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,s;this._register(T.Event.debounce(this._onDidChangeData.event,(r,o)=>(r||(r={message:!1,elements:[]}),o.element!==!1&&(n||(n=new Promise(g=>s=g),this.refreshPromise=this.refreshPromise.then(()=>n)),r.elements.push(o.element)),o.message&&(r.message=!0),r),200,!0)(({message:r,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=s;return n=null,this.refresh(o).then(()=>g())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,I.isUndefinedOrNull)(v))}getChildren(v){const S=v?this.getExtensionElement(v):void 0;if(v&&!S)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(v);return(u?Promise.resolve(u):this.fetchChildrenNodes(S)).then(f=>f.map(c=>c.item))}getExtensionElement(v){return this.elements.get(v)}reveal(v,S){S=S||{select:!0,focus:!1};const u=(0,I.isUndefinedOrNull)(S.select)?!0:S.select,f=(0,I.isUndefinedOrNull)(S.focus)?!1:S.focus,c=(0,I.isUndefinedOrNull)(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(t=>this.resolveTreeNode(v,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(s=>s.item)},{select:u,focus:f,expand:c})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:f,expand:c})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,S){const u=this.getExtensionElement(v);u&&(S?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(v){(0,i.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(v,S){const u=v.map(c=>this.getExtensionElement(c)).filter(c=>!(0,I.isUndefinedOrNull)(c)),f=this.getExtensionElement(S);return u&&f?(0,k.asPromise)(()=>{var c;return(c=this.dndController)===null||c===void 0?void 0:c.onDrop(u,f)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,S){var u;if(!this.dataProvider.resolveTreeItem)return;const f=this.elements.get(v);if(f){const c=this.nodes.get(f);if(c){const t=(u=await this.dataProvider.resolveTreeItem(c.extensionItem,f,S))!==null&&u!==void 0?u:c.extensionItem;return c.item.tooltip=this.getTooltip(t.tooltip),c.item.command=this.getCommand(c.disposableStore,t.command),c.item}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(S=>S?this.resolveUnknownParentChain(S).then(u=>this.resolveTreeNode(S,u[u.length-1]).then(f=>(u.push(f),u))):Promise.resolve([]))}resolveParent(v){const S=this.nodes.get(v);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,S){const u=this.nodes.get(v);return u?Promise.resolve(u):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(f=>this.createHandle(v,f,S,!0)).then(f=>this.getChildren(S?S.item.handle:void 0).then(()=>{const c=this.getExtensionElement(f);if(c){const t=this.nodes.get(c);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${f}`)}))}getChildrenNodes(v){if(v){let S;if(typeof v=="string"){const u=this.getExtensionElement(v);S=u?this.nodes.get(u):void 0}else S=v;return S&&S.children||null}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const S=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=v?this.nodes.get(v):void 0,f=await this.dataProvider.getChildren(v);if(S.token.isCancellationRequested)return[];const c=await Promise.all((0,i.coalesce)(f||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,u):null}));return S.token.isCancellationRequested?[]:(0,i.coalesce)(c)}finally{S.dispose()}}refresh(v){if(v.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(v);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const S=new Set,u=v.map(c=>this.nodes.get(c));for(const c of u)if(c&&!S.has(c.item.handle)){let t=c;for(;t&&t.parent&&u.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&S.add(c.item.handle)}const f=[];return S.forEach(c=>{const t=this.elements.get(c);if(t){const n=this.nodes.get(t);n&&(!n.parent||!S.has(n.parent.item.handle))&&f.push(c)}}),f}refreshHandles(v){const S={};return Promise.all(v.map(u=>this.refreshNode(u).then(f=>{f&&(S[u]=f.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(v){const S=this.getExtensionElement(v);if(S){const u=this.nodes.get(S);if(u)return this.clearChildren(S),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(S)).then(f=>{if(f){const c=this.createTreeNode(S,f,u.parent);return this.updateNodeCache(S,c,u,u.parent),u.dispose(),c}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,S,u){const f=this.createTreeNode(v,S,u);if(S.id&&this.elements.has(f.item.handle))throw new Error((0,w.localize)(7,null,S.id));return this.addNodeToCache(v,f),this.addNodeToParentCache(f,u),f}getTooltip(v){return D.MarkdownString.isMarkdownString(v)?A.MarkdownString.from(v):v}getCommand(v,S){return S?this.commands.toInternal(S,v):void 0}createTreeNode(v,S,u){const f=new y.DisposableStore,c=this.createHandle(v,S,u),t=this.getLightIconPath(S);return{item:{handle:c,parentHandle:u?u.item.handle:void 0,label:p(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(f,S.command),contextValue:S.contextValue,icon:t,iconDark:this.getDarkIconPath(S)||t,themeIcon:this.getThemeIcon(S),collapsibleState:(0,I.isUndefinedOrNull)(S.collapsibleState)?D.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation},extensionItem:S,parent:u,children:void 0,disposableStore:f,dispose(){f.dispose()}}}getThemeIcon(v){return v.iconPath instanceof D.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:S,label:u,resourceUri:f},c,t){if(S)return`${h.ID_HANDLE_PREFIX}/${S}`;const n=p(u,this.extension),s=c?c.item.handle:h.LABEL_HANDLE_PREFIX;let r=n?n.label:f?(0,R.basename)(f):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const o=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,g=this.getChildrenNodes(c)||[];let m,_=0;do{if(m=`${s}/${_}:${r}`,t||!this.elements.has(m)||o===m)break;_++}while(_<=g.length);return m}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof D.ThemeIcon))return typeof v.iconPath=="string"||C.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof D.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return C.URI.isUri(v)?v:C.URI.file(v)}addNodeToCache(v,S){this.elements.set(S.item.handle,v),this.nodes.set(v,S)}updateNodeCache(v,S,u,f){this.elements.delete(S.item.handle),this.nodes.delete(v),S.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(v,S);const c=this.getChildrenNodes(f)||[],t=c.filter(n=>n.item.handle===u.item.handle)[0];t&&c.splice(c.indexOf(t),1,S)}addNodeToParentCache(v,S){S?(S.children||(S.children=[]),S.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const S=this.nodes.get(v);if(S){if(S.children)for(const u of S.children){const f=this.elements.get(u.item.handle);f&&this.clear(f)}S.children=void 0}}else this.clearAll()}clear(v){const S=this.nodes.get(v);if(S){if(S.children)for(const u of S.children){const f=this.elements.get(u.item.handle);f&&this.clear(f)}this.nodes.delete(v),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}h.LABEL_HANDLE_PREFIX="0",h.ID_HANDLE_PREFIX="1"}),define(ge[217],pe([0,1,16,13,21,12,86,20,7,123]),function(G,e,w,R,C,T,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(E,v){if(v!==void 0){const S=this.testIdsToInternal.get(v),u=S==null?void 0:S.get(E);if(u)return[S,u]}return(0,w.mapFind)(this.testIdsToInternal.values(),S=>{const u=S.get(E);return u&&[S,u]})}createForHierarchy(E=()=>{}){return new a(this.createIdMap(d++),E)}createIdMap(E){const v=new p(E);return this.testIdsToInternal.set(v.id,v),{object:v,dispose:()=>this.testIdsToInternal.delete(v.id)}}}e.OwnedTestCollection=i;var A;(function(h){h[h.Disconnected=0]="Disconnected",h[h.IsChild=1]="IsChild",h[h.IsParent=2]="IsParent",h[h.IsSame=3]="IsSame"})(A=e.TestPosition||(e.TestPosition={}));let d=0;class p{constructor(E){this.id=E,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(E){if(this.map.has(E.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${E.item.extId}`);this.map.set(E.item.extId,E),E.parent||this._roots.add(E)}has(E){return this.map.has(E)}delete(E){const v=this.map.get(E);return v?(this.map.delete(E),this._roots.delete(v),!0):!1}get(E){return this.map.get(E)}comparePositions(E,v){const S=typeof E=="string"?this.map.get(E):E,u=typeof v=="string"?this.map.get(v):v;if(!S||!u)return 0;if(S===u)return 3;for(let f=this.map.get(u.parent);f;f=this.map.get(f.parent))if(f===S)return 1;for(let f=this.map.get(S.parent);f;f=this.map.get(f.parent))if(f===u)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=p;class a{constructor(E,v){this.testIdToInternal=E,this.publishDiff=v,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(E,v){this.addItem(E,v,null)}getTestByReference(E){return this.testItemToInternal.get(E)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const v=this.diff[this.diff.length-1];if(v&&E[0]===1){if(v[0]===1&&v[1].extId===E[1].extId){(0,I.applyTestItemUpdate)(v[1],E[1]);return}if(v[0]===0&&v[1].item.extId===E[1].extId){(0,I.applyTestItemUpdate)(v[1],E[1]);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,v){var S;const u=this.testIdToInternal.object.get(E);if(!!u){if((u.expandLevels===void 0||v>u.expandLevels)&&(u.expandLevels=v),u.expand===1){const f=this.refreshChildren(u);return f.isSettled?this.expandChildren(u,v-1):f.p.then(()=>this.expandChildren(u,v-1))}else if(u.expand===3)return((S=u.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?u.initialExpand.p.then(()=>this.expandChildren(u,v-1)):this.expandChildren(u,v-1)}}dispose(){var E;for(const v of this.testItemToInternal.values())(E=v.discoverCts)===null||E===void 0||E.dispose(!0),(0,y.getPrivateApiFor)(v.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(E,v){const S=E==null?void 0:E.actual.id;switch(v[0]){case 2:this.pushDiff([4,S]);break;case 1:this.removeItem(E);break;case 0:this.addItem(v[1],E.src.controller,E);break;case 3:const[u,f,c]=v;switch(f){case"status":this.updateExpandability(E);break;case"range":this.pushDiff([1,{extId:S,item:{range:k.Range.from(c)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:k.MarkdownString.fromStrict(c)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[f]:c??null}}]);break}break;default:(0,T.assertNever)(v[0])}}addItem(E,v,S){if(!(E instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${E.id} did not`);if(this.testItemToInternal.has(E))throw new Error(`Attempted to add a single TestItem ${E.id} multiple times to the tree`);if(this.testIdToInternal.object.has(E.id))throw new Error(`Attempted to insert a duplicate test item ID ${E.id}`);const u=S?S.item.extId:null,f=E.resolveHandler?1:0,c=S?S.expandLevels:1,t={controller:v,tree:this.testIdToInternal.object.id},n={actual:E,parent:u,item:k.TestItem.from(E),expandLevels:c?c-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(E,n),this.pushDiff([0,{parent:u,src:t,expand:f,item:n.item}]);const s=(0,y.getPrivateApiFor)(E);s.parent=S==null?void 0:S.actual,s.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const r of s.children.values())this.testItemToInternal.has(r)||this.addItem(r,v,n)}updateExpandability(E){var v;let S;E.actual.resolveHandler?E.actual.status===D.TestItemStatus.Pending?S=E.discoverCts?2:1:((v=E.initialExpand)===null||v===void 0||v.complete(),S=3):S=0,S!==E.expand&&(E.expand=S,this.pushDiff([1,{extId:E.actual.id,expand:S}]),S===1&&E.expandLevels!==void 0&&this.refreshChildren(E))}expandChildren(E,v){if(v<0)return;const S=[...E.actual.children.values()].map(u=>this.expand(u.id,v)).filter(R.isThenable);if(S.length)return Promise.all(S).then(()=>{})}refreshChildren(E){if(E.discoverCts&&E.discoverCts.dispose(!0),!E.actual.resolveHandler){const v=new R.DeferredPromise;return v.complete(),v}return E.expand=2,E.discoverCts=new C.CancellationTokenSource,this.pushExpandStateUpdate(E),E.initialExpand=new R.DeferredPromise,E.actual.resolveHandler(E.discoverCts.token),E.initialExpand}pushExpandStateUpdate(E){this.pushDiff([1,{extId:E.actual.id,expand:E.expand}])}removeItem(E){var v;this.pushDiff([2,E.actual.id]);const S=[E];for(;S.length;){const u=S.pop();if(!!u){(v=u.discoverCts)===null||v===void 0||v.dispose(!0),this.testIdToInternal.object.delete(u.item.extId),this.testItemToInternal.delete(u.actual);for(const f of u.actual.children.values())S.push(this.testIdToInternal.object.get(f.id))}}}flushDiff(){const E=this.collectDiff();E.length&&this.publishDiff(E)}}e.SingleUseTestCollection=a}),define(ge[218],pe([0,1,26,3,9]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=T;class y{constructor(i){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(w.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(w.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let A of i.activationEvents)A==="onUri"&&(A=`onUri:${w.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(A)||this._activationMap.set(A,[]),this._activationMap.get(A).push(i)}}keepOnly(i){const A=new Set;i.forEach(d=>A.add(w.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>A.has(w.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,A){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const d=y._findLoopingExtensions(this._extensionDescriptions);if(A=A.concat(d.map(p=>p.identifier)),A.length>0){const p=new Set;A.forEach(a=>p.add(w.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!p.has(w.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(d)}static _findLoopingExtensions(i){const A=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,v){this.addNode(E),this.addNode(v),this._arcs.has(E)?this._arcs.get(E).push(v):this._arcs.set(E,[v])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,v){const S=A.getArcs(E);for(let u=0;u<S.length;u++)if(!v.has(S[u]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let E of i){const v=w.ExtensionIdentifier.toKey(E.identifier);if(d.set(v,E),E.extensionDependencies)for(let S of E.extensionDependencies){const u=w.ExtensionIdentifier.toKey(S);A.addArc(v,u)}}let p=new Set;A.getNodes().filter(E=>A.getArcs(E).length===0).forEach(E=>p.add(E));let a=A.getNodes().filter(E=>!p.has(E)),h;do{h=!1;for(let E=0;E<a.length;E++){const v=a[E];A.hasOnlyGoodArcs(v,p)&&(a.splice(E,1),E--,p.add(v),h=!0)}}while(h);return a.map(E=>d.get(E))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(w.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const A=this._activationMap.get(i);return A?A.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const A=this._extensionsMap.get(w.ExtensionIdentifier.toKey(i));return A||void 0}}e.ExtensionDescriptionRegistry=y;var k;(function(I){I[I.Builtin=0]="Builtin",I[I.User=1]="User",I[I.Dev=2]="Dev"})(k||(k={}));function D(I,i){const A=I.isBuiltin?0:I.isUnderDevelopment?2:1,d=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(A!==d)return A-d;const p=C.posix.basename(I.extensionLocation.path),a=C.posix.basename(i.extensionLocation.path);return p<a?-1:p>a?1:0}}),define(ge[219],pe([0,1,23]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function T(k){const D=w.VSBuffer.alloc(1);switch(k){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=T;function y(k,D){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(ge[39],pe([0,1,3,2,4,26,183]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");class k{constructor(S){this.dependency=S}}e.MissingExtensionDependency=k;var D;(function(v){v[v.LocalProcess=0]="LocalProcess",v[v.LocalWebWorker=1]="LocalWebWorker",v[v.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class I{constructor(S,u,f,c){this.codeLoadingTime=S,this.activateCallTime=u,this.activateResolvedTime=f,this.activationReason=c}}e.ActivationTimes=I;class i{constructor(S,u){this.description=S,this.value=u}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var A;(function(v){v[v.Normal=0]="Normal",v[v.Immediate=1]="Immediate"})(A=e.ActivationKind||(e.ActivationKind={}));function d(v){v.enableProposedApi||p(v)}e.checkProposedApiEnabled=d;function p(v){throw new Error(`[${v.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`)}e.throwProposedApiError=p;function a(v){return{type:v.isBuiltin?0:1,isBuiltin:v.isBuiltin||v.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(v.publisher,v.name),uuid:v.uuid},manifest:v,location:v.extensionLocation}}e.toExtension=a;function h(v){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(v.identifier.id),isBuiltin:v.type===0,isUserBuiltin:v.type===1&&v.isBuiltin,isUnderDevelopment:!1,extensionLocation:v.location},v.manifest),{uuid:v.identifier.uuid})}e.toExtensionDescription=h;class E{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,u){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,u,f,c,t){}_onDidActivateExtensionError(S,u){}_onExtensionRuntimeError(S,u){}_onExtensionHostExit(S){}}e.NullExtensionService=E}),define(ge[220],pe([0,1,26,39,14]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class y{constructor(a,h,E,v){this.startup=a,this.codeLoadingTime=h,this.activateCallTime=E,this.activateResolvedTime=v}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class k{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,h){return a===-1||h===-1?-1:h-a}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class D{constructor(a,h,E,v,S,u){this.activationFailed=a,this.activationFailedError=h,this.activationTimes=E,this.module=v,this.exports=S,this.subscriptions=u}}e.ActivatedExtension=D;class I extends D{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class i extends D{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class A extends D{constructor(a){super(!0,a,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=A;let d=class{constructor(a,h,E,v,S){this._logService=S,this._registry=a,this._resolvedExtensionsSet=new Set,h.forEach(u=>this._resolvedExtensionsSet.add(w.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,E.forEach(u=>this._hostExtensionsMap.set(w.ExtensionIdentifier.toKey(u),u)),this._host=v,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const h=w.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(h)}getActivatedExtension(a){const h=w.ExtensionIdentifier.toKey(a),E=this._activatedExtensions.get(h);if(!E)throw new Error("Extension `"+a.value+"` is not known or not activated");return E}activateByEvent(a,h){if(this._alreadyActivatedEvents[a])return T;const E=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(E.map(v=>({id:v.identifier,reason:{startup:h,extensionId:v.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,h){const E=this._registry.getExtensionDescription(a);if(!E)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:E.identifier,reason:h}])}_handleActivateRequest(a,h,E){if(this._hostExtensionsMap.has(w.ExtensionIdentifier.toKey(a.id))){h[w.ExtensionIdentifier.toKey(a.id)]=a;return}const v=this._registry.getExtensionDescription(a.id);if(!v){const f=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,f,new R.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(w.ExtensionIdentifier.toKey(a.id),new A(f));return}const S=typeof v.extensionDependencies=="undefined"?[]:v.extensionDependencies;let u=!0;for(let f=0,c=S.length;f<c;f++){const t=S[f];if(this._resolvedExtensionsSet.has(w.ExtensionIdentifier.toKey(t)))continue;const n=this._activatedExtensions.get(w.ExtensionIdentifier.toKey(t));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const g=v.displayName||v.identifier.value,m=this._registry.getExtensionDescription(t),_=m&&m.displayName||t,b=new Error(`Cannot activate the '${g}' extension because its dependency '${_}' failed to activate`);b.detail=n.activationFailedError,this._host.onExtensionActivationError(v.identifier,b,null),this._activatedExtensions.set(w.ExtensionIdentifier.toKey(v.identifier),new A(b));return}if(this._hostExtensionsMap.has(w.ExtensionIdentifier.toKey(t))){u=!1,h[w.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(w.ExtensionIdentifier.toKey(t)),reason:a.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){u=!1,h[w.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:a.reason};continue}const r=v.displayName||v.identifier.value,o=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(v.identifier,o,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(w.ExtensionIdentifier.toKey(v.identifier),new A(o));return}u?h[w.ExtensionIdentifier.toKey(v.identifier)]=a:E.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(S=>!this._activatedExtensions.has(w.ExtensionIdentifier.toKey(S.id))),a.length===0))return Promise.resolve(void 0);const h=Object.create(null),E=[];for(let S=0,u=a.length;S<u;S++)this._handleActivateRequest(a[S],h,E);for(let S=0,u=E.length;S<u;S++){const f=w.ExtensionIdentifier.toKey(E[S].id);h[f]&&delete h[f]}const v=Object.keys(h).map(S=>h[S]);return E.length===0?Promise.all(v.map(S=>this._activateExtension(S.id,S.reason))).then(S=>{}):this._activateExtensions(v).then(S=>this._activateExtensions(E))}_activateExtension(a,h){const E=w.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(E))return Promise.resolve(void 0);const v=this._activatingExtensions.get(E);if(v)return v;const S=this._host.actualActivateExtension(a,h).then(void 0,u=>{const f=new Error;return u&&u.name&&(f.name=u.name),u&&u.message?f.message=`Activating extension '${a.value}' failed: ${u.message}.`:f.message=`Activating extension '${a.value}' failed: ${u}.`,u&&u.stack&&(f.stack=u.stack),this._host.onExtensionActivationError(a,f,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(u),new A(u)}).then(u=>{this._activatedExtensions.set(E,u),this._activatingExtensions.delete(E)});return this._activatingExtensions.set(E,S),S}};d=Ve([He(4,C.ILogService)],d),e.ExtensionsActivator=d}),define(ge[221],pe([0,1,14,39,27,10,112]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends w.LogService{constructor(I){if(I.logFile.scheme!==T.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(R.ExtensionHostLogFileName,I.logFile.fsPath,!0,I.logLevel))}$setLevel(I){this.setLevel(I)}};k=Ve([He(0,C.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(ge[222],pe([0,1,17]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,y)=>{this._actualOk=T,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,w.onUnexpectedError)(T))}then(T,y){return this._ensureActual().then(T,y)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=R}),define(ge[126],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class w{constructor(D,I){this.isMain=D,this.sid=I,this.nid=++w.count}}e.ProxyIdentifier=w,w.count=0;const R=[];function C(k){const D=new w(!0,k);return R[D.nid]=D,D}e.createMainContextProxyIdentifier=C;function T(k){const D=new w(!1,k);return R[D.nid]=D,D}e.createExtHostContextProxyIdentifier=T;function y(k){return R[k].sid}e.getStringIdentifierForProxy=y}),define(ge[5],pe([0,1,58,2,126]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));var d;(function(u){u.name="$ident";function f(t,n){return Object.defineProperty(t,u.name,{value:n,enumerable:!0}),t}u.mixin=f;function c(t){return t[u.name]}u.of=c})(d=e.ObjectIdentifier||(e.ObjectIdentifier={}));class p{static mixin(f){return f._id=p._n++,f}}e.IdObject=p,p._n=0;var a;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(E=e.WorkspaceEditType||(e.WorkspaceEditType={}));function v(u){if(u&&u.edits)for(const f of u.edits)typeof f.resource=="object"?f.resource=R.URI.revive(f.resource):(f.newUri=R.URI.revive(f.newUri),f.oldUri=R.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,w.revive)(f.metadata));return u}e.reviveWorkspaceEditDto=v;var S;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,C.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,C.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadTheming:(0,C.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,C.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,C.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostTheming:(0,C.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[88],pe([0,1,5,3,4]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(k){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(w.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,D){return this._proxy.$getPassword(k,D)}store(k,D,I){return this._proxy.$setPassword(k,D,I)}delete(k,D){return this._proxy.$deletePassword(k,D)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(ge[65],pe([0,1,4,14,5,15]),function(G,e,w,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,w.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(C.MainContext.MainThreadTelemetry)}report(D,I,i){const A=this.getUsageKey(D,I);this._reportedUsages.has(A)||(this._reportedUsages.add(A),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:D}))}getUsageKey(D,I){return`${D}-${I.identifier.value}`}};y=Ve([He(0,T.IExtHostRpcService),He(1,R.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(k,D,I){}})}),define(ge[223],pe([0,1,3,5,7,26]),function(G,e,w,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new w.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new w.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,I,i,A={}){const d=T.ExtensionIdentifier.toKey(D.identifier),p=this._inFlightRequests.get(d)||[],a=[...i].sort().join(" ");let h=p.find(E=>E.scopes===a);if(h)return h.result;{const E=this._getSession(D,d,I,i,A);h={scopes:a,result:E},p.push(h),this._inFlightRequests.set(d,p);try{await E}finally{const v=p.findIndex(S=>S.scopes===a);v>-1&&(p.splice(v),this._inFlightRequests.set(d,p))}return E}}async _getSession(D,I,i,A,d={}){await this._proxy.$ensureProvider(i);const p=D.displayName||D.name;return this._proxy.$getSession(i,A,I,p,d)}async removeSession(D,I){const i=this._authenticationProviders.get(D);return i?i.provider.removeSession(I):this._proxy.$removeSession(D,I)}registerAuthenticationProvider(D,I,i,A){var d;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:I,provider:i,options:A??{supportsMultipleAccounts:!1}}),this._providers.find(a=>a.id===D)||this._providers.push({id:D,label:I});const p=i.onDidChangeSessions(a=>{var h,E,v;this._proxy.$sendDidChangeSessions(D,{added:(h=a.added)!==null&&h!==void 0?h:[],changed:(E=a.changed)!==null&&E!==void 0?E:[],removed:(v=a.removed)!==null&&v!==void 0?v:[]})});return this._proxy.$registerAuthenticationProvider(D,I,(d=A==null?void 0:A.supportsMultipleAccounts)!==null&&d!==void 0?d:!1),new C.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(D);const a=this._providers.findIndex(h=>h.id===D);a>-1&&this._providers.splice(a),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,I){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,I){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,I){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,I){return this._onDidChangeSessions.fire({provider:{id:D,label:I}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,I){return D.forEach(i=>{this._providers.some(A=>A.id===i.id)||this._providers.push(i)}),I.forEach(i=>{const A=this._providers.findIndex(d=>d.id===i.id);A>-1&&this._providers.splice(A)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:I}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ge[224],pe([0,1,5,15,20]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(k,D){this._extHostDocumentsAndEditors=D,this._proxy=k.getProxy(w.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const D=C.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};T=Ve([He(0,R.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(ge[225],pe([0,1,5]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(T){const y=T.getProxy(w.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(k){return y.$writeText(k)}})}}e.ExtHostClipboard=R}),define(ge[49],pe([0,1,12,7,20,25,5,16,14,58,42,46,2,6,4,15]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new v(this,s=>{const r=this._apiCommands.get(s);return(r==null?void 0:r.result)===u.Void?r:void 0},n),this._argumentProcessors=[{processArgument(s){return(0,I.revive)(s)}},{processArgument(s){return(0,T.cloneAndChange)(s,function(r){if(i.Range.isIRange(r))return C.Range.to(r);if(A.Position.isIPosition(r))return C.Position.to(r);if(i.Range.isIRange(r.range)&&d.URI.isUri(r.uri))return C.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...s)=>{const r=t.args.map((g,m)=>{if(!g.validate(s[m]))throw new Error(`Invalid argument '${g.name}' when running '${t.id}', received: ${s[m]}`);return g.convert(s[m])}),o=await this.executeCommand(t.internalId,...r);return t.result.convert(o,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,s,r,o){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:s,thisArg:r,description:o}),t&&this._proxy.$registerCommand(n),new R.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,s){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=(0,T.cloneAndChange)(n,function(o){if(o instanceof R.Position)return C.Position.from(o);if(o instanceof R.Range)return C.Range.from(o);if(o instanceof R.Location)return C.location.from(o);if(R.NotebookRange.isNotebookRange(o))return C.NotebookRange.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,r,s);return(0,I.revive)(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw o}}}async _executeContributedCommand(t,n){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:r,thisArg:o,description:g}=s;if(g)for(let m=0;m<g.args.length;m++)try{(0,w.validateConstraint)(n[m],g.args[m].constraint)}catch(_){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${g.args[m].name}' - ${g.args[m].description}`)}try{return await r.apply(o,n)}catch(m){if(t===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...n);_&&(t=_.command)}throw this._logService.error(m,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(s=>this._argumentProcessors.reduce((r,o)=>o.processArgument(r),s)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(s=>s[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,s]of this._commands){let{description:r}=s;r&&(t[n]=r)}return Promise.resolve(t)}};E=Ve([He(0,h.IExtHostRpcService),He(1,D.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class v{constructor(t,n,s){this._commands=t,this._lookupApiCommand=n,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const r=this._lookupApiCommand(t.command);if(r)s.id=r.internalId,s.arguments=r.args.map((o,g)=>o.convert(t.arguments&&t.arguments[g]));else if((0,k.isNonEmptyArray)(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),n.add((0,p.toDisposable)(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),s.$ident=o,s.id=this.delegatingCommandId,s.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return s}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class S{constructor(t,n,s,r){this.name=t,this.description=n,this.validate=s,this.convert=r}optional(){return new S(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new S(t??this.name,n??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",c=>d.URI.isUri(c),c=>c),S.Position=new S("position","A position in a text document",c=>R.Position.isPosition(c),C.Position.from),S.Range=new S("range","A range in a text document",c=>R.Range.isRange(c),C.Range.from),S.Selection=new S("selection","A selection in a text document",c=>R.Selection.isSelection(c),C.Selection.from),S.Number=new S("number","",c=>typeof c=="number",c=>c),S.String=new S("string","",c=>typeof c=="string",c=>c),S.CallHierarchyItem=new S("item","A call hierarchy item",c=>c instanceof R.CallHierarchyItem,C.CallHierarchyItem.to);class u{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=u,u.Void=new u("no result",c=>c);class f{constructor(t,n,s,r,o){this.id=t,this.internalId=n,this.description=s,this.args=r,this.result=o}}e.ApiCommand=f}),define(ge[226],pe([0,1,6,20,7,80,49,203,16,108]),function(G,e,w,R,C,T,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",d(R.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,h)=>{if((0,D.isFalsyOrEmpty)(a))return;class E extends C.SymbolInformation{static to(S){const u=new E(S.name,R.SymbolKind.to(S.kind),S.containerName||"",new C.Location(h[0],R.Range.to(S.range)));return u.detail=S.detail,u.range=u.location.range,u.selectionRange=R.Range.to(S.selectionRange),u.children=S.children?S.children.map(E.to):[],u}}return a.map(E.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",d(R.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",d(R.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(h=>C.Position.isPosition(h)),a=>a.map(R.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(h=>{let E;for(const v of h.reverse())E=new C.SelectionRange(R.Range.to(v),E);return E}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const h=[];if(Array.isArray(a))for(let E of a)h.push(...E[1].map(R.WorkspaceSymbol.to));return h})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(R.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(R.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(R.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return R.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(R.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new C.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const h=(0,I.decodeSemanticTokensDto)(a);if(h.type==="full")return new C.SemanticTokens(h.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new C.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const h=(0,I.decodeSemanticTokensDto)(a);if(h.type==="full")return new C.SemanticTokens(h.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,h,E)=>{if(!a)return new C.CompletionList([]);const v=a.suggestions.map(S=>R.CompletionItem.to(S,E));return new C.CompletionList(v,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return R.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,h,E)=>d(v=>new C.CodeLens(R.Range.to(v.range),v.command&&E.fromInternal(v.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>C.Range.isRange(a),a=>C.Selection.isSelection(a)?R.Selection.from(a):R.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,h,E)=>d(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return E.fromInternal(v.command)}else{const S=new C.CodeAction(v.title,v.kind?new C.CodeActionKind(v.kind):void 0);return v.edit&&(S.edit=R.WorkspaceEdit.to(v.edit)),v.command&&(S.command=E.fromInternal(v.command)),S.isPreferred=v.isPreferred,S}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(h=>new C.ColorInformation(R.Range.to(h.range),R.Color.to(h.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof C.Color,R.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:R.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(R.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",a=>a.map(R.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",d(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(h=>R.NotebookExclusiveDocumentPattern.to(h))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(R.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[R.ViewColumn.from(a.viewColumn),R.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[R.ViewColumn.from(a.viewColumn),R.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[R.ViewColumn.from(a.viewColumn),R.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void)];class A{constructor(h){this._disposables=new w.DisposableStore,this._commands=h}static register(h){return i.forEach(h.registerApiCommand,h),new A(h).registerCommands()}registerCommands(){const h=E=>(...v)=>E(this._commands,...v);this._register(k.RemoveFromRecentlyOpenedAPICommand.ID,h(k.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:E=>typeof E=="string"}]})}_register(h,E,v){const S=this._commands.registerCommand(!1,h,E,this,v);this._disposables.add(S)}}e.ExtHostApiCommands=A;function d(a){return h=>{if(Array.isArray(h))return h.map(a)}}function p(a){if(!Array.isArray(a))return;const h=[];for(const E of a)T.isLocationLink(E)?h.push(R.DefinitionLink.to(E)):h.push(R.location.to(E));return h}}),define(ge[227],pe([0,1,13,53,3,6,2,80,26,20,7,5]),function(G,e,w,R,C,T,y,k,D,I,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class d{constructor(f,c,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=f.getProxy(A.MainContext.MainThreadComments),c.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s||n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.commentUniqueId,g=r.getCommentByUniqueId(o);return g||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.text,g=n.commentUniqueId,m=r.getCommentByUniqueId(g);return m?(m.body=o,m):n}return n}})}createCommentController(f,c,t){const n=d.handlePool++,s=new a(f,n,this._proxy,c,t);this._commentControllers.set(s.handle,s);const r=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(f.identifier))||[];return r.push(s),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(f.identifier),r),s}$createCommentThreadTemplate(f,c,t){const n=this._commentControllers.get(f);!n||n.$createCommentThreadTemplate(c,t)}async $updateCommentThreadTemplate(f,c,t){const n=this._commentControllers.get(f);!n||n.$updateCommentThreadTemplate(c,t)}$deleteCommentThread(f,c){const t=this._commentControllers.get(f);t&&t.$deleteCommentThread(c)}$provideCommentingRanges(f,c,t){const n=this._commentControllers.get(f);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(y.URI.revive(c));return(0,w.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(s,t)).then(r=>r?r.map(o=>I.Range.from(o)):void 0)}$toggleReaction(f,c,t,n,s){const r=this._commentControllers.get(f);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,w.asPromise)(()=>{const o=r.getCommentThread(c);if(o){const g=o.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&g&&r.reactionHandler)return r.reactionHandler(g,v(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=d,d.handlePool=0;class p{constructor(f,c,t,n,s,r,o){this._proxy=f,this._commentController=c,this._id=t,this._uri=n,this._range=s,this._comments=r,this.handle=p._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${c.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,I.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){f.isEqual(this._range)||(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const f=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),c={};f("range")&&(c.range=I.Range.from(this._range)),f("label")&&(c.label=this.label),f("contextValue")&&(c.contextValue=this.contextValue),f("comments")&&(c.comments=this._comments.map(t=>h(this,this._commentController,t,this._commentsMap))),f("collapsibleState")&&(c.collapseState=S(this._collapseState)),f("canReply")&&(c.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(f){for(let c of this._commentsMap){let t=c[0],n=c[1];if(f===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}p._handlePool=0,Ve([(0,R.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=p;class a{constructor(f,c,t,n,s){this._extension=f,this._handle=c,this._proxy=t,this._id=n,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(f,c,t,n){if(typeof f=="string"){const s=new p(this._proxy,this,f,c,t,n,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new p(this._proxy,this,void 0,f,c,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(f,c){const t=new p(this._proxy,this,void 0,y.URI.revive(f),I.Range.to(c),[],this._extension.identifier);return t.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(f,c){let t=this._threads.get(f);t&&(t.range=I.Range.to(c))}$deleteCommentThread(f){let c=this._threads.get(f);c&&c.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function h(u,f,c,t){let n=t.get(c);n||(n=++u.commentHandle,t.set(c,n));const s=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:n,body:I.MarkdownString.from(c.body),userName:c.author.name,userIconPath:s,label:c.label,commentReactions:c.reactions?c.reactions.map(r=>E(r)):void 0}}function E(u){return{label:u.label,iconPath:u.iconPath?I.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function v(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?y.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function S(u){if(u!==void 0)switch(u){case i.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}}),define(ge[127],pe([0,1,2,5,7,4,15,14,16,8,9]),function(G,e,w,R,C,T,y,k,D,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let A=class vn{constructor(p,a){this._logService=a,this._provider=new Map,this._proxy=p.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,a){const h=vn._handlePool++;this._provider.set(h,{provider:p,extensionId:a}),this._proxy.$registerDecorationProvider(h,a.value);const E=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(v=>{if(!v){this._proxy.$onDidChange(h,null);return}let S=(0,D.asArray)(v);if(S.length<=vn._maxEventSize){this._proxy.$onDidChange(h,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,S.length);const u=S.map(t=>({uri:t,rank:(0,I.count)(t.path,"/")})),f=(0,D.groupBy)(u,(t,n)=>t.rank-n.rank||(0,I.compare)(t.uri.path,n.uri.path));let c=[];e:for(let t of f){let n;for(let s of t){let r=(0,i.dirname)(s.uri.path);if(n!==r&&(n=r,c.push(s.uri)>=vn._maxEventSize))break e}}this._proxy.$onDidChange(h,c)});return new C.Disposable(()=>{E==null||E.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(p,a,h){if(!this._provider.has(p))return Object.create(null);const E=Object.create(null),{provider:v,extensionId:S}=this._provider.get(p);return await Promise.all(a.map(async u=>{try{const{uri:f,id:c}=u,t=await Promise.resolve(v.provideFileDecoration(w.URI.revive(f),h));if(!t)return;try{C.FileDecoration.validate(t),E[c]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${S.value}': ${n}`)}}catch(f){this._logService.error(f)}})),E}};A._handlePool=0,A._maxEventSize=250,A=Ve([He(0,y.IExtHostRpcService),He(1,k.ILogService)],A),e.ExtHostDecorations=A,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(ge[228],pe([0,1,161,113,2,5,7,20,3,14,22]),function(G,e,w,R,C,T,y,k,D,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class A{constructor(a,h,E,v,S){this._name=a,this._owner=h,this._maxDiagnosticsPerFile=E,this._proxy=v,this._onDidChangeDiagnostics=S,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,h){if(!a){this.clear();return}this._checkDisposed();let E=[];if(C.URI.isUri(a)){if(!h){this.delete(a);return}this._data.set(a,h.slice()),E=[a]}else if(Array.isArray(a)){E=[];let S;a=[...a].sort(A._compareIndexedTuplesByUri);for(const u of a){const[f,c]=u;if((!S||f.toString()!==S.toString())&&(S&&this._data.get(S).length===0&&this._data.delete(S),S=f,E.push(f),this._data.set(f,[])),c){const t=this._data.get(f);t&&t.push(...c)}else{const t=this._data.get(f);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!this._proxy)return;const v=[];for(let S of E){let u=[];const f=this._data.get(S);if(f)if(f.length>this._maxDiagnosticsPerFile){u=[];const c=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of f)if(n.severity===c[t]&&u.push(k.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;u.push({severity:R.MarkerSeverity.Info,message:(0,w.localize)(0,null,f.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=f.map(c=>k.Diagnostic.from(c));v.push([S,u])}this._proxy.$changeMany(this._owner,v)}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,h){this._checkDisposed();for(let E of this._data.keys())a.apply(h,[E,this.get(E),this])}get(a){this._checkDisposed();const h=this._data.get(a);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,h){return a[0].toString()<h[0].toString()?-1:a[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=A;let d=class jt{constructor(a,h){this._logService=h,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,jt._debouncer,50),jt._mapper),this._proxy=a.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(a,h){return a?a.concat(h):h}static _mapper(a){const h=new i.ResourceMap;for(const E of a)h.set(E,E);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(a,h){const{_collections:E,_proxy:v,_onDidChangeDiagnostics:S,_logService:u}=this,f=new class{$changeMany(n,s){v.$changeMany(n,s),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,n,s.length===0?"CLEARING":s)}$clear(n){v.$clear(n),u.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,n)}dispose(){v.dispose()}};let c;if(!h)h="_generated_diagnostic_collection_name_#"+jt._idPool++,c=h;else if(!E.has(h))c=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do c=h+jt._idPool++;while(E.has(c))}return new class extends A{constructor(){super(h,c,jt._maxDiagnosticsPerFile,f,S);E.set(c,this)}dispose(){super.dispose(),E.delete(c)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const h=new Map,E=[];for(const v of this._collections.values())v.forEach((S,u)=>{let f=h.get(S.toString());typeof f=="undefined"&&(f=E.length,h.set(S.toString(),f),E.push([S,[]])),E[f][1]=E[f][1].concat(...u)});return E}}_getDiagnostics(a){let h=[];for(let E of this._collections.values())E.has(a)&&(h=h.concat(E.get(a)));return h}$acceptMarkersChange(a){if(!this._mirrorCollection){const h="_generated_mirror",E=new A(h,h,jt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(h,E),this._mirrorCollection=E}for(const[h,E]of a)this._mirrorCollection.set(C.URI.revive(h),E.map(k.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=Ve([He(1,I.ILogService)],d),e.ExtHostDiagnostics=d}),define(ge[229],pe([0,1,2,5]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(y){this._proxy=y.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(k=>k?k.map(D=>w.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(k=>k?w.URI.revive(k):void 0)}}e.ExtHostDialogs=C}),define(ge[230],pe([0,1,17,2,7,5,10,21,8]),function(G,e,w,R,C,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(A,d,p){this._documentsAndEditors=d,this._logService=p,this._documentContentProviders=new Map,this._proxy=A.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(A,d){if(Object.keys(y.Schemas).indexOf(A)>=0)throw new Error(`scheme '${A}' already registered`);const p=I._handlePool++;this._documentContentProviders.set(p,d),this._proxy.$registerTextContentProvider(p,A);let a;return typeof d.onDidChange=="function"&&(a=d.onDidChange(h=>{if(h.scheme!==A){this._logService.warn(`Provider for scheme '${A}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(p,h).then(E=>{if(!E&&typeof E!="string")return;const v=this._documentsAndEditors.getDocument(h);if(!v)return;const S=(0,D.splitLines)(E);if(!v.equalLines(S))return this._proxy.$onVirtualDocumentChange(h,E)},w.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(A,d){const p=this._documentContentProviders.get(A);return p?Promise.resolve(p.provideTextDocumentContent(R.URI.revive(d),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(ge[231],pe([0,1,3,6,2,5,120,20,12,25]),function(G,e,w,R,C,T,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(d,p){this._onDidAddDocument=new w.Emitter,this._onDidRemoveDocument=new w.Emitter,this._onDidChangeDocument=new w.Emitter,this._onDidSaveDocument=new w.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const h of a)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const h of a)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const p=this._documentsAndEditors.getDocument(d);if(p)return p}getDocument(d){const p=this.getDocumentData(d);if(!(p==null?void 0:p.document))throw new Error(`Unable to retrieve document from URI '${d}'`);return p.document}ensureDocumentData(d){const p=this._documentsAndEditors.getDocument(d);if(p)return Promise.resolve(p);let a=this._documentLoader.get(d.toString());return a||(a=this._proxy.$tryOpenDocument(d).then(h=>{this._documentLoader.delete(d.toString());const E=C.URI.revive(h);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(E))},h=>(this._documentLoader.delete(d.toString()),Promise.reject(h))),this._documentLoader.set(d.toString(),a)),a}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(p=>C.URI.revive(p))}$acceptModelModeChanged(d,p){const a=C.URI.revive(d),h=this._documentsAndEditors.getDocument(a);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(p),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(d){const p=C.URI.revive(d),a=this._documentsAndEditors.getDocument(p);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(d,p){const a=C.URI.revive(d),h=this._documentsAndEditors.getDocument(a);if(!h)throw new Error("unknown document");h._acceptIsDirty(p),this._onDidChangeDocument.fire({document:h.document,contentChanges:[]})}$acceptModelChanged(d,p,a){const h=C.URI.revive(d),E=this._documentsAndEditors.getDocument(h);if(!E)throw new Error("unknown document");E._acceptIsDirty(a),E.onEvents(p),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:E.document,contentChanges:p.changes.map(v=>({range:k.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text}))}))}setWordDefinitionFor(d,p){(0,y.setWordDefinitionFor)(d,p)}}e.ExtHostDocuments=i}),define(ge[40],pe([0,1,51,3,6,2,4,5,120,15,125,20,14,22,10,54,135]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class v{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(f,c){this._extHostRpc=f,this._logService=c,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const c=[],t=[],n=[];if(f.removedDocuments)for(const s of f.removedDocuments){const r=T.URI.revive(s),o=this._documents.get(r);(o==null?void 0:o.unref())&&(this._documents.delete(r),c.push(o.value))}if(f.addedDocuments)for(const s of f.addedDocuments){const r=T.URI.revive(s.uri);let o=this._documents.get(r);if(o&&r.scheme!==a.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);o||(o=new v(new D.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),r,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(r,o),t.push(o.value)),o.ref()}if(f.removedEditors)for(const s of f.removedEditors){const r=this._editors.get(s);this._editors.delete(s),r&&n.push(r)}if(f.addedEditors)for(const s of f.addedEditors){const r=T.URI.revive(s.documentUri);w.ok(this._documents.has(r),`document '${r}' does not exist`),w.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const o=this._documents.get(r).value,g=new i.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>o.document),s.selections.map(A.Selection.to),s.options,s.visibleRanges.map(m=>A.Range.to(m)),typeof s.editorPosition=="number"?A.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,g)}f.newActiveEditor!==void 0&&(w.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,C.dispose)(c),(0,C.dispose)(n),f.removedDocuments&&this._onDidRemoveDocuments.fire(c),f.addedDocuments&&this._onDidAddDocuments.fire(t),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){var c;return(c=this._documents.get(f))===null||c===void 0?void 0:c.value}allDocuments(){return h.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const c=this._editors.get(this._activeEditorId);return f?c:c==null?void 0:c.value}allEditors(){return[...this._editors.values()]}};S=Ve([He(0,I.IExtHostRpcService),He(1,d.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[232],pe([0,1,2,5,6,7,20,144,8,23]),function(G,e,w,R,C,T,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const a=this._schemes.indexOf(p);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),a=[];let h,E,v=14,S=14;for(const u of p){let f=h?(0,D.commonPrefixLength)(h,u):0;for(f===0?E=1:E=S;f<u.length;f++)f+1===u.length?(v=S,S=9):S+=1,a.push([E,u.toUpperCase().charCodeAt(f),S]),a.push([E,u.toLowerCase().charCodeAt(f),S]),E=S;h=u,S=v}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new k.StateMachine(a)}}provideDocumentLinks(p){this._initStateMachine();const a=[],h=k.LinkComputer.computeLinks({getLineContent(E){return p.lineAt(E-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const E of h){const v=y.DocumentLink.to(E);v.target&&a.push(v)}return a}}class A{constructor(p,a){this._extHostLanguageFeatures=a,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=p.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var p;(p=this._linkProviderRegistration)===null||p===void 0||p.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(p,a,h,E={},v){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const S=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(S,h),this._enableProposedApi.set(S,v??!1);let u=2;E.isCaseSensitive&&(u+=1024),E.isReadonly&&(u+=2048),typeof h.copy=="function"&&(u+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(S,a,u).catch(c=>{console.error(`FAILED to register filesystem provider of ${p.value}-extension for the scheme ${a}`),console.error(c)});const f=h.onDidChangeFile(c=>{const t=[];for(const n of c){let{uri:s,type:r}=n;if(s.scheme!==a)continue;let o;switch(r){case T.FileChangeType.Changed:o=0;break;case T.FileChangeType.Created:o=1;break;case T.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:o})}this._proxy.$onFileSystemChange(S,t)});return(0,C.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(S),this._enableProposedApi.delete(S),this._proxy.$unregisterProvider(S)})}static _asIStat(p,a){const{type:h,ctime:E,mtime:v,size:S,permissions:u}=p;return a?{type:h,ctime:E,mtime:v,size:S,permissions:u}:{type:h,ctime:E,mtime:v,size:S}}$stat(p,a){return Promise.resolve(this._getFsProvider(p).stat(w.URI.revive(a))).then(h=>{var E;return A._asIStat(h,(E=this._enableProposedApi.get(p))!==null&&E!==void 0?E:!1)})}$readdir(p,a){return Promise.resolve(this._getFsProvider(p).readDirectory(w.URI.revive(a)))}$readFile(p,a){return Promise.resolve(this._getFsProvider(p).readFile(w.URI.revive(a))).then(h=>I.VSBuffer.wrap(h))}$writeFile(p,a,h,E){return Promise.resolve(this._getFsProvider(p).writeFile(w.URI.revive(a),h.buffer,E))}$delete(p,a,h){return Promise.resolve(this._getFsProvider(p).delete(w.URI.revive(a),h))}$rename(p,a,h,E){return Promise.resolve(this._getFsProvider(p).rename(w.URI.revive(a),w.URI.revive(h),E))}$copy(p,a,h,E){const v=this._getFsProvider(p);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(w.URI.revive(a),w.URI.revive(h),E))}$mkdir(p,a){return Promise.resolve(this._getFsProvider(p).createDirectory(w.URI.revive(a)))}$watch(p,a,h,E){const v=this._getFsProvider(p).watch(w.URI.revive(h),E);this._watches.set(a,v)}$unwatch(p,a){const h=this._watches.get(a);h&&(h.dispose(),this._watches.delete(a))}$open(p,a,h){const E=this._getFsProvider(p);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(w.URI.revive(a),h))}$close(p,a){const h=this._getFsProvider(p);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(a))}$read(p,a,h,E){const v=this._getFsProvider(p);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const S=I.VSBuffer.alloc(E);return Promise.resolve(v.read(a,h,S.buffer,0,E)).then(u=>S.slice(0,u))}$write(p,a,h,E){const v=this._getFsProvider(p);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(a,h,E.buffer,0,E.byteLength))}_getFsProvider(p){const a=this._fsProvider.get(p);if(!a){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return a}}e.ExtHostFileSystem=A}),define(ge[89],pe([0,1,5,43,7,23,4,15,62]),function(G,e,w,R,C,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let I=class Ut{constructor(A,d){const p=A.getProxy(w.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return p.$stat(a).catch(Ut._handleError)},readDirectory(a){return p.$readdir(a).catch(Ut._handleError)},createDirectory(a){return p.$mkdir(a).catch(Ut._handleError)},async readFile(a){return p.$readFile(a).then(h=>h.buffer).catch(Ut._handleError)},writeFile(a,h){return p.$writeFile(a,T.VSBuffer.wrap(h)).catch(Ut._handleError)},delete(a,h){return p.$delete(a,Object.assign({recursive:!1,useTrash:!1},h)).catch(Ut._handleError)},rename(a,h,E){return p.$rename(a,h,Object.assign({overwrite:!1},E)).catch(Ut._handleError)},copy(a,h,E){return p.$copy(a,h,Object.assign({overwrite:!1},E)).catch(Ut._handleError)},isWritableFileSystem(a){const h=d.getCapabilities(a);if(typeof h=="number")return!(h&2048)}})}static _handleError(A){if(!(A instanceof Error))throw new C.FileSystemError(String(A));if(A.name==="ENOPRO")throw C.FileSystemError.Unavailable(A.message);switch(A.name){case R.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(A.message);case R.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(A.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(A.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(A.message);case R.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(A.message);case R.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(A.message);default:throw new C.FileSystemError(A.message,A.name)}}};I=Ve([He(0,k.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],I),e.ExtHostConsumerFileSystem=I,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[233],pe([0,1,6,5]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(y){this._handlePool=0,this._proxy=y.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,y),(0,w.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=C}),define(ge[234],pe([0,1,2,25,20,7,13,5,8,42,16,12,141,6,108,73,85,44,17,3]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E,v,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor(q,J){this._documents=q,this._provider=J}provideDocumentSymbols(q,J){const re=this._documents.getDocument(q);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(re,J)).then(oe=>{if(!(0,i.isFalsyOrEmpty)(oe))return oe[0]instanceof T.DocumentSymbol?oe.map(C.DocumentSymbol.from):f._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree(q){var J;q=q.slice(0).sort((Y,ce)=>{let ve=Y.location.range.start.compareTo(ce.location.range.start);return ve===0&&(ve=ce.location.range.end.compareTo(Y.location.range.end)),ve});const re=[],oe=[];for(const Y of q){const ce={name:Y.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Y.kind),tags:((J=Y.tags)===null||J===void 0?void 0:J.map(C.SymbolTag.from))||[],detail:"",containerName:Y.containerName,range:C.Range.from(Y.location.range),selectionRange:C.Range.from(Y.location.range),children:[]};for(;;){if(oe.length===0){oe.push(ce),re.push(ce);break}const ve=oe[oe.length-1];if(I.Range.containsRange(ve.range,ce.range)&&!I.Range.equalsRange(ve.range,ce.range)){ve.children&&ve.children.push(ce),oe.push(ce);break}oe.pop()}}return re}}class c{constructor(q,J,re){this._documents=q,this._commands=J,this._provider=re,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,J){const re=this._documents.getDocument(q),oe=await this._provider.provideCodeLenses(re,J);if(!oe||J.isCancellationRequested)return;const Y=this._cache.add(oe),ce=new p.DisposableStore;this._disposables.set(Y,ce);const ve={cacheId:Y,lenses:[]};for(let Le=0;Le<oe.length;Le++)ve.lenses.push({cacheId:[Y,Le],range:C.Range.from(oe[Le].range),command:this._commands.toInternal(oe[Le].command,ce)});return ve}async resolveCodeLens(q,J){var re;const oe=q.cacheId&&this._cache.get(...q.cacheId);if(!oe)return;let Y;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?Y=oe:Y=await this._provider.resolveCodeLens(oe,J),Y||(Y=oe),J.isCancellationRequested)return;const ce=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!ce)return q.command=this._commands.toInternal((re=Y.command)!==null&&re!==void 0?re:c._badCmd,ce),q}releaseCodeLenses(q){var J;(J=this._disposables.get(q))===null||J===void 0||J.dispose(),this._disposables.delete(q),this._cache.delete(q)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(qe){return Array.isArray(qe)?qe.map(C.DefinitionLink.from):qe?[C.DefinitionLink.from(qe)]:[]}class n{constructor(q,J){this._documents=q,this._provider=J}provideDefinition(q,J,re){const oe=this._documents.getDocument(q),Y=C.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideDefinition(oe,Y,re)).then(t)}}class s{constructor(q,J){this._documents=q,this._provider=J}provideDeclaration(q,J,re){const oe=this._documents.getDocument(q),Y=C.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideDeclaration(oe,Y,re)).then(t)}}class r{constructor(q,J){this._documents=q,this._provider=J}provideImplementation(q,J,re){const oe=this._documents.getDocument(q),Y=C.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideImplementation(oe,Y,re)).then(t)}}class o{constructor(q,J){this._documents=q,this._provider=J}provideTypeDefinition(q,J,re){const oe=this._documents.getDocument(q),Y=C.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(oe,Y,re)).then(t)}}class g{constructor(q,J){this._documents=q,this._provider=J}provideHover(q,J,re){const oe=this._documents.getDocument(q),Y=C.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideHover(oe,Y,re)).then(ce=>{if(!(!ce||(0,i.isFalsyOrEmpty)(ce.contents)))return ce.range||(ce.range=oe.getWordRangeAtPosition(Y)),ce.range||(ce.range=new T.Range(Y,Y)),C.Hover.from(ce)})}}class m{constructor(q,J){this._documents=q,this._provider=J}provideEvaluatableExpression(q,J,re){const oe=this._documents.getDocument(q),Y=C.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(oe,Y,re)).then(ce=>{if(ce)return C.EvaluatableExpression.from(ce)})}}class _{constructor(q,J){this._documents=q,this._provider=J}provideInlineValues(q,J,re,oe){const Y=this._documents.getDocument(q);return(0,y.asPromise)(()=>this._provider.provideInlineValues(Y,C.Range.to(J),C.InlineValueContext.to(re),oe)).then(ce=>{if(Array.isArray(ce))return ce.map(ve=>C.InlineValue.from(ve))})}}class b{constructor(q,J){this._documents=q,this._provider=J}provideDocumentHighlights(q,J,re){const oe=this._documents.getDocument(q),Y=C.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(oe,Y,re)).then(ce=>{if(Array.isArray(ce))return ce.map(C.DocumentHighlight.from)})}}class l{constructor(q,J){this._documents=q,this._provider=J}provideLinkedEditingRanges(q,J,re){const oe=this._documents.getDocument(q),Y=C.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(oe,Y,re)).then(ce=>{if(ce&&Array.isArray(ce.ranges))return{ranges:(0,i.coalesce)(ce.ranges.map(C.Range.from)),wordPattern:ce.wordPattern}})}}class L{constructor(q,J){this._documents=q,this._provider=J}provideReferences(q,J,re,oe){const Y=this._documents.getDocument(q),ce=C.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideReferences(Y,ce,re,oe)).then(ve=>{if(Array.isArray(ve))return ve.map(C.location.from)})}}class O{constructor(q,J,re,oe,Y,ce,ve){this._documents=q,this._commands=J,this._diagnostics=re,this._provider=oe,this._logService=Y,this._extension=ce,this._apiDeprecation=ve,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(q,J,re,oe){const Y=this._documents.getDocument(q),ce=d.Selection.isISelection(J)?C.Selection.to(J):C.Range.to(J),ve=[];for(const we of this._diagnostics.getDiagnostics(q))if(ce.intersection(we.range)&&ve.push(we)>O._maxCodeActionsPerFile)break;const Le={diagnostics:ve,only:re.only?new T.CodeActionKind(re.only):void 0,triggerKind:C.CodeActionTriggerKind.to(re.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(Y,ce,Le,oe)).then(we=>{var je;if(!(0,i.isNonEmptyArray)(we)||oe.isCancellationRequested)return;const K=this._cache.add(we),ne=new p.DisposableStore;this._disposables.set(K,ne);const Ee=[];for(let Oe=0;Oe<we.length;Oe++){const $e=we[Oe];!$e||(O._isCommand($e)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ee.push({_isSynthetic:!0,title:$e.title,command:this._commands.toInternal($e,ne)})):(Le.only&&($e.kind?Le.only.contains($e.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action is of kind '${$e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ee.push({cacheId:[K,Oe],title:$e.title,command:$e.command&&this._commands.toInternal($e.command,ne),diagnostics:$e.diagnostics&&$e.diagnostics.map(C.Diagnostic.from),edit:$e.edit&&C.WorkspaceEdit.from($e.edit),kind:$e.kind&&$e.kind.value,isPreferred:$e.isPreferred,disabled:(je=$e.disabled)===null||je===void 0?void 0:je.reason})))}return{cacheId:K,actions:Ee}})}async resolveCodeAction(q,J){var re;const[oe,Y]=q,ce=this._cache.get(oe,Y);if(!ce||O._isCommand(ce)||!this._provider.resolveCodeAction)return;const ve=(re=await this._provider.resolveCodeAction(ce,J))!==null&&re!==void 0?re:ce;return(ve==null?void 0:ve.edit)?C.WorkspaceEdit.from(ve.edit):void 0}releaseCodeActions(q){var J;(J=this._disposables.get(q))===null||J===void 0||J.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}O._maxCodeActionsPerFile=1e3;class ${constructor(q,J){this._documents=q,this._provider=J}provideDocumentFormattingEdits(q,J,re){const oe=this._documents.getDocument(q);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(oe,J,re)).then(Y=>{if(Array.isArray(Y))return Y.map(C.TextEdit.from)})}}class ie{constructor(q,J){this._documents=q,this._provider=J}provideDocumentRangeFormattingEdits(q,J,re,oe){const Y=this._documents.getDocument(q),ce=C.Range.to(J);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(Y,ce,re,oe)).then(ve=>{if(Array.isArray(ve))return ve.map(C.TextEdit.from)})}}class se{constructor(q,J){this._documents=q,this._provider=J,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(q,J,re,oe,Y){const ce=this._documents.getDocument(q),ve=C.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(ce,ve,re,oe,Y)).then(Le=>{if(Array.isArray(Le))return Le.map(C.TextEdit.from)})}}class U{constructor(q,J){this._provider=q,this._logService=J,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(q,J){const re=k.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(q,J)).then(oe=>{if((0,i.isNonEmptyArray)(oe))for(const Y of oe){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const ce=k.IdObject.mixin(C.WorkspaceSymbol.from(Y));this._symbolCache.set(ce._id,Y),re.symbols.push(ce)}}).then(()=>(re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re))}async resolveWorkspaceSymbol(q,J){if(typeof this._provider.resolveWorkspaceSymbol!="function")return q;const re=this._symbolCache.get(q._id);if(re){const oe=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(re,J));return oe&&(0,R.mixin)(q,C.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(q){const J=this._resultCache.get(q);if(J){for(let[re,oe]=J;re<=oe;re++)this._symbolCache.delete(re);this._resultCache.delete(q)}}}class V{constructor(q,J,re){this._documents=q,this._provider=J,this._logService=re}static supportsResolving(q){return typeof q.prepareRename=="function"}provideRenameEdits(q,J,re,oe){const Y=this._documents.getDocument(q),ce=C.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(Y,ce,re,oe)).then(ve=>{if(!!ve)return C.WorkspaceEdit.from(ve)},ve=>{const Le=V._asMessage(ve);return Le?{rejectReason:Le,edits:void 0}:Promise.reject(ve)})}resolveRenameLocation(q,J,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(q),Y=C.Position.to(J);return(0,y.asPromise)(()=>this._provider.prepareRename(oe,Y,re)).then(ce=>{let ve,Le;if(T.Range.isRange(ce)?(ve=ce,Le=oe.getText(ce)):(0,A.isObject)(ce)&&(ve=ce.range,Le=ce.placeholder),!!ve){if(ve.start.line>Y.line||ve.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ve),text:Le}}},ce=>{const ve=V._asMessage(ce);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(ce)})}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class W{constructor(q,J){this.resultId=q,this.tokens=J}}class P{constructor(q,J){this._documents=q,this._provider=J,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(q,J,re){const oe=this._documents.getDocument(q),Y=J!==0?this._previousResults.get(J):null;return(0,y.asPromise)(()=>Y&&typeof Y.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,Y.resultId,re):this._provider.provideDocumentSemanticTokens(oe,re)).then(ce=>(Y&&this._previousResults.delete(J),ce?(ce=P._fixProvidedSemanticTokens(ce),this._send(P._convertToEdits(Y,ce),ce)):null))}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return P._isSemanticTokens(q)?P._isCorrectSemanticTokens(q)?q:new T.SemanticTokens(new Uint32Array(q.data),q.resultId):P._isSemanticTokensEdits(q)?P._isCorrectSemanticTokensEdits(q)?q:new T.SemanticTokensEdits(q.edits.map(J=>new T.SemanticTokensEdit(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const J of q.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,J){if(!P._isSemanticTokens(J)||!q||!q.tokens)return J;const re=q.tokens,oe=re.length,Y=J.data,ce=Y.length;let ve=0;const Le=Math.min(oe,ce);for(;ve<Le&&re[ve]===Y[ve];)ve++;if(ve===oe&&ve===ce)return new T.SemanticTokensEdits([],J.resultId);let we=0;const je=Le-ve;for(;we<je&&re[oe-we-1]===Y[ce-we-1];)we++;return new T.SemanticTokensEdits([{start:ve,deleteCount:oe-ve-we,data:Y.subarray(ve,ce-we)}],J.resultId)}_send(q,J){if(P._isSemanticTokens(q)){const re=this._nextResultId++;return this._previousResults.set(re,new W(q.resultId,q.data)),(0,a.encodeSemanticTokensDto)({id:re,type:"full",data:q.data})}if(P._isSemanticTokensEdits(q)){const re=this._nextResultId++;return P._isSemanticTokens(J)?this._previousResults.set(re,new W(J.resultId,J.data)):this._previousResults.set(re,new W(q.resultId)),(0,a.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(q.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=P;class N{constructor(q,J){this._documents=q,this._provider=J}provideDocumentRangeSemanticTokens(q,J,re){const oe=this._documents.getDocument(q);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(oe,C.Range.to(J),re)).then(Y=>Y?this._send(Y):null)}_send(q){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=N;class F{constructor(q,J,re,oe,Y){this._documents=q,this._commands=J,this._provider=re,this._apiDeprecation=oe,this._extension=Y,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,J,re,oe){const Y=this._documents.getDocument(q),ce=C.Position.to(J),ve=Y.getWordRangeAtPosition(ce)||new T.Range(ce,ce),Le=ve.with({end:ce}),we=new v.StopWatch(!0),je=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(Y,ce,oe,C.CompletionContext.to(re)));if(!je||oe.isCancellationRequested)return;const K=Array.isArray(je)?new T.CompletionList(je):je,ne=F.supportsResolving(this._provider)?this._cache.add(K.items):this._cache.add([]),Ee=new p.DisposableStore;this._disposables.set(ne,Ee);const Oe=[],$e={x:ne,b:Oe,a:{replace:C.Range.from(ve),insert:C.Range.from(Le)},c:K.isIncomplete||void 0,d:we.elapsed()};for(let We=0;We<K.items.length;We++){const Xe=K.items[We],De=this._convertCompletionItem(Xe,[ne,We],Le,ve);Oe.push(De)}return $e}async resolveCompletionItem(q,J){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...q);if(!re)return;const oe=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(re,J));if(!!oe)return this._convertCompletionItem(oe,q)}releaseCompletionItems(q){var J;(J=this._disposables.get(q))===null||J===void 0||J.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,J,re,oe){var Y;const ce=this._disposables.get(J[0]);if(!ce)throw Error("DisposableStore is missing...");const ve={x:J,a:(Y=q.label)!==null&&Y!==void 0?Y:"",o:q.label2,b:q.kind!==void 0?C.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(C.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(q.command,ce)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ve.h=q.textEdit.newText):typeof q.insertText=="string"?ve.h=q.insertText:q.insertText instanceof T.SnippetString&&(ve.h=q.insertText.value,ve.i|=4);let Le;return q.textEdit?Le=q.textEdit.range:q.range&&(Le=q.range),T.Range.isRange(Le)?ve.j=C.Range.from(Le):Le&&(!(re==null?void 0:re.isEqual(Le.inserting))||!(oe==null?void 0:oe.isEqual(Le.replacing)))&&(ve.j={insert:C.Range.from(Le.inserting),replace:C.Range.from(Le.replacing)}),ve}}class M{constructor(q,J,re){this._documents=q,this._provider=J,this._commands=re,this._cache=new E.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,J,re,oe){const Y=this._documents.getDocument(q),ce=C.Position.to(J),ve=await(0,y.asPromise)(()=>this._provider.provideInlineCompletionItems(Y,ce,re,oe));if(!ve||oe.isCancellationRequested)return;const Le=this._cache.add(ve.items);let we;return{pid:Le,items:ve.items.map((je,K)=>{let ne;return je.command&&(we||(we=new p.DisposableStore,this._disposables.set(Le,we)),ne=this._commands.toInternal(je.command,we)),{text:je.text,range:je.range?C.Range.from(je.range):void 0,command:ne,idx:K}})}}disposeCompletions(q){this._cache.delete(q);const J=this._disposables.get(q);J&&J.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,J){const re=this._cache.get(q,J);re&&B.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class B{constructor(){this._onDidShowCompletionItemEmitter=new u.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let J=B.map.get(q);return J||(J=new B,B.map.set(q,J)),J}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=B,B.map=new WeakMap;class H{constructor(q,J){this._documents=q,this._provider=J,this._cache=new E.Cache("SignatureHelp")}provideSignatureHelp(q,J,re,oe){const Y=this._documents.getDocument(q),ce=C.Position.to(J),ve=this.reviveContext(re);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(Y,ce,oe,ve)).then(Le=>{if(Le){const we=this._cache.add([Le]);return Object.assign(Object.assign({},C.SignatureHelp.from(Le)),{id:we})}})}reviveContext(q){let J;if(q.activeSignatureHelp){const re=C.SignatureHelp.to(q.activeSignatureHelp),oe=this._cache.get(q.activeSignatureHelp.id,0);oe?(J=oe,J.activeSignature=re.activeSignature,J.activeParameter=re.activeParameter):J=re}return Object.assign(Object.assign({},q),{activeSignatureHelp:J})}releaseSignatureHelp(q){this._cache.delete(q)}}class Q{constructor(q,J){this._documents=q,this._provider=J}provideInlayHints(q,J,re){const oe=this._documents.getDocument(q);return(0,y.asPromise)(()=>this._provider.provideInlayHints(oe,C.Range.to(J),re)).then(Y=>Y?{hints:Y.map(C.InlayHint.from)}:void 0)}}class le{constructor(q,J){this._documents=q,this._provider=J,this._cache=new E.Cache("DocumentLink")}provideLinks(q,J){const re=this._documents.getDocument(q);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(re,J)).then(oe=>{if(!(!Array.isArray(oe)||oe.length===0)&&!J.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.map(C.DocumentLink.from)};{const Y=this._cache.add(oe),ce={links:[],id:Y};for(let ve=0;ve<oe.length;ve++){const Le=C.DocumentLink.from(oe[ve]);Le.cacheId=[Y,ve],ce.links.push(Le)}return ce}}})}resolveLink(q,J){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const re=this._cache.get(...q);return re?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(re,J)).then(oe=>oe&&C.DocumentLink.from(oe)||void 0):Promise.resolve(void 0)}releaseLinks(q){this._cache.delete(q)}}class be{constructor(q,J){this._documents=q,this._provider=J}provideColors(q,J){const re=this._documents.getDocument(q);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(re,J)).then(oe=>Array.isArray(oe)?oe.map(ce=>({color:C.Color.from(ce.color),range:C.Range.from(ce.range)})):[])}provideColorPresentations(q,J,re){const oe=this._documents.getDocument(q),Y=C.Range.to(J.range),ce=C.Color.to(J.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(ce,{document:oe,range:Y},re)).then(ve=>{if(!!Array.isArray(ve))return ve.map(C.ColorPresentation.from)})}}class Te{constructor(q,J){this._documents=q,this._provider=J}provideFoldingRanges(q,J,re){const oe=this._documents.getDocument(q);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(oe,J,re)).then(Y=>{if(!!Array.isArray(Y))return Y.map(C.FoldingRange.from)})}}class ke{constructor(q,J,re){this._documents=q,this._provider=J,this._logService=re}provideSelectionRanges(q,J,re){const oe=this._documents.getDocument(q),Y=J.map(C.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(oe,Y,re)).then(ce=>{if(!(0,i.isNonEmptyArray)(ce))return[];if(ce.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Le=0;Le<Y.length;Le++){const we=[];ve.push(we);let je=Y[Le],K=ce[Le];for(;;){if(!K.range.contains(je))throw new Error("INVALID selection range, must contain the previous range");if(we.push(C.SelectionRange.from(K)),!K.parent)break;je=K.range,K=K.parent}}return ve})}}class Ne{constructor(q,J){this._documents=q,this._provider=J,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(q,J,re){const oe=this._documents.getDocument(q),Y=C.Position.to(J),ce=await this._provider.prepareCallHierarchy(oe,Y,re);if(!ce)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ce)?ce.map(Le=>this._cacheAndConvertItem(ve,Le)):[this._cacheAndConvertItem(ve,ce)]}async provideCallsTo(q,J,re){const oe=this._itemFromCache(q,J);if(!oe)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(oe,re);if(!!Y)return Y.map(ce=>({from:this._cacheAndConvertItem(q,ce.from),fromRanges:ce.fromRanges.map(ve=>C.Range.from(ve))}))}async provideCallsFrom(q,J,re){const oe=this._itemFromCache(q,J);if(!oe)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(oe,re);if(!!Y)return Y.map(ce=>({to:this._cacheAndConvertItem(q,ce.to),fromRanges:ce.fromRanges.map(ve=>C.Range.from(ve))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,J){var re;const oe=this._cache.get(q),Y={_sessionId:q,_itemId:oe.size.toString(36),name:J.name,detail:J.detail,kind:C.SymbolKind.from(J.kind),uri:J.uri,range:C.Range.from(J.range),selectionRange:C.Range.from(J.selectionRange),tags:(re=J.tags)===null||re===void 0?void 0:re.map(C.SymbolTag.from)};return oe.set(Y._itemId,J),Y}_itemFromCache(q,J){const re=this._cache.get(q);return re==null?void 0:re.get(J)}}class Ke{constructor(q,J){this.adapter=q,this.extension=J}}class ze{constructor(q,J,re,oe,Y,ce,ve){this._adapter=new Map,this._uriTransformer=J,this._proxy=q.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=oe,this._diagnostics=Y,this._logService=ce,this._apiDeprecation=ve}_transformDocumentSelector(q){return(0,i.coalesce)((0,i.asArray)(q).map(J=>this._doTransformDocumentSelector(J)))}_doTransformDocumentSelector(q){if(typeof q=="string")return{$serialized:!0,language:q};if(q)return{$serialized:!0,language:q.language,scheme:this._transformScheme(q.scheme),pattern:typeof q.pattern=="undefined"?void 0:C.GlobPattern.from(q.pattern),exclusive:q.exclusive}}_transformScheme(q){return this._uriTransformer&&typeof q=="string"?this._uriTransformer.transformOutgoingScheme(q):q}_createDisposable(q){return new T.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return ze._handlePool++}_withAdapter(q,J,re,oe,Y=!1){const ce=this._adapter.get(q);if(!ce)return Promise.resolve(oe);if(ce.adapter instanceof J){let ve;ce.extension&&(ve=Date.now(),this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${J.name}'`));const Le=re(ce.adapter,ce.extension),we=ce.extension;return we&&Promise.resolve(Le).then(()=>this._logService.trace(`[${we.identifier.value}] provider DONE after ${Date.now()-ve}ms`),je=>{Y&&je instanceof S.CancellationError||(this._logService.error(`[${we.identifier.value}] provider FAILED`),this._logService.error(je))}),Le}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(q,J){const re=this._nextHandle();return this._adapter.set(re,new Ke(q,J)),re}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,J,re,oe){const Y=this._addNewAdapter(new f(this._documents,re),q),ce=oe&&oe.label||ze._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(J),ce),this._createDisposable(Y)}$provideDocumentSymbols(q,J,re){return this._withAdapter(q,f,oe=>oe.provideDocumentSymbols(w.URI.revive(J),re),void 0)}registerCodeLensProvider(q,J,re){const oe=this._nextHandle(),Y=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Ke(new c(this._documents,this._commands.converter,re),q)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(J),Y);let ce=this._createDisposable(oe);if(Y!==void 0){const ve=re.onDidChangeCodeLenses(Le=>this._proxy.$emitCodeLensEvent(Y));ce=T.Disposable.from(ce,ve)}return ce}$provideCodeLenses(q,J,re){return this._withAdapter(q,c,oe=>oe.provideCodeLenses(w.URI.revive(J),re),void 0)}$resolveCodeLens(q,J,re){return this._withAdapter(q,c,oe=>oe.resolveCodeLens(J,re),void 0)}$releaseCodeLenses(q,J){this._withAdapter(q,c,re=>Promise.resolve(re.releaseCodeLenses(J)),void 0)}registerDefinitionProvider(q,J,re){const oe=this._addNewAdapter(new n(this._documents,re),q);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideDefinition(q,J,re,oe){return this._withAdapter(q,n,Y=>Y.provideDefinition(w.URI.revive(J),re,oe),[])}registerDeclarationProvider(q,J,re){const oe=this._addNewAdapter(new s(this._documents,re),q);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideDeclaration(q,J,re,oe){return this._withAdapter(q,s,Y=>Y.provideDeclaration(w.URI.revive(J),re,oe),[])}registerImplementationProvider(q,J,re){const oe=this._addNewAdapter(new r(this._documents,re),q);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideImplementation(q,J,re,oe){return this._withAdapter(q,r,Y=>Y.provideImplementation(w.URI.revive(J),re,oe),[])}registerTypeDefinitionProvider(q,J,re){const oe=this._addNewAdapter(new o(this._documents,re),q);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideTypeDefinition(q,J,re,oe){return this._withAdapter(q,o,Y=>Y.provideTypeDefinition(w.URI.revive(J),re,oe),[])}registerHoverProvider(q,J,re,oe){const Y=this._addNewAdapter(new g(this._documents,re),q);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(J)),this._createDisposable(Y)}$provideHover(q,J,re,oe){return this._withAdapter(q,g,Y=>Y.provideHover(w.URI.revive(J),re,oe),void 0)}registerEvaluatableExpressionProvider(q,J,re,oe){const Y=this._addNewAdapter(new m(this._documents,re),q);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(J)),this._createDisposable(Y)}$provideEvaluatableExpression(q,J,re,oe){return this._withAdapter(q,m,Y=>Y.provideEvaluatableExpression(w.URI.revive(J),re,oe),void 0)}registerInlineValuesProvider(q,J,re,oe){const Y=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new _(this._documents,re),q);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(J),Y);let ve=this._createDisposable(ce);if(Y!==void 0){const Le=re.onDidChangeInlineValues(we=>this._proxy.$emitInlineValuesEvent(Y));ve=T.Disposable.from(ve,Le)}return ve}$provideInlineValues(q,J,re,oe,Y){return this._withAdapter(q,_,ce=>ce.provideInlineValues(w.URI.revive(J),re,oe,Y),void 0)}registerDocumentHighlightProvider(q,J,re){const oe=this._addNewAdapter(new b(this._documents,re),q);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideDocumentHighlights(q,J,re,oe){return this._withAdapter(q,b,Y=>Y.provideDocumentHighlights(w.URI.revive(J),re,oe),void 0)}registerLinkedEditingRangeProvider(q,J,re){const oe=this._addNewAdapter(new l(this._documents,re),q);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideLinkedEditingRanges(q,J,re,oe){return this._withAdapter(q,l,async Y=>{const ce=await Y.provideLinkedEditingRanges(w.URI.revive(J),re,oe);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?ze._serializeRegExp(ce.wordPattern):void 0}},void 0)}registerReferenceProvider(q,J,re){const oe=this._addNewAdapter(new L(this._documents,re),q);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideReferences(q,J,re,oe,Y){return this._withAdapter(q,L,ce=>ce.provideReferences(w.URI.revive(J),re,oe,Y),void 0)}registerCodeActionProvider(q,J,re,oe){var Y,ce;const ve=new p.DisposableStore,Le=this._addNewAdapter(new O(this._documents,this._commands.converter,this._diagnostics,re,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(Le,this._transformDocumentSelector(J),{providedKinds:(Y=oe==null?void 0:oe.providedCodeActionKinds)===null||Y===void 0?void 0:Y.map(we=>we.value),documentation:(ce=oe==null?void 0:oe.documentation)===null||ce===void 0?void 0:ce.map(we=>({kind:we.kind.value,command:this._commands.converter.toInternal(we.command,ve)}))},ze._extLabel(q),Boolean(re.resolveCodeAction)),ve.add(this._createDisposable(Le)),ve}$provideCodeActions(q,J,re,oe,Y){return this._withAdapter(q,O,ce=>ce.provideCodeActions(w.URI.revive(J),re,oe,Y),void 0)}$resolveCodeAction(q,J,re){return this._withAdapter(q,O,oe=>oe.resolveCodeAction(J,re),void 0)}$releaseCodeActions(q,J){this._withAdapter(q,O,re=>Promise.resolve(re.releaseCodeActions(J)),void 0)}registerDocumentFormattingEditProvider(q,J,re){const oe=this._addNewAdapter(new $(this._documents,re),q);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(J),q.identifier,q.displayName||q.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(q,J,re,oe){return this._withAdapter(q,$,Y=>Y.provideDocumentFormattingEdits(w.URI.revive(J),re,oe),void 0)}registerDocumentRangeFormattingEditProvider(q,J,re){const oe=this._addNewAdapter(new ie(this._documents,re),q);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(J),q.identifier,q.displayName||q.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(q,J,re,oe,Y){return this._withAdapter(q,ie,ce=>ce.provideDocumentRangeFormattingEdits(w.URI.revive(J),re,oe,Y),void 0)}registerOnTypeFormattingEditProvider(q,J,re,oe){const Y=this._addNewAdapter(new se(this._documents,re),q);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(J),oe,q.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(q,J,re,oe,Y,ce){return this._withAdapter(q,se,ve=>ve.provideOnTypeFormattingEdits(w.URI.revive(J),re,oe,Y,ce),void 0)}registerWorkspaceSymbolProvider(q,J){const re=this._addNewAdapter(new U(J,this._logService),q);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(q,J,re){return this._withAdapter(q,U,oe=>oe.provideWorkspaceSymbols(J,re),{symbols:[]})}$resolveWorkspaceSymbol(q,J,re){return this._withAdapter(q,U,oe=>oe.resolveWorkspaceSymbol(J,re),void 0)}$releaseWorkspaceSymbols(q,J){this._withAdapter(q,U,re=>re.releaseWorkspaceSymbols(J),void 0)}registerRenameProvider(q,J,re){const oe=this._addNewAdapter(new V(this._documents,re,this._logService),q);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(J),V.supportsResolving(re)),this._createDisposable(oe)}$provideRenameEdits(q,J,re,oe,Y){return this._withAdapter(q,V,ce=>ce.provideRenameEdits(w.URI.revive(J),re,oe,Y),void 0)}$resolveRenameLocation(q,J,re,oe){return this._withAdapter(q,V,Y=>Y.resolveRenameLocation(w.URI.revive(J),re,oe),void 0)}registerDocumentSemanticTokensProvider(q,J,re,oe){const Y=this._nextHandle(),ce=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new Ke(new P(this._documents,re),q)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(J),oe,ce);let ve=this._createDisposable(Y);if(ce){const Le=re.onDidChangeSemanticTokens(we=>this._proxy.$emitDocumentSemanticTokensEvent(ce));ve=T.Disposable.from(ve,Le)}return ve}$provideDocumentSemanticTokens(q,J,re,oe){return this._withAdapter(q,P,Y=>Y.provideDocumentSemanticTokens(w.URI.revive(J),re,oe),null,!0)}$releaseDocumentSemanticTokens(q,J){this._withAdapter(q,P,re=>re.releaseDocumentSemanticColoring(J),void 0)}registerDocumentRangeSemanticTokensProvider(q,J,re,oe){const Y=this._addNewAdapter(new N(this._documents,re),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(J),oe),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(q,J,re,oe){return this._withAdapter(q,N,Y=>Y.provideDocumentRangeSemanticTokens(w.URI.revive(J),re,oe),null,!0)}registerCompletionItemProvider(q,J,re,oe){const Y=this._addNewAdapter(new F(this._documents,this._commands.converter,re,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(J),oe,F.supportsResolving(re),`${q.identifier.value}(${oe.join("")})`),this._createDisposable(Y)}$provideCompletionItems(q,J,re,oe,Y){return this._withAdapter(q,F,ce=>ce.provideCompletionItems(w.URI.revive(J),re,oe,Y),void 0)}$resolveCompletionItem(q,J,re){return this._withAdapter(q,F,oe=>oe.resolveCompletionItem(J,re),void 0)}$releaseCompletionItems(q,J){this._withAdapter(q,F,re=>re.releaseCompletionItems(J),void 0)}registerInlineCompletionsProvider(q,J,re){const oe=this._addNewAdapter(new M(this._documents,re,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideInlineCompletions(q,J,re,oe,Y){return this._withAdapter(q,M,ce=>ce.provideInlineCompletions(w.URI.revive(J),re,oe,Y),void 0)}$handleInlineCompletionDidShow(q,J,re){this._withAdapter(q,M,async oe=>{oe.handleDidShowCompletionItem(J,re)},void 0)}$freeInlineCompletionsList(q,J){this._withAdapter(q,M,async re=>{re.disposeCompletions(J)},void 0)}registerSignatureHelpProvider(q,J,re,oe){const Y=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ce=this._addNewAdapter(new H(this._documents,re),q);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(J),Y),this._createDisposable(ce)}$provideSignatureHelp(q,J,re,oe,Y){return this._withAdapter(q,H,ce=>ce.provideSignatureHelp(w.URI.revive(J),re,oe,Y),void 0)}$releaseSignatureHelp(q,J){this._withAdapter(q,H,re=>re.releaseSignatureHelp(J),void 0)}registerInlayHintsProvider(q,J,re){const oe=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new Q(this._documents,re),q);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(J),oe);let ce=this._createDisposable(Y);if(oe!==void 0){const ve=re.onDidChangeInlayHints(Le=>this._proxy.$emitInlayHintsEvent(oe));ce=T.Disposable.from(ce,ve)}return ce}$provideInlayHints(q,J,re,oe){return this._withAdapter(q,Q,Y=>Y.provideInlayHints(w.URI.revive(J),re,oe),void 0)}registerDocumentLinkProvider(q,J,re){const oe=this._addNewAdapter(new le(this._documents,re),q);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(J),typeof re.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(q,J,re){return this._withAdapter(q,le,oe=>oe.provideLinks(w.URI.revive(J),re),void 0)}$resolveDocumentLink(q,J,re){return this._withAdapter(q,le,oe=>oe.resolveLink(J,re),void 0)}$releaseDocumentLinks(q,J){this._withAdapter(q,le,re=>re.releaseLinks(J),void 0)}registerColorProvider(q,J,re){const oe=this._addNewAdapter(new be(this._documents,re),q);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideDocumentColors(q,J,re){return this._withAdapter(q,be,oe=>oe.provideColors(w.URI.revive(J),re),[])}$provideColorPresentations(q,J,re,oe){return this._withAdapter(q,be,Y=>Y.provideColorPresentations(w.URI.revive(J),re,oe),void 0)}registerFoldingRangeProvider(q,J,re){const oe=this._nextHandle(),Y=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Ke(new Te(this._documents,re),q)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(J),Y);let ce=this._createDisposable(oe);if(Y!==void 0){const ve=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));ce=T.Disposable.from(ce,ve)}return ce}$provideFoldingRanges(q,J,re,oe){return this._withAdapter(q,Te,Y=>Y.provideFoldingRanges(w.URI.revive(J),re,oe),void 0)}registerSelectionRangeProvider(q,J,re){const oe=this._addNewAdapter(new ke(this._documents,re,this._logService),q);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideSelectionRanges(q,J,re,oe){return this._withAdapter(q,ke,Y=>Y.provideSelectionRanges(w.URI.revive(J),re,oe),[])}registerCallHierarchyProvider(q,J,re){const oe=this._addNewAdapter(new Ne(this._documents,re),q);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$prepareCallHierarchy(q,J,re,oe){return this._withAdapter(q,Ne,Y=>Promise.resolve(Y.prepareSession(w.URI.revive(J),re,oe)),void 0)}$provideCallHierarchyIncomingCalls(q,J,re,oe){return this._withAdapter(q,Ne,Y=>Y.provideCallsTo(J,re,oe),void 0)}$provideCallHierarchyOutgoingCalls(q,J,re,oe){return this._withAdapter(q,Ne,Y=>Y.provideCallsFrom(J,re,oe),void 0)}$releaseCallHierarchy(q,J){this._withAdapter(q,Ne,re=>Promise.resolve(re.releaseSession(J)),void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:(0,D.regExpFlags)(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:ze._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?ze._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?ze._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:ze._serializeRegExp(q.beforeText),afterText:q.afterText?ze._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?ze._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(ze._serializeOnEnterRule)}setLanguageConfiguration(q,J,re){let{wordPattern:oe}=re;if(oe&&(0,D.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(J,oe):this._documents.setWordDefinitionFor(J,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const Y=this._nextHandle(),ce={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?ze._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?ze._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?ze._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,J,ce),this._createDisposable(Y)}$setWordDefinitions(q){for(const J of q)this._documents.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(ge[235],pe([0,1,5,20,7]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(k,D){this._proxy=k.getProxy(w.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,D){await this._proxy.$changeLanguage(k,D);const I=this._documents.getDocumentData(k);if(!I)throw new Error(`document '${k.toString}' NOT found`);return I.document}async tokenAtPosition(k,D){var I;const i=k.version,A=R.Position.from(D),d=await this._proxy.$tokensAtPosition(k.uri,A),p={type:C.StandardTokenType.Other,range:(I=k.getWordRangeAtPosition(D))!==null&&I!==void 0?I:new C.Range(D.line,D.character,D.line,D.character)};if(!d)return p;const a={range:R.Range.to(d.range),type:R.TokenType.to(d.type)};return!a.range.contains(D)||i!==k.version?p:a}}e.ExtHostLanguages=T}),define(ge[236],pe([0,1,5,14,39]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(k){return k&&k.title}let y=class{constructor(D,I){this._logService=I,this._proxy=D.getProxy(w.MainContext.MainThreadMessageService)}showMessage(D,I,i,A,d){const p={extension:D};let a;typeof A=="string"||T(A)?a=[A,...d]:(p.modal=A&&A.modal,p.useCustom=A&&A.useCustom,a=d),p.useCustom&&(0,C.checkProposedApiEnabled)(D);const h=[];for(let E=0;E<a.length;E++){const v=a[E];if(typeof v=="string")h.push({title:v,handle:E,isCloseAffordance:!1});else if(typeof v=="object"){let{title:S,isCloseAffordance:u}=v;h.push({title:S,isCloseAffordance:!!u,handle:E})}else this._logService.warn("Invalid message item:",v)}return this._proxy.$showMessage(I,i,p,h).then(E=>{if(typeof E=="number")return a[E]})}};y=Ve([He(1,R.ILogService)],y),e.ExtHostMessageService=y}),define(ge[237],pe([0,1,23,3,75,73,6,22,8,12,2,85,5,20,7,64,214,124]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class S{constructor(c,t){const n=S._Keys.nextId();c.$registerNotebookEditorDecorationType(n,p.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){c.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=S,S._Keys=new T.IdGenerator("NotebookEditorDecorationType");class u{constructor(c,t,n,s,r,o){this._textDocumentsAndEditors=n,this._textDocuments=s,this.logService=r,this._extensionStoragePaths=o,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new R.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new R.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new R.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new A.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=c.getProxy(d.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=c.getProxy(d.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=c.getProxy(d.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:g=>{var m;if(g&&g.$mid===12){const _=(m=g.notebookEditor)===null||m===void 0?void 0:m.notebookUri,b=g.cell.handle,l=this._documents.get(_),L=l==null?void 0:l.getCell(b);if(L)return L.apiCell}return g}})}get activeNotebookEditor(){var c;return(c=this._activeNotebookEditor)===null||c===void 0?void 0:c.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(c=>c.apiEditor)}getEditorById(c){return this._editors.get(c)}getIdByEditor(c){for(const[t,n]of this._editors)if(n.apiEditor===c)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(c,t){const n=this._documents.get(c);if(!n&&!t)throw new Error(`NO notebook document for '${c}'`);return n}_getProviderData(c){const t=this._notebookContentProviders.get(c);if(!t)throw new Error(`NO provider for '${c}'`);return t}registerNotebookContentProvider(c,t,n,s,r){if((0,D.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:c,provider:n});let o;return n.onDidChangeNotebookContentOptions&&(o=n.onDidChangeNotebookContentOptions(()=>{const g=p.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,g)})),this._notebookProxy.$registerNotebookProvider({id:c.identifier,location:c.extensionLocation},t,p.NotebookDocumentContentOptions.from(s),u._convertNotebookRegistrationData(c,r)),new a.Disposable(()=>{o==null||o.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(c,t){if(!t)return;const n=t.filenamePattern.map(s=>p.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,t,n){const s=u._notebookStatusBarItemProviderHandlePool++,r=typeof n.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,r,t);let o;return r!==void 0&&(o=n.onDidChangeCellStatusBarItems(g=>this._notebookProxy.$emitCellStatusBarEvent(r))),new a.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,r),o&&o.dispose()})}createNotebookEditorDecorationType(c){return new S(this._notebookEditorsProxy,c).value}async createNotebookDocument(c){const t=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:c.viewType,content:c.content&&p.NotebookData.from(c.content)});return i.URI.revive(t)}async openNotebookDocument(c){const t=this._documents.get(c);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenNotebook(c),s=this._documents.get(i.URI.revive(n));return(0,I.assertIsDefined)(s==null?void 0:s.apiNotebook)}async showNotebookDocument(c,t){var n;i.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let s;typeof t=="object"?s={position:p.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(p.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:s={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(c.uri,c.viewType,s),o=r&&((n=this._editors.get(r))===null||n===void 0?void 0:n.apiEditor);if(o)return o;throw r?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,t,n,s){var r;const o=this._notebookStatusBarItemProviders.get(c),g=i.URI.revive(t),m=this._documents.get(g);if(!m||!o)return;const _=m.getCellFromIndex(n);if(!_)return;const b=await o.provideCellStatusBarItems(_.apiCell,s);if(!b)return;const l=new y.DisposableStore,L=this._statusBarCache.add([l]),O=(r=b&&b.map($=>p.NotebookStatusBarItem.from($,this._commandsConverter,l)))!==null&&r!==void 0?r:void 0;return{cacheId:L,items:O}}$releaseNotebookCellStatusBarItems(c){this._statusBarCache.delete(c)}registerNotebookSerializer(c,t,n,s,r){if((0,D.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,n),this._notebookProxy.$registerNotebookSerializer(o,{id:c.identifier,location:c.extensionLocation},t,p.NotebookDocumentContentOptions.from(s),u._convertNotebookRegistrationData(c,r)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(c,t,n){const s=this._notebookSerializer.get(c);if(!s)throw new Error("NO serializer found");const r=await s.deserializeNotebook(t.buffer,n);return p.NotebookData.from(r)}async $notebookToData(c,t,n){const s=this._notebookSerializer.get(c);if(!s)throw new Error("NO serializer found");const r=await s.serializeNotebook(p.NotebookData.to(t),n);return w.VSBuffer.wrap(r)}async $openNotebook(c,t,n,s,r){const{provider:o}=this._getProviderData(c),g=await o.openNotebook(i.URI.revive(t),{backupId:n,untitledDocumentData:s==null?void 0:s.buffer},r);return{metadata:p.NotebookDocumentMetadata.from(g.metadata),cells:g.cells.map(p.NotebookCellData.from)}}async $saveNotebook(c,t,n){const s=this.getNotebookDocument(i.URI.revive(t)),{provider:r}=this._getProviderData(c);return await r.saveNotebook(s.apiNotebook,n),!0}async $saveNotebookAs(c,t,n,s){const r=this.getNotebookDocument(i.URI.revive(t)),{provider:o}=this._getProviderData(c);return await o.saveNotebookAs(i.URI.revive(n),r.apiNotebook,s),!0}async $backupNotebook(c,t,n){var s;const r=this.getNotebookDocument(i.URI.revive(t)),o=this._getProviderData(c),g=(s=this._extensionStoragePaths.workspaceValue(o.extension))!==null&&s!==void 0?s:this._extensionStoragePaths.globalValue(o.extension),m=String((0,C.hash)([r.uri.toString(),this._backupIdPool++])),_=i.URI.joinPath(g,m),b=await o.provider.backupNotebook(r.apiNotebook,{destination:_},n);return r.updateBackup(b),b.id}$acceptModelChanged(c,t,n){this.getNotebookDocument(i.URI.revive(c)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(c,t){const n=this.getNotebookDocument(i.URI.revive(c));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(c){const t=this.getNotebookDocument(i.URI.revive(c));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(c,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",c,t);const n=this._editors.get(c);if(!n)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(p.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(p.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(c){for(const t in c){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(p.ViewColumn.to(c[t]))}}$acceptDocumentPropertiesChanged(c,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",c.path,t);const n=this.getNotebookDocument(i.URI.revive(c));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(c,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const s=new v.ExtHostNotebookEditor(t,this._notebookEditorsProxy,c,n.visibleRanges.map(p.NotebookRange.to),n.selections.map(p.NotebookRange.to),typeof n.viewColumn=="number"?p.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,s)}$acceptDocumentAndEditorsDelta(c){var t,n,s;if(c.removedDocuments)for(const o of c.removedDocuments){const g=i.URI.revive(o),m=this._documents.get(g);m&&(m.dispose(),this._documents.delete(g),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(_=>_.document.uri)}),this._onDidCloseNotebookDocument.fire(m.apiNotebook));for(const _ of this._editors.values())_.notebookData.uri.toString()===g.toString()&&this._editors.delete(_.id)}if(c.addedDocuments){const o=[];for(const g of c.addedDocuments){const m=i.URI.revive(g.uri),_=g.viewType;if(this._documents.has(m))throw new Error(`adding EXISTING notebook ${m} `);const b=this,l=new E.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(L){b._onDidChangeNotebookCells.fire(L)},emitCellOutputsChange(L){b._onDidChangeCellOutputs.fire(L)},emitCellMetadataChange(L){b._onDidChangeCellMetadata.fire(L)},emitCellExecutionStateChange(L){b._onDidChangeCellExecutionState.fire(L)}},_,g.metadata?p.NotebookDocumentMetadata.to(g.metadata):new a.NotebookDocumentMetadata,m);l.acceptModelChanged({versionId:g.versionId,rawEvents:[{kind:h.NotebookCellsChangeType.Initialize,changes:[[0,0,g.cells]]}]},!1),o.push(...g.cells.map(L=>E.ExtHostCell.asModelAddData(l.apiNotebook,L))),(t=this._documents.get(m))===null||t===void 0||t.dispose(),this._documents.set(m,l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:o}),this._onDidOpenNotebookDocument.fire(l.apiNotebook)}}if(c.addedEditors)for(const o of c.addedEditors){if(this._editors.has(o.id))return;const g=i.URI.revive(o.documentUri),m=this._documents.get(g);m&&this._createExtHostEditor(m,o.id,o)}const r=[];if(c.removedEditors)for(const o of c.removedEditors){const g=this._editors.get(o);g&&(this._editors.delete(o),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===g.id&&(this._activeNotebookEditor=void 0),r.push(g))}if(c.visibleEditors){this._visibleNotebookEditors=c.visibleEditors.map(g=>this._editors.get(g)).filter(g=>!!g);const o=new Set;this._visibleNotebookEditors.forEach(g=>o.add(g.id));for(const g of this._editors.values()){const m=o.has(g.id);g._acceptVisibility(m)}this._visibleNotebookEditors=[...this._editors.values()].map(g=>g).filter(g=>g.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}c.newActiveEditor===null?this._activeNotebookEditor=void 0:c.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(c.newActiveEditor)),c.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor)}}e.ExtHostNotebookController=u,u._notebookStatusBarItemProviderHandlePool=0}),define(ge[238],pe([0,1,3,6,5,26,2,20,87,22,13,64,21,16,14,7]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let E=class{constructor(c,t,n,s){this._mainContext=c,this._initData=t,this._extHostNotebook=n,this._logService=s,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=c.getProxy(C.MainContext.MainThreadNotebookKernels)}createNotebookController(c,t,n,s,r,o){for(let N of this._kernelData.values())if(N.controller.id===t&&T.ExtensionIdentifier.equals(c.identifier,N.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const g=this._handlePool++,m=this;this._logService.trace(`NotebookController[${g}], CREATED by ${c.identifier.value}, ${t}`);const _=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${c.identifier}'`);let b=!1;const l=new R.DisposableStore,L=new w.Emitter,O=new w.Emitter,$={id:`${c.identifier.value}/${t}`,viewType:n,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:s||c.identifier.value,preloads:o?o.map(k.NotebookKernelPreload.from):[]};let ie=r??_,se;this._proxy.$addKernel(g,$).catch(N=>{console.log(N),b=!0});let U=0;const V=()=>{if(b)return;const N=++U;Promise.resolve().then(()=>{N===U&&this._proxy.$updateKernel(g,$)})},W=new I.ResourceMap,P={get id(){return t},get viewType(){return $.viewType},onDidChangeNotebookAssociation:L.event,get label(){return $.label},set label(N){var F;$.label=(F=N??c.displayName)!==null&&F!==void 0?F:c.name,V()},get detail(){var N;return(N=$.detail)!==null&&N!==void 0?N:""},set detail(N){$.detail=N,V()},get description(){var N;return(N=$.description)!==null&&N!==void 0?N:""},set description(N){$.description=N,V()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(N){$.supportedLanguages=N,V()},get hasExecutionOrder(){var N;return(N=$.hasExecutionOrder)!==null&&N!==void 0?N:!1},set hasExecutionOrder(N){$.hasExecutionOrder=N,V()},get preloads(){return $.preloads?$.preloads.map(k.NotebookKernelPreload.to):[]},get executeHandler(){return ie},set executeHandler(N){ie=N??_},get interruptHandler(){return se},set interruptHandler(N){se=N,$.supportsInterrupt=Boolean(N),V()},createNotebookCellExecutionTask(N){if(b)throw new Error("notebook controller is DISPOSED");if(!W.has(N.notebook.uri))throw m._logService.trace(`NotebookController[${g}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(W.keys()).map(F=>F.toString())),new Error(`notebook controller is NOT associated to notebook: ${N.notebook.uri.toString()}`);return m._createNotebookCellExecution(N)},dispose:()=>{b||(this._logService.trace(`NotebookController[${g}], DISPOSED`),b=!0,this._kernelData.delete(g),l.dispose(),L.dispose(),O.dispose(),this._proxy.$removeKernel(g))},onDidReceiveMessage:O.event,postMessage(N,F){return m._proxy.$postMessage(g,F&&m._extHostNotebook.getIdByEditor(F),N)},asWebviewUri(N){return(0,D.asWebviewUri)(N,m._initData.remote)},updateNotebookAffinity(N,F){m._proxy.$updateNotebookPriority(g,N.uri,F)}};return this._kernelData.set(g,{extensionId:c.identifier,controller:P,onDidReceiveMessage:O,onDidChangeSelection:L,associatedNotebooks:W}),P}$acceptNotebookAssociation(c,t,n){const s=this._kernelData.get(c);if(s){const r=this._extHostNotebook.getNotebookDocument(y.URI.revive(t));n?s.associatedNotebooks.set(r.uri,!0):s.associatedNotebooks.delete(r.uri),this._logService.trace(`NotebookController[${c}] ASSOCIATE notebook`,r.uri.toString(),n),s.onDidChangeSelection.fire({selected:n,notebook:r.apiNotebook})}}async $executeCells(c,t,n){const s=this._kernelData.get(c);if(!s)return;const r=this._extHostNotebook.getNotebookDocument(y.URI.revive(t)),o=[];for(let g of n){const m=r.getCell(g);m&&o.push(m.apiCell)}try{this._logService.trace(`NotebookController[${c}] EXECUTE cells`,r.uri.toString(),o.length),await s.controller.executeHandler.call(s.controller,o,r.apiNotebook,s.controller)}catch(g){this._logService.error(`NotebookController[${c}] execute cells FAILED`,g),console.error(g)}}async $cancelCells(c,t,n){var s;const r=this._kernelData.get(c);if(!r)return;const o=this._extHostNotebook.getNotebookDocument(y.URI.revive(t));r.controller.interruptHandler&&await r.controller.interruptHandler.call(r.controller,o.apiNotebook);for(let g of n){const m=o.getCell(g);m&&((s=this._activeExecutions.get(m.uri))===null||s===void 0||s.cancel())}}$acceptKernelMessageFromRenderer(c,t,n){const s=this._kernelData.get(c);if(!s)return;const r=this._extHostNotebook.getEditorById(t);if(!r)throw new Error(`send message for UNKNOWN editor: ${t}`);s.onDidReceiveMessage.fire(Object.freeze({editor:r.apiEditor,message:n}))}_createNotebookCellExecution(c){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const s=new S(n.notebook,n,this._mainContext.getProxy(C.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(n.uri,s);const r=s.onDidChangeState(()=>{s.state===v.Resolved&&(s.dispose(),r.dispose(),this._activeExecutions.delete(n.uri))});return s.asApiObject()}};E=Ve([He(3,a.ILogService)],E),e.ExtHostNotebookKernels=E;var v;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(v||(v={}));class S extends R.Disposable{constructor(c,t,n){super();this._document=c,this._cell=t,this._proxy=n,this._onDidChangeState=new w.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=v.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._collector=new u(10,s=>this.applyEdits(s)),this._executionOrder=t.internalMetadata.executionOrder,this.mixinMetadata({runState:A.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(c){await this._collector.addItem(c)}async applyEdits(c){return this._proxy.$applyEdits(this._document.uri,c,!1)}verifyStateForOutput(){if(this._state===v.Init)throw new Error("Must call start before modifying cell output");if(this._state===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(c){const t={editType:9,handle:this._cell.handle,internalMetadata:c};this.applyEdits([t])}cellIndexToHandle(c){if(typeof c!="number")return this._cell.handle;const t=this._document.getCellFromIndex(c);if(!t)throw new Error("INVALID cell index");return t.handle}validateAndConvertOutputs(c){return c.map(t=>{const n=h.NotebookCellOutput.ensureUniqueMimeTypes(t.outputs,!0);return n===t.outputs?k.NotebookCellOutput.from(t):k.NotebookCellOutput.from({outputs:n,id:t.id,metadata:t.metadata})})}asApiObject(){const c=this;return Object.freeze({get token(){return c._tokenSource.token},get document(){return c._document.apiNotebook},get cell(){return c._cell.apiCell},get executionOrder(){return c._executionOrder},set executionOrder(t){c._executionOrder=t,c.mixinMetadata({executionOrder:t})},start(t){var n;if(c._state===v.Resolved||c._state===v.Started)throw new Error("Cannot call start again");c._state=v.Started,c._onDidChangeState.fire(),c.mixinMetadata({runState:A.NotebookCellExecutionState.Executing,runStartTime:(n=t==null?void 0:t.startTime)!==null&&n!==void 0?n:null})},end(t){var n,s;if(c._state===v.Resolved)throw new Error("Cannot call resolve twice");c._state=v.Resolved,c._onDidChangeState.fire(),c.mixinMetadata({runState:null,lastRunSuccess:(n=t==null?void 0:t.success)!==null&&n!==void 0?n:null,runEndTime:(s=t==null?void 0:t.endTime)!==null&&s!==void 0?s:null})},clearOutput(t){return c.verifyStateForOutput(),this.replaceOutput([],t)},async appendOutput(t,n){c.verifyStateForOutput();const s=c.cellIndexToHandle(n),r=c.validateAndConvertOutputs((0,p.asArray)(t));return c.applyEditSoon({editType:2,handle:s,append:!0,outputs:r})},async replaceOutput(t,n){c.verifyStateForOutput();const s=c.cellIndexToHandle(n),r=c.validateAndConvertOutputs((0,p.asArray)(t));return c.applyEditSoon({editType:2,handle:s,outputs:r})},async appendOutputItems(t,n){return c.verifyStateForOutput(),t=h.NotebookCellOutput.ensureUniqueMimeTypes((0,p.asArray)(t),!0),c.applyEditSoon({editType:7,append:!0,items:t.map(k.NotebookCellOutputItem.from),outputId:n})},async replaceOutputItems(t,n){return c.verifyStateForOutput(),t=h.NotebookCellOutput.ensureUniqueMimeTypes((0,p.asArray)(t),!0),c.applyEditSoon({editType:7,items:t.map(k.NotebookCellOutputItem.from),outputId:n})}})}}class u{constructor(c,t){this.delay=c,this.callback=t,this.batch=[]}addItem(c){return this.batch.push(c),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const t=this.batch;return this.batch=[],this.callback(t)})),this.waitPromise}}}),define(ge[239],pe([0,1,3,5,124]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(k,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=k.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,D,I){var i;const A=this._extHostNotebook.getEditorById(k);!A||(i=this._rendererMessageEmitters.get(D))===null||i===void 0||i.fire({editor:A.apiEditor,message:I})}createRendererMessaging(k){return{onDidReceiveMessage:(...I)=>this.getOrCreateEmitterFor(k).event(...I),postMessage:(I,i)=>{const A=C.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);if(!A)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(A.id,k,i)}}}getOrCreateEmitterFor(k){let D=this._rendererMessageEmitters.get(k);return D||(D=new w.Emitter({onLastListenerRemove:()=>{D==null||D.dispose(),this._rendererMessageEmitters.delete(k)}}),this._rendererMessageEmitters.set(k,D),D)}}e.ExtHostNotebookRenderers=T}),define(ge[66],pe([0,1,5,3,6,23,4,15]),function(G,e,w,R,C,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends C.Disposable{constructor(a,h,E,v){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=v,this._id=v.$register(this.name,h,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?T.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(h=>this._proxy.$clear(h,a))}show(a,h){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof a=="boolean"?a:h)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class I extends D{constructor(a,h){super(a,!1,void 0,h)}append(a){super.append(a),this._id.then(h=>this._proxy.$append(h,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=I;class i extends D{constructor(a,h,E){super(a,!0,h,E)}append(a){throw new Error("Not supported")}}class A{constructor(a,h){this.name=a,this._channel=h}append(a){this._channel.then(h=>h.append(a))}appendLine(a){this._channel.then(h=>h.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,h){this._channel.then(E=>E.show(a,h))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=A;let d=class{constructor(a){this._proxy=a.getProxy(w.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new I(a,this._proxy)}createOutputChannelFromLogFile(a,h){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!h)throw new Error("illegal argument `file`. must not be falsy");return new i(a,h,this._proxy)}};d=Ve([He(0,k.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(ge[240],pe([0,1,13,21,3,6,5,2,7,17,16,57]),function(G,e,w,R,C,T,y,k,D,I,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(p,a,h){const E=p.getProxy(y.MainContext.MainThreadQuickOpen);class v{constructor(r,o){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=o}showQuickPick(r,o,g,m=R.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(r),b=++this._instances,l=E.$show(b,{title:g==null?void 0:g.title,placeHolder:g==null?void 0:g.placeHolder,matchOnDescription:g==null?void 0:g.matchOnDescription,matchOnDetail:g==null?void 0:g.matchOnDetail,ignoreFocusLost:g==null?void 0:g.ignoreFocusOut,canPickMany:g==null?void 0:g.canPickMany},m),L={},O=l.then(()=>L);return Promise.race([O,_]).then($=>{if($!==L)return _.then(ie=>{const se=[];for(let U=0;U<ie.length;U++){const V=ie[U];let W,P,N,F,M;typeof V=="string"?W=V:(W=V.label,P=V.description,N=V.detail,F=V.picked,M=V.alwaysShow),se.push({label:W,description:P,handle:U,detail:N,picked:F,alwaysShow:M})}return g&&typeof g.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{g.onDidSelectItem(ie[U])}),E.$setItems(b,se),l.then(U=>{if(typeof U=="number")return ie[U];if(Array.isArray(U))return U.map(V=>ie[V])})})}).then(void 0,$=>{if(!(0,I.isPromiseCanceledError)($))return E.$setError(b,$),Promise.reject($)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,o=R.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,E.$input(r,typeof this._validateInput=="function",o).then(void 0,g=>{if(!(0,I.isPromiseCanceledError)(g))return Promise.reject(g)})}$validateInput(r){return this._validateInput?(0,w.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,o=R.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!g)return;const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(_=>_.uri.toString()===g.uri.toString())}createQuickPick(r,o){const g=new t(r,o,()=>this._sessions.delete(g._id));return this._sessions.set(g._id,g),g}createInputBox(r){const o=new n(r,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(r,o){const g=this._sessions.get(r);g&&g._fireDidChangeValue(o)}$onDidAccept(r){const o=this._sessions.get(r);o&&o._fireDidAccept()}$onDidChangeActive(r,o){const g=this._sessions.get(r);g instanceof t&&g._fireDidChangeActive(o)}$onDidChangeSelection(r,o){const g=this._sessions.get(r);g instanceof t&&g._fireDidChangeSelection(o)}$onDidTriggerButton(r,o){const g=this._sessions.get(r);g&&g._fireDidTriggerButton(o)}$onDidHide(r){const o=this._sessions.get(r);o&&o._fireDidHide()}}class S{constructor(r,o){this._extensionId=r,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((o,g)=>{const m=o===D.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(m,o)}),this.update({buttons:r.map((o,g)=>({iconPath:u(o.iconPath),tooltip:o.tooltip,handle:o===D.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const o=this._handlesToButtons.get(r);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(r){if(!this._disposed){for(const o of Object.keys(r)){const g=r[o];this._pendingUpdate[o]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function u(s){if(s instanceof D.ThemeIcon)return{id:s.id};const r=c(s),o=f(s);return{dark:typeof r=="string"?k.URI.file(r):r,light:typeof o=="string"?k.URI.file(o):o}}function f(s){return typeof s=="object"&&"light"in s?s.light:s}function c(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends S{constructor(r,o,g){super(r,g);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((o,g)=>{this._handlesToItems.set(g,o),this._itemsToHandles.set(o,g)}),this.update({items:r.map((o,g)=>({label:o.label,description:o.description,handle:g,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(r){const o=(0,i.coalesce)(r.map(g=>this._handlesToItems.get(g)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(r){const o=(0,i.coalesce)(r.map(g=>this._handlesToItems.get(g)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class n extends S{constructor(r,o){super(r,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?A.default.Error:A.default.Ignore})}}return new v(a,h)}e.createExtHostQuickOpen=d}),define(ge[241],pe([0,1,2,3,53,6,13,5,16,97,14,26,39]),function(G,e,w,R,C,T,y,k,D,I,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(r){if(r)return typeof r.iconPath=="string"?w.URI.file(r.iconPath):r.iconPath}function a(r,o){if(!r.iconPath&&!o.iconPath)return 0;if(r.iconPath){if(!o.iconPath)return 1}else return-1;const g=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,m=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return(0,I.comparePaths)(g,m)}function h(r,o){let g=0;if(r.strikeThrough!==o.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==o.faded)return r.faded?1:-1;if(r.tooltip!==o.tooltip)return(r.tooltip||"").localeCompare(o.tooltip||"");if(g=a(r,o),g!==0)return g;if(r.light&&o.light)g=a(r.light,o.light);else{if(r.light)return 1;if(o.light)return-1}if(g!==0)return g;if(r.dark&&o.dark)g=a(r.dark,o.dark);else{if(r.dark)return 1;if(o.dark)return-1}return g}function E(r,o){if(r.command!==o.command)return r.command<o.command?-1:1;if(r.title!==o.title)return r.title<o.title?-1:1;if(r.tooltip!==o.tooltip){if(r.tooltip!==void 0&&o.tooltip!==void 0)return r.tooltip<o.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(r.arguments===o.arguments)return 0;if(r.arguments)if(o.arguments){if(r.arguments.length!==o.arguments.length)return r.arguments.length-o.arguments.length}else return 1;else return-1;for(let g=0;g<r.arguments.length;g++){const m=r.arguments[g],_=o.arguments[g];if(m!==_)return m<_?-1:1}return 0}function v(r,o){let g=(0,I.comparePaths)(r.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(g!==0)return g;if(r.command&&o.command)g=E(r.command,o.command);else{if(r.command)return 1;if(o.command)return-1}if(g!==0)return g;if(r.decorations&&o.decorations)g=h(r.decorations,o.decorations);else{if(r.decorations)return 1;if(o.decorations)return-1}return g}function S(r,o){for(let g=0;g<r.length;g++)if(r[g]!==o[g])return!1;return!0}function u(r,o){return r.command===o.command&&r.title===o.title&&r.tooltip===o.tooltip&&(r.arguments&&o.arguments?S(r.arguments,o.arguments):r.arguments===o.arguments)}function f(r,o){return(0,D.equals)(r,o,u)}class c{constructor(o,g,m){this._extension=o,this._proxy=g,this._sourceControlHandle=m,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(o){if((0,d.checkProposedApiEnabled)(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,g){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,g)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=c;class t{constructor(o,g,m,_,b){this._proxy=o,this._commands=g,this._sourceControlHandle=m,this._id=_,this._label=b,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,g){const m=this._resourceStatesCommandsMap.get(o);return m?(0,y.asPromise)(()=>this._commands.executeCommand(m.command,...m.arguments||[],g)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const g=[...this._resourceStates].sort(v),_=(0,D.sortedDiff)(this._resourceSnapshot,g,v).map(L=>{const O=L.toInsert.map($=>{const ie=this._resourceHandlePool++;this._resourceStatesMap.set(ie,$);const se=$.resourceUri,U=p($.decorations),V=$.decorations&&p($.decorations.light)||U,W=$.decorations&&p($.decorations.dark)||U,P=[];let N;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const le=new T.DisposableStore;N=this._commands.converter.toInternal($.command,le),this._resourceStatesDisposablesMap.set(ie,le)}else this._resourceStatesCommandsMap.set(ie,$.command);V&&P.push(V),W&&W.toString()!==(V==null?void 0:V.toString())&&P.push(W);const F=$.decorations&&$.decorations.tooltip||"",M=$.decorations&&!!$.decorations.strikeThrough,B=$.decorations&&!!$.decorations.faded,H=$.contextValue||"";return{rawResource:[ie,se,P,F,M,B,H,N],handle:ie}});return{start:L.start,deleteCount:L.deleteCount,toInsert:O}}),b=_.map(({start:L,deleteCount:O,toInsert:$})=>[L,O,$.map(ie=>ie.rawResource)]),l=_.reverse();for(const{start:L,deleteCount:O,toInsert:$}of l){const ie=$.map(U=>U.handle),se=this._handlesSnapshot.splice(L,O,...ie);for(const U of se)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),(o=this._resourceStatesDisposablesMap.get(U))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=g,b}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(o,g,m,_,b,l){this._proxy=g,this._commands=m,this._id=_,this._label=b,this._rootUri=l,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new c(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,b,l)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=o;const g=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:g})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&f(this._statusBarCommands,o))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=o;const g=(o||[]).map(m=>this._commands.converter.toInternal(m,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:g})}get selected(){return this._selected}createResourceGroup(o,g){const m=new t(this._proxy,this._commands,this.handle,o,g),_=R.Event.once(m.onDidDispose)(()=>this.createdResourceGroups.delete(m));return this.createdResourceGroups.set(m,_),this.eventuallyAddResourceGroups(),m}eventuallyAddResourceGroups(){const o=[],g=[];for(const[m,_]of this.createdResourceGroups){_.dispose();const b=m.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(m),this.eventuallyUpdateResourceStates()});R.Event.once(m.onDidDispose)(()=>{this.updatedResourceGroups.delete(m),b.dispose(),this._groups.delete(m.handle),this._proxy.$unregisterGroup(this.handle,m.handle)}),o.push([m.handle,m.id,m.label,m.features]);const l=m._takeResourceStateSnapshot();l.length>0&&g.push([m.handle,l]),this._groups.set(m.handle,m)}this._proxy.$registerGroups(this.handle,o,g),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(g=>{const m=g._takeResourceStateSnapshot();m.length!==0&&o.push([g.handle,m])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([(0,C.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([(0,C.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class Un{constructor(o,g,m){this._commands=g,this.logService=m,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=o.getProxy(k.MainContext.MainThreadSCM),this._telemetry=o.getProxy(k.MainContext.MainThreadTelemetry),g.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const b=this._sourceControls.get(_.sourceControlHandle);if(!b)return _;const l=b.getResourceGroup(_.groupHandle);return l?l.getResourceState(_.handle):_}else if(_&&_.$mid===4){const b=this._sourceControls.get(_.sourceControlHandle);return b?b.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const b=this._sourceControls.get(_.handle);return b||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,g,m,_){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,g,m,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const b=Un._handlePool++,l=new n(o,this._proxy,this._commands,g,m,_);this._sourceControls.set(b,l);const L=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(o.identifier))||[];return L.push(l),this._sourceControlsByExtension.set(A.ExtensionIdentifier.toKey(o.identifier),L),l}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const g=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(o.identifier)),m=g&&g[g.length-1];return m&&m.inputBox}$provideOriginalResource(o,g,m){const _=w.URI.revive(g);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,_.toString());const b=this._sourceControls.get(o);return!b||!b.quickDiffProvider||!b.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>b.quickDiffProvider.provideOriginalResource(_,m)).then(l=>l||null)}$onInputBoxValueChange(o,g){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const m=this._sourceControls.get(o);return m&&m.inputBox.$onInputBoxValueChange(g),Promise.resolve(void 0)}$executeResourceCommand(o,g,m,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,g,m);const b=this._sourceControls.get(o);if(!b)return Promise.resolve(void 0);const l=b.getResourceGroup(g);return l?l.$executeResourceCommand(m,_):Promise.resolve(void 0)}$validateInput(o,g,m){this.logService.trace("ExtHostSCM#$validateInput",o);const _=this._sourceControls.get(o);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>_.inputBox.validateInput(g,m)).then(b=>b?Promise.resolve([b.message,b.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var g,m;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((g=this._sourceControls.get(o))===null||g===void 0||g.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((m=this._sourceControls.get(this._selectedSourceControlHandle))===null||m===void 0||m.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};s._handlePool=0,s=Ve([He(2,i.ILogService)],s),e.ExtHostSCM=s});var nt=this&&this.__classPrivateFieldSet||function(G,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!C:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(G,w):C?C.value=w:e.set(G,w),w},Be=this&&this.__classPrivateFieldGet||function(G,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!R:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(G):R?R.value:e.get(G)};define(ge[242],pe([0,1,7,5,164,6]),function(G,e,w,R,C,T){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(d,p,a,h,E=w.StatusBarAlignment.Left,v){y.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,nt(this,y,d,"f"),nt(this,k,p,"f"),this._entryId=D.ID_GEN++,this._extension=a,this._id=h,this._alignment=E,this._priority=v}get id(){var d;return(d=this._id)!==null&&d!==void 0?d:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var d;return(d=this._command)===null||d===void 0?void 0:d.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!D.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){var p;((p=this._command)===null||p===void 0?void 0:p.fromApi)!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Be(this,k,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Be(this,k,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var d;this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let a;this._name?a=this._name:a=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Be(this,y,"f").$setEntry(this._entryId,p,a,this._text,this._tooltip,(d=this._command)===null||d===void 0?void 0:d.internal,h,this._backgroundColor,this._alignment===w.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,k=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new w.ThemeColor("statusBarItem.errorForeground")]]);class I{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const p={message:d};return this._messages.unshift(p),this._update(),new w.Disposable(()=>{const a=this._messages.indexOf(p);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(d,p){this._proxy=d.getProxy(R.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new I(this)}createStatusBarEntry(d,p,a,h){return new D(this._proxy,this._commands,d,p,a,h)}setStatusBarMessage(d,p){const a=this._statusMessage.setMessage(d);let h;return typeof p=="number"?h=setTimeout(()=>a.dispose(),p):typeof p!="undefined"&&p.then(()=>a.dispose(),()=>a.dispose()),new w.Disposable(()=>{a.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=i}),define(ge[90],pe([0,1,5,3,4]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(k){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(w.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,D){this._proxy.$registerExtensionStorageKeysToSync(k,D)}getValue(k,D,I){return this._proxy.$getValue(k,D).then(i=>i||I)}setValue(k,D,I){return this._proxy.$setValue(k,D,I)}$acceptValue(k,D,I){this._onDidChangeStorage.fire({shared:k,key:D,value:I})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(ge[91],pe([0,1,4,27,14,89,2]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,w.createDecorator)("IExtensionStoragePaths");let k=class{constructor(I,i,A){var d;this._logService=i,this._extHostFileSystem=A,this._workspace=(d=I.workspace)!==null&&d!==void 0?d:void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getOrCreateWorkspaceStoragePath(){var I;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,A=y.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch(d){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(I=y.URI.revive(this._workspace.configuration))===null||I===void 0?void 0:I.toString(),name:this._workspace.name},void 0,2))),A}catch(d){this._logService.error("[ExtHostStorage]",d);return}}workspaceValue(I){if(this._value)return y.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return y.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}};k=Ve([He(0,R.IExtHostInitDataService),He(1,C.ILogService),He(2,T.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(ge[33],pe([0,1,3,5,4,2,15,6,7,165,17,208,21,32,192]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class h{constructor(t,n,s,r){this._proxy=t,this._id=n,this._creationOptions=s,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(g=>this._pidPromiseComplete=g);const o=this;this.value={get name(){return o._name||""},get processId(){return o._pidPromise},get creationOptions(){return o._creationOptions},get exitStatus(){return o._exitStatus},sendText(g,m=!0){o._checkDisposed(),o._proxy.$sendText(o._id,g,m)},show(g){o._checkDisposed(),o._proxy.$show(o._id,g)},hide(){o._checkDisposed(),o._proxy.$hide(o._id)},dispose(){o._disposed||(o._disposed=!0,o._proxy.$dispose(o._id))},get dimensions(){if(!(o._cols===void 0||o._rows===void 0))return{columns:o._cols,rows:o._rows}}}}async create(t,n,s,r,o,g,m,_,b,l,L,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:s,env:r,icon:o,initialText:g,waitOnExit:m,strictEnv:_,hideFromUser:b,isFeatureTerminal:l,isExtensionOwnedTerminal:L,useShellEnvironment:O})}async createExtensionTerminal(t){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:t}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=h;class E{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new w.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new w.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new w.Emitter,this._onProcessTitleChanged=new w.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new w.Emitter,this._onProcessShellTypeChanged=new w.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let v=1,S=class extends k.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new w.Emitter,this._onDidOpenTerminal=new w.Emitter,this._onDidChangeActiveTerminal=new w.Emitter,this._onDidChangeTerminalDimensions=new w.Emitter,this._proxy=n.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new w.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(t){const n=t?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.path)||""}getDefaultShellArgs(t){const n=t?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.args)||[]}createExtensionTerminal(t){const n=new h(this._proxy,(0,p.generateUuid)(),t,t.name),s=new E(t.pty);return n.createExtensionTerminal(t.iconPath).then(r=>{const o=this._setupExtHostProcessListeners(r,s);this._terminalProcessDisposables[r]=o}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new E(n),o=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=o}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:n})}async $acceptTerminalDimensions(t,n,s){const r=this._getTerminalById(t);r&&r.setDimensions(n,s)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,s){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}async $acceptTerminalTitleChange(t,n){const s=this._getTerminalById(t);s&&(s.name=n)}async $acceptTerminalClosed(t,n){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const r=this._terminals.splice(s,1)[0];r.setExitCode(n),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,n,s,r){if(n){const m=this._getTerminalObjectIndexById(this._terminals,n);if(m!==null){this._terminals[m]._id=t,this._onDidOpenTerminal.fire(this.terminals[m]),this._terminals[m].isOpen=!0;return}}const o={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:T.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},g=new h(this._proxy,t,o,s);this._terminals.push(g),this._onDidOpenTerminal.fire(g.value),g.isOpen=!0}async $acceptTerminalProcessId(t,n){const s=this._getTerminalById(t);s&&s._setProcessId(n)}async $startExtensionTerminal(t,n){const s=this._getTerminalById(t);if(!s)return{message:(0,I.localize)(0,null,t)};s.isOpen||await new Promise(o=>{const g=this.onDidOpenTerminal(async m=>{m===s.value&&(g.dispose(),o())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const s=new k.DisposableStore;s.add(n.onProcessReady(o=>this._proxy.$sendProcessReady(t,o.pid,o.cwd))),s.add(n.onProcessTitleChanged(o=>this._proxy.$sendProcessTitle(t,o))),this._bufferer.startBuffering(t,n.onProcessData),s.add(n.onProcessExit(o=>this._onProcessExit(t,o))),n.onProcessOverrideDimensions&&s.add(n.onProcessOverrideDimensions(o=>this._proxy.$sendOverrideDimensions(t,o))),this._terminalProcesses.set(t,n);const r=this._extensionTerminalAwaitingStart[t];return r&&n instanceof E&&(n.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(n)}$acceptProcessResize(t,n,s){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}catch(o){if(o.code!=="EPIPE"&&o.code!=="ERR_IPC_CHANNEL_CLOSED")throw o}}$acceptProcessShutdown(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const o=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,o);const g=[],m={terminal:s.value,line:n},_=[];for(const L of this._linkProviders)_.push(new Promise(async O=>{o.token.onCancellationRequested(()=>O({provider:L,links:[]}));const $=await L.provideTerminalLinks(m,o.token)||[];o.token.isCancellationRequested||O({provider:L,links:$})}));const b=await Promise.all(_);if(o.token.isCancellationRequested)return[];const l=new Map;for(const L of b)L&&L.links.length>0&&g.push(...L.links.map(O=>{const $={id:v++,startIndex:O.startIndex,length:O.length,label:O.tooltip};return l.set($.id,{provider:L.provider,link:O}),$}));return this._terminalLinkCache.set(t,l),g}$activateLink(t,n){var s;const r=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(n);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const s=this._getTerminalObjectIndexById(t,n);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,n){let s=null;return t.some((r,o)=>r._id===n?(s=o,!0):!1),s}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new u,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const s=(0,A.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const s=n[0],r=new u(n[1]);this._setEnvironmentVariableCollection(s,r)})}$acceptDefaultProfile(t,n){this._defaultProfile=t,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};S=Ve([He(1,y.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class u{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new w.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const s=this.map.get(t);(!s||s.value!==n.value||s.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((s,r)=>t.call(n,r,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let f=class extends S{constructor(t){super(!1,t)}createTerminal(t,n,s){throw new i.NotSupportedError}createTerminalFromOptions(t,n){throw new i.NotSupportedError}};f=Ve([He(0,y.IExtHostRpcService)],f),e.WorkerExtHostTerminalService=f}),define(ge[243],pe([0,1,3,16,5,125,20,7]),function(G,e,w,R,C,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(i,A){this._extHostDocumentsAndEditors=A,this._onDidChangeTextEditorSelection=new w.Emitter,this._onDidChangeTextEditorOptions=new w.Emitter,this._onDidChangeTextEditorVisibleRanges=new w.Emitter,this._onDidChangeTextEditorViewColumn=new w.Emitter,this._onDidChangeActiveTextEditor=new w.Emitter,this._onDidChangeVisibleTextEditors=new w.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const A=this._extHostDocumentsAndEditors.allEditors();return i?A:A.map(d=>d.value)}async showTextDocument(i,A,d){let p;typeof A=="number"?p={position:y.ViewColumn.from(A),preserveFocus:d}:typeof A=="object"?p={position:y.ViewColumn.from(A.viewColumn),preserveFocus:A.preserveFocus,selection:typeof A.selection=="object"?y.Range.from(A.selection):void 0,pinned:typeof A.preview=="boolean"?!A.preview:void 0}:p={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(i.uri,p),h=a&&this._extHostDocumentsAndEditors.getEditor(a);if(h)return h.value;throw a?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new T.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,A){const d=this._extHostDocumentsAndEditors.getEditor(i);if(!d)throw new Error("unknown text editor");if(A.options&&d._acceptOptions(A.options),A.selections){const p=A.selections.selections.map(y.Selection.to);d._acceptSelections(p)}if(A.visibleRanges){const p=R.coalesce(A.visibleRanges.map(y.Range.to));d._acceptVisibleRanges(p)}if(A.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:Object.assign(Object.assign({},A.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(A.options.lineNumbers)})}),A.selections){const p=k.TextEditorSelectionChangeKind.fromValue(A.selections.source),a=A.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:a,kind:p})}if(A.visibleRanges){const p=R.coalesce(A.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:p})}}$acceptEditorPositionData(i){for(const A in i){const d=this._extHostDocumentsAndEditors.getEditor(A);if(!d)throw new Error("Unknown text editor");const p=y.ViewColumn.to(i[A]);d.value.viewColumn!==p&&(d._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:p}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=D});var Qt=this&&this.__rest||function(G,e){var w={};for(var R in G)Object.prototype.hasOwnProperty.call(G,R)&&e.indexOf(R)<0&&(w[R]=G[R]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(G);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(G,R[C])&&(w[R[C]]=G[R[C]]);return w};define(ge[244],pe([0,1,2,4,5,6,7]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class k{constructor(i,A){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(C.MainContext.MainThreadTimeline),A.registerArgumentProcessor({processArgument:d=>{var p,a;if(d&&d.$mid===11){const h=d.uri===void 0?void 0:w.URI.revive(d.uri);return(a=(p=this._itemsBySourceAndUriMap.get(d.source))===null||p===void 0?void 0:p.get(D(h)))===null||a===void 0?void 0:a.get(d.handle)}return d}})}async $getTimeline(i,A,d,p,a){const h=this._providers.get(i);return h==null?void 0:h.provideTimeline(w.URI.revive(A),d,p,a)}registerTimelineProvider(i,A,d,p){const a=new T.DisposableStore,h=this.convertTimelineItem(A.id,p,a).bind(this);let E;A.onDidChange&&(E=A.onDidChange(S=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},S),{id:A.id})),this));const v=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},A),{scheme:i,onDidChange:void 0,async provideTimeline(S,u,f,c){var t;(c==null?void 0:c.resetCache)&&(a.clear(),(t=v.get(A.id))===null||t===void 0||t.clear());const n=await A.provideTimeline(S,u,f);if(n==null)return;const s=h(S,c);return Object.assign(Object.assign({},n),{source:A.id,items:n.items.map(s)})},dispose(){var S;for(const u of v.values())(S=u.get(A.id))===null||S===void 0||S.clear();E==null||E.dispose(),a.dispose()}}))}convertTimelineItem(i,A,d){return(p,a)=>{let h;if(a==null?void 0:a.cacheResults){let E=this._itemsBySourceAndUriMap.get(i);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(i,E));const v=D(p);h=E.get(v),h===void 0&&(h=new Map,E.set(v,h))}return E=>{var v,S;const{iconPath:u}=E,f=Qt(E,["iconPath"]),c=`${i}|${(v=E.id)!==null&&v!==void 0?v:E.timestamp}`;h==null||h.set(c,E);let t,n,s;return E.iconPath&&(u instanceof y.ThemeIcon?s={id:u.id}:w.URI.isUri(u)?(t=u,n=u):{light:t,dark:n}=u),Object.assign(Object.assign({},f),{id:(S=f.id)!==null&&S!==void 0?S:void 0,handle:c,source:i,command:E.command?A.toInternal(E.command,d):void 0,icon:t,iconDark:n,themeIcon:s,accessibilityInformation:E.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,T.toDisposable)(()=>{var d;for(const p of this._itemsBySourceAndUriMap.values())(d=p.get(i.id))===null||d===void 0||d.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=k;function D(I){return I==null?void 0:I.toString()}}),define(ge[245],pe([0,1,6,10,2,5]),function(G,e,w,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,I,i,A){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const d=A.schemes.find(p=>!y.supportedSchemes.has(p));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,i),this._proxy.$registerUriOpener(I,A.schemes,D,A.label),(0,w.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(D,I,i){const A=this._openers.get(D);if(!A)throw new Error(`Unknown opener with id: ${D}`);const d=C.URI.revive(I);return A.canOpenExternalUri(d,i)}async $openUri(D,I,i){const A=this._openers.get(D);if(!A)throw new Error(`Unknown opener id: '${D}'`);return A.openExternalUri(C.URI.revive(I.resolvedUri),{sourceUri:C.URI.revive(I.sourceUri)},i)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(ge[246],pe([0,1,5,2,6,17,26]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(w.MainContext.MainThreadUrls)}registerUriHandler(I,i){if(this.handles.has(y.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const A=k.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(I)),this.handlers.set(A,i),this._proxy.$registerUriHandler(A,I),(0,C.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(I)),this.handlers.delete(A),this._proxy.$unregisterUriHandler(A)})}$handleExternalUri(I,i){const A=this.handlers.get(I);if(!A)return Promise.resolve(void 0);try{A.handleUri(R.URI.revive(i))}catch(d){(0,T.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(I){return R.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=k,k.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(G,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!C:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(G,w):C?C.value=w:e.set(G,w),w},Be=this&&this.__classPrivateFieldGet||function(G,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!R:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(G):R?R.value:e.get(G)};define(ge[67],pe([0,1,3,2,176,200,87,5]),function(G,e,w,R,C,T,y,k){"use strict";var D,I,i,A,d,p,a,h,E,v,S,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(m,_,b,l,L,O,$){D.set(this,void 0),I.set(this,void 0),i.set(this,void 0),A.set(this,void 0),d.set(this,void 0),p.set(this,void 0),a.set(this,""),h.set(this,void 0),E.set(this,!1),v.set(this,!1),S.set(this,!1),this._onMessageEmitter=new w.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new w.Emitter),this._onDidDispose=Be(this,u,"f").event,nt(this,D,m,"f"),nt(this,I,_,"f"),nt(this,h,b,"f"),nt(this,A,l,"f"),nt(this,d,L,"f"),nt(this,p,O,"f"),nt(this,S,c(O),"f"),nt(this,i,$,"f")}dispose(){nt(this,E,!0,"f"),Be(this,u,"f").fire(),Be(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return nt(this,v,!0,"f"),(0,y.asWebviewUri)(m,Be(this,A,"f").remote)}get cspSource(){return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,a,"f")}set html(m){this.assertNotDisposed(),Be(this,a,"f")!==m&&(nt(this,a,m,"f"),!Be(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(nt(this,v,!0,"f"),Be(this,i,"f").report("Webview vscode-resource: uris",Be(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,I,"f").$setHtml(Be(this,D,"f"),m))}get options(){return this.assertNotDisposed(),Be(this,h,"f")}set options(m){this.assertNotDisposed(),Be(this,I,"f").$setOptions(Be(this,D,"f"),s(Be(this,p,"f"),Be(this,d,"f"),m)),nt(this,h,m,"f")}async postMessage(m){if(Be(this,E,"f"))return!1;const _=(0,T.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Be(this,S,"f")});return Be(this,I,"f").$postMessage(Be(this,D,"f"),_.message,..._.buffers)}assertNotDisposed(){if(Be(this,E,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,D=new WeakMap,I=new WeakMap,i=new WeakMap,A=new WeakMap,d=new WeakMap,p=new WeakMap,a=new WeakMap,h=new WeakMap,E=new WeakMap,v=new WeakMap,S=new WeakMap,u=new WeakMap;function c(g){try{const m=(0,C.normalizeVersion)((0,C.parseVersion)(g.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch(m){return!1}}e.shouldSerializeBuffersForPostMessage=c;class t{constructor(m,_,b,l,L){this.initData=_,this.workspace=b,this._logService=l,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=m.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(m,_,...b){const l=this.getWebview(m);if(l){const{message:L}=(0,T.deserializeWebviewMessage)(_,b);l._onMessageEmitter.fire(L)}}$onMissingCsp(m,_){this._logService.warn(`${_} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,_,b){const l=new f(m,this._webviewProxy,r(_),this.initData,this.workspace,b,this._deprecationService);return this._webviews.set(m,l),l._onDidDispose(()=>{this._webviews.delete(m)}),l}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=t;function n(g){return{id:g.identifier,location:g.extensionLocation}}e.toExtensionData=n;function s(g,m,_){return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:_.localResourceRoots||o(g,m)}}e.serializeWebviewOptions=s;function r(g){var m;return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,portMapping:g.portMapping,localResourceRoots:(m=g.localResourceRoots)===null||m===void 0?void 0:m.map(_=>R.URI.from(_))}}e.reviveOptions=r;function o(g,m){return[...((m==null?void 0:m.getWorkspaceFolders())||[]).map(_=>_.uri),g.extensionLocation]}}),define(ge[247],pe([0,1,21,75,6,10,24,2,20,67,85,5,7]),function(G,e,w,R,C,T,y,k,D,I,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=f(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class a{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,s){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const o=new p(n,s);return this._documents.set(r,o),o}delete(t,n){const s=this.key(t,n.uri);this._documents.delete(s)}key(t,n){return`${t}@@@${n}`}}var h;(function(c){c[c.Text=0]="Text",c[c.Custom=1]="Custom"})(h||(h={}));class E{constructor(){this._providers=new Map}addTextProvider(t,n,s){return this.add(0,t,n,s)}addCustomProvider(t,n,s){return this.add(1,t,n,s)}get(t){return this._providers.get(t)}add(t,n,s,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:s,provider:r}),new d.Disposable(()=>this._providers.delete(n))}}class v{constructor(t,n,s,r,o){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=r,this._extHostWebviewPanels=o,this._editorProviders=new E,this._documents=new a,this._proxy=t.getProxy(A.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,s,r){const o=new C.DisposableStore;return S(s)?(o.add(this._editorProviders.addTextProvider(n,t,s)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(t),n,r.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(t))):(o.add(this._editorProviders.addCustomProvider(n,t,s)),this.supportEditing(s)&&o.add(s.onDidChangeCustomDocument(g=>{const m=this.getCustomDocumentEntry(n,g.document.uri);if(u(g)){const _=m.addEdit(g);this._proxy.$onDidEdit(g.document.uri,n,_,g.label)}else this._proxy.$onContentChange(g.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(o,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,s,r,o){var g;const m=this._editorProviders.get(n);if(!m)throw new Error(`No provider found for '${n}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${n}'`);const _=k.URI.revive(t),b=await m.provider.openCustomDocument(_,{backupId:s,untitledDocumentData:r==null?void 0:r.buffer},o);let l;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(l=(g=this._extensionStoragePaths.workspaceValue(m.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(n,b,l),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(t,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=k.URI.revive(t),{document:o}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,o),o.dispose()}async $resolveWebviewEditor(t,n,s,r,o,g){const m=this._editorProviders.get(s);if(!m)throw new Error(`No provider found for '${s}'`);const _=D.ViewColumn.to(o),b=this._extHostWebview.createNewWebview(n,r.webviewOptions,m.extension),l=this._extHostWebviewPanels.createNewWebviewPanel(n,s,r.title,_,r.panelOptions,b),L=k.URI.revive(t);switch(m.type){case 1:{const{document:O}=this.getCustomDocumentEntry(s,L);return m.provider.resolveCustomEditor(O,l,g)}case 0:{const O=this._extHostDocuments.getDocument(L);return m.provider.resolveCustomTextEditor(O,l,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,s){this.getCustomDocumentEntry(n,t).disposeEdits(s)}async $onMoveCustomEditor(t,n,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const g=k.URI.revive(n),m=this._extHostDocuments.getDocument(g);await r.provider.moveCustomTextEditor(m,o,w.CancellationToken.None)}async $undo(t,n,s,r){return this.getCustomDocumentEntry(n,t).undo(s,r)}async $redo(t,n,s,r){return this.getCustomDocumentEntry(n,t).redo(s,r)}async $revert(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,s),r.disposeBackup()}async $onSave(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,s),r.disposeBackup()}async $onSaveAs(t,n,s,r){const o=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(o.document,k.URI.revive(s),r)}async $backup(t,n,s){const r=this.getCustomDocumentEntry(n,t),g=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},s);return r.updateBackup(g),g.id}getCustomDocumentEntry(t,n){const s=this._documents.get(t,k.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const n=this._editorProviders.get(t),s=n==null?void 0:n.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=v;function S(c){return typeof c.resolveCustomTextEditor=="function"}function u(c){return typeof c.undo=="function"&&typeof c.redo=="function"}function f(c){const t=c.scheme===T.Schemas.file||c.scheme===T.Schemas.untitled?c.fsPath:c.toString();return(0,R.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(G,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!C:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(G,w):C?C.value=w:e.set(G,w),w},Be=this&&this.__classPrivateFieldGet||function(G,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!R:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(G):R?R.value:e.get(G)};define(ge[248],pe([0,1,3,6,2,32,20,67,5,7]),function(G,e,w,R,C,T,y,k,D,I){"use strict";var i,A,d,p,a,h,E,v,S,u,f,c,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends R.Disposable{constructor(g,m,_,b,l,L,O){super();i.set(this,void 0),A.set(this,void 0),d.set(this,void 0),p.set(this,void 0),a.set(this,void 0),h.set(this,void 0),E.set(this,void 0),v.set(this,void 0),S.set(this,!0),u.set(this,!0),f.set(this,!1),c.set(this,this._register(new w.Emitter)),this.onDidDispose=Be(this,c,"f").event,t.set(this,this._register(new w.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,nt(this,i,g,"f"),nt(this,A,m,"f"),nt(this,d,_,"f"),nt(this,a,L,"f"),nt(this,v,l,"f"),nt(this,h,b,"f"),nt(this,p,O,"f")}dispose(){Be(this,f,"f")||(nt(this,f,!0,"f"),Be(this,c,"f").fire(),Be(this,A,"f").$disposeWebview(Be(this,i,"f")),Be(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,p,"f")}get viewType(){return this.assertNotDisposed(),Be(this,d,"f")}get title(){return this.assertNotDisposed(),Be(this,h,"f")}set title(g){this.assertNotDisposed(),Be(this,h,"f")!==g&&(nt(this,h,g,"f"),Be(this,A,"f").$setTitle(Be(this,i,"f"),g))}get iconPath(){return this.assertNotDisposed(),Be(this,E,"f")}set iconPath(g){this.assertNotDisposed(),Be(this,E,"f")!==g&&(nt(this,E,g,"f"),Be(this,A,"f").$setIconPath(Be(this,i,"f"),C.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return Be(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,v,"f")=="number"&&Be(this,v,"f")<0))return Be(this,v,"f")}get active(){return this.assertNotDisposed(),Be(this,u,"f")}get visible(){return this.assertNotDisposed(),Be(this,S,"f")}_updateViewState(g){Be(this,f,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(nt(this,u,g.active,"f"),nt(this,S,g.visible,"f"),nt(this,v,g.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(g,m){this.assertNotDisposed(),Be(this,A,"f").$reveal(Be(this,i,"f"),{viewColumn:g?y.ViewColumn.from(g):void 0,preserveFocus:!!m})}assertNotDisposed(){if(Be(this,f,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,A=new WeakMap,d=new WeakMap,p=new WeakMap,a=new WeakMap,h=new WeakMap,E=new WeakMap,v=new WeakMap,S=new WeakMap,u=new WeakMap,f=new WeakMap,c=new WeakMap,t=new WeakMap;class s{constructor(g,m,_){this.webviews=m,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(g,m,_,b,l={}){const L=typeof b=="object"?b.viewColumn:b,O={viewColumn:y.ViewColumn.from(L),preserveFocus:typeof b=="object"&&!!b.preserveFocus},$=(0,k.shouldSerializeBuffersForPostMessage)(g),ie=s.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(g),ie,m,{title:_,panelOptions:r(l),webviewOptions:(0,k.serializeWebviewOptions)(g,this.workspace,l),serializeBuffersForPostMessage:$},O);const se=this.webviews.createNewWebview(ie,l,g);return this.createNewWebviewPanel(ie,m,_,L,l,se)}$onDidChangeWebviewPanelViewStates(g){const m=Object.keys(g);m.sort((_,b)=>{const l=g[_],L=g[b];return l.active?1:L.active?-1:+l.visible-+L.visible});for(const _ of m){const b=this.getWebviewPanel(_);if(!b)continue;const l=g[_];b._updateViewState({active:l.active,visible:l.visible,viewColumn:y.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(g){const m=this.getWebviewPanel(g);m==null||m.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,m,_){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:_,extension:g}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(g)}),new I.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(g,m,_,b){const l=this._serializers.get(m);if(!l)throw new Error(`No serializer found for '${m}'`);const{serializer:L,extension:O}=l,$=this.webviews.createNewWebview(g,_.webviewOptions,O),ie=this.createNewWebviewPanel(g,m,_.title,b,_.panelOptions,$);await L.deserializeWebviewPanel(ie,_.state)}createNewWebviewPanel(g,m,_,b,l,L){const O=new n(g,this._proxy,m,_,b,l,L);return this._webviewPanels.set(g,O),O}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=s;function r(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(G,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!C:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(G,w):C?C.value=w:e.set(G,w),w},Be=this&&this.__classPrivateFieldGet||function(G,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!R:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(G):R?R.value:e.get(G)};define(ge[249],pe([0,1,3,6,67,5,7]),function(G,e,w,R,C,T,y){"use strict";var k,D,I,i,A,d,p,a,h,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends R.Disposable{constructor(f,c,t,n,s,r){super();k.set(this,void 0),D.set(this,void 0),I.set(this,void 0),i.set(this,void 0),A.set(this,!1),d.set(this,void 0),p.set(this,void 0),a.set(this,void 0),h.set(this,this._register(new w.Emitter)),this.onDidChangeVisibility=Be(this,h,"f").event,E.set(this,this._register(new w.Emitter)),this.onDidDispose=Be(this,E,"f").event,nt(this,I,t,"f"),nt(this,p,n,"f"),nt(this,k,f,"f"),nt(this,D,c,"f"),nt(this,i,s,"f"),nt(this,d,r,"f")}dispose(){Be(this,A,"f")||(nt(this,A,!0,"f"),Be(this,E,"f").fire(),Be(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,p,"f")}set title(f){this.assertNotDisposed(),Be(this,p,"f")!==f&&(nt(this,p,f,"f"),Be(this,D,"f").$setWebviewViewTitle(Be(this,k,"f"),f))}get description(){return this.assertNotDisposed(),Be(this,a,"f")}set description(f){this.assertNotDisposed(),Be(this,a,"f")!==f&&(nt(this,a,f,"f"),Be(this,D,"f").$setWebviewViewDescription(Be(this,k,"f"),f))}get visible(){return Be(this,d,"f")}get webview(){return Be(this,i,"f")}get viewType(){return Be(this,I,"f")}_setVisible(f){f===Be(this,d,"f")||Be(this,A,"f")||(nt(this,d,f,"f"),Be(this,h,"f").fire())}show(f){this.assertNotDisposed(),Be(this,D,"f").$show(Be(this,k,"f"),!!f)}assertNotDisposed(){if(Be(this,A,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,D=new WeakMap,I=new WeakMap,i=new WeakMap,A=new WeakMap,d=new WeakMap,p=new WeakMap,a=new WeakMap,h=new WeakMap,E=new WeakMap;class S{constructor(f,c){this._extHostWebview=c,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,c,t,n){if(this._viewProviders.has(c))throw new Error(`View provider for '${c}' already registered`);return this._viewProviders.set(c,{provider:t,extension:f}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(f),c,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(c),this._proxy.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(f,c,t,n,s){const r=this._viewProviders.get(c);if(!r)throw new Error(`No view provider found for '${c}'`);const{provider:o,extension:g}=r,m=this._extHostWebview.createNewWebview(f,{},g),_=new v(f,this._proxy,c,t,m,!0);this._webviewViews.set(f,_),await o.resolveWebviewView(_,{state:n},s)}async $onDidChangeWebviewViewVisibility(f,c){this.getWebviewView(f)._setVisible(c)}async $disposeWebviewView(f){const c=this.getWebviewView(f);this._webviewViews.delete(f),c.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const c=this._webviewViews.get(f);if(!c)throw new Error("No webview found");return c}}e.ExtHostWebviewViews=S}),define(ge[128],pe([0,1,3,5,2,10,8,4,15]),function(G,e,w,R,C,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class xn{constructor(A){this._onDidChangeWindowState=new w.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=A.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(A){A!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:A}),this._onDidChangeWindowState.fire(this._state))}openUri(A,d){let p;if(typeof A=="string"){p=A;try{A=C.URI.parse(A)}catch(a){return Promise.reject(`Invalid uri - '${A}'`)}}return(0,y.isFalsyOrWhitespace)(A.scheme)?Promise.reject("Invalid scheme - cannot be empty"):A.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${A.scheme}'`):this._proxy.$openUri(A,p,d)}async asExternalUri(A,d){if((0,y.isFalsyOrWhitespace)(A.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(A,d);return C.URI.from(p)}};I.InitialState={focused:!0},I=Ve([He(0,D.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(ge[250],pe([0,1,9,101,32,49,6,5,2,15]),function(G,e,w,R,C,T,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends y.Disposable{constructor(d,p){super();const a=d.getProxy(k.MainContext.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async h=>{const E=D.URI.file((0,w.join)((0,R.tmpdir)(),(0,C.generateUuid)()));return await a.$download(h,E),E})}};i=Ve([He(0,I.IExtHostRpcService),He(1,T.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(ge[251],pe([0,1,2,9,148,28,66,27,15,6,14,112,43]),function(G,e,w,R,C,T,y,k,D,I,i,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class p{constructor(v,S,u){this.name=v,this.file=S,this.appender=u}static async create(v,S){const u=await(0,A.createRotatingLogger)(v,S,30*d.ByteSize.MB,1);return u.clearFormatters(),new p(v,S,u)}append(v){this.appender.critical(v)}flush(){this.appender.flush()}}class a extends y.AbstractExtHostOutputChannel{constructor(v,S,u){super(v,!1,w.URI.file(S.file),u);this._appender=S}append(v){super.append(v),this._appender.append(v),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(v,S){this._appender.flush(),super.show(v,S)}clear(){this._appender.flush(),super.clear()}}let h=class extends y.ExtHostOutputService{constructor(v,S,u){super(v);this.logService=S,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new I.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(v){if(v){const S=this._channels.get(v);S&&(this._visibleChannelDisposable.value=S.onDidAppend(()=>S.update()))}}createOutputChannel(v){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const S=this._doCreateOutChannel(v);return S.then(u=>u._id.then(f=>this._channels.set(f,u))),new y.LazyOutputChannel(v,S)}async _doCreateOutChannel(v){try{const S=(0,R.join)(this._logsLocation.fsPath,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await T.SymlinkSupport.existsDirectory(S)||await T.Promises.mkdir(S,{recursive:!0});const f=`${this._namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}`,c=w.URI.file((0,R.join)(S,`${f}.log`)),t=await p.create(f,c.fsPath);return new a(v,t,this._proxy)}catch(S){return this.logService.error(S),new y.ExtHostPushOutputChannel(v,this._proxy)}}};h=Ve([He(0,D.IExtHostRpcService),He(1,i.ILogService),He(2,k.IExtHostInitDataService)],h),e.ExtHostOutputService2=h}),define(ge[252],pe([0,1,12,32,15,33]),function(G,e,w,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends T.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,I,i){const A=new T.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),{name:D,shellPath:I,shellArgs:i},D);return this._terminals.push(A),A.create(I,i),A.value}createTerminalFromOptions(D,I){const i=new T.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),D,D.name);return this._terminals.push(i),i.create((0,w.withNullAsUndefined)(D.shellPath),(0,w.withNullAsUndefined)(D.shellArgs),(0,w.withNullAsUndefined)(D.cwd),(0,w.withNullAsUndefined)(D.env),(0,w.withNullAsUndefined)(D.iconPath),(0,w.withNullAsUndefined)(D.message),void 0,(0,w.withNullAsUndefined)(D.strictEnv),(0,w.withNullAsUndefined)(D.hideFromUser),(0,w.withNullAsUndefined)(I==null?void 0:I.isFeatureTerminal),!0,(0,w.withNullAsUndefined)(I==null?void 0:I.useShellEnvironment)),i.value}};y=Ve([He(0,C.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(ge[253],pe([0,1,5,15,6,27,2,37,24,28,7,11,48,3,74,14]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class E{constructor(g,m,_){this.remoteAddress=g,this.localAddress=m,this._dispose=_,this._onDispose=new p.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function v(o){const g=o.trim().split(`
`),m=[];return g.forEach(b=>{const l=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(b);l&&l.length>=3&&m.push({pid:parseInt(l[1],10),socket:parseInt(l[2],10)})}),m.reduce((b,l)=>(b[l.socket]=l,b),{})}e.getSockets=v;function S(...o){const g=[].concat(...o.map(f));return[...new Map(g.filter(m=>m.st==="0A").map(m=>{const _=m.local_address.split(":");return{socket:parseInt(m.inode,10),ip:u(_[0]),port:parseInt(_[1],16)}}).map(m=>[m.ip+":"+m.port,m])).values()]}e.loadListeningPorts=S;function u(o){let g="";if(o.length===8)for(let m=o.length-2;m>=0;m-=2)g+=parseInt(o.substr(m,2),16),m!==0&&(g+=".");else for(let m=o.length-4;m>=0;m-=4)g+=parseInt(o.substr(m,4),16).toString(16),m!==0&&(g+=":");return g}e.parseIpAddress=u;function f(o){const g=o.trim().split(`
`),m=g.shift().trim().split(/\s+/).filter(b=>b!=="rx_queue"&&b!=="tm->when");return g.map(b=>b.trim().split(/\s+/).reduce((l,L,O)=>(l[m[O]||O]=L,l),{}))}e.loadConnectionTable=f;function c(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/vs/server/main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function t(o){const g=o.trim().split(`
`),m=[];return g.forEach(_=>{const b=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(_);b&&b.length>=4&&m.push({pid:parseInt(b[1],10),ppid:parseInt(b[2]),cmd:b[3]})}),m}e.getRootProcesses=t;async function n(o,g,m){const _=m.reduce((l,L)=>(l[L.pid]=L,l),{}),b=[];return o.forEach(({socket:l,ip:L,port:O})=>{var $;const ie=g[l]?g[l].pid:void 0,se=ie?($=_[ie])===null||$===void 0?void 0:$.cmd:void 0;ie&&se&&!c(se)&&b.push({host:L,port:O,detail:se,pid:ie})}),b}e.findPorts=n;function s(o,g,m){const _=new Map,b=t(g);for(const l of o){const L=m.get(l.port);if(L){_.set(l.port,L);continue}const O=b.find($=>$.cmd.includes(`${l.port}`));if(O){let $=O,ie;do ie=b.find(se=>se.ppid===$.pid),ie&&($=ie);while(ie);_.set(l.port,{host:l.ip,port:l.port,pid:$.pid,detail:$.cmd,ppid:$.ppid})}else _.set(l.port,{host:l.ip,port:l.port,ppid:Number.MAX_VALUE})}return _}e.tryFindRootPorts=s;let r=class extends C.Disposable{constructor(g,m,_){super();this.logService=_,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new p.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=g.getProxy(w.MainContext.MainThreadTunnelService),A.isLinux&&m.remote.isRemote&&m.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(g,m){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${g.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const _=await this._proxy.$openTunnel(m,g.displayName);if(_){const b=new E(_.remoteAddress,_.localAddress,()=>this._proxy.$closeTunnel(_.remoteAddress));return this._register(b),b}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(g){return Math.max(g*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(g,m){const _=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(_,{selector:g,provider:m}),this._proxy.$registerPortsAttributesProvider(g,_),new i.Disposable(()=>{this._portAttributesProviders.delete(_),this._proxy.$unregisterPortsAttributesProvider(_)})}async $providePortAttributes(g,m,_,b,l){const L=[];for(const $ of g){const ie=this._portAttributesProviders.get($);if(!ie)return[];L.push(...await Promise.all(m.map(async se=>ie.provider.providePortAttributes(se,_,b,l))))}const O=L.filter($=>!!$);return O.length>0?O.map($=>({autoForwardAction:$.autoForwardAction,port:$.port})):[]}async $registerCandidateFinder(g){if(g&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=g;let m=new a.MovingAverage,_;for(;this._candidateFindingEnabled;){const b=new Date().getTime(),l=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${l.map(O=>O.port).join(", ")}`);const L=new Date().getTime()-b;m.update(L),(!_||JSON.stringify(_)!==JSON.stringify(l))&&(_=l,await this._proxy.$onFoundNewCandidates(_)),await new Promise(O=>setTimeout(()=>O(),this.calculateDelay(m.value)))}}async setTunnelExtensionFunctions(g){var m;return g?(g.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(g.candidatePortSource),g.showCandidatePort&&(this._showCandidatePort=g.showCandidatePort,this._proxy.$setCandidateFilter()),g.tunnelFactory&&(this._forwardPortProvider=g.tunnelFactory,this._proxy.$setTunnelProvider((m=g.tunnelFeatures)!==null&&m!==void 0?m:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(g,m){if(this._extensionTunnels.has(g.host)){const _=this._extensionTunnels.get(g.host);_.has(g.port)&&(m&&_.get(g.port).disposeListener.dispose(),await _.get(g.port).tunnel.dispose(),_.delete(g.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(g,m){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const _=this._forwardPortProvider(g,m);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),_!==void 0){const b=await _;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(g.remoteAddress.host)||this._extensionTunnels.set(g.remoteAddress.host,new Map);const l=this._register(b.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(b.remoteAddress))));return this._extensionTunnels.get(g.remoteAddress.host).set(g.remoteAddress.port,{tunnel:b,disposeListener:l}),d.TunnelDto.fromApiTunnel(b)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(_){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(g){const m=await Promise.all(g.map(b=>{var l;return this._showCandidatePort(b.host,b.port,(l=b.detail)!==null&&l!==void 0?l:"")})),_=g.filter((b,l)=>m[l]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${g.map(b=>b.port).join(", ")} to ${_.map(b=>b.port).join(", ")}`),_}async findCandidatePorts(){let g="",m="";try{g=await I.Promises.readFile("/proc/net/tcp","utf8"),m=await I.Promises.readFile("/proc/net/tcp6","utf8")}catch(V){}const _=S(g,m),b=await new Promise(V=>{(0,k.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(W,P,N)=>{V(P)})}),l=v(b),L=await I.readdir("/proc"),O=[];for(let V of L)try{const W=Number(V),P=D.joinPath(y.URI.file("/proc"),V);if((await I.Promises.stat(P.fsPath)).isDirectory()&&!isNaN(W)){const F=await I.Promises.readlink(D.joinPath(P,"cwd").fsPath),M=await I.Promises.readFile(D.joinPath(P,"cmdline").fsPath,"utf8");O.push({pid:W,cwd:F,cmd:M})}}catch(W){}const $=[],ie=_.filter(V=>{const W=l[V.socket];return W||$.push(V),W}),se=n(ie,l,O);let U;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${$.length}`),$.length>0){const V=await new Promise(W=>{(0,k.exec)("ps -F -A -l | grep root",(P,N,F)=>{W(N)})});this._foundRootPorts=s($,V,this._foundRootPorts),U=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.join(", ")}`)}return se.then(V=>U?V.concat(U):V)}};r=Ve([He(0,R.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,h.ILogService)],r),e.ExtHostTunnelService=r}),define(ge[254],pe([0,1,13,21,17,3,6,99,222,126,23]),function(G,e,w,R,C,T,y,k,D,I,i){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function d(r,o){try{return JSON.stringify(r,o)}catch(g){return"null"}}function p(r,o){return JSON.stringify(r,o)}function a(r){return r?(o,g)=>g&&g.$mid===1?r.transformOutgoing(g):g:null}var h;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const v=()=>{},S=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class f extends y.Disposable{constructor(o,g=null,m=null){super();this[A]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=g,this._uriTransformer=m,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let _=0,b=I.ProxyIdentifier.count;_<b;_++)this._locals[_]=null,this._proxies[_]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new w.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(_=>this._receiveOneMessage(_))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?(0,k.transformIncomingURIs)(o,this._uriTransformer):o}getProxy(o){const{nid:g,sid:m}=o;return this._proxies[g]||(this._proxies[g]=this._createProxy(g,m)),this._proxies[g]}_createProxy(o,g){let m={get:(_,b)=>(typeof b=="string"&&!_[b]&&b.charCodeAt(0)===36&&(_[b]=(...l)=>this._remoteCall(o,b,l)),b===u?g:_[b])};return new Proxy(Object.create(null),m)}set(o,g){return this._locals[o.nid]=g,g}assertRegistered(o){for(let g=0,m=o.length;g<m;g++){const _=o[g];if(!this._locals[_.nid])throw new Error(`Missing actor ${_.sid} (isMain: ${_.isMain})`)}}_receiveOneMessage(o){if(this._isDisposed)return;const g=o.byteLength,m=c.read(o,0),_=m.readUInt8(),b=m.readUInt32();switch(_){case 1:case 2:{let{rpcId:l,method:L,args:O}=t.deserializeRequestJSONArgs(m);this._uriTransformer&&(O=(0,k.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(g,b,l,L,O,_===2);break}case 3:case 4:{let{rpcId:l,method:L,args:O}=t.deserializeRequestMixedArgs(m);this._uriTransformer&&(O=(0,k.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(g,b,l,L,O,_===4);break}case 5:{this._logger&&this._logger.logIncoming(g,b,0,"ack"),this._onDidReceiveAcknowledge(b);break}case 6:{this._receiveCancel(g,b);break}case 7:{this._receiveReply(g,b,void 0);break}case 9:{let l=t.deserializeReplyOKJSON(m);this._uriTransformer&&(l=(0,k.transformIncomingURIs)(l,this._uriTransformer)),this._receiveReply(g,b,l);break}case 8:{let l=t.deserializeReplyOKVSBuffer(m);this._receiveReply(g,b,l);break}case 10:{let l=t.deserializeReplyErrError(m);this._uriTransformer&&(l=(0,k.transformIncomingURIs)(l,this._uriTransformer)),this._receiveReplyErr(g,b,l);break}case 11:{this._receiveReplyErr(g,b,void 0);break}default:console.error("received unexpected message"),console.error(o)}}_receiveRequest(o,g,m,_,b,l){this._logger&&this._logger.logIncoming(o,g,1,`receiveRequest ${(0,I.getStringIdentifierForProxy)(m)}.${_}(`,b);const L=String(g);let O,$;if(l){const se=new R.CancellationTokenSource;b.push(se.token),O=this._invokeHandler(m,_,b),$=()=>se.cancel()}else O=this._invokeHandler(m,_,b),$=v;this._cancelInvokedHandlers[L]=$;const ie=t.serializeAcknowledged(g);this._logger&&this._logger.logOutgoing(ie.byteLength,g,1,"ack"),this._protocol.send(ie),O.then(se=>{delete this._cancelInvokedHandlers[L];const U=t.serializeReplyOK(g,se,this._uriReplacer);this._logger&&this._logger.logOutgoing(U.byteLength,g,1,"reply:",se),this._protocol.send(U)},se=>{delete this._cancelInvokedHandlers[L];const U=t.serializeReplyErr(g,se);this._logger&&this._logger.logOutgoing(U.byteLength,g,1,"replyErr:",se),this._protocol.send(U)})}_receiveCancel(o,g){this._logger&&this._logger.logIncoming(o,g,1,"receiveCancel");const m=String(g);this._cancelInvokedHandlers[m]&&this._cancelInvokedHandlers[m]()}_receiveReply(o,g,m){this._logger&&this._logger.logIncoming(o,g,0,"receiveReply:",m);const _=String(g);if(!this._pendingRPCReplies.hasOwnProperty(_))return;const b=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_],b.resolveOk(m)}_receiveReplyErr(o,g,m){this._logger&&this._logger.logIncoming(o,g,0,"receiveReplyErr:",m);const _=String(g);if(!this._pendingRPCReplies.hasOwnProperty(_))return;const b=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_];let l;m&&(m.$isError?(l=new Error,l.name=m.name,l.message=m.message,l.stack=m.stack):l=m),b.resolveErr(l)}_invokeHandler(o,g,m){try{return Promise.resolve(this._doInvokeHandler(o,g,m))}catch(_){return Promise.reject(_)}}_doInvokeHandler(o,g,m){const _=this._locals[o];if(!_)throw new Error("Unknown actor "+(0,I.getStringIdentifierForProxy)(o));let b=_[g];if(typeof b!="function")throw new Error("Unknown method "+g+" on actor "+(0,I.getStringIdentifierForProxy)(o));return b.apply(_,m)}_remoteCall(o,g,m){if(this._isDisposed)return Promise.reject(C.canceled());let _=null;if(m.length>0&&R.CancellationToken.isCancellationToken(m[m.length-1])&&(_=m.pop()),_&&_.isCancellationRequested)return Promise.reject(C.canceled());const b=t.serializeRequestArguments(m,this._uriReplacer),l=++this._lastMessageId,L=String(l),O=new D.LazyPromise;_&&_.onCancellationRequested(()=>{const ie=t.serializeCancel(l);this._logger&&this._logger.logOutgoing(ie.byteLength,l,0,"cancel"),this._protocol.send(t.serializeCancel(l))}),this._pendingRPCReplies[L]=O,this._onWillSendRequest(l);const $=t.serializeRequest(l,o,g,b,!!_);return this._logger&&this._logger.logOutgoing($.byteLength,l,0,`request: ${(0,I.getStringIdentifierForProxy)(o)}.${g}(`,m),this._protocol.send($),O}}e.RPCProtocol=f,A=S,f.UNRESPONSIVE_TIME=3*1e3;class c{constructor(o,g){this._buff=o,this._offset=g}static alloc(o,g,m){let _=new c(i.VSBuffer.alloc(m+1+4),0);return _.writeUInt8(o),_.writeUInt32(g),_}static read(o,g){return new c(o,g)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const m=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,m}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,m}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const g=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,g}static sizeMixedArray(o,g){let m=0;m+=1;for(let _=0,b=o.length;_<b;_++){const l=o[_],L=g[_];switch(m+=1,L){case 1:m+=this.sizeLongString(l);break;case 2:m+=this.sizeVSBuffer(l);break;case 3:break}}return m}writeMixedArray(o,g){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let m=0,_=o.length;m<_;m++){const b=o[m];switch(g[m]){case 1:this.writeUInt8(1),this.writeLongString(b);break;case 2:this.writeUInt8(2),this.writeVSBuffer(b);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let g=new Array(o);for(let m=0;m<o;m++)switch(this.readUInt8()){case 1:g[m]=this.readLongString();break;case 2:g[m]=this.readVSBuffer();break;case 3:g[m]=void 0;break}return g}}class t{static _arrayContainsBufferOrUndefined(o){for(let g=0,m=o.length;g<m;g++)if(o[g]instanceof i.VSBuffer||typeof o[g]=="undefined")return!0;return!1}static serializeRequestArguments(o,g){if(this._arrayContainsBufferOrUndefined(o)){let m=[],_=[];for(let b=0,l=o.length;b<l;b++){const L=o[b];L instanceof i.VSBuffer?(m[b]=L,_[b]=2):typeof L=="undefined"?(m[b]=i.VSBuffer.alloc(0),_[b]=3):(m[b]=i.VSBuffer.fromString(p(L,g)),_[b]=1)}return{type:"mixed",args:m,argsType:_}}return{type:"simple",args:p(o,g)}}static serializeRequest(o,g,m,_,b){return _.type==="mixed"?this._requestMixedArgs(o,g,m,_.args,_.argsType,b):this._requestJSONArgs(o,g,m,_.args,b)}static _requestJSONArgs(o,g,m,_,b){const l=i.VSBuffer.fromString(m),L=i.VSBuffer.fromString(_);let O=0;O+=c.sizeUInt8(),O+=c.sizeShortString(l),O+=c.sizeLongString(L);let $=c.alloc(b?2:1,o,O);return $.writeUInt8(g),$.writeShortString(l),$.writeLongString(L),$.buffer}static deserializeRequestJSONArgs(o){const g=o.readUInt8(),m=o.readShortString(),_=o.readLongString();return{rpcId:g,method:m,args:JSON.parse(_)}}static _requestMixedArgs(o,g,m,_,b,l){const L=i.VSBuffer.fromString(m);let O=0;O+=c.sizeUInt8(),O+=c.sizeShortString(L),O+=c.sizeMixedArray(_,b);let $=c.alloc(l?4:3,o,O);return $.writeUInt8(g),$.writeShortString(L),$.writeMixedArray(_,b),$.buffer}static deserializeRequestMixedArgs(o){const g=o.readUInt8(),m=o.readShortString(),_=o.readMixedArray(),b=new Array(_.length);for(let l=0,L=_.length;l<L;l++){const O=_[l];typeof O=="string"?b[l]=JSON.parse(O):b[l]=O}return{rpcId:g,method:m,args:b}}static serializeAcknowledged(o){return c.alloc(5,o,0).buffer}static serializeCancel(o){return c.alloc(6,o,0).buffer}static serializeReplyOK(o,g,m){return typeof g=="undefined"?this._serializeReplyOKEmpty(o):g instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(o,g):this._serializeReplyOKJSON(o,d(g,m))}static _serializeReplyOKEmpty(o){return c.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,g){let m=0;m+=c.sizeVSBuffer(g);let _=c.alloc(8,o,m);return _.writeVSBuffer(g),_.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,g){const m=i.VSBuffer.fromString(g);let _=0;_+=c.sizeLongString(m);let b=c.alloc(9,o,_);return b.writeLongString(m),b.buffer}static deserializeReplyOKJSON(o){const g=o.readLongString();return JSON.parse(g)}static serializeReplyErr(o,g){return g?this._serializeReplyErrEror(o,g):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,g){const m=i.VSBuffer.fromString(d(C.transformErrorForSerialization(g),null));let _=0;_+=c.sizeLongString(m);let b=c.alloc(10,o,_);return b.writeLongString(m),b.buffer}static deserializeReplyErrError(o){const g=o.readLongString();return JSON.parse(g)}static _serializeReplyErrEmpty(o){return c.alloc(11,o,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var s;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(s||(s={}))}),define(ge[255],pe([0,1,4]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,w.createDecorator)("remoteAgentService")}),define(ge[256],pe([0,1,10,9,11,2,4,255]),function(G,e,w,R,C,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(i,A){this.localUserHome=i,this.remoteAgentService=A,this.resolveOS=(async()=>{const d=await this.remoteAgentService.getEnvironment();return(d==null?void 0:d.os)||C.OS})(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(d==null?void 0:d.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?R.win32:R.posix)}async fileURI(i){let A="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const p=i.indexOf("/",2);p===-1?(A=i.substring(2),i="/"):(A=i.substring(2,p),i=i.substring(p)||"/")}return T.URI.from({scheme:w.Schemas.file,authority:A,path:i,query:"",fragment:""})}};D=Ve([He(1,k.IRemoteAgentService)],D),e.AbstractPathService=D}),define(ge[68],pe([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class w{constructor(y,k){this.line=y,this.character=k}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,k){return new w(0,0)}with(y){return new w(0,0)}}e.Position=w;class R{constructor(y,k,D,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(y,k),this.end=new w(D,I)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new R(0,0,0,0)}with(y){return new R(0,0,0,0)}}e.Range=R;var C;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ge[31],pe([0,1,16,30,25,29,8,4,9,17,68]),function(G,e,w,R,C,T,y,k,D,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const A="\u27EA ",d=" characters skipped \u27EB",p=(A.length+d.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var a;(function(P){P[P.file=0]="file",P[P.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(P){P[P.File=1]="File",P[P.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function E(P){return!!P.preview}e.resultIsMatch=E;function v(P){return!!P.resource}e.isFileMatch=v;function S(P){return!!P.message}e.isProgressMessage=S;var u;(function(P){P[P.Normal=0]="Normal",P[P.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class f{constructor(N){this.resource=N,this.results=[]}}e.FileMatch=f;class c{constructor(N,F,M){this.ranges=F;const B=Array.isArray(F)?F:[F];if(M&&M.matchLines===1&&t(B)){N=(0,y.getNLines)(N,M.matchLines);let H="",Q=0,le=0;const be=Math.floor(M.charsPerLine/5),Te=[];for(const ke of B){const Ne=Math.max(ke.startColumn-be,0),Ke=ke.startColumn+M.charsPerLine;if(Ne>le+be+p){const ze=A+(Ne-le)+d;H+=ze+N.slice(Ne,Ke),Q+=Ne-(le+ze.length)}else H+=N.slice(le,Ke);Te.push(new s(0,ke.startColumn-Q,ke.endColumn-Q)),le=Ke}this.preview={text:H,matches:Array.isArray(this.ranges)?Te:Te[0]}}else{const H=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:N,matches:(0,w.mapArrayOrNot)(F,Q=>new n(Q.startLineNumber-H,Q.startColumn,Q.endLineNumber-H,Q.endColumn))}}}}e.TextSearchMatch=c;function t(P){const N=P[0].startLineNumber;for(const F of P)if(F.startLineNumber!==N||F.endLineNumber!==N)return!1;return!0}class n{constructor(N,F,M,B){this.startLineNumber=N,this.startColumn=F,this.endLineNumber=M,this.endColumn=B}}e.SearchRange=n;class s extends n{constructor(N,F,M){super(N,F,N,M)}}e.OneLineRange=s;var r;(function(P){P.Default="default",P.FileNames="fileNames",P.Type="type",P.Modified="modified",P.CountDescending="countDescending",P.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function o(P,N=!0){const F=P&&P.files&&P.files.exclude,M=N&&P&&P.search&&P.search.exclude;if(!F&&!M)return;if(!F||!M)return F||M;let B=Object.create(null);return B=C.mixin(B,C.deepClone(F)),B=C.mixin(B,C.deepClone(M),!0),B}e.getExcludes=o;function g(P,N){return P.excludePattern&&R.match(P.excludePattern,N)?!1:P.includePattern||P.usingSearchPaths?P.includePattern&&R.match(P.includePattern,N)?!0:P.usingSearchPaths?!!P.folderQueries&&P.folderQueries.some(F=>{const M=F.folder.fsPath;if(T.isEqualOrParent(N,M)){const B=D.relative(M,N);return!F.includePattern||!!R.match(F.includePattern,B)}else return!1}):!1:!0}e.pathIncludedInQuery=g;var m;(function(P){P[P.unknownEncoding=1]="unknownEncoding",P[P.regexParseError=2]="regexParseError",P[P.globParseError=3]="globParseError",P[P.invalidLiteral=4]="invalidLiteral",P[P.rgProcessError=5]="rgProcessError",P[P.other=6]="other",P[P.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(N,F){super(N);this.code=F}}e.SearchError=_;function b(P){const N=P.message;if((0,I.isPromiseCanceledError)(P))return new _(N,m.canceled);try{const F=JSON.parse(N);return new _(F.message,F.code)}catch(F){return new _(N,m.other)}}e.deserializeSearchError=b;function l(P){const N={message:P.message,code:P.code};return new Error(JSON.stringify(N))}e.serializeSearchError=l;function L(P){return P.type==="error"?!0:P.type==="success"}e.isSerializedSearchComplete=L;function O(P){return P.type==="success"}e.isSerializedSearchSuccess=O;function $(P){return!!P.path}e.isSerializedFileMatch=$;function ie(P,N){const F=P.searchPath?P.searchPath:P.relativePath;return(0,y.fuzzyContains)(F,N)}e.isFilePatternMatch=ie;class se{constructor(N){this.path=N,this.results=[]}addMatch(N){this.results.push(N)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=se;function U(P,N){const F=Object.assign(Object.assign({},P||{}),N||{});return Object.keys(F).filter(M=>{const B=F[M];return typeof B=="boolean"&&B})}e.resolvePatternsForProvider=U;class V{constructor(N,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},N.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let M=N.includePattern;F.includePattern&&(M?M=Object.assign(Object.assign({},M),F.includePattern):M=F.includePattern),M&&(this._parsedIncludeExpression=R.parse(M))}includedInQuerySync(N,F,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(N,F,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(N,F,M))}includedInQuery(N,F,M){return Promise.resolve(this._parsedExcludeExpression(N,F,M)).then(H=>!!H).then(H=>H?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(N,F,M)).then(Q=>!!Q):Promise.resolve(!0)).then(H=>H)}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=V;function W(P){for(const N in P)if(typeof P[N]!="boolean")return!0;return!1}}),define(ge[34],pe([0,1,16,13,21,3,22,10,74,24,8,12,2,167,4,14,186,61,62,27,15,7,31,5]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E,v,S,u,f,c,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(L,O,$){return new I.ExtUri(ie=>m(ie,$)).isEqual(L,O)}function r(L,O,$){return s(L.uri,O.uri,$)?0:(0,i.compare)(L.uri.toString(),O.uri.toString())}function o(L,O,$){return L.index!==O.index?L.index<O.index?-1:1:s(L.uri,O.uri,$)?(0,i.compare)(L.name,O.name):(0,i.compare)(L.uri.toString(),O.uri.toString())}function g(L,O,$,ie){const se=L.slice(0).sort((V,W)=>$(V,W,ie)),U=O.slice(0).sort((V,W)=>$(V,W,ie));return(0,w.delta)(se,U,(V,W)=>$(V,W,ie))}function m(L,O){const $=O.getCapabilities(L.scheme);return!($&&$&1024)}class _ extends v.Workspace{constructor(O,$,ie,se,U,V){super(O,ie.map(W=>new v.WorkspaceFolder(W)),se,V);this._name=$,this._isUntitled=U,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(V),ie.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(O,$,ie,se){if(!O)return{workspace:null,added:[],removed:[]};const{id:U,name:V,folders:W,configuration:P,isUntitled:N}=O,F=[],M=$;$?W.forEach((le,be)=>{const Te=d.URI.revive(le.uri),ke=_._findFolder(ie||$,Te,se);ke?(ke.name=le.name,ke.index=le.index,F.push(ke)):F.push({uri:Te,name:le.name,index:be})}):F.push(...W.map(({uri:le,name:be,index:Te})=>({uri:d.URI.revive(le),name:be,index:Te}))),F.sort((le,be)=>le.index<be.index?-1:1);const B=new _(U,V,F,P?d.URI.revive(P):null,!!N,le=>m(le,se)),{added:H,removed:Q}=g(M?M.workspaceFolders:[],B.workspaceFolders,r,se);return{workspace:B,added:H,removed:Q}}static _findFolder(O,$,ie){for(let se=0;se<O.folders.length;se++){const U=O.workspaceFolders[se];if(s(U.uri,$,ie))return U}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,$){return $&&this._structure.get(O)&&(O=(0,I.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let b=class{constructor(O,$,ie,se){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=se,this._extHostFileSystemInfo=ie,this._requestIdProvider=new D.Counter,this._barrier=new R.Barrier,this._proxy=O.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(n.MainContext.MainThreadMessageService);const U=$.workspace;this._confirmedWorkspace=U?new _(U.id,U.name,[],U.configuration?d.URI.revive(U.configuration):null,!!U.isUntitled,V=>m(V,ie)):void 0}$initializeWorkspace(O,$){this._trusted=$,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:k.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,$,ie,...se){const U=[];if(Array.isArray(se)&&se.forEach(F=>{d.URI.isUri(F.uri)&&!U.some(M=>s(M.uri,F.uri,this._extHostFileSystemInfo))&&U.push({uri:F.uri,name:F.name||(0,I.basenameOrAuthority)(F.uri)})}),this._unconfirmedWorkspace||[$,ie].some(F=>typeof F!="number"||F<0)||ie===0&&U.length===0)return!1;const V=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+ie>V.length)return!1;const W=V.slice(0);W.splice($,ie,...U.map(F=>({uri:F.uri,name:F.name||(0,I.basenameOrAuthority)(F.uri),index:void 0})));for(let F=0;F<W.length;F++){const M=W[F];if(W.some((B,H)=>H!==F&&s(M.uri,B.uri,this._extHostFileSystemInfo)))return!1}W.forEach((F,M)=>F.index=M);const{added:P,removed:N}=g(V,W,o,this._extHostFileSystemInfo);if(P.length===0&&N.length===0)return!1;if(this._proxy){const F=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(F,$,ie,U).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,p.localize)(0,null,F,M.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(O,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,$)}async getWorkspaceFolder2(O,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,$)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,$){let ie,se="";if(typeof O=="string"?(ie=d.URI.file(O),se=O):typeof O!="undefined"&&(ie=O,se=O.fsPath),!ie)return se;const U=this.getWorkspaceFolder(ie,!0);if(!U)return se;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let V=(0,I.relativePath)(U.uri,ie);return $&&U.name&&(V=`${U.name}/${V}`),V}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:$,added:ie,removed:se}=_.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ie,removed:se}))}findFiles(O,$,ie,se,U=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${se.value}, entryPoint: findFiles`);let V;if($===null?V=!1:$&&(typeof $=="string"?V=$:V=$.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:P}=l(O);return this._proxy.$startFileSearch((0,A.withUndefinedAsNull)(W),(0,A.withUndefinedAsNull)(P),(0,A.withUndefinedAsNull)(V),(0,A.withUndefinedAsNull)(ie),U).then(N=>Array.isArray(N)?N.map(F=>d.URI.revive(F)):[])}async findTextInFiles(O,$,ie,se,U=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${se.value}, entryPoint: findTextInFiles`);const V=this._requestIdProvider.getNext(),W=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:P,folder:N}=l($.include),F=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,M={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:W,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:P,excludePattern:F},B=!1;if(this._activeSearchCallbacks[V]=H=>{if(B)return;const Q=d.URI.revive(H.resource);H.results.forEach(le=>{(0,t.resultIsMatch)(le)?ie({uri:Q,preview:{text:le.preview.text,matches:(0,w.mapArrayOrNot)(le.preview.matches,be=>new c.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,w.mapArrayOrNot)(le.ranges,be=>new c.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):ie({uri:Q,text:le.text,lineNumber:le.lineNumber})})},U.isCancellationRequested)return{};try{const H=await this._proxy.$startTextSearch(O,(0,A.withUndefinedAsNull)(N),M,V,U);return delete this._activeSearchCallbacks[V],H||{}}catch(H){throw delete this._activeSearchCallbacks[V],H}}$handleTextSearchResult(O,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};b=Ve([He(0,f.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,S.IExtHostFileSystemInfo),He(3,h.ILogService)],b),e.ExtHostWorkspace=b,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function l(L){let O,$;return L&&(typeof L=="string"?O=L:(O=L.pattern,$=L.baseFolder||d.URI.file(L.base))),{includePattern:O,folder:$}}}),define(ge[35],pe([0,1,25,3,34,5,7,189,83,12,13,4,15,14,2]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(n,s){if(s){const r=s.split(".");let o=n;for(let g=0;o&&g<r.length;g++)o=o[r[g]];return o}}function E(n){return n instanceof a.URI}function v(n){return n&&n.uri instanceof a.URI&&n.languageId&&typeof n.languageId=="string"}function S(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function u(n){return n&&n.uri instanceof a.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function f(n){if(E(n))return{resource:n};if(v(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(S(n))return{overrideIdentifier:n.languageId};if(u(n))return{resource:n.uri};if(n===null)return{resource:null}}let c=class{constructor(s,r,o){this._proxy=s.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=o,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,r){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(s,r))}};c=Ve([He(0,d.IExtHostRpcService),He(1,C.IExtHostWorkspace),He(2,p.ILogService)],c),e.ExtHostConfiguration=c;class t{constructor(s,r,o,g){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=g,this._extHostWorkspace=r,this._configuration=k.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,r){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,o))}getConfiguration(s,r,o){const g=f(r)||{},m=this._toReadonlyValue(s?h(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,g,o==null?void 0:o.identifier);function _(l){if(l==null)return null;if(typeof l=="boolean")return l?1:4;switch(l){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const b={has(l){return typeof h(m,l)!="undefined"},get:(l,L)=>{this._validateConfigurationAccess(s?`${s}.${l}`:l,g,o==null?void 0:o.identifier);let O=h(m,l);if(typeof O=="undefined")O=L;else{let $;const ie=(se,U)=>{let V;const W=()=>{$=$||(0,w.deepClone)(m),V=V||h($,U)};return(0,I.isObject)(se)?new Proxy(se,{get:(P,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return W(),()=>V;if($)return V=V||h($,U),V[N];const F=P[N];return typeof N=="string"?ie(F,`${U}.${N}`):F},set:(P,N,F)=>(W(),V&&(V[N]=F),!0),deleteProperty:(P,N)=>(W(),V&&delete V[N],!0),defineProperty:(P,N,F)=>(W(),V&&Object.defineProperty(V,N,F),!0)}):se};O=ie(O,l)}return O},update:(l,L,O,$)=>{l=s?`${s}.${l}`:l;const ie=_(O);return L!==void 0?this._proxy.$updateConfigurationOption(ie,l,L,g,$):this._proxy.$removeConfigurationOption(ie,l,g,$)},inspect:l=>{var L,O,$,ie,se,U,V,W;l=s?`${s}.${l}`:l;const P=(0,w.deepClone)(this._configuration.inspect(l,g,this._extHostWorkspace.workspace));if(P)return{key:l,defaultValue:(L=P.default)===null||L===void 0?void 0:L.value,globalValue:(O=P.user)===null||O===void 0?void 0:O.value,workspaceValue:($=P.workspace)===null||$===void 0?void 0:$.value,workspaceFolderValue:(ie=P.workspaceFolder)===null||ie===void 0?void 0:ie.value,defaultLanguageValue:(se=P.default)===null||se===void 0?void 0:se.override,globalLanguageValue:(U=P.user)===null||U===void 0?void 0:U.override,workspaceLanguageValue:(V=P.workspace)===null||V===void 0?void 0:V.override,workspaceFolderLanguageValue:(W=P.workspaceFolder)===null||W===void 0?void 0:W.override,languageIds:P.overrideIdentifiers}}};return typeof m=="object"&&(0,w.mixin)(b,m,!1),Object.freeze(b)}_toReadonlyValue(s){const r=o=>(0,I.isObject)(o)?new Proxy(o,{get:(g,m)=>r(g[m]),set:(g,m,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(g,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(g,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return r(s)}_validateConfigurationAccess(s,r,o){const g=D.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),m=o?`[${o.value}] `:"";if(g===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){(r==null?void 0:r.resource)&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,r){const o=new k.ConfigurationChangeEvent(s,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,m)=>o.affectsConfiguration(g,f(m))})}_toMap(s){return s.reduce((r,o)=>(r.set(o[0],o[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,A.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(G,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!C:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(G,w):C?C.value=w:e.set(G,w),w},Be=this&&this.__classPrivateFieldGet||function(G,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!R:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(G):R?R.value:e.get(G)};define(ge[69],pe([0,1,2,13,3,5,7,34,40,35,21,33,15,27,4,10,11,14,65,207,17]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E,v,S,u,f){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(se){function U(W){if(W!=null)return W}se.from=U;function V(W){if(W!=null)return W}se.to=V})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(se){function U(W){if(W!=null)return W}se.from=U;function V(W){if(W!=null)return W}se.to=V})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(se){function U(W){if(W!=null)return W}se.from=U;function V(W){if(W!=null)return W}se.to=V})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(se){function U(P){if(P){const N=P;return N&&!!N.process}else return!1}se.is=U;function V(P){if(P==null)return;const N={process:P.process,args:P.args};return P.options&&(N.options=s.from(P.options)),N}se.from=V;function W(P){if(P!=null)return new y.ProcessExecution(P.process,P.args,P.options)}se.to=W})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(se){function U(W){if(W!=null)return W}se.from=U;function V(W){if(W!=null)return W}se.to=V})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var g;(function(se){function U(P){if(P){const N=P;return N&&(!!N.commandLine||!!N.command)}else return!1}se.is=U;function V(P){if(P==null)return;const N={};return P.commandLine!==void 0?N.commandLine=P.commandLine:(N.command=P.command,N.args=P.args),P.options&&(N.options=o.from(P.options)),N}se.from=V;function W(P){if(!(P==null||P.command===void 0&&P.commandLine===void 0))return P.commandLine?new y.ShellExecution(P.commandLine,P.options):new y.ShellExecution(P.command,P.args?P.args:[],P.options)}se.to=W})(g=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(se){function U(P){if(P){let N=P;return N&&N.customExecution==="customExecution"}else return!1}se.is=U;function V(P){return{customExecution:"customExecution"}}se.from=V;function W(P,N){return N.get(P)}se.to=W})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function(se){function U(V,W){let P;return V.scope!==void 0&&typeof V.scope!="number"?P=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===y.TaskScope.Workspace&&W&&W.workspaceFile?P=W.workspaceFile:P=u.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:P}}se.from=U})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var b;(function(se){function U(P,N){if(P==null)return[];const F=[];for(let M of P){const B=V(M,N);B&&F.push(B)}return F}se.fromMany=U;function V(P,N){if(P==null)return;let F;P.execution instanceof y.ProcessExecution?F=r.from(P.execution):P.execution instanceof y.ShellExecution?F=g.from(P.execution):P.execution&&P.execution instanceof y.CustomExecution&&(F=m.from(P.execution));const M=t.from(P.definition);let B;if(P.scope?typeof P.scope=="number"?B=P.scope:B=P.scope.uri:B=y.TaskScope.Workspace,!M||!B)return;const H=P.group?P.group.id:void 0;return{_id:P._id,definition:M,name:P.name,source:{extensionId:N.identifier.value,label:P.source,scope:B},execution:F,isBackground:P.isBackground,group:H,presentationOptions:n.from(P.presentationOptions),problemMatchers:P.problemMatchers,hasDefinedMatchers:P.hasDefinedMatchers,runOptions:P.runOptions?P.runOptions:{reevaluateOnRerun:!0},detail:P.detail}}se.from=V;async function W(P,N,F){if(P==null)return;let M;r.is(P.execution)?M=r.to(P.execution):g.is(P.execution)?M=g.to(P.execution):m.is(P.execution)&&(M=m.to(P._id,F));const B=t.to(P.definition);let H;if(P.source&&(P.source.scope!==void 0?typeof P.source.scope=="number"?H=P.source.scope:H=await N.resolveWorkspaceFolder(w.URI.revive(P.source.scope)):H=y.TaskScope.Workspace),!B||!H)return;const Q=new y.Task(B,H,P.name,P.source.label,M,P.problemMatchers);return P.isBackground!==void 0&&(Q.isBackground=P.isBackground),P.group!==void 0&&(Q.group=y.TaskGroup.from(P.group)),P.presentationOptions&&(Q.presentationOptions=n.to(P.presentationOptions)),P._id&&(Q._id=P._id),P.detail&&(Q.detail=P.detail),Q}se.to=W})(b=e.TaskDTO||(e.TaskDTO={}));var l;(function(se){function U(W){return W}se.from=U;function V(W){if(!!W)return Object.assign(Object.create(null),W)}se.to=V})(l=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(U,V,W){this._id=V,this._task=W,c.set(this,void 0),nt(this,c,U,"f")}get task(){return this._task}terminate(){Be(this,c,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}c=new WeakMap;var O;(function(se){function U(V){return{id:V._id,task:void 0}}se.from=U})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(U,V,W,P,N,F,M,B){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=U.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=P,this._configurationService=N,this._terminalService=F,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=B,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,V,W){if(!W)return new y.Disposable(()=>{});const P=this.nextHandle();return this._handlers.set(P,{type:V,provider:W,extension:U}),this._proxy.$registerTaskProvider(P,V),new y.Disposable(()=>{this._handlers.delete(P),this._proxy.$unregisterTaskProvider(P)})}registerTaskSystem(U,V){this._proxy.$registerTaskSystem(U,V)}fetchTasks(U){return this._proxy.$fetchTasks(l.from(U)).then(async V=>{const W=[];for(let P of V){const N=await b.to(P,this._workspaceProvider,this._providedCustomExecutions2);N&&W.push(N)}return W})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(V=>U.push(V)),U}terminateTask(U){if(!(U instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,V,W){const P=this._providedCustomExecutions2.get(U.id);if(P){if(this._activeCustomExecutions2.get(U.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(U.id,P),this._terminalService.attachPtyToTerminal(V,await P.callback(W))}this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const V=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const V=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:V,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const V=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:U.exitCode})}$provideTasks(U,V){const W=this._handlers.get(U);if(!W)return Promise.reject(new Error("no handler found"));const P=[],N=(0,R.asPromise)(()=>W.provider.provideTasks(i.CancellationToken.None)).then(F=>this.provideTasksInternal(V,P,W,F));return new Promise(F=>{N.then(M=>{Promise.all(P).then(()=>{F(M)})})})}async $resolveTask(U,V){const W=this._handlers.get(U);if(!W)return Promise.reject(new Error("no handler found"));if(V.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${W.type}].`);const P=await b.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!P)throw new Error("Unexpected: Task cannot be resolved.");const N=await W.provider.resolveTask(P,i.CancellationToken.None);if(!N)return;this.checkDeprecation(N,W);const F=b.from(N,W.extension);if(!F)throw new Error("Unexpected: Task cannot be resolved.");if(N.definition!==P.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(F.execution)&&await this.addCustomExecution(F,N,!0),await this.resolveTaskInternal(F)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,V,W){const P=await this._proxy.$createTaskId(U);!W&&!this._providedCustomExecutions2.has(P)&&this._notProvidedCustomExecutions.add(P),this._providedCustomExecutions2.set(P,V.execution)}async getTaskExecution(U,V){if(typeof U=="string"){const N=this._taskExecutionPromises.get(U);if(!N)throw new Error("Unexpected: The specified task is missing an execution");return N}let W=this._taskExecutionPromises.get(U.id);if(W)return W;const P=new Promise(async(N,F)=>{const M=V||await b.to(U.task,this._workspaceProvider,this._providedCustomExecutions2);M?N(new L(this,U.id,M)):F("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(U.id,P),P.then(N=>(this._taskExecutions.set(U.id,N),N),N=>Promise.reject(N))}checkDeprecation(U,V){U._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));let W=this._notProvidedCustomExecutions.values(),P=W.next();for(;!P.done;)!this._activeCustomExecutions2.has(P.value)&&this._lastStartedTask!==P.value&&(this._providedCustomExecutions2.delete(P.value),this._notProvidedCustomExecutions.delete(P.value)),P=W.next()}};$=Ve([He(0,d.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,I.IExtHostConfiguration),He(5,A.IExtHostTerminalService),He(6,v.ILogService),He(7,S.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let ie=class extends ${constructor(U,V,W,P,N,F,M,B){super(U,V,W,P,N,F,M,B);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(U,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const W=b.from(V,U);if(W===void 0)throw new Error("Task is not valid");if(m.is(W.execution))await this.addCustomExecution(W,V,!1);else throw new f.NotSupportedError;const P=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),V);return this._proxy.$executeTask(W).catch(N=>{throw new Error(N)}),P}provideTasksInternal(U,V,W,P){const N=[];if(P)for(let F of P){this.checkDeprecation(F,W),(!F.definition||!U[F.definition.type])&&this._logService.warn(`The task [${F.source}, ${F.name}] uses an undefined task type. The task will be ignored in the future.`);const M=b.from(F,W.extension);M&&m.is(M.execution)?(N.push(M),V.push(this.addCustomExecution(M,F,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:N,extension:W.extension}}async resolveTaskInternal(U){if(m.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,V,W){}};ie=Ve([He(0,d.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,I.IExtHostConfiguration),He(5,A.IExtHostTerminalService),He(6,v.ILogService),He(7,S.IExtHostApiDeprecationService)],ie),e.WorkerExtHostTask=ie,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")});var nt=this&&this.__classPrivateFieldSet||function(G,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!C:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(G,w):C?C.value=w:e.set(G,w),w},Be=this&&this.__classPrivateFieldGet||function(G,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!R:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(G):R?R.value:e.get(G)},Qt=this&&this.__rest||function(G,e){var w={};for(var R in G)Object.prototype.hasOwnProperty.call(G,R)&&e.indexOf(R)<0&&(w[R]=G[R]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(G);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(G,R[C])&&(w[R[C]]=G[R[C]]);return w};define(ge[257],pe([0,1,16,13,23,21,3,72,54,6,25,12,2,32,5,40,15,86,20,7,34,217,123]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E,v,S,u,f,c,t){"use strict";var n,s,r,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const g=(W,P)=>`${W}:${P.toString()}`;let m=class{constructor(P,N,F){this.documents=N,this.workspace=F,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new c.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=P.getProxy(a.MainContext.MainThreadTesting),this.runQueue=new _(this.proxy),this.workspaceObservers=new U(this.proxy),this.textDocumentObservers=new V(this.proxy,N)}registerTestController(P,N){const F=(0,p.generateUuid)();this.controllers.set(F,{instance:N,extensionId:P}),this.proxy.$registerTestController(F);const M=[...this.testControllers.keys()];return setTimeout(()=>{var B;for(const H of M)(B=this.testControllers.get(H))===null||B===void 0||B.subscribeFn(F,N)},0),new u.Disposable(()=>{this.controllers.delete(F),this.proxy.$unregisterTestController(F)})}createTextDocumentTestObserver(P){return this.textDocumentObservers.checkout(P.uri)}createWorkspaceTestObserver(P){return this.workspaceObservers.checkout(P.uri)}async runTests(P,N=T.CancellationToken.None){const F=M=>M.map(this.getInternalTestForReference,this).filter(A.isDefined).map(B=>({src:B.src,testId:B.item.extId}));await this.proxy.$runTests({exclude:P.exclude?F(P.exclude).map(M=>M.testId):void 0,tests:F(P.tests),debug:P.debug},N)}createTestRun(P,N,F,M=!0){return this.runQueue.createTestRun(P,N,F,M)}$publishTestResults(P){this.results=Object.freeze(P.map(N=>(0,i.deepFreeze)(S.TestResults.to(N))).concat(this.results).sort((N,F)=>F.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(P,N){const F=d.URI.revive(N),M=g(P,F);if(this.testControllers.has(M))return;const B=new T.CancellationTokenSource;let H;if(P===1){let ke=this.documents.getDocument(F);if(!ke){const Ne=new I.DisposableStore;ke=await new Promise(Ke=>{Ne.add((0,R.disposableTimeout)(()=>Ke(void 0),5e3)),Ne.add(this.documents.onDidAddDocuments(ze=>{const qe=ze.find(q=>q.document.uri.toString()===F.toString());qe&&Ke(qe)}))}).finally(()=>Ne.dispose())}if(ke){const Ne=await this.workspace.getWorkspaceFolder2(F,!1);H=Ke=>Ke.createDocumentTestRoot?Ke.createDocumentTestRoot(ke.document,B.token):(0,e.createDefaultDocumentTestRoot)(Ke,ke.document,Ne,B.token)}}else{const ke=await this.workspace.getWorkspaceFolder2(F,!1);ke&&(H=Ne=>Ne.createWorkspaceTestRoot(ke,B.token))}if(!H)return;const Q=async(ke,Ne)=>{try{const Ke=await H(Ne);Ke&&be.addRoot(Ke,ke)}catch(Ke){console.error(Ke)}},le=new I.DisposableStore,be=le.add(this.ownedTests.createForHierarchy(ke=>this.proxy.$publishDiff(P,N,ke)));le.add((0,I.toDisposable)(()=>B.dispose(!0)));const Te=[];for(const[ke,Ne]of this.controllers)Te.push(Q(ke,Ne.instance));Promise.all(Te).then(()=>be.pushDiff([3,-1])),this.testControllers.set(M,{store:le,collection:be,subscribeFn:Q})}async $expandTest(P,N){const F=(0,w.mapFind)(this.testControllers.values(),M=>M.collection.treeId===P.src.tree?M:void 0);await(F==null?void 0:F.collection.expand(P.testId,N<0?Infinity:N)),this.flushCollectionDiffs()}$unsubscribeFromTests(P,N){var F;const M=d.URI.revive(N),B=g(P,M);(F=this.testControllers.get(B))===null||F===void 0||F.store.dispose(),this.testControllers.delete(B)}$acceptDiff(P,N,F){P===1?this.textDocumentObservers.acceptDiff(d.URI.revive(N),F):this.workspaceObservers.acceptDiff(d.URI.revive(N),F)}async $runTestsForProvider(P,N){const F=this.controllers.get(P.tests[0].src.controller);if(!F)return;const M=P.tests.map(({testId:Q,src:le})=>this.ownedTests.getTestById(Q,le==null?void 0:le.tree)).filter(A.isDefined).map(([Q,le])=>le),B=P.excludeExtIds.map(Q=>this.ownedTests.getTestById(Q)).filter(A.isDefined).filter(([Q,le])=>M.some(be=>Q.comparePositions(be,le)===1));if(!M.length)return;const H={tests:M.map(Q=>O.unwrap(Q.actual)),exclude:B.map(([,Q])=>O.unwrap(Q.actual)),debug:P.debug};await this.runQueue.enqueueRun({dto:b.fromInternal(P),token:N,extensionId:F.extensionId,req:H,doRun:()=>F.instance.runTests(H,N)})}$lookupTest(P){const N=this.ownedTests.getTestById(P.testId);if(!N)return Promise.resolve(void 0);const F=N[1],{actual:M,discoverCts:B,expandLevels:H}=F,Q=Qt(F,["actual","discoverCts","expandLevels"]);return Promise.resolve(Q)}flushCollectionDiffs(){for(const{collection:P}of this.testControllers.values())P.flushDiff()}getInternalTestForReference(P){var N,F;return(F=(N=this.workspaceObservers.getMirroredTestDataByReference(P))!==null&&N!==void 0?N:(0,w.mapFind)(this.testControllers.values(),M=>M.collection.getTestByReference(P)))!==null&&F!==void 0?F:this.textDocumentObservers.getMirroredTestDataByReference(P)}};m=Ve([He(0,E.IExtHostRpcService),He(1,h.IExtHostDocumentsAndEditors),He(2,f.IExtHostWorkspace)],m),e.ExtHostTesting=m;class _{constructor(P){this.proxy=P,this.state=new Map}enqueueRun(P){let N=this.state.get(P.extensionId);N||(N={queue:[],current:void 0},this.state.set(P.extensionId,N));const F=new R.DeferredPromise,M=()=>{const B=[],H=new Set;N.current={publicReq:P.req,factory:Q=>{const le=new l(Q,P.dto,H,this.proxy);return B.push(le),P.token.onCancellationRequested(()=>le.end()),le}},this.invokeRunner(P.extensionId,P.dto.id,P.doRun,B).finally(()=>F.complete())};return N.queue.push(M),N.queue.length===1&&M(),F.p}createTestRun(P,N,F,M){var B,H;const Q=this.state.get(P);if((Q==null?void 0:Q.current.publicReq)===N)return Q.current.factory(F);const le=b.fromPublic(N),be=new l(F,le,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:N.debug,exclude:(H=(B=N.exclude)===null||B===void 0?void 0:B.map(Te=>Te.id))!==null&&H!==void 0?H:[],id:le.id,tests:N.tests.map(Te=>Te.id),persist:M}),be.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(le.id)),be}invokeRunner(P,N,F,M){try{const B=F();return(0,R.isThenable)(B)?B.then(()=>this.handleInvokeResult(P,N,M,void 0)).catch(H=>this.handleInvokeResult(P,N,M,H)):this.handleInvokeResult(P,N,M,void 0)}catch(B){return this.handleInvokeResult(P,N,M,B)}}async handleInvokeResult(P,N,F,M){const B=this.state.get(P);!B||(B.queue.shift(),B.queue.length>0?B.queue[0]():this.state.delete(P),await Promise.all(F.map(H=>H.onEnd.wait())))}}class b{constructor(P,N,F){this.id=P,this.include=N,this.exclude=F}static fromPublic(P){var N,F;return new b((0,p.generateUuid)(),new Set(P.tests.map(M=>M.id)),new Set((F=(N=P.exclude)===null||N===void 0?void 0:N.map(M=>M.id))!==null&&F!==void 0?F:D.Iterable.empty()))}static fromInternal(P){return new b(P.runId,new Set(P.tests.map(N=>N.testId)),new Set(P.excludeExtIds))}isIncluded(P){for(let N=P;N;N=N.parent){if(this.include.has(N.id))return!0;if(this.exclude.has(N.id))return!1}return!0}}class l{constructor(P,N,F,M){this.name=P,n.set(this,void 0),s.set(this,void 0),r.set(this,(0,p.generateUuid)()),o.set(this,void 0),this.onEnd=new R.Barrier,nt(this,n,M,"f"),nt(this,s,N,"f"),nt(this,o,F,"f"),M.$startedTestRunTask(N.id,{id:Be(this,r,"f"),name:P,running:!0})}setState(P,N,F){Be(this,s,"f").isIncluded(P)&&(this.ensureTestIsKnown(P),Be(this,n,"f").$updateTestStateInRun(Be(this,s,"f").id,Be(this,r,"f"),P.id,N,F))}appendMessage(P,N){Be(this,s,"f").isIncluded(P)&&(this.ensureTestIsKnown(P),Be(this,n,"f").$appendTestMessageInRun(Be(this,s,"f").id,Be(this,r,"f"),P.id,S.TestMessage.from(N)))}appendOutput(P){Be(this,n,"f").$appendOutputToRun(Be(this,s,"f").id,Be(this,r,"f"),C.VSBuffer.fromString(P))}end(){Be(this,n,"f").$finishedTestRunTask(Be(this,s,"f").id,Be(this,r,"f")),this.onEnd.open()}ensureTestIsKnown(P){const N=Be(this,o,"f");if(N.has(P.id))return;const F=[];for(;F.unshift(S.TestItem.from(P)),!(N.has(P.id)||(N.add(P.id),!P.parent));)P=P.parent;Be(this,n,"f").$addTestsToRun(Be(this,s,"f").id,F)}}n=new WeakMap,s=new WeakMap,r=new WeakMap,o=new WeakMap;const L=async(W,P,N,F)=>{if(!N)return;const M=await W.createWorkspaceTestRoot(N,F);if(!M)return;F.onCancellationRequested(()=>{O.removeFilter(P)});const B=O.getWrapperForTestItem(M,P);return B.refreshMatch(),B};e.createDefaultDocumentTestRoot=L;class O extends u.TestItemImpl{constructor(P,N,F){super(P.id,P.label,P.uri,void 0);if(this.actual=P,this.filterDocument=N,this.actualParent=F,!(P instanceof u.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${P.id} did not`);this.debuggable=P.debuggable,this.runnable=P.runnable,this.description=P.description,this.error=P.error,this.status=P.status,this.range=P.range,this.resolveHandler=P.resolveHandler;const M=(0,v.getPrivateApiFor)(this);(0,v.getPrivateApiFor)(P).bus.event(H=>{switch(H[0]){case 3:this[H[1]]=H[2];break;case 0:const Q=O.getWrapperForTestItem(H[1],this.filterDocument,this);(0,v.getPrivateApiFor)(Q).parent=P,Q.refreshMatch();break;default:M.bus.fire(H)}})}static removeFilter(P){this.wrapperMap.delete(P)}static getWrapperForTestItem(P,N,F){let M=this.wrapperMap.get(N);if(M==null?void 0:M.has(P))return M.get(P);M||(M=new WeakMap,this.wrapperMap.set(N,M));const B=new O(P,N,F);return M.set(P,B),B}static unwrap(P){return P instanceof O?P.actual:P}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var P,N;const F=this._cachedMatchesFilter;for(const B of this.actual.children.values()){const H=O.getWrapperForTestItem(B,this.filterDocument,this);H.hasNodeMatchingFilter?this.children.has(H.id)||this.addChild(H):H.dispose()}const M=this.children.size>0||((P=this.actual.uri)===null||P===void 0?void 0:P.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==F&&((N=this.actualParent)===null||N===void 0||N.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,v.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,v.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=O,O.wrapperMap=new WeakMap;class $ extends t.IncrementalChangeCollector{constructor(P){super();this.emitter=P,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(P){this.added.add(P)}update(P){Object.assign(P.revived,S.TestItem.toPlain(P.item)),this.added.has(P)||this.updated.add(P)}remove(P){if(this.added.has(P)){this.added.delete(P);return}if(this.updated.delete(P),P.parent&&this.alreadyRemoved.has(P.parent)){this.alreadyRemoved.add(P.item.extId);return}this.removed.add(P)}getChangeEvent(){const{added:P,updated:N,removed:F}=this;return{get added(){return[...P].map(M=>M.revived)},get updated(){return[...N].map(M=>M.revived)},get removed(){return[...F].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ie extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(P){let N=[];for(const F of P){const M=this.items.get(F);M&&N.push(M.revived)}return N}getMirroredTestDataById(P){return this.items.get(P)}getMirroredTestDataByReference(P){return this.items.get(P.id)}createItem(P,N){return Object.assign(Object.assign({},P),{revived:S.TestItem.toPlain(P.item),depth:N?N.depth+1:0,children:new Set})}createChangeCollector(){return new $(this.changeEmitter)}}e.MirroredTestCollection=ie;class se{constructor(){this.resources=new Map}checkout(P){var N,F;const M=P.toString(),B=(N=this.resources.get(M))!==null&&N!==void 0?N:this.createObserverData(P);return(F=B.pendingDeletion)===null||F===void 0||F.dispose(),B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return B.tests.rootTestItems},dispose:(0,k.once)(()=>{--B.observers||(B.pendingDeletion=this.eventuallyDispose(P))})}}getMirroredTestDataByReference(P){for(const{tests:N}of this.resources.values()){const F=N.getMirroredTestDataByReference(P);if(F)return F}}eventuallyDispose(P){return(0,R.disposableTimeout)(()=>this.unlisten(P),10*1e3)}createObserverData(P){const N=new ie,F=this.listen(P,B=>N.apply(B)),M={observers:0,tests:N,listener:F};return this.resources.set(P.toString(),M),M}unlisten(P){var N;const F=P.toString(),M=this.resources.get(F);M&&(M.observers=-1,(N=M.pendingDeletion)===null||N===void 0||N.dispose(),M.listener.dispose(),this.resources.delete(F))}}class U extends se{constructor(P){super();this.proxy=P,this.diffListeners=new Map}acceptDiff(P,N){var F;(F=this.diffListeners.get(P.toString()))===null||F===void 0||F(N)}listen(P,N){this.proxy.$subscribeToDiffs(0,P);const F=P.toString();return this.diffListeners.set(F,N),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,P),this.diffListeners.delete(F)})}}class V extends se{constructor(P,N){super();this.proxy=P,this.documents=N,this.diffListeners=new Map}acceptDiff(P,N){var F;(F=this.diffListeners.get(P.toString()))===null||F===void 0||F(N)}listen(P,N){if(!this.documents.getDocument(P))return new u.Disposable(()=>{});const M=P.toString();return this.diffListeners.set(M,N),this.proxy.$subscribeToDiffs(1,P),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,P),this.diffListeners.delete(M)})}}}),define(ge[258],pe([0,1,16,52,30,77,22,10,9,24,8,12,2,142,172,84,61,210,256,31]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E,v,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(_,b,l,L){this.configurationService=_,this.workspaceContextService=b,this.editorGroupsService=l,this.pathService=L}text(_,b,l={}){_=this.getContentPattern(_,l);const L=this.configurationService.getValue(),O=b&&b.some(ie=>!this.configurationService.getValue({resource:ie}).search.useRipgrep),$=this.commonQuery(b==null?void 0:b.map(E.toWorkspaceFolder),l);return Object.assign(Object.assign({},$),{type:2,contentPattern:_,previewOptions:l.previewOptions,maxFileSize:l.maxFileSize,usePCRE2:L.search.usePCRE2||O||!1,beforeContext:l.beforeContext,afterContext:l.afterContext,userDisabledExcludesAndIgnoreFiles:l.disregardExcludeSettings&&l.disregardIgnoreFiles})}getContentPattern(_,b){const l=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const L=Object.assign(Object.assign({},_),{wordSeparators:l.editor.wordSeparators});return this.isCaseSensitive(_,b)&&(L.isCaseSensitive=!0),this.isMultiline(_)&&(L.isMultiline=!0),L}file(_,b={}){const l=this.commonQuery(_,b);return Object.assign(Object.assign({},l),{type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey})}handleIncludeExclude(_,b){return _?(_=Array.isArray(_)?_.map(r):r(_),b?this.parseSearchPaths(_):{pattern:t(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],b={}){const l=this.handleIncludeExclude(b.includePattern,b.expandPatterns),L=this.handleIncludeExclude(b.excludePattern,b.expandPatterns),O=_.length>1,$=(l.searchPaths&&l.searchPaths.length?l.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,b,L)):_.map(U=>this.getFolderQueryForRoot(U,b,L,O))).filter(U=>!!U),ie={_reason:b._reason,folderQueries:$,usingSearchPaths:!!(l.searchPaths&&l.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:L.pattern,includePattern:l.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const V=w.coalesce(w.flatten(this.editorGroupsService.groups.map(P=>P.editors.map(N=>N.resource)))).filter(P=>(0,u.pathIncludedInQuery)(ie,P.fsPath)),W=this.commonQueryFromFileList(V);return Object.assign(Object.assign({},ie),W)}const se=b.extraFileResources&&b.extraFileResources.filter(U=>(0,u.pathIncludedInQuery)(ie,U.fsPath));return ie.extraFileResources=se&&se.length?se:void 0,ie}commonQueryFromFileList(_){const b=[],l=new y.ResourceMap,L={};let O=!1;return _.forEach($=>{var ie,se;if($.scheme===k.Schemas.walkThrough)return;if((0,I.isAbsolutePath)($)){const V=(se=(ie=this.workspaceContextService.getWorkspaceFolder($))===null||ie===void 0?void 0:ie.uri)!==null&&se!==void 0?se:$.with({path:D.dirname($.fsPath)});let W=l.get(V);W||(O=!0,W={folder:V,includePattern:{}},b.push(W),l.set(V,W));const P=D.relative(V.fsPath,$.fsPath);(0,A.assertIsDefined)(W.includePattern)[P.replace(/\\/g,"/")]=!0}else $.fsPath&&(O=!0,L[$.fsPath]=!0)}),{folderQueries:b,includePattern:L,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(_,b){if(b.isSmartCase){if(_.isRegExp){if(i.containsUppercaseCharacter(_.pattern,!0))return!0}else if(i.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,p.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const b=W=>D.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),L=(Array.isArray(_)?_:n(_)).map(W=>{const P=this.pathService.resolvedUserHome;return P?(0,T.untildify)(W,P.scheme===k.Schemas.file?P.fsPath:P.path):W}),O=R.groupBy(L,W=>b(W)?"searchPaths":"exprSegments"),$=(O.exprSegments||[]).map(W=>i.rtrim(W,"/")).map(W=>i.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),s(W))),ie={},se=this.expandSearchPathPatterns(O.searchPaths||[]);se&&se.length&&(ie.searchPaths=se);const U=w.flatten($),V=t(...U);return V&&(ie.pattern=V),ie}getExcludesForFolder(_,b){return b.disregardExcludeSettings?void 0:(0,u.getExcludes)(_,!b.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const b=w.flatten(_.map(L=>{let{pathPortion:O,globPortion:$}=c(L);$&&($=o($));const ie=this.expandOneSearchPath(O);return w.flatten(ie.map(se=>this.resolveOneSearchPathPattern(se,$)))})),l=new Map;return b.forEach(L=>{const O=L.searchPath.toString(),$=l.get(O);$?L.pattern&&($.pattern=$.pattern||{},$.pattern[L.pattern]=!0):l.set(O,{searchPath:L.searchPath,pattern:L.pattern?t(L.pattern):void 0})}),Array.from(l.values())}expandOneSearchPath(_){if(D.isAbsolute(_)){const b=this.workspaceContextService.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==k.Schemas.file?[{searchPath:b[0].uri.with({path:_})}]:[{searchPath:d.URI.file(D.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const b=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=r(_),_.startsWith("../")||_===".."){const L=D.posix.resolve(b.path,_);return[{searchPath:b.with({path:L})}]}const l=o(_);return[{searchPath:b,pattern:l}]}else{if(_==="./"||_===".\\")return[];{const b=_.replace(/^\.[\/\\]/,""),L=this.workspaceContextService.getWorkspace().folders.map(O=>{const $=b.match(new RegExp(`^${O.name}(?:/(.*))?`));return $?{match:$,folder:O}:null}).filter(A.isDefined);if(L.length)return L.map(O=>{const $=O.match[1];return{searchPath:O.folder.uri,pattern:$&&o($)}});{const O=_.match(/\.[\/\\](.+)[\/\\]?/),$=O?O[1]:_,ie=a.localize(0,null,$);throw new Error(ie)}}}}resolveOneSearchPathPattern(_,b){const l=_.pattern&&b?`${_.pattern}/${b}`:_.pattern||b,L=[{searchPath:_.searchPath,pattern:l}];return l&&!l.endsWith("**")&&L.push({searchPath:_.searchPath,pattern:l+"/**"}),L}getFolderQueryForSearchPath(_,b,l){const L=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(_.searchPath),b,l,!1);return L?Object.assign(Object.assign({},L),{includePattern:_.pattern}):null}getFolderQueryForRoot(_,b,l,L){let O;const $=d.URI.isUri(_)?_:_.uri;if(l.searchPaths){const W=l.searchPaths.filter(P=>(0,I.isEqual)(P.searchPath,$))[0];if(W&&!W.pattern)return null;W&&(O=W.pattern)}const ie=this.configurationService.getValue({resource:$}),se=this.getExcludesForFolder(ie,b),U=Object.assign(Object.assign({},se||{}),O||{}),V=d.URI.isUri(_)?(0,I.basename)(_):_.name;return{folder:$,folderName:L?V:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:ie.files&&ie.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!ie.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!ie.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!ie.search.followSymlinks}}};f=Ve([He(0,h.IConfigurationService),He(1,E.IWorkspaceContextService),He(2,v.IEditorGroupsService),He(3,S.IPathService)],f),e.QueryBuilder=f;function c(m){const _=m.match(/[\*\{\}\(\)\[\]\?]/);if(_){const b=_.index,l=m.substr(0,b).match(/[/|\\][^/\\]*$/);if(l){let L=m.substr(0,l.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:m.substr((l.index||0)+1)}}}return{pathPortion:m}}function t(...m){return m.length?m.reduce((_,b)=>(_[b]=!0,_),Object.create(null)):void 0}function n(m){return C.splitGlobAware(m,",").map(_=>_.trim()).filter(_=>!!_.length)}function s(m){return[`**/${m}/**`,`**/${m}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function r(m){return m.replace(/\\/g,"/")}function o(m){return r(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(m,_){m=w.distinct(m,L=>L.toString());const b=[],l=_.getWorkspace();return m&&m.forEach(L=>{let O;if(_.getWorkbenchState()===2)O=(0,I.relativePath)(l.folders[0].uri,L),O&&O!=="."&&(O="./"+O);else{const $=_.getWorkspaceFolder(L);if($){const ie=$.name;if(l.folders.filter(U=>U.name===ie).length===1){const U=(0,I.relativePath)($.uri,L);U===""?O=`./${$.name}`:O=`./${$.name}/${U}`}else O=L.fsPath}}O&&b.push(O)}),b}e.resolveResourcesForSearchIncludes=g}),define(ge[259],pe([0,1,24,2,21,17,4,258,31,61]),function(G,e,w,R,C,T,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function A(h,E){const v=E.activationEvents;if(!v)return Promise.resolve(void 0);const S=[],u=[];for(const r of v)if(/^workspaceContains:/.test(r)){const o=r.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||h.forceUsingSearch?u.push(o):S.push(o)}if(S.length===0&&u.length===0)return Promise.resolve(void 0);let f;const c=new Promise((r,o)=>{f=r}),t=r=>f({activationEvent:r}),n=Promise.all(S.map(r=>d(h,r,t))).then(()=>{}),s=p(h,E.identifier,u,t);return Promise.all([n,s]).then(()=>{f(void 0)}),c}e.checkActivateWorkspaceContainsExtension=A;async function d(h,E,v){for(const S of h.folders)if(await h.exists(w.joinPath(R.URI.revive(S),E))){v(`workspaceContains:${E}`);return}}async function p(h,E,v,S){if(v.length===0)return Promise.resolve(void 0);const u=new C.CancellationTokenSource,f=h.checkExists(h.folders,v,u.token),c=setTimeout(async()=>{u.cancel(),S(`workspaceContainsTimeout:${v.join(",")}`)},i);let t=!1;try{t=await f}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}u.dispose(),clearTimeout(c),t&&S(`workspaceContains:${v.join(",")}`)}function a(h,E,v,S){const u=h.get(y.IInstantiationService),f=h.get(D.ISearchService),t=u.createInstance(k.QueryBuilder).file(E.map(n=>(0,I.toWorkspaceFolder)(R.URI.revive(n))),{_reason:"checkExists",includePattern:v,exists:!0});return f.fileSearch(t,S).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=a});var nt=this&&this.__classPrivateFieldSet||function(G,e,w,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!C:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(G,w):C?C.value=w:e.set(G,w),w},Be=this&&this.__classPrivateFieldGet||function(G,e,w,R){if(w==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!R:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?R:w==="a"?R.call(G):R?R.value:e.get(G)};define(ge[41],pe([0,1,162,9,70,24,13,6,22,2,14,5,35,220,90,34,39,218,17,26,23,196,7,116,4,27,91,15,82,48,33,3,259,88,197]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E,v,S,u,f,c,t,n,s,r,o,g,m,_,b,l,L,O,$){"use strict";var ie,se,U;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let V=class Bn extends k.Disposable{constructor(F,M,B,H,Q,le,be,Te,ke,Ne){super();this._onDidChangeRemoteConnectionData=this._register(new l.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=B,this._initData=be,this._extHostWorkspace=H,this._extHostConfiguration=Q,this._logService=le,this._extHostTunnelService=ke,this._extHostTerminalService=Ne,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(A.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(A.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(A.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new v.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=F.createChild(new m.ServiceCollection([a.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const Ke=new Set;this._initData.hostExtensions.forEach(ze=>Ke.add(u.ExtensionIdentifier.toKey(ze))),this._activator=new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,qe,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,S.transformErrorForSerialization(qe),q)},actualActivateExtension:async(ze,qe)=>{if(Ke.has(u.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,qe),new p.HostExtension;const q=this._registry.getExtensionDescription(ze);return this._activateExtension(q,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){S.onUnexpectedError(F)}}async deactivateAll(){let F=[];try{F=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(M){}await Promise.all(F)}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}_activateByEvent(F,M){return this._activator.activateByEvent(F,M)}_activateById(F,M){return this._activator.activateById(F,M)}activateByIdWithErrors(F,M){return this._activateById(F,M).then(()=>{const B=this._activator.getActivatedExtension(F);if(B.activationFailed)return Promise.reject(B.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._registry)}getExtensionExports(F){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(F).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const F=D.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map(B=>{if(!!this._getEntryPoint(B))return this._hostUtils.realpath(B.extensionLocation.fsPath).then(H=>F.set(I.URI.file(H).fsPath,B))});this._extensionPathIndex=Promise.all(M).then(()=>F)}return this._extensionPathIndex}_deactivate(F){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return M;const B=this._activator.getActivatedExtension(F);if(!B)return M;try{typeof B.module.deactivate=="function"&&(M=Promise.resolve(B.module.deactivate()).then(void 0,H=>(this._logService.error(H),Promise.resolve(void 0))))}catch(H){this._logService.error(H)}try{(0,k.dispose)(B.subscriptions)}catch(H){this._logService.error(H)}return M}async _activateExtension(F,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,M).then(B=>{const H=B.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,H.codeLoadingTime,H.activateCallTime,H.activateResolvedTime,M),this._logExtensionActivationTimes(F,M,"success",H),B},B=>{throw this._logExtensionActivationTimes(F,M,"failure"),B})}_logExtensionActivationTimes(F,M,B,H){const Q=W(F,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},Q),H||{}),{outcome:B}))}_doActivateExtension(F,M){const B=W(F,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",B);const H=this._getEntryPoint(F);if(!H)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const Q=new p.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(F.identifier,(0,T.joinPath)(F.extensionLocation,H),Q),this._loadExtensionContext(F)]).then(le=>(C.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),Bn._callActivate(this._logService,F.identifier,le[0],le[1],Q))).then(le=>(C.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),le))}_loadExtensionContext(F){const M=new c.ExtensionGlobalMemento(F,this._storage),B=new c.ExtensionMemento(F.identifier.value,!1,this._storage),H=new $.ExtensionSecrets(F,this._secretState),Q=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([M.whenReady,B.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let Te;return Object.freeze({globalState:M,workspaceState:B,secrets:H,subscriptions:[],get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(ke){return R.join(F.extensionLocation.fsPath,ke)},get storagePath(){var ke;return(ke=be._storagePath.workspaceValue(F))===null||ke===void 0?void 0:ke.fsPath},get globalStoragePath(){return be._storagePath.globalValue(F).fsPath},get logPath(){return R.join(be._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return I.URI.joinPath(be._initData.logsLocation,F.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(F)},get globalStorageUri(){return be._storagePath.globalValue(F)},get extensionMode(){return Q},get extension(){return Te===void 0&&(Te=new P(be,F.identifier,F,le)),Te},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(F),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(F)}})})}static _callActivate(F,M,B,H,Q){return B=B||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,M,B,H,Q).then(le=>new p.ActivatedExtension(!1,null,Q.build(),B,le,H.subscriptions))}static _callActivateOptional(F,M,B,H,Q){if(typeof B.activate=="function")try{Q.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${M.value}`);const le=typeof global=="object"?global:self,be=B.activate.apply(le,[H]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(be).then(Te=>(Q.activateResolveStop(),Te))}catch(le){return Promise.reject(le)}else return Promise.resolve(B)}_activateOneStartupFinished(F,M){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:M}).then(void 0,B=>{this._logService.error(B)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const F of this._registry.getAllExtensionDescriptions())if(F.activationEvents)for(const M of F.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(F,M)}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],B=this._handleWorkspaceContainsEagerExtensions(M),H=Promise.all([F,B]).then(()=>{});return Promise.race([H,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),H}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(F,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,M){if(this.isActivated(M.identifier))return;const B=!this._initData.remote.isRemote&&!!this._initData.remote.authority,H={folders:F.map(le=>le.uri),forceUsingSearch:B,exists:le=>this._hostUtils.exists(le.fsPath),checkExists:(le,be,Te)=>this._mainThreadWorkspaceProxy.$checkExists(le,be,Te)},Q=await(0,L.checkActivateWorkspaceContainsExtension)(H,M);if(!!Q)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:Q.activationEvent}).then(void 0,le=>this._logService.error(le))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:M}=this._initData.environment;if(!F||!M)throw new Error(w.localize(0,null));const B=await this._loadCommonJSModule(null,M,new p.ExtensionActivationTimesBuilder(!1));if(!B||typeof B.run!="function")throw new Error(w.localize(1,null,M.toString()));return new Promise((H,Q)=>{const le=(ke,Ne)=>{ke?Q(ke):H(typeof Ne=="number"&&Ne>0?1:0)},be=(0,T.originalFSPath)(M),Te=B.run(be,le);Te&&Te.then&&Te.then(()=>{H(0)}).catch(ke=>{Q(ke.toString())})})}async $extensionTestsExit(F){this._logService.info(`extension host terminating: test runner requested exit with code ${F}`),this._logService.info(`exiting with code ${F}`),this._logService.flush(),this._hostUtils.exit(F)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(F,M){return this._resolvers[F]=M,(0,k.toDisposable)(()=>{delete this._resolvers[F]})}async _activateAndGetResolver(F){const M=F.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const B=F.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${B}`,!1),{authorityPrefix:B,resolver:this._resolvers[B]}}async $resolveAuthority(F,M){const{authorityPrefix:B,resolver:H}=await this._activateAndGetResolver(F);if(!H)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${B}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(H)),C.mark(`code/extHost/willResolveAuthority/${B}`);const Q=await H.resolve(F,{resolveAttempt:M});C.mark(`code/extHost/didResolveAuthorityOK/${B}`);const le={authority:F,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},be={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted};return{type:"ok",value:{authority:le,options:be,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(C.mark(`code/extHost/didResolveAuthorityError/${B}`),Q instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(F,M){const{authorityPrefix:B,resolver:H}=await this._activateAndGetResolver(F);if(!H)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${B}`);const Q=I.URI.revive(M);if(typeof H.getCanonicalURI=="undefined")return Q;const le=await(0,y.asPromise)(()=>H.getCanonicalURI(Q));return le||Q}$startExtensionHost(F){return this._registry.keepOnly(F),this._startExtensionHost()}$activateByEvent(F,M){return M===1?this._activateByEvent(F,!1):this._readyToRunExtensions.wait().then(B=>this._activateByEvent(F,!1))}async $activate(F,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(F)?(await this._activateById(F,M),!0):!1}async $deltaExtensions(F,M){F.forEach(H=>H.extensionLocation=I.URI.revive(H.extensionLocation));const B=await this.getExtensionPathIndex();return await Promise.all(M.map(async H=>{const Q=this._registry.getExtensionDescription(H);if(!Q)return;const le=await this._hostUtils.realpath(Q.extensionLocation.fsPath);B.delete(I.URI.file(le).fsPath)})),await Promise.all(F.map(async H=>{const Q=await this._hostUtils.realpath(H.extensionLocation.fsPath);B.set(I.URI.file(Q).fsPath,H)})),this._registry.deltaExtensions(F,M),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){let M=f.VSBuffer.alloc(F),B=Math.random()%256;for(let H=0;H<F;H++)M.writeUInt8(B,H);return M}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};V=Ve([He(0,s.IInstantiationService),He(1,e.IHostUtils),He(2,g.IExtHostRpcService),He(3,h.IExtHostWorkspace),He(4,d.IExtHostConfiguration),He(5,i.ILogService),He(6,r.IExtHostInitDataService),He(7,o.IExtensionStoragePaths),He(8,_.IExtHostTunnelService),He(9,b.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function W(N,F){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class P{constructor(F,M,B,H){ie.set(this,void 0),se.set(this,void 0),U.set(this,void 0),nt(this,ie,F,"f"),nt(this,se,M,"f"),nt(this,U,B.identifier,"f"),this.id=B.identifier.value,this.extensionUri=B.extensionLocation,this.extensionPath=R.normalize((0,T.originalFSPath)(B.extensionLocation)),this.packageJSON=B,this.extensionKind=H}get isActive(){return Be(this,ie,"f").isActivated(Be(this,U,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,ie,"f").getExtensionExports(Be(this,U,"f"))}activate(){return Be(this,ie,"f").activateByIdWithErrors(Be(this,U,"f"),{startup:!1,extensionId:Be(this,se,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=P,ie=new WeakMap,se=new WeakMap,U=new WeakMap}),define(ge[50],pe([0,1,9,2,3,13,5,7,121,34,41,40,209,35,204,15,4,12,36,47]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E,v,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let f=class{constructor(m,_,b,l,L,O){this._workspaceService=_,this._extensionService=b,this._editorsService=l,this._configurationService=L,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=m.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then($=>{$.onDidChange(ie=>{this.registerAllDebugTypes($)}),this.registerAllDebugTypes($)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,_){const b=m;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let l=`debug:${encodeURIComponent(b.path||"")}`,L="?";return _&&(l+=`${L}session=${encodeURIComponent(_.id)}`,L="&"),l+=`${L}ref=${b.sourceReference}`,R.URI.parse(l)}else{if(b.path)return R.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const _=[];for(const b of m.getAllExtensionDescriptions())if(b.contributes){const l=b.contributes.debuggers;if(l&&l.length>0)for(const L of l)(0,a.isDebuggerMainContribution)(L)&&_.push(L.type)}this._debugServiceProxy.$registerDebugTypes(_)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(_=>m.push(_)),m}addBreakpoints(m){this.startBreakpoints();const _=m.filter(L=>{const O=L.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,L),!0)});this.fireBreakpointChanges(_,[],[]);const b=[],l=new Map;for(const L of _)if(L instanceof k.SourceBreakpoint){let O=l.get(L.location.uri.toString());O||(O={type:"sourceMulti",uri:L.location.uri,lines:[]},l.set(L.location.uri.toString(),O),b.push(O)),O.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character})}else L instanceof k.FunctionBreakpoint&&b.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName});return this._debugServiceProxy.$registerBreakpoints(b)}removeBreakpoints(m){this.startBreakpoints();const _=m.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],_,[]);const b=_.filter(O=>O instanceof k.SourceBreakpoint).map(O=>O.id),l=_.filter(O=>O instanceof k.FunctionBreakpoint).map(O=>O.id),L=_.filter(O=>O instanceof k.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(b,l,L)}startDebugging(m,_,b){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,_,{parentSessionID:b.parentSession?b.parentSession.id:void 0,repl:b.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,_,b){if(!_)return new k.Disposable(()=>{});const l=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:l,provider:_}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,b,!!_.provideDebugConfigurations,!!_.resolveDebugConfiguration,!!_.resolveDebugConfigurationWithSubstitutedVariables,l),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(L=>L.provider!==_),this._debugServiceProxy.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(m,_,b){if(!b)return new k.Disposable(()=>{});if(!this.definesDebugType(m,_))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${_}' debugger.`);if(this.getAdapterDescriptorFactoryByType(_))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:_,handle:l,factory:b}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(_,l),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(L=>L.factory!==b),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(m,_){if(!_)return new k.Disposable(()=>{});const b=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:b,factory:_}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(l=>l.factory!==_)})}async $runInTerminal(m,_){return Promise.resolve(void 0)}async $substituteVariables(m,_){if(!this._variableResolver){const[L,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(L||[],this._editorsService,O)}let b;const l=await this.getFolder(m);return l&&(b={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(b,_)}createDebugAdapter(m,_){if(m.type==="implementation")return new r(m.implementation)}createSignService(){}async $startDASession(m,_){const b=this,l=await this.getSession(_);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(l.type),l).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const O=this.convertToDto(L),$=this.createDebugAdapter(O,l);if(!$)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const ie=$;return this._debugAdapters.set(m,ie),this.getDebugAdapterTrackers(l).then(se=>(se&&this._debugAdaptersTrackers.set(m,se),ie.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const V=U,W={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const P=await this._signService.sign(V.arguments.value);W.body={signature:P},ie.sendResponse(W)}else throw new Error("no signer")}catch(P){W.success=!1,W.message=P.message,ie.sendResponse(W)}}else se&&se.onDidSendMessage&&se.onDidSendMessage(U),U=(0,a.convertToVSCPaths)(U,!0),b._debugServiceProxy.$acceptDAMessage(m,U)}),ie.onError(U=>{se&&se.onError&&se.onError(U),this._debugServiceProxy.$acceptDAError(m,U.name,U.message,U.stack)}),ie.onExit(U=>{se&&se.onExit&&se.onExit((0,v.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(m,(0,v.withNullAsUndefined)(U),void 0)}),se&&se.onWillStartSession&&se.onWillStartSession(),ie.startSession()))})}$sendDAMessage(m,_){_=(0,a.convertToDAPaths)(_,!1);const b=this._debugAdaptersTrackers.get(m);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(_);const l=this._debugAdapters.get(m);l&&l.sendMessage(_)}$stopDASession(m){const _=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),_&&_.onWillStopSession&&_.onWillStopSession();const b=this._debugAdapters.get(m);return this._debugAdapters.delete(m),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const _=[],b=[],l=[];if(m.added)for(const L of m.added){const O=L.id;if(O&&!this._breakpoints.has(O)){let $;if(L.type==="function")$=new k.FunctionBreakpoint(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage);else if(L.type==="data")$=new k.DataBreakpoint(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage);else{const ie=R.URI.revive(L.uri);$=new k.SourceBreakpoint(new k.Location(ie,new k.Position(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage)}$._id=O,this._breakpoints.set(O,$),_.push($)}}if(m.removed)for(const L of m.removed){const O=this._breakpoints.get(L);O&&(this._breakpoints.delete(L),b.push(O))}if(m.changed){for(const L of m.changed)if(L.id){const O=this._breakpoints.get(L.id);if(O){if(O instanceof k.FunctionBreakpoint&&L.type==="function"){const $=O;$.enabled=L.enabled,$.condition=L.condition,$.hitCondition=L.hitCondition,$.logMessage=L.logMessage,$.functionName=L.functionName}else if(O instanceof k.SourceBreakpoint&&L.type==="source"){const $=O;$.enabled=L.enabled,$.condition=L.condition,$.hitCondition=L.hitCondition,$.logMessage=L.logMessage,$.location=new k.Location(R.URI.revive(L.uri),new k.Position(L.line,L.character))}l.push(O)}}}this.fireBreakpointChanges(_,b,l)}$provideDebugConfigurations(m,_,b){return(0,T.asPromise)(async()=>{const l=this.getConfigProviderByHandle(m);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.getFolder(_);return l.provideDebugConfigurations(L,b)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(m,_,b,l){return(0,T.asPromise)(async()=>{const L=this.getConfigProviderByHandle(m);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(_);return L.resolveDebugConfiguration(O,b,l)})}$resolveDebugConfigurationWithSubstitutedVariables(m,_,b,l){return(0,T.asPromise)(async()=>{const L=this.getConfigProviderByHandle(m);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(_);return L.resolveDebugConfigurationWithSubstitutedVariables(O,b,l)})}async $provideDebugAdapter(m,_){const b=this.getAdapterDescriptorFactoryByHandle(m);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.getSession(_);return this.getAdapterDescriptor(b,l).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.convertToDto(L)})}async $acceptDebugSessionStarted(m){const _=await this.getSession(m);this._onDidStartDebugSession.fire(_)}async $acceptDebugSessionTerminated(m){const _=await this.getSession(m);_&&(this._onDidTerminateDebugSession.fire(_),this._debugSessions.delete(_.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,_){const b=await this.getSession(m);b&&b._acceptNameChanged(_)}async $acceptDebugSessionCustomEvent(m,_){const l={session:await this.getSession(m),event:_.event,body:_.body};this._onDidReceiveDebugSessionCustomEvent.fire(l)}convertToDto(m){if(m instanceof k.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof k.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const _=this._adapterFactories.filter(b=>b.type===m);if(_.length>0)return _[0].factory}getAdapterDescriptorFactoryByHandle(m){const _=this._adapterFactories.filter(b=>b.handle===m);if(_.length>0)return _[0].factory}getConfigProviderByHandle(m){const _=this._configProviders.filter(b=>b.handle===m);if(_.length>0)return _[0].provider}definesDebugType(m,_){if(m.contributes){const b=m.contributes.debuggers;if(b&&b.length>0){for(const l of b)if(l.label&&l.type&&l.type===_)return!0}}return!1}getDebugAdapterTrackers(m){const b=m.configuration.type,l=this._trackerFactories.filter(L=>L.type===b||L.type==="*").map(L=>(0,T.asPromise)(()=>L.factory.createDebugAdapterTracker(m)).then(O=>O,O=>null));return Promise.race([Promise.all(l).then(L=>{const O=L.filter($=>!!$);if(O.length>0)return new s(O)}),new Promise((L,O)=>{const $=setTimeout(()=>{clearTimeout($),O(new Error("timeout"))},1e3)})]).catch(L=>{})}async getAdapterDescriptor(m,_){const b=_.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new k.DebugAdapterServer(b));if(m){const L=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>m.createDebugAdapterDescriptor(_,this.daExecutableFromPackage(_,L))).then(O=>{if(O)return O})}const l=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(_,l))}daExecutableFromPackage(m,_){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,_,b){(m.length>0||_.length>0||b.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:_,changed:b}))}async getSession(m){if(m)if(typeof m=="string"){const _=this._debugSessions.get(m);if(_)return _}else{let _=this._debugSessions.get(m.id);if(!_){const b=await this.getFolder(m.folderUri),l=m.parent?this._debugSessions.get(m.parent):void 0;_=new c(this._debugServiceProxy,m.id,m.type,m.name,b,m.configuration,l),this._debugSessions.set(_.id,_),this._debugServiceProxy.$sessionCached(_.id)}return _}throw new Error("cannot find session")}getFolder(m){if(m){const _=R.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(_)}return Promise.resolve(void 0)}};f=Ve([He(0,h.IExtHostRpcService),He(1,I.IExtHostWorkspace),He(2,i.IExtHostExtensionService),He(3,A.IExtHostDocumentsAndEditors),He(4,p.IExtHostConfiguration),He(5,u.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class c{constructor(m,_,b,l,L,O,$){this._debugServiceProxy=m,this._id=_,this._type=b,this._name=l,this._workspaceFolder=L,this._configuration=O,this._parentSession=$}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,_){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,_)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=c;class t{constructor(m){this.value=Object.freeze({append(_){m.$appendDebugConsole(_)},appendLine(_){this.append(_+`
`)}})}}e.ExtHostDebugConsole=t;class n extends d.AbstractVariableResolverService{constructor(m,_,b,l,L){function O(){if(_){const $=_.activeEditor();if($)return $.document.uri;const ie=l.tabs.filter(se=>se.isActive);if(ie.length>0)return ie[0].resource}}super({getFolderUri:$=>{const ie=m.filter(se=>se.name===$);if(ie&&ie.length>0)return ie[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:($,ie)=>b.getConfiguration(void 0,$).get(ie),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=O();if($)return w.normalize($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(L){const $=O();if($){const ie=L.getWorkspaceFolder($);if(ie)return w.normalize(ie.uri.fsPath)}}},getSelectedText:()=>{if(_){const $=_.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(_){const $=_.activeEditor();if($)return String($.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=n;class s{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(_=>_.onWillReceiveMessage?_.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(_=>_.onDidSendMessage?_.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(_=>_.onError?_.onError(m):void 0)}onExit(m,_){this.trackers.forEach(b=>b.onExit?b.onExit(m,_):void 0)}}class r extends D.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(_=>{this.acceptMessage(_)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends f{constructor(m,_,b,l,L,O){super(m,_,b,l,L,O)}createVariableResolver(m,_,b){return new n(m,_,b,this._editorTabs)}};o=Ve([He(0,h.IExtHostRpcService),He(1,I.IExtHostWorkspace),He(2,i.IExtHostExtensionService),He(3,A.IExtHostDocumentsAndEditors),He(4,p.IExtHostConfiguration),He(5,u.IExtHostEditorTabs)],o),e.WorkerExtHostDebugService=o}),define(ge[260],pe([0,1,70,2,5,35,39,26,15,27,4,41,36,14]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(u,f,c,t,n,s,r){this._apiFactory=u,this._extensionRegistry=f,this._instaService=c,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=s,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),w.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,f,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,f,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let f of u.nodeModuleName)this._factories.set(f,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(f=>u.alternativeModuleName(f))}};a=Ve([He(2,i.IInstantiationService),He(3,T.IExtHostConfiguration),He(4,A.IExtHostExtensionService),He(5,I.IExtHostInitDataService),He(6,p.ILogService)],a),e.RequireInterceptor=a;class h{constructor(u,f,c,t,n){this._apiFactory=u,this._extensionPaths=f,this._extensionRegistry=c,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,f){const c=this._extensionPaths.findSubstr(f.fsPath);if(c){let t=this._extApiImpl.get(k.ExtensionIdentifier.toKey(c.identifier));return t||(t=this._apiFactory(c,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(c.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,s)=>t+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(u,f){this.nodeModuleName="keytar";const{environment:c}=f,t=u.getProxy(C.MainContext.MainThreadKeytar);if(c.appRoot){let n=c.appRoot.fsPath;d.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,s)=>t.$getPassword(n,s),setPassword:(n,s,r)=>t.$setPassword(n,s,r),deletePassword:(n,s)=>t.$deletePassword(n,s),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(u,f){return this._impl}alternativeModuleName(u){const f=u.length;if(f<=7||!this.alternativeNames)return;const c=f-7;if((u.charAt(c)==="/"||u.charAt(c)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};E=Ve([He(0,D.IExtHostRpcService),He(1,I.IExtHostInitDataService)],E);let v=class{constructor(u,f,c){this._extensionPaths=u,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=c.getProxy(C.MainContext.MainThreadTelemetry);const t=c.getProxy(C.MainContext.MainThreadWindow);this._impl=(n,s)=>{const r=R.URI.parse(n);return s?this.callOriginal(n,s):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,s)}}load(u,f,c){const t=this._extensionPaths.findSubstr(f.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=c(u),this._impl}callOriginal(u,f){return this.sendNoForwardTelemetry(),this._original(u,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=Ve([He(2,D.IExtHostRpcService)],v)}),define(ge[261],pe([0,1,168,11,7,205,34,41,40,35,33,15,50,191,13,206,47]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let v=class extends d.ExtHostDebugServiceBase{constructor(f,c,t,n,s,r,o){super(f,c,t,n,s,o);this._terminalService=r,this._integratedTerminalInstances=new S}createDebugAdapter(f,c){switch(f.type){case"server":return new T.SocketDebugAdapter(f);case"pipeServer":return new T.NamedPipeDebugAdapter(f);case"executable":return new T.ExecutableDebugAdapter(f,c.type)}return super.createDebugAdapter(f,c)}daExecutableFromPackage(f,c){const t=T.ExecutableDebugAdapter.platformAdapterExecutable(c.getAllExtensionDescriptions(),f.type);if(t)return new C.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new p.SignService}async $runInTerminal(f,c){if(f.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),r=JSON.stringify({shell:n,shellArgs:s});let o=await this._integratedTerminalInstances.checkout(r),g,m=!1;if(o)g=f.cwd;else{const L={shellPath:n,shellArgs:s,cwd:f.cwd,name:f.title||w.localize(0,null)};m=!0,o=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(o,r)}o.show(!0);const _=await o.processId;m?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?o.sendText("cls"):n.indexOf("bash")>=0?o.sendText("clear"):R.isWindows?o.sendText("cls"):o.sendText("clear"));const b=(0,h.prepareCommand)(n,f.args,g,f.env);o.sendText(b);const l=this.onDidTerminateDebugSession(L=>{L.id===c&&(this._integratedTerminalInstances.free(o),l.dispose())});return _}else if(f.kind==="external")return(0,h.runInExternalTerminal)(f,await this._configurationService.getConfigProvider());return super.$runInTerminal(f,c)}createVariableResolver(f,c,t){return new d.ExtHostVariableResolverService(f,c,t,this._editorTabs,this._workspaceService)}};v=Ve([He(0,A.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,D.IExtHostDocumentsAndEditors),He(4,I.IExtHostConfiguration),He(5,i.IExtHostTerminalService),He(6,E.IExtHostEditorTabs)],v),e.ExtHostDebugService=v;class S{constructor(){this._terminalInstances=new Map}async checkout(f){const t=[...this._terminalInstances.entries()].map(([n,s])=>(0,a.createCancelablePromise)(async r=>{if(s.lastUsedAt!==-1&&await(0,h.hasChildProcesses)(await n.processId))return null;const o=Date.now();return s.lastUsedAt+S.minUseDelay>o||r.isCancellationRequested||s.config!==f?null:(s.lastUsedAt=o,n)}));return await(0,a.firstParallel)(t,n=>!!n)}insert(f,c){this._terminalInstances.set(f,{lastUsedAt:Date.now(),config:c})}free(f){const c=this._terminalInstances.get(f);c&&(c.lastUsedAt=-1)}onTerminalClosed(f){this._terminalInstances.delete(f)}}S.minUseDelay=1e3}),define(ge[262],pe([0,1,9,2,110,34,50,40,35,33,15,27,69,10,14,65,47]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let v=class extends d.ExtHostTaskBase{constructor(u,f,c,t,n,s,r,o,g){super(u,f,c,t,n,s,r,o);this.workspaceService=c,this.editorTabs=g,f.remote.isRemote&&f.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:f.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(u,f){const c=f;if(!f.execution&&c._id===void 0)throw new Error("Tasks to execute must include an execution");if(c._id!==void 0){const t=d.TaskHandleDTO.from(c,this.workspaceService),n=await this._proxy.$getTaskExecution(t);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(n,f);return this._proxy.$executeTask(t).catch(()=>{}),s}else{const t=d.TaskDTO.from(f,u);if(t===void 0)return Promise.reject(new Error("Task is not valid"));d.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,f,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),f);return this._proxy.$executeTask(t).catch(()=>{}),n}}provideTasksInternal(u,f,c,t){const n=[];if(t)for(let s of t){this.checkDeprecation(s,c),(!s.definition||!u[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const r=d.TaskDTO.from(s,c.extension);r&&(n.push(r),d.CustomExecutionDTO.is(r.execution)&&f.push(this.addCustomExecution(r,s,!0)))}return{tasks:n,extension:c.extension}}async resolveTaskInternal(u){return u}async getVariableResolver(u){if(this._variableResolver===void 0){const f=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(u,this._editorService,f,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(u,f){const c=R.URI.revive(u),t={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(c),s=await this._workspaceProvider.getWorkspaceFolders2();if(!s||!n)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const r=await this.getVariableResolver(s),o={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}};for(let g of f.variables)t.variables[g]=await r.resolveAsync(o,g);if(f.process!==void 0){let g;if(f.process.path!==void 0){g=f.process.path.split(w.delimiter);for(let m=0;m<g.length;m++)g[m]=await r.resolveAsync(o,g[m])}t.process=await C.win32.findExecutable(await r.resolveAsync(o,f.process.name),f.process.cwd!==void 0?await r.resolveAsync(o,f.process.cwd):void 0,g)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(u,f,c){return C.win32.findExecutable(u,f,c)}};v=Ve([He(0,i.IExtHostRpcService),He(1,A.IExtHostInitDataService),He(2,T.IExtHostWorkspace),He(3,k.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,a.ILogService),He(7,h.IExtHostApiDeprecationService),He(8,E.IExtHostEditorTabs)],v),e.ExtHostTask=v}),define(ge[263],pe([0,1,13,17,70,6,2,5,254,14,79,82,27,185,15,63,41,33]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(f,c,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new D.RPCProtocol(f,null,n),c=S._transform(c,this._rpcProtocol);const s=new A.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());s.set(d.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},c)),s.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),s.set(h.IURITransformerService,new h.URITransformerService(n)),s.set(E.IHostUtils,t);const r=new p.InstantiationService(s,!0),o=r.invokeFunction(b=>b.get(v.IExtHostTerminalService));this._disposables.add(o),this._logService=r.invokeFunction(b=>b.get(I.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",c),this._extensionService=r.invokeFunction(b=>b.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(l,L)=>{let O="",$,ie;for(const se of L)O+=`
	at ${se.toString()}`,ie=se.getFileName(),!$&&ie&&($=b.findSubstr(ie));return g.set(l,$),`${l.name||"Error"}: ${l.message||""}${O}`}});const m=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),_=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(b=>{const l=R.transformErrorForSerialization(b),L=g.get(b);L?m.$onExtensionRuntimeError(L.identifier,l):_.$onUnexpectedError(l)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const c=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,w.timeout)(4e3),c]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(f,c){f.extensions.forEach(n=>n.extensionLocation=y.URI.revive(c.transformIncomingURIs(n.extensionLocation))),f.environment.appRoot=y.URI.revive(c.transformIncomingURIs(f.environment.appRoot));const t=f.environment.extensionDevelopmentLocationURI;return t&&(f.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(c.transformIncomingURIs(n)))),f.environment.extensionTestsLocationURI=y.URI.revive(c.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=y.URI.revive(c.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=y.URI.revive(c.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=y.URI.revive(c.transformIncomingURIs(f.logsLocation)),f.logFile=y.URI.revive(c.transformIncomingURIs(f.logFile)),f.workspace=c.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=S}),define(ge[264],pe([0,1,9,21,60,30,24,44,31]),function(G,e,w,R,C,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(d,p,a){this.config=d,this.provider=p,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&T.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&T.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const p=this.config.folderQueries||[];return new Promise((a,h)=>{const E=v=>{this.resultCount++,d(v)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(v=>{const S=v.toString(),u=w.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,u)||this.matchFile(E,{base:v,basename:u})}),Promise.all(p.map(v=>this.searchInFolder(v,E))).then(v=>{a({limitHit:this.isLimitHit,stats:v[0]||void 0})},v=>{h(new Error((0,C.toErrorMessage)(v)))})})}async searchInFolder(d,p){const a=new R.CancellationTokenSource,h=this.getSearchOptionsForFolder(d),E=this.initDirectoryTree(),v=new D.QueryGlobTester(this.config,d),S=!v.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(a),u=k.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,a.token),c=u.elapsed(),t=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(n=>{const s=w.posix.relative(d.folder.path,n.path);if(S){const r=w.basename(n.path);this.matchFile(p,{base:d.folder,relativePath:s,basename:r});return}this.addDirectoryEntries(E,d.folder,s,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,v,p),{providerTime:c,postProcessTime:t.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(d){const p=(0,D.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:a,includes:p,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},p,a,h){if(a===this.filePattern){const v=w.basename(this.filePattern);this.matchFile(h,{base:p,relativePath:this.filePattern,basename:v})}function E(v){const S=w.basename(v),u=w.dirname(v);let f=d[u];f||(f=d[u]=[],E(u)),f.push({base:p,relativePath:v,basename:S})}E(a)}matchDirectoryTree({rootEntries:d,pathToEntries:p},a,h){const E=this,v=this.filePattern;function S(u){const f=T.hasSiblingFn(()=>u.map(c=>c.basename));for(let c=0,t=u.length;c<t;c++){const n=u[c],{relativePath:s,basename:r}=n;if(!a.includedInQuerySync(s,r,v!==r?f:void 0))continue;const o=p[s];if(o)S(o);else{if(s===v)continue;E.matchFile(h,n)}if(E.isLimitHit)break}}S(d)}matchFile(d,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(p))}}class i{constructor(){this.sessions=new Map}fileSearch(d,p,a,h){const E=this.getSessionTokenSource(d.cacheKey),v=new I(d,p,E&&E.token);let S=0;const u=f=>{S+=f.length,a(f.map(c=>this.rawMatchToSearchItem(c)))};return this.doSearch(v,i.BATCH_SIZE,u,h).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:f.stats}}))}clearCache(d){const p=this.getSessionTokenSource(d);p&&p.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new R.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:y.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,p,a,h){h.onCancellationRequested(()=>{d.cancel()});const E=S=>{S&&(v.push(S),p>0&&v.length>=p&&(a(v),v=[]))};let v=[];return d.search(E).then(S=>(v.length&&a(v),S),S=>(v.length&&a(v),Promise.reject(S)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(ge[129],pe([0,1,9,16,21,60,24,30,2,31,10,12]),function(G,e,w,R,C,T,y,k,D,I,i,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(u,f,c){this.query=u,this.provider=f,this.fileUtils=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,f){const c=this.query.folderQueries||[],t=new C.CancellationTokenSource;return f.onCancellationRequested(()=>t.cancel()),new Promise((n,s)=>{this.collector=new a(u);let r=!1;const o=(g,m)=>{if(!r&&!this.isLimitHit){const _=this.resultSize(g);E(g)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),g=this.trimResultToSize(g,this.query.maxResults-this.resultCount));const b=this.resultSize(g);this.resultCount+=b,(b>0||!E(g))&&this.collector.add(g,m)}};Promise.all(c.map((g,m)=>this.searchInFolder(g,_=>o(_,m),t.token))).then(g=>{t.dispose(),this.collector.flush();const m=g.some(_=>!!_&&!!_.limitHit);n({limitHit:this.isLimitHit||m,messages:(0,R.flatten)(g.map(_=>(_==null?void 0:_.message)?(0,A.isArray)(_.message)?_.message:[_.message]:[])),stats:{type:"textSearchProvider"}})},g=>{t.dispose();const m=(0,T.toErrorMessage)(g);s(new Error(m))})})}resultSize(u){return E(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,f){const c=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:c.slice(0,f),preview:{matches:t.slice(0,f),text:u.preview.text},uri:u.uri}}async searchInFolder(u,f,c){const t=new I.QueryGlobTester(this.query,u),n=[],s={report:g=>{if(!this.validateProviderResult(g))return;const m=u.folder.scheme===i.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(g.uri))):void 0,_=y.relativePath(u.folder,g.uri);_&&n.push(t.includedInQuery(_,w.basename(_),m).then(b=>{b&&f(g)}))}},r=this.getSearchOptionsForFolder(u),o=await this.provider.provideTextSearchResults(p(this.query.contentPattern),r,s,c);return await Promise.all(n),o}validateProviderResult(u){if(E(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const f=(0,I.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),c=(0,I.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),t={folder:D.URI.from(u.folder),excludes:c,includes:f,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function p(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class a{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,f=>this.sendItems(f))}add(u,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!y.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(h(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=a;function h(S){return E(S)?{preview:{matches:(0,R.mapArrayOrNot)(S.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:S.preview.text},ranges:(0,R.mapArrayOrNot)(S.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function E(S){return!!S.preview}e.extensionResultIsMatch=E;class v{constructor(u,f){this.maxBatchSize=u,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,f){!u||this.addItemToBatch(u,f)}addItems(u,f){!u||this.addItemsToBatch(u,f)}addItemToBatch(u,f){this.batch.push(u),this.batchSize+=f,this.onUpdate()}addItemsToBatch(u,f){this.batch=this.batch.concat(u),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(ge[71],pe([0,1,6,5,4,264,15,63,14,2,129]),function(G,e,w,R,C,T,y,k,D,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let A=class{constructor(h,E,v){this.extHostRpc=h,this._uriTransformer=E,this._logService=v,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,E){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const v=this._handlePool++;return this._textSearchProvider.set(v,E),this._proxy.$registerTextSearchProvider(v,this._transformScheme(h)),(0,w.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}registerFileSearchProvider(h,E){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const v=this._handlePool++;return this._fileSearchProvider.set(v,E),this._proxy.$registerFileSearchProvider(v,this._transformScheme(h)),(0,w.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}$provideFileSearchResults(h,E,v,S){const u=d(v),f=this._fileSearchProvider.get(h);if(f)return this._fileSearchManager.fileSearch(u,f,c=>{this._proxy.$handleFileMatch(h,E,c.map(t=>t.resource))},S);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,E,v,S){const u=this._textSearchProvider.get(h);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const f=d(v);return this.createTextSearchManager(f,u).search(t=>this._proxy.$handleTextMatch(h,E,t),S)}createTextSearchManager(h,E){return new i.TextSearchManager(h,E,{readdir:v=>Promise.resolve([]),toCanonicalName:v=>v})}};A=Ve([He(0,y.IExtHostRpcService),He(1,k.IURITransformerService),He(2,D.ILogService)],A),e.ExtHostSearch=A;function d(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(p),extraFileResources:a.extraFileResources&&a.extraFileResources.map(h=>I.URI.revive(h))})}e.reviveQuery=d;function p(a){return Object.assign(Object.assign({},a),{folder:I.URI.revive(a.folder)})}}),define(ge[265],pe([0,1,21,17,3,57,2,152,106,143,78,43,5,226,225,49,227,35,228,229,230,212,231,40,41,232,213,234,235,236,66,215,240,241,242,90,33,243,216,20,7,246,67,128,34,39,52,201,233,117,127,69,50,71,14,63,15,27,237,199,48,65,223,244,198,91,89,249,247,248,224,62,257,245,88,47,119,238,68,239,10,187]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E,v,S,u,f,c,t,n,s,r,o,g,m,_,b,l,L,O,$,ie,se,U,V,W,P,N,F,M,B,H,Q,le,be,Te,ke,Ne,Ke,ze,qe,q,J,re,oe,Y,ce,ve,Le,we,je,K,ne,Ee,Oe,$e,We,Xe,De,ye,Ce,ae,he,z,Z,ue,Ie,Pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ue(xe){const Qe=xe.get(re.IExtHostInitDataService),rt=xe.get(Xe.IExtHostFileSystemInfo),tt=xe.get(ne.IExtHostConsumerFileSystem),Ye=xe.get(s.IExtHostExtensionService),ot=xe.get(B.IExtHostWorkspace),Et=xe.get(he.IExtHostTelemetry),bt=xe.get(v.IExtHostConfiguration),_e=xe.get(q.IURITransformerService),fe=xe.get(J.IExtHostRpcService),de=xe.get(ie.IExtHostStorage),X=xe.get(K.IExtensionStoragePaths),Fe=xe.get(qe.ILogService),Re=xe.get(ce.IExtHostTunnelService),Ze=xe.get(ve.IExtHostApiDeprecationService),et=xe.get(M.IExtHostWindow),ft=xe.get(Ce.IExtHostSecretState),ct=xe.get(ae.IExtHostEditorTabs);fe.set(d.ExtHostContext.ExtHostFileSystemInfo,rt),fe.set(d.ExtHostContext.ExtHostLogService,Fe),fe.set(d.ExtHostContext.ExtHostWorkspace,ot),fe.set(d.ExtHostContext.ExtHostConfiguration,bt),fe.set(d.ExtHostContext.ExtHostExtensionService,Ye),fe.set(d.ExtHostContext.ExtHostStorage,de),fe.set(d.ExtHostContext.ExtHostTunnelService,Re),fe.set(d.ExtHostContext.ExtHostWindow,et),fe.set(d.ExtHostContext.ExtHostSecretState,ft),fe.set(d.ExtHostContext.ExtHostTelemetry,Et),fe.set(d.ExtHostContext.ExtHostEditorTabs,ct);const it=fe.set(d.ExtHostContext.ExtHostDecorations,xe.get(ke.IExtHostDecorations)),vt=fe.set(d.ExtHostContext.ExtHostDocumentsAndEditors,xe.get(n.IExtHostDocumentsAndEditors)),ht=fe.set(d.ExtHostContext.ExtHostCommands,xe.get(h.IExtHostCommands)),lt=fe.set(d.ExtHostContext.ExtHostTerminalService,xe.get(se.IExtHostTerminalService)),mt=fe.set(d.ExtHostContext.ExtHostDebugService,xe.get(Ke.IExtHostDebugService)),Pt=fe.set(d.ExtHostContext.ExtHostSearch,xe.get(ze.IExtHostSearch)),Ct=fe.set(d.ExtHostContext.ExtHostTask,xe.get(Ne.IExtHostTask)),At=fe.set(d.ExtHostContext.ExtHostOutputService,xe.get(b.IExtHostOutputService)),Rt=fe.set(d.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(fe)),St=fe.set(d.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(fe,vt)),Xt=fe.set(d.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(fe,vt,Fe)),Yt=fe.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new c.ExtHostDocumentSaveParticipant(Fe,St,fe.getProxy(d.MainContext.MainThreadBulkEdits))),gt=fe.set(d.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(fe,ht,vt,St,Fe,X)),Jt=fe.set(d.ExtHostContext.ExtHostNotebookKernels,new z.ExtHostNotebookKernels(fe,Qe,gt,Fe)),Zt=fe.set(d.ExtHostContext.ExtHostNotebookRenderers,new ue.ExtHostNotebookRenderers(fe,gt)),Dt=fe.set(d.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(fe,vt)),dn=fe.set(d.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(fe.getProxy(d.MainContext.MainThreadTreeViews),ht,Fe)),en=fe.set(d.ExtHostContext.ExtHostEditorInsets,new le.ExtHostEditorInsets(fe.getProxy(d.MainContext.MainThreadEditorInsets),Dt,Qe)),xt=fe.set(d.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(fe,Fe)),ut=fe.set(d.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(fe,_e,St,ht,xt,Fe,Ze)),tn=fe.set(d.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(fe,ut)),Ft=fe.set(d.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(fe,Fe,vt)),Mt=fe.set(d.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(fe,ot,ht)),qt=fe.set(d.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(fe,ht,Fe)),wn=fe.set(d.ExtHostContext.ExtHostComments,new E.ExtHostComments(fe,ht,St)),hn=fe.set(d.ExtHostContext.ExtHostProgress,new l.ExtHostProgress(fe.getProxy(d.MainContext.MainThreadProgress))),bn=fe.set(d.ExtHostContext.ExtHosLabelService,new be.ExtHostLabelService(fe)),fn=fe.set(d.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(fe)),Bt=fe.set(d.ExtHostContext.ExtHostAuthentication,new Le.ExtHostAuthentication(fe)),nn=fe.set(d.ExtHostContext.ExtHostTimeline,new we.ExtHostTimeline(fe,ht)),Ht=fe.set(d.ExtHostContext.ExtHostWebviews,new F.ExtHostWebviews(fe,{remote:Qe.remote},ot,Fe,Ze)),rn=fe.set(d.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(fe,Ht,ot)),En=fe.set(d.ExtHostContext.ExtHostCustomEditors,new Oe.ExtHostCustomEditors(fe,St,X,Ht,rn)),_n=fe.set(d.ExtHostContext.ExtHostWebviewViews,new Ee.ExtHostWebviewViews(fe,Ht)),Ot=fe.set(d.ExtHostContext.ExtHostTesting,new De.ExtHostTesting(fe,vt,ot)),Kt=fe.set(d.ExtHostContext.ExtHostUriOpeners,new ye.ExtHostUriOpeners(fe)),Sn=(0,Q.values)(d.ExtHostContext);fe.assertRegistered(Sn);const yn=new We.ExtHostBulkEdits(fe,vt),sn=new a.ExtHostClipboard(fe),on=new _.ExtHostMessageService(fe,Fe),$t=new u.ExtHostDialogs(fe),Gt=new $.ExtHostStatusBar(fe,ht.converter),Wt=new m.ExtHostLanguages(fe,St);return p.ExtHostApiCommands.register(ht),function(Me,an,It){const pt=function(){let ee=!Me.isUnderDevelopment;function me(Ae){ee||(Fe.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Ae(st){if(Array.isArray(st))st.forEach(Ae);else if(typeof st=="string")me(st);else{const wt=st;typeof wt.scheme=="undefined"&&me(st),!Me.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,H.throwProposedApiError)(Me)}return st}}(),Dn={getSession(ee,me,Ae){return Bt.getSession(Me,ee,me,Ae)},get onDidChangeSessions(){return Bt.onDidChangeSessions},registerAuthenticationProvider(ee,me,Ae,st){return Bt.registerAuthenticationProvider(ee,me,Ae,st)},get onDidChangeAuthenticationProviders(){return(0,H.checkProposedApiEnabled)(Me),Bt.onDidChangeAuthenticationProviders},get providers(){return(0,H.checkProposedApiEnabled)(Me),Bt.providers},logout(ee,me){return(0,H.checkProposedApiEnabled)(Me),Bt.removeSession(ee,me)}},Cn={registerCommand(ee,me,Ae){return ht.registerCommand(!0,ee,me,Ae)},registerTextEditorCommand(ee,me,Ae){return ht.registerCommand(!0,ee,(...st)=>{const wt=Dt.getActiveTextEditor();if(!wt){Fe.warn("Cannot execute "+ee+" because there is no active text editor.");return}return wt.edit(_t=>{me.apply(Ae,[wt,_t,...st])}).then(_t=>{_t||Fe.warn("Edits from command "+ee+" were not applied.")},_t=>{Fe.warn("An error occurred while running command "+ee,_t)})})},registerDiffInformationCommand:(ee,me,Ae)=>((0,H.checkProposedApiEnabled)(Me),ht.registerCommand(!0,ee,async(...st)=>{const wt=vt.activeEditor(!0);if(!wt){Fe.warn("Cannot execute "+ee+" because there is no active text editor.");return}const _t=await Dt.getDiffInformation(wt.id);me.apply(Ae,[_t,...st])})),executeCommand(ee,...me){return ht.executeCommand(ee,...me)},getCommands(ee=!1){return ht.getCommands(ee)}},mn={get machineId(){return Qe.telemetryInfo.machineId},get sessionId(){return Qe.telemetryInfo.sessionId},get language(){return Qe.environment.appLanguage},get appName(){return Qe.environment.appName},get appRoot(){var ee,me;return(me=(ee=Qe.environment.appRoot)===null||ee===void 0?void 0:ee.fsPath)!==null&&me!==void 0?me:""},get uriScheme(){return Qe.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return lt.getDefaultShell(!1)},get isTelemetryEnabled(){return Et.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Et.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ee=Date.now()-new Date(Qe.telemetryInfo.firstSessionDate).getTime();return isNaN(ee)?!1:ee<1e3*60*60*24},openExternal(ee,me){return et.openUri(ee,{allowTunneling:!!Qe.remote.authority,allowContributedOpeners:me==null?void 0:me.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===Qe.environment.appUriScheme)return Rt.createAppUri(ee);!(0,Pe.matchesScheme)(ee,Ie.Schemas.http)&&!(0,Pe.matchesScheme)(ee,Ie.Schemas.https)&&(0,H.checkProposedApiEnabled)(Me);try{return await et.asExternalUri(ee,{allowTunneling:!!Qe.remote.authority})}catch(me){return ee}},get remoteName(){return(0,Te.getRemoteName)(Qe.remote.authority)},get uiKind(){return Qe.uiKind}};Qe.environment.extensionTestsLocationURI||Object.freeze(mn);const gn=Qe.remote.isRemote?P.ExtensionKind.Workspace:P.ExtensionKind.UI,kn={registerTestController(ee){return Ot.registerTestController(Me.identifier.value,ee)},createDocumentTestObserver(ee){return(0,H.checkProposedApiEnabled)(Me),Ot.createTextDocumentTestObserver(ee)},createWorkspaceTestObserver(ee){return(0,H.checkProposedApiEnabled)(Me),Ot.createWorkspaceTestObserver(ee)},runTests(ee){return Ot.runTests(ee)},createTestItem(ee,me){return new P.TestItemImpl(ee.id,ee.label,ee.uri,me)},createTestRun(ee,me,Ae){return Ot.createTestRun(Me.identifier.value,ee,me,Ae)},get onDidChangeTestResults(){return(0,H.checkProposedApiEnabled)(Me),Ot.onResultsChanged},get testResults(){return(0,H.checkProposedApiEnabled)(Me),Ot.results}},In={getExtension(ee){const me=an.getExtensionDescription(ee);if(me)return new s.Extension(Ye,Me.identifier,me,gn)},get all(){return an.getAllExtensionDescriptions().map(ee=>new s.Extension(Ye,Me.identifier,ee,gn))},get onDidChange(){return an.onDidChange}},Pn={createDiagnosticCollection(ee){return xt.createDiagnosticCollection(Me.identifier,ee)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:ee=>xt.getDiagnostics(ee),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(ee,me){return Wt.changeLanguage(ee.uri,me)},match(ee,me){return(0,i.score)(W.LanguageSelector.from(ee),me.uri,me.languageId,!0)},registerCodeActionsProvider(ee,me,Ae){return ut.registerCodeActionProvider(Me,pt(ee),me,Ae)},registerCodeLensProvider(ee,me){return ut.registerCodeLensProvider(Me,pt(ee),me)},registerDefinitionProvider(ee,me){return ut.registerDefinitionProvider(Me,pt(ee),me)},registerDeclarationProvider(ee,me){return ut.registerDeclarationProvider(Me,pt(ee),me)},registerImplementationProvider(ee,me){return ut.registerImplementationProvider(Me,pt(ee),me)},registerTypeDefinitionProvider(ee,me){return ut.registerTypeDefinitionProvider(Me,pt(ee),me)},registerHoverProvider(ee,me){return ut.registerHoverProvider(Me,pt(ee),me,Me.identifier)},registerEvaluatableExpressionProvider(ee,me){return ut.registerEvaluatableExpressionProvider(Me,pt(ee),me,Me.identifier)},registerInlineValuesProvider(ee,me){return ut.registerInlineValuesProvider(Me,pt(ee),me,Me.identifier)},registerDocumentHighlightProvider(ee,me){return ut.registerDocumentHighlightProvider(Me,pt(ee),me)},registerLinkedEditingRangeProvider(ee,me){return ut.registerLinkedEditingRangeProvider(Me,pt(ee),me)},registerReferenceProvider(ee,me){return ut.registerReferenceProvider(Me,pt(ee),me)},registerRenameProvider(ee,me){return ut.registerRenameProvider(Me,pt(ee),me)},registerDocumentSymbolProvider(ee,me,Ae){return ut.registerDocumentSymbolProvider(Me,pt(ee),me,Ae)},registerWorkspaceSymbolProvider(ee){return ut.registerWorkspaceSymbolProvider(Me,ee)},registerDocumentFormattingEditProvider(ee,me){return ut.registerDocumentFormattingEditProvider(Me,pt(ee),me)},registerDocumentRangeFormattingEditProvider(ee,me){return ut.registerDocumentRangeFormattingEditProvider(Me,pt(ee),me)},registerOnTypeFormattingEditProvider(ee,me,Ae,...st){return ut.registerOnTypeFormattingEditProvider(Me,pt(ee),me,[Ae].concat(st))},registerDocumentSemanticTokensProvider(ee,me,Ae){return ut.registerDocumentSemanticTokensProvider(Me,pt(ee),me,Ae)},registerDocumentRangeSemanticTokensProvider(ee,me,Ae){return ut.registerDocumentRangeSemanticTokensProvider(Me,pt(ee),me,Ae)},registerSignatureHelpProvider(ee,me,Ae,...st){return typeof Ae=="object"?ut.registerSignatureHelpProvider(Me,pt(ee),me,Ae):ut.registerSignatureHelpProvider(Me,pt(ee),me,typeof Ae=="undefined"?[]:[Ae,...st])},registerCompletionItemProvider(ee,me,...Ae){return ut.registerCompletionItemProvider(Me,pt(ee),me,Ae)},registerInlineCompletionItemProvider(ee,me){return(0,H.checkProposedApiEnabled)(Me),ut.registerInlineCompletionsProvider(Me,pt(ee),me)},registerDocumentLinkProvider(ee,me){return ut.registerDocumentLinkProvider(Me,pt(ee),me)},registerColorProvider(ee,me){return ut.registerColorProvider(Me,pt(ee),me)},registerFoldingRangeProvider(ee,me){return ut.registerFoldingRangeProvider(Me,pt(ee),me)},registerSelectionRangeProvider(ee,me){return ut.registerSelectionRangeProvider(Me,ee,me)},registerCallHierarchyProvider(ee,me){return ut.registerCallHierarchyProvider(Me,ee,me)},setLanguageConfiguration:(ee,me)=>ut.setLanguageConfiguration(Me,ee,me),getTokenInformationAtPosition(ee,me){return(0,H.checkProposedApiEnabled)(Me),Wt.tokenAtPosition(ee,me)},registerInlayHintsProvider(ee,me){return(0,H.checkProposedApiEnabled)(Me),ut.registerInlayHintsProvider(Me,ee,me)}},ln={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return lt.activeTerminal},get terminals(){return lt.terminals},async showTextDocument(ee,me,Ae){const st=await(y.URI.isUri(ee)?Promise.resolve(pn.openTextDocument(ee)):Promise.resolve(ee));return Dt.showTextDocument(st,me,Ae)},createTextEditorDecorationType(ee){return Dt.createTextEditorDecorationType(ee)},onDidChangeActiveTextEditor(ee,me,Ae){return Dt.onDidChangeActiveTextEditor(ee,me,Ae)},onDidChangeVisibleTextEditors(ee,me,Ae){return Dt.onDidChangeVisibleTextEditors(ee,me,Ae)},onDidChangeTextEditorSelection(ee,me,Ae){return Dt.onDidChangeTextEditorSelection(ee,me,Ae)},onDidChangeTextEditorOptions(ee,me,Ae){return Dt.onDidChangeTextEditorOptions(ee,me,Ae)},onDidChangeTextEditorVisibleRanges(ee,me,Ae){return Dt.onDidChangeTextEditorVisibleRanges(ee,me,Ae)},onDidChangeTextEditorViewColumn(ee,me,Ae){return Dt.onDidChangeTextEditorViewColumn(ee,me,Ae)},onDidCloseTerminal(ee,me,Ae){return lt.onDidCloseTerminal(ee,me,Ae)},onDidOpenTerminal(ee,me,Ae){return lt.onDidOpenTerminal(ee,me,Ae)},onDidChangeActiveTerminal(ee,me,Ae){return lt.onDidChangeActiveTerminal(ee,me,Ae)},onDidChangeTerminalDimensions(ee,me,Ae){return(0,H.checkProposedApiEnabled)(Me),lt.onDidChangeTerminalDimensions(ee,me,Ae)},onDidWriteTerminalData(ee,me,Ae){return(0,H.checkProposedApiEnabled)(Me),lt.onDidWriteTerminalData(ee,me,Ae)},get state(){return et.state},onDidChangeWindowState(ee,me,Ae){return et.onDidChangeWindowState(ee,me,Ae)},showInformationMessage(ee,...me){return on.showMessage(Me,T.default.Info,ee,me[0],me.slice(1))},showWarningMessage(ee,...me){return on.showMessage(Me,T.default.Warning,ee,me[0],me.slice(1))},showErrorMessage(ee,...me){return on.showMessage(Me,T.default.Error,ee,me[0],me.slice(1))},showQuickPick(ee,me,Ae){return Mt.showQuickPick(ee,!!Me.enableProposedApi,me,Ae)},showWorkspaceFolderPick(ee){return Mt.showWorkspaceFolderPick(ee)},showInputBox(ee,me){return Mt.showInput(ee,me)},showOpenDialog(ee){return $t.showOpenDialog(ee)},showSaveDialog(ee){return $t.showSaveDialog(ee)},createStatusBarItem(ee,me,Ae){let st,wt,_t;return typeof ee=="string"?(st=ee,wt=me,_t=Ae):(wt=ee,_t=me),Gt.createStatusBarEntry(Me,st,wt,_t)},setStatusBarMessage(ee,me){return Gt.setStatusBarMessage(ee,me)},withScmProgress(ee){return Ze.report("window.withScmProgress",Me,"Use 'withProgress' instead."),hn.withProgress(Me,{location:P.ProgressLocation.SourceControl},(me,Ae)=>ee({report(st){}}))},withProgress(ee,me){return hn.withProgress(Me,ee,me)},createOutputChannel(ee){return At.createOutputChannel(ee)},createWebviewPanel(ee,me,Ae,st){return rn.createWebviewPanel(Me,ee,me,Ae,st)},createWebviewTextEditorInset(ee,me,Ae,st){return(0,H.checkProposedApiEnabled)(Me),en.createWebviewEditorInset(ee,me,Ae,st,Me)},createTerminal(ee,me,Ae){return typeof ee=="object"?"pty"in ee?lt.createExtensionTerminal(ee):(ee.iconPath&&(0,H.checkProposedApiEnabled)(Me),lt.createTerminalFromOptions(ee)):lt.createTerminal(ee,me,Ae)},registerTerminalLinkProvider(ee){return lt.registerLinkProvider(ee)},registerTreeDataProvider(ee,me){return dn.registerTreeDataProvider(ee,me,Me)},createTreeView(ee,me){return dn.createTreeView(ee,me,Me)},registerWebviewPanelSerializer:(ee,me)=>rn.registerWebviewPanelSerializer(Me,ee,me),registerCustomEditorProvider:(ee,me,Ae={})=>En.registerCustomEditorProvider(Me,ee,me,Ae),registerFileDecorationProvider(ee){return it.registerFileDecorationProvider(ee,Me.identifier)},registerUriHandler(ee){return Rt.registerUriHandler(Me.identifier,ee)},createQuickPick(){return Mt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Mt.createInputBox(Me.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(ee,me,Ae){return fn.onDidChangeActiveColorTheme(ee,me,Ae)},registerWebviewViewProvider(ee,me,Ae){return _n.registerWebviewViewProvider(Me,ee,me,Ae==null?void 0:Ae.webviewOptions)},get activeNotebookEditor(){return(0,H.checkProposedApiEnabled)(Me),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,me,Ae){return(0,H.checkProposedApiEnabled)(Me),gt.onDidChangeActiveNotebookEditor(ee,me,Ae)},get visibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Me),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Me),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,me,Ae){return(0,H.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookEditorSelection(ee,me,Ae)},onDidChangeNotebookEditorVisibleRanges(ee,me,Ae){return(0,H.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookEditorVisibleRanges(ee,me,Ae)},showNotebookDocument(ee,me){return(0,H.checkProposedApiEnabled)(Me),gt.showNotebookDocument(ee,me)},registerExternalUriOpener(ee,me,Ae){return(0,H.checkProposedApiEnabled)(Me),Kt.registerExternalUriOpener(Me.identifier,ee,me,Ae)},get openEditors(){return(0,H.checkProposedApiEnabled)(Me),ct.tabs},get onDidChangeOpenEditors(){return(0,H.checkProposedApiEnabled)(Me),ct.onDidChangeTabs},getInlineCompletionItemController(ee){return(0,H.checkProposedApiEnabled)(Me),g.InlineCompletionController.get(ee)}},pn={get rootPath(){return Ze.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(ee){throw R.readonly()},getWorkspaceFolder(ee){return ot.getWorkspaceFolder(ee)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(ee){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(ee){throw R.readonly()},updateWorkspaceFolders:(ee,me,...Ae)=>ot.updateWorkspaceFolders(Me,ee,me||0,...Ae),onDidChangeWorkspaceFolders:function(ee,me,Ae){return ot.onDidChangeWorkspace(ee,me,Ae)},asRelativePath:(ee,me)=>ot.getRelativePath(ee,me),findFiles:(ee,me,Ae,st)=>ot.findFiles(W.GlobPattern.from(ee),W.GlobPattern.from(me),Ae,Me.identifier,st),findTextInFiles:(ee,me,Ae,st)=>{let wt,_t;return typeof me=="object"?(wt=me,_t=Ae):(wt={},_t=me,st=Ae),ot.findTextInFiles(ee,wt||{},_t,Me.identifier,st)},saveAll:ee=>ot.saveAll(ee),applyEdit(ee){return yn.applyWorkspaceEdit(ee)},createFileSystemWatcher:(ee,me,Ae,st)=>Ft.createFileSystemWatcher(W.GlobPattern.from(ee),me,Ae,st),get textDocuments(){return St.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw R.readonly()},openTextDocument(ee){let me;const Ae=ee;if(typeof ee=="string")me=Promise.resolve(y.URI.file(ee));else if(y.URI.isUri(ee))me=Promise.resolve(ee);else if(!Ae||typeof Ae=="object")me=St.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(st=>St.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(ee,me,Ae)=>St.onDidAddDocument(ee,me,Ae),onDidCloseTextDocument:(ee,me,Ae)=>St.onDidRemoveDocument(ee,me,Ae),onDidChangeTextDocument:(ee,me,Ae)=>St.onDidChangeDocument(ee,me,Ae),onDidSaveTextDocument:(ee,me,Ae)=>St.onDidSaveDocument(ee,me,Ae),onWillSaveTextDocument:(ee,me,Ae)=>Yt.getOnWillSaveTextDocumentEvent(Me)(ee,me,Ae),onDidChangeConfiguration:(ee,me,Ae)=>It.onDidChangeConfiguration(ee,me,Ae),getConfiguration(ee,me){return me=arguments.length===1?void 0:me,It.getConfiguration(ee,me,Me)},registerTextDocumentContentProvider(ee,me){return Xt.registerTextDocumentContentProvider(ee,me)},registerTaskProvider:(ee,me)=>(Ze.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Me,ee,me)),registerFileSystemProvider(ee,me,Ae){return tn.registerFileSystemProvider(Me.identifier,ee,me,Ae,Me.enableProposedApi)},get fs(){return tt.value},registerFileSearchProvider:(ee,me)=>((0,H.checkProposedApiEnabled)(Me),Pt.registerFileSearchProvider(ee,me)),registerTextSearchProvider:(ee,me)=>((0,H.checkProposedApiEnabled)(Me),Pt.registerTextSearchProvider(ee,me)),registerRemoteAuthorityResolver:(ee,me)=>((0,H.checkProposedApiEnabled)(Me),Ye.registerRemoteAuthorityResolver(ee,me)),registerResourceLabelFormatter:ee=>((0,H.checkProposedApiEnabled)(Me),bn.$registerResourceLabelFormatter(ee)),onDidCreateFiles:(ee,me,Ae)=>Ft.onDidCreateFile(ee,me,Ae),onDidDeleteFiles:(ee,me,Ae)=>Ft.onDidDeleteFile(ee,me,Ae),onDidRenameFiles:(ee,me,Ae)=>Ft.onDidRenameFile(ee,me,Ae),onWillCreateFiles:(ee,me,Ae)=>Ft.getOnWillCreateFileEvent(Me)(ee,me,Ae),onWillDeleteFiles:(ee,me,Ae)=>Ft.getOnWillDeleteFileEvent(Me)(ee,me,Ae),onWillRenameFiles:(ee,me,Ae)=>Ft.getOnWillRenameFileEvent(Me)(ee,me,Ae),openTunnel:ee=>((0,H.checkProposedApiEnabled)(Me),Re.openTunnel(Me,ee).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,H.checkProposedApiEnabled)(Me),Re.getTunnels()},onDidChangeTunnels:(ee,me,Ae)=>((0,H.checkProposedApiEnabled)(Me),Re.onDidChangeTunnels(ee,me,Ae)),registerPortAttributesProvider:(ee,me)=>((0,H.checkProposedApiEnabled)(Me),Re.registerPortsAttributesProvider(ee,me)),registerTimelineProvider:(ee,me)=>((0,H.checkProposedApiEnabled)(Me),nn.registerTimelineProvider(ee,me,Me.identifier,ht.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:ee=>((0,H.checkProposedApiEnabled)(Me),ot.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,me,Ae)=>ot.onDidGrantWorkspaceTrust(ee,me,Ae)},An={get inputBox(){return Ze.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),qt.getLastInputBox(Me)},createSourceControl(ee,me,Ae){return qt.createSourceControl(Me,ee,me,Ae)}},Tn={createCommentController(ee,me){return wn.createCommentController(Me,ee,me)}},Rn={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(ee,me,Ae){return mt.onDidStartDebugSession(ee,me,Ae)},onDidTerminateDebugSession(ee,me,Ae){return mt.onDidTerminateDebugSession(ee,me,Ae)},onDidChangeActiveDebugSession(ee,me,Ae){return mt.onDidChangeActiveDebugSession(ee,me,Ae)},onDidReceiveDebugSessionCustomEvent(ee,me,Ae){return mt.onDidReceiveDebugSessionCustomEvent(ee,me,Ae)},onDidChangeBreakpoints(ee,me,Ae){return mt.onDidChangeBreakpoints(ee,me,Ae)},registerDebugConfigurationProvider(ee,me,Ae){return mt.registerDebugConfigurationProvider(ee,me,Ae||P.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,me){return mt.registerDebugAdapterDescriptorFactory(Me,ee,me)},registerDebugAdapterTrackerFactory(ee,me){return mt.registerDebugAdapterTrackerFactory(ee,me)},startDebugging(ee,me,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?mt.startDebugging(ee,me,{parentSession:Ae}):mt.startDebugging(ee,me,Ae||{})},stopDebugging(ee){return mt.stopDebugging(ee)},addBreakpoints(ee){return mt.addBreakpoints(ee)},removeBreakpoints(ee){return mt.removeBreakpoints(ee)},asDebugSourceUri(ee,me){return mt.asDebugSourceUri(ee,me)}},Ln={registerTaskProvider:(ee,me)=>Ct.registerTaskProvider(Me,ee,me),fetchTasks:ee=>Ct.fetchTasks(ee),executeTask:ee=>Ct.executeTask(Me,ee),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(ee,me,Ae)=>Ct.onDidStartTask(ee,me,Ae),onDidEndTask:(ee,me,Ae)=>Ct.onDidEndTask(ee,me,Ae),onDidStartTaskProcess:(ee,me,Ae)=>Ct.onDidStartTaskProcess(ee,me,Ae),onDidEndTaskProcess:(ee,me,Ae)=>Ct.onDidEndTaskProcess(ee,me,Ae)},Fn={async openNotebookDocument(ee,me){(0,H.checkProposedApiEnabled)(Me);let Ae;if(y.URI.isUri(ee))Ae=ee,await gt.openNotebookDocument(ee);else if(typeof ee=="string")Ae=y.URI.revive(await gt.createNotebookDocument({viewType:ee,content:me}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return(0,H.checkProposedApiEnabled)(Me),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,H.checkProposedApiEnabled)(Me),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,H.checkProposedApiEnabled)(Me),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,H.checkProposedApiEnabled)(Me),gt.notebookDocuments.map(ee=>ee.apiNotebook)},registerNotebookSerializer(ee,me,Ae,st){return(0,H.checkProposedApiEnabled)(Me),gt.registerNotebookSerializer(Me,ee,me,Ae,Me.enableProposedApi?st:void 0)},registerNotebookContentProvider:(ee,me,Ae,st)=>((0,H.checkProposedApiEnabled)(Me),gt.registerNotebookContentProvider(Me,ee,me,Ae,Me.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(ee,me)=>((0,H.checkProposedApiEnabled)(Me),gt.registerNotebookCellStatusBarItemProvider(Me,ee,me)),createNotebookEditorDecorationType(ee){return(0,H.checkProposedApiEnabled)(Me),gt.createNotebookEditorDecorationType(ee)},createRendererMessaging(ee){return(0,H.checkProposedApiEnabled)(Me),Zt.createRendererMessaging(ee)},onDidChangeNotebookDocumentMetadata(ee,me,Ae){return(0,H.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookDocumentMetadata(ee,me,Ae)},onDidChangeNotebookCells(ee,me,Ae){return(0,H.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookCells(ee,me,Ae)},onDidChangeNotebookCellExecutionState(ee,me,Ae){return(0,H.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookCellExecutionState(ee,me,Ae)},onDidChangeCellOutputs(ee,me,Ae){return(0,H.checkProposedApiEnabled)(Me),gt.onDidChangeCellOutputs(ee,me,Ae)},onDidChangeCellMetadata(ee,me,Ae){return(0,H.checkProposedApiEnabled)(Me),gt.onDidChangeCellMetadata(ee,me,Ae)},createConcatTextDocument(ee,me){return(0,H.checkProposedApiEnabled)(Me),new je.ExtHostNotebookConcatDocument(gt,St,ee,me)},createNotebookController(ee,me,Ae,st,wt){return(0,H.checkProposedApiEnabled)(Me),Jt.createNotebookController(Me,ee,me,Ae,st,wt)}};return{version:Qe.version,authentication:Dn,commands:Cn,comments:Tn,debug:Rn,env:mn,extensions:In,languages:Pn,notebook:Fn,scm:An,tasks:Ln,test:kn,window:ln,workspace:pn,Breakpoint:P.Breakpoint,CallHierarchyIncomingCall:P.CallHierarchyIncomingCall,CallHierarchyItem:P.CallHierarchyItem,CallHierarchyOutgoingCall:P.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:w.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:P.CodeAction,CodeActionKind:P.CodeActionKind,CodeActionTriggerKind:P.CodeActionTriggerKind,CodeLens:P.CodeLens,Color:P.Color,ColorInformation:P.ColorInformation,ColorPresentation:P.ColorPresentation,ColorThemeKind:P.ColorThemeKind,CommentMode:P.CommentMode,CommentThreadCollapsibleState:P.CommentThreadCollapsibleState,CompletionItem:P.CompletionItem,CompletionItemKind:P.CompletionItemKind,CompletionItemTag:P.CompletionItemTag,CompletionList:P.CompletionList,CompletionTriggerKind:P.CompletionTriggerKind,ConfigurationTarget:P.ConfigurationTarget,CustomExecution:P.CustomExecution,DebugAdapterExecutable:P.DebugAdapterExecutable,DebugAdapterInlineImplementation:P.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:P.DebugAdapterNamedPipeServer,DebugAdapterServer:P.DebugAdapterServer,DebugConfigurationProviderTriggerKind:P.DebugConfigurationProviderTriggerKind,DebugConsoleMode:P.DebugConsoleMode,DecorationRangeBehavior:P.DecorationRangeBehavior,Diagnostic:P.Diagnostic,DiagnosticRelatedInformation:P.DiagnosticRelatedInformation,DiagnosticSeverity:P.DiagnosticSeverity,DiagnosticTag:P.DiagnosticTag,Disposable:P.Disposable,DocumentHighlight:P.DocumentHighlight,DocumentHighlightKind:P.DocumentHighlightKind,DocumentLink:P.DocumentLink,DocumentSymbol:P.DocumentSymbol,EndOfLine:P.EndOfLine,EnvironmentVariableMutatorType:P.EnvironmentVariableMutatorType,EvaluatableExpression:P.EvaluatableExpression,InlineValueText:P.InlineValueText,InlineValueVariableLookup:P.InlineValueVariableLookup,InlineValueEvaluatableExpression:P.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:P.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:P.ExtensionKind,ExtensionMode:P.ExtensionMode,ExternalUriOpenerPriority:P.ExternalUriOpenerPriority,FileChangeType:P.FileChangeType,FileDecoration:P.FileDecoration,FileSystemError:P.FileSystemError,FileType:A.FileType,FilePermission:A.FilePermission,FoldingRange:P.FoldingRange,FoldingRangeKind:P.FoldingRangeKind,FunctionBreakpoint:P.FunctionBreakpoint,InlineCompletionItem:P.InlineSuggestion,InlineCompletionList:P.InlineSuggestions,Hover:P.Hover,IndentAction:I.IndentAction,Location:P.Location,MarkdownString:P.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:P.ParameterInformation,PortAutoForwardAction:P.PortAutoForwardAction,Position:P.Position,ProcessExecution:P.ProcessExecution,ProgressLocation:P.ProgressLocation,QuickInputButtons:P.QuickInputButtons,Range:P.Range,RelativePattern:P.RelativePattern,Selection:P.Selection,SelectionRange:P.SelectionRange,SemanticTokens:P.SemanticTokens,SemanticTokensBuilder:P.SemanticTokensBuilder,SemanticTokensEdit:P.SemanticTokensEdit,SemanticTokensEdits:P.SemanticTokensEdits,SemanticTokensLegend:P.SemanticTokensLegend,ShellExecution:P.ShellExecution,ShellQuoting:P.ShellQuoting,SignatureHelp:P.SignatureHelp,SignatureHelpTriggerKind:P.SignatureHelpTriggerKind,SignatureInformation:P.SignatureInformation,SnippetString:P.SnippetString,SourceBreakpoint:P.SourceBreakpoint,StandardTokenType:P.StandardTokenType,StatusBarAlignment:P.StatusBarAlignment,SymbolInformation:P.SymbolInformation,SymbolKind:P.SymbolKind,SymbolTag:P.SymbolTag,Task:P.Task,TaskGroup:P.TaskGroup,TaskPanelKind:P.TaskPanelKind,TaskRevealKind:P.TaskRevealKind,TaskScope:P.TaskScope,TextDocumentSaveReason:P.TextDocumentSaveReason,TextEdit:P.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:P.TextEditorLineNumbersStyle,TextEditorRevealType:P.TextEditorRevealType,TextEditorSelectionChangeKind:P.TextEditorSelectionChangeKind,ThemeColor:P.ThemeColor,ThemeIcon:P.ThemeIcon,TreeItem:P.TreeItem,TreeItemCollapsibleState:P.TreeItemCollapsibleState,UIKind:d.UIKind,Uri:y.URI,ViewColumn:P.ViewColumn,WorkspaceEdit:P.WorkspaceEdit,InlayHint:P.InlayHint,InlayHintKind:P.InlayHintKind,RemoteAuthorityResolverError:P.RemoteAuthorityResolverError,ResolvedAuthority:P.ResolvedAuthority,SourceControlInputBoxValidationType:P.SourceControlInputBoxValidationType,ExtensionRuntime:P.ExtensionRuntime,TimelineItem:P.TimelineItem,NotebookRange:P.NotebookRange,NotebookCellKind:P.NotebookCellKind,NotebookCellExecutionState:P.NotebookCellExecutionState,NotebookDocumentMetadata:P.NotebookDocumentMetadata,NotebookCellMetadata:P.NotebookCellMetadata,NotebookCellData:P.NotebookCellData,NotebookData:P.NotebookData,NotebookKernelPreload:P.NotebookKernelPreload,NotebookCellStatusBarAlignment:P.NotebookCellStatusBarAlignment,NotebookEditorRevealType:P.NotebookEditorRevealType,NotebookCellOutput:P.NotebookCellOutput,NotebookCellOutputItem:P.NotebookCellOutputItem,NotebookCellStatusBarItem:P.NotebookCellStatusBarItem,NotebookControllerAffinity:P.NotebookControllerAffinity,PortAttributes:P.PortAttributes,LinkedEditingRanges:P.LinkedEditingRanges,TestItemStatus:P.TestItemStatus,TestResultState:P.TestResultState,TestMessage:P.TestMessage,TextSearchCompleteMessageType:Z.TextSearchCompleteMessageType,TestMessageSeverity:P.TestMessageSeverity,WorkspaceTrustState:P.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ue}),define(ge[266],pe([0,1,79,66,34,127,35,49,40,33,69,50,71,91,90,48,65,128,89,62,88,119,47]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E,v,S,u,f,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(p.IExtensionStoragePaths,p.ExtensionStoragePaths),(0,w.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService),(0,w.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,w.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,w.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,w.registerSingleton)(A.IExtHostDebugService,A.WorkerExtHostDebugService),(0,w.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,w.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,w.registerSingleton)(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo),(0,w.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,w.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,w.registerSingleton)(a.IExtHostStorage,a.ExtHostStorage),(0,w.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,w.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,w.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,w.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,w.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace),(0,w.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState),(0,w.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry),(0,w.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(ge[92],pe([0,1,16,14,31,68]),function(G,e,w,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(A){return A.startsWith("**")||A.startsWith("/")?A:`/${A}`}e.anchorGlob=y;function k(A,d,p,a){const h=(0,w.mapArrayOrNot)(p,D),E=new C.TextSearchMatch(d,h,a),v=E.preview.matches;return{ranges:(0,w.mapArrayOrNot)(h,I),uri:A,preview:{text:E.preview.text,matches:(0,w.mapArrayOrNot)(v,I)}}}e.createTextSearchResult=k;function D(A){return new C.SearchRange(A.start.line,A.start.character,A.end.line,A.end.character)}function I(A){return new T.Range(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn)}let i=class{constructor(d,p){this.prefix=d,this.logService=p}appendLine(d){this.logService.debug(`${this.prefix}#search`,d)}};i=Ve([He(1,R.ILogService)],i),e.OutputChannel=i}),define(ge[267],pe([0,1,93,23]),function(G,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const T=512,y=512,k=512*8,D=512*128;class I{constructor(n){this.iconvLiteDecoder=n}static async create(n){let s;if(n!==e.UTF8)s=(await new Promise((o,g)=>{G(["iconv-lite-umd"],o,g)})).getDecoder(p(n));else{const r=new TextDecoder;s={write(o){return r.decode(o,{stream:!0})},end(){return r.decode()}}}return new I(s)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function i(t,n){var s;const r=((s=n.minBytesRequiredForDetection)!==null&&s!==void 0?s:n.guessEncoding)?k:y;return new Promise((o,g)=>{const m=(0,w.newWriteableStream)(O=>O.join("")),_=[];let b=0,l;const L=async()=>{try{const O=await c({buffer:R.VSBuffer.concat(_),bytesRead:b},n.guessEncoding);O.encoding=await n.overwriteEncoding(O.encoding),l=await I.create(O.encoding);const $=l.write(R.VSBuffer.concat(_).buffer);m.write($),_.length=0,b=0,o({stream:m,detected:O})}catch(O){g(O)}};(0,w.listenStream)(t,{onData:async O=>{l?m.write(l.write(O.buffer)):(_.push(O),b+=O.byteLength,b>=r&&(t.pause(),await L(),setTimeout(()=>t.resume())))},onError:O=>m.error(O),onEnd:async()=>{l||await L(),m.end(l==null?void 0:l.end())}})})}e.toDecodeStream=i;async function A(t,n,s){const o=(await new Promise((_,b)=>{G(["iconv-lite-umd"],_,b)})).getEncoder(p(n),s);let g=!1,m=!1;return{read(){if(m)return null;const _=t.read();if(typeof _!="string"){if(m=!0,!g&&(s==null?void 0:s.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const b=o.end();return b&&b.length>0?(g=!0,R.VSBuffer.wrap(b)):null}return g=!0,R.VSBuffer.wrap(o.write(_))}}}e.toEncodeReadable=A;async function d(t){return(await new Promise((s,r)=>{G(["iconv-lite-umd"],s,r)})).encodingExists(p(t))}e.encodingExists=d;function p(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=p;function a(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),r=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return s===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const h=["ascii","utf-16","utf-32"];async function E(t){const n=await new Promise((m,_)=>{G(["jschardet"],m,_)}),s=t.slice(0,D),r=u(s.buffer),o=n.detect(r);if(!o||!o.encoding)return null;const g=o.encoding.toLowerCase();return 0<=h.indexOf(g)?null:S(o.encoding)}const v={ibm866:"cp866",big5:"cp950"};function S(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[n]||n}function u(t){let n="";for(let s=0;s<t.length;s++)n+=String.fromCharCode(t[s]);return n}function f(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=f;function c({buffer:t,bytesRead:n},s){let r=a(t,n),o=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let g=!0,m=!0,_=!1;for(let b=0;b<n&&b<T;b++){const l=b%2==1,L=t.readUInt8(b)===0;if(L&&(_=!0),g&&(l&&!L||!l&&L)&&(g=!1),m&&(l&&L||!l&&!L)&&(m=!1),L&&!g&&!m)break}_&&(g?r=e.UTF16le:m?r=e.UTF16be:o=!0)}return s&&!o&&!r&&t?E(t.slice(0,n)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:o,encoding:r}}e.detectEncodingFromBuffer=c,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[130],pe([0,1,267,28,129]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class T extends C.TextSearchManager{constructor(k,D,I=R){super(k,D,{readdir:i=>I.readdir(i.fsPath),toCanonicalName:i=>(0,w.toCanonicalName)(i)})}}e.NativeTextSearchManager=T}),define(ge[268],pe([0,1,269,283,284,2,285]),function(G,e,w,R,C,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(A,d,p,a,h,E){const v=E.environment.useHostProxy,S=typeof v=="boolean"?v:!E.remote.isRemote,u=(0,y.createProxyResolver)({resolveProxy:c=>A.resolveProxy(c),getHttpProxySetting:()=>d.getConfiguration("http").get("proxy"),log:(c,t,...n)=>{switch(c){case y.LogLevel.Trace:a.trace(t,...n);break;case y.LogLevel.Debug:a.debug(t,...n);break;case y.LogLevel.Info:a.info(t,...n);break;case y.LogLevel.Warning:a.warn(t,...n);break;case y.LogLevel.Error:a.error(t,...n);break;case y.LogLevel.Critical:a.critical(t,...n);break;case y.LogLevel.Off:break;default:s(c,t,n);break}function s(r,o,...g){a.error("Unknown log level",r),a.error(o,...g)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:c=>{h.$publicLog2("resolveProxy",c)},useHostProxy:S,env:process.env}),f=D(d,u);return i(p,f)}e.connectProxyResolver=k;function D(A,d){const p={config:A.getConfiguration("http").get("proxySupport")||"off"};A.onDidChangeConfiguration(h=>{p.config=A.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!A.getConfiguration("http").get("systemCertificates")};return A.onDidChangeConfiguration(h=>{a.config=!!A.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},w,(0,y.createHttpPatch)(w,d,{config:"off"},a,!0)),on:Object.assign({},w,(0,y.createHttpPatch)(w,d,{config:"on"},a,!0)),override:Object.assign({},w,(0,y.createHttpPatch)(w,d,{config:"override"},a,!0)),onRequest:Object.assign({},w,(0,y.createHttpPatch)(w,d,p,a,!0)),default:Object.assign(w,(0,y.createHttpPatch)(w,d,p,a,!1))},https:{off:Object.assign({},R,(0,y.createHttpPatch)(R,d,{config:"off"},a,!0)),on:Object.assign({},R,(0,y.createHttpPatch)(R,d,{config:"on"},a,!0)),override:Object.assign({},R,(0,y.createHttpPatch)(R,d,{config:"override"},a,!0)),onRequest:Object.assign({},R,(0,y.createHttpPatch)(R,d,p,a,!0)),default:Object.assign(R,(0,y.createHttpPatch)(R,d,p,a,!1))},tls:Object.assign(C,(0,y.createTlsPatch)(C))}}const I=new Map;function i(A,d){return A.getExtensionPathIndex().then(p=>{const a=G.__$__nodeRequire("module"),h=a._load;a._load=function(v,S,u){if(v==="tls")return d.tls;if(v!=="http"&&v!=="https")return h.apply(this,arguments);const f=d[v],c=p.findSubstr(T.URI.file(S.filename).fsPath);let t=I.get(c);if(t||I.set(c,t={}),!t[v]){let n=f.default;c&&c.enableProposedApi&&(n=f[c.proxySupport]||f.onRequest),t[v]=Object.assign({},n)}return t[v]}})}}),define(ge[270],pe([0,1,37,9,76,29,11,8,92,271]),function(G,e,w,R,C,T,y,k,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function A(u,f,c,t){const n=d(u,f,c,t),s=f.folder.fsPath;return{cmd:w.spawn(i,n.args,{cwd:s}),rgDiskPath:i,siblingClauses:n.siblingClauses,rgArgs:n,cwd:s}}e.spawnRipgrepCmd=A;function d(u,f,c,t){const n=["--files","--hidden","--case-sensitive"];a([f],c,!1).forEach(r=>{const o=(0,D.anchorGlob)(r);if(n.push("-g",o),y.isMacintosh){const g=(0,C.normalizeNFD)(o);g!==o&&n.push("-g",g)}});const s=p([f],t,void 0,!1);return s.globArgs.forEach(r=>{const o=`!${(0,D.anchorGlob)(r)}`;if(n.push("-g",o),y.isMacintosh){const g=(0,C.normalizeNFD)(o);g!==o&&n.push("-g",g)}}),f.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),f.ignoreSymlinks||n.push("--follow"),u.exists&&n.push("--quiet"),n.push("--no-config"),f.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:s.siblingClauses}}function p(u,f,c,t=!0){const n=[];let s={};return u.forEach(r=>{const o=Object.assign({},r.excludePattern||{},f||{}),g=h(o,t?r.folder.fsPath:void 0,c);n.push(...g.globArgs),g.siblingClauses&&(s=Object.assign(s,g.siblingClauses))}),{globArgs:n,siblingClauses:s}}e.foldersToRgExcludeGlobs=p;function a(u,f,c=!0){const t=[];return u.forEach(n=>{const s=Object.assign({},f||{},n.includePattern||{}),r=h(s,c?n.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=a;function h(u,f,c){const t=[],n={};return Object.keys(u).forEach(s=>{if(c&&c.has(s)||!s)return;const r=u[s];s=v(f?E(f,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof r=="boolean"&&r?(s.startsWith("\\\\")&&(s+="**"),t.push(S(s))):r&&r.when&&(n[s]=r)}),{globArgs:t,siblingClauses:n}}function E(u,f){return R.isAbsolute(f)?f:R.join(u,f)}e.getAbsoluteGlob=E;function v(u){return u=k.rtrim(u,"\\"),k.rtrim(u,"/")}function S(u){return T.getRoot(u).toLowerCase()==="c:/"?u.replace(/^c:[/\\]/i,"/"):u}e.fixDriveC=S}),define(ge[272],pe([0,1,37,59,9,100,16,60,30,76,29,11,44,8,12,28,31,270,98]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const u=new Set;process.on("exit",()=>{u.forEach(s=>s())});class f{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&D.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,S.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&D.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(o=>{const g=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),m=o.folder.fsPath;r.folderQueries.map(_=>_.folder.fsPath).filter(_=>_!==m).forEach(_=>{(0,i.isEqualOrParent)(_,m)&&(g[C.relative(m,_)]=!0)}),this.folderExcludePatterns.set(m,new t(g,m))})}cancel(){this.isCanceled=!0}walk(r,o,g,m,_){if(this.fileWalkSW=d.StopWatch.create(!1),this.isCanceled)return _(null,this.isLimitHit);o.forEach(b=>{const l=C.basename(b.fsPath);this.globalExcludePattern&&this.globalExcludePattern(b.fsPath,l)||this.matchFile(g,{relativePath:b.fsPath,searchPath:void 0})}),this.cmdSW=d.StopWatch.create(!1),this.parallel(r,(b,l)=>{this.call(this.cmdTraversal,this,b,g,m,L=>{if(L){const O=(0,k.toErrorMessage)(L);console.error(O),this.errors.push(O),l(L,void 0)}else l(null,void 0)})},(b,l)=>{this.fileWalkSW.stop();const L=b?y.coalesce(b)[0]:null;_(L,this.isLimitHit)})}parallel(r,o,g){const m=new Array(r.length),_=new Array(r.length);let b=!1,l=0;if(r.length===0)return g(null,[]);r.forEach((L,O)=>{o(L,($,ie)=>{if($?(b=!0,m[O]=null,_[O]=$):(m[O]=ie,_[O]=null),++l===r.length)return g(b?_:null,m)})})}call(r,o,...g){try{r.apply(o,g)}catch(m){g[g.length-1](m)}}cmdTraversal(r,o,g,m){const _=r.folder.fsPath,b=A.isMacintosh;let l;const L=()=>l&&l.kill();u.add(L);let O=P=>{u.delete(L),O=()=>{},m(P)},$="";const ie=this.initDirectoryTree();let se;const U=(0,v.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);l=U.cmd,se=!Object.keys(U.siblingClauses).length;const V=U.rgArgs.args.map(P=>P.match(/^-/)?P:`'${P}'`).join(" ");let W=`${U.rgDiskPath} ${V}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(W+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),g({message:W}),this.cmdResultCount=0,this.collectStdout(l,"utf8",g,(P,N,F)=>{if(P){O(P);return}if(this.isLimitHit){O();return}const B=($+(b?I.normalizeNFC(N||""):N)).split(`
`);if(F){const H=B.length;B[H-1]=B[H-1].trim(),B[H-1]||B.pop()}else $=B.pop()||"";if(B.length&&B[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=B.length,se){for(const H of B)if(this.matchFile(o,{base:_,relativePath:H,searchPath:this.getSearchPath(r,H)}),this.isLimitHit){L();break}(F||this.isLimitHit)&&O();return}this.addDirectoryEntries(r,ie,_,B,o),F&&(this.matchDirectoryTree(ie,_,o),O())})}spawnFindCmd(r){const o=this.folderExcludePatterns.get(r.folder.fsPath),g=o.getBasenameTerms(),m=o.getPathTerms(),_=["-L","."];if(g.length||m.length){_.push("-not","(","(");for(const b of g)_.push("-name",b),_.push("-o");for(const b of m)_.push("-path",b),_.push("-o");_.pop(),_.push(")","-prune",")")}return _.push("-type","f"),w.spawn("find",_,{cwd:r.folder.fsPath})}readStdout(r,o,g){let m="";this.collectStdout(r,o,()=>{},(_,b,l)=>{if(_){g(_);return}m+=b,l&&g(null,m)})}collectStdout(r,o,g,m){let _=(L,O,$)=>{(L||$)&&(_=()=>{},this.cmdSW&&this.cmdSW.stop()),m(L,O,$)},b=!1;r.stdout?(this.forwardData(r.stdout,o,_),r.stdout.once("data",()=>b=!0)):g({message:"stdout is null"});let l;r.stderr?l=this.collectData(r.stderr):g({message:"stderr is null"}),r.on("error",L=>{_(L)}),r.on("close",L=>{let O;!b&&(O=this.decodeData(l,o))&&n(O)?_(new Error(`command failed with error code ${L}: ${this.decodeData(l,o)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),_(null,"",!0))})}forwardData(r,o,g){const m=new T.StringDecoder(o);return r.on("data",_=>{g(null,m.write(_))}),m}collectData(r){const o=[];return r.on("data",g=>{o.push(g)}),o}decodeData(r,o){const g=new T.StringDecoder(o);return r.map(m=>g.write(m)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:o},g,m,_){m.indexOf(this.filePattern)!==-1&&this.matchFile(_,{base:g,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const b=l=>{const L=C.basename(l),O=C.dirname(l);let $=o[O];$||($=o[O]=[],b(O)),$.push({base:g,relativePath:l,basename:L,searchPath:this.getSearchPath(r,l)})};m.forEach(b)}matchDirectoryTree({rootEntries:r,pathToEntries:o},g,m){const _=this,b=this.folderExcludePatterns.get(g),l=this.filePattern;function L(O){_.directoriesWalked++;const $=D.hasSiblingFn(()=>O.map(ie=>ie.basename));for(let ie=0,se=O.length;ie<se;ie++){const U=O[ie],{relativePath:V,basename:W}=U;if(b.test(V,W,l!==W?$:void 0))continue;const P=o[V];if(P)L(P);else{if(_.filesWalked++,V===l)continue;_.matchFile(m,U)}if(_.isLimitHit)break}}L(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,o,g,m,_){const b=r.folder,l=D.hasSiblingFn(()=>g);this.parallel(g,(L,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const $=o?[o,L].join(C.sep):L;if(this.folderExcludePatterns.get(r.folder.fsPath).test($,L,this.config.filePattern!==L?l:void 0))return O(null);const ie=[b.fsPath,$].join(C.sep);R.lstat(ie,(se,U)=>{if(se||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(ie,U,(V,W)=>V||this.isCanceled||this.isLimitHit?O(null):W.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ie,U,(P,N)=>P||this.isCanceled||this.isLimitHit||(N=N||"",this.walkedPaths[N])?O(null):(this.walkedPaths[N]=!0,(0,h.readdir)(ie).then(F=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(r,$,F,m,M=>O(M||null))},F=>{O(null)})))):(this.filesWalked++,$===this.filePattern||this.maxFilesize&&a.isNumber(W.size)&&W.size>this.maxFilesize||this.matchFile(m,{base:b.fsPath,relativePath:$,searchPath:this.getSearchPath(r,$)}),O(null,void 0)))})},L=>{const O=L&&y.coalesce(L);return _(O&&O.length>0?O[0]:void 0)})}matchFile(r,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,C.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(o))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,o,g){return o.isSymbolicLink()?R.stat(r,g):g(null,o)}realPathIfNeeded(r,o,g){return o.isSymbolicLink()?R.realpath(r,(m,_)=>m?g(m):g(null,_)):g(null,r)}getSearchPath(r,o){return r.folderName?C.join(r.folderName,o):o}}e.FileWalker=f;class c{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new f(r)}search(r,o,g){this.walker.walk(this.folderQueries,this.extraFiles,r,o,(m,_)=>{g(m,{limitHit:_,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=c;class t{constructor(r,o){this.expression=r,this.root=o,this.init(r)}init(r){let o,g;Object.keys(r).filter(m=>r[m]).forEach(m=>{C.isAbsolute(m)?(o=o||D.getEmptyExpression(),o[m]=r[m]):(g=g||D.getEmptyExpression(),g[m]=r[m])}),this.absoluteParsedExpr=o&&D.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=g&&D.parse(g,{trimForExclusions:!0})}test(r,o,g){return this.relativeParsedExpr&&this.relativeParsedExpr(r,o,g)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,r),o,g)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getPathTerms(this.relativeParsedExpr)),r}}function n(s){const r=s.trim().split(`
`),o=r[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return p.uppercaseFirstLetter(r[r.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=n}),define(ge[131],pe([0,1,37,286,100,16,52,30,9,8,2,31,68,287,271,92]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class v{constructor(b){this.outputChannel=b}provideTextSearchResults(b,l,L,O){return this.outputChannel.appendLine(`provideTextSearchResults ${b.pattern}, ${JSON.stringify(Object.assign(Object.assign({},l),{folder:l.folder.toString()}))}`),new Promise(($,ie)=>{O.onCancellationRequested(()=>M());const se=n(b,l),U=l.folder.fsPath,V=se.map(be=>be.match(/^-/)?be:`'${be}'`).join(" ");this.outputChannel.appendLine(`${E} ${V}
 - cwd: ${U}`);let W=w.spawn(E,se,{cwd:U});W.on("error",be=>{console.error(be),this.outputChannel.appendLine("Error: "+(be&&be.message)),ie((0,A.serializeSearchError)(new A.SearchError(be&&be.message,A.SearchErrorCode.rgProcessError)))});let P=!1;const N=new f(l.maxResults,U,l.previewOptions);N.on("result",be=>{P=!0,H="",L.report(be)});let F=!1;const M=()=>{F=!0,W&&W.kill(),N&&N.cancel()};let B=!1;N.on("hitLimit",()=>{B=!0,M()});let H="";W.stdout.on("data",be=>{N.handleData(be),P||(H+=be)});let Q=!1;W.stdout.once("data",()=>Q=!0);let le="";W.stderr.on("data",be=>{const Te=be.toString();this.outputChannel.appendLine(Te),le+=Te}),W.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(P?"Got result from parser":"No result from parser"),H&&this.outputChannel.appendLine(`Got data without result: ${H}`),this.outputChannel.appendLine(""),F)$({limitHit:B});else{N.flush(),W=null;let be;le&&!Q&&(be=S(le))?ie((0,A.serializeSearchError)(new A.SearchError(be.message,be.code))):$({limitHit:B})}})})}}e.RipgrepTextSearchEngine=v;function S(_){const b=_.split(`
`),l=b[0].trim();if(b.some(O=>O.startsWith("regex parse error")))return new A.SearchError(u(b),A.SearchErrorCode.regexParseError);const L=l.match(/grep config error: unknown encoding: (.*)/);if(L)return new A.SearchError(`Unknown encoding: ${L[1]}`,A.SearchErrorCode.unknownEncoding);if(l.startsWith("error parsing glob"))return new A.SearchError(l.charAt(0).toUpperCase()+l.substr(1),A.SearchErrorCode.globParseError);if(l.startsWith("the literal"))return new A.SearchError(l.charAt(0).toUpperCase()+l.substr(1),A.SearchErrorCode.invalidLiteral);if(l.startsWith("PCRE2: error compiling pattern"))return new A.SearchError(l,A.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=S;function u(_){const b=["Regex parse error"],l=_.filter(L=>L.startsWith("PCRE2:"));if(l.length>=1){const L=l[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const O=L.split(":")[1];b.push(":"+O)}}return b.join("")}e.buildRegexParseError=u;class f extends R.EventEmitter{constructor(b,l,L){super();this.maxResults=b,this.rootFolder=l,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(b,l){return super.on(b,l),this}handleData(b){if(this.isDone)return;const l=typeof b=="string"?b:this.stringDecoder.write(b);this.handleDecodedData(l)}handleDecodedData(b){let l=b.indexOf(`
`);const L=this.remainder+b;if(l>=0)l+=this.remainder.length;else{this.remainder=L;return}let O=0;for(;l>=0;)this.handleLine(L.substring(O,l).trim()),O=l+1,l=L.indexOf(`
`,O);this.remainder=L.substring(O)}handleLine(b){if(this.isDone||!b)return;let l;try{l=JSON.parse(b)}catch(L){throw new Error(`malformed line from rg: ${b}`)}if(l.type==="match"){const L=c(l.data.path),O=i.URI.file(D.join(this.rootFolder,L)),$=this.createTextSearchMatch(l.data,O);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(l.type==="context"){const L=c(l.data.path),O=i.URI.file(D.join(this.rootFolder,L));this.createTextSearchContext(l.data,O).forEach(ie=>this.onResult(ie))}}createTextSearchMatch(b,l){const L=b.line_number-1;let O=!1,$=c(b.lines);L===0&&(0,I.startsWithUTF8BOM)($)&&(O=!0,$=(0,I.stripUTF8BOM)($));const ie=Buffer.from($);let se=0,U=0,V=L;b.submatches.length===0&&b.submatches.push($.length?{start:0,end:1,match:{text:$[0]}}:{start:0,end:0,match:{text:""}});const W=(0,T.coalesce)(b.submatches.map((P,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let F=c(P.match);L===0&&N===0&&O&&(F=(0,I.stripUTF8BOM)(F),P.start=P.start<=3?0:P.start-3,P.end=P.end<=3?0:P.end-3);const M=ie.slice(se,P.start).toString().length,B=U+M,H=t(F),Q=V,le=H.numLines+Q,be=H.numLines>0?H.lastLineLength:H.lastLineLength+B;return se=P.end,U=be,V=le,new d.Range(Q,B,le,be)}));return(0,h.createTextSearchResult)(l,$,W,this.previewOptions)}createTextSearchContext(b,l){const L=c(b.lines),O=b.line_number;return L.replace(/\r?\n$/,"").split(`
`).map(($,ie)=>({text:$,uri:l,lineNumber:O+ie}))}onResult(b){this.emit("result",b)}}e.RipgrepParser=f;function c(_){return _.bytes?Buffer.from(_.bytes,"base64").toString():_.text}function t(_){const b=/\n/g;let l=0,L=-1,O;for(;O=b.exec(_);)l++,L=O.index;const $=L>=0?_.length-L-1:_.length;return{numLines:l,lastLineLength:$}}function n(_,b){const l=["--hidden"];l.push(_.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:O}=(0,y.groupBy)(b.includes,ie=>ie.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const ie=new Set;O.forEach(se=>{ie.add(se)}),l.push("-g","!*"),ie.forEach(se=>{s(se).map(h.anchorGlob).forEach(U=>{l.push("-g",U)})})}L&&L.length&&L.forEach(ie=>{l.push("-g",ie)}),b.excludes.map(h.anchorGlob).forEach(ie=>l.push("-g",`!${ie}`)),b.maxFileSize&&l.push("--max-filesize",b.maxFileSize+""),b.useIgnoreFiles?l.push("--no-ignore-parent"):l.push("--no-ignore"),b.followSymlinks&&l.push("--follow"),b.encoding&&b.encoding!=="utf8"&&l.push("--encoding",b.encoding),_.pattern==="--"&&(_.isRegExp=!0,_.pattern="\\-\\-"),_.isMultiline&&!_.isRegExp&&(_.pattern=(0,I.escapeRegExpCharacters)(_.pattern),_.isRegExp=!0),b.usePCRE2&&l.push("--pcre2"),l.push("--crlf"),_.isRegExp&&(_.pattern=r(_.pattern),l.push("--auto-hybrid-regex"));let $;if(_.isWordMatch){const se=(0,I.createRegExp)(_.pattern,!!_.isRegExp,{wholeWord:_.isWordMatch}).source.replace(/\\\//g,"/");l.push("--regexp",se)}else if(_.isRegExp){let ie=g(_.pattern);ie=m(ie),l.push("--regexp",ie)}else $=_.pattern,l.push("--fixed-strings");return l.push("--no-config"),b.useGlobalIgnoreFiles||l.push("--no-ignore-global"),l.push("--json"),_.isMultiline&&l.push("--multiline"),b.beforeContext&&l.push("--before-context",b.beforeContext+""),b.afterContext&&l.push("--after-context",b.afterContext+""),l.push("--"),$&&l.push($),l.push("."),l}function s(_){const b=(0,k.splitGlobAware)(_,"/");return b.map((l,L)=>b.slice(0,L+1).join("/"))}e.spreadGlobComponents=s;function r(_){const b=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;_.match(b);)_=_.replace(b,"$1\\x{$2}");const l=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;_.match(l);)_=_.replace(l,"$1\\x{$2}");return _}e.unicodeEscapesToPCRE2=r;const o=_=>_.type==="Assertion"&&_.kind==="lookbehind";function g(_){let b;try{b=new p.RegExpParser().parsePattern(_)}catch(se){return _}let l="",L=0;const O=(se,U,V)=>{l+=_.slice(L,se)+V,L=U},$=[];return new p.RegExpVisitor({onCharacterEnter(se){if(se.raw!=="\\n")return;const U=$[0];if(!U)O(se.start,se.end,"\\r?\\n");else if(!$.some(o))if(U.type==="CharacterClass")if(U.negate){const V=_.slice(U.start+2,se.start)+_.slice(se.end,U.end-1);O(U.start,U.end,"(?!\\r?\\n"+(V?`|[${V}]`:"")+")")}else{const V=_.slice(U.start+1,se.start)+_.slice(se.end,U.end-1);O(U.start,U.end,V===""?"\\r?\\n":`(?:[${V}]|\\r?\\n)`)}else U.type==="Quantifier"&&O(se.start,se.end,"(?:\\r?\\n)")},onQuantifierEnter(se){$.unshift(se)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(se){$.unshift(se)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(se){$.unshift(se)},onCharacterClassLeave(){$.shift()},onAssertionEnter(se){o(se)&&$.push(se)},onAssertionLeave(se){$[0]===se&&$.shift()}}).visit(b),l+=_.slice(L),l}e.fixRegexNewline=g;function m(_){return _.replace(/\n/g,"\\r?\\n")}e.fixNewline=m}),define(ge[273],pe([0,1,21,131,114,10]),function(G,e,w,R,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,i,A,d){const p=new R.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===T.Schemas.userData){const a=Object.assign(Object.assign({},i),{folder:i.folder.with({scheme:T.Schemas.file})}),h=new C.Progress(E=>A.report(Object.assign(Object.assign({},E),{uri:E.uri.with({scheme:i.folder.scheme})})));return this.withToken(d,E=>p.provideTextSearchResults(I,a,h,E))}else return this.withToken(d,a=>p.provideTextSearchResults(I,i,A,a))}async withToken(I,i){const A=k(I);this.inProgress.add(A);const d=await i(A.token);return this.inProgress.delete(A),d}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=y;function k(D){const I=new w.CancellationTokenSource;return D.onCancellationRequested(()=>I.cancel()),I}}),define(ge[274],pe([0,1,28,131,130]),function(G,e,w,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class T{constructor(D){this.query=D}search(D,I,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const A={appendLine(p){i({message:p})}},d=new C.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(A),w);return new Promise((p,a)=>d.search(h=>{I(h.map(y))},D).then(h=>p({limitHit:h.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=T;function y(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((D,I)=>{if(I.ranges){const i=I;return D+(Array.isArray(i.ranges)?i.ranges.length:1)}else return D+1},0)}}}),define(ge[275],pe([0,1,59,288,16,13,17,3,98,9,44,2,43,31,272,274]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(w);class E{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const s=u(t),r=new k.Emitter({onFirstListenerDidAdd:()=>{n=(0,T.createCancelablePromise)(o=>this.doFileSearchWithEngine(a.Engine,s,g=>r.fire(g),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}textSearch(t){let n;const s=u(t),r=new k.Emitter({onFirstListenerDidAdd:()=>{n=(0,T.createCancelablePromise)(o=>this.ripgrepTextSearch(s,g=>r.fire(g),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}ripgrepTextSearch(t,n,s){return t.maxFileSize=(0,d.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new h.TextSearchEngineAdapter(t).search(s,n,n)}doFileSearch(t,n,s){return this.doFileSearchWithEngine(a.Engine,t,n,s)}doFileSearchWithEngine(t,n,s,r,o=E.BATCH_SIZE){let g=0;const m=b=>{Array.isArray(b)?(g+=b.length,s(b.map(l=>this.rawMatchToSearchItem(l)))):b.relativePath?(g++,s(this.rawMatchToSearchItem(b))):s(b)};if(n.sortByScore){let b=this.trySortedSearchFromCache(n,m,r);if(!b){const l=n.maxResults?Object.assign({},n,{maxResults:null}):n,L=new t(l);b=this.doSortedSearch(L,n,s,m,r)}return new Promise((l,L)=>{b.then(([O,$])=>{const ie=$.map(se=>this.rawMatchToSearchItem(se));this.sendProgress(ie,s,o),l(O)},L)})}const _=new t(n);return this.doSearch(_,m,o,r).then(b=>({limitHit:b.limitHit,type:"success",stats:{detailStats:b.stats,type:"searchProcess",fromCache:!1,resultCount:g,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,I.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,s,r,o){const g=new k.Emitter;let m=(0,T.createCancelablePromise)(b=>{let l=[];const L=O=>{Array.isArray(O)?l=O:(r(O),g.fire(O))};return this.doSearch(t,L,-1,b).then(O=>[O,l])}),_;if(n.cacheKey){_=this.getOrCreateCache(n.cacheKey);const b={promise:m,event:g.event,resolved:!1};_.resultsToSearchCache[n.filePattern||""]=b,m.then(()=>{b.resolved=!0},l=>{delete _.resultsToSearchCache[n.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([b,l])=>{const L=_?_.scorerCache:Object.create(null),O=(typeof n.maxResults!="number"||n.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(n,l,L,o).then($=>{const ie=O?O.elapsed():-1;return[{type:"success",stats:{detailStats:b.stats,sortingTime:ie,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:$.length},messages:b.messages,limitHit:b.limitHit||typeof n.maxResults=="number"&&l.length>n.maxResults},$]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new v)}trySortedSearchFromCache(t,n,s){const r=t.cacheKey&&this.caches[t.cacheKey];if(!r)return;const o=this.getResultsFromCache(r,t.filePattern||"",n,s);if(o)return o.then(([g,m,_])=>{const b=i.StopWatch.create(!1);return this.sortResults(t,m,r.scorerCache,s).then(l=>{const L=b.elapsed(),O={fromCache:!0,detailStats:_,type:"searchProcess",resultCount:m.length,sortingTime:L};return[{type:"success",limitHit:g.limitHit||typeof t.maxResults=="number"&&m.length>t.maxResults,stats:O},l]})})}sortResults(t,n,s,r){const o=(0,D.prepareQuery)(t.filePattern||""),g=(_,b)=>(0,D.compareItemsByFuzzyScore)(_,b,o,!0,S,s),m=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return C.topAsync(n,g,m,1e4,r)}sendProgress(t,n,s){if(s&&s>0)for(let r=0;r<t.length;r+=s)n(t.slice(r,r+s));else n(t)}getResultsFromCache(t,n,s,r){const o=i.StopWatch.create(!1),g=n.indexOf(I.sep)>=0;let m;for(const L in t.resultsToSearchCache)if(n.startsWith(L)){if(g&&L.indexOf(I.sep)<0&&L!=="")continue;const O=t.resultsToSearchCache[L];m={promise:this.preventCancellation(O.promise),event:O.event,resolved:O.resolved};break}if(!m)return null;const _=o.elapsed(),b=i.StopWatch.create(!1),l=m.event(s);return r&&r.onCancellationRequested(()=>{l.dispose()}),m.promise.then(([L,O])=>{if(r&&r.isCancellationRequested)throw(0,y.canceled)();const $=[],ie=(0,D.prepareQuery)(n).normalizedLowercase;for(const se of O)!(0,p.isFilePatternMatch)(se,ie)||$.push(se);return[L,$,{cacheWasResolved:m.resolved,cacheLookupTime:_,cacheFilterTime:b.elapsed(),cacheEntryCount:O.length}]})}doSearch(t,n,s,r){return new Promise((o,g)=>{let m=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(_=>{_&&(s?(m.push(_),s>0&&m.length>=s&&(n(m),m=[])):n(_))},_=>{n(_)},(_,b)=>{m.length&&n(m),_?g(_):o(b)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,s){return t.then(n,s)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=E,E.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const S=new class{getItemLabel(c){return(0,I.basename)(c.relativePath)}getItemDescription(c){return(0,I.dirname)(c.relativePath)}getItemPath(c){return c.relativePath}};function u(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(f),extraFileResources:c.extraFileResources&&c.extraFileResources.map(t=>A.URI.revive(t))})}function f(c){return Object.assign(Object.assign({},c),{folder:A.URI.revive(c.folder)})}}),define(ge[276],pe([0,1,6,2,28,14,31,275,273,92,15,63,27,71,10,130]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends p.ExtHostSearch{constructor(S,u,f,c){super(S,f,c);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new I.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new D.RipgrepSearchProvider(t)),u.remote.isRemote&&u.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const S=new I.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new D.RipgrepSearchProvider(S)),this.registerInternalFileSearchProvider(a.Schemas.file,new k.SearchService)}registerInternalFileSearchProvider(S,u){const f=this._handlePool++;return this._internalFileSearchProvider=u,this._internalFileSearchHandle=f,this._proxy.$registerFileSearchProvider(f,this._transformScheme(S)),(0,w.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(S,u,f,c){const t=(0,p.reviveQuery)(f);return S===this._internalFileSearchHandle?this.doInternalFileSearch(S,u,t,c):super.$provideFileSearchResults(S,u,f,c)}doInternalFileSearch(S,u,f,c){const t=n=>{if((0,y.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(S,u,n.map(s=>R.URI.file(s.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(f,t,c)}$clearCache(S){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(S),super.$clearCache(S)}createTextSearchManager(S,u){return new h.NativeTextSearchManager(S,u)}};E=Ve([He(0,i.IExtHostRpcService),He(1,d.IExtHostInitDataService),He(2,A.IURITransformerService),He(3,T.ILogService)],E),e.NativeExtHostSearch=E}),define(ge[132],pe([0,1,289,122,290,3,103,9,101,32,6,23,104,17,11]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(m){this.socket=m,this._errorListener=_=>{if(_){if(_.code==="EPIPE")return;(0,p.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const _=b=>m(A.VSBuffer.wrap(b));return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(m){return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,p.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,p.onUnexpectedError)(_)}}end(){this.socket.end()}drain(){return new Promise((m,_)=>{if(this.socket.bufferSize===0){m();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),m()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.NodeSocket=h;var E;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var v;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(v||(v={}));class S extends i.Disposable{constructor(m,_,b,l){super();this._onDidZlibFlush=this._register(new T.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new T.Emitter),this._onClose=this._register(new T.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=_,this._recordInflateBytes=l,_?(this._zlibInflate=C.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",L=>{console.error(L),(0,p.onUnexpectedError)(L),this._onClose.fire()}),this._zlibInflate.on("data",L=>{this._pendingInflateData.push(L)}),b&&(this._zlibInflate.write(b.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=C.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{console.error(L),(0,p.onUnexpectedError)(L),this._onClose.fire()}),this._zlibDeflate.on("data",L=>{this._pendingDeflateData.push(L)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new d.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):A.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let _=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.length-4),this._isEnded||this._write(A.VSBuffer.wrap(_),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,_){let b=2;m.byteLength<126?b+=0:m.byteLength<2**16?b+=2:b+=8;const l=A.VSBuffer.alloc(b);if(_?l.writeUInt8(194,0):l.writeUInt8(130,0),m.byteLength<126)l.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){l.writeUInt8(126,1);let L=1;l.writeUInt8(m.byteLength>>>8&255,++L),l.writeUInt8(m.byteLength>>>0&255,++L)}else{l.writeUInt8(127,1);let L=1;l.writeUInt8(0,++L),l.writeUInt8(0,++L),l.writeUInt8(0,++L),l.writeUInt8(0,++L),l.writeUInt8(m.byteLength>>>24&255,++L),l.writeUInt8(m.byteLength>>>16&255,++L),l.writeUInt8(m.byteLength>>>8&255,++L),l.writeUInt8(m.byteLength>>>0&255,++L)}this._totalOutgoingWireBytes+=l.byteLength+m.byteLength,this.socket.write(A.VSBuffer.concat([l,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),l=(_.readUInt8(0)&128)>>>7,L=_.readUInt8(1),O=(L&128)>>>7,$=L&127;this._state.state=2,this._state.readLen=2+(O?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=l,this._state.mask=0}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),b=_.readUInt8(1),l=(b&128)>>>7;let L=b&127,O=1;L===126?L=_.readUInt8(++O)*2**8+_.readUInt8(++O):L===127&&(L=_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*2**24+_.readUInt8(++O)*2**16+_.readUInt8(++O)*2**8+_.readUInt8(++O));let $=0;l&&($=_.readUInt8(++O)*2**24+_.readUInt8(++O)*2**16+_.readUInt8(++O)*2**8+_.readUInt8(++O)),this._state.state=3,this._state.readLen=L,this._state.mask=$}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);u(_,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(_.buffer)),this._zlibInflate.write(_.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const b=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=b.length,this._onData.fire(A.VSBuffer.wrap(b))})):(this._totalIncomingDataBytes+=_.byteLength,this._onData.fire(_))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await T.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=S;function u(g,m){if(m===0)return;let _=g.byteLength>>>2;for(let ie=0;ie<_;ie++){const se=g.readUInt32BE(ie*4);g.writeUInt32BE(se^m,ie*4)}let b=_*4,l=g.byteLength-b;const L=m>>>24&255,O=m>>>16&255,$=m>>>8&255;l>=1&&g.writeUInt8(g.readUInt8(b)^L,b),l>=2&&g.writeUInt8(g.readUInt8(b+1)^O,b+1),l>=3&&g.writeUInt8(g.readUInt8(b+2)^$,b+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const f={[2]:107,[1]:103};function c(){const g=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let m;return e.XDG_RUNTIME_DIR?m=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):m=(0,k.join)((0,D.tmpdir)(),`vscode-ipc-${g}.sock`),n(m),m}e.createRandomIPCHandle=c;function t(g,m,_){const b=(0,w.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${b}-${_}-${m}-sock`;let l;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?l=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${b.substr(0,8)}-${_}-${m}.sock`):l=(0,k.join)(g,`${_}-${m}.sock`),n(l),l}e.createStaticIPCHandle=t;function n(g){const m=f[a.platform];typeof m=="number"&&g.length>=m&&console.warn(`WARNING: IPC handle "${g}" is longer than ${m} chars, try a shorter --user-data-dir`)}class s extends y.IPCServer{constructor(m){super(s.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const _=T.Event.fromNodeEventEmitter(m,"connection");return T.Event.map(_,b=>({protocol:new d.Protocol(new h(b)),onDidClientDisconnect:T.Event.once(T.Event.fromNodeEventEmitter(b,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(g){return new Promise((m,_)=>{const b=(0,R.createServer)();b.on("error",_),b.listen(g,()=>{b.removeListener("error",_),m(new s(b))})})}e.serve=r;function o(g,m){return new Promise((_,b)=>{const l=(0,R.createConnection)(g,()=>{l.removeListener("error",b),_(d.Client.fromSocket(new h(l),m))});l.once("error",b)})}e.connect=o}),define(ge[277],pe([0,1,132,269,59,49,2,118,14]),function(G,e,w,R,C,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(d,p,a){this._commands=d,this.logService=p,this._ipcHandlePath=a,this._server=R.createServer((h,E)=>this.onRequest(h,E)),this.setup().catch(h=>(p.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",d=>this.logService.error(d))}catch(d){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(d,p){const a=[];d.setEncoding("utf8"),d.on("data",h=>a.push(h)),d.on("end",()=>{const h=JSON.parse(a.join(""));switch(h.type){case"open":this.open(h,p);break;case"openExternal":this.openExternal(h,p);break;case"status":this.getStatus(h,p);break;case"extensionManagement":this.manageExtensions(h,p).catch(this.logService.error);break;default:p.writeHead(404),p.write(`Unknown message type: ${h.type}`,E=>{E&&this.logService.error(E)}),p.end();break}})}open(d,p){let{fileURIs:a,folderURIs:h,forceNewWindow:E,diffMode:v,addMode:S,forceReuseWindow:u,gotoLineMode:f,waitMarkerFilePath:c}=d;const t=[];if(Array.isArray(h))for(const n of h)try{t.push({folderUri:y.URI.parse(n)})}catch(s){}if(Array.isArray(a))for(const n of a)try{(0,k.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:y.URI.parse(n)}):t.push({fileUri:y.URI.parse(n)})}catch(s){}if(t.length){const n=c?y.URI.file(c):void 0,r={forceNewWindow:E,diffMode:v,addMode:S,gotoLineMode:f,forceReuseWindow:u,preferNewWindow:!u&&!n&&!S,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,r)}p.writeHead(200),p.end()}async openExternal(d,p){for(const a of d.uris){const h=y.URI.parse(a),E=h.scheme==="file"?h:a;await this._commands.executeCommand("_remoteCLI.openExternal",E)}p.writeHead(200),p.end()}async manageExtensions(d,p){try{const a=v=>v==null?void 0:v.map(S=>/\.vsix$/i.test(S)?y.URI.parse(S):S),h={list:d.list,install:a(d.install),uninstall:a(d.uninstall),force:d.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",h);p.writeHead(200),p.write(E)}catch(a){p.writeHead(500),p.write(String(a),h=>{h&&this.logService.error(h)})}p.end()}async getStatus(d,p){try{const a=await this._commands.executeCommand("_remoteCLI.getSystemStatus");p.writeHead(200),p.write(a),p.end()}catch(a){p.writeHead(500),p.write(String(a),h=>{h&&this.logService.error(h)}),p.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let i=class extends I{constructor(d,p){super(d,p,(0,w.createRandomIPCHandle)())}};i=Ve([He(0,T.IExtHostCommands),He(1,D.ILogService)],i),e.CLIServer=i}),define(ge[278],pe([0,1,70,265,260,5,268,41,250,2,10,7,277,102]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends C.RequireInterceptor{_installInterceptor(){const v=this,S=G.__$__nodeRequire("module"),u=S._load;S._load=function(c,t,n){for(let s of v._alternatives){let r=s(c);if(r){c=r;break}}return v._factories.has(c)?v._factories.get(c).load(c,I.URI.file((0,p.realpathSync)(t.filename)),s=>u.apply(this,[s,t,n])):u.apply(this,arguments)}}}class h extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const v=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(d.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(a,v,this._registry).install(),w.mark("code/extHost/didInitAPI");const u=await this._extHostConfiguration.getConfigProvider();await(0,y.connectProxyResolver)(this._extHostWorkspace,u,this,this._logService,this._mainThreadTelemetryProxy,this._initData),w.mark("code/extHost/didInitProxyResolver");const f=process.send,c=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?f.apply(process,t):(c.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(v){return v.main}_loadCommonJSModule(v,S,u){if(S.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${S}', must be of file-scheme`);let f=null;u.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${S.toString(!0)}`),this._logService.flush();try{v&&w.mark(`code/extHost/willLoadExtensionCode/${v.value}`),f=G.__$__nodeRequire(S.fsPath)}catch(c){return Promise.reject(c)}finally{v&&w.mark(`code/extHost/didLoadExtensionCode/${v.value}`),u.codeLoadingStop()}return Promise.resolve(f)}async $setRemoteEnvironment(v){if(!!this._initData.remote.isRemote)for(const S in v){const u=v[S];u===null?delete process.env[S]:process.env[S]=u}}}e.ExtHostExtensionService=h}),define(ge[279],pe([0,1,79,251,252,262,261,276,278,221,253,50,41,66,71,69,33,48,14]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h,E,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(d.IExtHostExtensionService,D.ExtHostExtensionService),(0,w.registerSingleton)(S.ILogService,I.ExtHostLogService),(0,w.registerSingleton)(A.IExtHostDebugService,y.ExtHostDebugService),(0,w.registerSingleton)(p.IExtHostOutputService,R.ExtHostOutputService2),(0,w.registerSingleton)(a.IExtHostSearch,k.NativeExtHostSearch),(0,w.registerSingleton)(h.IExtHostTask,T.ExtHostTask),(0,w.registerSingleton)(E.IExtHostTerminalService,C.ExtHostTerminalService),(0,w.registerSingleton)(v.IExtHostTunnelService,i.ExtHostTunnelService)}),define(ge[280],pe([0,1,122,291,70,17,104,132,188,219,263,23,99,28,102,13,266,279]),function(G,e,w,R,C,T,y,k,D,I,i,A,d,p,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const E=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=G.__$__nodeRequire("module"),r=s._load;s._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const v=process.exit.bind(process);function S(s){process.exit=function(r){if(s)v(r);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let u=function(s){v()};function f(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,r)=>{let o=null,g=setTimeout(()=>{u("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,_=3e5,b=new h.RunOnceScheduler(()=>u("renderer disconnected for too long (1)"),m),l=new h.RunOnceScheduler(()=>u("renderer disconnected for too long (2)"),_);process.on("message",(O,$)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ie=A.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let se;if(O.skipWebSocketFrames)se=new k.NodeSocket($);else{const U=A.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));se=new k.WebSocketNodeSocket(new k.NodeSocket($),O.permessageDeflate,U,!1)}o?(b.cancel(),l.cancel(),o.beginAcceptReconnection(se,ie),o.endAcceptReconnection()):(clearTimeout(g),o=new y.PersistentProtocol(se,ie),o.onDidDispose(()=>u("renderer disconnected")),s(o),o.onSocketClose(()=>{b.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(l.isScheduled())return;b.isScheduled()&&l.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,o)=>{const g=w.createConnection(s,()=>{g.removeListener("error",o),r(new y.PersistentProtocol(new k.NodeSocket(g)))});g.once("error",o),g.on("close",()=>{u("renderer closed the socket")})})}}async function c(){const s=await f();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(r=>{(0,I.isMessageOfType)(r,2)?(this._terminating=!0,u("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||s.send(r)}drain(){return s.drain()}}}function t(s){return new Promise(r=>{const o=s.onMessage(g=>{o.dispose();const m=JSON.parse(g.toString()),_=m.commit,b=D.default.commit;_&&b&&_!==b&&v(55);const l=[];process.on("unhandledRejection",($,ie)=>{l.push(ie),setTimeout(()=>{const se=l.indexOf(ie);se>=0&&ie.catch(U=>{l.splice(se,1),console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),(0,T.onUnexpectedError)($)})},1e3)}),process.on("rejectionHandled",$=>{const ie=l.indexOf($);ie>=0&&l.splice(ie,1)}),process.on("uncaughtException",function($){(0,T.onUnexpectedError)($)});let L=0;setInterval(function(){try{process.kill(m.parentPid,0),L=0}catch($){$&&$.code==="EPERM"?(L++,L>=3&&u(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${$.message} (code: ${$.code}) (errno: ${$.errno})`)):u(`parent process ${m.parentPid} does not exist anymore: ${$.message} (code: ${$.code}) (errno: ${$.errno})`)}},1e3);let O;try{O=G.__$__nodeRequire("native-watchdog"),O.start(m.parentPid)}catch($){(0,T.onUnexpectedError)($)}s.send((0,I.createMessageOfType)(0)),r({protocol:s,initData:m})});s.send((0,I.createMessageOfType)(1))})}async function n(){C.mark("code/extHost/willConnectToRenderer");const s=await c();C.mark("code/extHost/didConnectToRenderer");const r=await t(s);C.mark("code/extHost/didWaitForInitData");const{initData:o}=r;S(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=E.useHostProxy!==void 0?E.useHostProxy!=="false":void 0;const g=new class{exit(l){v(l)}exists(l){return(0,p.exists)(l)}realpath(l){return(0,a.realpath)(l)}};let m=null;if(o.remote.authority&&E.uriTransformerPath)try{const l=G.__$__nodeRequire(E.uriTransformerPath)(o.remote.authority);m=new d.URITransformer(l)}catch(b){console.error(b)}const _=new i.ExtensionHostMain(r.protocol,o,g,m);u=b=>_.terminate(b)}e.startExtensionHostProcess=n}),define(ge[292],pe([0,1,280]),function(G,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.startExtensionHostProcess)().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1082913dd012e21cc5f35a06f15c480ca447f67f/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
